unit FIDHum;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, DB, DBTables, Grids, Buttons, HumDB, SerGrobal;
type
  TFrmIDHum = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label3: TLabel;
    EdChrName: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    BtnCreateChr: TSpeedButton;
    BtnEraseChr: TSpeedButton;
    BtnChrNameSearch: TSpeedButton;
    IdGrid: TStringGrid;
    ChrGrid: TStringGrid;
    BtnSelAll: TSpeedButton;
    CbShowDelChr: TCheckBox;
    BtnDeleteChr: TSpeedButton;
    BtnRevival: TSpeedButton;
    SpeedButton1: TSpeedButton;
    Button1: TButton;
    Label2: TLabel;
    EdUserId: TEdit;
    BtnDeleteChrAllInfo: TSpeedButton;
    SpeedButton2: TSpeedButton;
    LabelCount: TLabel;
    SpeedButtonEditData: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure BtnChrNameSearchClick(Sender: TObject);
    procedure BtnSelAllClick(Sender: TObject);
    procedure BtnEraseChrClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ChrGridClick(Sender: TObject);
    procedure ChrGridDblClick(Sender: TObject);
    procedure BtnDeleteChrClick(Sender: TObject);
    procedure BtnRevivalClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BtnCreateChrClick(Sender: TObject);
    procedure BtnDeleteChrAllInfoClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure RefChrGrid(n08: Integer; HumDBRecord: THumInfo);
    procedure EdChrNameKeyPress(Sender: TObject; var Key: Char);
    procedure EdUserIdKeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButtonEditDataClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmIDHum: TFrmIDHum;

implementation

uses DBSMain, HUtil32, MudUtil, CreateChr, FDBexpl, viewrcd, EditRcd;


{$R *.DFM}

procedure TFrmIDHum.FormCreate(Sender: TObject);
begin
  Edit1.Text := '';
  Edit2.Text := '';
  IdGrid.Cells[0, 0] := '¼ʺ';
  IdGrid.Cells[1, 0] := '';
  IdGrid.Cells[2, 0] := 'û';
  IdGrid.Cells[3, 0] := 'ResiRegi';
  IdGrid.Cells[4, 0] := 'Tran';
  IdGrid.Cells[5, 0] := 'Secretwd';
  IdGrid.Cells[6, 0] := 'Adress(cont)';
  IdGrid.Cells[7, 0] := 'ע';

  ChrGrid.Cells[0, 0] := '';
  ChrGrid.Cells[1, 0] := '';
  ChrGrid.Cells[2, 0] := '¼ʺ';
  ChrGrid.Cells[3, 0] := 'Ƿ';
  ChrGrid.Cells[4, 0] := 'ʱ';
  ChrGrid.Cells[5, 0] := '';
  ChrGrid.Cells[6, 0] := 'ѡ';
end;

procedure TFrmIDHum.EdUserIdKeyPress(Sender: TObject; var Key: Char);
//0x0049FF58
var
  sAccount: string;
  ChrList: TStringList;
  i, nIndex: Integer;
  HumDBRecord: THumInfo;
begin
  if Key = #13 then begin
    Key := #0;
    sAccount := EdUserId.Text;
    ChrGrid.RowCount := 1;
    if sAccount <> '' then begin
      ChrList := TStringList.Create;
      try
        if HumInfo.OpenEx then begin
          HumInfo.FindByAccount(sAccount, ChrList);
          for i := 0 to ChrList.Count - 1 do begin
            nIndex := pTQuickID(ChrList.Objects[i]).nIndex;
            if nIndex >= 0 then begin
              HumInfo.GetBy(nIndex, HumDBRecord);
              if CbShowDelChr.Checked then RefChrGrid(nIndex, HumDBRecord)
              else if not HumDBRecord.boDeleted then
                RefChrGrid(nIndex, HumDBRecord);
            end;
          end;
        end;
      finally
        HumInfo.Close;
      end;
      ChrList.Free;
    end;
  end;
end;

procedure TFrmIDHum.EdChrNameKeyPress(Sender: TObject; var Key: Char);
//0x004A025C
begin
  if Key = #13 then begin
    Key := #0;
    BtnChrNameSearchClick(Sender);
  end;
end;

procedure TFrmIDHum.BtnChrNameSearchClick(Sender: TObject);
var
  s64,s65: string;
  n08, i,nIndex: Integer;
  HumDBRecord: THumInfo;
  ChrList: TStringList;
  QuickID: pTQuickID;
begin
  s64 := Trim(EdChrName.Text);
  s65 := Trim(EdUserId.Text);
  ChrGrid.RowCount := 1;
  if (s65 <> '') and (s64 = '*') then begin
    try
      ChrList := TStringList.Create;
      if HumInfo.OpenEx then begin
        if HumInfo.FindByAccount(s65,ChrList) > 0 then begin
          for i := 0 to ChrList.Count - 1 do begin
            QuickID := pTQuickID(ChrList.Objects[i]);
            if QuickID <> nil then begin
                if HumInfo.GetBy(QuickID.nIndex, HumDBRecord) then begin
                  if CbShowDelChr.Checked then RefChrGrid(nIndex, HumDBRecord)
                  else if not HumDBRecord.boDeleted then
                    RefChrGrid(nIndex, HumDBRecord);
                end;
            end;
          end;
        end;
      end;
    finally
      HumInfo.Close;
      ChrList.Free;
    end;
    Exit;
  end;
  if (s64 <> '') and (s65 = '*') then begin
    try
      if HumInfo.OpenEx then begin
        n08 := HumInfo.Index(s64);
        if n08 >= 0 then begin
          nIndex := HumInfo.Get(n08, HumDBRecord);
          if nIndex >= 0 then begin
            if CbShowDelChr.Checked then RefChrGrid(nIndex, HumDBRecord)
            else if not HumDBRecord.boDeleted then
              RefChrGrid(nIndex, HumDBRecord);
          end;
        end;
      end;
    finally
      HumInfo.Close;
    end;
  end;
end;

procedure TFrmIDHum.BtnSelAllClick(Sender: TObject);
var
  sChrName: string;
  ChrList: TStringList;
  i, nIndex: Integer;
  HumDBRecord: THumInfo;
begin
  sChrName := EdChrName.Text;
  ChrGrid.RowCount := 1;
  ChrList := TStringList.Create;
  try
    if HumInfo.OpenEx then begin
      if HumInfo.FindByName(sChrName, ChrList) > 0 then begin
        for i := 0 to ChrList.Count - 1 do begin
          nIndex := Integer(ChrList.Objects[i]);
          if HumInfo.GetBy(nIndex, HumDBRecord) then begin
            if CbShowDelChr.Checked then RefChrGrid(nIndex, HumDBRecord)
            else if not HumDBRecord.boDeleted then
              RefChrGrid(nIndex, HumDBRecord);
          end;
        end;
      end;
    end;
  finally
    HumInfo.Close;
  end;
  ChrList.Free;
end;

procedure TFrmIDHum.BtnEraseChrClick(Sender: TObject); //004A04DC
var
  sChrName: string;
begin
  sChrName := EdChrName.Text;
  if sChrName = '' then Exit;
  if MessageDlg('Ƿȷɾ ' + sChrName + ' ', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    try
      if HumInfo.Open then begin
        HumInfo.Delete(sChrName);
      end;
    finally
      HumInfo.Close;
    end;
  end;
end;

procedure TFrmIDHum.FormShow(Sender: TObject);
begin
  EdChrName.SetFocus;
end;

procedure TFrmIDHum.ChrGridClick(Sender: TObject);
var
  nRow: Integer;
begin
  nRow := ChrGrid.Row;
  if nRow < 1 then Exit;
  if ChrGrid.RowCount - 1 < nRow then Exit;
  EdChrName.Text := ChrGrid.Cells[1, nRow];
end;

procedure TFrmIDHum.ChrGridDblClick(Sender: TObject); //0x004A08C0
var
  n8, nC: Integer;
  s10: string;
  ChrRecord: THumDataInfo;
begin
  s10 := '';
  n8 := ChrGrid.Row;
  if (n8 >= 1) and (ChrGrid.RowCount - 1 >= n8) then
    s10 := ChrGrid.Cells[1, n8];
  try
    if HumDataDB.OpenEx then begin
      nC := HumDataDB.Index(s10);
      if nC >= 0 then begin
        if HumDataDB.Get(nC, ChrRecord) >= 0 then begin
          FrmFDBViewer.n2F8 := nC;
          FrmFDBViewer.s2FC := s10;
          FrmFDBViewer.ChrRecord := ChrRecord;
          FrmFDBViewer.ShowHumData;
          FrmFDBViewer.Left := FrmIDHum.Left - 144;
          FrmFDBViewer.Top := FrmIDHum.Top + 100;
          FrmFDBViewer.Show;
        end;
      end;
    end;
  finally
    HumDataDB.Close;
  end;
end;

procedure TFrmIDHum.BtnDeleteChrClick(Sender: TObject);
var
  sChrName: string;
  nIndex: Integer;
  HumRecord: THumInfo;
begin
  sChrName := EdChrName.Text;
  if sChrName = '' then Exit;
  if MessageDlg('ǷȷϽ ' + sChrName + ' ', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    try
      if HumInfo.Open then begin
        nIndex := HumInfo.Index(sChrName);
        HumInfo.Get(nIndex, HumRecord);
        HumRecord.boDeleted := True;
        HumRecord.dModDate := Now();
        Inc(HumRecord.btCount);
        HumInfo.Update(nIndex, HumRecord);
      end;
    finally
      HumInfo.Close;
    end;
  end;
end;

procedure TFrmIDHum.BtnRevivalClick(Sender: TObject);
//0x004A0D28
var
  sChrName: string;
  nIndex: Integer;
  HumRecord: THumInfo;
begin
  sChrName := EdChrName.Text;
  if sChrName = '' then Exit;
  if MessageDlg('Ƿȷ ' + sChrName + ' ', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    try
      if HumInfo.Open then begin
        nIndex := HumInfo.Index(sChrName);
        HumInfo.Get(nIndex, HumRecord);
        HumRecord.boDeleted := False;
        Inc(HumRecord.btCount);
        HumInfo.Update(nIndex, HumRecord);
      end;
    finally
      HumInfo.Close;
    end;
  end;
end;

procedure TFrmIDHum.SpeedButton1Click(Sender: TObject);
begin
  FrmFDBExplore.Show;
end;

procedure TFrmIDHum.BtnCreateChrClick(Sender: TObject);
var
  nCheckCode: Integer;
  HumRecord: THumInfo;
begin
  if not FrmCreateChr.IncputChrInfo then Exit;
  nCheckCode := 0;
  try
    if HumInfo.Open then begin
      if HumInfo.ChrCountOfAccount(FrmCreateChr.sUserId) < 2 then begin
        HumRecord.Header.btSelectID := FrmCreateChr.nSelectID;
        HumRecord.sChrName := FrmCreateChr.sChrName;
        HumRecord.sAccount := FrmCreateChr.sUserId;
        HumRecord.boDeleted := False;
        HumRecord.btCount := 0;
        HumRecord.Header.sName := FrmCreateChr.sChrName;
        if HumRecord.Header.sName <> '' then begin
          if not HumInfo.Add(HumRecord) then nCheckCode := 2;
        end;
      end else nCheckCode := 3;
    end;
  finally
    HumInfo.Close;
  end;
  if nCheckCode = 0 then ShowMessage('ﴴɹ...')
  else ShowMessage('ﴴʧܣ')
end;

procedure TFrmIDHum.BtnDeleteChrAllInfoClick(Sender: TObject); //0x004A0610
var
  sChrName: string;
begin
  sChrName := EdChrName.Text;
  if sChrName = '' then Exit;
  if MessageDlg('Ƿȷɾ ' + sChrName + ' ݣ', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    try
      if HumInfo.Open then begin
        HumInfo.Delete(sChrName);
      end;
    finally
      HumInfo.Close;
    end;
    try
      if HumDataDB.Open then HumDataDB.Delete(sChrName);
    finally
      HumDataDB.Close;
    end;
  end;
end;

procedure TFrmIDHum.SpeedButton2Click(Sender: TObject); //0x004A0B64
var
  nIndex: Integer;
  HumRecord: THumInfo;
  nRow: Integer;
begin
  nRow := ChrGrid.Row;
  if nRow < 1 then Exit;
  if ChrGrid.RowCount - 1 < nRow then Exit;
  nIndex := Str_ToInt(ChrGrid.Cells[0, nRow], 0);
  if MessageDlg('ǷȷϽü¼ ' + IntToStr(nIndex) + ' ', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    try
      if HumInfo.Open then begin
        if HumInfo.GetBy(nIndex, HumRecord) then begin
          HumRecord.boDeleted := True;
          HumRecord.dModDate := Now();
          Inc(HumRecord.btCount);
          HumInfo.UpdateBy(nIndex, HumRecord);
        end;
      end;
    finally
      HumInfo.Close;
    end;
  end;
end;

procedure TFrmIDHum.RefChrGrid(n08: Integer; HumDBRecord: THumInfo); //0x004A00C4
var
  nRowCount: Integer;
begin
  ChrGrid.RowCount := ChrGrid.RowCount + 1;
  ChrGrid.FixedRows := 1;
  nRowCount := ChrGrid.RowCount - 1;
  ChrGrid.Cells[0, nRowCount] := IntToStr(n08);
  ChrGrid.Cells[1, nRowCount] := HumDBRecord.sChrName;
  ChrGrid.Cells[2, nRowCount] := HumDBRecord.sAccount;
  ChrGrid.Cells[3, nRowCount] := BoolToStr(HumDBRecord.boDeleted);
  if HumDBRecord.boDeleted then
    ChrGrid.Cells[4, nRowCount] := DateTimeToStr(HumDBRecord.dModDate)
  else ChrGrid.Cells[4, nRowCount] := '';

  ChrGrid.Cells[5, nRowCount] := IntToStr(HumDBRecord.btCount);
  ChrGrid.Cells[6, nRowCount] := IntToStr(HumDBRecord.Header.btSelectID);
  LabelCount.Caption := IntToStr(ChrGrid.RowCount - 1);
end;

procedure TFrmIDHum.SpeedButtonEditDataClick(Sender: TObject);
var
  nRow, nIdx: Integer;
  sName: string;
  ChrRecord: THumDataInfo;
begin
  sName := '';
  nRow := ChrGrid.Row;
  if (nRow >= 1) and (ChrGrid.RowCount - 1 >= nRow) then
    sName := ChrGrid.Cells[1, nRow];
  if sName = '' then Exit;
  try
    if HumDataDB.OpenEx then begin
      nIdx := HumDataDB.Index(sName);
      if nIdx >= 0 then begin
        if HumDataDB.Get(nIdx, ChrRecord) >= 0 then begin
          frmEditRcd.m_nIdx := nIdx;
          frmEditRcd.m_ChrRcd := ChrRecord;
        end;
      end;
    end;
  finally
    HumDataDB.Close;
  end;
  frmEditRcd.Left := FrmIDHum.Left + 50;
  frmEditRcd.Top := FrmIDHum.Top + 50;
  frmEditRcd.Open;
end;

end.

