unit HumanInfo;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms,
  SerGrobal,Dialogs,
  ObjBase, StdCtrls, Spin, ComCtrls, ExtCtrls, Grids, TyFunc, Menus;

type
  TfrmHumanInfo = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    EditName: TEdit;
    EditMap: TEdit;
    EditXY: TEdit;
    EditAccount: TEdit;
    EditIPaddr: TEdit;
    EditLogonTime: TEdit;
    EditLogonLong: TEdit;
    GroupBox2: TGroupBox;
    Label12: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    EditLevel: TSpinEdit;
    EditGold: TSpinEdit;
    EditPKPoint: TSpinEdit;
    EditExp: TSpinEdit;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    Timer: TTimer;
    GroupBox4: TGroupBox;
    CheckBoxMonitor: TCheckBox;
    GroupBox6: TGroupBox;
    CheckBoxGameMaster: TCheckBox;
    CheckBoxSuperMan: TCheckBox;
    CheckBoxObserver: TCheckBox;
    ButtonKick: TButton;
    GroupBox7: TGroupBox;
    GroupBox9: TGroupBox;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    EditGameGold: TSpinEdit;
    EditGamePoint: TSpinEdit;
    EditCreditPoint: TSpinEdit;
    EditBonusPoint: TSpinEdit;
    Label19: TLabel;
    EditEditBonusPointUsed: TSpinEdit;
    GridUserItem: TStringGrid;
    GroupBox8: TGroupBox;
    GridBagItem: TStringGrid;
    GroupBox10: TGroupBox;
    GridStorageItem: TStringGrid;
    Label21: TLabel;
    EditMaxExp: TSpinEdit;
    GroupBox3: TGroupBox;
    Label11: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    EditAC: TEdit;
    EditMAC: TEdit;
    EditDC: TEdit;
    EditMC: TEdit;
    EditSC: TEdit;
    EditHP: TEdit;
    EditMP: TEdit;
    GroupBox11: TGroupBox;
    EditBActorName: TEdit;
    PopupMenuItemC: TPopupMenu;
    N_DellItem: TMenuItem;
    ButtonSave: TButton;
    EditHumanStatus: TEdit;
    Label20: TLabel;
    GroupBox5: TGroupBox;
    Label22: TLabel;
    ComboBox_DelItem: TComboBox;
    Button_DelItem: TButton;
    ComboBox_DelItem_CheckType: TComboBox;
    Label23: TLabel;
    Label24: TLabel;
    SpinEdit_DelItem_CheckVal: TSpinEdit;
    procedure TimerTimer(Sender: TObject);
    procedure CheckBoxMonitorClick(Sender: TObject);
    procedure ButtonKickClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N_DellItemClick(Sender: TObject);
    procedure Button_DelItemClick(Sender: TObject);
  private
    procedure RefHumanInfo();
    { Private declarations }
  public
    PlayObject: TPlayObject;
    procedure Open();
    { Public declarations }
  end;

var
  frmHumanInfo: TfrmHumanInfo;

implementation

uses UsrEngn, M2Share, MirGrobal;

{$R *.dfm}
var
  boRefHuman: Boolean = False;
  { TfrmHumanInfo }

procedure TfrmHumanInfo.FormCreate(Sender: TObject);
begin
  GridUserItem.Cells[0, 0] := 'װλ';
  GridUserItem.Cells[1, 0] := 'װ';
  GridUserItem.Cells[2, 0] := '';
  GridUserItem.Cells[3, 0] := 'ϵк';
  GridUserItem.Cells[4, 0] := '־';
  GridUserItem.Cells[5, 0] := '';
  GridUserItem.Cells[6, 0] := 'ħ';
  GridUserItem.Cells[7, 0] := '';
  GridUserItem.Cells[8, 0] := '';
  GridUserItem.Cells[9, 0] := 'ħ';
  GridUserItem.Cells[10, 0] := 'Ƕ';
  GridUserItem.Cells[11, 0] := '';

  GridUserItem.Cells[0, 1] := '·';
  GridUserItem.Cells[0, 2] := '';
  GridUserItem.Cells[0, 3] := '';
  GridUserItem.Cells[0, 4] := '';
  GridUserItem.Cells[0, 5] := 'ͷ';
  GridUserItem.Cells[0, 6] := '';
  GridUserItem.Cells[0, 7] := '';
  GridUserItem.Cells[0, 8] := 'ָ';
  GridUserItem.Cells[0, 9] := 'ҽָ';
  GridUserItem.Cells[0, 10] := 'Ʒ';
  GridUserItem.Cells[0, 11] := '';
  GridUserItem.Cells[0, 12] := 'Ь';
  GridUserItem.Cells[0, 13] := 'ʯ';

  GridBagItem.Cells[0, 0] := '';
  GridBagItem.Cells[1, 0] := 'װ';
  GridBagItem.Cells[2, 0] := '';
  GridBagItem.Cells[3, 0] := 'ϵк';
  GridBagItem.Cells[4, 0] := '־';
  GridBagItem.Cells[5, 0] := '';
  GridBagItem.Cells[6, 0] := 'ħ';
  GridBagItem.Cells[7, 0] := '';
  GridBagItem.Cells[8, 0] := '';
  GridBagItem.Cells[9, 0] := 'ħ';
  GridBagItem.Cells[10, 0] := 'Ƕ';
  GridBagItem.Cells[11, 0] := '';


  GridStorageItem.Cells[0, 0] := '';
  GridStorageItem.Cells[1, 0] := 'װ';
  GridStorageItem.Cells[2, 0] := '';
  GridStorageItem.Cells[3, 0] := 'ϵк';
  GridStorageItem.Cells[4, 0] := '־';
  GridStorageItem.Cells[5, 0] := '';
  GridStorageItem.Cells[6, 0] := 'ħ';
  GridStorageItem.Cells[7, 0] := '';
  GridStorageItem.Cells[8, 0] := '';
  GridStorageItem.Cells[9, 0] := 'ħ';
  GridStorageItem.Cells[10, 0] := 'Ƕ';
  GridStorageItem.Cells[11, 0] := '';
  PageControl1.ActivePageIndex := 0;
end;

procedure TfrmHumanInfo.Open;
begin
  RefHumanInfo();
  ButtonKick.Enabled := True;
  Timer.Enabled := True;
  ShowModal;
  CheckBoxMonitor.Checked := False;
  Timer.Enabled := False;
end;

procedure TfrmHumanInfo.RefHumanInfo;
var
  i: Integer;
  nTotleUsePoint: Integer;
  StdItem: pTStdItem;
  Item: TStdItem;
  UserItem: pTUserItem;
begin
  if (PlayObject = nil) then begin
    Exit;
  end;
  if PlayObject.m_bActor <> nil then
    EditBActorName.Text := PlayObject.m_bActor.m_sCharName;
    
  EditName.Text := PlayObject.m_sCharName;
  EditMap.Text := PlayObject.m_sMapName + '(' + PlayObject.m_PMap.sMapDesc + ')';
  EditXY.Text := IntToStr(PlayObject.m_nCurrX) + ':' + IntToStr(PlayObject.m_nCurrY);
  EditAccount.Text := PlayObject.m_sUserID;
  EditIPaddr.Text := PlayObject.m_sIPaddr;
  EditLogonTime.Text := DateTimeToStr(PlayObject.m_dLogonTime);
  EditLogonLong.Text := IntToStr((GetTickCount - PlayObject.m_dwLogonTick) div (60 * 1000)) + ' ';
  EditLevel.Value := PlayObject.m_Abil.Level;
  EditGold.Value := PlayObject.m_nGold;
  EditPKPoint.Value := PlayObject.m_wPkPoint;
  EditExp.Value := PlayObject.m_Abil.Exp;
  EditMaxExp.Value := PlayObject.m_Abil.MaxExp;

  EditAC.Text := IntToStr(LoWord(PlayObject.m_WAbil.AC)) + '/' + IntToStr(HiWord(PlayObject.m_WAbil.AC));
  EditMAC.Text := IntToStr(LoWord(PlayObject.m_WAbil.MAC)) + '/' + IntToStr(HiWord(PlayObject.m_WAbil.MAC));
  EditDC.Text := IntToStr(LoWord(PlayObject.m_WAbil.DC)) + '/' + IntToStr(HiWord(PlayObject.m_WAbil.DC));
  EditMC.Text := IntToStr(LoWord(PlayObject.m_WAbil.MC)) + '/' + IntToStr(HiWord(PlayObject.m_WAbil.MC));
  EditSC.Text := IntToStr(LoWord(PlayObject.m_WAbil.SC)) + '/' + IntToStr(HiWord(PlayObject.m_WAbil.SC));
  EditHP.Text := IntToStr(PlayObject.m_WAbil.HP) + '/' + IntToStr(PlayObject.m_WAbil.MaxHP);
  EditMP.Text := IntToStr(PlayObject.m_WAbil.MP) + '/' + IntToStr(PlayObject.m_WAbil.MaxMP);

  EditGameGold.Value := PlayObject.m_nGameGold;
  EditGamePoint.Value := PlayObject.m_nGamePoint;
  EditCreditPoint.Value := PlayObject.m_btCreditPoint;
  EditBonusPoint.Value := PlayObject.m_nBonusPoint;

  nTotleUsePoint := PlayObject.m_BonusAbil.DC +
    PlayObject.m_BonusAbil.MC +
    PlayObject.m_BonusAbil.SC +
    PlayObject.m_BonusAbil.AC +
    PlayObject.m_BonusAbil.MAC +
    PlayObject.m_BonusAbil.HP +
    PlayObject.m_BonusAbil.MP +
    PlayObject.m_BonusAbil.Hit +
    PlayObject.m_BonusAbil.Speed;

  EditEditBonusPointUsed.Value := nTotleUsePoint;

  CheckBoxGameMaster.Checked := PlayObject.m_boAdminMode;
  CheckBoxSuperMan.Checked := PlayObject.m_boSuperMan;
  CheckBoxObserver.Checked := PlayObject.m_boObMode;

  if PlayObject.m_boDeath then begin
    EditHumanStatus.Text := '';
  end else
    if PlayObject.m_boGhost then begin
      EditHumanStatus.Text := '';
      PlayObject := nil;
    end else EditHumanStatus.Text := '';
  for i := Low(PlayObject.m_UseItems) to High(PlayObject.m_UseItems) do begin
    UserItem := @PlayObject.m_UseItems[i];
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if StdItem = nil then begin
      GridUserItem.Cells[1, i + 1] := '';
      GridUserItem.Cells[2, i + 1] := '';
      GridUserItem.Cells[3, i + 1] := '';
      GridUserItem.Cells[4, i + 1] := '';
      GridUserItem.Cells[5, i + 1] := '';
      GridUserItem.Cells[6, i + 1] := '';
      GridUserItem.Cells[7, i + 1] := '';
      GridUserItem.Cells[8, i + 1] := '';
      GridUserItem.Cells[9, i + 1] := '';
      GridUserItem.Cells[10, i + 1] := '';
      GridUserItem.Cells[11, i + 1] := '';
      Continue;
    end;
    Item := StdItem^;
    ItemUnit.GetItemAddValue(UserItem, Item);

    GridUserItem.Cells[1, i + 1] := Item.Name;
    GridUserItem.Cells[2, i + 1] := IntToStr(Item.StdMode);
    GridUserItem.Cells[3, i + 1] := IntToStr(UserItem.MakeIndex);
    GridUserItem.Cells[4, i + 1] := format('%d/%d', [UserItem.Dura, UserItem.DuraMax]);
    GridUserItem.Cells[5, i + 1] := format('%d/%d', [LoWord(Item.DC), HiWord(Item.DC)]);
    GridUserItem.Cells[6, i + 1] := format('%d/%d', [LoWord(Item.MC), HiWord(Item.MC)]);
    GridUserItem.Cells[7, i + 1] := format('%d/%d', [LoWord(Item.SC), HiWord(Item.SC)]);
    GridUserItem.Cells[8, i + 1] := format('%d/%d', [LoWord(Item.AC), HiWord(Item.AC)]);
    GridUserItem.Cells[9, i + 1] := format('%d/%d', [LoWord(Item.MAC), HiWord(Item.MAC)]);
    GridUserItem.Cells[10, i + 1] := GetAddValue('/', UserItem.btArrXQ);
    GridUserItem.Cells[11, i + 1] := GetAddValue('/', UserItem.btAddValue);
  end;

  if PlayObject.m_ItemList.Count <= 0 then GridBagItem.RowCount := 2
  else GridBagItem.RowCount := PlayObject.m_ItemList.Count + 1;

  for i := 0 to PlayObject.m_ItemList.Count - 1 do begin
    UserItem := PlayObject.m_ItemList.Items[i];
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if StdItem = nil then begin
      GridBagItem.Cells[1, i + 1] := '';
      GridBagItem.Cells[2, i + 1] := '';
      GridBagItem.Cells[3, i + 1] := '';
      GridBagItem.Cells[4, i + 1] := '';
      GridBagItem.Cells[5, i + 1] := '';
      GridBagItem.Cells[6, i + 1] := '';
      GridBagItem.Cells[7, i + 1] := '';
      GridBagItem.Cells[8, i + 1] := '';
      GridBagItem.Cells[9, i + 1] := '';
      GridBagItem.Cells[10, i + 1] := '';
      GridBagItem.Cells[11, i + 1] := '';
      Continue;
    end;
    Item := StdItem^;
    ItemUnit.GetItemAddValue(UserItem, Item);
    GridBagItem.Cells[0, i + 1] := IntToStr(i);
    GridBagItem.Cells[1, i + 1] := Item.Name;
    GridBagItem.Cells[2, i + 1] := IntToStr(Item.StdMode);
    GridBagItem.Cells[3, i + 1] := IntToStr(UserItem.MakeIndex);
    GridBagItem.Cells[4, i + 1] := format('%d/%d', [UserItem.Dura, UserItem.DuraMax]);
    GridBagItem.Cells[5, i + 1] := format('%d/%d', [LoWord(Item.DC), HiWord(Item.DC)]);
    GridBagItem.Cells[6, i + 1] := format('%d/%d', [LoWord(Item.MC), HiWord(Item.MC)]);
    GridBagItem.Cells[7, i + 1] := format('%d/%d', [LoWord(Item.SC), HiWord(Item.SC)]);
    GridBagItem.Cells[8, i + 1] := format('%d/%d', [LoWord(Item.AC), HiWord(Item.AC)]);
    GridBagItem.Cells[9, i + 1] := format('%d/%d', [LoWord(Item.MAC), HiWord(Item.MAC)]);
    GridBagItem.Cells[10, i + 1] := GetAddValue('/', UserItem.btArrXQ);
    GridBagItem.Cells[11, i + 1] := GetAddValue('/', UserItem.btAddValue);
  end;

  if PlayObject.m_StorageItemList.Count <= 0 then GridStorageItem.RowCount := 2
  else GridStorageItem.RowCount := PlayObject.m_StorageItemList.Count + 1;

  for i := 0 to PlayObject.m_StorageItemList.Count - 1 do begin
    UserItem := PlayObject.m_StorageItemList.Items[i];
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if StdItem = nil then begin
      GridStorageItem.Cells[1, i + 1] := '';
      GridStorageItem.Cells[2, i + 1] := '';
      GridStorageItem.Cells[3, i + 1] := '';
      GridStorageItem.Cells[4, i + 1] := '';
      GridStorageItem.Cells[5, i + 1] := '';
      GridStorageItem.Cells[6, i + 1] := '';
      GridStorageItem.Cells[7, i + 1] := '';
      GridStorageItem.Cells[8, i + 1] := '';
      GridStorageItem.Cells[9, i + 1] := '';
      GridStorageItem.Cells[10, i + 1] := '';
      GridStorageItem.Cells[11, i + 1] := '';
      Continue;
    end;
    Item := StdItem^;
    ItemUnit.GetItemAddValue(UserItem, Item);

    GridStorageItem.Cells[0, i + 1] := IntToStr(i);
    GridStorageItem.Cells[1, i + 1] := Item.Name;
    GridStorageItem.Cells[2, i + 1] := IntToStr(Item.StdMode);
    GridStorageItem.Cells[3, i + 1] := IntToStr(UserItem.MakeIndex);
    GridStorageItem.Cells[4, i + 1] := format('%d/%d', [UserItem.Dura, UserItem.DuraMax]);
    GridStorageItem.Cells[5, i + 1] := format('%d/%d', [LoWord(Item.DC), HiWord(Item.DC)]);
    GridStorageItem.Cells[6, i + 1] := format('%d/%d', [LoWord(Item.MC), HiWord(Item.MC)]);
    GridStorageItem.Cells[7, i + 1] := format('%d/%d', [LoWord(Item.SC), HiWord(Item.SC)]);
    GridStorageItem.Cells[8, i + 1] := format('%d/%d', [LoWord(Item.AC), HiWord(Item.AC)]);
    GridStorageItem.Cells[9, i + 1] := format('%d/%d', [LoWord(Item.MAC), HiWord(Item.MAC)]);
    GridStorageItem.Cells[10, i + 1] := GetAddValue('/', UserItem.btArrXQ);
    GridStorageItem.Cells[11, i + 1] := GetAddValue('/', UserItem.btAddValue);
  end;
end;

procedure TfrmHumanInfo.TimerTimer(Sender: TObject);
begin
  if PlayObject = nil then Exit;
  if PlayObject.m_boGhost then begin
    EditHumanStatus.Text := '';
    PlayObject := nil;
    Exit;
  end;
  if PlayObject.m_boIsAuto then begin
    EditHumanStatus.Text := '߹һ';
    PlayObject := nil;
    Exit;
  end;
  if boRefHuman then RefHumanInfo();
end;

procedure TfrmHumanInfo.CheckBoxMonitorClick(Sender: TObject);
begin
  boRefHuman := CheckBoxMonitor.Checked;
  ButtonSave.Enabled := not boRefHuman;
end;

procedure TfrmHumanInfo.ButtonKickClick(Sender: TObject);
begin
  if PlayObject = nil then Exit;
  PlayObject.m_boEmergencyClose := True;
  PlayObject.m_boIsAuto := False;
  PlayObject.m_boPlayOffLine := False;
  ButtonKick.Enabled := False;
end;

procedure TfrmHumanInfo.ButtonSaveClick(Sender: TObject);
var
  nLevel: Integer;
  nGold: Integer;
  nPKPOINT: Integer;
  nGameGold: Integer;
  nGamePoint: Integer;
  nCreditPoint: Integer;
  nBonusPoint: Integer;
  boGameMaster: Boolean;
  boObServer: Boolean;
  boSuperman: Boolean;
begin
  if PlayObject = nil then Exit;
  nLevel := EditLevel.Value;
  nGold := EditGold.Value;
  nPKPOINT := EditPKPoint.Value;
  nGameGold := EditGameGold.Value;
  nGamePoint := EditGamePoint.Value;
  nCreditPoint := EditCreditPoint.Value;
  nBonusPoint := EditBonusPoint.Value;
  boGameMaster := CheckBoxGameMaster.Checked;
  boObServer := CheckBoxObserver.Checked;
  boSuperman := CheckBoxSuperMan.Checked;
  if (nLevel < 0) or (nLevel > High(Word)) or (nGold < 0) or (nGold > 200000000) or (nPKPOINT < 0) or
    (nPKPOINT > High(word)) or (nCreditPoint < 0) or (nCreditPoint > High(Byte)) or (nBonusPoint < 0) or (nBonusPoint > 20000000) then begin
    MessageBox(Handle, 'ݲȷ', 'Ϣ', MB_OK);
    Exit;
  end;
  PlayObject.m_Abil.Level := nLevel;
  PlayObject.m_nGold := nGold;
  PlayObject.m_wPkPoint := nPKPOINT;
  PlayObject.m_nGameGold := nGameGold;
  PlayObject.m_nGamePoint := nGamePoint;
  PlayObject.m_btCreditPoint := nCreditPoint;
  PlayObject.m_nBonusPoint := nBonusPoint;
  PlayObject.m_boAdminMode := boGameMaster;
  PlayObject.m_boObMode := boObServer;
  PlayObject.m_boSuperMan := boSuperman;
  PlayObject.RecalcAbilitys;
  PlayObject.GoldChanged;
  PlayObject.FeatureChanged();
  MessageBox(Handle, 'ѱ档', 'ʾϢ', MB_OK);
end;

procedure TfrmHumanInfo.N_DellItemClick(Sender: TObject);
var
  Item:pTUserItem;
  Idx:Byte;
begin
  if PlayObject = nil then Exit;
  try
    EnterCriticalSection(ProcessHumanCriticalSection);
    with TStringGrid(PopupMenuItemC.PopupComponent),PlayObject do begin
      Idx := Row -1;
      case Tag of
        0:begin //װ
          if not Idx in [Low(THumItems)..High(THumItems)] then Exit;
          Item := @m_UseItems[Idx];
          SendDelItems(Item);
          Item.wIndex := 0;
        end;
        1:begin  //װ
          if not Idx in [0..m_ItemList.Count -1] then Exit;
          Item := pTUserItem(m_ItemList[Idx]);
          SendDelItems(Item);
          m_ItemList.Remove(Item);
          Dispose(Item);
        end;
        2:begin //ֿ
          if (not Idx in [0..m_StorageItemList.Count -1]) then Exit;
          Item := pTUserItem(m_StorageItemList[Idx]);
          m_StorageItemList.Remove(Item);
          Dispose(Item);
        end;
      end;
    end;
  finally
    LeaveCriticalSection(ProcessHumanCriticalSection);
  end;
end;

procedure TfrmHumanInfo.Button_DelItemClick(Sender: TObject);
var
  i,del1,del2,del3:Integer;
  CzItem:pTUserItem;
  function CanDel(Item:pTUserItem):Boolean;
  var
    StdItem2: pTStdItem;
    StdItem: TStdItem;
    boDel:Boolean;
    ItemVal,ii:Integer;
  begin
    boDel := False;
    if Item = nil then Exit;
    StdItem2 := UserEngine.GetStdItem(Item.wIndex);
    if StdItem2 = nil then Exit;
      StdItem := StdItem2^;
    ItemUnit.GetItemAddValue(Item, StdItem);
    case ComboBox_DelItem.ItemIndex of
      0:begin//
         ItemVal := StdItem.StdMode;
      end;
      1:begin//־
        ItemVal := Item.Dura;
      end;
      2:begin//
        ItemVal := StdItem.AC;
      end;
      3:begin//ħ
        ItemVal := StdItem.MAC;
      end;
      4:begin//
        ItemVal := StdItem.DC;
      end;
      5:begin//ħ
        ItemVal := StdItem.MC;
      end;
      6:begin//
        ItemVal := StdItem.SC;
      end;
      7:begin//Ƕ
        for ii := Low(StdItem.btArrXQ) to High(StdItem.btArrXQ) do
        begin
          ItemVal := StdItem.btArrXQ[ii];
          case ComboBox_DelItem_CheckType.ItemIndex of
            0:begin//>
              boDel := ItemVal > SpinEdit_DelItem_CheckVal.Value;
            end;
            1:begin//<С
              boDel := ItemVal > SpinEdit_DelItem_CheckVal.Value;
            end;
            2:begin//=
              boDel := ItemVal = SpinEdit_DelItem_CheckVal.Value;
            end;
            3:begin//>=ڵ
              boDel := ItemVal >= SpinEdit_DelItem_CheckVal.Value;
            end;
            4:begin//<=Сڵ
              boDel := ItemVal <= SpinEdit_DelItem_CheckVal.Value;
            end;
          end;
          if boDel then begin
            Result := True;
            Exit;
          end;
        end;
      end;
      8:begin//ȼ
        ItemVal := StdItem.UpLevel;
      end;
    end;
    case ComboBox_DelItem_CheckType.ItemIndex of
      0:begin//>
        boDel := ItemVal > SpinEdit_DelItem_CheckVal.Value;
      end;
      1:begin//<С
        boDel := ItemVal > SpinEdit_DelItem_CheckVal.Value;
      end;
      2:begin//=
        boDel := ItemVal = SpinEdit_DelItem_CheckVal.Value;
      end;
      3:begin//>=ڵ
        boDel := ItemVal >= SpinEdit_DelItem_CheckVal.Value;
      end;
      4:begin//<=Сڵ
        boDel := ItemVal <= SpinEdit_DelItem_CheckVal.Value;
      end;
    end;
    Result := boDel;
  end;
begin
  if PlayObject = nil then Exit;
  try
    del1 := 0;
    del2 := 0;
    del3 := 0;
    EnterCriticalSection(ProcessHumanCriticalSection);
    with PlayObject do begin
      for i := Low(THumItems) to High(THumItems) do begin
        CzItem := @m_UseItems[i];
        if CanDel(CzItem) then begin
          SendDelItems(CzItem);
          CzItem.wIndex := 0;
          Inc(del1);
        end;
      end;
      for i := 0 to m_ItemList.Count-1 do begin
        CzItem := pTUserItem(m_ItemList[i]);
        if CanDel(CzItem) then begin
          SendDelItems(CzItem);
          m_ItemList.Remove(CzItem);
          Inc(del2);
        end;
      end;
      for i := 0 to m_StorageItemList.Count-1 do begin
        CzItem := pTUserItem(m_StorageItemList[i]);
        if CanDel(CzItem) then begin
          m_StorageItemList.Remove(CzItem);
          Inc(del3);
        end;
      end;
    end;
  finally
    LeaveCriticalSection(ProcessHumanCriticalSection);
  end;
  if del1+del2+del3 <> 0 then 
  ShowMessage(Format('ɾɹ'+#13+
                     'װ:%d'+#13+
                     'װ:%d'+#13+
                     'ֿװ:%d',

  [del1,del2,del3]));
end;

end.
