{------------------------------------------------------------------------------}
{ Ԫ: ObjHero.pas                                                        }
{                                                                              }
{ Ԫ: Mars                                                               }
{ : 2007-02-12 20:30:00                                                }
{                                                                              }
{ ܽ:                                                                    }
{   ʵӢ۹ܵԪ                                                           }
{                                                                              }
{ ʹ˵:                                                                    }
{                                                                              }
{                                                                              }
{ ʷ:                                                                    }
{                                                                              }
{ д:                                                                    }
{                                                                              }
{                                                                              }
{------------------------------------------------------------------------------}
unit ObjHero;

interface
uses
  Windows, SysUtils, StrUtils, Classes, Grobal2, ObjBase, IniFiles, Castle;
type
  THeroObject = class(TBaseObject)
    n54C: Integer;
    m_dwThinkTick: LongWord;
    bo554: Boolean;
    m_boDupMode: Boolean;
    m_nNotProcessCount: Integer;
    m_nTargetX: Integer;
    m_nTargetY: Integer;
    m_boRunAwayMode: Boolean;
    m_dwRunAwayStart: LongWord;
    m_dwRunAwayTime: LongWord;
    m_boCanPickUpItem: Boolean;
    m_boSlavePickUpItem: Boolean;
    m_dwPickUpItemTick: LongWord;
    m_boIsPickUpItem: Boolean;
    m_nPickUpItemMakeIndex: Integer;
    m_SelMapItem: PTMapItem;

    m_wHitMode: Word;

    m_btOldDir: Byte;
    m_dwActionTick: LongWord;
    m_wOldIdent: Word;

    m_dwTurnIntervalTime: LongWord;
    m_dwMagicHitIntervalTime: LongWord;
    m_dwHitIntervalTime: LongWord;
    m_dwRunIntervalTime: LongWord;
    m_dwWalkIntervalTime: LongWord;

    m_dwActionIntervalTime: LongWord;
    m_dwRunLongHitIntervalTime: LongWord;
    m_dwWalkHitIntervalTime: LongWord;
    m_dwRunHitIntervalTime: LongWord;
    m_dwRunMagicIntervalTime: LongWord;

    m_nDieDropUseItemRate: Integer; //װ
    m_SkillUseTick: array[0..60 - 1] of LongWord; //ħʹü
    m_nItemBagCount: Integer;
    m_btStatus: Byte; //״̬
    m_boProtectStatus: Boolean; //Ƿػ״̬
    m_boTarget: Boolean; //ǷĿ
    m_nProtectTargetX, m_nProtectTargetY: Integer; //ػ
    m_dwAutoAvoidTick: LongWord;
    m_boIsNeedAvoid: Boolean;

    m_dwEatItemTick: LongWord;
    m_dwSearchIsPickUpItemTick: LongWord;
    m_dwSearchIsPickUpItemTime: LongWord;
    m_boCanDrop: Boolean;
    m_boCanUseItem: Boolean; //ǷʹƷ
    m_boCanWalk: Boolean;
    m_boCanRun: Boolean;
    m_boCanHit: Boolean;
    m_boCanSpell: Boolean;
    m_boCanSendMsg: Boolean;
    m_btReLevel: Byte;
    m_btCreditPoint: Byte;
    m_nMemberType: Integer;
    m_nMemberLevel: Integer;
    m_nKillMonExpMultiple: Integer;
    m_nKillMonExpRate: Integer;

    m_dwMagicAttackInterval: LongWord;
    m_dwMagicAttackTick: LongWord;
    m_dwSearchMagic: LongWord;
    m_nSelectMagic: Integer;
    m_boIsUseMagic: Boolean;
    m_boIsUseAttackMagic: Boolean;
    m_btLastDirection: Byte;
    m_wLastHP: Word;
    m_nPickUpItemPosition: Integer;
    m_nFirDragonPoint: Integer;
    m_dwAddFirDragonTick: LongWord;
    m_boStartUseSpell: Boolean;
    m_nStartUseSpell: Integer;
    m_dwStartUseSpellTick: LongWord;
    m_boNewHuman: Boolean;
  private
    function Think: Boolean;
    function GetSpellPoint(UserMagic: pTUserMagic): Integer;

    function SearchPickUpItem(nPickUpTime: Integer): Boolean;
    procedure EatMedicine();
    function AutoEatUseItems(btItemType: Byte): Boolean; //Զҩ
    function WarrAttackTarget(wHitMode: Word): Boolean; {}
    function WarrorAttackTarget(): Boolean; {սʿ}
    function WizardAttackTarget(): Boolean; {ʦ}
    function TaoistAttackTarget(): Boolean; {ʿ}
    function CompareHP(BaseObject1, BaseObject2: TBaseObject): Boolean;
    function CompareLevel(BaseObject1, BaseObject2: TBaseObject): Boolean;
    function CompareXY(BaseObject1, BaseObject2: TBaseObject): Boolean;
    function EatUseItems(nShape: Integer): Boolean;
    function AutoAvoid(): Boolean; //Զ

    function SearchIsPickUpItem(): Boolean;
    function IsPickUpItem(StdItem: pTStdItem): Boolean;

    function IsNeedAvoid(): Boolean; //ǷҪ
    function IsNeedGotoXY(): Boolean; //ǷĿ

    function CheckUserMagic(wMagIdx: Word): pTUserMagic;
    function CheckTargetXYCount(nX, nY, nRange: Integer): Integer;

    function GotoTargetXYRange(): Boolean;
    function GetUserItemList(nItemType: Integer): Integer;
    function UseItem(nItemType, nIndex: Integer): Boolean;
    function CheckUserItemType(nItemType: Integer): Boolean;
    function CheckItemType(nItemType: Integer; StdItem: pTStdItem): Boolean;
    function FindMagic(wMagIdx: Word): pTUserMagic;
    function CheckTargetXYCountOfDirection(nX, nY, nDir, nRange: Integer): Integer;
    procedure SearchMagic();
    function SelectMagic(): Integer; //ѡħ
    function IsUseMagic(): Boolean;
    function IsUseAttackMagic(): Boolean;
    function IsSearchTarget: Boolean;
    function CheckActionStatus(wIdent: Word; var dwDelayTime: LongWord): Boolean;
    function DoMotaebo(nDir: Byte; nMagicLevel: Integer): Boolean;
    procedure RepairAllItem();
    function GetTogetherUseSpell: Integer;

  public
    constructor Create(); override;
    destructor Destroy; override;
    function Operate(ProcessMsg: pTProcessMessage): Boolean; override;
    function AttackTarget(): Boolean;
    function CheckTakeOnItems(nWhere: Integer; var StdItem: TStdItem): Boolean;
    function IsEnoughBag(): Boolean;
    procedure RecalcAbilitys; override;
    procedure Run; override;
    procedure Die; override;
    function GetShowName(): string; override;
    procedure ItemDamageRevivalRing();
    procedure DoDamageWeapon(nWeaponDamage: Integer);
    procedure StruckDamage(nDamage: Integer);
    function IsAllowUseMagic(wMagIdx: Word): Boolean;
    procedure SearchTarget();
    procedure DelTargetCreat(); override;
    procedure SetTargetXY(nX, nY: Integer); virtual;
    function WalkToTargetXY2(nTargetX, nTargetY: Integer): Boolean;
    function WalkToTargetXY(nTargetX, nTargetY: Integer): Boolean;
    function RunToTargetXY(nTargetX, nTargetY: Integer): Boolean;
    function GotoTargetXY(nTargetX, nTargetY: Integer): Boolean;

    procedure Wondering(); virtual;
    procedure Attack(TargeTBaseObject: TBaseObject; nDir: Integer); virtual;
    procedure Struck(hiter: TBaseObject); virtual;

    procedure ClientQueryBagItems();

    procedure RefMyStatus();
    function AddItemToBag(UserItem: pTUserItem): Boolean;
    procedure WeightChanged;
    function ReadBook(StdItem: pTStdItem): Boolean;
    function EatItems(StdItem: pTStdItem): Boolean;
    procedure SysMsg(sMsg: string; MsgColor: TMsgColor; MsgType: TMsgType);
    procedure SendSocket(DefMsg: pTDefaultMessage; sMsg: string);
    procedure SendDefMessage(wIdent: Word; nRecog: Integer; nParam, nTag, nSeries: Word; sMsg: string);
    procedure SendMsg(BaseObject: TBaseObject; wIdent, wParam: Word; nParam1, nParam2, nParam3: Integer; sMsg: string);
    procedure SendUpdateMsg(BaseObject: TBaseObject; wIdent, wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string);
    procedure SendDelayMsg(BaseObject: TBaseObject; wIdent, wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string; dwDelay: LongWord);
    procedure SendUpdateDelayMsg(BaseObject: TBaseObject; wIdent, wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string; dwDelay: LongWord);
    procedure SendChangeItems(nWhere1, nWhere2: Integer; UserItem1, UserItem2: pTUserItem);
    procedure SendUseitems();
    procedure SendUseMagic();
    procedure SendDelMagic(UserMagic: pTUserMagic);
    procedure SendAddMagic(UserMagic: pTUserMagic);
    procedure SendAddItem(UserItem: pTUserItem);
    procedure SendDelItemList(ItemList: TStringList);
    procedure SendDelItems(UserItem: pTUserItem);
    procedure SendUpdateItem(UserItem: pTUserItem);
    procedure ClientHeroUseItems(nItemIdx: Integer; sItemName: string); //Ӣ۳ҩ
    procedure GetBagItemCount;
    procedure MakeWeaponUnlock;
    function WeaptonMakeLuck: Boolean;
    function RepairWeapon: Boolean;
    function SuperRepairWeapon: Boolean;
    procedure GetExp(dwExp: LongWord);
    procedure WinExp(dwExp: LongWord);
    procedure GainExp(dwExp: LongWord);
    function AbilityUp(UserMagic: pTUserMagic): Boolean;
    function ClientSpellXY(UserMagic: pTUserMagic; nTargetX, nTargetY: Integer;
      TargeTBaseObject: TBaseObject): Boolean;
    function ClientDropItem(sItemName: string; nItemIdx: Integer): Boolean;
    function DoSpell(UserMagic: pTUserMagic; nTargetX, nTargetY: Integer; BaseObject: TBaseObject): Boolean;
    function FindTogetherMagic: pTUserMagic;
    function WearFirDragon: Boolean;
    procedure RepairFirDragon(btType: Byte; nItemIdx: Integer; sItemName: string);

    procedure MakeSaveRcd(var HumanRcd: THumDataInfo);
    procedure Login();
  end;

implementation
uses UsrEngn, M2Share, Event, GameMap, Magic, HUtil32, PlugIn, Common, EDcode;

{ THeroObject }

constructor THeroObject.Create;
begin
  inherited;
  m_btRaceServer := RC_HEROOBJECT;
  m_boDupMode := False;
  bo554 := False;
  m_dwThinkTick := GetTickCount();
  m_nViewRange := 12;
  m_nRunTime := 250;
  m_dwSearchTick := GetTickCount();
  m_nCopyHumanLevel := 3;
  m_nNotProcessCount := 0;
  m_nTargetX := -1;
  dwTick3F0 := Random(4) * 500 + 1000;
  dwTick3F4 := GetTickCount();
  m_btNameColor := 6;
  m_boFixedHideMode := True;
  m_dwHitIntervalTime := g_Config.dwHitIntervalTime; //
  m_dwMagicHitIntervalTime := g_Config.dwMagicHitIntervalTime; //ħ
  m_dwRunIntervalTime := g_Config.dwRunIntervalTime; //·
  m_dwWalkIntervalTime := g_Config.dwWalkIntervalTime; //·
  m_dwTurnIntervalTime := g_Config.dwTurnIntervalTime; //
  m_dwActionIntervalTime := g_Config.dwActionIntervalTime; //ϲ
  m_dwRunLongHitIntervalTime := g_Config.dwRunLongHitIntervalTime; //ϲ
  m_dwRunHitIntervalTime := g_Config.dwRunHitIntervalTime; //ϲ
  m_dwWalkHitIntervalTime := g_Config.dwWalkHitIntervalTime; //ϲ
  m_dwRunMagicIntervalTime := g_Config.dwRunMagicIntervalTime; //λħ

  m_dwHitTick := GetTickCount - LongWord(Random(3000));
  m_dwWalkTick := GetTickCount - LongWord(Random(3000));
  m_nWalkSpeed := 300;
  m_nWalkStep := 10;
  m_dwWalkWait := 0;
  m_dwSearchEnemyTick := GetTickCount();
  m_boRunAwayMode := False;
  m_dwRunAwayStart := GetTickCount();
  m_dwRunAwayTime := 0;
  m_boCanPickUpItem := True;
  m_boSlavePickUpItem := False;
  m_dwPickUpItemTick := GetTickCount();
  m_dwAutoAvoidTick := GetTickCount();
  m_dwEatItemTick := GetTickCount();
  m_boIsNeedAvoid := False;
  m_SelMapItem := nil;
  m_boIsPickUpItem := False;
  m_nNextHitTime := 300;
  m_nDieDropUseItemRate := 100;
  m_nItemBagCount := 10;
  m_btStatus := 0; //״̬
  m_boProtectStatus := False; //Ƿػ״̬
  m_boTarget := False; //ǷĿ

  m_nProtectTargetX := -1; //ػ
  m_nProtectTargetY := -1; //ػ

  m_boCanDrop := True; //ǷƷ
  m_boCanUseItem := True; //ǷʹƷ
  m_boCanWalk := True;
  m_boCanRun := True;
  m_boCanHit := True;
  m_boCanSpell := True;
  m_boCanSendMsg := True;
  m_btReLevel := 0;
  m_btCreditPoint := 0;
  m_nMemberType := 0;
  m_nMemberLevel := 0;
  m_nKillMonExpMultiple := 1;
  m_nKillMonExpRate := 100;
  m_boIsUseMagic := False;
  m_boIsUseAttackMagic := False;
  m_nSelectMagic := 0;
  m_nPickUpItemPosition := 0;
  m_nFirDragonPoint := 0;
  m_dwAddFirDragonTick := GetTickCount();
  m_btLastDirection := m_btDirection;
  m_wLastHP := 0;
  m_nStartUseSpell := 0;
  m_boStartUseSpell := False;
  m_dwSearchMagic := GetTickCount();
  FillChar(m_SkillUseTick, SizeOf(m_SkillUseTick), 0);
  m_boNewHuman := False;
end;

destructor THeroObject.Destroy;
begin
  inherited;
end;

procedure THeroObject.SysMsg(sMsg: string; MsgColor: TMsgColor; MsgType: TMsgType);
begin
  if m_Master = nil then Exit;
  if (m_Master <> nil) and TPlayObject(m_Master).m_boNotOnlineAddExp then Exit;
  m_Master.SysMsg('(Ӣ)' + sMsg, MsgColor, MsgType);
end;

procedure THeroObject.SendSocket(DefMsg: pTDefaultMessage; sMsg: string);
begin
  if m_Master = nil then Exit;
  if (m_Master <> nil) and TPlayObject(m_Master).m_boNotOnlineAddExp then Exit;
  TPlayObject(m_Master).SendSocket(DefMsg, sMsg);
end;

procedure THeroObject.SendDefMessage(wIdent: Word; nRecog: Integer; nParam, nTag, nSeries: Word; sMsg: string);
begin
  if m_Master = nil then Exit;
  if (m_Master <> nil) and TPlayObject(m_Master).m_boNotOnlineAddExp then Exit;
  TPlayObject(m_Master).SendDefMessage(wIdent, nRecog, nParam, nTag, nSeries, sMsg);
end;

procedure THeroObject.SendMsg(BaseObject: TBaseObject; wIdent, wParam: Word; nParam1, nParam2, nParam3: Integer; sMsg: string);
begin
  if m_Master = nil then Exit;
  if (m_Master <> nil) and TPlayObject(m_Master).m_boNotOnlineAddExp then Exit;
  m_Master.SendMsg(BaseObject, wIdent, wParam, nParam1, nParam2, nParam3, sMsg);
end;

procedure THeroObject.SendUpdateMsg(BaseObject: TBaseObject; wIdent, wParam: Word;
  lParam1, lParam2, lParam3: Integer; sMsg: string);
begin
  if m_Master = nil then Exit;
  if (m_Master <> nil) and TPlayObject(m_Master).m_boNotOnlineAddExp then Exit;
  m_Master.SendUpdateMsg(BaseObject, wIdent, wParam, lParam1, lParam2, lParam3, sMsg);
end;

procedure THeroObject.SendDelayMsg(BaseObject: TBaseObject; wIdent, wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string; dwDelay: LongWord);
begin
  if m_Master = nil then Exit;
  if (m_Master <> nil) and TPlayObject(m_Master).m_boNotOnlineAddExp then Exit;
  m_Master.SendDelayMsg(BaseObject, wIdent, wParam, lParam1, lParam2, lParam3, sMsg, dwDelay);
end;

procedure THeroObject.SendUpdateDelayMsg(BaseObject: TBaseObject; wIdent, wParam: Word; lParam1, lParam2, lParam3: Integer; sMsg: string; dwDelay: LongWord);
begin
  if m_Master = nil then Exit;
  if (m_Master <> nil) and TPlayObject(m_Master).m_boNotOnlineAddExp then Exit;
  m_Master.SendUpdateDelayMsg(BaseObject, wIdent, wParam, lParam1, lParam2, lParam3, sMsg, dwDelay);
end;

function THeroObject.FindTogetherMagic: pTUserMagic;
begin
  Result := FindMagic(GetTogetherUseSpell);
end;

function THeroObject.GetTogetherUseSpell: Integer;
begin
  Result := 0;
  if m_Master = nil then Exit;
  case m_Master.m_btJob of
    0: begin
        case m_btJob of
          0: Result := 60;
          1: Result := 62;
          2: Result := 61;
        end;
      end;
    1: begin
        case m_btJob of
          0: Result := 62;
          1: Result := 65;
          2: Result := 64;
        end;
      end;
    2: begin
        case m_btJob of
          0: Result := 61;
          1: Result := 64;
          2: Result := 63;
        end;
      end;
  end;
end;

procedure THeroObject.ClientQueryBagItems();
var
  I: Integer;
  Item: pTStdItem;
  sSENDMSG: string;
  ClientItem: TClientItem;
  StdItem: TStdItem;
  UserItem: pTUserItem;
  sUserItemName: string;
begin
  sSENDMSG := '';
  for I := 0 to m_ItemList.Count - 1 do begin
    UserItem := m_ItemList.Items[I];
    Item := UserEngine.GetStdItem(UserItem.wIndex);
    if Item <> nil then begin
      StdItem := Item^;
      ItemUnit.GetItemAddValue(UserItem, StdItem);
      Move(StdItem, ClientItem.s, SizeOf(TStdItem));
      //ȡԶƷ
      sUserItemName := '';
      if UserItem.btValue[13] = 1 then
        sUserItemName := ItemUnit.GetCustomItemName(UserItem.MakeIndex, UserItem.wIndex);
      if sUserItemName <> '' then
        ClientItem.s.Name := sUserItemName;
      ClientItem.Dura := UserItem.Dura;
      ClientItem.DuraMax := UserItem.DuraMax;
      ClientItem.MakeIndex := UserItem.MakeIndex;
      if StdItem.StdMode = 50 then begin
        ClientItem.s.Name := ClientItem.s.Name + ' #' + IntToStr(UserItem.Dura);
      end;
      sSENDMSG := sSENDMSG + EncodeBuffer(@ClientItem, SizeOf(TClientItem)) + '/';
    end;
  end;
  if sSENDMSG <> '' then begin
    m_DefMsg := MakeDefaultMsg(SM_HEROBAGITEMS, Integer(m_Master), 0, 0, m_ItemList.Count);
    SendSocket(@m_DefMsg, sSENDMSG);
  end;
end;

procedure THeroObject.GetBagItemCount;
var
  I: Integer;
  nOldBagCount: Integer;
begin
  nOldBagCount := m_nItemBagCount;
  for I := High(g_Config.nHeroBagItemCount) downto Low(g_Config.nHeroBagItemCount) do begin
    if m_Abil.Level >= g_Config.nHeroBagItemCount[I] then begin
      case I of
        0: m_nItemBagCount := 20;
        1: m_nItemBagCount := 30;
        2: m_nItemBagCount := 35;
        3: m_nItemBagCount := 40;
      end;
      Break;
    end;
  end;
  if nOldBagCount <> m_nItemBagCount then begin
    SendMsg(m_Master, RM_QUERYHEROBAGCOUNT, 0, m_nItemBagCount, 0, 0, '');
  end;
end;

function THeroObject.AddItemToBag(UserItem: pTUserItem): Boolean;
begin
  Result := False;
  if m_Master = nil then Exit;
  if m_ItemList.Count < m_nItemBagCount then begin
    m_ItemList.Add(UserItem);
    WeightChanged();
    Result := True;
  end;
end;

procedure THeroObject.SendUseMagic();
var
  I: Integer;
  sSENDMSG: string;
  UserMagic: pTUserMagic;
  ClientMagic: TClientMagic;
begin
  sSENDMSG := '';
  for I := 0 to m_MagicList.Count - 1 do begin
    UserMagic := m_MagicList.Items[I];
    if UserMagic <> nil then begin
      ClientMagic.Key := Chr(UserMagic.btKey);
      ClientMagic.Level := UserMagic.btLevel;
      ClientMagic.CurTrain := UserMagic.nTranPoint;
      ClientMagic.Def := UserMagic.MagicInfo^;
      sSENDMSG := sSENDMSG + EncodeBuffer(@ClientMagic, SizeOf(TClientMagic)) + '/';
    end;
  end;
  if sSENDMSG <> '' then begin
    m_DefMsg := MakeDefaultMsg(SM_HEROSENDMYMAGIC, 0, 0, 0, m_MagicList.Count);
    SendSocket(@m_DefMsg, sSENDMSG);
  end;
end;

procedure THeroObject.SendUseitems();
var
  I: Integer;
  Item: pTStdItem;
  sSENDMSG: string;
  ClientItem: TClientItem;
  StdItem: TStdItem;
  sUserItemName: string;
begin
  sSENDMSG := '';
  for I := Low(THumanUseItems) to High(THumanUseItems) do begin
    if m_UseItems[I].wIndex > 0 then begin
      //sItemNewName:=GetItemName(m_UseItems[i].MakeIndex);
      Item := UserEngine.GetStdItem(m_UseItems[I].wIndex);
      if Item <> nil then begin
        StdItem := Item^;
        ItemUnit.GetItemAddValue(@m_UseItems[I], StdItem);
        Move(StdItem, ClientItem.s, SizeOf(TStdItem));
        //ȡԶƷ
        sUserItemName := '';
        if m_UseItems[I].btValue[13] = 1 then
          sUserItemName := ItemUnit.GetCustomItemName(m_UseItems[I].MakeIndex, m_UseItems[I].wIndex);
        if sUserItemName <> '' then
          ClientItem.s.Name := sUserItemName;
        ClientItem.Dura := m_UseItems[I].Dura;
        ClientItem.DuraMax := m_UseItems[I].DuraMax;
        ClientItem.MakeIndex := m_UseItems[I].MakeIndex;
        sSENDMSG := sSENDMSG + IntToStr(I) + '/' + EncodeBuffer(@ClientItem, SizeOf(TClientItem)) + '/';
      end;
    end;
  end;
  if sSENDMSG <> '' then begin
    m_DefMsg := MakeDefaultMsg(SM_SENDHEROUSEITEMS, 0, 0, 0, 0);
    SendSocket(@m_DefMsg, sSENDMSG);
  end;
end;

procedure THeroObject.SendChangeItems(nWhere1, nWhere2: Integer; UserItem1, UserItem2: pTUserItem);
var
  StdItem1: pTStdItem;
  StdItem2: pTStdItem;
  StdItem80: TStdItem;
  ClientItem: TClientItem;
  sUserItemName: string;
  sSendText: string;
begin
  sSendText := '';
  if UserItem1 <> nil then begin
    StdItem1 := UserEngine.GetStdItem(UserItem1.wIndex);
    if StdItem1 <> nil then begin
      StdItem80 := StdItem1^;
      ItemUnit.GetItemAddValue(@UserItem1, StdItem80);
      Move(StdItem80, ClientItem.s, SizeOf(TStdItem));
      //ȡԶƷ
      sUserItemName := '';
      if UserItem1.btValue[13] = 1 then
        sUserItemName := ItemUnit.GetCustomItemName(UserItem1.MakeIndex, UserItem1.wIndex);
      if sUserItemName <> '' then
        ClientItem.s.Name := sUserItemName;
      ClientItem.MakeIndex := UserItem1.MakeIndex;
      ClientItem.Dura := UserItem1.Dura;
      ClientItem.DuraMax := UserItem1.DuraMax;
      if StdItem1.StdMode = 50 then begin
        ClientItem.s.Name := ClientItem.s.Name + ' #' + IntToStr(UserItem1.Dura);
      end;
      sSendText := '0/' + IntToStr(nWhere1) + '/' + EncodeBuffer(@ClientItem, SizeOf(TClientItem)) + '/';
    end;
  end;

  if UserItem2 <> nil then begin
    StdItem2 := UserEngine.GetStdItem(UserItem2.wIndex);
    if StdItem2 <> nil then begin
      StdItem2 := UserEngine.GetStdItem(UserItem2.wIndex);
      StdItem80 := StdItem2^;
      ItemUnit.GetItemAddValue(@UserItem2, StdItem80);
      Move(StdItem80, ClientItem.s, SizeOf(TStdItem));
      //ȡԶƷ
      sUserItemName := '';
      if UserItem2.btValue[13] = 1 then
        sUserItemName := ItemUnit.GetCustomItemName(UserItem2.MakeIndex, UserItem2.wIndex);
      if sUserItemName <> '' then
        ClientItem.s.Name := sUserItemName;
      ClientItem.MakeIndex := UserItem2.MakeIndex;
      ClientItem.Dura := UserItem2.Dura;
      ClientItem.DuraMax := UserItem2.DuraMax;
      if StdItem2.StdMode = 50 then begin
        ClientItem.s.Name := ClientItem.s.Name + ' #' + IntToStr(UserItem2.Dura);
      end;
      if sSendText = '' then begin
        sSendText := '1/' + IntToStr(nWhere2) + '/' + EncodeBuffer(@ClientItem, SizeOf(TClientItem)) + '/';
      end else begin
        sSendText := sSendText + '1/' + IntToStr(nWhere2) + '/' + EncodeBuffer(@ClientItem, SizeOf(TClientItem)) + '/';
      end;
    end;
  end;
  if sSendText <> '' then begin
    m_DefMsg := MakeDefaultMsg(SM_HEROCHANGEITEM, Integer(m_Master), 0, 0, 0);
    SendSocket(@m_DefMsg, sSendText);
  end;
end;

procedure THeroObject.SendDelItemList(ItemList: TStringList);
var
  I: Integer;
  s10: string;
begin
  s10 := '';
  for I := 0 to ItemList.Count - 1 do begin
    s10 := s10 + ItemList.Strings[I] + '/' + IntToStr(Integer(ItemList.Objects[I])) + '/';
  end;
  m_DefMsg := MakeDefaultMsg(SM_HERODELITEMS, 0, 0, 0, ItemList.Count);
  SendSocket(@m_DefMsg, EncodeString(s10));
end;

procedure THeroObject.SendDelItems(UserItem: pTUserItem);
var
  StdItem: pTStdItem;
  StdItem80: TStdItem;
  ClientItem: TClientItem;
  sUserItemName: string;
begin
  StdItem := UserEngine.GetStdItem(UserItem.wIndex);
  if StdItem <> nil then begin
    StdItem80 := StdItem^;
    ItemUnit.GetItemAddValue(@UserItem, StdItem80);
    Move(StdItem80, ClientItem.s, SizeOf(TStdItem));
    //ȡԶƷ
    sUserItemName := '';
    if UserItem.btValue[13] = 1 then
      sUserItemName := ItemUnit.GetCustomItemName(UserItem.MakeIndex, UserItem.wIndex);
    if sUserItemName <> '' then
      ClientItem.s.Name := sUserItemName;
    ClientItem.MakeIndex := UserItem.MakeIndex;
    ClientItem.Dura := UserItem.Dura;
    ClientItem.DuraMax := UserItem.DuraMax;
    if StdItem.StdMode = 50 then begin
      ClientItem.s.Name := ClientItem.s.Name + ' #' + IntToStr(UserItem.Dura);
    end;
    m_DefMsg := MakeDefaultMsg(SM_HERODELITEM, Integer(m_Master), 0, 0, 1);
    SendSocket(@m_DefMsg, EncodeBuffer(@ClientItem, SizeOf(TClientItem)));
  end;
end;

procedure THeroObject.SendAddItem(UserItem: pTUserItem);
var
  pStdItem: pTStdItem;
  StdItem: TStdItem;
  ClientItem: TClientItem;
  sUserItemName: string;
begin
  pStdItem := UserEngine.GetStdItem(UserItem.wIndex);
  if pStdItem = nil then Exit;
  StdItem := pStdItem^;
  ItemUnit.GetItemAddValue(UserItem, StdItem);
  Move(StdItem, ClientItem.s, SizeOf(TStdItem));
  //ȡԶƷ
  sUserItemName := '';
  if UserItem.btValue[13] = 1 then
    sUserItemName := ItemUnit.GetCustomItemName(UserItem.MakeIndex, UserItem.wIndex);
  if sUserItemName <> '' then
    ClientItem.s.Name := sUserItemName;
  ClientItem.MakeIndex := UserItem.MakeIndex;
  ClientItem.Dura := UserItem.Dura;
  ClientItem.DuraMax := UserItem.DuraMax;
  if StdItem.StdMode = 50 then begin
    ClientItem.s.Name := ClientItem.s.Name + ' #' + IntToStr(UserItem.Dura);
  end;
  if StdItem.StdMode in [15, 19, 20, 21, 22, 23, 24, 26] then begin
    if UserItem.btValue[8] = 0 then ClientItem.s.Shape := 0
    else ClientItem.s.Shape := 130;
  end;
  m_DefMsg := MakeDefaultMsg(SM_HEROADDITEM, Integer(m_Master), 0, 0, 1);
  SendSocket(@m_DefMsg, EncodeBuffer(@ClientItem, SizeOf(TClientItem)));
end;

procedure THeroObject.SendUpdateItem(UserItem: pTUserItem);
var
  StdItem: pTStdItem;
  StdItem80: TStdItem;
  ClientItem: TClientItem;
  OClientItem: TOClientItem;
  sUserItemName: string;
begin
  StdItem := UserEngine.GetStdItem(UserItem.wIndex);
  if StdItem <> nil then begin
    StdItem80 := StdItem^;
    ItemUnit.GetItemAddValue(UserItem, StdItem80);
    ClientItem.s := StdItem80;
    //ȡԶƷ
    sUserItemName := '';
    if UserItem.btValue[13] = 1 then
      sUserItemName := ItemUnit.GetCustomItemName(UserItem.MakeIndex, UserItem.wIndex);
    if sUserItemName <> '' then
      ClientItem.s.Name := sUserItemName;

    ClientItem.MakeIndex := UserItem.MakeIndex;
    ClientItem.Dura := UserItem.Dura;
    ClientItem.DuraMax := UserItem.DuraMax;
    if StdItem.StdMode = 50 then begin
      ClientItem.s.Name := ClientItem.s.Name + ' #' + IntToStr(UserItem.Dura);
    end;
    m_DefMsg := MakeDefaultMsg(SM_HEROUPDATEITEM, Integer(Self), 0, 0, 1);
    SendSocket(@m_DefMsg, EncodeBuffer(@ClientItem, SizeOf(TClientItem)));
  end;
end;

function THeroObject.GetShowName(): string;
begin
  Result := m_sCharName;
end;

procedure THeroObject.ItemDamageRevivalRing();
var
  I: Integer;
  pSItem: pTStdItem;
  nDura, tDura: Integer;
  HeroObject: THeroObject;
begin
  for I := Low(THumanUseItems) to High(THumanUseItems) do begin
    if m_UseItems[I].wIndex > 0 then begin
      pSItem := UserEngine.GetStdItem(m_UseItems[I].wIndex);
      if pSItem <> nil then begin
//        if (i = U_RINGR) or (i = U_RINGL) then begin
        if (pSItem.Shape in [114, 160, 161, 162]) or (((I = U_WEAPON) or (I = U_RIGHTHAND)) and (pSItem.AniCount in [114, 160, 161, 162])) then begin
          nDura := m_UseItems[I].Dura;
          tDura := Round(nDura / 1000 {1.03});
          Dec(nDura, 1000);
          if nDura <= 0 then begin
            nDura := 0;
            m_UseItems[I].Dura := nDura;
            if m_btRaceServer = RC_HEROOBJECT then begin
              HeroObject := THeroObject(Self);
              HeroObject.SendDelItems(@m_UseItems[I]);
            end; //004C0310
            m_UseItems[I].wIndex := 0;
            RecalcAbilitys();
          end else begin //004C0331
            m_UseItems[I].Dura := nDura;
          end;
          if tDura <> Round(nDura / 1000 {1.03}) then begin
            SendMsg(Self, RM_HERODURACHANGE, I, nDura, m_UseItems[I].DuraMax, 0, '');
          end;
            //break;
        end; //004C0397
//        end;//004C0397
      end; //004C0397 if pSItem <> nil then begin
    end; //if UseItems[i].wIndex > 0 then begin
  end; // for i:=Low(UseItems) to High(UseItems) do begin
end;

procedure THeroObject.DoDamageWeapon(nWeaponDamage: Integer);
var
  nDura, nDuraPoint: Integer;
  HeroObject: THeroObject;
  StdItem: pTStdItem;
begin
  if m_UseItems[U_WEAPON].wIndex <= 0 then Exit;
  nDura := m_UseItems[U_WEAPON].Dura;
  nDuraPoint := Round(nDura / 1.03);
  Dec(nDura, nWeaponDamage);
  if nDura <= 0 then begin
    nDura := 0;
    m_UseItems[U_WEAPON].Dura := nDura;
    if m_btRaceServer = RC_HEROOBJECT then begin
      HeroObject := THeroObject(Self);
      HeroObject.SendDelItems(@m_UseItems[U_WEAPON]);
      StdItem := UserEngine.GetStdItem(m_UseItems[U_WEAPON].wIndex);
            //004C195A
      {if StdItem.NeedIdentify = 1 then
            AddGameDataLog ('3' + #9 +
                        m_sMapName + #9 +
                        IntToStr(m_nCurrX) + #9 +
                        IntToStr(m_nCurrY) + #9 +
                        m_sCharName + #9 +
                        //UserEngine.GetStdItemName(m_UseItems[U_WEAPON].wIndex) + #9 +
                        StdItem.Name + #9 +
                        IntToStr(m_UseItems[U_WEAPON].MakeIndex) + #9 +
                        BoolToIntStr(m_btRaceServer = RC_PLAYOBJECT) + #9 +
                        '0');  }
    end;
    m_UseItems[U_WEAPON].wIndex := 0;
    SendMsg(Self, RM_HERODURACHANGE, U_WEAPON, nDura, m_UseItems[U_WEAPON].DuraMax, 0, '');
  end else begin //004C199D
    m_UseItems[U_WEAPON].Dura := nDura;
  end;
  if (nDura / 1.03) <> nDuraPoint then begin
    SendMsg(Self, RM_HERODURACHANGE, U_WEAPON, m_UseItems[U_WEAPON].Dura, m_UseItems[U_WEAPON].DuraMax, 0, '');
  end;
end;

procedure THeroObject.StruckDamage(nDamage: Integer);
var
  I: Integer;
  nDam: Integer;
  nDura, nOldDura: Integer;
  HeroObject: THeroObject;
  StdItem: pTStdItem;
  bo19: Boolean;
begin
  if nDamage <= 0 then Exit;
  nDam := Random(10) + 5;
  if m_wStatusTimeArr[POISON_DAMAGEARMOR {1 0x62}] > 0 then begin
    nDam := Round(nDam * (g_Config.nPosionDamagarmor / 10) {1.2});
    nDamage := Round(nDamage * (g_Config.nPosionDamagarmor / 10) {1.2});
  end;
  bo19 := False;
  if m_UseItems[U_DRESS].wIndex > 0 then begin
    nDura := m_UseItems[U_DRESS].Dura;
    nOldDura := Round(nDura / 1000);
    Dec(nDura, nDam);
    if nDura <= 0 then begin
      if m_btRaceServer = RC_HEROOBJECT then begin
        HeroObject := THeroObject(Self);
        HeroObject.SendDelItems(@m_UseItems[U_DRESS]);
        StdItem := UserEngine.GetStdItem(m_UseItems[U_DRESS].wIndex);
            //004BE088
        {if StdItem.NeedIdentify = 1 then
            AddGameDataLog ('3' + #9 +
                        m_sMapName + #9 +
                        IntToStr(m_nCurrX) + #9 +
                        IntToStr(m_nCurrY) + #9 +
                        m_sCharName + #9 +
                        //UserEngine.GetStdItemName(m_UseItems[U_DRESS].wIndex) + #9 +
                        StdItem.Name + #9 +
                        IntToStr(m_UseItems[U_DRESS].MakeIndex) + #9 +
                        BoolToIntStr(m_btRaceServer = RC_PLAYOBJECT) + #9 +
                        '0'); }
        m_UseItems[U_DRESS].wIndex := 0;
        FeatureChanged();
      end;
      m_UseItems[U_DRESS].wIndex := 0;
      m_UseItems[U_DRESS].Dura := 0;
      bo19 := True;
    end else begin
      m_UseItems[U_DRESS].Dura := nDura;
    end;
    if nOldDura <> Round(nDura / 1000) then begin
      SendMsg(Self, RM_HERODURACHANGE, U_DRESS, nDura, m_UseItems[U_DRESS].DuraMax, 0, '');
    end;
  end;
  for I := Low(THumanUseItems) to High(THumanUseItems) do begin
    if (m_UseItems[I].wIndex > 0) and (Random(8) = 0) then begin
      nDura := m_UseItems[I].Dura;
      nOldDura := Round(nDura / 1000);
      Dec(nDura, nDam);
      if nDura <= 0 then begin
        if m_btRaceServer = RC_HEROOBJECT then begin
          HeroObject := THeroObject(Self);
          HeroObject.SendDelItems(@m_UseItems[I]);
          StdItem := UserEngine.GetStdItem(m_UseItems[I].wIndex);
            //004BE2B8
          {if StdItem.NeedIdentify = 1 then
            AddGameDataLog ('3' + #9 +
                        m_sMapName + #9 +
                        IntToStr(m_nCurrX) + #9 +
                        IntToStr(m_nCurrY) + #9 +
                        m_sCharName + #9 +
                        //UserEngine.GetStdItemName(m_UseItems[i].wIndex) + #9 +
                        StdItem.Name + #9 +
                        IntToStr(m_UseItems[i].MakeIndex) + #9 +
                        BoolToIntStr(m_btRaceServer = RC_PLAYOBJECT) + #9 +
                        '0'); }
          m_UseItems[I].wIndex := 0;
          FeatureChanged();
        end;
        m_UseItems[I].wIndex := 0;
        m_UseItems[I].Dura := 0;
        bo19 := True;
      end else begin
        m_UseItems[I].Dura := nDura;
      end;
      if nOldDura <> Round(nDura / 1000) then begin
        SendMsg(Self, RM_HERODURACHANGE, I, nDura, m_UseItems[I].DuraMax, 0, '');
      end;
    end;
  end;
  if bo19 then RecalcAbilitys();
  DamageHealth(nDamage);
end;

function THeroObject.ClientDropItem(sItemName: string;
  nItemIdx: Integer): Boolean;
var
  I: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
  sUserItemName: string;
  sCheckItemName: string;
begin
  Result := False;
  {if not TPlayObject(m_Master).m_boClientFlag then begin
    if TPlayObject(m_Master).m_nStep = 8 then Inc(TPlayObject(m_Master).m_nStep)
    else TPlayObject(m_Master).m_nStep := 0;
  end; }
  if g_Config.boInSafeDisableDrop and InSafeZone then begin
    SendMsg(g_ManageNPC, RM_MENU_OK, 0, Integer(Self), 0, 0, g_sCanotDropInSafeZoneMsg);
    Exit;
  end;

  if not m_boCanDrop then begin
    SendMsg(g_ManageNPC, RM_MENU_OK, 0, Integer(Self), 0, 0, g_sCanotDropItemMsg);
    Exit;
  end;

  if Pos(' ', sItemName) > 0 then begin //۷Ʒ(żƷƺʹô)
    GetValidStr3(sItemName, sItemName, [' ']);
  end;

  for I := m_ItemList.Count - 1 downto 0 do begin
    if m_ItemList.Count <= 0 then Break;
    UserItem := m_ItemList.Items[I];
    if (UserItem <> nil) and (UserItem.MakeIndex = nItemIdx) then begin
      StdItem := UserEngine.GetStdItem(UserItem.wIndex);
      if StdItem = nil then Continue;
        //sItem:=UserEngine.GetStdItemName(UserItem.wIndex);
        //ȡԶƷ
      sUserItemName := '';
      if UserItem.btValue[13] = 1 then
        sUserItemName := ItemUnit.GetCustomItemName(UserItem.MakeIndex, UserItem.wIndex);
      if sUserItemName = '' then
        sUserItemName := UserEngine.GetStdItemName(UserItem.wIndex);

      if CompareText(sUserItemName, sItemName) = 0 then begin
        if Assigned(PlugInEngine.CheckCanDropItem) then begin
          sCheckItemName := StdItem.Name;
          if not PlugInEngine.CheckCanDropItem(Self, PChar(sCheckItemName), True) then Break;
        end;
        if g_Config.boControlDropItem and (StdItem.Price < g_Config.nCanDropPrice) then begin
          m_ItemList.Delete(I);
          Dispose(UserItem);
          Result := True;
          Break;
        end;
        if DropItemDown(UserItem, 1, False, nil, m_Master) then begin
          m_ItemList.Delete(I);
          Dispose(UserItem);
          Result := True;
          Break;
        end;
      end;
    end;
  end;
  if Result then WeightChanged();
end;

procedure THeroObject.RepairAllItem();
var
  nWhere: Integer;
  sCheckItemName: string;
  StdItem: pTStdItem;
begin
  for nWhere := Low(THumanUseItems) to High(THumanUseItems) do begin
    if m_UseItems[nWhere].wIndex > 0 then begin
      StdItem := UserEngine.GetStdItem(m_UseItems[nWhere].wIndex);
      if StdItem <> nil then begin
        if (m_UseItems[nWhere].DuraMax > m_UseItems[nWhere].Dura) and (StdItem.StdMode <> 43) then begin
          if Assigned(PlugInEngine.CheckCanRepairItem) then begin
            sCheckItemName := StdItem.Name;
            if not PlugInEngine.CheckCanRepairItem(m_Master, PChar(sCheckItemName), False) then Continue;
          end;
          m_UseItems[nWhere].Dura := m_UseItems[nWhere].DuraMax;
          SendMsg(Self, RM_HERODURACHANGE, nWhere, m_UseItems[nWhere].Dura, m_UseItems[nWhere].DuraMax, 0, '');
        end;
      end;
    end;
  end;
end;

procedure THeroObject.ClientHeroUseItems(nItemIdx: Integer; sItemName: string); //Ӣ۳ҩ
  function GetUnbindItemName(nShape: Integer): string;
  var
    I: Integer;
  begin
    Result := '';
    for I := 0 to g_UnbindList.Count - 1 do begin
      if Integer(g_UnbindList.Objects[I]) = nShape then begin
        Result := g_UnbindList.Strings[I];
        Break;
      end;
    end;
  end;
  function GetUnBindItems(sItemName: string; nCount: Integer): Boolean;
  var
    I: Integer;
    UserItem: pTUserItem;
  begin
    Result := False;
    for I := 0 to nCount - 1 do begin
      New(UserItem);
      if UserEngine.CopyToUserItemFromName(sItemName, UserItem) then begin
        m_ItemList.Add(UserItem);
        //if m_btRaceServer = RC_PLAYOBJECT then
        SendAddItem(UserItem);
        Result := True;
      end else begin
        Dispose(UserItem);
        Break;
      end;
    end;
  end;
  function FoundUserItem(Item: pTUserItem): Boolean;
  var
    I: Integer;
    UserItem: pTUserItem;
  begin
    Result := False;
    for I := 0 to m_ItemList.Count - 1 do begin
      UserItem := m_ItemList.Items[I];
      if UserItem = Item then begin
        Result := True;
        Break;
      end;
    end;
  end;
var
  I: Integer;
  boEatOK: Boolean;
  boSendUpDate: Boolean;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
  UserItem34: TUserItem;
  sMapName: string;
  nCurrX, nCurrY: Integer;
begin
  boEatOK := False;
  boSendUpDate := False;
  StdItem := nil;
  if m_boCanUseItem then begin
    if not m_boDeath then begin
      for I := m_ItemList.Count - 1 downto 0 do begin
        if m_ItemList.Count <= 0 then Break;
        UserItem := m_ItemList.Items[I];
        if (UserItem <> nil) and (UserItem.MakeIndex = nItemIdx) then begin
          UserItem34 := UserItem^;
          StdItem := UserEngine.GetStdItem(UserItem.wIndex);
          if StdItem <> nil then begin
            if not m_PEnvir.AllowStdItems(UserItem.wIndex) then begin
              SysMsg(Format(g_sCanotMapUseItemMsg, [StdItem.Name]), c_Red, t_Hint);
              Break;
            end;
            case StdItem.StdMode of
              0, 1, 3: begin //ҩ
                  if EatItems(StdItem) then begin
                    m_ItemList.Delete(I);
                    DisPoseAndNil(UserItem);
                    boEatOK := True;
                  end;
                  Break;
                end;
              2: begin //޸ˮ
                  case StdItem.Shape of
                    1: begin
                        if UserItem.Dura > 0 then begin
                          if UserItem.Dura >= 100 then begin
                            Dec(UserItem.Dura, 100);
                          end else begin
                            UserItem.Dura := 0;
                          end;
                          RepairAllItem();
                          boEatOK := True;
                        end;
                        if UserItem.Dura > 0 then begin
                          boSendUpDate := True;
                          boEatOK := False;
                        end;
                      end;
                  end;
                end;
              4: begin //
                  if ReadBook(StdItem) then begin
                    m_ItemList.Delete(I);
                    DisPoseAndNil(UserItem);
                    boEatOK := True;
                    if (m_MagicErgumSkill <> nil) and (not m_boUseThrusting) then begin
                      ThrustingOnOff(True);
                      //SendSocket(nil, '+LNG');
                    end;
                    if (m_MagicBanwolSkill <> nil) and (not m_boUseHalfMoon) then begin
                      HalfMoonOnOff(True);
                      //SendSocket(nil, '+WID');
                    end;
                  end;
                end;
              31: begin //Ʒ
                  if StdItem.AniCount = 0 then begin
                    if (m_ItemList.Count + 6 - 1) <= m_nItemBagCount then begin
                      m_ItemList.Delete(I);
                      DisPoseAndNil(UserItem);
                      GetUnBindItems(GetUnbindItemName(StdItem.Shape), 6);
                      boEatOK := True;
                    end;
                  end;
                end;
            end;
            Break;
          end;
        end;
      end;
    end;
  end else begin
    m_Master.SendMsg(g_ManageNPC, RM_MENU_OK, 0, Integer(m_Master), 0, 0, g_sCanotUseItemMsg);
  end;
  if boEatOK then begin
    WeightChanged();
    SendDefMessage(SM_HEROEAT_OK, 0, 0, 0, 0, '');
    if StdItem.NeedIdentify = 1 then
      AddGameDataLog('11' + #9 +
        m_sMapName + #9 +
        IntToStr(m_nCurrX) + #9 +
        IntToStr(m_nCurrY) + #9 +
        m_sCharName + #9 +
        //UserEngine.GetStdItemName(UserItem34.wIndex) + #9 +
        StdItem.Name + #9 +
        IntToStr(UserItem34.MakeIndex) + #9 +
        '1' + #9 +
        '0');
  end else begin
    SendDefMessage(SM_HEROEAT_FAIL, 0, 0, 0, 0, '');
  end;
  if (UserItem <> nil) and boSendUpDate then begin
    SendUpdateItem(UserItem);
  end;
end;

procedure THeroObject.WeightChanged;
begin
  if m_Master = nil then Exit;
  m_WAbil.Weight := RecalcBagWeight();
  if m_btRaceServer = RC_HEROOBJECT then begin
    SendUpdateMsg(m_Master, RM_HEROWEIGHTCHANGED, 0, 0, 0, 0, '');
  end;
end;

procedure THeroObject.RefMyStatus();
begin
  RecalcAbilitys();
  m_Master.SendMsg(m_Master, RM_MYSTATUS, 0, 1, 0, 0, '');
end;

function THeroObject.EatItems(StdItem: pTStdItem): Boolean;
var
  bo06: Boolean;
  nOldStatus: Integer;
begin
  Result := False;
  if m_PEnvir.m_boNODRUG then begin
    SysMsg(sCanotUseDrugOnThisMap, c_Red, t_Hint);
    Exit;
  end;
  case StdItem.StdMode of
    0: begin
        case StdItem.Shape of
          1: begin
              IncHealthSpell(StdItem.AC, StdItem.MAC);
              Result := True;
            end;
          2: begin
              m_boUserUnLockDurg := True;
              Result := True;
            end;
        else begin
            if (StdItem.AC > 0) then begin
              Inc(m_nIncHealth, StdItem.AC);
            end;
            if (StdItem.MAC > 0) then begin
              Inc(m_nIncSpell, StdItem.MAC);
            end;
            Result := True;
          end;
        end;
      end;
    1: Result := False;
    {1: begin
        nOldStatus := GetMyStatus();
        Inc(m_nHungerStatus, StdItem.DuraMax div 10);
        m_nHungerStatus := _MIN(5000, m_nHungerStatus);
        if nOldStatus <> GetMyStatus() then
          RefMyStatus();
        Result := True;
      end;}
    3: begin
        if StdItem.Shape = 12 then begin
          bo06 := False;
          if LoWord(StdItem.DC) > 0 then begin
            m_wStatusArrValue[0 {0x218}] := LoWord(StdItem.DC);
            m_dwStatusArrTimeOutTick[0 {0x220}] := GetTickCount + HiWord(StdItem.MAC) * 1000;
            SysMsg('' + IntToStr(HiWord(StdItem.MAC)) + '', c_Green, t_Hint);
            bo06 := True;
          end;
          if LoWord(StdItem.MC) > 0 then begin
            m_wStatusArrValue[1 {0x219}] := LoWord(StdItem.MC);
            m_dwStatusArrTimeOutTick[1 {0x224}] := GetTickCount + HiWord(StdItem.MAC) * 1000;
            SysMsg('ħ' + IntToStr(HiWord(StdItem.MAC)) + '', c_Green, t_Hint);
            bo06 := True;
          end;
          if LoByte(StdItem.SC) > 0 then begin
            m_wStatusArrValue[2 {0x21A}] := LoWord(StdItem.SC);
            m_dwStatusArrTimeOutTick[2 {0x228}] := GetTickCount + HiWord(StdItem.MAC) * 1000;
            SysMsg('' + IntToStr(HiWord(StdItem.MAC)) + '', c_Green, t_Hint);
            bo06 := True;
          end;
          if HiWord(StdItem.AC) > 0 then begin
            m_wStatusArrValue[3 {0x21B}] := HiWord(StdItem.AC);
            m_dwStatusArrTimeOutTick[3 {0x22C}] := GetTickCount + HiWord(StdItem.MAC) * 1000;
            SysMsg('ٶ' + IntToStr(HiWord(StdItem.MAC)) + '', c_Green, t_Hint);
            bo06 := True;
          end;
          if LoWord(StdItem.AC) > 0 then begin
            m_wStatusArrValue[4 {0x21C}] := LoWord(StdItem.AC);
            m_dwStatusArrTimeOutTick[4 {0x230}] := GetTickCount + HiWord(StdItem.MAC) * 1000;
            SysMsg('ֵ' + IntToStr(HiWord(StdItem.MAC)) + '', c_Green, t_Hint);
            bo06 := True;
          end;
          if LoWord(StdItem.MAC) > 0 then begin
            m_wStatusArrValue[5 {0x21D}] := LoWord(StdItem.MAC);
            m_dwStatusArrTimeOutTick[5 {0x234}] := GetTickCount + HiWord(StdItem.MAC) * 1000;
            SysMsg('ħֵ' + IntToStr(HiWord(StdItem.MAC)) + '', c_Green, t_Hint);
            bo06 := True;
          end;
          if bo06 then begin
            RecalcAbilitys();
            SendMsg(m_Master, RM_HEROABILITY, 0, 0, 0, 0, '');
            SendMsg(m_Master, RM_HEROSUBABILITY, 0, 0, 0, 0, '');
            Result := True;
          end;
        end else begin
          Result := EatUseItems(StdItem.Shape);
        end;
      end;
  end;
end;

function THeroObject.ReadBook(StdItem: pTStdItem): Boolean;
var
  Magic: pTMagic;
  UserMagic: pTUserMagic;
  HeroObject: THeroObject;
begin
  Result := False;
  Magic := UserEngine.FindHeroMagic(StdItem.Name);
  if Magic <> nil then begin
    if not IsTrainingSkill(Magic.wMagicId) then begin
      if (Magic.sDescr = 'Ӣ') and ((Magic.btJob = 99) or (Magic.btJob = m_btJob)) then begin
        if (Magic.wMagicId in [60, 65]) and (Magic.wMagicId <> GetTogetherUseSpell) then Exit;
        if m_Abil.Level >= Magic.TrainLevel[0] then begin
          New(UserMagic);
          UserMagic.MagicInfo := Magic;
          UserMagic.wMagIdx := Magic.wMagicId;
          UserMagic.btKey := 0;
          UserMagic.btLevel := 0;
          UserMagic.nTranPoint := 0;
          m_MagicList.Add(UserMagic);
          RecalcAbilitys();
          SendAddMagic(UserMagic);
          Result := True;
        end;
      end;
    end;
  end;
end;

procedure THeroObject.SendAddMagic(UserMagic: pTUserMagic);
var
  ClientMagic: TClientMagic;
begin
  ClientMagic.Key := Char(UserMagic.btKey);
  ClientMagic.Level := UserMagic.btLevel;
  ClientMagic.CurTrain := UserMagic.nTranPoint;
  ClientMagic.Def := UserMagic.MagicInfo^;
  m_DefMsg := MakeDefaultMsg(SM_HEROADDMAGIC, 0, 0, 0, 1);
  SendSocket(@m_DefMsg, EncodeBuffer(@ClientMagic, SizeOf(TClientMagic)));
end;

procedure THeroObject.SendDelMagic(UserMagic: pTUserMagic);
begin
  m_DefMsg := MakeDefaultMsg(SM_HERODELMAGIC, UserMagic.wMagIdx, 0, 0, 1);
  SendSocket(@m_DefMsg, '');
end;

function THeroObject.IsEnoughBag(): Boolean;
begin
  Result := False;
  if m_ItemList.Count < m_nItemBagCount then
    Result := True;
end;

procedure THeroObject.MakeWeaponUnlock;
begin
  if m_UseItems[U_WEAPON].wIndex <= 0 then Exit;
  if m_UseItems[U_WEAPON].btValue[3] > 0 then begin
    Dec(m_UseItems[U_WEAPON].btValue[3]);
    SysMsg(g_sTheWeaponIsCursed, c_Red, t_Hint);
  end else begin
    if m_UseItems[U_WEAPON].btValue[4] < 10 then begin
      Inc(m_UseItems[U_WEAPON].btValue[4]);
      SysMsg(g_sTheWeaponIsCursed, c_Red, t_Hint);
    end;
  end;
  if m_btRaceServer = RC_HEROOBJECT then begin
    RecalcAbilitys();
    SendMsg(m_Master, RM_HEROABILITY, 0, 0, 0, 0, '');
    SendMsg(m_Master, RM_HEROSUBABILITY, 0, 0, 0, 0, '');
  end;
end;

//ʹף
function THeroObject.WeaptonMakeLuck: Boolean;
var
  StdItem: pTStdItem;
  nRand: Integer;
  boMakeLuck: Boolean;
begin
  Result := False;
  if m_UseItems[U_WEAPON].wIndex <= 0 then Exit;
  nRand := 0;
  StdItem := UserEngine.GetStdItem(m_UseItems[U_WEAPON].wIndex);
  if StdItem <> nil then begin
    nRand := abs((HiWord(StdItem.DC) - LoWord(StdItem.DC))) div 5;
  end;
  if Random(g_Config.nWeaponMakeUnLuckRate {20}) = 1 then begin
    MakeWeaponUnlock();
  end else begin
    boMakeLuck := False;
    if m_UseItems[U_WEAPON].btValue[4] > 0 then begin
      Dec(m_UseItems[U_WEAPON].btValue[4]);
      SysMsg(g_sWeaptonMakeLuck {'...'}, c_Green, t_Hint);
      boMakeLuck := True;
    end else if m_UseItems[U_WEAPON].btValue[3] < g_Config.nWeaponMakeLuckPoint1 {1} then begin
      Inc(m_UseItems[U_WEAPON].btValue[3]);
      SysMsg(g_sWeaptonMakeLuck {'...'}, c_Green, t_Hint);
      boMakeLuck := True;
    end else if (m_UseItems[U_WEAPON].btValue[3] < g_Config.nWeaponMakeLuckPoint2 {3}) and (Random(nRand + g_Config.nWeaponMakeLuckPoint2Rate {6}) = 1) then begin
      Inc(m_UseItems[U_WEAPON].btValue[3]);
      SysMsg(g_sWeaptonMakeLuck {'...'}, c_Green, t_Hint);
      boMakeLuck := True;
    end else if (m_UseItems[U_WEAPON].btValue[3] < g_Config.nWeaponMakeLuckPoint3 {7}) and (Random(nRand * g_Config.nWeaponMakeLuckPoint3Rate {10 + 30}) = 1) then begin
      Inc(m_UseItems[U_WEAPON].btValue[3]);
      SysMsg(g_sWeaptonMakeLuck {'...'}, c_Green, t_Hint);
      boMakeLuck := True;
    end;
    if m_btRaceServer = RC_HEROOBJECT then begin
      RecalcAbilitys();
      SendMsg(m_Master, RM_HEROABILITY, 0, 0, 0, 0, '');
      SendMsg(m_Master, RM_HEROSUBABILITY, 0, 0, 0, 0, '');
    end;
    if not boMakeLuck then SysMsg(g_sWeaptonNotMakeLuck {'Ч'}, c_Green, t_Hint);
  end;
  Result := True;
end;

function THeroObject.RepairWeapon: Boolean;
var
  nDura: Integer;
  UserItem: pTUserItem;
begin
  Result := False;
  UserItem := @m_UseItems[U_WEAPON];
  if (UserItem.wIndex <= 0) or (UserItem.DuraMax <= UserItem.Dura) then Exit;
  Dec(UserItem.DuraMax, (UserItem.DuraMax - UserItem.Dura) div g_Config.nRepairItemDecDura {30});
  nDura := _MIN(5000, UserItem.DuraMax - UserItem.Dura);
  if nDura > 0 then begin
    Inc(UserItem.Dura, nDura);
    if m_btRaceServer = RC_HEROOBJECT then begin
      SendMsg(m_Master, RM_HERODURACHANGE, 1, UserItem.Dura, UserItem.DuraMax, 0, '');
      SysMsg(g_sWeaponRepairSuccess {'޸ɹ...'}, c_Green, t_Hint);
    end;
    Result := True;
  end;
end;

function THeroObject.SuperRepairWeapon: Boolean;
begin
  Result := False;
  if m_UseItems[U_WEAPON].wIndex <= 0 then Exit;
  m_UseItems[U_WEAPON].Dura := m_UseItems[U_WEAPON].DuraMax;
  if m_btRaceServer = RC_HEROOBJECT then begin
    SendMsg(m_Master, RM_HERODURACHANGE, 1, m_UseItems[U_WEAPON].Dura, m_UseItems[U_WEAPON].DuraMax, 0, '');
    SysMsg(g_sWeaponRepairSuccess {'޸ɹ...'}, c_Green, t_Hint);
  end;
  Result := True;
end;

function THeroObject.AbilityUp(UserMagic: pTUserMagic): Boolean;
var
  nSpellPoint, n14: Integer;
begin
  Result := False;
  nSpellPoint := GetSpellPoint(UserMagic);
  if nSpellPoint > 0 then begin
    if m_WAbil.MP < nSpellPoint then Exit;
    n14 := (Random(10 + UserMagic.btLevel) + UserMagic.btLevel) * UserMagic.btLevel;
    m_dwStatusArrTimeOutTick[2 {0x228}] := GetTickCount + n14 * 1000;
    m_wStatusArrValue[2 {0x218}] := MakeLong(LoWord(m_WAbil.SC), HiWord(m_WAbil.SC) - 2 - (m_Abil.Level div 7)) * 2;
    SysMsg('' + IntToStr(m_wStatusArrValue[2 {0x218}]) + ' ' + IntToStr(n14) + '', c_Green, t_Hint);
    RecalcAbilitys();
    SendMsg(m_Master, RM_HEROABILITY, 0, 0, 0, 0, '');
    SendMsg(m_Master, RM_HEROSUBABILITY, 0, 0, 0, 0, '');
    Result := True;
  end;
end;

procedure THeroObject.GainExp(dwExp: LongWord);
begin
  WinExp(dwExp);
end;

procedure THeroObject.WinExp(dwExp: LongWord);
begin
  if m_Abil.Level > g_Config.nLimitExpLevel then begin
    dwExp := g_Config.nLimitExpValue;
    GetExp(dwExp);
  end else
    if dwExp > 0 then begin
    dwExp := g_Config.dwKillMonExpMultiple * dwExp; //ϵͳָɱ־鱶
    dwExp := LongWord(m_nKillMonExpMultiple) * dwExp; //ָɱ־鱶
    dwExp := Round((m_nKillMonExpRate / 100) * dwExp); //ָɱ־鱶
    if m_PEnvir.m_boEXPRATE then
      dwExp := Round((m_PEnvir.m_nEXPRATE / 100) * dwExp); //ͼָɱ־鱶
    if m_boExpItem then begin //Ʒ鱶
      dwExp := Round(m_rExpItem * dwExp);
    end;
    GetExp(dwExp);
  end;
end;

procedure THeroObject.GetExp(dwExp: LongWord);
begin
  Inc(m_Abil.Exp, dwExp);
  //AddBodyLuck(dwExp * 0.002);
  if not TPlayObject(m_Master).m_boNotOnlineAddExp then //ֻ͸߹һ
    SendMsg(m_Master, RM_HEROWINEXP, 0, dwExp, 0, 0, '');
  if m_Abil.Exp >= m_Abil.MaxExp then begin
    Dec(m_Abil.Exp, m_Abil.MaxExp);
    if m_Abil.Level < MAXUPLEVEL then begin
      Inc(m_Abil.Level);
    end;
    HasLevelUp(m_Abil.Level - 1);
    {AddBodyLuck(100);
    AddGameDataLog('12' + #9 +
      m_sMapName + #9 +
      IntToStr(m_Abil.Level) + #9 +
      IntToStr(m_Abil.Exp) + #9 +
      m_sCharName + #9 +
      '0' + #9 +
      '0' + #9 +
      '1' + #9 +
      '0'); }
    IncHealthSpell(2000, 2000);
  end;
end;

function THeroObject.RunToTargetXY(nTargetX, nTargetY: Integer): Boolean;
var
  nDir: Integer;
  n10: Integer;
  n14: Integer;
begin
  Result := False;
  n10 := nTargetX;
  n14 := nTargetY;
  dwTick3F4 := GetTickCount();
  nDir := DR_DOWN;
  if n10 > m_nCurrX then begin
    nDir := DR_RIGHT;
    if n14 > m_nCurrY then nDir := DR_DOWNRIGHT;
    if n14 < m_nCurrY then nDir := DR_UPRIGHT;
  end else begin
    if n10 < m_nCurrX then begin
      nDir := DR_LEFT;
      if n14 > m_nCurrY then nDir := DR_DOWNLEFT;
      if n14 < m_nCurrY then nDir := DR_UPLEFT;
    end else begin
      if n14 > m_nCurrY then nDir := DR_DOWN
      else if n14 < m_nCurrY then nDir := DR_UP;
    end;
  end;
  if not RunTo(nDir, False, nTargetX, nTargetY) then begin
    Result := WalkToTargetXY(nTargetX, nTargetY);
  end else begin
    if (abs(nTargetX - m_nCurrX) <= 1) and (abs(nTargetY - m_nCurrY) <= 1) then begin
      Result := True;
    end;
  end;
end;

function THeroObject.WalkToTargetXY(nTargetX, nTargetY: Integer): Boolean;
var
  I: Integer;
  nDir: Integer;
  n10: Integer;
  n14: Integer;
  n20: Integer;
  nOldX: Integer;
  nOldY: Integer;
  n16: Integer;
begin
  Result := False;
  if (abs(nTargetX - m_nCurrX) > 1) or (abs(nTargetY - m_nCurrY) > 1) then begin
    n10 := nTargetX;
    n14 := nTargetY;
    dwTick3F4 := GetTickCount();
    nDir := DR_DOWN;
    if n10 > m_nCurrX then begin
      nDir := DR_RIGHT;
      if n14 > m_nCurrY then nDir := DR_DOWNRIGHT;
      if n14 < m_nCurrY then nDir := DR_UPRIGHT;
    end else begin
      if n10 < m_nCurrX then begin
        nDir := DR_LEFT;
        if n14 > m_nCurrY then nDir := DR_DOWNLEFT;
        if n14 < m_nCurrY then nDir := DR_UPLEFT;
      end else begin
        if n14 > m_nCurrY then nDir := DR_DOWN
        else if n14 < m_nCurrY then nDir := DR_UP;
      end;
    end;
    nOldX := m_nCurrX;
    nOldY := m_nCurrY;
    WalkTo(nDir, False);
    if (abs(nTargetX - m_nCurrX) <= 1) and (abs(nTargetY - m_nCurrY) <= 1) then Result := True;
    if not Result then begin
      n20 := Random(3);
      for I := DR_UP to DR_UPLEFT do begin
        if (nOldX = m_nCurrX) and (nOldY = m_nCurrY) then begin
          if n20 <> 0 then Inc(nDir)
          else if nDir > 0 then Dec(nDir)
          else nDir := DR_UPLEFT;
          if (nDir > DR_UPLEFT) then nDir := DR_UP;
          WalkTo(nDir, False);
          if (abs(nTargetX - m_nCurrX) <= 1) and (abs(nTargetY - m_nCurrY) <= 1) then begin
            Result := True;
            Break;
          end;
        end;
      end;
    end;
  end;
end;

function THeroObject.WalkToTargetXY2(nTargetX, nTargetY: Integer): Boolean;
var
  I: Integer;
  nDir: Integer;
  n10: Integer;
  n14: Integer;
  n20: Integer;
  nOldX: Integer;
  nOldY: Integer;
  n16: Integer;
begin
  Result := False;
  if (nTargetX <> m_nCurrX) or (nTargetY <> m_nCurrY) then begin
    n10 := nTargetX;
    n14 := nTargetY;
    dwTick3F4 := GetTickCount();
    nDir := DR_DOWN;
    if n10 > m_nCurrX then begin
      nDir := DR_RIGHT;
      if n14 > m_nCurrY then nDir := DR_DOWNRIGHT;
      if n14 < m_nCurrY then nDir := DR_UPRIGHT;
    end else begin
      if n10 < m_nCurrX then begin
        nDir := DR_LEFT;
        if n14 > m_nCurrY then nDir := DR_DOWNLEFT;
        if n14 < m_nCurrY then nDir := DR_UPLEFT;
      end else begin
        if n14 > m_nCurrY then nDir := DR_DOWN
        else if n14 < m_nCurrY then nDir := DR_UP;
      end;
    end;
    nOldX := m_nCurrX;
    nOldY := m_nCurrY;
    WalkTo(nDir, False);
    if (nTargetX = m_nCurrX) and (nTargetY = m_nCurrY) then Result := True;
    if not Result then begin
      n20 := Random(3);
      for I := DR_UP to DR_UPLEFT do begin
        if (nOldX = m_nCurrX) and (nOldY = m_nCurrY) then begin
          if n20 <> 0 then Inc(nDir)
          else if nDir > 0 then Dec(nDir)
          else nDir := DR_UPLEFT;
          if (nDir > DR_UPLEFT) then nDir := DR_UP;
          WalkTo(nDir, False);
          if (nTargetX = m_nCurrX) and (nTargetY = m_nCurrY) then begin
            Result := True;
            Break;
          end;
        end;
      end;
    end;
  end;
end;

function THeroObject.GotoTargetXY(nTargetX, nTargetY: Integer): Boolean;
begin
  if (abs(m_nCurrX - nTargetX) >= 3) or (abs(m_nCurrY - nTargetY) >= 3) then begin
    Result := RunToTargetXY(nTargetX, nTargetY);
  end else begin
    Result := WalkToTargetXY2(nTargetX, nTargetY);
  end;
end;

function THeroObject.Operate(ProcessMsg: pTProcessMessage): Boolean;
begin
  //  Result:=False;
  case ProcessMsg.wIdent of
    RM_STRUCK: begin
        if (ProcessMsg.BaseObject = Self) and (TBaseObject(ProcessMsg.nParam3 {AttackBaseObject}) <> nil) then begin
          SetLastHiter(TBaseObject(ProcessMsg.nParam3 {AttackBaseObject}));
          Struck(TBaseObject(ProcessMsg.nParam3 {AttackBaseObject})); {0FFEC}
          BreakHolySeizeMode();
          if (m_Master <> nil) and
            (TBaseObject(ProcessMsg.nParam3) <> m_Master) and
            (TBaseObject(ProcessMsg.nParam3).m_btRaceServer = RC_PLAYOBJECT) then begin
            m_Master.SetPKFlag(TBaseObject(ProcessMsg.nParam3));
          end;
          if g_Config.boMonSayMsg then MonsterSayMsg(TBaseObject(ProcessMsg.nParam3), s_UnderFire);
        end;
        Result := True;
      end;
  else begin
      Result := inherited Operate(ProcessMsg);
    end;
  end;
end;

function THeroObject.CompareHP(BaseObject1, BaseObject2: TBaseObject): Boolean;
var
  HP1, HP2: Integer;
begin
  HP1 := BaseObject1.m_WAbil.HP * 100 div BaseObject1.m_WAbil.MaxHP;
  HP2 := BaseObject2.m_WAbil.HP * 100 div BaseObject2.m_WAbil.MaxHP;
  Result := HP1 > HP2;
end;
function THeroObject.CompareLevel(BaseObject1, BaseObject2: TBaseObject): Boolean;
begin
  Result := BaseObject1.m_WAbil.Level < BaseObject2.m_WAbil.Level;
end;
function THeroObject.CompareXY(BaseObject1, BaseObject2: TBaseObject): Boolean;
var
  nXY1, nXY2: Integer;
begin
  nXY1 := abs(BaseObject1.m_nCurrX - m_nCurrX) + abs(BaseObject1.m_nCurrY - m_nCurrY);
  nXY2 := abs(BaseObject2.m_nCurrX - m_nCurrX) + abs(BaseObject2.m_nCurrY - m_nCurrY);
  Result := nXY1 > nXY2;
end;

procedure THeroObject.Struck(hiter: TBaseObject);
var
  btDir: Byte;
begin
  if not m_boTarget then begin
    m_dwStruckTick := GetTickCount;
    if hiter <> nil then begin
      if (m_TargetCret = nil) or GetAttackDir(m_TargetCret, btDir) or (Random(6) = 0) then begin
        if IsProperTarget(hiter) then
          SetTargetCreat(hiter);
      end;
    end;
    if m_boAnimal then begin
      m_nMeatQuality := m_nMeatQuality - Random(300);
      if m_nMeatQuality < 0 then m_nMeatQuality := 0;
    end;
  end;
  m_dwHitTick := m_dwHitTick + LongWord(150 - _MIN(130, m_Abil.Level * 4));
end;

procedure THeroObject.Attack(TargeTBaseObject: TBaseObject; nDir: Integer);
begin
  inherited AttackDir(TargeTBaseObject, m_wHitMode, nDir);
end;

procedure THeroObject.DelTargetCreat;
begin
  inherited;
  m_nTargetX := -1;
  m_nTargetY := -1;
end;

procedure THeroObject.SearchTarget;
var
  BaseObject, BaseObject18: TBaseObject;
  I, nC, n10: Integer;
begin
  if (m_TargetCret = nil) and m_boTarget then m_boTarget := False;
  if (m_TargetCret <> nil) and m_TargetCret.m_boDeath and m_boTarget then m_boTarget := False;
  if (m_btStatus = 1) and not m_boProtectStatus and not m_boTarget then begin
    BaseObject18 := nil;
    n10 := 9999;
    for I := 0 to m_VisibleActors.Count - 1 do begin
      BaseObject := TBaseObject(pTVisibleBaseObject(m_VisibleActors.Items[I]).BaseObject);
      if BaseObject <> nil then begin
        if not BaseObject.m_boDeath then begin
          if IsProperTarget(BaseObject) and
            (not BaseObject.m_boHideMode or m_boCoolEye) then begin
            nC := abs(m_nCurrX - BaseObject.m_nCurrX) + abs(m_nCurrY - BaseObject.m_nCurrY);
            if nC < n10 then begin
              n10 := nC;
              BaseObject18 := BaseObject;
            end;
          end;
        end;
      end;
    end;
    if BaseObject18 <> nil then begin
      SetTargetCreat(BaseObject18);
      {if (m_TargetCret <> nil) and (m_TargetCret.m_boDeath) then m_TargetCret := nil;
      if m_TargetCret <> nil then begin
        if CompareHP(m_TargetCret, BaseObject18) and CompareLevel(m_TargetCret, BaseObject18) and CompareXY(m_TargetCret, BaseObject18) then begin
          SetTargetCreat(BaseObject18);
        end;
      end else SetTargetCreat(BaseObject18); }
    end;
  end;
end;

procedure THeroObject.SetTargetXY(nX, nY: Integer);
begin
  m_nTargetX := nX;
  m_nTargetY := nY;
end;

procedure THeroObject.Wondering;
begin
  if (Random(10) = 0) then
    if (Random(4) = 1) then TurnTo(Random(8))
    else WalkTo(m_btDirection, False);
end;

function THeroObject.IsAllowUseMagic(wMagIdx: Word): Boolean;
var
  UserMagic: pTUserMagic;
begin
  Result := False;
  UserMagic := CheckUserMagic(wMagIdx);
  if UserMagic <> nil then begin
    if GetSpellPoint(UserMagic) < m_WAbil.MP then Result := True;
  end;
end;

function THeroObject.SelectMagic(): Integer;
var
  wHitMode: Word;
  UserMagic: pTUserMagic;
begin
  Result := 0;
  case m_btJob of
    0: begin //սʿ
        if IsAllowUseMagic(26) and (not m_boFireHitSkill) and ((GetTickCount - m_dwLatestFireHitTick) > 10 * 1000) then begin {һ}
          AllowFireHitSkill;
          Result := 26;
          Exit;
        end;
        if CheckTargetXYCount(m_nCurrX, m_nCurrY, 2) >= 4 then begin //Χ
          if IsAllowUseMagic(41) and (GetTickCount - m_SkillUseTick[41] > 1000 * 10) then begin
            m_SkillUseTick[41] := GetTickCount; //ʨӺ
            Result := 41;
            Exit;
          end else
            if IsAllowUseMagic(39) and (GetTickCount - m_SkillUseTick[39] > 1000 * 10) then begin
            m_SkillUseTick[39] := GetTickCount; //Ӣ۳ض
            Result := 39;
            Exit;
          end else
            if IsAllowUseMagic(40) then begin //Ӣ۱µ
            if not m_boCrsHitkill then begin
              SkillCrsOnOff(True);
            end;
            Result := 40;
            Exit;
          end else begin
            if (m_wLastHP - m_WAbil.HP) > (m_WAbil.MaxHP div 5) then begin
              if IsAllowUseMagic(12) then begin //Ӣ۴ɱ
                if not m_boUseThrusting then begin
                  ThrustingOnOff(True);
                end;
                Result := 12;
              end else
                if IsAllowUseMagic(25) then begin
                if not m_boUseHalfMoon then begin
                  HalfMoonOnOff(True);
                end;
                Result := 25;
              end else
                if IsAllowUseMagic(40) then begin //Ӣ۱µ
                if not m_boCrsHitkill then begin
                  SkillCrsOnOff(True);
                end;
                Result := 40;
              end else
                if IsAllowUseMagic(39) and (GetTickCount - m_SkillUseTick[39] > 1000 * 10) then begin
                m_SkillUseTick[39] := GetTickCount; //Ӣ۳ض
                Result := 39;
                Exit;
              end;
              m_wLastHP := m_WAbil.HP;
              Exit;
            end;
            m_wLastHP := m_WAbil.HP;
            case Random(2) of
              0: begin
                  if IsAllowUseMagic(25) then begin //Ӣ۰䵶
                    if not m_boUseHalfMoon then begin
                      HalfMoonOnOff(True);
                    end;
                    Result := 25;
                  end else
                    if IsAllowUseMagic(12) then begin //Ӣ۴ɱ
                    if not m_boUseThrusting then begin
                      ThrustingOnOff(True);
                    end;
                    Result := 12;
                  end else
                    if IsAllowUseMagic(40) then begin //Ӣ۱µ
                    if not m_boCrsHitkill then begin
                      SkillCrsOnOff(True);
                    end;
                    Result := 40;
                  end else
                    if IsAllowUseMagic(39) and (GetTickCount - m_SkillUseTick[39] > 1000 * 10) then begin
                    m_SkillUseTick[39] := GetTickCount; //Ӣ۳ض
                    Result := 39;
                    Exit;
                  end;
                end;
              1: begin
                  if IsAllowUseMagic(12) then begin //Ӣ۴ɱ
                    if not m_boUseThrusting then begin
                      ThrustingOnOff(True);
                    end;
                    Result := 12;
                  end else
                    if IsAllowUseMagic(25) then begin
                    if not m_boUseHalfMoon then begin
                      HalfMoonOnOff(True);
                    end;
                    Result := 25;
                  end else
                    if IsAllowUseMagic(40) then begin //Ӣ۱µ
                    if not m_boCrsHitkill then begin
                      SkillCrsOnOff(True);
                    end;
                    Result := 40;
                  end else
                    if IsAllowUseMagic(39) and (GetTickCount - m_SkillUseTick[39] > 1000 * 10) then begin
                    m_SkillUseTick[39] := GetTickCount; //Ӣ۳ض
                    Result := 39;
                    Exit;
                  end;
                end;
              2: begin
                  if IsAllowUseMagic(40) then begin //Ӣ۱µ
                    if not m_boCrsHitkill then begin
                      SkillCrsOnOff(True);
                    end;
                    Result := 40;
                  end else
                    if IsAllowUseMagic(12) then begin //Ӣ۰䵶
                    if not m_boUseThrusting then begin
                      ThrustingOnOff(True);
                    end;
                    Result := 12;
                  end else
                    if IsAllowUseMagic(25) then begin
                    if not m_boUseHalfMoon then begin
                      HalfMoonOnOff(True);
                    end;
                    Result := 25;
                  end else
                    if IsAllowUseMagic(39) and (GetTickCount - m_SkillUseTick[39] > 1000 * 10) then begin
                    m_SkillUseTick[39] := GetTickCount; //Ӣ۳ض
                    Result := 39;
                    Exit;
                  end;
                end;
            end;
          end;
        end else begin
          {if IsAllowUseMagic(41) and (GetTickCount - m_SkillUseTick[41] > 1000 * 10) then begin
            m_SkillUseTick[41] := GetTickCount;           //ʨӺ
            Result := 41;
            Exit;
          end else begin}
          if (m_wLastHP - m_WAbil.HP) > (m_WAbil.MaxHP div 5) then begin
            if IsAllowUseMagic(12) then begin //Ӣ۴ɱ
              if not m_boUseThrusting then begin
                ThrustingOnOff(True);
              end;
              Result := 12;
            end else
              if IsAllowUseMagic(25) then begin
              if not m_boUseHalfMoon then begin
                HalfMoonOnOff(True);
              end;
              Result := 25;
            end else
              if IsAllowUseMagic(40) then begin //Ӣ۱µ
              if not m_boCrsHitkill then begin
                SkillCrsOnOff(True);
              end;
              Result := 40;
            end else
              if IsAllowUseMagic(39) and (GetTickCount - m_SkillUseTick[39] > 1000 * 10) then begin
              m_SkillUseTick[39] := GetTickCount; //Ӣ۳ض
              Result := 39;
              Exit;
            end;
            m_wLastHP := m_WAbil.HP;
            Exit;
          end;
          m_wLastHP := m_WAbil.HP;
          case Random(2) of
            0: begin
                if IsAllowUseMagic(25) then begin //Ӣ۰䵶
                  if not m_boUseHalfMoon then begin
                    HalfMoonOnOff(True);
                  end;
                  Result := 25;
                end else
                  if IsAllowUseMagic(12) then begin //Ӣ۴ɱ
                  if not m_boUseThrusting then begin
                    ThrustingOnOff(True);
                  end;
                  Result := 12;
                end else
                  if IsAllowUseMagic(40) then begin //Ӣ۱µ
                  if not m_boCrsHitkill then begin
                    SkillCrsOnOff(True);
                  end;
                  Result := 40;
                end else
                  if IsAllowUseMagic(39) and (GetTickCount - m_SkillUseTick[39] > 1000 * 10) then begin
                  m_SkillUseTick[39] := GetTickCount; //Ӣ۳ض
                  Result := 39;
                  Exit;
                end;
              end;
            1: begin
                if IsAllowUseMagic(12) then begin //Ӣ۴ɱ
                  if not m_boUseThrusting then begin
                    ThrustingOnOff(True);
                  end;
                  Result := 12;
                end else
                  if IsAllowUseMagic(25) then begin //Ӣ۰䵶
                  if not m_boUseHalfMoon then begin
                    HalfMoonOnOff(True);
                  end;
                  Result := 25;
                end else
                  if IsAllowUseMagic(40) then begin //Ӣ۱µ
                  if not m_boCrsHitkill then begin
                    SkillCrsOnOff(True);
                  end;
                  Result := 40;
                end else
                  if IsAllowUseMagic(39) and (GetTickCount - m_SkillUseTick[39] > 1000 * 10) then begin
                  m_SkillUseTick[39] := GetTickCount; //Ӣ۳ض
                  Result := 39;
                  Exit;
                end;
              end;
            2: begin
                if IsAllowUseMagic(40) then begin //Ӣ۱µ
                  if not m_boCrsHitkill then begin
                    SkillCrsOnOff(True);
                  end;
                  Result := 40;
                end else
                  if IsAllowUseMagic(12) then begin //Ӣ۴ɱ
                  if not m_boUseThrusting then begin
                    ThrustingOnOff(True);
                  end;
                  Result := 12;
                end else
                  if IsAllowUseMagic(25) then begin //Ӣ۰䵶
                  if not m_boUseHalfMoon then begin
                    HalfMoonOnOff(True);
                  end;
                  Result := 25;
                end else
                  if IsAllowUseMagic(39) and (GetTickCount - m_SkillUseTick[39] > 1000 * 10) then begin
                  m_SkillUseTick[39] := GetTickCount; //Ӣ۳ض
                  Result := 39;
                  Exit;
                end;
              end;
          end;
          //end;
        end;
      end;
    1: begin //ʦ
        if (IsAllowUseMagic(31)) and (m_wStatusTimeArr[STATE_BUBBLEDEFENCEUP {0x76}] = 0) then begin {ʹ ħ}
          Result := 31;
          Exit;
        end;
        if CheckTargetXYCount(m_nCurrX, m_nCurrY, 2) >= 2 then begin //Χ    SendDelItems
          case Random(4) of //ѡħ
            0: begin
                if IsAllowUseMagic(24) then begin
                  Result := 24; //׹
                end else
                  if IsAllowUseMagic(23) then begin
                  Result := 23; //ѻ
                end else
                  if IsAllowUseMagic(22) and (GetTickCount - m_SkillUseTick[22] > 1000 * 10) and (g_EventManager.GetRangeEvent(m_PEnvir, Self, m_nCurrX, m_nCurrY, 6, ET_FIRE) = 0) then begin
                  m_SkillUseTick[22] := GetTickCount;
                  Result := 22; //ǽ
                end else
                  if IsAllowUseMagic(33) then begin
                  Result := 33;
                end else
                  if IsAllowUseMagic(37) then begin
                  Result := 37;
                end else
                  if IsAllowUseMagic(45) then begin
                  Result := 45;
                end else
                  if IsAllowUseMagic(47) then begin
                  Result := 47;
                end else
                  if IsAllowUseMagic(11) then begin
                  Result := 11;
                end else
                  if IsAllowUseMagic(5) then begin
                  Result := 5;
                end else
                  if IsAllowUseMagic(1) then begin
                  Result := 1;
                end;
              end;
            1: begin
                if IsAllowUseMagic(24) then begin
                  Result := 24; //׹
                end else
                  if IsAllowUseMagic(33) then begin
                  Result := 33;
                end else
                  if IsAllowUseMagic(22) and (GetTickCount - m_SkillUseTick[22] > 1000 * 10) and (g_EventManager.GetRangeEvent(m_PEnvir, Self, m_nCurrX, m_nCurrY, 6, ET_FIRE) = 0) then begin
                  m_SkillUseTick[22] := GetTickCount;
                  Result := 22;
                end else
                  if IsAllowUseMagic(23) then begin
                  Result := 23;
                end else
                  if IsAllowUseMagic(37) then begin
                  Result := 37;
                end else
                  if IsAllowUseMagic(45) then begin
                  Result := 45;
                end else
                  if IsAllowUseMagic(47) then begin
                  Result := 47;
                end else
                  if IsAllowUseMagic(8) and (GetTickCount - m_SkillUseTick[8] > 1000 * 10) and (m_TargetCret <> nil) and (m_TargetCret.m_Abil.Level <= m_Abil.Level) then begin
                  m_SkillUseTick[8] := GetTickCount;
                  Result := 8;
                end else
                  if IsAllowUseMagic(56) then begin
                  Result := 56;
                end else
                  if IsAllowUseMagic(11) then begin
                  Result := 11;
                end else
                  if IsAllowUseMagic(5) then begin
                  Result := 5;
                end else
                  if IsAllowUseMagic(1) then begin
                  Result := 1;
                end;
              end;
            2: begin
                if IsAllowUseMagic(24) then begin
                  Result := 24; //׹
                end else
                  if IsAllowUseMagic(47) then begin
                  Result := 47;
                end else
                  if IsAllowUseMagic(33) then begin
                  Result := 33;
                end else
                  if IsAllowUseMagic(22) and (GetTickCount - m_SkillUseTick[22] > 1000 * 10) and (g_EventManager.GetRangeEvent(m_PEnvir, Self, m_nCurrX, m_nCurrY, 6, ET_FIRE) = 0) then begin
                  m_SkillUseTick[22] := GetTickCount;
                  Result := 22;
                end else
                  if IsAllowUseMagic(23) then begin
                  Result := 23;
                end else
                  if IsAllowUseMagic(37) then begin
                  Result := 37;
                end else
                  if IsAllowUseMagic(45) then begin
                  Result := 45;
                end else
                  if IsAllowUseMagic(8) and (GetTickCount - m_SkillUseTick[8] > 1000 * 10) and (m_TargetCret <> nil) and (m_TargetCret.m_Abil.Level <= m_Abil.Level) then begin
                  m_SkillUseTick[8] := GetTickCount;
                  Result := 8;
                end else
                  if IsAllowUseMagic(56) then begin
                  Result := 56;
                end else
                  if IsAllowUseMagic(11) then begin
                  Result := 11;
                end else
                  if IsAllowUseMagic(5) then begin
                  Result := 5;
                end else
                  if IsAllowUseMagic(1) then begin
                  Result := 1;
                end;
              end;
            3: begin
                if IsAllowUseMagic(24) then begin
                  Result := 24; //׹
                end else
                  if IsAllowUseMagic(37) then begin
                  Result := 37;
                end else
                  if IsAllowUseMagic(22) and (GetTickCount - m_SkillUseTick[22] > 1000 * 10) and (g_EventManager.GetRangeEvent(m_PEnvir, Self, m_nCurrX, m_nCurrY, 6, ET_FIRE) = 0) then begin
                  m_SkillUseTick[22] := GetTickCount;
                  Result := 22;
                end else
                  if IsAllowUseMagic(23) then begin
                  Result := 23;
                end else
                  if IsAllowUseMagic(33) then begin
                  Result := 33;
                end else
                  if IsAllowUseMagic(45) then begin
                  Result := 45;
                end else
                  if IsAllowUseMagic(47) then begin
                  Result := 47;
                end else
                  if IsAllowUseMagic(8) and (GetTickCount - m_SkillUseTick[8] > 1000 * 10) and (m_TargetCret <> nil) and (m_TargetCret.m_Abil.Level <= m_Abil.Level) then begin
                  m_SkillUseTick[8] := GetTickCount;
                  Result := 8;
                end else
                  if IsAllowUseMagic(56) then begin
                  Result := 56;
                end else
                  if IsAllowUseMagic(11) then begin
                  Result := 11;
                end else
                  if IsAllowUseMagic(5) then begin
                  Result := 5;
                end else
                  if IsAllowUseMagic(1) then begin
                  Result := 1;
                end;
              end;
            4: begin
                if IsAllowUseMagic(24) then begin
                  Result := 24; //׹
                end else
                  if IsAllowUseMagic(47) then begin
                  Result := 47;
                end else
                  if IsAllowUseMagic(22) and (GetTickCount - m_SkillUseTick[22] > 1000 * 10) and (g_EventManager.GetRangeEvent(m_PEnvir, Self, m_nCurrX, m_nCurrY, 6, ET_FIRE) = 0) then begin
                  m_SkillUseTick[22] := GetTickCount;
                  Result := 22;
                end else
                  if IsAllowUseMagic(23) then begin
                  Result := 23;
                end else
                  if IsAllowUseMagic(33) then begin
                  Result := 33;
                end else
                  if IsAllowUseMagic(45) then begin
                  Result := 45;
                end else
                  if IsAllowUseMagic(37) then begin
                  Result := 37;
                end else
                  if IsAllowUseMagic(8) and (GetTickCount - m_SkillUseTick[8] > 1000 * 10) and (m_TargetCret <> nil) and (m_TargetCret.m_Abil.Level <= m_Abil.Level) then begin
                  m_SkillUseTick[8] := GetTickCount;
                  Result := 8;
                end else
                  if IsAllowUseMagic(56) then begin
                  Result := 56;
                end else
                  if IsAllowUseMagic(11) then begin
                  Result := 11;
                end else
                  if IsAllowUseMagic(5) then begin
                  Result := 5;
                end else
                  if IsAllowUseMagic(1) then begin
                  Result := 1;
                end;
              end;
          end;
        end else begin
          if CheckTargetXYCountOfDirection(m_nTargetX, m_nTargetY, m_btDirection, 3) = 1 then begin
            if IsAllowUseMagic(11) then begin
              Result := 11;
            end else
              if IsAllowUseMagic(5) then begin
              Result := 5;
            end else
              if IsAllowUseMagic(1) then begin
              Result := 1;
            end;
          end else begin
            case Random(4) of //ѡħ
              0: begin
                  if IsAllowUseMagic(23) then begin
                    Result := 23;
                  end else
                    if IsAllowUseMagic(22) and (GetTickCount - m_SkillUseTick[22] > 1000 * 10) and (g_EventManager.GetRangeEvent(m_PEnvir, Self, m_nCurrX, m_nCurrY, 6, ET_FIRE) = 0) then begin
                    m_SkillUseTick[22] := GetTickCount;
                    Result := 22;
                  end else
                    if IsAllowUseMagic(33) then begin
                    Result := 33;
                  end else
                    if IsAllowUseMagic(37) then begin
                    Result := 37;
                  end else
                    if IsAllowUseMagic(45) then begin
                    Result := 45;
                  end else
                    if IsAllowUseMagic(47) then begin
                    Result := 47;
                  end else
                    if IsAllowUseMagic(11) then begin
                    Result := 11;
                  end else
                    if IsAllowUseMagic(5) then begin
                    Result := 5;
                  end else
                    if IsAllowUseMagic(1) then begin
                    Result := 1;
                  end;
                end;
              1: begin
                  if IsAllowUseMagic(33) then begin
                    Result := 33;
                  end else
                    if IsAllowUseMagic(22) and (GetTickCount - m_SkillUseTick[22] > 1000 * 10) and (g_EventManager.GetRangeEvent(m_PEnvir, Self, m_nCurrX, m_nCurrY, 6, ET_FIRE) = 0) then begin
                    m_SkillUseTick[22] := GetTickCount;
                    Result := 22;
                  end else
                    if IsAllowUseMagic(23) then begin
                    Result := 23;
                  end else
                    if IsAllowUseMagic(37) then begin
                    Result := 37;
                  end else
                    if IsAllowUseMagic(45) then begin
                    Result := 45;
                  end else
                    if IsAllowUseMagic(47) then begin
                    Result := 47;
                  end else
                    if IsAllowUseMagic(11) then begin
                    Result := 11;
                  end else
                    if IsAllowUseMagic(5) then begin
                    Result := 5;
                  end else
                    if IsAllowUseMagic(1) then begin
                    Result := 1;
                  end;
                end;
              2: begin
                  if IsAllowUseMagic(47) then begin
                    Result := 47;
                  end else
                    if IsAllowUseMagic(33) then begin
                    Result := 33;
                  end else
                    if IsAllowUseMagic(22) and (GetTickCount - m_SkillUseTick[22] > 1000 * 10) and (g_EventManager.GetRangeEvent(m_PEnvir, Self, m_nCurrX, m_nCurrY, 6, ET_FIRE) = 0) then begin
                    m_SkillUseTick[22] := GetTickCount;
                    Result := 22;
                  end else
                    if IsAllowUseMagic(23) then begin
                    Result := 23;
                  end else
                    if IsAllowUseMagic(37) then begin
                    Result := 37;
                  end else
                    if IsAllowUseMagic(45) then begin
                    Result := 45;
                  end else
                    if IsAllowUseMagic(11) then begin
                    Result := 11;
                  end else
                    if IsAllowUseMagic(5) then begin
                    Result := 5;
                  end else
                    if IsAllowUseMagic(1) then begin
                    Result := 1;
                  end;
                end;
              3: begin
                  if IsAllowUseMagic(37) then begin
                    Result := 37;
                  end else
                    if IsAllowUseMagic(22) and (GetTickCount - m_SkillUseTick[22] > 1000 * 10) and (g_EventManager.GetRangeEvent(m_PEnvir, Self, m_nCurrX, m_nCurrY, 6, ET_FIRE) = 0) then begin
                    m_SkillUseTick[22] := GetTickCount;
                    Result := 22;
                  end else
                    if IsAllowUseMagic(23) then begin
                    Result := 23;
                  end else
                    if IsAllowUseMagic(33) then begin
                    Result := 33;
                  end else
                    if IsAllowUseMagic(45) then begin
                    Result := 45;
                  end else
                    if IsAllowUseMagic(47) then begin
                    Result := 47;
                  end else
                    if IsAllowUseMagic(11) then begin
                    Result := 11;
                  end else
                    if IsAllowUseMagic(5) then begin
                    Result := 5;
                  end else
                    if IsAllowUseMagic(1) then begin
                    Result := 1;
                  end;
                end;
              4: begin
                  if IsAllowUseMagic(47) then begin
                    Result := 47;
                  end else
                    if IsAllowUseMagic(22) and (GetTickCount - m_SkillUseTick[22] > 1000 * 10) and (g_EventManager.GetRangeEvent(m_PEnvir, Self, m_nCurrX, m_nCurrY, 6, ET_FIRE) = 0) then begin
                    m_SkillUseTick[22] := GetTickCount;
                    Result := 22;
                  end else
                    if IsAllowUseMagic(23) then begin
                    Result := 23;
                  end else
                    if IsAllowUseMagic(33) then begin
                    Result := 33;
                  end else
                    if IsAllowUseMagic(45) then begin
                    Result := 45;
                  end else
                    if IsAllowUseMagic(37) then begin
                    Result := 37;
                  end else
                    if IsAllowUseMagic(11) then begin
                    Result := 11;
                  end else
                    if IsAllowUseMagic(5) then begin
                    Result := 5;
                  end else
                    if IsAllowUseMagic(1) then begin
                    Result := 1;
                  end;
                end;
            end;
          end;
        end;
      end;
    2: begin //ʿ
        //if CheckTargetXYCount(m_nCurrX, m_nCurrY, 1) >= 2 then begin //Χ
        if m_WAbil.HP <= m_WAbil.MaxHP div 2 then begin //ʹ
          case Random(2) of
            0, 1: begin
                if IsAllowUseMagic(2) then begin {ʹ}
                  m_TargetCret := Self;
                  Result := 2;
                end;
              end;
            2: begin
                if IsAllowUseMagic(29) then begin {ʹȺ}
                  m_TargetCret := Self;
                  Result := 29;
                end;
              end;
          end;
          if Result > 0 then Exit;
        end;
        if IsAllowUseMagic(15) and (m_wStatusTimeArr[STATE_DEFENCEUP] = 0) and ((GetUserItemList(1) >= 0) or CheckUserItemType(1)) then begin // {ʹʥս}
          m_TargetCret := Self;
          Result := 15;
        end else
          if (m_TargetCret.m_wStatusTimeArr[POISON_DECHEALTH] = 0) and
          (m_TargetCret.m_wStatusTimeArr[POISON_DAMAGEARMOR] = 0) and ((GetUserItemList(2) >= 0) or CheckUserItemType(2)) then begin {}
          if IsAllowUseMagic(38) then Result := 38
          else if IsAllowUseMagic(6) then Result := 6
          else if IsAllowUseMagic(13) then Result := 13;
        end else
          if IsAllowUseMagic(13) and ((GetUserItemList(1) >= 0) or CheckUserItemType(1)) then begin
          Result := 13;
        end else
          if IsAllowUseMagic(52) and (m_TargetCret.m_wStatusArrValue[m_TargetCret.m_btJob] = 0) and ((GetUserItemList(1) >= 0) or CheckUserItemType(1)) then begin {}
          Result := 52;
        end else
          if IsAllowUseMagic(50) and (GetTickCount - m_SkillUseTick[50] > 1000 * 10) then begin {޼}
          m_SkillUseTick[50] := GetTickCount;
          Result := 50;
        end;
      end;
  end;
end;

function THeroObject.IsUseMagic(): Boolean; //Ƿʹñħ
var
  UserMagic: pTUserMagic;
  I: Integer;
begin
  Result := False;
  if m_nSelectMagic <= 0 then Exit;
  case m_btJob of
    2: begin
        for I := 0 to m_MagicList.Count - 1 do begin
          UserMagic := m_MagicList.Items[I];
          if UserMagic.MagicInfo.btJob in [2, 99] then begin
            case UserMagic.wMagIdx of
              SKILL_HEALLING {2},
                SKILL_HANGMAJINBUB {14},
                SKILL_DEJIWONHO {15},
                SKILL_HOLYSHIELD {16},
              //SKILL_SKELLETON {17},
              SKILL_CLOAK {18},
                SKILL_BIGCLOAK {19},
                SKILL_BIGHEALLING {29}: begin //Ҫ
                  Result := CheckUserItemType(1);
                  if Result then Break;
                  Result := GetUserItemList(1) > 0;
                  if Result then Break;
                end;
            end;
          end;
        end;
      end;
  end;
end;

function THeroObject.CheckActionStatus(wIdent: Word; var dwDelayTime: LongWord): Boolean;
begin
  Result := True;
end;

//1 Ϊ 2 Ϊҩ
function THeroObject.IsUseAttackMagic(): Boolean; //Ƿʹùħ
var
  UserMagic: pTUserMagic;
  I: Integer;
begin
  Result := False;
  if m_nSelectMagic <= 0 then Exit;
  case m_btJob of
    0, 1: Result := True;
    2: begin
        for I := 0 to m_MagicList.Count - 1 do begin
          UserMagic := m_MagicList.Items[I];
          if UserMagic.MagicInfo.btJob in [2, 99] then begin
            case UserMagic.wMagIdx of
              SKILL_AMYOUNSUL {6 ʩ}, SKILL_GROUPAMYOUNSUL {38 Ⱥʩ}: begin //Ҫҩ
                  Result := CheckUserItemType(2);
                  if Result then Break;
                  Result := GetUserItemList(2) > 0;
                  if Result then Break;
                end;
              SKILL_FIRECHARM {13},
                SKILL_HOLYSHIELD {16},
                SKILL_SKELLETON {17},
                SKILL_52: begin //Ҫ
                  Result := CheckUserItemType(1);
                  if Result then Break;
                  Result := GetUserItemList(1) > 0;
                  if Result then Break;
                end;
            end;
          end;
        end;
      end;
  end;
end;

function THeroObject.Think(): Boolean;
var
  nOldX, nOldY: Integer;
  bt06: Byte;
  I: Integer;
begin
  Result := False;
  if m_Master = nil then Exit;
  if (m_Master.m_nCurrX = m_nCurrX) and (m_Master.m_nCurrY = m_nCurrY) then begin
    m_boDupMode := True;
  end else begin
    if (GetTickCount - m_dwThinkTick) > 1000 then begin
      m_dwThinkTick := GetTickCount();
      if m_PEnvir.GetXYObjCount(m_nCurrX, m_nCurrY) >= 2 then m_boDupMode := True;
      if not IsProperTarget(m_TargetCret) then m_TargetCret := nil;
    end;
  end;
  EatMedicine();
  if m_boDupMode then begin
    nOldX := m_nCurrX;
    nOldY := m_nCurrY;
    WalkTo(Random(8), False);
    if (nOldX <> m_nCurrX) or (nOldY <> m_nCurrY) then begin
      m_boDupMode := False;
      Result := True;
    end;
  end;
end;

function THeroObject.SearchIsPickUpItem(): Boolean;
var
  VisibleMapItem: pTVisibleMapItem;
  MapItem: PTMapItem;
  I: Integer;
  nCurrX, nCurrY: Integer;
begin
  Result := False;
  if m_Master = nil then Exit;
  if (m_Master <> nil) and (m_Master.m_boDeath) then Exit;
  if m_btStatus = 2 then Exit;
  if m_TargetCret <> nil then Exit;
  if m_boProtectStatus then Exit;
  if m_VisibleItems.Count = 0 then Exit;
  if GetTickCount < m_dwSearchIsPickUpItemTime then Exit;
  if (not IsEnoughBag) or (not m_boCanPickUpItem) then Exit;
  if m_Master <> nil then begin
    nCurrX := m_Master.m_nCurrX;
    nCurrY := m_Master.m_nCurrY;
    if m_boProtectStatus then begin
      nCurrX := m_nProtectTargetX;
      nCurrY := m_nProtectTargetY;
    end;
    if (abs(nCurrX - m_nCurrX) > 15) or (abs(nCurrY - m_nCurrY) > 15) then begin
      //m_dwSearchIsPickUpItemTick := GetTickCount;
      m_dwSearchIsPickUpItemTime := GetTickCount + 1000 * 5;
      Exit;
    end;
  end;
  {m_dwSearchIsPickUpItemTick := GetTickCount;
  m_dwSearchIsPickUpItemTime := 1000;}
  for I := 0 to m_VisibleItems.Count - 1 do begin
    VisibleMapItem := pTVisibleMapItem(m_VisibleItems.Items[I]);
    if (VisibleMapItem <> nil) and (VisibleMapItem.nVisibleFlag > 0) then begin
      MapItem := VisibleMapItem.MapItem;
      if (MapItem <> nil) and (MapItem.DropBaseObject <> m_Master) then begin
        if IsAllowPickUpItem(VisibleMapItem.sName) and IsAddWeightAvailable(UserEngine.GetStdItemWeight(MapItem.UserItem.wIndex)) then begin
            //if (MapItem.DropBaseObject <> nil) and (TBaseObject(MapItem.DropBaseObject).m_btRaceServer = RC_PLAYOBJECT) then Continue;
          if (MapItem.OfBaseObject = nil) or (MapItem.OfBaseObject = m_Master) or (MapItem.OfBaseObject = Self) then begin
            if (abs(VisibleMapItem.nX - m_nCurrX) <= 5) and (abs(VisibleMapItem.nY - m_nCurrY) <= 5) then begin
              Result := True;
              Break;
            end;
          end;
        end;
      end;
    end;
  end;
end;

function THeroObject.GotoTargetXYRange(): Boolean;
var
  n10: Integer;
  n14: Integer;
  nTargetX: Integer;
  nTargetY: Integer;
begin
  Result := True;
  n10 := abs(m_TargetCret.m_nCurrX - m_nCurrX);
  n14 := abs(m_TargetCret.m_nCurrY - m_nCurrY);
  if n10 > 4 then Dec(n10, 5) else n10 := 0;
  if n14 > 4 then Dec(n14, 5) else n14 := 0;
  if m_TargetCret.m_nCurrX > m_nCurrX then nTargetX := m_nCurrX + n10;
  if m_TargetCret.m_nCurrX < m_nCurrX then nTargetX := m_nCurrX - n10;
  if m_TargetCret.m_nCurrY > m_nCurrY then nTargetY := m_nCurrY + n14;
  if m_TargetCret.m_nCurrY < m_nCurrY then nTargetY := m_nCurrY - n14;
  Result := GotoTargetXY(nTargetX, nTargetY);
end;

function THeroObject.AutoAvoid(): Boolean; //Զ
  function GetAvoidDir(): Integer;
  var
    n10: Integer;
    n14: Integer;
  begin
    n10 := m_TargetCret.m_nCurrX;
    n14 := m_TargetCret.m_nCurrY;
    Result := DR_DOWN;
    if n10 > m_nCurrX then begin
      Result := DR_LEFT;
      if n14 > m_nCurrY then Result := DR_DOWNLEFT;
      if n14 < m_nCurrY then Result := DR_UPLEFT;
    end else begin
      if n10 < m_nCurrX then begin
        Result := DR_RIGHT;
        if n14 > m_nCurrY then Result := DR_DOWNRIGHT;
        if n14 < m_nCurrY then Result := DR_UPRIGHT;
      end else begin
        if n14 > m_nCurrY then Result := DR_UP
        else if n14 < m_nCurrY then Result := DR_DOWN;
      end;
    end;
  end;
  function GetDirXY(nTargetX, nTargetY: Integer): Byte;
  var
    n10: Integer;
    n14: Integer;
  begin
    n10 := nTargetX;
    n14 := nTargetY;
    Result := DR_DOWN;
    if n10 > m_nCurrX then begin
      Result := DR_RIGHT;
      if n14 > m_nCurrY then Result := DR_DOWNRIGHT;
      if n14 < m_nCurrY then Result := DR_UPRIGHT;
    end else begin
      if n10 < m_nCurrX then begin
        Result := DR_LEFT;
        if n14 > m_nCurrY then Result := DR_DOWNLEFT;
        if n14 < m_nCurrY then Result := DR_UPLEFT;
      end else begin
        if n14 > m_nCurrY then Result := DR_DOWN
        else if n14 < m_nCurrY then Result := DR_UP;
      end;
    end;
  end;

  function GetGotoXY(nDir: Integer; var nTargetX, nTargetY: Integer): Boolean;
  var
    n01: Integer;
  begin
    Result := False;
    n01 := 0;
    while True do begin
      case nDir of
        DR_UP: begin
            if m_PEnvir.CanWalk(nTargetX, nTargetY, True) and (CheckTargetXYCountOfDirection(nTargetX, nTargetY, nDir, 8) = 0) then begin //CheckTargetXYCountOfDirection
              Inc(nTargetY, 2);
              Result := True;
              Break;
            end else begin
              if n01 >= 10 then Break;
              Inc(nTargetY, 2);
              Inc(n01, 2);
              Continue;
            end;
          end;
        DR_UPRIGHT: begin
            if m_PEnvir.CanWalk(nTargetX, nTargetY, True) and (CheckTargetXYCountOfDirection(nTargetX, nTargetY, nDir, 8) = 0) then begin
              Inc(nTargetX, 2);
              Inc(nTargetY, 2);
              Result := True;
              Break;
            end else begin
              if n01 >= 10 then Break;
              Inc(nTargetX, 2);
              Inc(nTargetY, 2);
              Inc(n01, 2);
              Continue;
            end;
          end; //CheckTargetXYCountOfDirection(m_nCurrX, m_nCurrY, m_btDirection, 1)
        DR_RIGHT: begin
            if m_PEnvir.CanWalk(nTargetX, nTargetY, True) and (CheckTargetXYCountOfDirection(nTargetX, nTargetY, nDir, 8) = 0) then begin
              Inc(nTargetX, 2);
              Result := True;
              Break;
            end else begin
              if n01 >= 10 then Break;
              Inc(nTargetX, 2);
              Inc(n01, 2);
              Continue;
            end;
          end;
        DR_DOWNRIGHT: begin
            if m_PEnvir.CanWalk(nTargetX, nTargetY, True) and (CheckTargetXYCountOfDirection(nTargetX, nTargetY, nDir, 8) = 0) then begin
              Inc(nTargetX, 2);
              Dec(nTargetY, 2);
              Result := True;
              Break;
            end else begin
              if n01 >= 10 then Break;
              Inc(nTargetX, 2);
              Dec(nTargetY, 2);
              Inc(n01);
              Continue;
            end;
          end;
        DR_DOWN: begin
            if m_PEnvir.CanWalk(nTargetX, nTargetY, True) and (CheckTargetXYCountOfDirection(nTargetX, nTargetY, nDir, 8) = 0) then begin
              Dec(nTargetY, 2);
              Result := True;
              Break;
            end else begin
              if n01 >= 10 then Break;
              Dec(nTargetY, 2);
              Inc(n01, 2);
              Continue;
            end;
          end;
        DR_DOWNLEFT: begin
            if m_PEnvir.CanWalk(nTargetX, nTargetY, True) and (CheckTargetXYCountOfDirection(nTargetX, nTargetY, nDir, 8) = 0) then begin
              Dec(nTargetX, 2);
              Dec(nTargetY, 2);
              Result := True;
              Break;
            end else begin
              if n01 >= 10 then Break;
              Dec(nTargetX, 2);
              Dec(nTargetY, 2);
              Inc(n01, 2);
              Continue;
            end;
          end;
        DR_LEFT: begin
            if m_PEnvir.CanWalk(nTargetX, nTargetY, True) and (CheckTargetXYCountOfDirection(nTargetX, nTargetY, nDir, 8) = 0) then begin
              Dec(nTargetX, 2);
              Result := True;
              Break;
            end else begin
              if n01 >= 10 then Break;
              Dec(nTargetX, 2);
              Inc(n01, 2);
              Continue;
            end;
          end;
        DR_UPLEFT: begin
            if m_PEnvir.CanWalk(nTargetX, nTargetY, True) and (CheckTargetXYCountOfDirection(nTargetX, nTargetY, nDir, 8) = 0) then begin
              Dec(nTargetX, 2);
              Inc(nTargetY, 2);
              Result := True;
              Break;
            end else begin
              if n01 >= 10 then Break;
              Dec(nTargetX, 2);
              Inc(nTargetY, 2);
              Inc(n01, 2);
              Continue;
            end;
          end;
      else begin
          Break;
        end;
      end;
    end;

  end;

  function GetAvoidXY(var nTargetX, nTargetY: Integer): Boolean;
  var
    I, n10, nDir: Integer;
    nX, nY: Integer;
  begin
    nX := nTargetX;
    nY := nTargetY;
    Result := GetGotoXY(m_btLastDirection, nTargetX, nTargetY);
    n10 := 0;
    while True do begin
      if n10 >= 7 then Break;
      if Result then Break;
      nTargetX := nX;
      nTargetY := nY;
      nDir := Random(7);
      Result := GetGotoXY(nDir, nTargetX, nTargetY);
      Inc(n10);
    end;
    m_btLastDirection := nDir; //m_btDirection;
  end;
  function GotoMasterXY(var nTargetX, nTargetY: Integer): Boolean;
  var
    nDir: Integer;
  begin
    Result := False;
    if (m_Master <> nil) and ((abs(m_Master.m_nCurrX - m_nCurrX) >= 10) or (abs(m_Master.m_nCurrY - m_nCurrY) >= 10)) and not m_boProtectStatus then begin
      nTargetX := m_nCurrX;
      nTargetY := m_nCurrY;
      nDir := GetDirXY(m_Master.m_nCurrX, m_Master.m_nCurrY);
      m_btLastDirection := nDir;
      case nDir of
        DR_UP: begin
            Result := GetGotoXY(nDir, nTargetX, nTargetY);
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_UPRIGHT, nTargetX, nTargetY);
              m_btLastDirection := DR_UPRIGHT;
            end;
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_UPLEFT, nTargetX, nTargetY);
              m_btLastDirection := DR_UPLEFT;
            end;
          end;
        DR_UPRIGHT: begin
            Result := GetGotoXY(nDir, nTargetX, nTargetY);
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_UP, nTargetX, nTargetY);
              m_btLastDirection := DR_UP;
            end;
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_RIGHT, nTargetX, nTargetY);
              m_btLastDirection := DR_RIGHT;
            end;
          end;
        DR_RIGHT: begin
            Result := GetGotoXY(nDir, nTargetX, nTargetY);
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_UPRIGHT, nTargetX, nTargetY);
              m_btLastDirection := DR_UPRIGHT;
            end;
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_DOWNRIGHT, nTargetX, nTargetY);
              m_btLastDirection := DR_DOWNRIGHT;
            end;
          end;
        DR_DOWNRIGHT: begin
            Result := GetGotoXY(nDir, nTargetX, nTargetY);
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_RIGHT, nTargetX, nTargetY);
              m_btLastDirection := DR_RIGHT;
            end;
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_DOWN, nTargetX, nTargetY);
              m_btLastDirection := DR_DOWN;
            end;
          end;
        DR_DOWN: begin
            Result := GetGotoXY(nDir, nTargetX, nTargetY);
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_DOWNRIGHT, nTargetX, nTargetY);
              m_btLastDirection := DR_DOWNRIGHT;
            end;
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_DOWNLEFT, nTargetX, nTargetY);
              m_btLastDirection := DR_DOWNLEFT;
            end;
          end;
        DR_DOWNLEFT: begin
            Result := GetGotoXY(nDir, nTargetX, nTargetY);
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_DOWN, nTargetX, nTargetY);
              m_btLastDirection := DR_DOWN;
            end;
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_LEFT, nTargetX, nTargetY);
              m_btLastDirection := DR_LEFT;
            end;
          end;
        DR_LEFT: begin
            Result := GetGotoXY(nDir, nTargetX, nTargetY);
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_DOWNLEFT, nTargetX, nTargetY);
              m_btLastDirection := DR_DOWNLEFT;
            end;
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_UPLEFT, nTargetX, nTargetY);
              m_btLastDirection := DR_UPLEFT;
            end;
          end;
        DR_UPLEFT: begin
            Result := GetGotoXY(nDir, nTargetX, nTargetY);
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_LEFT, nTargetX, nTargetY);
              m_btLastDirection := DR_LEFT;
            end;
            if not Result then begin
              nTargetX := m_nCurrX;
              nTargetY := m_nCurrY;
              Result := GetGotoXY(DR_UP, nTargetX, nTargetY);
              m_btLastDirection := DR_UP;
            end;
          end;
      end;
    end;
  end;
var
  nTargetX: Integer;
  nTargetY: Integer;
  nDir: Integer;
begin
  Result := True;
  if (m_TargetCret <> nil) and not m_TargetCret.m_boDeath then begin
    nDir := m_btLastDirection;
    if GotoMasterXY(nTargetX, nTargetY) then begin
      Result := GotoTargetXY(nTargetX, nTargetY);
    end else begin
      m_btLastDirection := nDir;
      nTargetX := m_nCurrX;
      nTargetY := m_nCurrY;
      if GetAvoidXY(nTargetX, nTargetY) then begin
        Result := GotoTargetXY(nTargetX, nTargetY);
      end;
    end;
  //m_btLastDirection := m_btDirection;
  end;
end;

function THeroObject.SearchPickUpItem(nPickUpTime: Integer): Boolean;
  procedure SetHideItem(MapItem: PTMapItem);
  var
    VisibleMapItem: pTVisibleMapItem;
    I: Integer;
  begin
    for I := 0 to m_VisibleItems.Count - 1 do begin
      VisibleMapItem := pTVisibleMapItem(m_VisibleItems.Items[I]);
      if (VisibleMapItem <> nil) and (VisibleMapItem.nVisibleFlag > 0) then begin
        if VisibleMapItem.MapItem = MapItem then begin
          VisibleMapItem.nVisibleFlag := 0;
          Break;
        end;
      end;
    end;
  end;

  function PickUpItem(nX, nY: Integer): Boolean;
  var
    UserItem: pTUserItem;
    StdItem: pTStdItem;
    MapItem: PTMapItem;
    nDeleteCode: Integer;
  begin
    Result := False;
    MapItem := m_PEnvir.GetItem(nX, nY);
    if MapItem = nil then Exit;
    if CompareText(MapItem.Name, sSTRING_GOLDNAME) = 0 then begin
      if m_PEnvir.DeleteFromMap(nX, nY, OS_ITEMOBJECT, TObject(MapItem)) = 1 then begin
        if (m_Master <> nil) and (not m_Master.m_boDeath) then begin //񵽵ǮӸ
          if TPlayObject(m_Master).IncGold(MapItem.Count) then begin
            SendRefMsg(RM_ITEMHIDE, 0, Integer(MapItem), nX, nY, '');
            if g_boGameLogGold then
              AddGameDataLog('4' + #9 +
                m_sMapName + #9 +
                IntToStr(nX) + #9 +
                IntToStr(nY) + #9 +
                m_sCharName + #9 +
                sSTRING_GOLDNAME + #9 +
                IntToStr(MapItem.Count) + #9 +
                '1' + #9 +
                '0');
            Result := True;
            m_Master.GoldChanged;
            SetHideItem(MapItem);
            Dispose(MapItem);
          end else begin
            m_PEnvir.AddToMap(nX, nY, OS_ITEMOBJECT, TObject(MapItem));
          end;
        end else begin
          m_PEnvir.AddToMap(nX, nY, OS_ITEMOBJECT, TObject(MapItem));
        end;
      end else begin
        m_PEnvir.AddToMap(nX, nY, OS_ITEMOBJECT, TObject(MapItem));
      end;
    end else begin //Ʒ
      StdItem := UserEngine.GetStdItem(MapItem.UserItem.wIndex);
      if StdItem <> nil then begin
        if m_PEnvir.DeleteFromMap(nX, nY, OS_ITEMOBJECT, TObject(MapItem)) = 1 then begin
          New(UserItem);
          UserItem^ := MapItem.UserItem;
          StdItem := UserEngine.GetStdItem(UserItem.wIndex);
          if (StdItem <> nil) and IsAddWeightAvailable(UserEngine.GetStdItemWeight(UserItem.wIndex)) then begin
            if AddItemToBag(UserItem) then begin
              SendRefMsg(RM_ITEMHIDE, 0, Integer(MapItem), nX, nY, '');
              SendAddItem(UserItem);
              m_WAbil.Weight := RecalcBagWeight();
              if not IsCheapStuff(StdItem.StdMode) then
                if StdItem.NeedIdentify = 1 then
                  AddGameDataLog('4' + #9 +
                    m_sMapName + #9 +
                    IntToStr(nX) + #9 +
                    IntToStr(nY) + #9 +
                    m_sCharName + #9 +
                    //UserEngine.GetStdItemName(pu.wIndex) + #9 +
                    StdItem.Name + #9 +
                    IntToStr(UserItem.MakeIndex) + #9 +
                    '1' + #9 +
                    '0');
              Result := True;
              SetHideItem(MapItem);
              Dispose(MapItem);
            end else begin
              Dispose(UserItem);
              m_PEnvir.AddToMap(nX, nY, OS_ITEMOBJECT, TObject(MapItem));
            end;
          end else begin
            Dispose(UserItem);
            m_PEnvir.AddToMap(nX, nY, OS_ITEMOBJECT, TObject(MapItem));
          end;
        end else begin
          Dispose(UserItem);
          m_PEnvir.AddToMap(nX, nY, OS_ITEMOBJECT, TObject(MapItem));
        end;
      end;
    end;
  end;

  function IsOfGroup(BaseObject: TBaseObject): Boolean;
  var
    I: Integer;
    GroupMember: TBaseObject;
  begin
    {Result := False;
    if m_Master.m_GroupOwner = nil then Exit;
    for I := 0 to m_Master.m_GroupOwner.m_GroupMembers.Count - 1 do begin
      GroupMember := TBaseObject(m_Master.m_GroupOwner.m_GroupMembers.Objects[I]);
      if GroupMember = BaseObject then begin
        Result := True;
        Break;
      end;
    end;}
  end;
var
  MapItem: PTMapItem;
  VisibleMapItem: pTVisibleMapItem;
  SelVisibleMapItem: pTVisibleMapItem;
  I: Integer;
  nCheckCode: Integer;
  boFound: Boolean;
  sName: string;
  n01, n02: Integer;
resourcestring
  sExceptionMsg2 = '[Exception] THeroObject::PickUpItem 1-%d %s %s %d %d %d';
begin
  Result := False;
  if GetTickCount() - m_dwPickUpItemTick < nPickUpTime then Exit;
  m_dwPickUpItemTick := GetTickCount();
  //MainOutMessage('ʼƷ');
  boFound := False;
  if m_SelMapItem <> nil then begin
    for I := 0 to m_VisibleItems.Count - 1 do begin
      VisibleMapItem := pTVisibleMapItem(m_VisibleItems.Items[I]);
      if (VisibleMapItem <> nil) and (VisibleMapItem.nVisibleFlag > 0) then begin
        if VisibleMapItem.MapItem = m_SelMapItem then begin
          boFound := True;
          Break;
        end;
      end;
    end;
  end;
  if not boFound then m_SelMapItem := nil;
  if m_SelMapItem <> nil then begin
    if PickUpItem(m_nCurrX, m_nCurrY) then begin
      Result := True;
      Exit;
    end;
  end;
  n01 := 999;
  SelVisibleMapItem := nil;
  boFound := False;
  if m_SelMapItem <> nil then begin
    for I := 0 to m_VisibleItems.Count - 1 do begin
      VisibleMapItem := pTVisibleMapItem(m_VisibleItems.Items[I]);
      if (VisibleMapItem <> nil) and (VisibleMapItem.nVisibleFlag > 0) then begin
        if VisibleMapItem.MapItem = m_SelMapItem then begin
          SelVisibleMapItem := VisibleMapItem;
          boFound := True;
          Break;
        end;
      end;
    end;
  end;
  if not boFound then begin
    for I := 0 to m_VisibleItems.Count - 1 do begin
      VisibleMapItem := pTVisibleMapItem(m_VisibleItems.Items[I]);
      if (VisibleMapItem <> nil) and (VisibleMapItem.nVisibleFlag > 0) then begin
        MapItem := VisibleMapItem.MapItem;
        if (MapItem <> nil) and (MapItem.DropBaseObject <> m_Master) then begin
          if IsAllowPickUpItem(VisibleMapItem.sName) and IsAddWeightAvailable(UserEngine.GetStdItemWeight(MapItem.UserItem.wIndex)) then begin
            //if (MapItem.DropBaseObject <> nil) and (TBaseObject(MapItem.DropBaseObject).m_btRaceServer = RC_PLAYOBJECT) then Continue;
            if (MapItem.OfBaseObject = nil) or (MapItem.OfBaseObject = m_Master) or (MapItem.OfBaseObject = Self) {or IsOfGroup(TBaseObject(MapItem.OfBaseObject))} then begin
              if (abs(VisibleMapItem.nX - m_nCurrX) <= 5) and (abs(VisibleMapItem.nY - m_nCurrY) <= 5) then begin
                n02 := abs(VisibleMapItem.nX - m_nCurrX) + abs(VisibleMapItem.nY - m_nCurrY);
                if n02 < n01 then begin
                  n01 := n02;
                  SelVisibleMapItem := VisibleMapItem;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
  if SelVisibleMapItem <> nil then begin
    m_SelMapItem := SelVisibleMapItem.MapItem;
    if (m_nCurrX <> SelVisibleMapItem.nX) or (m_nCurrY <> SelVisibleMapItem.nY) then begin
      WalkToTargetXY2(SelVisibleMapItem.nX, VisibleMapItem.nY);
      Result := True;
    end;
  end;
end;

function THeroObject.IsPickUpItem(StdItem: pTStdItem): Boolean;
begin
  Result := True;
  {if StdItem.StdMode = 0 then begin
    if (StdItem.Shape in [0, 1, 2]) then Result := True;
  end else
    if StdItem.StdMode = 31 then begin
    if GetBindItemType(StdItem.Shape) >= 0 then Result := True;
  end else begin
    Result := False;
  end;}
end;

function THeroObject.EatUseItems(nShape: Integer): Boolean;
begin
  Result := False;
  case nShape of
    4: begin
        if WeaptonMakeLuck() then Result := True;
      end;
    9: begin
        if RepairWeapon() then Result := True;
      end;
    10: begin
        if SuperRepairWeapon() then Result := True;
      end;
  end;
end;

function THeroObject.AutoEatUseItems(btItemType: Byte): Boolean; //Զҩ
  function FoundAddHealthItem(ItemType: Byte): Integer;
  var
    I: Integer;
    UserItem: pTUserItem;
    StdItem: pTStdItem;
  begin
    Result := -1;
    for I := 0 to m_ItemList.Count - 1 do begin
      UserItem := m_ItemList.Items[I];
      if UserItem <> nil then begin
        StdItem := UserEngine.GetStdItem(UserItem.wIndex);
        if StdItem <> nil then begin
          case ItemType of
            0: begin //ҩ
                if (StdItem.StdMode = 0) and (StdItem.Shape = 0) and (StdItem.AC > 0) then begin
                  Result := I;
                  Break;
                end;
              end;
            1: begin //ҩ
                if (StdItem.StdMode = 0) and (StdItem.Shape = 0) and (StdItem.MAC > 0) then begin
                  Result := I;
                  Break;
                end;
              end;
            2: begin //̫ˮ
                if (StdItem.StdMode = 0) and (StdItem.Shape = 1) and (StdItem.AC > 0) and (StdItem.MAC > 0) then begin
                  Result := I;
                  Break;
                end;
              end;
            3: begin //ҩ
                if (StdItem.StdMode = 31) and (GetBindItemType(StdItem.Shape) = 0) and (m_ItemList.Count + 6 < m_nItemBagCount) then begin
                  Result := I;
                  Break;
                end;
              end;
            4: begin //ҩ
                if (StdItem.StdMode = 31) and (GetBindItemType(StdItem.Shape) = 1) and (m_ItemList.Count + 6 < m_nItemBagCount) then begin
                  Result := I;
                  Break;
                end;
              end;
          end;
        end;
      end;
    end;
  end;
var
  nItemIdx: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
  boFound: Boolean;
begin
  boFound := False;
  if not m_boDeath then begin
    nItemIdx := FoundAddHealthItem(btItemType);
    if (nItemIdx >= 0) and (nItemIdx < m_ItemList.Count) then begin
      UserItem := pTUserItem(m_ItemList.Items[nItemIdx]);
      SendDelItems(UserItem);
      ClientHeroUseItems(UserItem.MakeIndex, UserEngine.GetStdItem(UserItem.wIndex).Name);
      boFound := True;
    end else begin
      case btItemType of //ҽƷ
        0: begin
            nItemIdx := FoundAddHealthItem(3);
            if (nItemIdx >= 0) and (nItemIdx < m_ItemList.Count) then begin
              UserItem := pTUserItem(m_ItemList.Items[nItemIdx]);
              SendDelItems(UserItem);
              ClientHeroUseItems(UserItem.MakeIndex, UserEngine.GetStdItem(UserItem.wIndex).Name);
              boFound := True;
            end else begin
              nItemIdx := FoundAddHealthItem(2);
              if (nItemIdx >= 0) and (nItemIdx < m_ItemList.Count) then begin
                UserItem := pTUserItem(m_ItemList.Items[nItemIdx]);
                SendDelItems(UserItem);
                ClientHeroUseItems(UserItem.MakeIndex, UserEngine.GetStdItem(UserItem.wIndex).Name);
                boFound := True;
              end;
            end;
          end;
        1: begin
            nItemIdx := FoundAddHealthItem(4);
            if (nItemIdx >= 0) and (nItemIdx < m_ItemList.Count) then begin
              UserItem := pTUserItem(m_ItemList.Items[nItemIdx]);
              SendDelItems(UserItem);
              ClientHeroUseItems(UserItem.MakeIndex, UserEngine.GetStdItem(UserItem.wIndex).Name);
              boFound := True;
            end else begin
              nItemIdx := FoundAddHealthItem(2);
              if (nItemIdx >= 0) and (nItemIdx < m_ItemList.Count) then begin
                UserItem := pTUserItem(m_ItemList.Items[nItemIdx]);
                SendDelItems(UserItem);
                ClientHeroUseItems(UserItem.MakeIndex, UserEngine.GetStdItem(UserItem.wIndex).Name);
                boFound := True;
              end;
            end;
          end;
      end;
    end;
  end;
  if not boFound then begin
    case btItemType of
      0: SysMsg('ҩѾ꣡', c_Red, t_Hint);
      1: SysMsg('ħҩѾ꣡', c_Red, t_Hint);
    end;
  end;
end;

function THeroObject.IsNeedGotoXY(): Boolean; //ǷĿ
begin
  Result := False;
  if (m_TargetCret <> nil) and ((m_nSelectMagic <= 0) or (not m_boIsUseAttackMagic) or (m_btJob = 0)) then begin //
    if (m_btStatus <> 2) and ((abs(m_TargetCret.m_nCurrX - m_nCurrX) > 1) or (abs(m_TargetCret.m_nCurrY - m_nCurrY) > 1)) then begin
      Result := True;
    end;
  end;
end;

function THeroObject.IsNeedAvoid(): Boolean; //ǷҪ
begin
  Result := False;
  if ((GetTickCount - m_dwAutoAvoidTick) > 1000) and (m_btJob > 0) and (m_btStatus <> 2) and (m_nSelectMagic > 0) and m_boIsUseAttackMagic then begin
    m_dwAutoAvoidTick := GetTickCount();
    //if ((abs(m_TargetCret.m_nCurrX - m_nCurrX) <= 1) or (abs(m_TargetCret.m_nCurrY - m_nCurrY) <= 1)) then begin
    if CheckTargetXYCount(m_nCurrX, m_nCurrY, 3) > 0 then begin
      Result := True;
    end;
  end;
end;

procedure THeroObject.EatMedicine(); {ҩ}
begin
  if (GetTickCount - m_dwEatItemTick) > 3 * 1000 then begin
    m_dwEatItemTick := GetTickCount();
    if (m_nCopyHumanLevel > 0) and (m_ItemList.Count > 0) then begin
      if m_WAbil.HP < (m_WAbil.MaxHP * g_Config.nHeroAddHPRate) div 100 then begin
        AutoEatUseItems(0);
      end;
      if m_WAbil.MP < (m_WAbil.MaxMP * g_Config.nHeroAddMPRate) div 100 then begin
        AutoEatUseItems(1);
      end;
    end;
  end;
end;

{ָͷΧĹ}
function THeroObject.CheckTargetXYCountOfDirection(nX, nY, nDir, nRange: Integer): Integer;
var
  BaseObject: TBaseObject;
  I, nC, n10: Integer;
begin
  Result := 0;
  n10 := 2;
  for I := 0 to m_VisibleActors.Count - 1 do begin
    BaseObject := TBaseObject(pTVisibleBaseObject(m_VisibleActors.Items[I]).BaseObject);
    if BaseObject <> nil then begin
      if not BaseObject.m_boDeath then begin
        if IsProperTarget(BaseObject) and
          (not BaseObject.m_boHideMode or m_boCoolEye) then begin
          case nDir of
            DR_UP: begin
                if (abs(nX - BaseObject.m_nCurrX) <= nRange) and ((BaseObject.m_nCurrY - nY) in [0..nRange]) then Inc(Result);
              end;
            DR_UPRIGHT: begin
                if ((BaseObject.m_nCurrX - nX) in [0..nRange]) and ((BaseObject.m_nCurrY - nY) in [0..nRange]) then Inc(Result);
              end;
            DR_RIGHT: begin
                if ((BaseObject.m_nCurrX - nX) in [0..nRange]) and (abs(nY - BaseObject.m_nCurrY) <= nRange) then Inc(Result);
              end;
            DR_DOWNRIGHT: begin
                if ((BaseObject.m_nCurrX - nX) in [0..nRange]) and ((nY - BaseObject.m_nCurrY) in [0..nRange]) then Inc(Result);
              end;
            DR_DOWN: begin
                if (abs(nX - BaseObject.m_nCurrX) <= nRange) and ((nY - BaseObject.m_nCurrY) in [0..nRange]) then Inc(Result);
              end;
            DR_DOWNLEFT: begin
                if ((nX - BaseObject.m_nCurrX) in [0..nRange]) and ((nY - BaseObject.m_nCurrY) in [0..nRange]) then Inc(Result);
              end;
            DR_LEFT: begin
                if ((nX - BaseObject.m_nCurrX) in [0..nRange]) and (abs(nY - BaseObject.m_nCurrY) <= nRange) then Inc(Result);
              end;
            DR_UPLEFT: begin
                if ((nX - BaseObject.m_nCurrX) in [0..nRange]) and ((BaseObject.m_nCurrY - nY) in [0..nRange]) then Inc(Result);
              end;
          end;
          //if Result > 2 then break;
        end;
      end;
    end;
  end;
end;

function THeroObject.WarrAttackTarget(wHitMode: Word): Boolean; {}
var
  bt06: Byte;
begin
  Result := False;
  if m_TargetCret <> nil then begin
    if GetAttackDir(m_TargetCret, bt06) then begin
      m_dwTargetFocusTick := GetTickCount();
      Attack(m_TargetCret, bt06);
      BreakHolySeizeMode();
      Result := True;
    end else begin
      if m_TargetCret.m_PEnvir = m_PEnvir then begin
        SetTargetXY(m_TargetCret.m_nCurrX, m_TargetCret.m_nCurrY);
      end else begin
        DelTargetCreat();
      end;
    end;
  end;
end;

function THeroObject.WarrorAttackTarget(): Boolean; {սʿ}
var
  wHitMode: Word;
  nSelectMagic: Integer;
  UserMagic: pTUserMagic;
  dwDelayTime: LongWord;
begin
  Result := False;
  m_wHitMode := 0;
  if m_nSelectMagic > 0 then begin
    UserMagic := FindMagic(m_nSelectMagic);
    if UserMagic <> nil then begin
      case m_nSelectMagic of
        39, 41, 60..65: begin
            Result := ClientSpellXY(UserMagic, m_TargetCret.m_nCurrX, m_TargetCret.m_nCurrY, m_TargetCret); //սʿħ
            Exit;
          end;
      end;
      case m_nSelectMagic of
        7: m_wHitMode := 3; //ɱ
        12: m_wHitMode := 4; //ʹôɱ
        25: m_wHitMode := 5; //ʹð
        26: m_wHitMode := 7; //ʹһ
        40: m_wHitMode := 8; //µ
      end;
    end;
  end;
  Result := WarrAttackTarget(m_wHitMode);
end;

function THeroObject.WizardAttackTarget(): Boolean; {ʦ}
var
  nSelectMagic: Integer;
  UserMagic: pTUserMagic;
  dwDelayTime: LongWord;
begin
  Result := False;
  m_wHitMode := 0;
  if m_nSelectMagic > 0 then begin
    UserMagic := FindMagic(m_nSelectMagic);
    if UserMagic <> nil then begin
      Result := ClientSpellXY(UserMagic, m_TargetCret.m_nCurrX, m_TargetCret.m_nCurrY, m_TargetCret); //ʹħ
      Exit;
    end;
  end;
  Result := WarrAttackTarget(m_wHitMode);
end;

function THeroObject.TaoistAttackTarget(): Boolean; {ʿ}
var
  nSelectMagic: Integer;
  UserMagic: pTUserMagic;
  nIndex: Integer;
  dwDelayTime: LongWord;
begin
  Result := False;
  m_wHitMode := 0;
  if m_nSelectMagic > 0 then begin
    case m_nSelectMagic of
      SKILL_FIRECHARM {13},
        SKILL_HANGMAJINBUB {14},
        SKILL_DEJIWONHO {15},
        SKILL_HOLYSHIELD {16},
        SKILL_SKELLETON {17},
        SKILL_CLOAK {18},
        SKILL_BIGCLOAK {19},
        SKILL_52, {52}
        SKILL_57: begin
          if not CheckUserItemType(1) then begin //
            nIndex := GetUserItemList(1);
            if nIndex >= 0 then begin
              UseItem(1, nIndex);
            end;
          end;
        end;
      SKILL_AMYOUNSUL, SKILL_GROUPAMYOUNSUL: begin //
          if not CheckUserItemType(2) then begin
            nIndex := GetUserItemList(2);
            if nIndex >= 0 then begin
              UseItem(2, nIndex);
            end;
          end;
        end;
    end;
    UserMagic := FindMagic(m_nSelectMagic);
    if UserMagic <> nil then begin
      Result := ClientSpellXY(UserMagic, m_TargetCret.m_nCurrX, m_TargetCret.m_nCurrY, m_TargetCret); //ʹħ
      Exit;
    end;
  end;
  Result := WarrAttackTarget(m_wHitMode);
end;

function THeroObject.CheckUserMagic(wMagIdx: Word): pTUserMagic;
var
  I: Integer;
begin
  Result := nil;
  for I := 0 to m_MagicList.Count - 1 do begin
    if pTUserMagic(m_MagicList.Items[I]).MagicInfo.wMagicId = wMagIdx then begin
      Result := pTUserMagic(m_MagicList.Items[I]);
      Break;
    end;
  end;
end;

function THeroObject.CheckTargetXYCount(nX, nY, nRange: Integer): Integer;
var
  BaseObject: TBaseObject;
  I, nC, n10: Integer;
begin
  Result := 0;
  n10 := nRange;
  for I := 0 to m_VisibleActors.Count - 1 do begin
    BaseObject := TBaseObject(pTVisibleBaseObject(m_VisibleActors.Items[I]).BaseObject);
    if BaseObject <> nil then begin
      if not BaseObject.m_boDeath then begin
        if IsProperTarget(BaseObject) and
          (not BaseObject.m_boHideMode or m_boCoolEye) then begin
          nC := abs(nX - BaseObject.m_nCurrX) + abs(nY - BaseObject.m_nCurrY);
          if nC <= n10 then begin
            Inc(Result);
            //if Result > 2 then break;
          end;
        end;
      end;
    end;
  end;
end;

{ʿ}
function THeroObject.CheckItemType(nItemType: Integer; StdItem: pTStdItem): Boolean;
begin
  Result := False;
  case nItemType of
    1: begin
        if (StdItem.StdMode = 25) and (StdItem.Shape = 5) then Result := True;
      end;
    2: begin
        if (StdItem.StdMode = 25) and (StdItem.Shape <= 2) then Result := True;
      end;
  end;
end;

function THeroObject.CheckUserItemType(nItemType: Integer): Boolean;
var
  UserItem: pTUserItem;
  StdItem: pTStdItem;
begin
  Result := False;
  if m_UseItems[U_ARMRINGL {U_BUJUK}].wIndex > 0 then begin
    StdItem := UserEngine.GetStdItem(m_UseItems[U_ARMRINGL {U_BUJUK}].wIndex);
    if StdItem <> nil then begin
      Result := CheckItemType(nItemType, StdItem);
    end;
  end;
end;

function THeroObject.UseItem(nItemType, nIndex: Integer): Boolean; //Զ
var
  UserItem: pTUserItem;
  AddUserItem: pTUserItem;
  StdItem: pTStdItem;
begin
  Result := False;
  if (nIndex >= 0) and (nIndex < m_ItemList.Count) then begin
    UserItem := m_ItemList.Items[nIndex];
    if m_UseItems[U_ARMRINGL {U_BUJUK}].wIndex > 0 then begin
      StdItem := UserEngine.GetStdItem(m_UseItems[U_ARMRINGL {U_BUJUK}].wIndex);
      if StdItem <> nil then begin
        if CheckItemType(nItemType, StdItem) then begin
          Result := True;
        end else begin
          m_ItemList.Delete(nIndex);
          New(AddUserItem);
          AddUserItem^ := m_UseItems[U_ARMRINGL {U_BUJUK}];
          if AddItemToBag(AddUserItem) then begin
            m_UseItems[U_ARMRINGL {U_BUJUK}] := UserItem^;
            SendChangeItems(U_ARMRINGL, U_ARMRINGL, UserItem, AddUserItem);
            Dispose(UserItem);
            Result := True;
          end else m_ItemList.Add(UserItem);
        end;
      end else begin
        m_ItemList.Delete(nIndex);
        m_UseItems[U_ARMRINGL {U_BUJUK}] := UserItem^;
        SendChangeItems(U_ARMRINGL, U_ARMRINGL, UserItem, nil);
        Dispose(UserItem);
        Result := True;
      end;
    end else begin
      m_ItemList.Delete(nIndex);
      m_UseItems[U_ARMRINGL {U_BUJUK}] := UserItem^;
      SendChangeItems(U_ARMRINGL, U_ARMRINGL, UserItem, nil);
      Dispose(UserItem);
      Result := True;
    end;
  end;
  //SendUseitems();
  //ClientQueryBagItems;
end;

//ǷзͶ
//nType Ϊָ 1 Ϊ 2 Ϊҩ
function THeroObject.GetUserItemList(nItemType: Integer): Integer;
var
  I: Integer;
  UserItem: pTUserItem;
  StdItem: pTStdItem;
begin
  Result := -1;
  for I := 0 to m_ItemList.Count - 1 do begin
    UserItem := m_ItemList.Items[I];
    StdItem := UserEngine.GetStdItem(UserItem.wIndex);
    if StdItem <> nil then begin
      if CheckItemType(nItemType, StdItem) then begin
        Result := I;
        Break;
      end;
    end;
  end;
end;

function THeroObject.AttackTarget(): Boolean;
begin
  Result := False;
  if m_btStatus = 2 then Exit;
  m_dwTargetFocusTick := GetTickCount();
  case m_btJob of
    0: begin
        if Integer(GetTickCount - m_dwHitTick) > g_Config.dwHeroWarrorAttackTime then begin
          m_dwHitTick := GetTickCount();
          Result := WarrorAttackTarget;
        end;
      end;
    1: begin
        if Integer(GetTickCount - m_dwHitTick) > g_Config.dwHeroWizardAttackTime then begin
          m_dwHitTick := GetTickCount();
          Result := WizardAttackTarget;
        end;
      end;
    2: begin
        if Integer(GetTickCount - m_dwHitTick) > g_Config.dwHeroTaoistAttackTime then begin
          m_dwHitTick := GetTickCount();
          Result := TaoistAttackTarget;
        end;
      end;
  end;
end;

procedure THeroObject.SearchMagic();
var
  UserMagic: pTUserMagic;
begin
  m_nSelectMagic := SelectMagic;
  if m_nSelectMagic > 0 then begin
    UserMagic := FindMagic(m_nSelectMagic);
    if UserMagic <> nil then begin
      m_boIsUseAttackMagic := IsUseAttackMagic;
    end else begin
      m_boIsUseAttackMagic := False;
    end;
  end else begin
    m_boIsUseAttackMagic := False;
  end;
end;

function THeroObject.IsSearchTarget: Boolean;
begin
  Result := False;
  if m_TargetCret = Self then m_TargetCret := nil;
  if (m_TargetCret = nil) or ((GetTickCount - m_dwSearchEnemyTick) > 8000) then begin
    m_dwSearchEnemyTick := GetTickCount;
    Result := True;
    Exit;
  end;
  if GetTickCount - m_dwSearchEnemyTick < 1000 then Exit;
  m_dwSearchEnemyTick := GetTickCount;
  Result := True;
  {case m_btJob of
    0: begin
        if (m_TargetCret <> nil) and ((abs(m_TargetCret.m_nCurrX - m_nCurrX) > 1) or (abs(m_TargetCret.m_nCurrY - m_nCurrY) > 1)) and (CheckTargetXYCount(m_nCurrX, m_nCurrY, 1) >= 1) then begin
          m_dwSearchEnemyTick := GetTickCount;
          Result := True;
          Exit;
        end;
      end;
    1, 2: begin
        if m_boIsUseAttackMagic then begin
          if (m_TargetCret <> nil) and ((abs(m_TargetCret.m_nCurrX - m_nCurrX) > 3) or (abs(m_TargetCret.m_nCurrY - m_nCurrY) > 3)) and (CheckTargetXYCount(m_nCurrX, m_nCurrY, 1) > 0) then begin
            m_dwSearchEnemyTick := GetTickCount;
            Result := True;
            Exit;
          end;
        end else begin
          if (m_TargetCret <> nil) and ((abs(m_TargetCret.m_nCurrX - m_nCurrX) > 1) or (abs(m_TargetCret.m_nCurrY - m_nCurrY) > 1)) and (CheckTargetXYCount(m_nCurrX, m_nCurrY, 1) >= 2) then begin
            m_dwSearchEnemyTick := GetTickCount;
            Result := True;
            Exit;
          end;
        end;
      end;
  end; }
end;

function THeroObject.WearFirDragon: Boolean;
var
  StdItem: pTStdItem;
begin
  Result := False;
  if m_UseItems[U_BUJUK].wIndex > 0 then begin
    StdItem := UserEngine.GetStdItem(m_UseItems[U_BUJUK].wIndex);
    if (StdItem <> nil) and (StdItem.StdMode = 25) and (StdItem.Shape = 9) then begin
      Result := True;
    end;
  end;
end;

procedure THeroObject.RepairFirDragon(btType: Byte; nItemIdx: Integer; sItemName: string);
var
  I, n14: Integer;
  UserItem: pTUserItem;
  StdItem, StdItem20: pTStdItem;
  sUserItemName: string;
  boRepairOK: Boolean;
  ItemList: TList;
  OldDura: Word;
begin
  boRepairOK := False;
  ItemList := nil;
  StdItem := nil;
  UserItem := nil;
  n14 := -1;
  if (m_Master <> nil) and WearFirDragon then begin
    if m_UseItems[U_BUJUK].Dura < m_UseItems[U_BUJUK].DuraMax then begin
      OldDura := m_UseItems[U_BUJUK].Dura;
      case btType of
        2: ItemList := m_Master.m_ItemList;
        4: ItemList := m_ItemList;
      end;
      if ItemList <> nil then begin
        for I := 0 to ItemList.Count - 1 do begin
          UserItem := ItemList.Items[I];
          if (UserItem <> nil) and (UserItem.MakeIndex = nItemIdx) then begin
            //ȡԶƷ
            sUserItemName := '';
            if UserItem.btValue[13] = 1 then
              sUserItemName := ItemUnit.GetCustomItemName(UserItem.MakeIndex, UserItem.wIndex);
            if sUserItemName = '' then
              sUserItemName := UserEngine.GetStdItemName(UserItem.wIndex);
            StdItem := UserEngine.GetStdItem(UserItem.wIndex);
            if StdItem <> nil then begin
              if CompareText(sUserItemName, sItemName) = 0 then begin
                n14 := I;
                Break;
              end;
            end;
          end;
          UserItem := nil;
        end;
        if (StdItem <> nil) and (UserItem <> nil) and (StdItem.StdMode = 42) then begin
          Inc(m_UseItems[U_BUJUK].Dura, UserItem.DuraMax);
          boRepairOK := True;
          case btType of
            2: m_Master.DelBagItem(n14);
            4: DelBagItem(n14);
          end;
        end;
      end;
    end;
  end;
  if boRepairOK then begin
    if OldDura <> m_UseItems[U_BUJUK].Dura then
      SendMsg(Self, RM_HERODURACHANGE, U_BUJUK, m_UseItems[U_BUJUK].Dura, m_UseItems[U_BUJUK].DuraMax, 0, '');
    SendDefMessage(SM_REPAIRFIRDRAGON_OK, btType, 0, 0, 0, '');
  end else begin
    SendDefMessage(SM_REPAIRFIRDRAGON_FAIL, btType, 0, 0, 0, '');
  end;
end;

procedure THeroObject.Run;
var
  nX, nY: Integer;
begin
  if not m_boGhost and
    not m_boDeath and
    not m_boFixedHideMode and
    not m_boStoneMode and
    (m_wStatusTimeArr[POISON_STONE] = 0) then begin
    if Think then begin
      inherited;
      Exit;
    end;

    if not m_boStartUseSpell then begin
      if m_nFirDragonPoint < g_Config.nMaxFirDragonPoint then begin
        if GetTickCount() - m_dwAddFirDragonTick > 1000 * 3 then begin
          m_dwAddFirDragonTick := GetTickCount();
          if WearFirDragon and (m_UseItems[U_BUJUK].Dura > 0) then begin
            if m_UseItems[U_BUJUK].Dura >= g_Config.nDecFirDragonPoint then begin
              Dec(m_UseItems[U_BUJUK].Dura, g_Config.nDecFirDragonPoint);
            end else begin
              m_UseItems[U_BUJUK].Dura := 0;
            end;
            Inc(m_nFirDragonPoint, g_Config.nAddFirDragonPoint);
            SendMsg(Self, RM_HERODURACHANGE, U_BUJUK, m_UseItems[U_BUJUK].Dura, m_UseItems[U_BUJUK].DuraMax, 0, '');
            SendMsg(Self, RM_FIRDRAGONPOINT, g_Config.nMaxFirDragonPoint, m_nFirDragonPoint, 0, 0, '');
          end;
        end;
      end;
    end else begin
      if m_boStartUseSpell and (m_nStartUseSpell >= 3) then begin
        m_nStartUseSpell := 0;
        m_boStartUseSpell := False;
      //MainOutMessage('m_nStartUseSpell >= 3');
      end;
      if m_boStartUseSpell and (GetTickCount - m_dwStartUseSpellTick > 1000 * 3) then begin
        m_nStartUseSpell := 0;
        m_boStartUseSpell := False;
      //MainOutMessage('GetTickCount - m_dwStartUseSpellTick > 1000 * 3');
      end;
      SendMsg(Self, RM_FIRDRAGONPOINT, g_Config.nMaxFirDragonPoint, m_nFirDragonPoint, 0, 0, '');
    end;

    if m_boFireHitSkill and ((GetTickCount - m_dwLatestFireHitTick) > 20 * 1000) then begin
      m_boFireHitSkill := False;
      SysMsg(sSpiritsGone, c_Red, t_Hint);
    end;
    {if IsSearchTarget then } SearchTarget(); //Ŀ
    m_dwWalkWait := 10;
    m_nWalkSpeed := 10;
    if m_boWalkWaitLocked then begin
      if (GetTickCount - m_dwWalkWaitTick) > m_dwWalkWait then begin
        m_boWalkWaitLocked := False;
      end;
    end;
    if not m_boWalkWaitLocked and (Integer(GetTickCount - m_dwWalkTick) > m_nWalkSpeed) then begin
      m_dwWalkTick := GetTickCount();
      if m_btRaceServer <> RC_HEROOBJECT then begin
        Inc(m_nWalkCount);
        if m_nWalkCount > m_nWalkStep then begin
          m_nWalkCount := 0;
          m_boWalkWaitLocked := True;
          m_dwWalkWaitTick := GetTickCount();
        end;
      end;
      if not m_boRunAwayMode then begin
        if not m_boNoAttackMode then begin
          if m_boProtectStatus then begin
            if (abs(m_nCurrX - m_nProtectTargetX) > 10) or (abs(m_nCurrY - m_nProtectTargetY) > 10) then begin
              m_TargetCret := nil;
              SpaceMove(m_PEnvir.sMapName, m_nProtectTargetX, m_nProtectTargetY, 1);
            end;
          end;
          if m_TargetCret <> nil then begin
            if m_boStartUseSpell then begin
              m_nFirDragonPoint := 0;
              m_nSelectMagic := GetTogetherUseSpell;
              SendMsg(m_TargetCret, RM_GOTETHERUSESPELL, m_nSelectMagic, m_TargetCret.m_nCurrX, m_TargetCret.m_nCurrY, 0, '');
            end else begin
              SearchMagic();
            end;
            //if not m_boStartUseSpell then begin
            if IsNeedAvoid then begin
              AutoAvoid();
              inherited;
              Exit;
            end else begin
              if IsNeedGotoXY then begin
                GotoTargetXY(m_TargetCret.m_nCurrX, m_TargetCret.m_nCurrY);
                inherited;
                Exit;
              end;
            end;
            //end;
            if AttackTarget then begin
              m_boStartUseSpell := False;
              inherited;
              Exit;
            end else begin
              if m_boStartUseSpell then begin
                Inc(m_nStartUseSpell);
              end;
            end;
          end else begin
            if not m_boProtectStatus then begin
              m_nTargetX := -1;
            end;
          end;
        end;
        if m_TargetCret <> nil then begin
          m_nTargetX := m_TargetCret.m_nCurrX;
          m_nTargetY := m_TargetCret.m_nCurrY;
        end;
        if SearchIsPickUpItem then begin
          SearchPickUpItem(500);
          inherited;
          Exit;
        end;
        if m_Master <> nil then begin
          if m_boProtectStatus then begin
            {if (abs(m_nCurrX - m_nProtectTargetX) > 10) or (abs(m_nCurrY - m_nProtectTargetY) > 10) then begin //Χ
              m_nTargetX := m_nProtectTargetX;
              m_nTargetY := m_nProtectTargetY;
              m_TargetCret := nil;
              SpaceMove(m_PEnvir.sMapName, m_nTargetX, m_nTargetY, 1);
            end else}
            if (abs(m_nCurrX - m_nProtectTargetX) > 5) or (abs(m_nCurrY - m_nProtectTargetY) > 5) then begin
              m_nTargetX := m_nProtectTargetX;
              m_nTargetY := m_nProtectTargetY;
              m_TargetCret := nil;
            end else begin
              m_nTargetX := -1;
            end;
          end else begin
            if (m_TargetCret = nil) and not m_boProtectStatus then begin
              m_Master.GetBackPosition(nX, nY);
              if (abs(m_nTargetX - nX) > 1) or (abs(m_nTargetY - nY {nX}) > 1) then begin
                m_nTargetX := nX;
                m_nTargetY := nY;
                if (abs(m_nCurrX - nX) <= 2) and (abs(m_nCurrY - nY) <= 2) then begin
                  if m_PEnvir.GetMovingObject(nX, nY, True) <> nil then begin
                    m_nTargetX := m_nCurrX;
                    m_nTargetY := m_nCurrY;
                  end;
                end;
              end;
            end; //if m_TargetCret = nil then begin
          end;
          if (not m_Master.m_boSlaveRelax) and (not m_boProtectStatus) and
            ((m_PEnvir <> m_Master.m_PEnvir) or
            (abs(m_nCurrX - m_Master.m_nCurrX) > 20) or
            (abs(m_nCurrY - m_Master.m_nCurrY) > 20)) then begin
            SpaceMove(m_Master.m_PEnvir.sMapName, m_nTargetX, m_nTargetY, 1);
          end;
        end; //if m_Master <> nil then begin
      end else begin
        if (m_dwRunAwayTime > 0) and ((GetTickCount - m_dwRunAwayStart) > m_dwRunAwayTime) then begin
          m_boRunAwayMode := False;
          m_dwRunAwayTime := 0;
        end;
      end;
      if (m_Master <> nil) and m_Master.m_boSlaveRelax then begin
        inherited;
        Exit;
      end;
      if m_TargetCret = nil then begin
        if m_nTargetX <> -1 then begin
          if (abs(m_nCurrX - m_nTargetX) > 1) or (abs(m_nCurrY - m_nTargetY) > 1) then begin
            GotoTargetXY(m_nTargetX, m_nTargetY);
          end;
        end else begin
          Wondering();
        end;
      end;
    end;
  end;
  inherited;
end;

procedure THeroObject.RecalcAbilitys;
begin
  inherited;
  if m_btRaceServer = RC_HEROOBJECT then begin
    SendUpdateMsg(Self, RM_CHARSTATUSCHANGED, m_nHitSpeed, m_nCharStatus, 0, 0, '');
  end;
end;

procedure THeroObject.Die; //Ӣ
begin
  inherited;
  if (m_btRaceServer = RC_HEROOBJECT) and (m_Master <> nil) then begin //ӢϢ
    SendMsg(Self, RM_HERODEATH, 0, 0, 0, 0, '');
    UserEngine.SaveHeroRcd(TPlayObject(m_Master));
    TPlayObject(m_Master).m_MyHero := nil;
  end;
  m_Master := nil;
end;

function THeroObject.FindMagic(wMagIdx: Word): pTUserMagic;
var
  UserMagic: pTUserMagic;
  I: Integer;
begin
  Result := nil;
  for I := 0 to m_MagicList.Count - 1 do begin
    UserMagic := m_MagicList.Items[I];
    if UserMagic.MagicInfo.wMagicId = wMagIdx then begin
      Result := UserMagic;
      Break;
    end;
  end;
end;

function THeroObject.CheckTakeOnItems(nWhere: Integer; var StdItem: TStdItem): Boolean;
  function GetUserItemWeitht(nWhere: Integer): Integer;
  var
    I: Integer;
    n14: Integer;
    StdItem: pTStdItem;
  begin
    n14 := 0;
    for I := Low(THumanUseItems) to High(THumanUseItems) do begin
      if (nWhere = -1) or (not (I = nWhere) and not (I = 1) and not (I = 2)) then begin
        StdItem := UserEngine.GetStdItem(m_UseItems[I].wIndex);
        if StdItem <> nil then Inc(n14, StdItem.Weight);
      end;
    end;
    Result := n14;
  end;
var
  Castle: TUserCastle;
begin
  Result := False;
  if (StdItem.StdMode = 10) and (m_btGender <> 0) then begin
    SysMsg(sWearNotOfWoMan, c_Red, t_Hint);
    Exit;
  end;
  if (StdItem.StdMode = 11) and (m_btGender <> 1) then begin
    SysMsg(sWearNotOfMan, c_Red, t_Hint);
    Exit;
  end;
  if (nWhere = 1) or (nWhere = 2) then begin
    if StdItem.Weight > m_WAbil.MaxHandWeight then begin
      SysMsg(sHandWeightNot, c_Red, t_Hint);
      Exit;
    end;
  end else begin
    if (StdItem.Weight + GetUserItemWeitht(nWhere)) > m_WAbil.MaxWearWeight then begin
      SysMsg(sWearWeightNot, c_Red, t_Hint);
      Exit;
    end;
  end;
  Castle := g_CastleManager.IsCastleMember(Self);
  case StdItem.Need of //
    0: begin
        if m_Abil.Level >= StdItem.NeedLevel then begin
          Result := True;
        end else begin
          SysMsg(g_sLevelNot, c_Red, t_Hint);
        end;
      end;
    1: begin
        if HiWord(m_WAbil.DC) >= StdItem.NeedLevel then begin
          Result := True;
        end else begin
          SysMsg(g_sDCNot, c_Red, t_Hint);
        end;
      end;
    10: begin
        if (m_btJob = LoWord(StdItem.NeedLevel)) and (m_Abil.Level >= HiWord(StdItem.NeedLevel)) then begin
          Result := True;
        end else begin
          SysMsg(g_sJobOrLevelNot, c_Red, t_Hint);
        end;
      end;
    11: begin
        if (m_btJob = LoWord(StdItem.NeedLevel)) and (HiWord(m_WAbil.DC) >= HiWord(StdItem.NeedLevel)) then begin
          Result := True;
        end else begin
          SysMsg(g_sJobOrDCNot, c_Red, t_Hint);
        end;
      end;
    12: begin
        if (m_btJob = LoWord(StdItem.NeedLevel)) and (HiWord(m_WAbil.MC) >= HiWord(StdItem.NeedLevel)) then begin
          Result := True;
        end else begin
          SysMsg(g_sJobOrMCNot, c_Red, t_Hint);
        end;
      end;
    13: begin
        if (m_btJob = LoWord(StdItem.NeedLevel)) and (HiWord(m_WAbil.SC) >= HiWord(StdItem.NeedLevel)) then begin
          Result := True;
        end else begin
          SysMsg(g_sJobOrSCNot, c_Red, t_Hint);
        end;
      end;
    2: begin
        if HiWord(m_WAbil.MC) >= StdItem.NeedLevel then begin
          Result := True;
        end else begin
          SysMsg(g_sMCNot, c_Red, t_Hint);
        end;
      end;
    3: begin
        if HiWord(m_WAbil.SC) >= StdItem.NeedLevel then begin
          Result := True;
        end else begin
          SysMsg(g_sSCNot, c_Red, t_Hint);
        end;
      end;
    4: begin
        if m_btReLevel >= StdItem.NeedLevel then begin
          Result := True;
        end else begin
          SysMsg(g_sReNewLevelNot, c_Red, t_Hint);
        end;
      end;
    40: begin
        if m_btReLevel >= LoWord(StdItem.NeedLevel) then begin
          if m_Abil.Level >= HiWord(StdItem.NeedLevel) then begin
            Result := True;
          end else begin
            SysMsg(g_sLevelNot, c_Red, t_Hint);
          end;
        end else begin
          SysMsg(g_sReNewLevelNot, c_Red, t_Hint);
        end;
      end;
    41: begin
        if m_btReLevel >= LoWord(StdItem.NeedLevel) then begin
          if HiWord(m_WAbil.DC) >= HiWord(StdItem.NeedLevel) then begin
            Result := True;
          end else begin
            SysMsg(g_sDCNot, c_Red, t_Hint);
          end;
        end else begin
          SysMsg(g_sReNewLevelNot, c_Red, t_Hint);
        end;
      end;
    42: begin
        if m_btReLevel >= LoWord(StdItem.NeedLevel) then begin
          if HiWord(m_WAbil.MC) >= HiWord(StdItem.NeedLevel) then begin
            Result := True;
          end else begin
            SysMsg(g_sMCNot, c_Red, t_Hint);
          end;
        end else begin
          SysMsg(g_sReNewLevelNot, c_Red, t_Hint);
        end;
      end;
    43: begin
        if m_btReLevel >= LoWord(StdItem.NeedLevel) then begin
          if HiWord(m_WAbil.SC) >= HiWord(StdItem.NeedLevel) then begin
            Result := True;
          end else begin
            SysMsg(g_sSCNot, c_Red, t_Hint);
          end;
        end else begin
          SysMsg(g_sReNewLevelNot, c_Red, t_Hint);
        end;
      end;
    44: begin
        if m_btReLevel >= LoWord(StdItem.NeedLevel) then begin
          if m_btCreditPoint >= HiWord(StdItem.NeedLevel) then begin
            Result := True;
          end else begin
            SysMsg(g_sCreditPointNot, c_Red, t_Hint);
          end;
        end else begin
          SysMsg(g_sReNewLevelNot, c_Red, t_Hint);
        end;
      end;
    5: begin
        if m_btCreditPoint >= StdItem.NeedLevel then begin
          Result := True;
        end else begin
          SysMsg(g_sCreditPointNot, c_Red, t_Hint);
        end;
      end;
    6: begin
        if (m_MyGuild <> nil) then begin
          Result := True;
        end else begin
          SysMsg(g_sGuildNot, c_Red, t_Hint);
        end;
      end;
    60: begin
        if (m_MyGuild <> nil) and (m_nGuildRankNo = 1) then begin
          Result := True;
        end else begin
          SysMsg(g_sGuildMasterNot, c_Red, t_Hint);
        end;
      end;
    7: begin
        //      if (m_MyGuild <> nil) and (UserCastle.m_MasterGuild = m_MyGuild) then begin
        if (m_MyGuild <> nil) and (Castle <> nil) then begin
          Result := True;
        end else begin
          SysMsg(g_sSabukHumanNot, c_Red, t_Hint);
        end;
      end;
    70: begin
        //      if (m_MyGuild <> nil) and (UserCastle.m_MasterGuild = m_MyGuild) and (m_nGuildRankNo = 1) then begin
        if (m_MyGuild <> nil) and (Castle <> nil) and (m_nGuildRankNo = 1) then begin
          if m_Abil.Level >= StdItem.NeedLevel then begin
            Result := True;
          end else begin
            SysMsg(g_sLevelNot, c_Red, t_Hint);
          end;
        end else begin
          SysMsg(g_sSabukMasterManNot, c_Red, t_Hint);
        end;
      end;
    8: begin
        if m_nMemberType <> 0 then begin
          Result := True;
        end else begin
          SysMsg(g_sMemberNot, c_Red, t_Hint);
        end;
      end;
    81: begin
        if (m_nMemberType = LoWord(StdItem.NeedLevel)) and (m_nMemberLevel >= HiWord(StdItem.NeedLevel)) then begin
          Result := True;
        end else begin
          SysMsg(g_sMemberTypeNot, c_Red, t_Hint);
        end;
      end;
    82: begin
        if (m_nMemberType >= LoWord(StdItem.NeedLevel)) and (m_nMemberLevel >= HiWord(StdItem.NeedLevel)) then begin
          Result := True;
        end else begin
          SysMsg(g_sMemberTypeNot, c_Red, t_Hint);
        end;
      end;
  end;
  //if not Result then SysMsg(g_sCanottWearIt,c_Red,t_Hint);
end;

function THeroObject.GetSpellPoint(UserMagic: pTUserMagic): Integer;
begin
  Result := Round(UserMagic.MagicInfo.wSpell / (UserMagic.MagicInfo.btTrainLv + 1) * (UserMagic.btLevel + 1)) + UserMagic.MagicInfo.btDefSpell;
end;

function THeroObject.DoMotaebo(nDir: Byte; nMagicLevel: Integer): Boolean;
  function CanMotaebo(BaseObject: TBaseObject): Boolean;
  var
    nC: Integer;
  begin
    Result := False;
    if (m_Abil.Level > BaseObject.m_Abil.Level) and (not BaseObject.m_boStickMode) then begin
      nC := m_Abil.Level - BaseObject.m_Abil.Level;
      if Random(20) < ((nMagicLevel * 4) + 6 + nC) then begin
        if IsProperTarget(BaseObject) then Result := True;
      end;
    end;
  end;
var
  bo35: Boolean;
  I, n20, n24, n28: Integer;
  PoseCreate: TBaseObject;
  BaseObject_30: TBaseObject;
  BaseObject_34: TBaseObject;
  nX, nY: Integer;
begin
  Result := False;
  bo35 := True;
  m_btDirection := nDir;
  BaseObject_34 := nil;
  n24 := nMagicLevel + 1;
  n28 := n24;
  PoseCreate := GetPoseCreate();
  if PoseCreate <> nil then begin
    for I := 0 to _MAX(2, nMagicLevel + 1) do begin
      PoseCreate := GetPoseCreate();
      if PoseCreate <> nil then begin
        n28 := 0;
        if not CanMotaebo(PoseCreate) then Break;
        if nMagicLevel >= 3 then begin
          if m_PEnvir.GetNextPosition(m_nCurrX, m_nCurrY, m_btDirection, 2, nX, nY) then begin
            BaseObject_30 := m_PEnvir.GetMovingObject(nX, nY, True);
            if (BaseObject_30 <> nil) and CanMotaebo(BaseObject_30) then
              BaseObject_30.CharPushed(m_btDirection, 1);
          end;
        end;
        BaseObject_34 := PoseCreate;
        if PoseCreate.CharPushed(m_btDirection, 1) <> 1 then Break;
        GetFrontPosition(nX, nY);
        if m_PEnvir.MoveToMovingObject(m_nCurrX, m_nCurrY, Self, nX, nY, False) > 0 then begin
          m_nCurrX := nX;
          m_nCurrY := nY;
          SendRefMsg(RM_RUSH, nDir, m_nCurrX, m_nCurrY, 0, '');
          bo35 := False;
          Result := True;
        end;
        Dec(n24);
      end; //004C32D7  if PoseCreate <> nil  then begin
    end; //004C32DD for i:=0 to _MAX(2,nMagicLevel + 1) do begin
  end else begin //004C32E8 if PoseCreate <> nil  then begin
    bo35 := False;
    for I := 0 to _MAX(2, nMagicLevel + 1) do begin
      GetFrontPosition(nX, nY); //sub_004B2790
      if m_PEnvir.MoveToMovingObject(m_nCurrX, m_nCurrY, Self, nX, nY, False) > 0 then begin
        m_nCurrX := nX;
        m_nCurrY := nY;
        SendRefMsg(RM_RUSH, nDir, m_nCurrX, m_nCurrY, 0, '');
        Dec(n28);
      end else begin
        if m_PEnvir.CanWalk(nX, nY, True) then n28 := 0
        else begin
          bo35 := True;
          Break;
        end;
      end;
    end;
  end;
  if (BaseObject_34 <> nil) then begin
    if n24 < 0 then n24 := 0;
    n20 := Random((n24 + 1) * 10) + ((n24 + 1) * 10);
    n20 := BaseObject_34.GetHitStruckDamage(Self, n20);
    BaseObject_34.StruckDamage(n20);
    BaseObject_34.SendRefMsg(RM_STRUCK, n20, BaseObject_34.m_WAbil.HP, BaseObject_34.m_WAbil.MaxHP, Integer(Self), '');
    if BaseObject_34.m_btRaceServer <> RC_PLAYOBJECT then begin
      BaseObject_34.SendMsg(BaseObject_34, RM_STRUCK, n20, BaseObject_34.m_WAbil.HP, BaseObject_34.m_WAbil.MaxHP, Integer(Self), '');
    end;
  end;
  if bo35 then begin
    GetFrontPosition(nX, nY);
    SendRefMsg(RM_RUSHKUNG, m_btDirection, nX, nY, 0, '');
    SysMsg(sMateDoTooweak {ײ}, c_Red, t_Hint);
  end;
  if n28 > 0 then begin
    if n24 < 0 then n24 := 0;
    n20 := Random(n24 * 10) + ((n24 + 1) * 3);
    n20 := GetHitStruckDamage(Self, n20);
    StruckDamage(n20);
    SendRefMsg(RM_STRUCK, n20, m_WAbil.HP, m_WAbil.MaxHP, 0, '');
  end;
end;

function THeroObject.ClientSpellXY(UserMagic: pTUserMagic; nTargetX, nTargetY: Integer;
  TargeTBaseObject: TBaseObject): Boolean;
var
  nSpellPoint: Integer;
  n14: Integer;
  BaseObject: TBaseObject;
  dwCheckTime: LongWord;
  boIsWarrSkill: Boolean;
resourcestring
  sDisableMagicCross = 'ǰͼʹã%s';
begin
  Result := False;
  if not m_boCanSpell then Exit;
  if m_boDeath or ((m_wStatusTimeArr[POISON_STONE {5}] {0x6A} <> 0) and not g_Config.ClientConf.boParalyCanSpell) then Exit; //

  if m_PEnvir <> nil then begin
    if not m_PEnvir.AllowMagics(UserMagic.MagicInfo.sMagicName) then begin
      SysMsg(Format(sDisableMagicCross, [UserMagic.MagicInfo.sMagicName]), c_Red, t_Notice);
      Exit;
    end;
  end;

  boIsWarrSkill := MagicManager.IsWarrSkill(UserMagic.wMagIdx);

  {if not boLateDelivery and not boIsWarrSkill then begin
    if not CheckActionStatus(wIdent, dwDelayTime) then begin
      m_boFilterAction := False;
      Exit;
    end;
    m_boFilterAction := True;
    dwCheckTime := GetTickCount - m_dwMagicAttackTick;
    if dwCheckTime < m_dwMagicAttackInterval then begin
      Inc(m_dwMagicAttackCount);
      dwDelayTime := m_dwMagicAttackInterval - dwCheckTime;
      if dwDelayTime > g_Config.dwMagicHitIntervalTime div 3 then begin
        if m_dwMagicAttackCount >= 4 then begin
          m_dwMagicAttackTick := GetTickCount();
          m_dwMagicAttackCount := 0;
          dwDelayTime := g_Config.dwMagicHitIntervalTime div 3;
          if m_boTestSpeedMode then
            TPlayObject(m_Master).SysMsg('(Ӣħæλ' + IntToStr(dwDelayTime), c_Red, t_Hint);
        end else m_dwMagicAttackCount := 0;
        Exit;
      end else begin
        if m_boTestSpeedMode then
          TPlayObject(m_Master).SysMsg('(Ӣħæ' + IntToStr(dwDelayTime), c_Red, t_Hint);
        Exit;
      end;
    end;
  end;}

  Dec(m_nSpellTick, 450);
  m_nSpellTick := _MAX(0, m_nSpellTick);

  if boIsWarrSkill then begin
    //m_dwMagicAttackInterval:=0;
    //m_dwMagicAttackInterval:=g_Config.dwMagicHitIntervalTime;
  end else begin
    m_dwMagicAttackInterval := UserMagic.MagicInfo.dwDelayTime + g_Config.dwMagicHitIntervalTime;
  end;
  m_dwMagicAttackTick := GetTickCount();
  case UserMagic.wMagIdx of //
    SKILL_ERGUM {12}: begin //ɱ
        if m_MagicErgumSkill <> nil then begin
          if not m_boUseThrusting then begin
            ThrustingOnOff(True);
            //SendSocket(nil, '+LNG');
          end else begin
            ThrustingOnOff(False);
            //SendSocket(nil, '+ULNG');
          end;
        end;
        Result := True;
      end;
    SKILL_BANWOL {25}: begin //䵶
        if m_MagicBanwolSkill <> nil then begin
          if not m_boUseHalfMoon then begin
            HalfMoonOnOff(True);
            //SendSocket(nil, '+WID');
          end else begin
            HalfMoonOnOff(False);
            //SendSocket(nil, '+UWID');
          end;
        end;
        Result := True;
      end;
    SKILL_FIRESWORD {26}: begin //һ𽣷
        if m_MagicFireSwordSkill <> nil then begin
          if AllowFireHitSkill then begin
            nSpellPoint := GetSpellPoint(UserMagic);
            if m_WAbil.MP >= nSpellPoint then begin
              if nSpellPoint > 0 then begin
                DamageSpell(nSpellPoint);
                HealthSpellChanged();
              end;
              //SendSocket(nil, '+FIR');
            end;
          end;
        end;
        Result := True;
      end;
    SKILL_MOOTEBO {27}: begin //Ұײ
        Result := True;
        if (GetTickCount - m_dwDoMotaeboTick) > 3 * 1000 then begin
          m_dwDoMotaeboTick := GetTickCount();
          m_btDirection := nTargetX;
          nSpellPoint := GetSpellPoint(UserMagic);
          if m_WAbil.MP >= nSpellPoint then begin
            if nSpellPoint > 0 then begin
              DamageSpell(nSpellPoint);
              HealthSpellChanged();
            end;
            if DoMotaebo(m_btDirection, UserMagic.btLevel) then begin
              if UserMagic.btLevel < 3 then begin
                if UserMagic.MagicInfo.TrainLevel[UserMagic.btLevel] < m_Abil.Level then begin
                  TrainSkill(UserMagic, Random(3) + 1);
                  if not CheckMagicLevelup(UserMagic) then begin
                    SendDelayMsg(Self,
                      RM_MAGIC_LVEXP,
                      0,
                      UserMagic.MagicInfo.wMagicId,
                      UserMagic.btLevel,
                      UserMagic.nTranPoint,
                      '', 1000);
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    SKILL_40: begin //˫ն µ
        if m_MagicCrsSkill <> nil then begin
          if not m_boCrsHitkill then begin
            SkillCrsOnOff(True);
            //SendSocket(nil, '+CRS');
          end else begin
            SkillCrsOnOff(False);
            //SendSocket(nil, '+UCRS');
          end;
        end;
        Result := True;
      end;
    42: begin //ն
        if m_Magic42Skill <> nil then begin
          if not m_bo42kill then begin
            Skill42OnOff(True);
            //SendSocket(nil, '+TWN');
          end else begin
            Skill42OnOff(False);
            //SendSocket(nil, '+UTWN');
          end;
        end;
        Result := True;
      end;
    43: begin //ƿս
        if m_Magic43Skill <> nil then begin
          if not m_bo43kill then begin
            Skill43OnOff(True);
            //SendSocket(nil, '+CID');
          end else begin
            Skill43OnOff(False);
            //SendSocket(nil, '+UCID');
          end;
        end;
        Result := True;
      end;
  else begin
      n14 := GetNextDirection(m_nCurrX, m_nCurrY, nTargetX, nTargetY);
      m_btDirection := n14;
      BaseObject := nil;
      //ĿɫĿΧΧĿ
      if UserMagic.wMagIdx in [60..65] then begin //ǺϻĿ
        if CretInNearXY(TargeTBaseObject, nTargetX, nTargetY, 6) then begin
          BaseObject := TargeTBaseObject;
          nTargetX := BaseObject.m_nCurrX;
          nTargetY := BaseObject.m_nCurrY;
        end;
      end else begin
        if CretInNearXY(TargeTBaseObject, nTargetX, nTargetY) then begin
          BaseObject := TargeTBaseObject;
          nTargetX := BaseObject.m_nCurrX;
          nTargetY := BaseObject.m_nCurrY;
        end;
      end;
      if not DoSpell(UserMagic, nTargetX, nTargetY, BaseObject) then begin
        //SendRefMsg(RM_MAGICFIREFAIL, 0, 0, 0, 0, '');
      end;
      Result := True;
    end;
  end;
end;

function THeroObject.DoSpell(UserMagic: pTUserMagic; nTargetX,
  nTargetY: Integer; BaseObject: TBaseObject): Boolean;
var
  nSpellPoint: Integer;
begin
  Result := False;
  try
    if not MagicManager.IsWarrSkill(UserMagic.wMagIdx) then begin
      nSpellPoint := GetSpellPoint(UserMagic);
      if nSpellPoint > 0 then begin
        if m_WAbil.MP < nSpellPoint then Exit;
        DamageSpell(nSpellPoint);
        HealthSpellChanged();
      end;
      Result := MagicManager.DoSpell(Self, UserMagic, nTargetX, nTargetY, BaseObject);
    end;
  except
    on E: Exception do begin
      MainOutMessage(Format('[Exception] THeroObject.DoSpell MagID:%d X:%d Y:%d', [UserMagic.wMagIdx, nTargetX, nTargetY]));
      MainOutMessage(E.Message);
    end;
  end;
end;

procedure THeroObject.MakeSaveRcd(var HumanRcd: THumDataInfo);
var
  I: Integer;
  HumData: pTHumData;
  HumItems: pTHumItems;
  HumAddItems: pTHumAddItems;
  BagItems: pTBagItems;
  HumMagics: pTHumMagics;
  UserMagic: pTUserMagic;
  StorageItems: pTStorageItems;
begin
  HumanRcd.Header.boIsHero := True;
  HumData := @HumanRcd.Data;
  HumData.sChrName := m_sCharName;
  HumData.sCurMap := m_sMapName;
  HumData.wCurX := m_nCurrX;
  HumData.wCurY := m_nCurrY;
  HumData.btDir := m_btDirection;
  HumData.btHair := m_btHair;
  HumData.btSex := m_btGender;
  HumData.btJob := m_btJob;
  HumData.nGold := 0;

  HumData.Abil.Level := m_Abil.Level;
  HumData.Abil.HP := m_Abil.HP;
  HumData.Abil.MP := m_Abil.MP;
  HumData.Abil.MaxHP := m_Abil.MaxHP;
  HumData.Abil.MaxMP := m_Abil.MaxMP;
  HumData.Abil.Exp := m_Abil.Exp;
  HumData.Abil.MaxExp := m_Abil.MaxExp;
  HumData.Abil.Weight := m_Abil.Weight;
  HumData.Abil.MaxWeight := m_Abil.MaxWeight;
  HumData.Abil.WearWeight := m_Abil.WearWeight;
  HumData.Abil.MaxWearWeight := m_Abil.MaxWearWeight;
  HumData.Abil.HandWeight := m_Abil.HandWeight;
  HumData.Abil.MaxHandWeight := m_Abil.MaxHandWeight;

  HumData.Abil.HP := m_WAbil.HP;
  HumData.Abil.MP := m_WAbil.MP;

  HumData.wStatusTimeArr := m_wStatusTimeArr;
  HumData.sHomeMap := m_sHomeMap;
  HumData.wHomeX := m_nHomeX;
  HumData.wHomeY := m_nHomeY;
  HumData.nPKPOINT := m_nPkPoint;
  HumData.BonusAbil := m_BonusAbil; // 08/09
  HumData.nBonusPoint := m_nBonusPoint; // 08/09
  //HumData.sStoragePwd := m_sStoragePwd;
  HumData.btCreditPoint := m_btCreditPoint;
  HumData.btReLevel := m_btReLevel;

  HumData.sMasterName := m_Master.m_sCharName;
  //HumData.boMaster := m_boMaster;
  //HumData.sDearName := m_sDearName;

  //HumData.nGameGold := m_nGameGold;
  //HumData.nGamePoint := m_nGamePoint;

  //if m_boAllowGroup then HumData.btAllowGroup := 1
  //else HumData.btAllowGroup := 0;
  //HumData.btF9 := btB2;
  HumData.btAttatckMode := m_btAttatckMode;
  HumData.btIncHealth := m_nIncHealth;
  HumData.btIncSpell := m_nIncSpell;
  HumData.btIncHealing := m_nIncHealing;
  HumData.btFightZoneDieCount := m_nFightZoneDieCount;
  //HumData.sAccount := m_sUserID;
  HumData.btEE := nC4;
  //HumData.boLockLogon := m_boLockLogon;
  //HumData.wContribution := m_wContribution;
  HumData.btEF := btC8;
  //HumData.nHungerStatus := m_nHungerStatus;
  //HumData.boAllowGuildReCall := m_boAllowGuildReCall;
  //HumData.wGroupRcallTime := m_wGroupRcallTime;
  HumData.dBodyLuck := m_dBodyLuck;
  //HumData.boAllowGroupReCall := m_boAllowGroupReCall;

  HumData.btLastOutStatus := m_btLastOutStatus; //2006-01-12 ˳״̬ 1Ϊ˳
  //HumData.wMasterCount := m_wMasterCount; //ʦͽ
  HumData.QuestFlag := m_QuestFlag;
  HumData.boHasHero := False;
  //HumData.boIsHero := True;
  HumData.btStatus := m_btStatus;

  HumItems := @HumanRcd.Data.HumItems;
  HumItems[U_DRESS] := m_UseItems[U_DRESS];
  HumItems[U_WEAPON] := m_UseItems[U_WEAPON];
  HumItems[U_RIGHTHAND] := m_UseItems[U_RIGHTHAND];

  HumItems[U_HELMET] := m_UseItems[U_NECKLACE];
  HumItems[U_NECKLACE] := m_UseItems[U_HELMET];

  HumItems[U_ARMRINGL] := m_UseItems[U_ARMRINGL];
  HumItems[U_ARMRINGR] := m_UseItems[U_ARMRINGR];
  HumItems[U_RINGL] := m_UseItems[U_RINGL];
  HumItems[U_RINGR] := m_UseItems[U_RINGR];

  HumAddItems := @HumanRcd.Data.HumAddItems;
  HumAddItems[U_BUJUK] := m_UseItems[U_BUJUK];
  HumAddItems[U_BELT] := m_UseItems[U_BELT];
  HumAddItems[U_BOOTS] := m_UseItems[U_BOOTS];
  HumAddItems[U_CHARM] := m_UseItems[U_CHARM];

  BagItems := @HumanRcd.Data.BagItems;
  for I := 0 to m_ItemList.Count - 1 do begin
    if I >= MAXHEROBAGITEM then Break;
    BagItems[I] := pTUserItem(m_ItemList.Items[I])^;
  end;
  HumMagics := @HumanRcd.Data.HumMagics;
  for I := 0 to m_MagicList.Count - 1 do begin
    if I >= MAXMAGIC then Break;
    UserMagic := m_MagicList.Items[I];
    HumMagics[I].wMagIdx := UserMagic.wMagIdx;
    HumMagics[I].btLevel := UserMagic.btLevel;
    HumMagics[I].btKey := UserMagic.btKey;
    HumMagics[I].nTranPoint := UserMagic.nTranPoint;
  end;
  {StorageItems := @HumanRcd.Data.StorageItems;
  for I := 0 to m_StorageItemList.Count - 1 do begin
    if I >= MAXBAGITEM then Break;
    StorageItems[I] := pTUserItem(m_StorageItemList.Items[I])^;
  end;}
end;

procedure THeroObject.Login();
var
  I: Integer;
  II: Integer;
  UserItem: pTUserItem;
  UserItem1: pTUserItem;
  StdItem: pTStdItem;
  s14: string;
  sItem: string;
  sIPaddr: string;
resourcestring
  sExceptionMsg = '[Exception] THeroObject::Login';
begin
  try
    //Ʒ
    if m_boNewHuman then begin
      New(UserItem);
      if UserEngine.CopyToUserItemFromName(g_Config.sHeroBasicDrug, UserItem) then begin
        m_ItemList.Add(UserItem);
      end else Dispose(UserItem);
      New(UserItem);
      if UserEngine.CopyToUserItemFromName(g_Config.sHeroWoodenSword, UserItem) then begin
        m_ItemList.Add(UserItem);
      end else Dispose(UserItem);
      New(UserItem);
      if m_btGender = 0 then
        sItem := g_Config.sHeroClothsMan
      else
        sItem := g_Config.sHeroClothsWoman;
      if UserEngine.CopyToUserItemFromName(sItem, UserItem) then begin
        m_ItemList.Add(UserItem);
      end else Dispose(UserItem);
    end;
    //鱳еƷǷϷ
    for I := m_ItemList.Count - 1 downto 0 do begin
      if m_ItemList.Count <= 0 then Break;
      UserItem := m_ItemList.Items[I];
      if UserEngine.GetStdItemName(UserItem.wIndex) = '' then begin
        Dispose(pTUserItem(m_ItemList.Items[I]));
        m_ItemList.Delete(I);
      end;
    end;
    //ϵƷǷʹù
    if g_Config.boCheckUserItemPlace then begin
      for I := Low(THumanUseItems) to High(THumanUseItems) do begin
        if m_UseItems[I].wIndex > 0 then begin
          StdItem := UserEngine.GetStdItem(m_UseItems[I].wIndex);
          if StdItem <> nil then begin
            if not CheckUserItems(I, StdItem) then begin
              New(UserItem);
              UserItem^ := m_UseItems[I];
              if not AddItemToBag(UserItem) then begin
                m_ItemList.Insert(0, UserItem);
              end;
              m_UseItems[I].wIndex := 0;
            end;
          end else m_UseItems[I].wIndex := 0;
        end;
      end;
    end;
    //鱳ǷиƷ
    for I := m_ItemList.Count - 1 downto 0 do begin
      if m_ItemList.Count <= 0 then Break;
      UserItem := m_ItemList.Items[I];
      s14 := UserEngine.GetStdItemName(UserItem.wIndex);
      for II := I - 1 downto 0 do begin
        UserItem1 := m_ItemList.Items[II];
        if (UserEngine.GetStdItemName(UserItem1.wIndex) = s14) and
          (UserItem.MakeIndex = UserItem1.MakeIndex) then begin
          m_ItemList.Delete(II);
          Break;
        end;
      end;
    end;
    for I := Low(m_dwStatusArrTick) to High(m_dwStatusArrTick) do begin
      if m_wStatusTimeArr[I] > 0 then
        m_dwStatusArrTick[I] := GetTickCount();
    end;
    {RecalcLevelAbilitys();
    RecalcAbilitys();
    m_Abil.MaxExp := GetLevelExp(m_Abil.Level);}
    if (g_ManageNPC <> nil) and (m_Master <> nil) then begin
      g_ManageNPC.GotoLable(TPlayObject(m_Master), '@HeroLogin', False);
    end;
    m_boFixedHideMode := False;
  except
    on E: Exception do begin
      MainOutMessage(sExceptionMsg);
      MainOutMessage(E.Message);
    end;
  end;
end;

end.

