unit ViewKernelInfo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Grids, M2Config, M2Share,TyFunc,
  Spin;

type
  TfrmViewKernelInfo = class(TForm)
    Timer: TTimer;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditLoadHumanDBCount: TEdit;
    EditLoadHumanDBErrorCoun: TEdit;
    EditSaveHumanDBCount: TEdit;
    EditHumanDBQueryID: TEdit;
    TabSheet2: TTabSheet;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    EditWinLotteryCount: TEdit;
    EditNoWinLotteryCount: TEdit;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    EditWinLotteryLevel1: TEdit;
    EditWinLotteryLevel2: TEdit;
    EditWinLotteryLevel3: TEdit;
    EditWinLotteryLevel4: TEdit;
    Label13: TLabel;
    EditWinLotteryLevel5: TEdit;
    Label14: TLabel;
    EditWinLotteryLevel6: TEdit;
    GroupBox4: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    EditItemNumber: TEdit;
    EditItemNumberEx: TEdit;
    TabSheet3: TTabSheet;
    GroupBox5: TGroupBox;
    Label15: TLabel;
    EditG_Val: TEdit;
    TabSheet4: TTabSheet;
    GroupBox6: TGroupBox;
    Label25: TLabel;
    EditAllocMemCount: TEdit;
    Label26: TLabel;
    EditAllocMemSize: TEdit;
    TabSheet5: TTabSheet;
    GroupBox7: TGroupBox;
    GridThread: TStringGrid;
    SpinEdit_G: TSpinEdit;
    Label16: TLabel;
    SpinEdit_A: TSpinEdit;
    EditA_Val: TEdit;
    Label17: TLabel;
    SpinEdit_I: TSpinEdit;
    EditI_Val: TEdit;
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpinEdit_GChange(Sender: TObject);
    procedure EditG_ValChange(Sender: TObject);
    procedure EditA_ValChange(Sender: TObject);
    procedure EditI_ValChange(Sender: TObject);
  private
    procedure GridThreadAdd(ThreadInfo: pTThreadInfo; Index: Integer);
    procedure ReShowGameVar();
  public
    procedure Open();
    { Public declarations }
  end;

var
  frmViewKernelInfo: TfrmViewKernelInfo;

implementation

//uses M2Share;

{$R *.dfm}

{ TfrmViewKernelInfo }


procedure TfrmViewKernelInfo.FormCreate(Sender: TObject);
const
  sNo = '';
  sHandle = '';
  sThreadID = '߳ID';
  sRunTime = 'ʱ';
  sRunFlag = '״̬';
var
  Config: pTConfig;
  ThreadInfo: pTThreadInfo;
begin
  Config := @g_Config;
  GridThread.Cells[0, 0] := sNo;
  GridThread.Cells[1, 0] := sHandle;
  GridThread.Cells[2, 0] := sThreadID;
  GridThread.Cells[3, 0] := sRunTime;
  GridThread.Cells[4, 0] := sRunFlag;
  ThreadInfo := @Config.UserEngineThread;
  ThreadInfo.hThreadHandle := 0;
  ThreadInfo.dwRunTick := 0;
  ThreadInfo.nRunTime := 0;
  ThreadInfo.nMaxRunTime := 0;
  ThreadInfo.nRunFlag := 0;
  ThreadInfo := @Config.IDSocketThread;
  ThreadInfo.hThreadHandle := 0;
  ThreadInfo.dwRunTick := 0;
  ThreadInfo.nRunTime := 0;
  ThreadInfo.nMaxRunTime := 0;
  ThreadInfo.nRunFlag := 0;
  ThreadInfo := @Config.DBSOcketThread;
  ThreadInfo.hThreadHandle := 0;
  ThreadInfo.dwRunTick := 0;
  ThreadInfo.nRunTime := 0;
  ThreadInfo.nMaxRunTime := 0;
  ThreadInfo.nRunFlag := 0;
end;

procedure TfrmViewKernelInfo.Open;
begin
  Timer.Enabled := True;
  ShowModal;
  Timer.Enabled := False;
end;
procedure TfrmViewKernelInfo.ReShowGameVar();
begin
  if SpinEdit_G.Value in [Low(g_Config.nGlobalVal)..High(g_Config.nGlobalVal)] then
    EditG_Val.Text := IntToStr(g_Config.nGlobalVal[SpinEdit_G.Value]); //G

  if SpinEdit_A.Value in [Low(g_Config.sGlobalAVal)..High(g_Config.sGlobalAVal)] then
    EditA_Val.Text := (g_Config.sGlobalAVal[SpinEdit_A.Value]); //A

  if SpinEdit_I.Value in [Low(g_Config.sGlobalAVal)..High(g_Config.sGlobalAVal)] then
    EditI_Val.Text := (g_Config.sGlobalAVal[SpinEdit_I.Value]); //I
end;
procedure TfrmViewKernelInfo.TimerTimer(Sender: TObject);
var
  Config: pTConfig;
  ThreadInfo: pTThreadInfo;
begin
  Config := @g_Config;
  EditLoadHumanDBCount.Text := IntToStr(g_Config.nLoadDBCount);
  EditLoadHumanDBErrorCoun.Text := IntToStr(g_Config.nLoadDBErrorCount);
  EditSaveHumanDBCount.Text := IntToStr(g_Config.nSaveDBCount);
  EditHumanDBQueryID.Text := IntToStr(g_Config.nDBQueryID);

  EditItemNumber.Text := IntToStr(g_Config.nItemNumber);
  EditItemNumberEx.Text := IntToStr(g_Config.nItemNumberEx);

  EditWinLotteryCount.Text := IntToStr(g_Config.nWinLotteryCount);
  EditNoWinLotteryCount.Text := IntToStr(g_Config.nNoWinLotteryCount);

  EditWinLotteryLevel1.Text := IntToStr(g_Config.nWinLotteryLevel1);
  EditWinLotteryLevel2.Text := IntToStr(g_Config.nWinLotteryLevel2);
  EditWinLotteryLevel3.Text := IntToStr(g_Config.nWinLotteryLevel3);
  EditWinLotteryLevel4.Text := IntToStr(g_Config.nWinLotteryLevel4);
  EditWinLotteryLevel5.Text := IntToStr(g_Config.nWinLotteryLevel5);
  EditWinLotteryLevel6.Text := IntToStr(g_Config.nWinLotteryLevel6);
  ReShowGameVar;


  EditAllocMemSize.Text := IntToStr(AllocMemSize);
  EditAllocMemCount.Text := IntToStr(AllocMemCount);

  //  GridThread.Row:=2;

  ThreadInfo := @Config.UserEngineThread;
  GridThreadAdd(ThreadInfo, 0);
  ThreadInfo := @Config.IDSocketThread;
  GridThreadAdd(ThreadInfo, 1);
  ThreadInfo := @Config.DBSOcketThread;
  GridThreadAdd(ThreadInfo, 2);

end;

procedure TfrmViewKernelInfo.GridThreadAdd(ThreadInfo: pTThreadInfo; Index: Integer);
begin
  GridThread.Cells[0, Index + 1] := format('%d', [Index]);
  GridThread.Cells[1, Index + 1] := format('%d', [ThreadInfo.hThreadHandle]);
  GridThread.Cells[2, Index + 1] := format('%d', [ThreadInfo.dwThreadID]);
  GridThread.Cells[3, Index + 1] := format('%d/%d/%d', [GetTickCount - ThreadInfo.dwRunTick,
    ThreadInfo.nRunTime,
      ThreadInfo.nMaxRunTime]);
  GridThread.Cells[4, Index + 1] := format('%d', [ThreadInfo.nRunFlag]);
end;


procedure TfrmViewKernelInfo.SpinEdit_GChange(Sender: TObject);
begin
  with TSpinEdit(Sender) do begin
    if Value < 0 then Value :=0;
    if Value > 99 then Value := 99;
  end;
  ReShowGameVar;
end;

procedure TfrmViewKernelInfo.EditG_ValChange(Sender: TObject);
begin
  if SpinEdit_G.Value in [Low(g_Config.nGlobalVal)..High(g_Config.nGlobalVal)] then
    g_Config.nGlobalVal[SpinEdit_G.Value] := Str_ToInt(EditG_Val.Text,0); //G
end;

procedure TfrmViewKernelInfo.EditA_ValChange(Sender: TObject);
begin   
  if SpinEdit_A.Value in [Low(g_Config.sGlobalAVal)..High(g_Config.sGlobalAVal)] then
    g_Config.sGlobalAVal[SpinEdit_A.Value] := EditA_Val.Text; //A
end;

procedure TfrmViewKernelInfo.EditI_ValChange(Sender: TObject);
begin
  if SpinEdit_I.Value in [Low(g_Config.sGlobalAVal)..High(g_Config.sGlobalAVal)] then
    g_Config.sGlobalAVal[SpinEdit_I.Value] := EditI_Val.Text; //I
end;

end.
