unit svMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JSocket, ExtCtrls, Buttons, StdCtrls, IniFiles, IdBaseComponent,
  IdUDPClient, Menus, ImgList, ComCtrls, Grids, IdComponent, IdUDPBase, SyncObjs,
  IdTCPClient, IdHTTP, IdTCPConnection,
  SList,
  M2Config, M2Share,
  MirGrobal, M2Type,
  TyFunc,SerGrobal,
  SDK, HUtil32,
  RunSock, GameMap,
  ItmUnit, Magic,
  NoticeM, Guild,
  Event, Castle,
  DBEngn, UsrEngn,
  MudUtil, ObjBase,ObjAutoPlay,
  PaiMai, PaiMaiManage,
  ShopConfig,
  Common, ObjNpc;

type
  TFrmMain = class(TForm)
    Timer1: TTimer;
    RunTimer: TTimer;
    DBSocket: TClientSocket;
    ConnectTimer: TTimer;
    StartTimer: TTimer;
    SaveVariableTimer: TTimer;
    CloseTimer: TTimer;
    MainMenu: TMainMenu;
    MENU_CONTROL: TMenuItem;
    MENU_CONTROL_EXIT: TMenuItem;
    MENU_CONTROL_RELOAD_CONF: TMenuItem;
    MENU_CONTROL_CLEARLOGMSG: TMenuItem;
    MENU_HELP: TMenuItem;
    MENU_HELP_ABOUT: TMenuItem;
    MENU_MANAGE: TMenuItem;
    MENU_CONTROL_RELOAD: TMenuItem;
    MENU_CONTROL_RELOAD_ITEMDB: TMenuItem;
    MENU_CONTROL_RELOAD_MAGICDB: TMenuItem;
    MENU_CONTROL_RELOAD_MONSTERDB: TMenuItem;
    MENU_MANAGE_PLUG: TMenuItem;
    MENU_OPTION: TMenuItem;
    MENU_OPTION_GENERAL: TMenuItem;
    MENU_OPTION_SERVERCONFIG: TMenuItem;
    MENU_OPTION_GAME: TMenuItem;
    MENU_OPTION_FUNCTION: TMenuItem;
    MENU_CONTROL_RELOAD_MONSTERSAY: TMenuItem;
    MENU_CONTROL_RELOAD_DISABLEMAKE: TMenuItem;
    MENU_CONTROL_GATE: TMenuItem;
    MENU_CONTROL_GATE_OPEN: TMenuItem;
    MENU_CONTROL_GATE_CLOSE: TMenuItem;
    MENU_VIEW: TMenuItem;
    MENU_VIEW_SESSION: TMenuItem;
    MENU_VIEW_ONLINEHUMAN: TMenuItem;
    MENU_VIEW_LEVEL: TMenuItem;
    MENU_VIEW_LIST: TMenuItem;
    MENU_MANAGE_ONLINEMSG: TMenuItem;
    MENU_VIEW_KERNELINFO: TMenuItem;
    MENU_TOOLS: TMenuItem;
    MENU_TOOLS_MERCHANT: TMenuItem;
    MENU_TOOLS_NPC: TMenuItem;
    MENU_OPTION_ITEMFUNC: TMenuItem;
    MENU_TOOLS_MONGEN: TMenuItem;
    MENU_CONTROL_RELOAD_STARTPOINT: TMenuItem;
    MENU_OPTION_GAMECMD: TMenuItem;
    MENU_OPTION_MONSTER: TMenuItem;
    MENU_TOOLS_IPSEARCH: TMenuItem;
    MENU_MANAGE_CASTLE: TMenuItem;
    MENU_HELP_REGKEY: TMenuItem;
    IdUDPClientLog: TIdUDPClient;
    MENU_CONTROL_RELOAD_QFunction: TMenuItem;
    MENU_OPTION_HERO: TMenuItem;
    MENU_CONTROL_RELOAD_QManage: TMenuItem;
    Panel1: TPanel;
    MemStatus: TLabel;
    LbUserCount: TLabel;
    LbTimeCount: TLabel;
    LbRunTime: TLabel;
    LbRunSocketTime: TLabel;
    Lbcheck: TLabel;
    Label5: TLabel;
    Label20: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    MemoLog: TMemo;
    GridGate: TStringGrid;
    MENU_VIEW_GATE: TMenuItem;
    MENU_CONTROL_RELOAD_MonItems: TMenuItem;
    MENU_CONTROL_RELOAD_RobotNPC: TMenuItem;
    MENU_MANAGE_SH: TMenuItem;
    MENU_MANAGE_JiShou: TMenuItem;
    IdHTTP1: TIdHTTP;
    CSCheckName: TClientSocket;

    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MemoLogChange(Sender: TObject);
    procedure MemoLogDblClick(Sender: TObject);
    procedure MENU_CONTROL_EXITClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_CONFClick(Sender: TObject);
    procedure MENU_CONTROL_CLEARLOGMSGClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_ITEMDBClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_MAGICDBClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_MONSTERDBClick(Sender: TObject);
    procedure MENU_HELP_ABOUTClick(Sender: TObject);
    procedure MENU_OPTION_SERVERCONFIGClick(Sender: TObject);
    procedure MENU_OPTION_GENERALClick(Sender: TObject);
    procedure MENU_OPTION_GAMEClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MENU_OPTION_FUNCTIONClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_MONSTERSAYClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_DISABLEMAKEClick(Sender: TObject);
    procedure MENU_CONTROL_GATE_OPENClick(Sender: TObject);
    procedure MENU_CONTROL_GATE_CLOSEClick(Sender: TObject);
    procedure MENU_CONTROLClick(Sender: TObject);
    procedure MENU_VIEW_GATEClick(Sender: TObject);
    procedure MENU_VIEW_SESSIONClick(Sender: TObject);
    procedure MENU_VIEW_ONLINEHUMANClick(Sender: TObject);
    procedure MENU_VIEW_LEVELClick(Sender: TObject);
    procedure MENU_VIEW_LISTClick(Sender: TObject);
    procedure MENU_MANAGE_ONLINEMSGClick(Sender: TObject);
    procedure MENU_VIEW_KERNELINFOClick(Sender: TObject);
    procedure MENU_TOOLS_MERCHANTClick(Sender: TObject);
    procedure MENU_OPTION_ITEMFUNCClick(Sender: TObject);
    procedure MENU_TOOLS_MONGENClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_STARTPOINTClick(Sender: TObject);
    procedure MENU_OPTION_GAMECMDClick(Sender: TObject);
    procedure MENU_OPTION_MONSTERClick(Sender: TObject);
    procedure MENU_TOOLS_IPSEARCHClick(Sender: TObject);
    procedure MENU_MANAGE_CASTLEClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_QFunctionClick(Sender: TObject);
    procedure MENU_OPTION_HEROClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_QManageClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_RobotNPCClick(Sender: TObject);
    procedure MENU_MANAGE_SHClick(Sender: TObject);
    procedure MENU_MANAGE_JiShouClick(Sender: TObject);
    procedure MENU_CONTROL_RELOAD_MonItemsClick(Sender: TObject);
    procedure CSCheckNameConnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    boServiceStarted: Boolean;
    procedure GateSocketClientError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure GateSocketClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure GateSocketClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure GateSocketClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure DBSocketConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure DBSocketError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure DBSocketRead(Sender: TObject; Socket: TCustomWinSocket);

    procedure Timer1Timer(Sender: TObject);
    procedure StartTimerTimer(Sender: TObject);
    procedure CloseTimerTimer(Sender: TObject);
    procedure SaveVariableTimerTimer(Sender: TObject);
    procedure RunTimerTimer(Sender: TObject);
    procedure ConnectTimerTimer(Sender: TObject);

    procedure StartService();
    procedure StopService();
    procedure SaveItemNumber;
    procedure StartEngine;
    procedure MakeStoneMines;
    procedure ReloadConfig(Sender: TObject);
    procedure ClearMemoLog();
    procedure CloseGateSocket();
    { Private declarations }
  public
    GateSocket: TServerSocket;
    procedure AppOnIdle(Sender: TObject; var Done: Boolean);
    procedure OnProgramException(Sender: TObject; E: Exception);
    procedure SetMenu(); virtual;
    procedure MyMessage(var MsgData: TWmCopyData); message WM_COPYDATA;
    { Public declarations }
  end;

function LoadAbuseInformation(FileName: string): Boolean;
procedure LoadServerTable();
procedure WriteConLog(MsgList: TStringList);
procedure ProcessGameRun();
var
  FrmMain: TFrmMain;
  g_GateSocket: TServerSocket;

implementation
uses
  LocalDB, InterServerMsg, InterMsgClient, IdSrvClient, FSrvValue,
  GeneralConfig, GameConfig, FunctionConfig, ObjRobot, ViewSession,
  ViewOnlineHuman, ViewLevel, ViewList, OnlineMsg, ViewKernelInfo,
  ConfigMerchant, ItemSet, ConfigMonGen, EDcode, EncryptUnit,
  GameCommand, MonsterConfig, RunDB, CastleManage, AboutUnit, HeroConfig;

//------------------------------------------------------------------------------
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {PlugOfEngine}//

var
  sCaption: string = '';
  l_dwRunTimeTick: LongWord;
  boRemoteOpenGateSocket: Boolean = True;
  boRemoteOpenGateSocketed: Boolean = False;
  boSaveData: Boolean = False;
  sChar: string = ' ?';
  sRun: string = 'Run';
  DllHandle                             : Integer;
{$R *.dfm}


function LoadAbuseInformation(FileName: string): Boolean;
var
  i: Integer;
  sText: string;
begin
  Result := False;
  if FileExists(FileName) then begin
    AbuseTextList.Clear;
    AbuseTextList.LoadFromFile(FileName);
    i := 0;
    while (True) do begin
      if AbuseTextList.Count <= i then break;
      sText := Trim(AbuseTextList.Strings[i]);
      if sText = '' then begin
        AbuseTextList.Delete(i);
        Continue;
      end;
      Inc(i);
    end;
    Result := True;
  end;
end;

procedure LoadServerTable(); //004E3E64
var
  i, ii: Integer;
  LoadList: TStringList;
  GateList: TStringList;
  SrvNetInfo: pTSrvNetInfo;
  sLineText, sGateMsg: string;
  sServerIdx, sIPaddr, sPort: string;
begin
  for i := 0 to ServerTableList.Count - 1 do begin
    TList(ServerTableList.Items[i]).Free;
  end;
  ServerTableList.Clear;
  if FileExists('.\!servertable.txt') then begin
    LoadList := TStringList.Create;
    LoadList.LoadFromFile('.\!servertable.txt');
    for i := 0 to LoadList.Count - 1 do begin
      sLineText := Trim(LoadList.Strings[i]);
      if (sLineText <> '') and (sLineText[1] <> ';') then begin
        sGateMsg := Trim(GetValidStr3(sLineText, sGateMsg, [' ', #9]));
        if sGateMsg <> '' then begin
          GateList := TStringList.Create;
          for ii := 0 to 30 do begin
            if sGateMsg = '' then break;
            sGateMsg := Trim(GetValidStr3(sGateMsg, sIPaddr, [' ', #9]));
            sGateMsg := Trim(GetValidStr3(sGateMsg, sPort, [' ', #9]));
            if (sIPaddr <> '') and (sPort <> '') then begin
              GateList.AddObject(sIPaddr, TObject(Str_ToInt(sPort, 0)));
            end;
          end;
          ServerTableList.Add(GateList);
        end;
      end;
    end;
    FreeAndNil(LoadList);
  end else begin
    ShowMessage('ļ!servertable.txtδҵ');
  end;
end;

procedure WriteConLog(MsgList: TStringList);
var
  i: Integer;
  Year, Month, Day, Hour, Min, Sec, MSec: Word;
  sLogDir, sLogFileName: string;
  LogFile: TextFile;
begin
  Exit;
  if MsgList.Count <= 0 then exit;
  DecodeDate(Date, Year, Month, Day);
  DecodeTime(Time, Hour, Min, Sec, MSec);
  if not DirectoryExists(g_Config.sConLogDir) then begin
    CreateDir(g_Config.sConLogDir);
  end;
  sLogDir := g_Config.sConLogDir + IntToStr(Year) + '-' + IntToStr2(Month) + '-' + IntToStr2(Day);
  if not DirectoryExists(sLogDir) then begin
    CreateDirectory(PChar(sLogDir), nil);
  end;
  sLogFileName := sLogDir + '\C-' + IntToStr(nServerIndex) + '-' + IntToStr2(Hour) + 'H' + IntToStr2((Min div 10 * 2) * 5) + 'M.txt';
  AssignFile(LogFile, sLogFileName);
  if not FileExists(sLogFileName) then begin
    Rewrite(LogFile);
  end else begin
    Append(LogFile);
  end;
  for i := 0 to MsgList.Count - 1 do begin
    WriteLn(LogFile, '1' + #9 + MsgList.Strings[i]);
  end; // for
  CloseFile(LogFile);
end;

procedure TFrmMain.SaveItemNumber();
var
  i: Integer;
begin
  try
    Config.WriteInteger('Setup', 'ItemNumber', g_Config.nItemNumber);
    Config.WriteInteger('Setup', 'ItemNumberEx', g_Config.nItemNumberEx);
    for i := Low(g_Config.nGlobalVal) to High(g_Config.nGlobalVal) do begin
      Config.WriteInteger('Setup', 'GlobalVal' + IntToStr(i), g_Config.nGlobalVal[i])
    end;
    for i := Low(g_Config.sGlobalAVal) to High(g_Config.sGlobalAVal) do begin
      Config.WriteString('Setup', 'GlobalStrVal' + IntToStr(i), g_Config.sGlobalAVal[i])
    end;
    Config.WriteInteger('Setup', 'WinLotteryCount', g_Config.nWinLotteryCount);
    Config.WriteInteger('Setup', 'NoWinLotteryCount', g_Config.nNoWinLotteryCount);
    Config.WriteInteger('Setup', 'WinLotteryLevel1', g_Config.nWinLotteryLevel1);
    Config.WriteInteger('Setup', 'WinLotteryLevel2', g_Config.nWinLotteryLevel2);
    Config.WriteInteger('Setup', 'WinLotteryLevel3', g_Config.nWinLotteryLevel3);
    Config.WriteInteger('Setup', 'WinLotteryLevel4', g_Config.nWinLotteryLevel4);
    Config.WriteInteger('Setup', 'WinLotteryLevel5', g_Config.nWinLotteryLevel5);
    Config.WriteInteger('Setup', 'WinLotteryLevel6', g_Config.nWinLotteryLevel6);
  except
  end;
end;

procedure TFrmMain.AppOnIdle(Sender: TObject; var Done: Boolean);
begin
end;

procedure TFrmMain.OnProgramException(Sender: TObject; E: Exception);
begin
  MainOutMessage(E.Message);
end;

procedure TFrmMain.DBSocketError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  ErrorCode := 0;
  Socket.Close;
end;

procedure TFrmMain.DBSocketRead(Sender: TObject; Socket: TCustomWinSocket);
var
  tStr: string;
begin
  EnterCriticalSection(UserDBSection);
  try

    tStr := Socket.ReceiveText;
    //MainOutMessage('DBRead:'+tStr);
    g_Config.sDBSocketRecvText := g_Config.sDBSocketRecvText + tStr;
    if not g_Config.boDBSocketWorking then begin
      g_Config.sDBSocketRecvText := '';
    end;
  finally
    LeaveCriticalSection(UserDBSection);
  end;
end;

procedure TFrmMain.Timer1Timer(Sender: TObject);
var
  boWriteLog: Boolean;
  i: Integer;
  nRow: Integer;
  wHour: Word;
  wMinute: Word;
  wSecond: Word;
  tSecond: Integer;
  sVerType: string;
  tTimeCount: Currency;
  GateInfo: pTGateInfo;
  LogFile: TextFile;
  s28: string;
begin
  Caption := sCaption + ' [' + sCaptionExtText + ']';
  EnterCriticalSection(LogMsgCriticalSection);
  try
    if MemoLog.Lines.Count > 500 then begin
      MemoLog.Lines.SaveToFile('.\MemoLog.txt');
      MemoLog.Clear;
    end;
    boWriteLog := True;
    if MainLogMsgList.Count > 0 then begin
      try
        if not FileExists(sLogFileName) then begin
          AssignFile(LogFile, sLogFileName);
          Rewrite(LogFile);
        end else begin
          AssignFile(LogFile, sLogFileName);
          Append(LogFile);
        end;
        boWriteLog := False;
      except
        MemoLog.Lines.Add('־Ϣ');
      end;
    end;
    for i := 0 to MainLogMsgList.Count - 1 do begin
      MemoLog.Lines.Add(MainLogMsgList.Strings[i]);
      if not boWriteLog then begin
        WriteLn(LogFile, MainLogMsgList.Strings[i]);
      end;
    end;
    MainLogMsgList.Clear;
    if not boWriteLog then CloseFile(LogFile);
    for i := 0 to LogStringList.Count - 1 do begin
      try
        s28 := '1' + #9 + IntToStr(g_Config.nServerNumber) + #9 + IntToStr(nServerIndex) + #9 + LogStringList.Strings[i];
        IdUDPClientLog.Send(s28);
      except
        Continue;
      end;
    end;
    LogStringList.Clear;
    if LogonCostLogList.Count > 0 then begin
      WriteConLog(LogonCostLogList);
    end;
    LogonCostLogList.Clear;
  finally
    LeaveCriticalSection(LogMsgCriticalSection);
  end;


  //߳ ʱ
  //g_dwEngineRunTime:=GetTickCount - g_dwEngineTick;

  tSecond := (GetTickCount() - g_dwStartTick) div 1000;
  wHour := tSecond div 3600;
  wMinute := (tSecond div 60) mod 60;
  wSecond := tSecond mod 60;
  LbRunTime.Caption := format(': %d[ʱ]%d[]%d[]', [wHour, wMinute, wSecond]);
  LbUserCount.Caption := '(' + IntToStr(UserEngine.MonsterCount) + ')   ' +
    IntToStr(UserEngine.OnlinePlayObject) + '/' +
    IntToStr(UserEngine.PlayObjectCount) + '[' +
    IntToStr(UserEngine.LoadPlayCount) + '/' +
    IntToStr(UserEngine.m_PlayObjectFreeList.Count) + ']';
  Label1.Caption := format('(%d/%d) (%d/%d) ɫ(%d/%d)', [nRunTimeMin, nRunTimeMax, g_nSockCountMin, g_nSockCountMax, g_nUsrTimeMin, g_nUsrTimeMax]);
  Label2.Caption := format('(%d/%d) ѭ(%d/%d) (%d/%d) (%d/%d) (%d)', [g_nHumCountMin,
    g_nHumCountMax,
      dwUsrRotCountMin,
      dwUsrRotCountMax,
      UserEngine.dwProcessMerchantTimeMin,
      UserEngine.dwProcessMerchantTimeMax,
      UserEngine.dwProcessNpcTimeMin,
      UserEngine.dwProcessNpcTimeMax,
      g_nProcessHumanLoopTime]);

  Label5.Caption := g_sMonGenInfo1 + ' - ' + g_sMonGenInfo2 + '    ';

  Label20.Caption := format('ˢ¹(%d/%d/%d) (%d/%d/%d) ɫ(%d/%d)', [g_nMonGenTime, g_nMonGenTimeMin, g_nMonGenTimeMax, g_nMonProcTime, g_nMonProcTimeMin, g_nMonProcTimeMax, g_nBaseObjTimeMin, g_nBaseObjTimeMax]);

  MemStatus.Caption := 'ڴ: ' + IntToStr(ROUND(AllocMemSize / 1024/1024)) + 'MB'; // + ' ڴ: ' + IntToStr(AllocMemCount);
  if dwStartTimeTick = 0 then dwStartTimeTick := GetTickCount;
  dwStartTime := (GetTickCount - dwStartTimeTick) div 1000;

  tTimeCount := GetTickCount() / (24 * 60 * 60 * 1000);
  if tTimeCount >= 36 then LbTimeCount.Font.Color := clRed
  else LbTimeCount.Font.Color := clBlack;
  LbTimeCount.Caption := CurrToStr(tTimeCount) + '';
  nRow := 1;
  for i := Low(g_GateArr) to High(g_GateArr) do begin
    GridGate.Cells[0, i + 1] := '';
    GridGate.Cells[1, i + 1] := '';
    GridGate.Cells[2, i + 1] := '';
    GridGate.Cells[3, i + 1] := '';
    GridGate.Cells[4, i + 1] := '';
    GridGate.Cells[5, i + 1] := '';
    GridGate.Cells[6, i + 1] := '';
    GateInfo := @g_GateArr[i];
    //GateInfo:=@RunSocket.GateList[i];
    if GateInfo.boUsed and (GateInfo.Socket <> nil) then begin
      GridGate.Cells[0, nRow] := IntToStr(i);
      GridGate.Cells[1, nRow] := GateInfo.sAddr + ':' + IntToStr(GateInfo.nPort);
      GridGate.Cells[2, nRow] := IntToStr(GateInfo.nAddActionCount);
      GridGate.Cells[3, nRow] := IntToStr(GateInfo.nSendedMsgCount);
      GridGate.Cells[4, nRow] := IntToStr(GateInfo.nSendRemainCount);
      if GateInfo.nAddActionBytes < 1024 then begin
        GridGate.Cells[5, nRow] := IntToStr(GateInfo.nAddActionBytes) + 'b';
      end else begin
        GridGate.Cells[5, nRow] := IntToStr(GateInfo.nAddActionBytes div 1024) + 'kb';
      end;
      GridGate.Cells[6, nRow] := IntToStr(GateInfo.nUserCount) + '/' + IntToStr(GateInfo.UserList.Count);
      Inc(nRow);
    end;
  end;
  Inc(nRunTimeMax);
  if g_nSockCountMax > 0 then Dec(g_nSockCountMax);
  if g_nUsrTimeMax > 0 then Dec(g_nUsrTimeMax);
  if g_nHumCountMax > 0 then Dec(g_nHumCountMax);
  if g_nMonTimeMax > 0 then Dec(g_nMonTimeMax);
  if dwUsrRotCountMax > 0 then Dec(dwUsrRotCountMax);
  if g_nMonGenTimeMin > 1 then Dec(g_nMonGenTimeMin, 2);
  if g_nMonProcTimeMin > 1 then Dec(g_nMonProcTimeMin, 2);
  if g_nBaseObjTimeMax > 0 then Dec(g_nBaseObjTimeMax);
end;

procedure TFrmMain.StartTimerTimer(Sender: TObject); //004E4848
var
  nCode: Integer;
begin
  SendGameCenterMsg(SG_STARTNOW, 'Ϸ...');
  g_Config.nServerFile_CRCB := CalcFileCRC32(Application.ExeName);
  if g_Config.nServerFile_CRCB <> g_Config.nServerFile_CRCB then begin
    ShowMessage('ݰ!');
    Close;
    Application.Terminate;
    Exit;
  end;   
  StartTimer.Enabled := False;
  FrmDB := TFrmDB.Create();
  StartService();
  try
    {if SizeOf(THumDataInfo) <> SIZEOFTHUMAN then begin
      ShowMessage('sizeof(THuman) ' + IntToStr(SizeOf(THumDataInfo)) + ' <> SIZEOFTHUMAN ' + IntToStr(SIZEOFTHUMAN));
      Close;
      exit;
    end;}
    FrmDB.Query.DatabaseName := sDBName;

    LoadDenyIPAddrList();
    LoadDenyAccountList();
    LoadDenyChrNameList();
    LoadNoClearMonList();

    MemoLog.Lines.Add('ڼƷݿ...');
    nCode := FrmDB.LoadItemsDB;
    if nCode < 0 then begin
      MemoLog.Lines.Add('Ʒݿʧܣ' + 'Code: ' + IntToStr(nCode));
      exit;
    end;
    MemoLog.Lines.Add(format('Ʒݿسɹ(%d)...', [UserEngine.StdItemList.Count]));
    MemoLog.Lines.Add('ڼͼļ...');
    nCode := FrmDB.LoadMinMap;
    if nCode < 0 then begin
      MemoLog.Lines.Add('Сͼݼʧܣ' + 'Code: ' + IntToStr(nCode));
      exit;
    end;
    MemoLog.Lines.Add('Сͼݼسɹ...');

    MemoLog.Lines.Add('ڼصͼ...');
    nCode := FrmDB.LoadMapInfo;
    if nCode < 0 then begin
      MemoLog.Lines.Add('ͼݼʧܣ' + 'Code: ' + IntToStr(nCode));
      exit;
    end;
    MemoLog.Lines.Add(format('ͼݼسɹ(%d)...', [g_MapManager.Count]));

    MemoLog.Lines.Add('ڼعݿ...');
    nCode := FrmDB.LoadMonsterDB;
    if nCode < 0 then begin
      MemoLog.Lines.Add('عݿʧܣ' + 'Code: ' + IntToStr(nCode));
      exit;
    end;
    MemoLog.Lines.Add(format('عݿɹ(%d)...', [UserEngine.MonDBList.Count]));

    MemoLog.Lines.Add('ڼؼݿ...');
    nCode := FrmDB.LoadMagicDB;
    if nCode < 0 then begin
      MemoLog.Lines.Add('ؼݿʧܣ' + 'Code: ' + IntToStr(nCode));
      exit;
    end;
    MemoLog.Lines.Add(format('ؼݿɹ(%d)...', [UserEngine.m_MagicList.Count]));

    MemoLog.Lines.Add('ڼعˢϢ...');
    nCode := FrmDB.LoadMonGen;
    if nCode < 0 then begin
      MemoLog.Lines.Add('عˢϢʧܣ' + 'Code: ' + IntToStr(nCode));
      exit;
    end;
    MemoLog.Lines.Add(format('عˢϢɹ(%d)...', [UserEngine.m_MonGenList.Count]));

    MemoLog.Lines.Add('ع˵Ϣ...');
    LoadMonSayMsg();
    MemoLog.Lines.Add(format('ع˵Ϣɹ(%d)...', [g_MonSayMsgList.Count]));


    LoadDisableMoveMap;
    ItemUnit.LoadCustomItemName();
    LoadDisableAddActionList();
    LoadItemBindIPaddr();
    LoadItemBindAccount();
    LoadItemBindCharName();
    LoadUnMasterList();
    LoadUnForceMasterList();

    MemoLog.Lines.Add('ڼ޲ֿݿ...');
    g_BigStorageList.LoadBigStorageList();
    MemoLog.Lines.Add(format('޲ֿݿɹ(%d/%d)...', [g_BigStorageList.HumManCount, g_BigStorageList.RecordCount]));




    MemoLog.Lines.Add('ڼװƷϢ...');

    nCode := FrmDB.LoadUnbindList;
    if nCode < 0 then begin
      MemoLog.Lines.Add('װƷϢʧܣ' + 'Code: ' + IntToStr(nCode));
      exit;
    end;
    MemoLog.Lines.Add('װƷϢɹ...');

    LoadBindItemTypeFromUnbindList(); {װƷ}

    MemoLog.Lines.Add('ڼͼϢ...');
    nCode := FrmDB.LoadMapQuest;
    if nCode < 0 then begin
      MemoLog.Lines.Add('ͼϢʧܣ');
      exit;
    end;
    MemoLog.Lines.Add('ͼϢɹ...');

    MemoLog.Lines.Add('ڼصͼ¼Ϣ...');
    nCode := FrmDB.LoadMapEvent;
    if nCode < 0 then begin
      MemoLog.Lines.Add('صͼ¼Ϣʧܣ');
      exit;
    end;
    MemoLog.Lines.Add('صͼ¼Ϣɹ...');

    MemoLog.Lines.Add('ڼ˵Ϣ...');
    nCode := FrmDB.LoadQuestDiary;
    if nCode < 0 then begin
      MemoLog.Lines.Add('˵Ϣʧܣ');
      exit;
    end;
    MemoLog.Lines.Add('˵Ϣɹ...');

    if LoadAbuseInformation('.\!abuse.txt') then begin
      MemoLog.Lines.Add('ֹϢɹ...');
    end;

    MemoLog.Lines.Add('ڼعʾϢ...');
    if not LoadLineNotice(g_Config.sNoticeDir + 'LineNotice.txt') then begin
      MemoLog.Lines.Add('عʾϢʧܣ');
    end;
    MemoLog.Lines.Add('عʾϢɹ...');

    FrmDB.LoadAdminList();
    MemoLog.Lines.Add('Աбسɹ...');
    g_AutoPlayMan.LoadForFile;
    g_GuildManager.LoadGuildInfo();
    MemoLog.Lines.Add('лбسɹ...');

    g_CastleManager.LoadCastleList();
    MemoLog.Lines.Add('Ǳбسɹ...');

    //UserCastle.Initialize;
    g_CastleManager.Initialize;
    MemoLog.Lines.Add('Ǳǳʼ...');
    if (nServerIndex = 0) then FrmSrvMsg.StartMsgServer
    else FrmMsgClient.ConnectMsgServer;
    StartEngine();
    boStartReady := True;
    Sleep(500);

    ConnectTimer.Enabled := True;

    g_dwRunTick := GetTickCount();

    n4EBD1C := 0;
    g_dwUsrRotCountTick := GetTickCount();

    RunTimer.Enabled := True;
    SendGameCenterMsg(SG_STARTOK, 'Ϸ...');
    GateSocket.Address := g_Config.sGateAddr;
    GateSocket.Port := g_Config.nGatePort;
    g_GateSocket := GateSocket;
    SendGameCenterMsg(SG_CHECKCODEADDR, IntToStr(nCode));
  except
    on E: Exception do
      MainOutMessage('쳣' + E.Message);
  end;
end;

procedure TFrmMain.StartEngine();
var
  nCode: Integer;
begin
  try
    //ִ StartTimerTimer
    FrmIDSoc.Initialize;
    MemoLog.Lines.Add('¼ӳʼ...');

    g_MapManager.LoadMapDoor;
    MemoLog.Lines.Add('ͼسɹ...');

    MakeStoneMines();
    MemoLog.Lines.Add('ݳʼɹ...');
    
    nCode := FrmDB.LoadMerchant;
    if nCode < 0 then begin
      MemoLog.Lines.Add('Load Merchant Error ' + 'Code: ' + IntToStr(nCode));
      exit;
    end;
    MemoLog.Lines.Add('NPCбسɹ...');
    if not g_Config.boVentureServer then begin
      nCode := FrmDB.LoadGuardList;
      if nCode < 0 then begin
        MemoLog.Lines.Add('Load GuardList Error ' + 'Code: ' + IntToStr(nCode));
      end;
      MemoLog.Lines.Add('бسɹ...');
    end;

    nCode := FrmDB.LoadNpcs;
    if nCode < 0 then begin
      MemoLog.Lines.Add('Load NpcList Error ' + 'Code: ' + IntToStr(nCode));
      exit;
    end;
    MemoLog.Lines.Add('NPCбسɹ...');

    nCode := FrmDB.LoadMakeItem;
    if nCode < 0 then begin
      MemoLog.Lines.Add('ҩ' + 'Code: ' + IntToStr(nCode));
      exit;
    end;
    MemoLog.Lines.Add('ҩϢسɹ...');

    nCode := FrmDB.LoadStartPoint;
    if nCode < 0 then begin
      MemoLog.Lines.Add('ػسǵʱִ (: ' + IntToStr(nCode) + ')');
      Close;
    end;
    MemoLog.Lines.Add('سǵüسɹ...');

    DBEngine.Resume;
    MemoLog.Lines.Add('ɹ...');

    UserEngine.Initialize;
    MemoLog.Lines.Add('Ϸʼɹ...');
    g_MapManager.MakeSafePkZone; //ȫȦ

    


    LoadShopItemList;
    MemoLog.Lines.Add('Ʒ...');
    FrmDB.LoadSeZiList;
    //MemoLog.Lines.Add('ɫƷ...');
    sCaptionExtText := 'ڳʼ...';
    //Caption := sCaption + ' [' + sCaptionExtText + ']';
    MemoLog.Lines.Add('ʼɹ...');
    boSaveData := True;
  except
    MainOutMessage('ʱ쳣 ');
  end;
end;

procedure TFrmMain.MakeStoneMines();
var
  i, nW, nH: Integer;
  Map: TMap;
begin
  for i := 0 to g_MapManager.Count - 1 do begin
    Map := TMap(g_MapManager.Items[i]);
    if Map.m_boMINE then begin
      Map.MakeStoneMines;
    end;
  end;
end;


procedure TFrmMain.FormCreate(Sender: TObject);
var
  nX, nY: Integer;
  Year, Month, Day: Word;
  hid                                   : String;
  MemoryStream: TMemoryStream;
begin
  Randomize;
  CHECK_PARENTPROC;
  //ShowMessage(ParamStr(0));
  {ShowMessage(IntToStr(TBaseObject.InstanceSize));
  Application.Terminate;
  Close;   
  if not DirectoryExists('.\Envir\Market_Prices\') then
    MkDir('.\Envir\Market_Prices\');
  if not DirectoryExists('.\Envir\Market_Saved\') then
    MkDir('.\Envir\Market_Saved\'); }

  NotRegenMonsters := False;

  g_dwGameCenterHandle := Str_ToInt(ParamStr(1), 0);
  nX := Str_ToInt(ParamStr(2), -1);
  nY := Str_ToInt(ParamStr(3), -1);
  if (nX >= 0) or (nY >= 0) then begin
    Left := nX;
    Top := nY;
  end;
  SendGameCenterMsg(SG_FORMHANDLE, IntToStr(Self.Handle));
  GridGate.RowCount := 21;
  GridGate.Cells[0, 0] := '';
  GridGate.Cells[1, 0] := 'صַ';
  GridGate.Cells[2, 0] := '';
  GridGate.Cells[3, 0] := '';
  GridGate.Cells[4, 0] := 'ʣ';
  GridGate.Cells[5, 0] := 'ƽ';
  GridGate.Cells[6, 0] := '';

  GateSocket := TServerSocket.Create(Owner);
  GateSocket.OnClientConnect := GateSocketClientConnect;
  GateSocket.OnClientDisconnect := GateSocketClientDisconnect;
  GateSocket.OnClientError := GateSocketClientError;
  GateSocket.OnClientRead := GateSocketClientRead;

  DBSocket.OnConnect := DBSocketConnect;
  DBSocket.OnError := DBSocketError;
  CSCheckName.OnError := DBSocketError;
  DBSocket.OnRead := DBSocketRead;

  Timer1.OnTimer := Timer1Timer;
  RunTimer.OnTimer := RunTimerTimer;
  StartTimer.OnTimer := StartTimerTimer;
  SaveVariableTimer.OnTimer := SaveVariableTimerTimer;
  ConnectTimer.OnTimer := ConnectTimerTimer;
  CloseTimer.OnTimer := CloseTimerTimer;
  MemoLog.OnChange := MemoLogChange;
  StartTimer.Enabled := True;
end;

procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
const
  sCloseServerYesNo = 'ǷȷϹرϷ';
  sCloseServerTitle = 'ȷϢ';
begin
  if not boServiceStarted then begin
    exit;
  end;
  if g_boExitServer then begin
    boStartReady := False;
    exit;
  end;
  CanClose := False;
  if Application.MessageBox(PChar(sCloseServerYesNo), PChar(sCloseServerTitle), MB_YESNO + MB_ICONQUESTION) = mrYes then begin
    g_boExitServer := True;
    CloseGateSocket();
    CloseTimer.Enabled := True;

  end;
end;

procedure SaveItemData();
var
  n01: Integer;
begin
  n01 := 0;
  boSaveData := False;
  while TRUE do begin
    Inc(n01);
    if g_BigStorageList.SaveStorageList() then break;
    if n01 >= 50 then break;
  end;
  n01 := 0;
end;

procedure TFrmMain.CloseTimerTimer(Sender: TObject);

const
  sCloseServer = '%s [ڹرշ(%s %d/%s %d)...]';
  sCloseServer1 = '%s [ֹͣ...]';
  sCloseServerEnd = '%s [ѹر]';
begin
  Caption := Format(sCloseServer, [g_Config.sServerName, '', UserEngine.OnlinePlayObject, '', DBEngine.SaveListCount]);
  if UserEngine.OnlinePlayObject = 0 then begin
    if DBEngine.IsIdle then begin
      CloseTimer.Enabled := False;
      SaveItemData();
      Caption := Format(sCloseServer1, [g_Config.sServerName]);
      StopService;
      Caption := Format(sCloseServerEnd, [g_Config.sServerName]);
      FrmDB.Free;
      FreeLibrary(DllHandle);
      Close;
    end;
  end;
end;

procedure TFrmMain.SaveVariableTimerTimer(Sender: TObject);
begin
  SaveItemNumber();
  if boSaveData then begin
    if g_BigStorageList <> nil then g_BigStorageList.SaveStorageList();
  end;
end;

procedure TFrmMain.GateSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  RunSocket.CloseErrGate(Socket, ErrorCode);
end;

procedure TFrmMain.GateSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  RunSocket.CloseGate(Socket);
end;

procedure TFrmMain.GateSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  RunSocket.AddGate(Socket);
end;

procedure TFrmMain.GateSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  RunSocket.SocketRead(Socket);
end;

procedure TFrmMain.RunTimerTimer(Sender: TObject);

begin
  if boStartReady then begin
    RunSocket.Execute;

    FrmIDSoc.Run;

    UserEngine.Execute;

    ProcessGameRun();

    if nServerIndex = 0 then
      FrmSrvMsg.Run
    else FrmMsgClient.Run;
  end;
  Inc(n4EBD1C);
  if (GetTickCount - g_dwRunTick) > 250 then begin
    g_dwRunTick := GetTickCount();
    nRunTimeMin := n4EBD1C;
    if nRunTimeMax > nRunTimeMin then nRunTimeMax := nRunTimeMin;
    n4EBD1C := 0;
  end;
  if boRemoteOpenGateSocket then begin
    if not boRemoteOpenGateSocketed then begin
      boRemoteOpenGateSocketed := True;
      try
        if Assigned(g_GateSocket) then begin
          g_GateSocket.Active := True;
        end;
      except
        on E: Exception do begin
          MainOutMessage(E.Message);
        end;
      end;
    end;
  end;
end;

procedure TFrmMain.ConnectTimerTimer(Sender: TObject);
begin
  if not DBSocket.Active then
    DBSocket.Active := True;
  if not CSCheckName.Active then
    CSCheckName.Open;
end;

procedure TFrmMain.ReloadConfig(Sender: TObject);
begin
  try
    LoadM2Config();
    FrmIDSoc.Timer1Timer(Sender);
    if not (nServerIndex = 0) then begin
      if not FrmMsgClient.MsgClient.Active then begin
        FrmMsgClient.MsgClient.Active := True;
      end;
    end;
    IdUDPClientLog.Host := g_Config.sLogServerAddr;
    IdUDPClientLog.Port := g_Config.nLogServerPort;
    LoadServerTable();
  finally

  end;
end;

procedure TFrmMain.MemoLogChange(Sender: TObject);
begin
  if MemoLog.Lines.Count > 1000 then begin
    MemoLog.Lines.SaveToFile('.\MemoLog.txt');
    MemoLog.Clear;
  end;

end;

procedure TFrmMain.MemoLogDblClick(Sender: TObject);
begin
  ClearMemoLog();
end;

procedure TFrmMain.MENU_CONTROL_EXITClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_CONFClick(Sender: TObject);
begin
  ReloadConfig(Sender);
  MainOutMessage('¼ز...');
end;

procedure TFrmMain.MENU_CONTROL_CLEARLOGMSGClick(Sender: TObject);
begin
  ClearMemoLog();
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_ITEMDBClick(Sender: TObject);
begin
  FrmDB.LoadItemsDB();
  MainOutMessage('¼Ʒݿ...');
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_MAGICDBClick(Sender: TObject);
begin
  FrmDB.LoadMagicDB();
  MainOutMessage('¼ؼݿ...');
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_MONSTERDBClick(Sender: TObject);
begin
  FrmDB.LoadMonsterDB();
  MainOutMessage('¼عݿ...');
end;

procedure TFrmMain.StartService;
var
  TimeNow: TDateTime;
  Year, Month, Day, Hour, Min, Sec, MSec: Word;
  F: TextFile;
begin
  //boThief := True;
  {if FileExists('.\IPLocal.dll') then
  g_IPLocalLibrary := LoadLibrary('.\IPLocal.dll');
  if g_IPLocalLibrary > 32 then
  IPLocal := GetProcAddress(g_IPLocalLibrary,'GetIPLocal');}
  nRunTimeMax := 99999;
  g_nSockCountMax := 0;
  g_nUsrTimeMax := 0;
  g_nHumCountMax := 0;
  g_nMonTimeMax := 0;
  g_nMonGenTimeMax := 0;
  g_nMonProcTime := 0;
  g_nMonProcTimeMin := 0;
  g_nMonProcTimeMax := 0;
  dwUsrRotCountMin := 0;
  dwUsrRotCountMax := 0;
  g_nProcessHumanLoopTime := 0;
  g_dwHumLimit := 30;
  g_dwMonLimit := 30;
  g_dwZenLimit := 5;
  g_dwNpcLimit := 5;
  g_dwSocLimit := 10;
  nDecLimit := 20;
  g_Config.sDBSocketRecvText := '';
  g_Config.boDBSocketWorking := False;
  g_Config.nLoadDBErrorCount := 0;
  g_Config.nLoadDBCount := 0;
  g_Config.nSaveDBCount := 0;
  g_Config.nDBQueryID := 0;
  g_Config.nItemNumber := 0;
  g_Config.nItemNumberEx := High(Integer) div 2;
  boStartReady := False;
  g_boExitServer := False;
  boFilterWord := True;
  g_Config.nWinLotteryCount := 0;
  g_Config.nNoWinLotteryCount := 0;
  g_Config.nWinLotteryLevel1 := 0;
  g_Config.nWinLotteryLevel2 := 0;
  g_Config.nWinLotteryLevel3 := 0;
  g_Config.nWinLotteryLevel4 := 0;
  g_Config.nWinLotteryLevel5 := 0;
  g_Config.nWinLotteryLevel6 := 0;
  FillChar(g_Config.nGlobalVal, SizeOf(g_Config.nGlobalVal), #0);
  FillChar(g_Config.nGlobaDyMval, SizeOf(g_Config.nGlobaDyMval), #0);
  FillChar(g_Config.sGlobalAVal, SizeOf(g_Config.sGlobalAVal), #0);
  FillChar(g_Config.ServerSetup, SizeOf(TServerSetup), #0);

  LoadM2Config();
  Memo := MemoLog;
  nServerIndex := 0;

  RunSocket := TRunSocket.Create();
  MainLogMsgList := TStringList.Create;
  LogStringList := TStringList.Create;
  LogonCostLogList := TStringList.Create;
  g_SeZiList       := TStringList.Create;
  g_MapManager := TMapManager.Create;
  ItemUnit := TItemUnit.Create;
  MagicManager := TMagicManager.Create;
  NoticeManager := TNoticeManager.Create;
  g_GuildManager := TGuildManager.Create;
  g_EventManager := TEventManager.Create;
  g_CastleManager := TCastleManager.Create;
  g_AutoPlayMan := TAutoPlayMan.Create;

  DBEngine := TDBEngine.Create(True);
  UserEngine := TUserEngine.Create();
  RobotManage := TRobotManage.Create;

  g_MakeItemList := TStringList.Create;
  g_StartPointList := TGStringList.Create;
  ServerTableList := TList.Create;
  g_DenySayMsgList := TQuickList.Create;
  g_MiniMapList := TStringList.Create;
  g_UnbindList := TStringList.Create;
  LineNoticeList := TStringList.Create;
  QuestDiaryList := TList.Create;
  ItemEventList := TStringList.Create;
  AbuseTextList := TStringList.Create;
  g_MonSayMsgList := TStringList.Create;

  g_DisableMoveMapList := TGStringList.Create;
  g_ItemCheckList := TGStringList.Create;
  g_DisableSayList := TGStringList.Create;


  g_UnMasterList := TGStringList.Create;
  g_UnForceMasterList := TGStringList.Create;
  g_DenyIPAddrList := TGStringList.Create;
  g_DenyChrNameList := TGStringList.Create;
  g_DenyAccountList := TGStringList.Create;
  g_NoClearMonList := TGStringList.Create;

  g_ItemBindIPaddr := TGList.Create;
  g_ItemBindAccount := TGList.Create;
  g_ItemBindCharName := TGList.Create;

  g_PaiMaiManage := TPaiMaiManage.Create;
  g_BigStorageList := TBigStorageList.Create;

  g_MapEventListOfDropItem := TGList.Create;
  g_MapEventListOfPickUpItem := TGList.Create;
  g_MapEventListOfMine := TGList.Create;
  g_MapEventListOfWalk := TGList.Create;
  g_MapEventListOfRun := TGList.Create;

  InitializeCriticalSection(LogMsgCriticalSection);
  InitializeCriticalSection(ProcessMsgCriticalSection);
  InitializeCriticalSection(ProcessHumanCriticalSection);

  InitializeCriticalSection(g_Config.UserIDSection);
  InitializeCriticalSection(UserDBSection);
  g_DynamicVarList := TSimpleList.Create;

  TimeNow := Now();
  DecodeDate(TimeNow, Year, Month, Day);
  DecodeTime(TimeNow, Hour, Min, Sec, MSec);
  if not DirectoryExists(g_Config.sLogDir) then begin
    CreateDir(g_Config.sLogDir);
  end;

  sLogFileName := g_Config.sLogDir {'.\Log\'} + IntToStr(Year) + '-' + IntToStr2(Month) + '-' + IntToStr2(Day) + '.' + IntToStr2(Hour) + '-' + IntToStr2(Min) + '.txt';
  try
    AssignFile(F, sLogFileName);
    Rewrite(F);
    CloseFile(F);
  except
    on E: Exception do
      MemoLog.Lines.Add(sLogFileName + '::' + e.Message);
  end;
  Caption := '';

  MemoLog.Lines.Add('ڶȡϢ...');

  nShiftUsrDataNameNo := 1;

  DBSocket.Address := g_Config.sDBAddr;
  DBSocket.Port := g_Config.nDBPort;

  CSCheckName.Address := g_Config.sCheckNameAddr;
  CSCheckName.Port := g_Config.nCheckNamePort;

  Caption := g_Config.sServerName;
  sCaption := g_Config.sServerName;
  LoadServerTable();

  IdUDPClientLog.Host := g_Config.sLogServerAddr;
  IdUDPClientLog.Port := g_Config.nLogServerPort;
  IdUDPClientLog.Active := True;
  Application.OnIdle := AppOnIdle;
  Application.OnException := OnProgramException;
  dwRunDBTimeMax := GetTickCount();
  g_dwStartTick := GetTickCount();
  Timer1.Enabled := True;

  boServiceStarted := True;
end;

procedure TFrmMain.StopService;
var
  i: Integer;
  ThreadInfo: pTThreadInfo;
begin
  try
    Timer1.Enabled := False;
    RunTimer.Enabled := False;
    FrmIDSoc.Close;
    GateSocket.Close;
    Memo := nil;
    SaveItemNumber();
    g_CastleManager.Free;
    g_AutoPlayMan.Free;

    DBEngine.Terminate();
    DBEngine.Free;
    MagicManager.Free;

    UserEngine.Free;
    if RobotManage <> nil then
    RobotManage.Free;

    RunSocket.Free;

    ConnectTimer.Enabled := False;
    DBSocket.Close;

    FreeAndNil(MainLogMsgList);
    FreeAndNil(LogStringList);
    FreeAndNil(LogonCostLogList);
    g_MapManager.Free;
    ItemUnit.Free;

    NoticeManager.Free;
    g_GuildManager.Free;

    for i := 0 to g_MakeItemList.Count - 1 do begin
      TStringList(g_MakeItemList.Objects[i]).Free;
    end;
    for i := 0 to g_StartPointList.Count - 1 do begin
      DisPose(pTStartPoint(g_StartPointList.Objects[i]));
    end;
    FreeAndNil(g_StartPointList);
    FreeAndNil(g_SeZiList);
    FreeAndNil(g_MakeItemList);
    FreeAndNil(ServerTableList);
    FreeAndNil(g_DenySayMsgList);
    FreeAndNil(g_MiniMapList);
    FreeAndNil(g_UnbindList);
    FreeAndNil(LineNoticeList);
    FreeAndNil(QuestDiaryList);
    FreeAndNil(ItemEventList);
    FreeAndNil(AbuseTextList);
    FreeAndNil(g_MonSayMsgList);
    FreeAndNil(g_DisableMoveMapList);

    FreeAndNil(g_DisableSayList);
    FreeAndNil(g_UnMasterList);
    FreeAndNil(g_UnForceMasterList);
    FreeAndNil(g_DenyIPAddrList);
    FreeAndNil(g_DenyChrNameList);
    FreeAndNil(g_DenyAccountList);
    FreeAndNil(g_NoClearMonList);
    FreeAndNil(g_PaiMaiManage);
    FreeAndNil(g_BigStorageList);

    for i := 0 to g_ItemBindIPaddr.Count - 1 do begin
      DisPose(pTItemBind(g_ItemBindIPaddr.Items[i]));
    end;
    for i := 0 to g_ItemBindAccount.Count - 1 do begin
      DisPose(pTItemBind(g_ItemBindAccount.Items[i]));
    end;
    for i := 0 to g_ItemBindCharName.Count - 1 do begin
      DisPose(pTItemBind(g_ItemBindCharName.Items[i]));
    end;
    FreeAndNil(g_ItemCheckList);
    FreeAndNil(g_ItemBindIPaddr);
    FreeAndNil(g_ItemBindAccount);
    FreeAndNil(g_ItemBindCharName);

    for i := 0 to g_MapEventListOfDropItem.Count - 1 do begin
      DisPose(pTMapEvent(g_MapEventListOfDropItem.Items[i]));
    end;
    FreeAndNil(g_MapEventListOfDropItem);

    for i := 0 to g_MapEventListOfPickUpItem.Count - 1 do begin
      DisPose(pTMapEvent(g_MapEventListOfPickUpItem.Items[i]));
    end;
    FreeAndNil(g_MapEventListOfPickUpItem);

    for i := 0 to g_MapEventListOfMine.Count - 1 do begin
      DisPose(pTMapEvent(g_MapEventListOfMine.Items[i]));
    end;
    FreeAndNil(g_MapEventListOfMine);

    for i := 0 to g_MapEventListOfWalk.Count - 1 do begin
      DisPose(pTMapEvent(g_MapEventListOfWalk.Items[i]));
    end;
    FreeAndNil(g_MapEventListOfWalk);

    for i := 0 to g_MapEventListOfRun.Count - 1 do begin
      DisPose(pTMapEvent(g_MapEventListOfRun.Items[i]));
    end;
    FreeAndNil(g_MapEventListOfRun);

    DeleteCriticalSection(LogMsgCriticalSection);
    DeleteCriticalSection(ProcessMsgCriticalSection);
    DeleteCriticalSection(ProcessHumanCriticalSection);

    DeleteCriticalSection(g_Config.UserIDSection);
    DeleteCriticalSection(UserDBSection);


    for i := 0 to g_DynamicVarList.Count - 1 do begin
      DisPose(pTDynamicVar(g_DynamicVarList.Items[i]));
    end;
    FreeAndNil(g_DynamicVarList);

    if g_BindItemTypeList <> nil then begin
      for i := 0 to g_BindItemTypeList.Count - 1 do begin
        DisPose(pTBindItem(g_BindItemTypeList.Items[i]));
      end;
      FreeAndNil(g_BindItemTypeList);
    end;

    boServiceStarted := False;
    UnLoadShopItemList;
    IdUDPClientLog.Active := False;

  except
    {on E: Exception do begin
      ShowMessage('Ϣ:' + E.Message);
      Exit;
      raise;
    end; }
  end;
end;

procedure TFrmMain.MENU_HELP_ABOUTClick(Sender: TObject);
begin
  FrmAbout := TFrmAbout.Create(Owner);
  FrmAbout.Open();
  FrmAbout.Free;
end;

procedure TFrmMain.DBSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  //if DBSocket.Active then
    MainOutMessage('ݿ(' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort) + ')ӳɹ...');
end;

procedure TFrmMain.MENU_OPTION_SERVERCONFIGClick(Sender: TObject);
begin
  FrmServerValue := TFrmServerValue.Create(Owner);
  FrmServerValue.Top := Self.Top + 20;
  FrmServerValue.Left := Self.Left;
  FrmServerValue.AdjuestServerConfig();
  FrmServerValue.Free;
end;

procedure TFrmMain.MENU_OPTION_GENERALClick(Sender: TObject);
begin
  frmGeneralConfig := TfrmGeneralConfig.Create(Owner);
  frmGeneralConfig.Top := Self.Top + 20;
  frmGeneralConfig.Left := Self.Left;
  frmGeneralConfig.Open();
  frmGeneralConfig.Free;
  Caption := g_Config.sServerName;
end;

procedure TFrmMain.MENU_OPTION_HEROClick(Sender: TObject);
begin
  frmHeroConfig := TfrmHeroConfig.Create(Owner);
  frmHeroConfig.Top := Top;
  frmHeroConfig.Left := Left;
  frmHeroConfig.Open();
  frmHeroConfig.Free;
end;

procedure TFrmMain.MENU_OPTION_GAMEClick(Sender: TObject);
begin
  frmGameConfig := TfrmGameConfig.Create(Owner);
  frmGameConfig.Top := Self.Top + 20;
  frmGameConfig.Left := Self.Left;
  frmGameConfig.Open;
  frmGameConfig.Free;
end;

procedure TFrmMain.MENU_OPTION_FUNCTIONClick(Sender: TObject);
begin
  frmFunctionConfig := TfrmFunctionConfig.Create(Owner);
  frmFunctionConfig.Top := Self.Top + 20;
  frmFunctionConfig.Left := Self.Left;
  frmFunctionConfig.Open;
  frmFunctionConfig.Free;
end;

procedure TFrmMain.MENU_OPTION_GAMECMDClick(Sender: TObject);
begin
  frmGameCmd := TfrmGameCmd.Create(Owner);
  frmGameCmd.Top := Self.Top + 20;
  frmGameCmd.Left := Self.Left;
  frmGameCmd.Open;
  frmGameCmd.Free;
end;

procedure TFrmMain.MENU_OPTION_MONSTERClick(Sender: TObject);
begin
  frmMonsterConfig := TfrmMonsterConfig.Create(Owner);
  frmMonsterConfig.Top := Self.Top + 20;
  frmMonsterConfig.Left := Self.Left;
  frmMonsterConfig.Open;
  frmMonsterConfig.Free;
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_MONSTERSAYClick(Sender: TObject);
begin
  UserEngine.ClearMonSayMsg();
  LoadMonSayMsg();
  MainOutMessage('¼ع˵...');
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_DISABLEMAKEClick(Sender: TObject);
begin
  LoadDisableMoveMap();
  ItemUnit.LoadCustomItemName();
  LoadDisableAddActionList();
  LoadItemCheckList();
  LoadItemBindIPaddr();
  LoadItemBindAccount();
  LoadItemBindCharName();
  LoadUnMasterList();
  LoadUnForceMasterList();
  LoadDenyIPAddrList();
  LoadDenyAccountList();
  LoadDenyChrNameList();
  LoadNoClearMonList();
  FrmDB.LoadAdminList();
  MainOutMessage('¼б...');
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_STARTPOINTClick(Sender: TObject);
begin
  FrmDB.LoadStartPoint();
  MainOutMessage('µͼȫб...');
end;

procedure TFrmMain.MENU_CONTROL_GATE_OPENClick(Sender: TObject);
const
  sGatePortOpen = 'Ϸض˿(%s:%d)Ѵ...';
begin
  if not GateSocket.Active then begin
    GateSocket.Active := True;
    MainOutMessage(format(sGatePortOpen, [GateSocket.Address, GateSocket.Port]));
  end;
end;

procedure TFrmMain.MENU_CONTROL_GATE_CLOSEClick(Sender: TObject);
begin
  CloseGateSocket();
end;

procedure TFrmMain.CloseGateSocket;
var
  i: Integer;
const
  sGatePortClose = 'Ϸض˿(%s:%d)ѹر...';
begin
  if GateSocket.Active then begin
    for i := 0 to GateSocket.Socket.ActiveConnections - 1 do begin
      GateSocket.Socket.Connections[i].Close;
    end;
    GateSocket.Active := False;
    MainOutMessage(format(sGatePortClose, [GateSocket.Address, GateSocket.Port]));
  end;
end;

procedure TFrmMain.MENU_CONTROLClick(Sender: TObject);
begin
  if GateSocket.Active then begin
    MENU_CONTROL_GATE_OPEN.Enabled := False;
    MENU_CONTROL_GATE_CLOSE.Enabled := True;
  end else begin
    MENU_CONTROL_GATE_OPEN.Enabled := True;
    MENU_CONTROL_GATE_CLOSE.Enabled := False;
  end;
end;

procedure UserEngineProcess(ThreadInfo: pTThreadInfo);
var
  nRunTime: Integer;
  dwRunTick: LongWord;
begin
  l_dwRunTimeTick := 0;
  dwRunTick := GetTickCount();
  ThreadInfo.dwRunTick := dwRunTick;
  while not ThreadInfo.boTerminaled do begin
    nRunTime := GetTickCount - ThreadInfo.dwRunTick;
    if ThreadInfo.nRunTime < nRunTime then ThreadInfo.nRunTime := nRunTime;
    if ThreadInfo.nMaxRunTime < nRunTime then ThreadInfo.nMaxRunTime := nRunTime;
    if GetTickCount - dwRunTick >= 1000 then begin
      dwRunTick := GetTickCount();
      if ThreadInfo.nRunTime > 0 then Dec(ThreadInfo.nRunTime);
    end;

    ThreadInfo.dwRunTick := GetTickCount();
    ThreadInfo.boActived := True;
    ThreadInfo.nRunFlag := 125;
    if G_Config.boThreadRun then
      ProcessGameRun();
    Sleep(1);
  end;
end;



procedure ProcessGameRun();
var
  i: Integer;
begin
  EnterCriticalSection(ProcessHumanCriticalSection);
  try
    UserEngine.PrcocessData;
    g_EventManager.Run;
    RobotManage.Run;
    if GetTickCount - l_dwRunTimeTick > 10000 then begin
      l_dwRunTimeTick := GetTickCount();
      g_GuildManager.Run;
      g_CastleManager.Run;
      g_PaiMaiManage.Run;
      g_DenySayMsgList.Lock;
      try
        for i := g_DenySayMsgList.Count - 1 downto 0 do begin
          if GetTickCount > LongWord(g_DenySayMsgList.Objects[i]) then begin
            g_DenySayMsgList.Delete(i);
          end;
        end;
      finally
        g_DenySayMsgList.UnLock;
      end;
    end;
  finally
    LeaveCriticalSection(ProcessHumanCriticalSection);
  end;
end;

procedure TFrmMain.MENU_VIEW_GATEClick(Sender: TObject);
begin
  MENU_VIEW_GATE.Checked := not MENU_VIEW_GATE.Checked;
  GridGate.Visible := MENU_VIEW_GATE.Checked;
end;

procedure TFrmMain.MENU_VIEW_SESSIONClick(Sender: TObject);
begin
  frmViewSession := TfrmViewSession.Create(Owner);
  frmViewSession.Top := Top + 20;
  frmViewSession.Left := Left;
  frmViewSession.Open();
  frmViewSession.Free;
end;

procedure TFrmMain.MENU_VIEW_ONLINEHUMANClick(Sender: TObject);
begin
  frmViewOnlineHuman := TfrmViewOnlineHuman.Create(Owner);
  frmViewOnlineHuman.Top := Top + 20;
  frmViewOnlineHuman.Left := Left;
  frmViewOnlineHuman.Open();
  frmViewOnlineHuman.Free;
end;

procedure TFrmMain.MENU_VIEW_LEVELClick(Sender: TObject);
begin
  frmViewLevel := TfrmViewLevel.Create(Owner);
  frmViewLevel.Top := Top + 20;
  frmViewLevel.Left := Left;
  frmViewLevel.Open();
  frmViewLevel.Free;
end;

procedure TFrmMain.MENU_VIEW_LISTClick(Sender: TObject);
begin
  frmViewList := TfrmViewList.Create(Owner);
  frmViewList.Top := Top + 20;
  frmViewList.Left := Left;
  frmViewList.Open();
  frmViewList.Free;
end;

procedure TFrmMain.MENU_MANAGE_ONLINEMSGClick(Sender: TObject);
begin
  frmOnlineMsg := TfrmOnlineMsg.Create(Owner);
  frmOnlineMsg.Top := Top + 20;
  frmOnlineMsg.Left := Left;
  frmOnlineMsg.Open();
  frmOnlineMsg.Free;
end;

procedure TFrmMain.SetMenu;
begin
  FrmMain.Menu := MainMenu;
end;

procedure TFrmMain.MENU_VIEW_KERNELINFOClick(Sender: TObject);
begin
  frmViewKernelInfo := TfrmViewKernelInfo.Create(Owner);
  frmViewKernelInfo.Top := Top + 20;
  frmViewKernelInfo.Left := Left;
  frmViewKernelInfo.Open();
  frmViewKernelInfo.Free;
end;

procedure TFrmMain.MENU_TOOLS_MERCHANTClick(Sender: TObject);
begin
  frmConfigMerchant := TfrmConfigMerchant.Create(Owner);
  frmConfigMerchant.Top := Top + 20;
  frmConfigMerchant.Left := Left;
  frmConfigMerchant.Open();
  frmConfigMerchant.Free;
end;

procedure TFrmMain.MENU_OPTION_ITEMFUNCClick(Sender: TObject);
begin
  frmItemSet := TfrmItemSet.Create(Owner);
  frmItemSet.Top := Top + 20;
  frmItemSet.Left := Left;
  frmItemSet.Open();
  frmItemSet.Free;
end;

procedure TFrmMain.ClearMemoLog;
begin
  if Application.MessageBox('Ƿȷ־Ϣ!!!', 'ʾϢ', MB_YESNO + MB_ICONQUESTION) = mrYes then begin
    MemoLog.Lines.SaveToFile('.\MemoLog.txt');
    MemoLog.Clear;
  end;
end;

procedure TFrmMain.MENU_TOOLS_MONGENClick(Sender: TObject);
begin
  frmConfigMonGen := TfrmConfigMonGen.Create(Owner);
  frmConfigMonGen.Top := Top + 20;
  frmConfigMonGen.Left := Left;
  frmConfigMonGen.Open();
  frmConfigMonGen.Free;
end;

procedure TFrmMain.MyMessage(var MsgData: TWmCopyData);
var
  sData: string;
  wIdent: Word;
begin
  wIdent := HiWord(MsgData.From);
  sData := StrPas(PAnsiChar(MsgData.CopyDataStruct^.lpData));
  case wIdent of
    GS_QUIT: begin
        g_boExitServer := True;
        CloseGateSocket();
        CloseTimer.Enabled := True;
      end;
    1: ;
    2: ;
    3: ;
  end;
end;

procedure TFrmMain.MENU_TOOLS_IPSEARCHClick(Sender: TObject);
var
  sIPaddr: string;
begin
  try
    sIPaddr := '192.168.0.1';
    //sIPaddr := InputBox('IPڵѯ', 'IPַ:', '192.168.0.1');
    if not InputQuery('IPڵѯ', 'IPַ:', sIPaddr) then Exit;
    if not IsIPaddr(sIPaddr) then begin
      Application.MessageBox('IPַʽȷ!!!', 'Ϣ', MB_OK + MB_ICONERROR);
      Exit;
    end;
    MemoLog.Lines.Add(format('%s:%s', [sIPaddr, GetIPLocal(sIPaddr)]));
  except
    MemoLog.Lines.Add(format('%s:%s', [sIPaddr, GetIPLocal(sIPaddr)]));
  end;
end;

procedure TFrmMain.MENU_MANAGE_CASTLEClick(Sender: TObject);
begin
  frmCastleManage := TfrmCastleManage.Create(Owner);
  frmCastleManage.Top := Top + 20;
  frmCastleManage.Left := Left;
  frmCastleManage.Open();
  frmCastleManage.Free;
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_QFunctionClick(Sender: TObject);
begin
  if g_FunctionNPC <> nil then begin
    g_FunctionNPC.ClearScript;
    g_FunctionNPC.LoadScript;
    MainOutMessage('QFunction ű...');
  end;
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_QManageClick(Sender: TObject);
begin
  if g_ManageNPC <> nil then begin
    g_ManageNPC.ClearScript;
    g_ManageNPC.LoadScript;
    MainOutMessage('QManage ű...');
  end;
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_RobotNPCClick(Sender: TObject);
begin
  if g_RobotNPC <> nil then begin
    RobotManage.RELOADROBOT();
    g_RobotNPC.ClearScript();
    g_RobotNPC.LoadScript();
    MainOutMessage('¼ػ˽ű...');
  end;
end;

procedure TFrmMain.MENU_MANAGE_SHClick(Sender: TObject);
begin
  FrmShopItem := TFrmShopItem.Create(Owner);
  FrmShopItem.Top := Top + 20;
  FrmShopItem.Left := Left;
  FrmShopItem.Open();
  FrmShopItem.Free;
end;

procedure TFrmMain.MENU_MANAGE_JiShouClick(Sender: TObject);
begin   
  FrmPaiMaiManage := TFrmPaiMaiManage.Create(Owner);
  FrmPaiMaiManage.Top := Top + 20;
  FrmPaiMaiManage.Left := Left;
  FrmPaiMaiManage.Open();
  FrmPaiMaiManage.Free;
end;

procedure TFrmMain.MENU_CONTROL_RELOAD_MonItemsClick(Sender: TObject);
var
  i,ii,iii: Integer;
  Monster: pTMonInfo;
  Mon:TBaseObject;
  MonGenInfo: pTMonGenInfo;
begin
  EnterCriticalSection(ProcessHumanCriticalSection);
  try
    for i := 0 to UserEngine.MonDBList.Count - 1 do begin
      Monster := UserEngine.MonDBList.Items[i];
      FrmDB.LoadMonitems(Monster.sName, Monster.ItemList);
    end;
    for i := 0 to UserEngine.m_MonGenList.Count - 1 do begin
      MonGenInfo := UserEngine.m_MonGenList.Items[i];
      for ii := 0 to MonGenInfo.CertList.Count - 1 do begin
        Mon := TBaseObject(MonGenInfo.CertList.Items[ii]);
        if (Mon = nil) or (Mon.m_boDeath) or(Mon.m_boGhost)or (Mon.m_ItemList.Count = 0) then Continue;
        for iii := 0 to Mon.m_ItemList.Count -1  do begin
          Dispose(pTUserItem(Mon.m_ItemList[iii]));
        end;
        Mon.m_ItemList.Clear;
        UserEngine.MonGetRandomItems(Mon);
      end;
    end;
  finally
    LeaveCriticalSection(ProcessHumanCriticalSection);
  end;
  MemoLog.Lines.Add('¼عﱬ...');
end;

procedure TFrmMain.CSCheckNameConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  MainOutMessage('ּ(' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort) + ')ӳɹ...');
end;

end.


