unit FState;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Math,
  DXDraws,
  SoundUtil,
  MirGrobal,
  ClType,
  ClFunc,
  ClVarConst,
  TyFunc,
  mywil,
  DXWinCtl,
  Actor,
  PlayActor,
  Debug,
  ResManager, //ԴԪ TasNat 2009-02-14 22:38:49
  QuickSearchMap,
  Fui_Std, Fui_Lcj;
const
  MsgDlgBaseX = 324;
var
{$IF Ver_LCJ}
  FrmDlg: Fui_Lcj.TFrmDlg_Lcj;
{$ELSE}
  FrmDlg: Fui_Std.TFrmDlg_Std;
{$IFEND}
  
  ShopTabPage: Integer;
  ShopPage: Integer;
  ShopSetItems: pTShopItem;

  g_GoodsList: TList; //list of PTClientGoods
  g_GoodsItemList: TList;
  BuySetItem: Pointer;
  BoDetailItem: Boolean;
  MenuTopLine: Integer;


  NpcAutoColorPos: Byte;
  NpcAutoColorList: array[0..9] of Byte;
  NpcAutoColorTick: Integer;
  SelMerchant: Integer;
  SJ_BS, SJ_KS, SJ_JLS: TClientItem;
  PaiMaiItem :TClientItem;

  ShaPu_GridTop: Byte = 0;
  ShaPu_SetItem: pTShopItem = nil;
  ChatList: TStringList;
  PChatListTop: ^Integer;
  boSellItem: Boolean = False;



procedure ToggleDWNeiGuaVisible;
procedure DShowMessage(Msg: string);
function DInputBox(Msg: string): string;
procedure DShowNotice(Msg: string);
function DQueryDlg(QueryMsg: string): Boolean;
procedure OpenAdjustAbility;
procedure OpenMyStatus(SPage: byte);
procedure CloseAllWindows;
procedure CloseHeroHealthStateWin;
procedure CloseSelServerWin;
procedure OpenShopDlg;
procedure OpenSellDlg(merchant: Integer; Mode: TSellMode);
procedure ViewBottomBox(Visible: Boolean);
procedure GetMouseItemInfo(Item:TClientItem;var iname, line1, line2, line3, line4, line5, line6: string);

function GetItemItemInfo(const iPos,id :Byte;ShowName:Boolean =False):string;
implementation
uses
  ClMain;

function GetDuraStr(Dura, maxdura: Integer): string;
begin
  Result := IntToStr(Round(Dura / 1000)) + '/' + IntToStr(Round(maxdura / 1000))
end;

{-------------------------------------------------------------------------------
  :    GetItemItemInfo
  :      TasNat
  :      2009.10.14
  ǶʯϢ
  ֵ:    ...
-------------------------------------------------------------------------------}
function GetItemItemInfo(const iPos,id :Byte;ShowName:Boolean =False):string;
var
  i:Integer;
  BaoShi: pTBaoShi;
begin
  Result := '';
  for i := 0 to g_BaoShiList.Count -1 do begin
    BaoShi := pTBaoShi(g_BaoShiList[i]);
    if BaoShi.Source = id then begin
      if not ShowName then
        if iPos <> 255 then
        Result := '&' + inttostr(clAqua) + '&'+'['+inttostr(iPos+1)+']'+BaoShi.Name+'\';

      if BaoShi.AC <> 0 then
        Result := Result+ '\:'+format('%d-%d',[Byte(BaoShi.AC),HiByte(BaoShi.AC)]);
      if BaoShi.MAC <> 0 then
        Result := Result+ '\ħ:'+format('%d-%d',[Byte(BaoShi.MAC),HiByte(BaoShi.MAC)]);
      if BaoShi.DC <> 0 then
        Result := Result+ '\:'+format('%d-%d',[Byte(BaoShi.DC),HiByte(BaoShi.DC)]);
      if BaoShi.MC <> 0 then
        Result := Result+ '\ħ:'+format('%d-%d',[Byte(BaoShi.MC),HiByte(BaoShi.MC)]);
      if BaoShi.SC <> 0 then
        Result := Result+ '\:'+format('%d-%d',[Byte(BaoShi.SC),HiByte(BaoShi.SC)]);
      if BaoShi.btArrFj[1] <> 0 then
      case BaoShi.btArrFj[0] of
        1:Result := Result + '\' + '&' + inttostr(clSkyBlue) + '&ǿ  ' + inttostr(BaoShi.btArrFj[1]) + '%';
        2:Result := Result + '\' + '&' + inttostr(clSkyBlue) + '&ħǿ  ' + inttostr(BaoShi.btArrFj[1]) + '%';
        3:Result := Result + '\' + '&' + inttostr(clSkyBlue) + '&ǿ  ' + inttostr(BaoShi.btArrFj[1]) + '%';
        4:Result := Result + '\' + '&' + inttostr(clSkyBlue) + '&ħǿ  ' + inttostr(BaoShi.btArrFj[1]) + '%';
        5:Result := Result + '\' + '&' + inttostr(clSkyBlue) + '&ǿ  ' + inttostr(BaoShi.btArrFj[1]) + '%';
        6:Result := Result + '\' + '&' + inttostr(clSkyBlue) + '&ǿ  ' + inttostr(BaoShi.btArrFj[1]) + '%';
        7:Result := Result + '\' + '&' + inttostr(clSkyBlue) + '&ħǿ  ' + inttostr(BaoShi.btArrFj[1]) + '%';
      end;

      Exit;
    end;
  end;


end;                                
procedure GetMouseItemInfo(Item:TClientItem;var iname, line1, line2, line3, line4, line5, line6: string);
var
  njob, nlevel, cl, i: Integer;
  CanUse: Boolean;
  astr: string;
  ChaoShu, Level: Byte;
begin

  iname := '';
  line1 := '';
  line2 := '';
  line3 := '';
  line4 := '';
  line5 := '';
  line6 := '';
  astr := '';
  CanUse := False;
  if MySelf = nil then
    Exit;

  with Item do
  if (s.Name <> '') then
  begin
    iname := '&' + inttostr(clYellow) + '&' + s.Name + ' ';
    if MakeIndex < 0 then begin
      line1 := '\&' + inttostr(clSkyBlue) +'&ʹ\ʣ '+ IntToStr(Dura)+'';
      Exit;
    end;
    case s.StdMode of
      0:
        begin  
          case s.Shape of
            0:begin
              if s.AC > 0 then
                line1 := '\+' + IntToStr(s.AC) + ' HP ';
              if s.MAC > 0 then
                line1 := line1 + '\+' + IntToStr(s.MAC) + ' MP';
            end;
            1:begin
              if s.AC + s.MAC > 0 then begin
                line1 := '\˲ָ';
                if s.AC > 0 then
                  line1 := line1 + '\' + IntToStr(s.AC) + ' HP ';
                if s.MAC > 0 then
                  line1 := line1 + '\' + IntToStr(s.MAC) + ' MP';
              end;
            end;
          end;
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight);
        end;
      1..2:begin
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight);
        end;
        3:begin
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight);
          if s.Shape = 12 then begin
            if LoWord(s.DC) > 0 then begin
              line2 := Format(' %d',[LoWord(s.DC)]);
            end;
            if LoWord(s.MC) > 0 then begin
              line2 := line2 + '\'+Format('ħ %d',[LoWord(s.MC)]);
            end;
            if LoByte(s.SC) > 0 then begin
              line2 := line2 + '\'+Format(' %d',[LoWord(s.SC)]);
            end;
            if HiWord(s.AC) > 0 then begin
              line2 := line2 + '\'+Format('ٶ %d',[HiWord(s.AC)]);
            end;
            if LoWord(s.AC) > 0 then begin
              line2 := line2 + '\'+Format('ֵ %d',[LoWord(s.AC)]);
            end;
            if LoWord(s.MAC) > 0 then begin
              line2 := line2 + '\'+Format('ħֵ %d',[LoWord(s.MAC)]);
            end;
            if HiWord(s.MAC) >0 then  line2 := line2 +'\'+IntToStr(HiWord(s.MAC) )+'  ';

          end;
        end;
      4: begin
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight);
          cl := clLime;
          if (MySelf.Job <> s.Shape) then
            cl := clRed;
          line2 := '&' + inttostr(cl) + '&' + GetJobName(s.Shape) + 'ؼ';

          cl := clLime;
          if (MySelf.m_Abil.Level < s.DuraMax) then
            cl := clRed;
          line3 := '&' + inttostr(cl) + '&' + 'Ҫȼ: ' + IntToStr(s.DuraMax);
        end;
      5..6: //
        begin
          if s.NeedIdentify <> 0 then //̵ƼǾ   
            iname := '(*)' + iname;

          line1 := line1 + '\' + ': ' + IntToStr(s.Weight) +
            '\־: ' + GetDuraStr(Dura, DuraMax);
          if s.DC > 0 then
            line2 := ': ' + IntToStr(LoWord(s.DC)) + '-' +
              IntToStr(HiWord(s.DC)) + ' ';
          if s.MC > 0 then
            line2 := line2 + '\' + 'ħ: ' + IntToStr(LoWord(s.MC)) +
              '-' + IntToStr(HiWord(s.MC)) + ' ';
          if s.SC > 0 then
            line2 := line2 + '\' + ': ' + IntToStr(LoWord(s.SC)) +
              '-' + IntToStr(HiWord(s.SC)) + ' ';

          if S.Source > 0 then
            line2 := line2 + '\' + 'ǿ: +' + IntToStr(S.Source) + ' ';
          if S.Source < 0 then
            line2 := line2 + '\' + 'ʥ: +' + IntToStr(Abs(S.Source)) + ' ';

          if HiWord(s.AC) > 0 then
            line3 := line3 + '\' + '׼ȷ: +' + IntToStr(HiWord(s.AC))
              +
              ' ';
          if LoWord(s.AC) > 0 then
            line3 := line3 + '\' + ': +' + IntToStr(LoWord(s.AC))
              + ' ';

          if HiWord(s.MAC) > 0 then
          begin
            if HiWord(s.MAC) > 10 then
              line3 := line3 + '\' + 'ٶ: +' +
                IntToStr(HiWord(s.MAC) - 10) + ' '
            else
              line3 := line3 + '\' + 'ٶ: -' +
                IntToStr(HiWord(s.MAC)) + ' ';
          end;

          if LoWord(s.MAC) > 0 then
            line3 := line3 + '\' + ': +' + IntToStr(LoWord(s.MAC))
              + ' ';
          case s.btNeedType of
            0: begin
                if MySelf.m_Abil.Level >= s.NeedLevel then
                  CanUse := True;
                astr := format('Ҫȼ: %d', [s.NeedLevel]);
              end;
            1: begin
                if HiWord(MySelf.m_Abil.DC) >= s.NeedLevel then
                  CanUse := True;
                astr := format('Ҫ: %d', [s.NeedLevel]);
              end;
            2: begin
                if HiWord(MySelf.m_Abil.MC) >= s.NeedLevel then
                  CanUse := True;
                astr := format('Ҫħ: %d', [s.NeedLevel]);
              end;
            3: begin
                if HiWord(MySelf.m_Abil.SC) >= s.NeedLevel then
                  CanUse := True;
                astr := format('Ҫ: %d', [s.NeedLevel]);
              end;
            //m2֧
            4: //ҪָתȼϲſԴ
              begin
                astr := format('Ҫתȼ: %d', [s.NeedLevel]);
              end;
            5: //ҪָϲſԴ
              begin
                astr := 'Ҫ: ' + IntToStr(s.NeedLevel);
              end;
            6: //л˲ſԴ
              begin
                astr := 'ҪлԱ';
              end;
            7: //ɳǳԱ˲ſԴ
              begin
                astr := 'ҪɳǳԱ';
              end;
            8: //ԱſԴ
              begin
                astr := 'ҪԱ';
              end;
            60: //лŲſԴ
              begin
                astr := 'Ҫл';
              end;

            70: //ɳǳſԴ
              begin
                astr := 'Ҫɳǳ';
              end;
            10: //ҪְָҵָϲſԴ
              begin
                astr := 'Ҫ :' + GetJobName(LoWord(s.NeedLevel)) + ' :' + Inttostr(HiWord(MouseItem.s.NeedLevel));
              end;
            11: //ҪְָҵָħϲſԴ
              begin
                astr := 'Ҫ :' + GetJobName(LoWord(s.NeedLevel)) + ' ħ:' + Inttostr(HiWord(MouseItem.s.NeedLevel));
              end;
            12: //ҪְָҵָϲſԴ
              begin
                astr := 'Ҫ :' + GetJobName(LoWord(s.NeedLevel)) + ' :' + Inttostr(HiWord(MouseItem.s.NeedLevel));
              end;
            40: //ҪָתȼָȼϲſԴ
              begin
                astr := 'Ҫתȼ:' + Inttostr(LoWord(s.NeedLevel)) + ' ȼ:' + Inttostr(HiWord(MouseItem.s.NeedLevel));
              end;
            41: //ҪָתȼָϲſԴ
              begin
                astr := 'Ҫתȼ:' + Inttostr(LoWord(s.NeedLevel)) + ' :' + Inttostr(HiWord(MouseItem.s.NeedLevel));
              end;
            42: //ҪָתȼָħϲſԴ
              begin
                astr := 'Ҫתȼ:' + Inttostr(LoWord(s.NeedLevel)) + ' ħ:' + Inttostr(HiWord(MouseItem.s.NeedLevel));
              end;
            43: //ҪָתȼָϲſԴ
              begin
                astr := 'Ҫתȼ:' + Inttostr(LoWord(s.NeedLevel)) + ' :' + Inttostr(HiWord(MouseItem.s.NeedLevel));
              end;
            44: //ҪָתȼָϲſԴ
              begin
                astr := 'Ҫתȼ:' + Inttostr(LoWord(s.NeedLevel)) + ' :' + Inttostr(HiWord(MouseItem.s.NeedLevel));
              end;
          end;
          cl := clLime;
          if not CanUse then cl := clRed;
          line3 := line3 + '\&' + inttostr(cl) + '&' + astr;
          cl := clLtGray;

          for i := Low(s.btArrXQ) to High(s.btArrXQ) do begin
            if s.btArrXQ[i] > 1 then
            line5 := line5+'\\'+GetItemItemInfo(i,s.btArrXQ[i]);
          end;

          {line6 := '&'+inttostr(clYellow)+'&'+
          Format('%d,%d,%d,%d,%d',[ACBai,MACBai,DCBai,MCBai,SCBai])+'\'; }
        end;
      10, 11, 30: //ڿ, ڿ
        begin
          CanUse := False;
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight) + '\' +
            '\־: ' + GetDuraStr(Dura, DuraMax);

          if s.AC > 0 then
            line2 := ': ' + IntToStr(LoWord(s.AC)) + '-' +
              IntToStr(HiWord(s.AC)) + ' ';
          if s.MAC > 0 then
            line2 := line2 + '\' + 'ħ: ' + IntToStr(LoWord(s.MAC))
              +
              '-' + IntToStr(HiWord(s.MAC)) + ' ';

          if s.DC > 0 then
            line2 := line2 + '\' + ': ' + IntToStr(LoWord(s.DC)) +
              '-' + IntToStr(HiWord(s.DC)) + ' ';
          if s.MC > 0 then
            line2 := line2 + '\' + 'ħ: ' + IntToStr(LoWord(s.MC)) +
              '-' + IntToStr(HiWord(s.MC)) + ' ';
          if s.SC > 0 then
            line2 := line2 + '\' + ': ' + IntToStr(LoWord(s.SC)) +
              '-' + IntToStr(HiWord(s.SC));

          case s.btNeedType of
            0:
              begin
                if MySelf.m_Abil.Level >= s.NeedLevel then
                  CanUse := True;
                astr := 'Ҫȼ: ' + IntToStr(s.NeedLevel);
              end;
            1:
              begin
                if HiWord(MySelf.m_Abil.DC) >= s.NeedLevel then
                  CanUse := True;
                astr := 'Ҫ: ' + IntToStr(s.NeedLevel);
              end;
            2: begin
                if HiWord(MySelf.m_Abil.MC) >= s.NeedLevel then
                  CanUse := True;
                astr := 'Ҫħ: ' + IntToStr(s.NeedLevel);
              end;
            3: begin
                if HiWord(MySelf.m_Abil.SC) >= s.NeedLevel then
                  CanUse := True;
                astr := 'Ҫ: ' + IntToStr(s.NeedLevel);
              end;
          end;
          cl := clLime;
          if not CanUse then cl := clRed;
          line3 := '&' + inttostr(cl) + '&' + astr;
          for i := Low(s.btArrXQ) to High(s.btArrXQ) do begin
            if s.btArrXQ[i] >1 then
            line5 := line5+'\\'+GetItemItemInfo(i,s.btArrXQ[i]);
          end;
        end;
      15, //,
        19, 20, 21, //
        22, 23, //
        24, 26,
        28, 29, 52, 53, 54, 62, 63, 64: //
        begin
          CanUse := False;
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight) + '\־: ' + GetDuraStr(Dura, DuraMax);
          if s.StdMode in [15, 19, 20, 21, 22, 23, 24, 26] then begin
            if s.Shape = 130 then begin
              line2 := '???';
              Exit;
            end;

          end;
          case s.StdMode of
            19: //
              begin
                if s.AC > 0 then
                  line2 := line2 + '\' + 'ħ: +' +
                    IntToStr(HiWord(s.AC)) + '0% ';
                if LoWord(s.MAC) > 0 then
                  line2 := line2 + '\' + ': +' +
                    IntToStr(LoWord(s.MAC)) + ' ';
                if HiWord(s.MAC) > 0 then
                  line2 := line2 + '\' + ': +' +
                    IntToStr(HiWord(s.MAC)) + ' ';
                //
              end;
            20, 24: //
              begin
                if s.AC > 0 then
                  line2 := line2 + '\' + '׼ȷ: +' +
                    IntToStr(HiWord(s.AC)) + ' ';
                if s.MAC > 0 then
                  line2 := line2 + '\' + ': +' +
                    IntToStr(HiWord(s.MAC)) + ' ';
              end;
            21: //
              begin
                if HiWord(s.AC) > 0 then
                  line2 := line2 + '\' + 'ָ: +' +
                    IntToStr(HiWord(s.AC)) + '0% ';
                if HiWord(s.MAC) > 0 then
                  line2 := line2 + '\' + 'ħָ: +' +
                    IntToStr(HiWord(s.MAC)) + '0% ';
                if LoWord(s.AC) > 0 then
                  line2 := line2 + '\' + 'ٶ: +' +
                    IntToStr(LoWord(s.AC)) + ' ';
                if LoWord(s.MAC) > 0 then
                  line2 := line2 + '\' + 'ٶ: -' +
                    IntToStr(LoWord(s.MAC)) + ' ';
              end;
            23: //
              begin
                if HiWord(s.AC) > 0 then
                  line2 := line2 + '\' + ': +' +
                    IntToStr(HiWord(s.AC)) + '0% ';
                if HiWord(s.MAC) > 0 then
                  line2 := line2 + '\' + 'жָ: +' +
                    IntToStr(HiWord(s.MAC)) + '0% ';
                if LoWord(s.AC) > 0 then
                  line2 := line2 + '\' + 'ٶ: +' +
                    IntToStr(LoWord(s.AC)) + ' ';
                if LoWord(s.MAC) > 0 then
                  line2 := line2 + '\' + 'ٶ: -' +
                    IntToStr(LoWord(s.MAC)) + ' ';
              end;
            52: begin
                {if DCBai > 0 then begin
                  line2 := line2 + '\' + ': +' +
                    IntToStr(DCBai) + ' ';
                  DCBai := 0;
                end;     }

              end;
          else //15,26, 28, 29,53, 54, 62, 63, 64
            begin
              if s.AC > 0 then
                line2 := line2 + '\' + ': ' +
                  IntToStr(LoWord(s.AC)) + '-' +
                  IntToStr(HiWord(s.AC)) + ' ';
              if s.MAC > 0 then
                line2 := line2 + '\' + 'ħ: ' +
                  IntToStr(LoWord(s.MAC)) + '-' +
                  IntToStr(HiWord(s.MAC)) + ' ';
            end;
          end;
          if s.DC > 0 then
            line2 := line2 + '\' + ': ' + IntToStr(LoWord(s.DC)) +
              '-' + IntToStr(HiWord(s.DC)) + ' ';
          if s.MC > 0 then
            line2 := line2 + '\' + 'ħ: ' + IntToStr(LoWord(s.MC)) +
              '-' + IntToStr(HiWord(s.MC)) + ' ';
          if s.SC > 0 then
            line2 := line2 + '\' + ': ' + IntToStr(LoWord(s.SC)) +
              '-' + IntToStr(HiWord(s.SC));
          case s.btNeedType of
            0:
              begin
                if MySelf.m_Abil.Level >= s.NeedLevel then
                  CanUse := True;
                astr := 'Ҫȼ: ';
              end;
            1:
              begin
                if HiWord(MySelf.m_Abil.DC) >= s.NeedLevel then
                  CanUse := True;
                astr := 'Ҫ: ';
              end;
            2:
              begin
                if HiWord(MySelf.m_Abil.MC) >= s.NeedLevel then
                  CanUse := True;
                astr := 'Ҫħ: ';
              end;
            3:
              begin
                if HiWord(MySelf.m_Abil.SC) >= s.NeedLevel then
                  CanUse := True;
                astr := 'Ҫ: ';
              end
          else astr := 'Ҫ: ' + inttostr(s.btNeedType) + '/';
          end;
          astr := astr + IntToStr(s.NeedLevel);
          cl := clLime;
          if not CanUse then
            cl := clRed;
          line3 := '&' + inttostr(cl) + '&' + astr;
          for i := Low(s.btArrXQ) to High(s.btArrXQ) do begin
            if s.btArrXQ[i] > 1 then
            line5 := line5+'\\'+GetItemItemInfo(i,s.btArrXQ[i]);
          end;
        end;
      25:
        begin
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight);
          line2 := ': ' + Format('%d/%d',[Dura, DuraMax]);
          if s.NeedLevel <> 0 then begin
            cl := clLime;
            if MySelf.m_Abil.Level < s.NeedLevel then
              cl := clRed;
            line3 := '&' + inttostr(cl) + '&Ҫȼ: ' + IntToStr(s.NeedLevel);
          end;
        end;
      40:
        begin
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight) + '\' +
            'Ʒ: ' + GetDuraStr(Dura, DuraMax);
        end;
      42:
        begin
          line1 := line1 + ': ' + IntToStr(s.Weight) + ' ҩ';
        end;
      43:
        begin
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight) + '\' +
            ': ' + IntToStr(Round(Dura / 1000));
          cl := clAqua;
        end;
      75: begin

          line1 := GetItemItemInfo(255,s.Source,True);
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight) + '\';
        end;
      76: begin //ʯ
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight);

          if s.DC > 0 then
            line1 := line1 + '\' + ': ' + IntToStr(LoWord(s.DC)) +
              '-' + IntToStr(HiWord(s.DC)) + ' ';
          if s.MC > 0 then
            line1 := line1 + '\' + 'ħ: ' + IntToStr(LoWord(s.MC)) +
              '-' + IntToStr(HiWord(s.MC)) + ' ';
          if s.SC > 0 then
            line1 := line1 + '\' + ': ' + IntToStr(LoWord(s.SC)) +
              '-' + IntToStr(HiWord(s.SC));
          if s.AC > 0 then
            line1 := line1 + '\' + ': ' +
              IntToStr(LoWord(s.AC)) + '-' +
              IntToStr(HiWord(s.AC)) + ' ';
          if s.MAC > 0 then
            line1 := line1 + '\' + 'ħ: ' +
              IntToStr(LoWord(s.MAC)) + '-' +
              IntToStr(HiWord(s.MAC)) + ' ';

        end;
      77: begin //ʯ
          line1 := line1 + '\' + ': ' + IntToStr(s.Weight);

        end
    else
      begin
        line1 := line1 + '\' + ': ' + IntToStr(s.Weight);
      end;
    end;

    ChaoShu := 0;

    Level := s.UpLevel;
    for i := Low(s.btArrXQ) to High(s.btArrXQ) do
    begin
      if s.btArrXQ[i] = 1 then
        Inc(ChaoShu);
    end;

    if ChaoShu <> 0 then begin
      line6 := 'Ƕʯ а: ' + IntToStr(ChaoShu)+'\';
    end;
    if Level <> 0 then begin
      cl := clYellow;
      line6 := line6 +'&' + inttostr(cl) + '&';
      for i := 1 to Min(Level, 10) do
      begin
        line6 := line6 + '';
      end;
    end;
    //line6 := line6 + '\'+ IntToStr(s.Looks);
    line6 := line6 + '\'+ GetItemPiHua(s.Name);
  end;
end;

procedure ViewBottomBox(Visible: Boolean);
begin
  FrmDlg.DBottom.Visible := Visible;
{$IF Ver_LCJ}
  FrmDlg.DWChat_Con.Visible := Visible;

  FrmDlg.DWChat_StrList_CloseClick(nil,0,0);
  FrmDlg.DWChat_StrList.Visible := Visible;
  FrmDlg.DWinHPMP.Visible := Visible;
  FrmDlg.DWMiniMap.Visible := Visible;
  FrmDlg.DBMiniMapAll.Visible := Visible;
{$ELSE}

{$IFEND}

end;

procedure CloseSelServerWin;
begin
{$IF Ver_LCJ}
{$ELSE}
  FrmDlg.DSelServerDlg.Visible := False;
{$IFEND}
end;

procedure CloseHeroHealthStateWin;
begin
{$IF Ver_LCJ}
{$ELSE}
  FrmDlg.DWinHeroItem.Visible := False;
{$IFEND}
end;

procedure OpenShopDlg;
begin
{$IF Ver_LCJ}
  if not FrmDlg.DWindowShaPu.Visible then
    FrmDlg.DWindowShaPu.Visible := True;

{$ELSE}
  if not FrmDlg.DShopWin.Visible then
    FrmDlg.DShopWin.Visible := True;
  ShopSetItems := nil;
{$IFEND}
end;

procedure OpenSellDlg(merchant: Integer; Mode: TSellMode);
begin

  CurMerchant := merchant;
  g_SellMode := Mode;
  FrmDlg.ShowShopSellDlg;
{$IF Ver_LCJ}
{$ELSE}
  FrmDlg.CloseDSellDlg;
{$IFEND}
end;

procedure CloseAllWindows;
var
  i: Integer;
  Control: TDXControl;
begin
  with FrmDlg do begin
    for i := 0 to ComponentCount - 1 do begin
      Control := TDXControl(Components[i]);
      if Control.DParent = nil then Continue;
      if (Control is TDXWindow) then begin
      //if Control.Name = 'DBackground' then Continue;

      //if Control.DParent is TDWindow then Continue;//
        Control.Visible := False;
      end;
    end;

{$IF Ver_LCJ}
    CloseItemUp(nil, 0, 0);
{$ELSE}
{$IFEND}
    HideAllControls;
    AutoTalkStr.Clear;
    BossHintStr.Clear;
    enemyHintStr.Clear;
    FriendHintStr.Clear;
    NoattackStr.Clear;
    UserMsgStr.Clear;
    MiniMapIndex := -1;
  end;
  if MDlgX <> -1 then begin
    FrmDlg.CloseMDlg;
    MDlgX := -1;
  end;
  IsItemMoving := False;
end;

procedure OpenMyStatus(SPage: byte);
begin
{$IF Ver_LCJ}
  case SPage of
    0: begin
        FrmDlg.DStateWin.Visible := not FrmDlg.DStateWin.Visible;
      end else FrmDlg.DMagicWindow.Visible := not FrmDlg.DMagicWindow.Visible;
  end;
{$ELSE}
  MySelf.StatePage := SPage;
  FrmDlg.DMyStateWin.Visible := not FrmDlg.DMyStateWin.Visible;
  FrmDlg.MySelfPageChanged;
{$IFEND}
end;

procedure OpenAdjustAbility;
begin
{$IF Ver_LCJ}

{$ELSE}

  FrmDlg.DAdjustAbility.Left := 300;
  FrmDlg.DAdjustAbility.Top := 100;
  SaveBonusPoint := BonusPoint;
  Fillchar(BonusAbilChg, SizeOf(TNakedAbility), #0);
  FrmDlg.DAdjustAbility.Visible := True;
{$IFEND}
end;

procedure ToggleDWNeiGuaVisible;
begin
  FrmDlg.DWNeiGua.Visible := not FrmDlg.DWNeiGua.Visible;
  if FrmDlg.DWNeiGua.Visible then
  else begin
    FrmDlg.Memo.Visible := False;
    FrmDlg.NeiGuaEdit.Visible := False;
  end;
end;

function DInputBox(Msg: string): string;
var
  i: Integer;
  lx, ly: Integer;
  d: TDirectDrawSurface;
begin
  FrmDlg.EdDlgEdit.Visible := True;
  FrmDlg.EdDlgEdit.SetFocus;
  FrmDlg.ViewDlgEdit := True;

  FrmDlg.MsgText := Msg;
  FrmDlg.ViewDlgEdit := FALSE;
  FrmDlg.DMsgDlgOk.Visible := FALSE;
  FrmDlg.DMsgDlgCancel.Visible := FALSE;
{$IF Ver_LCJ}
  d := w16progUse[122];
{$ELSE}
  d := WilPrguse.Images[360];
{$IFEND}

  if d <> nil then begin
    FrmDlg.DMsgDlg.Left := (SCREENWIDTH - d.Width) div 2;
    FrmDlg.DMsgDlg.Top := (SCREENHEIGHT - d.Height) div 2;
    FrmDlg.msglx := 39;
    FrmDlg.msgly := 38;
    lx := MsgDlgBaseX;
    ly := 126;
  end;
  FrmDlg.DMsgDlg.Left := (SCREENWIDTH - FrmDlg.DMsgDlg.Width) div 2;
  FrmDlg.DMsgDlg.Top := (SCREENHEIGHT - FrmDlg.DMsgDlg.Height) div 2;
  FrmDlg.DMsgDlgOk.Left := lx;
  FrmDlg.DMsgDlgOk.Top := ly;
  FrmDlg.DMsgDlgOk.Visible := True;


  FrmDlg.HideAllControls;
  FrmDlg.DMsgDlg.Floating := False;
  with FrmDlg.EdDlgEdit do begin
    Text := '';
    Width := FrmDlg.DMsgDlg.Width - 70;
    Left := (SCREENWIDTH - FrmDlg.EdDlgEdit.Width) div 2;
    Top := (SCREENHEIGHT - FrmDlg.EdDlgEdit.Height) div 2 - 10;
  end;
  FrmDlg.DMsgDlg.ShowModal;
  while True do begin
    if not FrmDlg.DMsgDlg.Visible then
      Break;
    GameWindows.ProcOnIdle;
    Application.ProcessMessages;
    if Application.Terminated then
      Exit;
  end;
  FrmDlg.RestoreHideControls;
  Result := FrmDlg.EdDlgEdit.text;



  if PlayScene.EdChat.Visible then PlayScene.EdChat.SetFocus;
end;

procedure DShowMessage(Msg: string);
var
  i: Integer;
  lx, ly: Integer;
  d: TDirectDrawSurface;
begin
  lx := MsgDlgBaseX;
  ly := 126;

  FrmDlg.HideAllControls;


  FrmDlg.MsgText := Msg;
  FrmDlg.ViewDlgEdit := FALSE;
  FrmDlg.DMsgDlg.Floating := True;
  FrmDlg.DMsgDlgCancel.Visible := FALSE;
  FrmDlg.DMsgDlg.Left := (SCREENWIDTH - FrmDlg.DMsgDlg.Width) div 2;
  FrmDlg.DMsgDlg.Top := (SCREENHEIGHT - FrmDlg.DMsgDlg.Height) div 2;
  FrmDlg.DMsgDlgOk.Left := lx;
  FrmDlg.DMsgDlgOk.Top := ly;
  FrmDlg.DMsgDlgOk.Visible := True;
  lx := lx - 110;
  FrmDlg.DMsgDlg.ShowModal;
  while True do begin
    if not FrmDlg.DMsgDlg.Visible then
      Break;
    GameWindows.ProcOnIdle;
    Application.ProcessMessages;
    if Application.Terminated then
      Exit;
  end;
  FrmDlg.RestoreHideControls;
  if PlayScene.EdChat.Visible then
    PlayScene.EdChat.SetFocus;
end;

procedure DShowNotice(Msg: string);
var
  i: Integer;
  lx, ly: Integer;
  d: TDirectDrawSurface;
begin

  lx := MsgDlgBaseX;
  ly := 126;
{$IF Ver_LCJ}
  d := w16ProgUse[237];
  if d <> nil then begin
    FrmDlg.DMsgDlg.ImageIndex := 0;
    FrmDlg.DMsgDlg.Initialize(w16ProgUse, 237);
    FrmDlg.DMsgDlg.Left := (SCREENWIDTH - d.Width) div 2;
    FrmDlg.DMsgDlg.Top := (SCREENHEIGHT - d.Height) div 2;
    FrmDlg.msglx := 18;
    FrmDlg.msgly := 19;

    lx := 86 ;
    ly := 244;
  end;
{$ELSE}
  d := WilPrguse[380];
  if d <> nil then begin
    FrmDlg.DMsgDlg.Initialize(WilPrguse, 380);
    FrmDlg.DMsgDlg.Left := (SCREENWIDTH - d.Width) div 2;
    FrmDlg.DMsgDlg.Top := (SCREENHEIGHT - d.Height) div 2;
    FrmDlg.msglx := 23;
    FrmDlg.msgly := 35;
    lx := 108;
    ly := 305;
  end;
{$IFEND}
  FrmDlg.DMsgDlgCancel.Visible := False;
  FrmDlg.MsgText := Msg;
  FrmDlg.ViewDlgEdit := FALSE;
  FrmDlg.DMsgDlg.Floating := FALSE;
  FrmDlg.DMsgDlgOk.Visible := FALSE;
  FrmDlg.DMsgDlgOk.Left := lx;
  FrmDlg.DMsgDlgOk.Top := ly;
  FrmDlg.DMsgDlgOk.Visible := True;

  FrmDlg.DMsgDlg.ShowModal;


  FrmDlg.HideAllControls;
  while True do begin
    if not FrmDlg.DMsgDlg.Visible then
      Break;
    GameWindows.ProcOnIdle;
    Application.ProcessMessages;
    if Application.Terminated then
      Exit;
  end;
  FrmDlg.RestoreHideControls;
  if PlayScene.EdChat.Visible then
    PlayScene.EdChat.SetFocus;
    
{$IF Ver_LCJ}
  d := w16ProgUse[122];
  if d <> nil then begin
    FrmDlg.DMsgDlg.ImageIndex := 0;
    FrmDlg.DMsgDlg.Initialize(w16ProgUse, 122);
    FrmDlg.DMsgDlg.Left := (SCREENWIDTH - d.Width) div 2;
    FrmDlg.DMsgDlg.Top := (SCREENHEIGHT - d.Height) div 2;
    FrmDlg.msglx := 39;
    FrmDlg.msgly := 38;
  end;
{$ELSE}
  d := WilPrguse[360];
  if d <> nil then begin
    FrmDlg.DMsgDlg.ImageIndex := 0;
    FrmDlg.DMsgDlg.Initialize(WilPrguse, 360);
    FrmDlg.DMsgDlg.Left := (SCREENWIDTH - d.Width) div 2;
    FrmDlg.DMsgDlg.Top := (SCREENHEIGHT - d.Height) div 2;
    FrmDlg.msglx := 39;
    FrmDlg.msgly := 38;
  end;
{$IFEND}
end;



function DQueryDlg(QueryMsg: string): Boolean;
var
  i: Integer;
  lx, ly: Integer;
  d: TDirectDrawSurface;
begin
  Result := False;
  lx := MsgDlgBaseX;
  ly := 126;
  d := WilPrguse[360];
  with FrmDlg do begin
    if d <> nil then begin
      DMsgDlg.Left := (SCREENWIDTH - d.Width) div 2;
      DMsgDlg.Top := (SCREENHEIGHT - d.Height) div 2;
      msglx := 39;
      msgly := 38;
    end;

    DMsgDlgCancel.Visible := True;
    DMsgDlgOk.Left := lx - 150;
    DMsgDlgOk.Top := ly;
    DMsgDlgOk.Visible := True;

    MsgText := QueryMsg;
    ViewDlgEdit := FALSE;
    DMsgDlg.Floating := True;

    HideAllControls;
    DMsgDlg.ShowModal;


    while True do begin
      if not DMsgDlg.Visible then
        Break;
      GameWindows.ProcOnIdle;
      Application.ProcessMessages;
      if Application.Terminated then
        Exit;
    end;
    RestoreHideControls;
    Result := DMsgDlg.DialogResult;
    if PlayScene.EdChat.Visible then PlayScene.EdChat.SetFocus;
  end;
end;
end.
