unit LNewAccount;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MirGrobal, RzButton, ClMain, RzBmpBtn, jpeg, ExtCtrls,
  JSocket, EDCode, RzForms;

type
  TfrmNewAccount = class(TForm)
    LabelStatus: TLabel;
    Label1: TLabel;
    Image1: TImage;
    Label2: TLabel;
    Label3: TLabel;
    EditAccount: TEdit;
    EditPassword: TEdit;
    EditConfirm: TEdit;
    EditYourName: TEdit;
    EditSSNo: TEdit;
    EditBirthDay: TEdit;
    EditQuiz1: TEdit;
    EditAnswer1: TEdit;
    EditQuiz2: TEdit;
    EditAnswer2: TEdit;
    EditEMail: TEdit;
    EditPhone: TEdit;
    EditMobPhone: TEdit;
    ButtonOK: TRzBmpButton;
    RzBmpButton2: TRzBmpButton;
    MemoHelp: TMemo;
    Timer1: TTimer;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    RzFormShape1: TRzFormShape;
    Label13: TLabel;
    ClientSocket: TClientSocket;
    procedure EditEnter(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure RzBmpButton2Click(Sender: TObject);
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Timer1Timer(Sender: TObject);
    procedure MemoHelpChange(Sender: TObject);
  private
    function CheckUserEntrys(): Boolean;
    function NewIdCheckBirthDay(): Boolean;
    { Private declarations }

  public
    procedure Open(Ip, Pos: string);
    procedure SendNewAccount(ue: TUserEntryInfo);
    procedure DecodeMessagePacket(datablock: string);
  end;

var
  frmNewAccount: TfrmNewAccount;
  NewIdRetryUE: TUserEntryInfo;

  code: Byte = 1;
  busy: Boolean = FALSE;
implementation

uses tyfunc {, EDecode};
var
  dwOKTick: LongWord;

{$R *.dfm}

function TfrmNewAccount.CheckUserEntrys: Boolean;
begin
  Result := False;
  EditAccount.Text := Trim(EditAccount.Text);
  EditQuiz1.Text := Trim(EditQuiz1.Text);
  EditYourName.Text := Trim(EditYourName.Text);
  if Length(EditAccount.Text) < 3 then begin
    Application.MessageBox('¼ʺŵĳȱ3λ', 'ʾϢ', MB_OK + MB_ICONINFORMATION);
    Beep;
    EditAccount.SetFocus;
    exit;
  end;
  if not NewIdCheckBirthday then exit;
  if Length(EditPassword.Text) < 3 then begin
    EditPassword.SetFocus;
    exit;
  end;
  if EditPassword.Text <> EditConfirm.Text then begin
    EditConfirm.SetFocus;
    exit;
  end;
  if Length(EditQuiz1.Text) < 1 then begin
    EditQuiz1.SetFocus;
    exit;
  end;
  if Length(EditAnswer1.Text) < 1 then begin
    EditAnswer1.SetFocus;
    exit;
  end;
  if Length(EditQuiz2.Text) < 1 then begin
    EditQuiz2.SetFocus;
    exit;
  end;
  if Length(EditAnswer2.Text) < 1 then begin
    EditAnswer2.SetFocus;
    exit;
  end;
  if Length(EditYourName.Text) < 1 then begin
    EditYourName.SetFocus;
    exit;
  end;
  Result := True;
end;

procedure TfrmNewAccount.EditEnter(Sender: TObject);
begin
  if Sender = EditAccount then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('ʺſֵַ');
    MemoHelp.Lines.Add('ȱΪ4.');
    MemoHelp.Lines.Add('ϸ봴ʺϢ.');
    MemoHelp.Lines.Add('');
    MemoHelp.Lines.Add('ĵ½ʺŲҪϷ');
    MemoHelp.Lines.Add('еĽɫͬȷ');
    MemoHelp.Lines.Add('벻ᱻƽ⡣');
    exit;
  end;
  if Sender = EditPassword then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('ֵַ,');
    MemoHelp.Lines.Add('볤ȱ4λ.');
    MemoHelp.Lines.Add('ݲҪ');
    MemoHelp.Lines.Add(',Է˲µ.');
    MemoHelp.Lines.Add('');

    MemoHelp.Lines.Add('ס,');
    MemoHelp.Lines.Add('ʧ뽫޷¼Ϸ');
  end;
  if Sender = EditConfirm then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('ٴ');
    MemoHelp.Lines.Add('ȷϡ');
  end;
  if Sender = EditYourName then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('ȫ.');
  end;
  if Sender = EditSSNo then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('֤');
    MemoHelp.Lines.Add('磺 720101-146720');
  end;
  if Sender = EditBirthDay then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('');
    MemoHelp.Lines.Add('ʽ://');
    MemoHelp.Lines.Add(':1987/10/29');
  end;
  if Sender = EditQuiz1 then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('һʾ');
    MemoHelp.Lines.Add('ʾ붪ʧ');
    MemoHelp.Lines.Add('һá');
    MemoHelp.Lines.Add('');
  end;
  if Sender = EditAnswer1 then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('');
    MemoHelp.Lines.Add('𰸡');
    MemoHelp.Lines.Add('');
  end;
  if Sender = EditQuiz2 then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('ڶʾ');
    MemoHelp.Lines.Add('ʾ붪ʧ');
    MemoHelp.Lines.Add('һá');
    MemoHelp.Lines.Add('');
  end;
  if Sender = EditAnswer2 then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('');
    MemoHelp.Lines.Add('𰸡');
    MemoHelp.Lines.Add('');
  end;
  if Sender = EditPhone then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('ĵ绰');
    MemoHelp.Lines.Add('롣');
    MemoHelp.Lines.Add('');
  end;
  if Sender = EditMobPhone then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('ֻ롣');
    MemoHelp.Lines.Add('');
  end;
  if Sender = EditEMail then begin
    MemoHelp.Clear;
    MemoHelp.Lines.Add('ʼַ');
    MemoHelp.Lines.Add('µһЩ');
    MemoHelp.Lines.Add('Ϣ');
  end;
end;

function TfrmNewAccount.NewIdCheckBirthDay: Boolean;
var
  str, t1, t2, t3, syear, smon, sday: string;
  ayear, amon, aday, sex: integer;
  flag: Boolean;
begin
  Result := TRUE;
  flag := TRUE;
  str := EditBirthDay.Text;
  str := GetValidStr3(str, syear, ['/']);
  str := GetValidStr3(str, smon, ['/']);
  str := GetValidStr3(str, sday, ['/']);
  ayear := Str_ToInt(syear, 0);
  amon := Str_ToInt(smon, 0);
  aday := Str_ToInt(sday, 0);
  if (ayear <= 1890) or (ayear > 2101) then flag := FALSE;
  if (amon <= 0) or (amon > 12) then flag := FALSE;
  if (aday <= 0) or (aday > 31) then flag := FALSE;
  if not flag then begin
    Beep;
    EditBirthDay.SetFocus;
    Result := FALSE;
  end;
end;

procedure TfrmNewAccount.ButtonOKClick(Sender: TObject);
begin
  if GetTickCount - dwOKTick < 5000 then begin
    Application.MessageBox('Ժٵȷ', 'ʾϢ', MB_OK + MB_ICONINFORMATION);
    exit;
  end;
  if CheckUserEntrys then begin
    FillChar(NewIdRetryUE, sizeof(TUserEntryInfo), #0);
    NewIdRetryUE.sLoginID := LowerCase(EditAccount.Text);
    NewIdRetryUE.sPassword := EditPassword.Text;
    NewIdRetryUE.sUserName := EditYourName.Text;
    NewIdRetryUE.sSSNo := '650101-1455111';
    NewIdRetryUE.sQuiz := EditQuiz1.Text;
    NewIdRetryUE.sAnswer := Trim(EditAnswer1.Text);
    NewIdRetryUE.sPhone := EditPhone.Text;
    NewIdRetryUE.sEMail := Trim(EditEMail.Text);
    NewIdRetryUE.sQuiz2 := EditQuiz2.Text;
    NewIdRetryUE.sAnswer2 := Trim(EditAnswer2.Text);
    NewIdRetryUE.sBirthday := EditBirthday.Text;
    NewIdRetryUE.sMobilePhone := EditMobPhone.Text;

    SendNewAccount(NewIdRetryUE);
    //dwOKTick:=GetTickCount();
  end;
end;

procedure TfrmNewAccount.SendNewAccount(ue: TUserEntryInfo);
var
  Str: string;
  Msg: TDefaultMessage;
begin
  msg := MakeDefaultMsg(CM_AccountCreate, 0, 0, 0, 0);
  Str := (IntToStr(1) +
    EncodeMessage(msg) +
    EncodeBuffer(@ue, SizeOf(TUserEntryInfo)));

  if ClientSocket.Socket.Connected then
  begin
    ClientSocket.Socket.SendText('#' + Str + '!');
  end;
end;


procedure TfrmNewAccount.Open(Ip, Pos: string);
begin
  ButtonOK.Enabled := True;
  ClientSocket.Close;
  ClientSocket.Port := 7000;
  ClientSocket.Address := Ip;
  ClientSocket.Open;
  EditAccount.Text := '';
  EditPassword.Text := '';
  EditConfirm.Text := '';
  EditYourName.Text := '';
  EditBirthDay.Text := '';
  EditQuiz1.Text := '';
  EditAnswer1.Text := '';
  EditQuiz2.Text := '';
  EditAnswer2.Text := '';
  EditEMail.Text := '';
  EditPhone.Text := '';
  EditMobPhone.Text := '';
  ShowModal;
end;

procedure TfrmNewAccount.RzBmpButton2Click(Sender: TObject);
begin
  close;
end;

procedure TfrmNewAccount.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  n: Integer;
  data, data2: string;
begin
  data := Socket.ReceiveText;
  n := Pos('*', data);
  if n > 0 then begin
    data2 := Copy(data, 1, n - 1);
    data := data2 + Copy(data, n + 1, Length(data));
    ClientSocket.Socket.SendText('*');
  end;
  SocStr := SocStr + data;

end;

procedure TfrmNewAccount.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ErrorCode := 0;
  Socket.close;
end;

procedure TfrmNewAccount.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Label2.Font.Color := clLime;
  Label2.Caption := '״̬...';
  LabelStatus.Caption := Label2.Caption;
end;

procedure TfrmNewAccount.DecodeMessagePacket(datablock: string);
var
  head, body, body2, tagstr, data, rdstr, str: string;
  Msg: TDefaultMessage;
  smsg: TShortMessage;
  mbw: TMessageBodyW;
  desc: TCharDesc;
  wl: TMessageBodyWL;
  featureEx: word;
  L, I, j, n, BLKSize, param, sound, cltime, svtime: Integer;
  tempb: Boolean;
begin
  if datablock[1] = '+' then begin
    Exit;
  end;
  if Length(datablock) < DEFBLOCKSIZE then begin
    Exit;
  end;
  head := Copy(datablock, 1, DEFBLOCKSIZE);
  body := Copy(datablock, DEFBLOCKSIZE + 1, Length(datablock) - DEFBLOCKSIZE);
  Msg := DecodeMessage(head);
  case Msg.Ident of
    SM_NEWID_SUCCESS: begin
        Application.MessageBox('ʺŴɹ' + #13 +
          'Ʊʺź룬' + #13 + 'ҲҪκԭʺźκˡ' + #13 +
          ',ͨǵҳһء', 'ʾϢ', MB_OK);
        close;
      end;
    SM_NEWID_FAIL: begin
        case Msg.Recog of
          0: begin
              str := NewIdRetryUE.sLoginID;
              Application.MessageBox(
                PChar('ʺ "' + str + '" ѱʹˡ'),
                PChar('ʾϢ'), MB_OK);
            end;
          -2: Application.MessageBox('ʺֹʹã', 'ʾϢ', MB_OK);
        else Application.MessageBox(PChar('ʺŴʧܣȷʺǷո񡢼ǷַCode: ' + IntToStr(Msg.Recog)), 'ʾϢ', MB_OK);
        end;
        ButtonOK.Enabled := true;
        Exit;
      end;
    ////////////////////////////////////////////////////////////////////////////////
    {SM_CHGPASSWD_SUCCESS: begin
        Application.MessageBox('޸ĳɹ', 'ʾϢ', MB_OK);
        frmChangePassword.ButtonOK.Enabled := FALSE;
        //frmNewAccount.Close;
        Exit;
      end;
    SM_CHGPASSWD_FAIL: begin
        case Msg.Recog of
          0: Application.MessageBox('ʺŲڣ', 'ʾϢ', MB_OK);
          -1: Application.MessageBox('ԭʼ벻ȷ', 'ʾϢ', MB_OK);
          -2: Application.MessageBox('ʺű', 'ʾϢ', MB_OK);
          else Application.MessageBox('볤Сλ', 'ʾϢ', MB_OK);
        end;
        frmChangePassword.ButtonOK.Enabled := true;
        Exit;
      end;
    SM_GETBACKPASSWD_SUCCESS: begin
        Application.MessageBox(PChar('һسɹ'+DecodeString(body)), 'ʾϢ', MB_OK);
        Exit;
      end;
    SM_GETBACKPASSWD_FAIL: begin
        case Msg.Recog of
          0: Application.MessageBox('ʺŲڣ', 'ʾϢ', MB_OK + MB_ICONERROR);
          -1: Application.MessageBox('𰸲ȷ', 'ʾϢ', MB_OK + MB_ICONERROR);
          -2: Application.MessageBox(PChar('ʺű' + #13 + 'Ժһء'), 'ʾϢ', MB_OK + MB_ICONERROR);
          -3: Application.MessageBox('벻ȷ', 'ʾϢ', MB_OK + MB_ICONERROR);
          else Application.MessageBox('δ֪', 'ʾϢ', MB_OK + MB_ICONERROR);
        end;
        frmGetBackPassword.ButtonOK.Enabled := true;
        Exit;
      end;  }
  end;
end;

procedure TfrmNewAccount.Timer1Timer(Sender: TObject);
var
  str, data: string;
  len, I, n, mcnt: Integer;
begin
  if busy then Exit;
  busy := true;
  try
    BufferStr := BufferStr + SocStr;
    SocStr := '';
    if BufferStr <> '' then begin
      mcnt := 0;
      while Length(BufferStr) >= 2 do begin
        if Pos('!', BufferStr) <= 0 then break;
        BufferStr := ArrestStringEx(BufferStr, '#', '!', data);
        if data <> '' then begin
          DecodeMessagePacket(data);
        end else
          if Pos('!', BufferStr) = 0 then
            break;
      end;
    end;
  finally
    busy := FALSE;
  end;

end;

procedure TfrmNewAccount.MemoHelpChange(Sender: TObject);
begin
  Label13.Caption := MemoHelp.Text;

end;

end.
