{*******************************************************}
{                                                       }
{       ɫʵֵԪ                              }
{                                                       }
{       Ȩ (C) 2009 TasNat                        }
{                                                       }
{*******************************************************}

unit PlayActor;

interface

uses
  SysUtils,
  Windows,
  Classes,
  Graphics,
  Forms,


  EDCode,
  magiceff,
  ClType,
  TyFunc, //ͨú
  ClFunc,
  ClVarConst,
  SoundUtil,
  MirGrobal,
  Actor;

type
  { TPlayActor }

  TPlayActor = class(THumActor)
  private

  protected

  public
    AutoMoveX, AutoMoveY: Integer;
    LatestSpellTime: longword;
    LatestFireHitTime: longword;
    LatestRushRushTime: longword;
    GetItemOK: Boolean;
    Level: Word;
    gold: Integer;
    MagicCur, MagicTop, MagicPage: Integer;
    StatePage: Integer;
    ActionFailLock: Boolean;
    FailAction, FailDir: Integer;
    ActionLock: Boolean;
    ActionLockTime: longword;
    LastHitTime: longword;
    MagicList: TList;
    ItemArr: array[0..MAXBAGITEMCL - 1] of TClientItem;
    UseItems: array[0..12] of TClientItem;
    btSpeedPoint,
      btHitPoint,
      btAntiPoison,
      btPoisonRecover,
      btHealthRecover,
      btSpellRecover,
      btAntiMagic: Byte;
    procedure UPSubAbility(msg: pTDefaultMessage);
    procedure AutoEatItem;
    procedure EatItem(idx: Integer);

    procedure AttackTarget(target: TActor);
    procedure ActionFailed;

    procedure Pickup;
    procedure UpdateItem(body: string);

    procedure GetSenduseItems(body: string);
    function FindItem(MakeIndex:Integer):pTClientItem;
    procedure AddItem(body: string);
    procedure DelItem(body: string;MakeIndex:Integer);
    procedure DelItems(body: string);
    procedure GetBagItmes(body: string);
    procedure AddMagic(body: string);
    procedure DelMagic(magid: Integer);
    procedure GetMagics(body: string);
    procedure GetMagicLvExp(magid, maglv, magtrain: Integer);
    procedure DuraChange(uidx, newdura, newduramax: Integer);
    procedure TurnDuyao;
    procedure TurnDuFu(pcm: PTClientMagic);
    procedure UseMagic(tx, ty: Integer; pcm: PTClientMagic);
    procedure UseHeroMagic(tx, ty: Integer; MagicID: Byte);
    procedure Eat(itmindex: Integer; itmname: string);
    procedure TakeOnItem(where: Byte; itmindex: Integer; itmname: string);
    procedure TakeOffItem(where: Byte; itmindex: Integer; itmname: string);
    procedure SpellMsg(ident, X, Y, Dir, target: Integer);
    procedure ArrangeItembag;
    procedure ClearBag;

    function IsBagFull:Boolean;
    function UpdateItemBag(cu: TClientItem): Boolean;


    function Move: Boolean;override;
    function ActionFinished: Boolean;//ɻû true
    function ServerAcceptNextAction: Boolean;
    function CanNextHit: Boolean;
    function IsUnLockAction(Action, adir: Integer): Boolean;
    function CanNextAction: Boolean;
    function CanNextAction1: Boolean;
    function AddItemBag(cu: TClientItem): Boolean;
    function EatByName(Name: string): Boolean;
    function Dig: Boolean;
    function AutoLieHuo: Boolean;
    function GetMagicByKey(Key: Char): PTClientMagic;
    function GetMagicById(Magid: Byte): PTClientMagic;
    function DelBagItem(iname: string; iindex: Integer): Boolean;

    constructor Create; override;
    destructor Destroy; override;

    property NowX: SmallInt read XX;
    property NowY: SmallInt read YY;
  end;
function TurnItemToNew(Body: string): TClientItem;
function TurnAbilToNew(Body: string): TAbility;
implementation

uses
  PlayScn,
  FState,
  ClMain;


function TurnItemToNew(Body: string): TClientItem;
var
  NewItem: TClientItem;

begin
  DecodeBuffer(body, @NewItem, SizeOf(TClientItem));

  Result := NewItem;

end;

function TurnAbilToNew(Body: string): TAbility;
var
  Ability: TAbility;
begin

  DecodeBuffer(body, @Ability, SizeOf(TAbility));
  Result := Ability;
end;



constructor TPlayActor.Create;
begin
  inherited;
  LatestSpellTime := GetTickCount;
  LatestFireHitTime := 0;
  LatestRushRushTime := 0;
  GetItemOK := False;
  gold := 0;
  Level := 0;
  MagicCur := 0;
  MagicTop := 0;
  MagicPage := 0;
  StatePage := 0;
  Fillchar(UseItems, SizeOf(UseItems), #0);
  Fillchar(ItemArr, SizeOf(ItemArr), #0);
  MagicList := TList.Create;
  ActionFailLock := False;
  FailAction := 0;
  FailDir := 0;
  ActionLock := False;
  ActionLockTime := 0;
  LastHitTime := 0;
  AutoMoveX := -1;
  AutoMoveY := -1;
  btSpeedPoint := 0;
  btHitPoint := 0;
  btAntiPoison := 0;
  btPoisonRecover := 0;
  btHealthRecover := 0;
  btSpellRecover := 0;
  btAntiMagic := 0;
end;

destructor TPlayActor.Destroy;
var
  i: Integer;
begin
  for i := 0 to MagicList.Count - 1 do
    Dispose(PTClientMagic(MagicList[i]));
  MagicList.Free;
  inherited;
end;

procedure TPlayActor.UPSubAbility(msg: pTDefaultMessage);
begin
  if msg = nil then Exit;
  btHitPoint := Lobyte(msg.param);
  btSpeedPoint := Hibyte(msg.param);
  btAntiPoison := Lobyte(msg.tag);
  btPoisonRecover := Hibyte(msg.tag);
  btHealthRecover := Lobyte(msg.series);
  btSpellRecover := Hibyte(msg.series);
  btAntiMagic := Lobyte(Loword(msg.Recog));
  btAntiMagic := Lobyte(Loword(msg.Recog));
end;
function TPlayActor.IsBagFull:Boolean;
var
  i:Integer;
begin                
  Result  := True;
  for i := Low(ItemArr) to High(ItemArr) do
  begin
    if ItemArr[i].s.Name = '' then begin
      Result := False;
      Break;
    end;
  end;
end;
function TPlayActor.FindItem(MakeIndex:Integer):pTClientItem;
var
  I:Integer;
begin
  Result := nil;
  for i := 0 to MAXBAGITEMCL - 1 do begin
    if (ItemArr[i].MakeIndex = MakeIndex) then begin
      Result := @ItemArr[i];
      Exit;
    end;
  end;


end;  
function TPlayActor.AddItemBag(cu: TClientItem): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := 0 to MAXBAGITEMCL - 1 do begin
    if (ItemArr[i].MakeIndex = cu.MakeIndex) and (ItemArr[i].s.Name = cu.s.Name)
      then begin
      Exit;
    end;
  end;
  //DScreen.AddChatBoardString(Self.UserName+':'+cu.s.Name,255,65535);
  if cu.s.Name = '' then
    Exit;
  if cu.s.StdMode <= 3 then begin

    for i := 0 to {$IF Ver_LCJ}7{$ELSE}5{$IFEND} do
      if ItemArr[i].s.Name = '' then begin
        ItemArr[i] := cu;
        Result := True;
        Exit;
      end;
  end;
  for i := {$IF Ver_LCJ}8{$ELSE}6{$IFEND} to MAXBAGITEMCL - 1 do begin
    if ItemArr[i].s.Name = '' then begin
      ItemArr[i] := cu;
      Result := True;
      Break;
    end;
  end;
  ArrangeItembag;
end;


procedure TPlayActor.ArrangeItembag;
var
  i, k: Integer;
begin
  for i := 0 to MAXBAGITEMCL - 1do begin
    if ItemArr[i].s.Name <> '' then begin
      for k := i + 1 to MAXBAGITEMCL - 1do begin
        if (ItemArr[i].s.Name = ItemArr[k].s.Name) and (ItemArr[i].MakeIndex =
          ItemArr[k].MakeIndex) then begin
          Fillchar(ItemArr[k], SizeOf(TClientItem), #0);
        end;
      end;

      if (ItemArr[i].s.Name = MovingItem.Item.s.Name) and
         (ItemArr[i].MakeIndex = MovingItem.Item.MakeIndex) then begin
        MovingItem.Index := 0;
        MovingItem.Item.s.Name := '';
      end;
    end;
  end;
end;

procedure TPlayActor.EatItem(idx: Integer);
var
  i, oldidx: Integer;
  ACount, Ocount, Count, where: Integer;
  str: string;
label
  Ok;
begin

  if (EatingItem.s.Name <> '') and (GetTickCount - EatTime > 5 * 1000) then begin
    EatingItem.s.Name := '';
  end;
  oldidx := idx;
  if oldidx > -1 then
    EatingItem := ItemArr[oldidx];
  if (oldidx = -1) and IsItemMoving then begin
    IsItemMoving := False;
    EatingItem := MovingItem.Item;
    MovingItem.Index := -1;
    MovingItem.Item.s.Name := '';
    oldidx := ItemMoveIndex;
  end;

  if EatingItem.s.Name = '' then exit;
  if (EatingItem.s.StdMode > 4) and (EatingItem.s.StdMode <> 31) then begin
    where := GetTakeOnPosition(EatingItem.s.StdMode);
    if where in [0..12] then begin
      if (U_RINGL = where) or (U_ARMRINGL = where) then begin
        if UseItems[where].s.Name = EatingItem.s.Name then Inc(where)
        else Inc(where, Random(1));
      end;
      WaitingUseItem.Item := EatingItem;
      WaitingUseItem.Index := where;

      ItemArr[ItemMoveIndex].s.Name := '';
      TakeOnItem(where, EatingItem.MakeIndex, EatingItem.s.Name);
    end else AddItemBag(EatingItem);
    Exit;
  end;

  if (EatingItem.s.StdMode = 4) and (EatingItem.s.Shape < 100) then begin

    if EatingItem.s.Shape < 50 then begin
      if not DQueryDlg('"' + EatingItem.s.Name +
        '"  Ҫʼѧϰü') then begin
        AddItemBag(EatingItem);
        Exit;
      end;
      EatTime := GetTickCount;
      Eat(EatingItem.MakeIndex, EatingItem.s.Name);
    end;
  end;
  if (EatingItem.s.Name <> '') and ((EatingItem.s.StdMode <> 4)) then begin
    Eat(EatingItem.MakeIndex, EatingItem.s.Name);
    EatTime := GetTickCount;
    ItemArr[OldIdx].s.Name := '';
    ItemUseSound(EatingItem.s.StdMode);

    Count := 0;
    if (EatingItem.s.Name <> '') and (neigua.Base.AutoPut = 1) and (ServerSetup.Base.AutoPut > 0) and (oldidx > -1) and (oldidx < {$IF Ver_LCJ}8{$ELSE}6{$IFEND}) then begin
      for i := {$IF Ver_LCJ}8{$ELSE}6{$IFEND} to MAXBAGITEMCL - 1 do begin
        if EatingItem.s.Name = ItemArr[i].s.Name then begin
          ItemArr[oldidx] := ItemArr[i];
          ItemArr[i].s.Name := '';
          goto Ok;
        end;
      end;
    end;
    count := 0;
    //if i < MAXBAGITEMCL then begin
      for i := {$IF Ver_LCJ}8{$ELSE}6{$IFEND} to MAXBAGITEMCL - 1 do begin
        if ItemArr[i].s.Name = EatingItem.s.Name then
          Inc(Count);
      end;

      (*for i := 0 to {$IF Ver_LCJ}8{$ELSE}6{$IFEND} -1 do begin
        if ItemArr[i].s.Name = EatingItem.s.Name then
          Inc(Count);
      end; *)
    //end;

    if (Count = 0) then begin

      ACount := 0;
      for i := 0 to MAXBAGITEMCL - 1 do begin
        if ItemArr[i].s.Name = '' then
          Inc(ACount);
      end;
      if (EatingItem.s.StdMode = 0) and (ACount > 4) and
      (neigua.Base.AutoTearOpen = 1) and (ServerSetup.Base.AutoTearOpen > 0) then begin
        i := TearGoodsName.IndexOf(EatingItem.s.Name);
        if i >= 0 then
          str := TearGoods[i];

        for i := {$IF Ver_LCJ}8{$ELSE}6{$IFEND} to MAXBAGITEMCL - 1 do begin
          if (ItemArr[i].s.Name = str) then begin
            Eat(ItemArr[i].MakeIndex, ItemArr[i].s.Name);
            ItemArr[i].s.Name := '';
            Count := 5;
            goto Ok;
          end;
        end;

      end;
      if ACount <= 4 then
        DScreen.AddChatBoardString('ռ䲻', clWhite, ClRed);

    end;

    if Oldidx > -1 then begin
      for i := 0 to {$IF Ver_LCJ}7{$ELSE}5{$IFEND} do begin
        if i = oldIdx then Continue;
        if EatingItem.s.Name = ItemArr[i].s.Name then begin
          ItemArr[oldidx] := ItemArr[i];
          ItemArr[i].s.Name := '';
          Break;
        end;
      end;
    end;
  end;
  Ok:
  if (EatingItem.s.Name <> '') then begin
    count := 0;
    for i := 0 to MAXBAGITEMCL - 1 do begin
      if EatingItem.s.Name = ItemArr[i].s.Name then
        Inc(Count);
    end;
    {if (Count > 0) then
      DScreen.AddChatBoardString('ʹ' + EatingItem.s.Name + '(ʣ:' + IntToStr(Count) + ')', clGreen, clWhite)
    else
      DScreen.AddChatBoardString(EatingItem.s.Name + ' ꣬뼰ʱ䣡', ClRed, clWhite);
    }
    ItemUseSound(EatingItem.s.StdMode);
  end;
end;

function TPlayActor.EatByName(Name: string): Boolean;
var
  i: Integer;
  Actor: TPlayActor;
begin
  Result := False;
  Actor := MySelf;
  if (Name = 'С') and (Actor.HiterCode > 0) then begin
    DScreen.ClearHint;
    CloseAllWindows;
    if not BoOneClick then begin
      SoftClosed := True;
      GameWindows.ActiveCmdTimer(tcReSelConnect);
    end
    else begin
      GameWindows.ActiveCmdTimer(tcReSelConnect);
    end;

    Map.CurrentMap := '';
    GameWindows.SendClientMessage(CM_SOFTCLOSE, 0, 0, 0, 0);
    Exit;
  end;
  if (Name = '') and (Actor.HiterCode > 0) then begin
    DScreen.ClearHint;
    GameWindows.SaveNeiGua(CharName, 1);
    Application.Terminate;
    Exit;
  end;

  for i := 0 to MAXBAGITEMCL - 1 do begin
    if (Actor.ItemArr[i].s.Name = Name) then begin
      MySelf.EatItem(i);
      Result := True;
      Exit;
    end;
  end;
end;

function TPlayActor.CanNextAction: Boolean;
begin
  if ((CurrentAction = 0) and (MsgList.Count = 0)) and
    (State and $04000000 = 0)
    and (GetTickCount - DizzyDelayStart > DizzyDelayTime)
    and LockEndFrame
    then begin
    Result := True;
  end;

end;

//100 0000 0000 0000 0000 0000 0000
function TPlayActor.CanNextAction1: Boolean;
begin
  Result := (IsIdle)and (GetTickCount - DizzyDelayStart > DizzyDelayTime);
  if Result then begin
    if (State and $04000000 = 0) then
      Result := True
    else
      if Neigua.Base.Nopalsy = 1 then             
        Result := True
      else
        Result := False;
  end;
end;
function TPlayActor.Move: Boolean;
var
  i:Integer;
begin
  Result :=inherited Move;
  if Result then begin


  end;
end;

procedure TPlayActor.AttackTarget(target: TActor);
var
  tdir, dx, dy, nHitMsg: Integer;
begin
  AutoMoveX := -1;
  nHitMsg := CM_HIT;
  if UseItems[U_WEAPON].s.StdMode = 6 then
    nHitMsg := CM_HEAVYHIT;
  tdir := GetNextDirection(MySelf.NowX, MySelf.Nowy, target.XX, target.yy);
  if (abs(MySelf.NowX - target.XX) <= 1) and
     (abs(MySelf.Nowy - target.yy) <= 1) and
     (not target.Death) then begin
    if CanNextAction1 and ServerAcceptNextAction and CanNextHit then begin
      if (Neigua.Work.AutoChi = 1) and
      (neigua.Work.AutoChiType = 1) then begin
        g_ChrAction := cawalk;
        dx := target.XX;
        dy := target.yy;
        tdir := target.Dir;
        GetNextRunXY(tdir, dx, dy);
        AutoMoveX := dx;
        AutoMoveY := dy;
        exit;
      end;

      if BoNextTimeFireHit and (MySelf.m_Abil.MP >= 7) then begin
        BoNextTimeFireHit := False;
        nHitMsg := CM_FIREHIT;
      end
      else
        if BoNextTimePowerHit then begin
          BoNextTimePowerHit := False;
          nHitMsg := CM_POWERHIT;
        end
        else
          if BoCanWideHit and (MySelf.m_Abil.MP >= 3) then begin

            if (Neigua.Work.AIBanYue = 1) and (MySelf.Job = 0) then begin
              if (GameWindows.TargetInSwordWideAttackRange(tdir)) then
                nHitMsg := CM_WIDEHIT
              else
                if (GetMagicById(12)<> nil)and(NeiGua.Work.DaoDaoChi = 1) then
                  nHitMsg := CM_LONGHIT;
            end
            else
              nHitMsg := CM_WIDEHIT;
          end
          else
            if (BoCanLongHit or ((GetMagicById(12)<> nil)and(NeiGua.Work.DaoDaoChi = 1) and
            (MySelf.Job = 0))) and (GameWindows.TargetInSwordLongAttackRange(tdir)) then begin
              nHitMsg := CM_LONGHIT;
            end;

      if (NeiGua.Work.AutoLie = 1) and (MySelf.Job = 0) then
        AutoLieHuo;
      if BoDoubleDragon then
        nHitMsg := CM_40HIT;
      if BoKuangfeng then
        nHitMsg := CM_42HIT;
      if BoPokongjian then
        nHitMsg := CM_43HIT;

      MySelf.AddAction(nHitMsg, MySelf.NowX, MySelf.Nowy, tdir, 0, 0, '', 0);
      LatestHitTime := GetTickCount;
    end;
    AutoMoveX := -1;
    LastAttackTime := GetTickCount;
  end
  else begin
    if (GameWindows.TargetInSwordLongAttackRange1(MySelf.NowX, MySelf.Nowy, Target.XX, Target.yy)) and
    (not target.Death) and (Neigua.Work.AutoChi = 1) and ((MySelf.Job = 0)and (GetMagicById(12)<> nil)) then begin
      if CanNextAction1 and ServerAcceptNextAction and CanNextHit then begin
        nHitMsg := CM_LONGHIT;
        tdir := GetNextDirection1(MySelf.NowX, MySelf.Nowy, target.XX, target.yy);
        MySelf.AddAction(nHitMsg, MySelf.NowX, MySelf.Nowy, tdir, 0, 0, '', 0);
      end;
    end
    else begin
      g_ChrAction := caRun;
      dx := MySelf.NowX;
      dy := MySelf.Nowy;
      if (Neigua.Work.AutoChi = 1) and ((MySelf.Job = 0)and (GetMagicById(12)<> nil)) then
        GetNextHitPosition(target.XX, target.yy, dx, dy)
      else
        GetBackPosition(target.XX, target.yy, tdir, dx, dy);
      if not  PlayScene.CrashActor(dx,dy) then begin
        AutoMoveX := dx;
        AutoMoveY := dy;
      end;
    end;

  end;
end;


function TPlayActor.Dig: Boolean;
var
  tdir, nx, ny, hitmsg, sel: Integer;
begin
  Result := False;
  if (UseItems[U_WEAPON].s.Name <> '') then begin

    if UseItems[U_WEAPON].s.Shape = 19 then begin
      tdir := GetNextDirection(MySelf.NowX, MySelf.Nowy, MCX, MCY);
      GetFrontPosition(MySelf.NowX, MySelf.Nowy, tdir, nx, ny);
      if not Map.FixCanMove(nx, ny) then begin
        if CanNextAction1 and ServerAcceptNextAction and CanNextHit then begin
          MySelf.AddAction(CM_HEAVYHIT, MySelf.NowX, MySelf.Nowy, tdir, 0, 0, '', 0);
        end;
        BoAutoDig := True;
        Result := True;
      end;
    end;
  end;
end;

procedure TPlayActor.Pickup;
var
  msg: TDefaultMessage;
  i,ii: integer;
  ItemList:TStringList;
begin
  msg := MakeDefaultMsg(CM_PICKUP, 0, MySelf.NowX, MySelf.NowY, 0);
  for i := 0 to MAXBAGITEMCL - 1 do begin
    if ItemArr[i].s.Name = '' then begin
      GameWindows.SendSocket(EncodeMessage(msg));
      Exit;
    end;
  end;
  ItemList:=TStringList.Create;
  PlayScene.GetDropItems2(MySelf.NowX, MySelf.NowY, ItemList);
  for i := 0 to ItemList.Count -1 do begin
    if ItemList[i] = '' then begin
      GameWindows.SendSocket(EncodeMessage(msg));
      Break;
    end;
  end;
  ItemList.Free;
end;

procedure TPlayActor.UpdateItem(body: string);
var
  i: Integer;
  cu: TClientItem;
begin
  if body <> '' then begin
    Cu := TurnItemToNew(Body);

    UpdateItemBag(cu);
    for i := Low(UseItems) to High(UseItems) do begin
      if (UseItems[i].s.Name = cu.s.Name) and (UseItems[i].MakeIndex =
        cu.MakeIndex) then begin
        UseItems[i] := cu;
      end;
    end;
  end;
end;

procedure TPlayActor.AddItem(body: string);
var
  cu: TClientItem;
begin
  if body <> '' then begin
    Cu := TurnItemToNew(Body);
    AddItemBag(cu);
    DScreen.AddSysMsg(cu.s.Name + '.');
  end;
end;



procedure TPlayActor.DelItem(body: string;MakeIndex:Integer);
var

  ItemName: string;
  i, iindex: Integer;
  Str, iname: string;
begin
  if body <> '' then begin
    ItemName := DecodeString(Body);

    DelBagItem(ItemName, MakeIndex);
    for i := Low(UseItems) to High(UseItems) do begin
      if (UseItems[i].s.Name = ItemName) and (UseItems[i].MakeIndex =
        MakeIndex) then begin
        UseItems[i].s.Name := '';
        if (Neigua.Work.AutoDuFu <> 0) and (UseItems[i].s.StdMode = 25) then begin

          for iindex := {$IF Ver_LCJ}8{$ELSE}6{$IFEND} to MAXBAGITEMCL - 1 do begin
            if (ItemArr[iindex].s.Name = str) then begin

              TakeOnItem(i, ItemArr[iindex].MakeIndex, ItemArr[iindex].s.Name);
              WaitingUseItem.Item := ItemArr[iindex];
              ItemArr[iindex].s.Name := '';

              Exit;
            end;
          end;
        end;

      end;
    end;
  end;
end;

procedure TPlayActor.DelItems(body: string);
var
  i, iindex: Integer;
  Str, iname: string;
begin
  body := DeCodeString(body);
  while body <> '' do begin
    body := GetValidStr3(body, iname, ['/']);
    body := GetValidStr3(body, Str, ['/']);
    if (iname <> '') and (Str <> '') then begin
      iindex := Str_ToInt(Str, 0);
      DelBagItem(iname, iindex);
      for i := Low(UseItems) to High(UseItems)  do begin
        if (UseItems[i].s.Name = iname) and (UseItems[i].MakeIndex = iindex) then begin
          str := UseItems[i].s.Name;
          UseItems[i].s.Name := '';
          if (Neigua.Work.AutoDuFu <> 0) and (UseItems[i].s.StdMode = 25) then begin

            for iindex := {$IF Ver_LCJ}8{$ELSE}6{$IFEND} to MAXBAGITEMCL - 1 do begin
              if (ItemArr[iindex].s.Name = str) then begin

                TakeOnItem(i, ItemArr[iindex].MakeIndex, ItemArr[iindex].s.Name);
                WaitingUseItem.Item := ItemArr[iindex];
                ItemArr[iindex].s.Name := '';

                Exit;
              end;
            end;
          end;

        end;
      end;
    end
    else
      Break;
  end;
end;

procedure TPlayActor.GetBagItmes(body: string);
var
  Str: string;
  cu: TClientItem;
label add;

begin
  Fillchar(ItemArr, SizeOf(ItemArr), #0);
  ClearBag;
  add: begin         
    body := GetValidStr3(body, Str, ['/']);
    DecodeBuffer(Str, @cu, SizeOf(TClientItem));
    AddItemBag(cu);
    if body <> '' then
      goto add;
  end;
{$IF Ver_LCJ}
{$ELSE}
  if Self = MyHero then FrmDlg.DWinHeroItem.Visible := True;
{$IFEND}
  GetItemOK := True;
  ArrangeItembag;
end;
function TPlayActor.GetMagicById(Magid: Byte): PTClientMagic;
var
  i: Integer;
  pm: PTClientMagic;
begin
  Result := nil;
  for i := 0 to MagicList.Count - 1 do begin
    pm := PTClientMagic(MagicList[i]);
    if pm.Def.wMagicId = Magid then begin
      Result := pm;
      Result.Def.btDefPower := i;
      Break;
    end;
  end;
end;
function TPlayActor.GetMagicByKey(Key: Char): PTClientMagic;
var
  i: Integer;
  pm: PTClientMagic;
begin
  Result := nil;
  for i := 0 to MagicList.Count - 1 do begin
    pm := PTClientMagic(MagicList[i]);
    if pm.Key = Key then begin
      Result := pm;
      Result.Def.btDefPower := i;
      Break;
    end;
  end;
end;

procedure TPlayActor.AutoEatItem;
var
  i: Integer;
  MP, Hp: Integer;
  pm: PTClientMagic;
  Actor: TPlayActor;
begin
  Actor := MySelf;
  if Actor = nil then
    Exit;

  Hp := Actor.m_Abil.Hp;
  MP := Actor.m_Abil.MP;

  if (Neigua.Work.AutoHP = 1) and (Actor.Job = 2) then begin
    if (Hp <= NeiGua.Work.AutoHpPer) and
      ((GetTickCount - AutoMagic) > NeiGua.Work.AutoHpTime * 1000) then begin
      for i := 0 to MagicList.Count - 1 do begin
        pm := PTClientMagic(MagicList[i]);
        if Pm.Def.wMagicID = 2 then begin
          SpellMsg(CM_SPELL, MySelf.NowX, MySelf.Nowy, 2, 0);
          AutoMagic := GetTickCount;
          Break;
        end;
      end;
    end;

  end;

  for i := 0 to 4 do begin
    if neigua.Protect.Protect[i] then begin
      if Hp <= neigua.Protect.Method[i].Per then begin
        if neigua.Protect.Method[i].Time < 2 then neigua.Protect.Method[i].Time := 2;

        if (GetTickCount - neigua.Protect.Method[i].Now) > neigua.Protect.Method[i].Time * 1000 then begin
          MySelf.EatByName(neigua.Protect.Method[i].ItemName);
          neigua.Protect.Method[i].Now := GetTickCount;
        end;

      end;
    end;
  end;
  for i := 5 to 6 do begin
    if neigua.Protect.Protect[i] then begin
      if MP <= neigua.Protect.Method[i].Per then begin
        if (GetTickCount - neigua.Protect.Method[i].Now) >
          neigua.Protect.Method[i].Time * 1000 then begin
          MySelf.EatByName(neigua.Protect.Method[i].ItemName);
          neigua.Protect.Method[i].Now := GetTickCount;
        end;
      end;

    end;
  end;
  if (NeiGua.Protect.Protect[7]) then begin

    if Neigua.Protect.Dura < 1 then
      Neigua.Protect.Dura := 2;
    if Actor.UseItems[1].Dura <= (Neigua.Protect.Dura + 1) * 1000 then
      MySelf.EatByName(NeiGua.Protect.ComBoBoxStr[7]);
  end;

end;

function TPlayActor.AutoLieHuo: Boolean;
var
  i: Integer;
  pm: PTClientMagic;
begin

  Result := False;
  if MySelf = nil then
    Exit;
  if ((GetTickCount - AutoMAgic) > 2500) and (MySelf.Job = 0) then begin
    pm :=GetMagicById(26); 
      if pm<> nil  then begin
        SpellMsg(3017, 571, 174, 26, 0);
        AutoMAgic := GetTickCount;
      end;

  end;

end;

procedure TPlayActor.AddMagic(body: string);
var
  pcm: PTClientMagic;
begin
  New(pcm);
  DecodeBuffer(body, @(pcm^), SizeOf(TClientMagic));
  MagicList.Add(pcm);
  inc(Neigua.SHezhi.MagicLockCount);
  if NeiGua.SHezhi.MagicLockCount > 20 then exit;
  Neigua.SHezhi.MagicLock[NeiGua.SHezhi.MagicLockCount - 1].MagicId := Pcm.Def.wMagicId;
  Neigua.SHezhi.MagicLock[NeiGua.SHezhi.MagicLockCount - 1].Name := pcm.Def.sMagicName;
  if pcm.Def.wMagicID in [1, 5, 6, 10, 11, 13, 20, 32, 33] then
    Neigua.SHezhi.MagicLock[Neigua.SHezhi.MagicLockCount - 1].IsLock := True;

end;

procedure TPlayActor.DelMagic(magid: Integer);
var
  i: Integer;
begin
  for i := MagicList.Count - 1 downto 0 do begin
    if PTClientMagic(MagicList[i]).Def.wMagicId = magid then begin
      Dispose(PTClientMagic(MagicList[i]));
      MagicList.Delete(i);
      Break;
    end;
  end;
end;

procedure TPlayActor.GetMagics(body: string);
var
  i: Integer;
  data: string;
  pcm: PTClientMagic;
begin
  for i := 0 to MagicList.Count - 1 do
    Dispose(PTClientMagic(MagicList[i]));
  MagicList.Clear;

  Neigua.SHezhi.MagicLockCount := 0;
  while True do begin
    if body = '' then
      Break;
    body := GetValidStr3(body, data, ['/']);
    if data <> '' then begin
      New(pcm);
      DecodeBuffer(data, @(pcm^), SizeOf(TClientMagic));
{$IF Ver_LCJ}
      if Self = MySelf then begin
        if pcm.Key <> #0 then begin//TasNat   2009-09-22 18:26:15
          i := StrToInt(pcm.Key);
          Dec(i);
          if (i >= 0) and (i <= 7) then
            FrmDlg.DraePmArr[i] := pcm;
        end;
      end;
{$ELSE}
{$IFEND}

      MagicList.Add(pcm);
      if NeiGua.SHezhi.MagicLockCount < 20 then begin
        Neigua.SHezhi.MagicLock[NeiGua.SHezhi.MagicLockCount].MagicId := Pcm.Def.wMagicId;
        Neigua.SHezhi.MagicLock[NeiGua.SHezhi.MagicLockCount].Name := pcm.Def.sMagicName;
        if not Neigua.SHezhi.MagicChang then
          if pcm.Def.wMagicID in [1, 5, 6, 10, 11, 13, 20, 32, 33] then
            Neigua.SHezhi.MagicLock[Neigua.SHezhi.MagicLockCount].IsLock := True;
        inc(Neigua.SHezhi.MagicLockCount);
      end;
    end
    else
      Break;
  end;
end;

procedure TPlayActor.DuraChange(uidx, newdura, newduramax: Integer);
  function EatByName(Name: string): Boolean;
  var
    i: Integer;
  begin
    Result := False;
    if Name = 'С' then begin
      DScreen.ClearHint;
      GameWindows.AppLogout;
      Exit;
    end;
    if Name = '' then begin
      DScreen.ClearHint;
      GameWindows.AppExit;
      Exit;
    end;

    for i := 0 to MAXBAGITEMCL - 1 do begin
      if (ItemArr[i].s.Name = Name) then begin
        EatItem(i);
        Result := True;
        Exit;
      end;
    end;
  end;
begin
  if uidx in [Low(UseItems)..High(UseItems)] then begin
    if UseItems[uidx].s.Name <> '' then begin
      UseItems[uidx].Dura := newdura;
      UseItems[uidx].DuraMax := newduramax;
    end;
  end;
  if (uidx = 1) and (NeiGua.Protect.Protect[7]) then begin
    if Neigua.Protect.Dura < 1 then
      Neigua.Protect.Dura := 2;
    if NewDura <= Neigua.Protect.Dura * 1000 then
      EatByName(NeiGua.Protect.ComBoBoxStr[7]);
  end;

end;

procedure TPlayActor.GetMagicLvExp(magid, maglv, magtrain: Integer);
var
  i: Integer;
begin
  for i := MagicList.Count - 1 downto 0 do begin
    if PTClientMagic(MagicList[i]).Def.wMagicId = magid then begin
      PTClientMagic(MagicList[i]).Level := maglv;
      PTClientMagic(MagicList[i]).CurTrain := magtrain;
      Break;
    end;
  end;
end;

procedure TPlayActor.TurnDuyao;
var
  s: TClientItem;
  Str: string;
  i: Integer;
begin
  s := UseItems[U_ARMRINGL];
  Str := 'ҩ';
  if (s.s.StdMode <> 25) and (Pos('ҩ', s.s.Name) < 1) then
    Exit;

  for i := 6 to MAXBAGITEMCL - 1 do begin
    if (ItemArr[i].s.StdMode = 25) and (ItemArr[i].s.Name <> s.s.Name) and
      (Pos(Str, ItemArr[i].s.Name) > 0) then begin
      TakeOnItem(U_ARMRINGL, ItemArr[i].MakeIndex, ItemArr[i].s.Name);
      WaitingUseItem.Index := U_ARMRINGL;
      WaitingUseItem.Item := ItemArr[i];
      ItemArr[i].s.Name := '';
      ArrangeItembag;
      Exit;
    end;
  end;
end;


procedure TPlayActor.TurnDuFu(pcm: PTClientMagic);
var
  s: TClientItem;
  Str, str1, str2: string;
  i, index: Integer;
  function GetIndex: Integer;
  var
    Index: Integer;
  begin
    Index := U_BUJUK;
    if (DufuIndex = U_BUJUK) then begin
      Index := DufuIndex;

    end;
    if (UseItems[U_BUJUK].s.StdMode = 25) and (Pos('', UseItems[U_BUJUK].s.Name) > 0) then
      Index := U_BUJUK;
    if (UseItems[U_BUJUK].s.StdMode = 25) and (Pos('ҩ', UseItems[U_BUJUK].s.Name) > 0) then
      Index := U_BUJUK;
    DufuIndex := Index;
    Result := DufuIndex;

  end;
begin

  if WaitingUseItem.Item.s.Name <> '' then exit;
  if Neigua.Work.AutoDuFu = 0 then exit;
  index := Getindex;
  s := UseItems[Index];

  if pcm.Def.wMagicId in [13, 14, 15, 17, 18, 30] then begin
    Str := '';
    str2 := 'ҩ';
    Str1 := Str;
  end
  else
    if pcm.Def.wMagicId = 6 then begin
      Str := 'ҩ';
      str2 := '';
      case NeiGua.Work.DuType of
        0: Str1 := '';
        1: str1 := '';
        2: begin
            if NeiGua.Work.Duwhich = 0 then begin
              str1 := '';
              NeiGua.Work.Duwhich := 1;
            end
            else begin
              str1 := '';
              NeiGua.Work.Duwhich := 0;
            end

          end;
      end;

    end
    else
      Exit;

  if (s.s.StdMode = 25) and (Pos(Str1, s.s.Name) > 0) then
    Exit;

  if (UseItems[U_BUJUK].s.StdMode = 25) and (Pos(Str1, UseItems[U_BUJUK].s.Name) > 0) then
    Exit;
  WaitingUseItem.Index := index;

  for i := 6 to MAXBAGITEMCL - 1 do begin
    if (ItemArr[i].s.StdMode = 25) and (Pos(Str, ItemArr[i].s.Name) > 0) and (Pos(Str1, ItemArr[i].s.Name) > 0) then begin

      TakeOnItem(WaitingUseItem.Index, ItemArr[i].MakeIndex, ItemArr[i].s.Name);
      WaitingUseItem.Item := ItemArr[i];
      ItemArr[i].s.Name := '';
      ArrangeItembag;
      Exit;
    end;
  end;
end;

procedure TPlayActor.UseHeroMagic(tx, ty: Integer; MagicID: Byte);
var
  msg: TDefaultMessage;
begin
  msg := MakeDefaultMsg(CM_BActorUseMagic, FocusCret.XX, FocusCret.yy, FocusCret.RecogId, MagicID);
  GameWindows.SendSocket(EncodeMessage(msg));
end;


procedure TPlayActor.UseMagic(tx, ty: Integer; pcm: PTClientMagic);

var
  tdir, targx, targy, targid: Integer;
  pmag: PTUseMagicInfo;
  function islock(id: integer): Boolean;
  var
    i: integer;
  begin
    Result := FAlse;
    for i := 0 to NeiGua.SHezhi.MagicLockCount - 1 do begin
      if NeiGua.SHezhi.MagicLock[i].MagicId = id then begin
        Result := NeiGua.SHezhi.MagicLock[i].IsLock;
        exit;
      end;
    end;
  end;

begin
  if pcm = nil then
    Exit;
  if (pcm.Def.wSpell + pcm.Def.btDefSpell <= m_Abil.MP) or (pcm.Def.btUseEffect
    = 0) then begin
    if pcm.Def.btUseEffect = 0 then begin //ҪʹЧ
      if pcm.Def.wMagicId = 26 then begin //һ𽣷
        if GetTickCount - LatestFireHitTime < 10 * 1000 then begin
          Exit;
        end;
      end;
      if pcm.Def.wMagicId = 27 then begin //Ұײ
        if GetTickCount - LatestRushRushTime < 3 * 1000 then begin
          Exit;
        end;
      end;
      if GetTickCount - LatestSpellTime > 500 then begin
        LatestSpellTime := GetTickCount;
        MagicDelayTime := 0;
        SpellMsg(CM_SPELL, Dir, 0, pcm.Def.wMagicId, 0);

      end;
    end
    else begin //ҪʹЧ
      MagicTarget := FocusCret;
      TurnDuFu(pcm);

      if (neigua.Base.MagicLock = 1) and (ServerSetup.Base.MagicLock > 0) and (islock(pcm.Def.wMagicId)) then begin
        if not PlayScene.IsValidActor(AutoMagicTarget) then //ЧĶ
          AutoMagicTarget := nil;
        if AutoMagicTarget <> nil then begin
          if (AutoMagicTarget.Death) or (not AutoMagicTarget.isVisible) or
            (Pos(UserName, AutoMagicTarget.UserName) > 0) then
            AutoMagicTarget := nil;
        end;
        if (MagicTarget <> nil) and (not MagicTarget.Death) and (ServerSetup.Base.MagicLock > 0) and ((neigua.Base.MagicLockType = 0) or (AutoMagicTarget = nil)) then begin
          AutoMagicTarget := MagicTarget;

        end
        else begin
          MagicTarget := AutoMagicTarget;
          if MagicTarget <> nil then
            PlayScene.ScreenXYfromMCXY(MagicTarget.XX, MagicTarget.yy, tx, ty);

        end;
      end;

      tdir := GetFlyDirection(390, 175, tx, ty);

      if not PlayScene.IsValidActor(MagicTarget) then
        MagicTarget := nil;
      if MagicTarget = nil then begin
        PlayScene.CXYfromMouseXY(tx, ty, targx, targy);
        targid := 0;
      end
      else begin
        targx := MagicTarget.XX1;
        targy := MagicTarget.yy1;
        targid := MagicTarget.RecogId;
      end;
      if (CanNextAction and ServerAcceptNextAction) or (Self = MyHero) then begin //
        LatestSpellTime := GetTickCount; //ʹħʱ
        New(pmag);
        Fillchar(pmag^, SizeOf(TUseMagicInfo), #0);
        pmag.EffectNumber := pcm.Def.btShowEffect;
        pmag.MagicSerial := pcm.Def.wMagicId;
        pmag.ServerMagicCode := 0;
        MagicDelayTime := 200 + pcm.Def.dwDelayTime;

        LatestMagicTime := GetTickCount;
        AddAction(CM_SPELL, targx, targy, tdir, Integer(pmag), targid, '', 0);
        //DScreen.AddChatBoardString('AddAction(CM-SPELL '+pcm.Def.sMagicName,clRed,clBlack);
      end;

    end;
  end
  else
    DScreen.AddSysMsg('ħֵ.');

end;

procedure TPlayActor.Eat(itmindex: Integer; itmname: string);
var
  msg: TDefaultMessage;
begin
  //DScreen.AddChatBoardString('Send EatItem',clRed,clYellow);
  msg := MakeDefaultMsg(CM_EAT, itmindex, 0, 0, 0);
  GameWindows.SendSocket(EncodeMessage(msg) + EncodeString(itmname));
end;

function TPlayActor.ActionFinished: Boolean;
begin
  if (CurrentAction = 0) or (currentframe >= endframe) then
    Result := True
  else
    Result := False;
end;


function TPlayActor.CanNextHit: Boolean;
var
  nexthit, levelfast: Integer;
begin

  levelfast := _MIN(370, (MySelf.m_Abil.Level * 14));
  levelfast := _MIN(800, levelfast + MySelf.HitSpeed * 60);
  if BoAttackSlow then
    nexthit := 1300 - levelfast + 1500
  else
    nexthit := 1300 - levelfast;

  {11.8nexthit := nexthit - (NeiGua.Fuzhu.AttackSpeed * 100);
  nexthit := nexthit - 800;
  if nexthit < 0 then  }
    nexthit := 0;
  if GetTickCount - LastHitTime > longword(nexthit) then begin
    LastHitTime := GetTickCount;
    Result := True;
  end
  else
    Result := False;
  if (MySelf.Horse > 0) then
    Result := False;

end;

function TPlayActor.ServerAcceptNextAction: Boolean;
var
  count: Integer;
begin
  Result := TRUE;

  if ActionLock then begin
    if GetTickCount - ActionLockTime > 5 * 1000 then begin
      ActionLock := FALSE;
    end;
    Result := FALSE;
  end;
  {11.8
  if (ServerSetup.Base.noslow = 3) and (Neigua.Base.NoSlow = 1) then
    Result := True;
  }
end;

procedure TPlayActor.ActionFailed;
begin
  MagicTargetX := -1;
  MagicTargetY := -1;
  ActionFailLock := True;

  CurrentAction := 0;
  LockEndFrame := True;
  XX := oldx;
  YY := oldy;
  Dir := olddir;
  CleanUserMsgs;
end;

function TPlayActor.IsUnLockAction(Action, adir: Integer): Boolean;
begin
  if (ActionFailLock and (Action = FailAction) and (adir = FailDir))
    or (MapMoving)
    or (BoServerChanging) then begin
    Result := False;
  end
  else begin
    ActionFailLock := False;
    Result := True;
  end;
end;

procedure TPlayActor.TakeOnItem(where: Byte; itmindex: Integer; itmname:
  string);
var
  msg: TDefaultMessage;
begin
  msg := MakeDefaultMsg(CM_TAKEONITEM, itmindex, where, Byte(Self = MyHero), 0);
  GameWindows.SendSocket(EncodeMessage(msg) + EncodeString(itmname));
end;

procedure TPlayActor.TakeOffItem(where: Byte; itmindex: Integer; itmname:
  string);
var
  msg: TDefaultMessage;
begin
  msg := MakeDefaultMsg(CM_TAKEOFFITEM, itmindex, where, Byte(Self = MyHero), 0);
  GameWindows.SendSocket(EncodeMessage(msg) + EncodeString(itmname));
end;

procedure TPlayActor.SpellMsg(ident, X, Y, Dir, target: Integer);
var
  msg: TDefaultMessage;
begin
  msg := MakeDefaultMsg(ident, MakeLong(X, Y), Loword(target), Dir,
    Hiword(target));
  GameWindows.SendSocket(EncodeMessage(msg));
  ActionLock := True;
  ActionLockTime := GetTickCount;
  Inc(SendCount);
end;


procedure TPlayActor.ClearBag;
var
  i: Integer;
begin
  for i := 0 to MAXBAGITEMCL - 1 do
    ItemArr[i].s.Name := '';
end;

function TPlayActor.DelBagItem(iname: string; iindex: Integer): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := MAXBAGITEMCL - 1 downto 0 do begin
    if (ItemArr[i].s.Name = iname) and (ItemArr[i].MakeIndex = iindex) then begin
      Fillchar(ItemArr[i], SizeOf(TClientItem), #0);
      Result := True;
      Break;
    end;
  end;
  ArrangeItembag;
end;

procedure TPlayActor.GetSenduseItems(body: string);
var
  Index: Integer;
  Str, data: string;
  cu: TClientItem;
begin
  Fillchar(UseItems, SizeOf(UseItems), #0);
  while True do begin
    if body = '' then
      Break;
    body := GetValidStr3(body, Str, ['/']);
    body := GetValidStr3(body, data, ['/']);
    Index := Str_ToInt(Str, -1);
    if Index in [Low(UseItems)..High(UseItems)] then begin
      Cu := TurnItemToNew(data);
      UseItems[Index] := cu;
    end;
  end;
end;


function TPlayActor.UpdateItemBag(cu: TClientItem): Boolean;
var
  I: Integer;
begin
  Result := FALSE;
  for I := High(ItemArr) downto Low(ItemArr) do begin
    if (ItemArr[I].S.Name = cu.S.Name) and (ItemArr[I].MakeIndex = cu.MakeIndex) then begin
      ItemArr[I] := cu;
      Result := True;
      Break;
    end;
  end;
end;

end.

