{*******************************************************}
{                                                       }
{       ԴԪ                                    }
{                                                       }
{       Ȩ (C) 2009 *                             }
{                                                       }
{*******************************************************}

unit ResManager;

interface
uses
  Classes, SysUtils,

  MirGrobal,
  DXDraws,
  Debug, //ϢԪ TasNat 2009-02-17 20:07:52
  DIB,
  mywil; //16ɫWILļ;

procedure InitializeAllRes;
procedure FinalizeAllRes;
procedure InitializeImgRes;
procedure FinalizeImgRes;


function GetBagItems(idx: Integer): TDirectDrawSurface;
function GetDnItems(idx: Integer): TDirectDrawSurface;
function GetHairEx(idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
function GetHumEx(idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
function GetMMap(idx: Integer): TDirectDrawSurface;
function GetNpcEx(idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
function GetObjs(wUnit, idx: Integer): TDirectDrawSurface;
function GetObjsEx(wUnit, idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
function GetSmTiles(idx: Integer): TDirectDrawSurface;
function GetStateitem(idx: Integer): TDirectDrawSurface;
function GetStateitemEx(idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
function GetTiles(idx: Integer): TDirectDrawSurface;
function GetWeaponEx(idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
function GetMonImg(appr: Integer): TTilFile;
type
  TTilFile = mywil.TTilFile;
var
  WILCSDD: TDirectDraw;
  WilNeiGua,
    WilChrSel,

    WilHum,
    WilHum2,
    WilHumEffect,
    WilHorse,
    WilHumHorse,
    WilHair,
    WilHair2,
    WilMagic,
    WilMagic2,
    WilMagIcon,
    WilItems,
    WilDnItems,
    WilStateItem,
    WilWeapon,
    WilWeapon2,
    WilNpc,
    WilMMap,
    WilMMap2,
    WilTiles,
    WilSmTiles,
    WilEffect,

    WilPrguse,
    WilPrguse3,
    WilMon1,
    WilMon3,
    WilMon4,
    WilMon5,
    WilMon6,
    WilMon7,
    WilMon14,
    WilMon15,
    WilMon18,
    WilMon19,
    WilMon20,
    WilMon21,
    WilMon22,
    WilMon23,

  WilMon2,
    WilMon8,
    WilMon9,
    WilMon10,
    WilMon11,
    WilMon12,
    WilMon13,
    WilMon16,
    WilMon17,
    WilMon24,
    WilMon25,
    WilMon26,
    WilMon27,
    WilMon28,
    WilMon29,
    WilDragon,
    WilMon40,
    WilMon41,
    WilMon42,


  WilObject,
    WilObject2,
    WilObject3,
    WilObject4,
    WilObject5,
    WilObject6,
    WilObject7,
    WilObject8,
    WilObject9,
    WilObject10,
    WilObject11,
    WilObject12,
    WilObject13,
    WilObject14,
    WilObject15,
  WilNewObject,
    w16Faceimg,
    WilItems2,
    WilDnItems2,
    WilStateItem2,
  w16ProgUse,
    W16ChrSel, W16ChrSelEff: TTilFile;
const
  OBJECTIMAGEFILE = 'Objects';
  ObjecTTilFileFormatStr = 'Objects%d';
  MonWilFileFormatStr = 'Mon%d';
implementation

uses
  MapUnit,ClMain;

function GetBagItems(idx: Integer): TDirectDrawSurface;
begin
  if idx < 3000 then  begin
    Result := WilItems.Images[idx];
  end
{$IF Ver_LCJ}
  else Result := WilItems2.Images[idx-3000]
{$ELSE}
{$IFEND}
end;
function GetStateitemEx(idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
begin
  if idx < 3000 then
    Result := WilStateItem.GetImage(idx, px, py)
{$IF Ver_LCJ}
  else Result := WilStateItem2.GetImage(idx - 3000, px, py)
{$ELSE}
{$IFEND}
end;
function GetDnItems(idx: Integer): TDirectDrawSurface;
begin
  if idx < 3000 then
    Result := WilDnItems[idx]
{$IF Ver_LCJ}
  else Result := WilDnItems2[idx-3000]
{$ELSE}
{$IFEND}
end;
function GetHumEx(idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
begin
  if idx < WilHum.ImageCount then
    Result := WilHum.GetImage(idx, px, py)
  else Result := WilHum2.GetImage(idx-WilHum.ImageCount, px, py)
end;

function GetHairEx(idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
begin
  if idx < WilHair.ImageCount then
    Result := WilHair.GetImage(idx, px, py)
  else Result := WilHair2.GetImage(idx-WilHair.ImageCount, px, py)
end;


function GetWeaponEx(idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
begin
  if idx < WilWeapon.ImageCount then
    Result := WilWeapon.GetImage(idx, px, py)
  else Result := WilWeapon2.GetImage(idx-WilWeapon.ImageCount, px, py)
end;

function GetNpcEx(idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
begin
  Result := WilNpc.GetImage(idx, px, py);
end;

function GetStateitem(idx: Integer): TDirectDrawSurface;
var
  x, y: SmallInt;
begin
  Result := GetStateitemEx(idx, x, y);
end;

function GetMMap(idx: Integer): TDirectDrawSurface;
begin
  if idx < 1000 then
    Result := WilMMap.Images[idx]
  else Result := WilMMap2.Images[idx-1000]
end;

function GetTiles(idx: Integer): TDirectDrawSurface;
begin
  Result := WilTiles.Images[idx];
end;

function GetSmTiles(idx: Integer): TDirectDrawSurface;
begin
  Result := WilSmTiles.Images[idx];
end;



function GetObjs(wUnit, idx: Integer): TDirectDrawSurface;
var
  x, y: SmallInt;
begin
  Result := GetObjsEx(wUnit, Idx, x, y);
end;

function GetObjsEx(wUnit, idx: Integer; var px, py: SmallInt): TDirectDrawSurface;
begin
  Result := nil;
  case wUnit of
    0: Result := WilObject.GetImage(Idx, px, py);  
    1: Result := WilObject2.GetImage(Idx, px, py);  
    2: Result := WilObject3.GetImage(Idx, px, py);  
    3: Result := WilObject4.GetImage(Idx, px, py);  
    4: Result := WilObject5.GetImage(Idx, px, py);  
    5: Result := WilObject6.GetImage(Idx, px, py);  
    6: Result := WilObject7.GetImage(Idx, px, py);  
    7: Result := WilObject8.GetImage(Idx, px, py);  
    8: Result := WilObject9.GetImage(Idx, px, py);  
    9: Result := WilObject10.GetImage(Idx, px, py);  
    10: Result := WilObject11.GetImage(Idx, px, py);  
    11: Result := WilObject12.GetImage(Idx, px, py);  
    12: Result := WilObject13.GetImage(Idx, px, py);  
    13: Result := WilObject14.GetImage(Idx, px, py);  
    14: Result := WilObject15.GetImage(Idx, px, py);  
    40: Result := WilNewObject.GetImage(Idx, px, py);  
  end;  
end;

function GetMonImg(appr: Integer): TTilFile;
begin
  Result := WilMon1;
  if appr div 10 = 90 then begin
    Result := WilEffect;
    Exit;
  end;
  case (appr div 10) of
    1: Result := WilMon2;
    2: Result := WilMon3;
    3: Result := WilMon4;
    4: Result := WilMon5;
    5: Result := WilMon6;
    6: Result := WilMon7;
    7: Result := WilMon8;
    8: Result := WilMon9;
    9: Result := WilMon10;
    10: Result := WilMon11;
    11: Result := WilMon12;
    12: Result := WilMon13;
    13: Result := WilMon14;
    14: Result := WilMon15;
    15: Result := WilMon16;
    16: Result := WilMon17;
    17: Result := WilMon18;
    18: Result := WilMon19;
    19: Result := WilMon20;
    20: Result := WilMon21;
    21: Result := WilMon22;
    22: Result := WilMon23;
    23: Result := WilMon24;
    24: Result := WilMon25;
    25: Result := WilMon26;
    26: Result := WilMon27;
    27: Result := WilMon28;
    28: Result := WilMon29;
{$IF Ver_LCJ}
    39: Result := WilMon40;
    40: Result := WilMon41;
    41: Result := WilMon42;
{$ELSE}
{$IFEND}
  end;
end;


procedure InitializeAllRes;
begin

end;


procedure FinalizeAllRes;
begin
  FinalizeImgRes;
end;

procedure InitializeImgRes;
begin
  DebugOutStr('ʼWilļ...');
  W16ProgUse :=   TTilFile.Create('.\LcjData\ProgUse');
  WilPrguse3 :=   TTilFile.Create('.\Data\Prguse3');
  WilPrguse :=    TTilFile.Create('.\Data\Prguse');
  WilHum :=       TTilFile.Create('.\Data\Hum');
  WilHum2 :=      TTilFile.Create('.\Data\Hum2');
  WilHumEffect := TTilFile.Create('.\Data\HumEffect');
  WilHorse :=     TTilFile.Create('.\Data\Horse');
  WilHumHorse :=  TTilFile.Create('.\Data\HumHorse');
  WilHair :=      TTilFile.Create('.\Data\Hair');
  WilHair2 :=     TTilFile.Create('.\Data\Hair2');
  WilMagic :=     TTilFile.Create('.\Data\Magic');
  WilMagic2 :=    TTilFile.Create('.\Data\Magic2');
  WilMagIcon :=   TTilFile.Create('.\Data\MagIcon');
  WilWeapon :=    TTilFile.Create('.\Data\Weapon');
  WilWeapon2 :=   TTilFile.Create('.\Data\Weapon2');
  WilNpc :=       TTilFile.Create('.\Data\Npc'); 
  WilEffect :=    TTilFile.Create('.\Data\Effect');
  WilObject :=    TTilFile.Create('.\Data\Objects');
  WilObject2 :=   TTilFile.Create('.\Data\Objects2');
  WilObject3 :=   TTilFile.Create('.\Data\Objects3');
  WilObject4 :=   TTilFile.Create('.\Data\Objects4');
  WilObject5 :=   TTilFile.Create('.\Data\Objects5');
  WilObject7 :=   TTilFile.Create('.\Data\Objects7');
  WilObject8 :=   TTilFile.Create('.\Data\Objects8');
  WilObject15 :=  TTilFile.Create('.\Data\Objects15');

  WilMon2 := TTilFile.Create('.\Data\Mon2');
  WilMon3 := TTilFile.Create('.\Data\Mon3');
  WilMon4 := TTilFile.Create('.\Data\Mon4');
  WilMon5 := TTilFile.Create('.\Data\Mon5');
  WilMon6 := TTilFile.Create('.\Data\Mon6');
  WilMon7 := TTilFile.Create('.\Data\Mon7');
  WilMon8 := TTilFile.Create('.\Data\Mon8');
  WilMon9 := TTilFile.Create('.\Data\Mon9');
  WilMon10 := TTilFile.Create('.\Data\Mon10');
  WilMon11 := TTilFile.Create('.\Data\Mon11');
  WilMon12 := TTilFile.Create('.\Data\Mon12');
  WilMon13 := TTilFile.Create('.\Data\Mon13');
  WilMon14 := TTilFile.Create('.\Data\Mon14');
  WilMon15 := TTilFile.Create('.\Data\Mon15');
  WilMon16 := TTilFile.Create('.\Data\Mon16');
  WilMon17 := TTilFile.Create('.\Data\Mon17');
  WilMon18 := TTilFile.Create('.\Data\Mon18');
  WilMon19 := TTilFile.Create('.\Data\Mon19');
  WilMon20 := TTilFile.Create('.\Data\Mon20');
  WilMon21 := TTilFile.Create('.\Data\Mon21');
  WilMon22 := TTilFile.Create('.\Data\Mon22');
  WilMon23 := TTilFile.Create('.\Data\Mon23');
  WilMon24 := TTilFile.Create('.\Data\Mon24');
  WilMon25 := TTilFile.Create('.\Data\Mon25');
  WilMon26 := TTilFile.Create('.\Data\Mon26');
  WilMon27 := TTilFile.Create('.\Data\Mon27');
  WilMon28 := TTilFile.Create('.\Data\Mon28');
  WilMon29 := TTilFile.Create('.\Data\Mon29');
  WilNeiGua := TTilFile.Create('.\LcjData\NeiGua');
{$IF Ver_LCJ}
  w16Faceimg :=    TTilFile.Create('.\LcjData\Face');
  W16ChrSel :=     TTilFile.Create('.\LcjData\ChrSel');
  W16ChrSelEff :=  TTilFile.Create('.\LcjData\ChrSelEff');
  WilNewObject :=  TTilFile.Create('.\lcjData\Objects40');
  WilMon42 :=      TTilFile.Create('.\LcjData\Mon42');
  WilMon41 :=      TTilFile.Create('.\LcjData\Mon41');
  WilMon40 :=      TTilFile.Create('.\LcjData\Mon40');

  if not FileExists('.\LcjData\Tiles.wil') then
    WilTiles :=     TTilFile.Create('.\Data\Tiles')
  else
    WilTiles :=     TTilFile.Create('.\LcjData\Tiles');

  if not FileExists('.\LcjData\SmTiles.wil') then
    WilSmTiles :=     TTilFile.Create('.\Data\SmTiles')
  else
    WilSmTiles :=     TTilFile.Create('.\LcjData\SmTiles');

  if not FileExists('.\LcjData\Objects6.wil') then
    WilObject6 :=     TTilFile.Create('.\Data\Objects6')
  else
    WilObject6 :=     TTilFile.Create('.\LcjData\Objects6');

  if not FileExists('.\LcjData\Objects9.wil') then
    WilObject9 :=     TTilFile.Create('.\Data\Objects9')
  else
    WilObject9 :=     TTilFile.Create('.\LcjData\Objects9');

  if not FileExists('.\LcjData\Objects10.wil') then
    WilObject10 :=     TTilFile.Create('.\Data\Objects10')
  else
    WilObject10 :=     TTilFile.Create('.\LcjData\Objects10');


  if not FileExists('.\LcjData\Objects11.wil') then
    WilObject11 :=     TTilFile.Create('.\Data\Objects11')
  else
    WilObject11 :=     TTilFile.Create('.\LcjData\Objects11');


  if not FileExists('.\LcjData\Objects12.wil') then
    WilObject12 :=     TTilFile.Create('.\Data\Objects12')
  else
    WilObject12 :=     TTilFile.Create('.\LcjData\Objects12');

  if not FileExists('.\LcjData\Objects13.wil') then
    WilObject13 :=     TTilFile.Create('.\Data\Objects13')
  else
    WilObject13 :=     TTilFile.Create('.\LcjData\Objects13');


  if not FileExists('.\LcjData\Objects14.wil') then
    WilObject14 :=     TTilFile.Create('.\Data\Objects14')
  else
    WilObject14 :=     TTilFile.Create('.\LcjData\Objects14');

  WilItems :=     TTilFile.Create('.\Data\Items');
  WilDnItems :=     TTilFile.Create('.\Data\DnItems');
  WilStateItem :=     TTilFile.Create('.\Data\StateItem');

  WilItems2 :=     TTilFile.Create('.\LcjData\Items');
  WilDnItems2 :=     TTilFile.Create('.\LcjData\DnItems');
  WilStateItem2 :=     TTilFile.Create('.\LcjData\StateItem');

  WilMMap :=     TTilFile.Create('.\Data\MMap');

  WilMMap2 :=     TTilFile.Create('.\LcjData\MMap');

{$ELSE}

  WilChrSel := TTilFile.Create('.\Data\ChrSel');
  WilItems := TTilFile.Create('.\Data\Items');
  WilDnItems := TTilFile.Create('.\Data\DnItems');
  WilStateItem := TTilFile.Create('.\Data\StateItem');
  WilNpc := TTilFile.Create('.\Data\Npc');
  WilMMap := TTilFile.Create('.\Data\MMap');
  WilTiles :=     TTilFile.Create('.\Data\Tiles');
  WilSmTiles :=   TTilFile.Create('.\Data\SmTiles');
  WilObject6 :=   TTilFile.Create('.\Data\Objects6');
  WilObject10 := TTilFile.Create('.\Data\Objects10');
  WilObject11 := TTilFile.Create('.\Data\Objects11');
  WilObject12 := TTilFile.Create('.\Data\Objects12');
  WilObject13 := TTilFile.Create('.\Data\Objects13');
  WilObject14 := TTilFile.Create('.\Data\Objects14');
{$IFEND} 
  WilMon1 := TTilFile.Create('.\Data\Mon1');
  DebugOutStr('ʼWilļ...');

end;


procedure FinalizeImgRes;
begin
  WilNeiGua.Free;
  WilChrSel.Free;

  WilHum.Free;
  WilHum2.Free;
  WilHumEffect.Free;
  WilHorse.Free;
  WilHumHorse.Free;
  WilHair.Free;
  WilHair2.Free;
  WilMagic.Free;
  WilMagic2.Free;
  WilMagIcon.Free;
  WilItems.Free;
  WilDnItems.Free;
  WilStateItem.Free;
  WilItems2.Free;
  WilDnItems2.Free;
  WilStateItem2.Free;
  WilWeapon.Free;
  WilWeapon2.Free;
  WilNpc.Free;
  WilMMap.Free;
  WilMMap2.Free;
  WilTiles.Free;
  WilSmTiles.Free;
  WilEffect.Free;

  WilPrguse.Free;
  WilPrguse3.Free;
  WilMon1.Free;
  WilMon3.Free;
  WilMon4.Free;
  WilMon5.Free;
  WilMon6.Free;
  WilMon7.Free;
  WilMon14.Free;
  WilMon15.Free;
  WilMon18.Free;
  WilMon19.Free;
  WilMon20.Free;
  WilMon21.Free;
  WilMon22.Free;
  WilMon23.Free;


  WilMon2.Free;
  WilMon8.Free;
  WilMon9.Free;
  WilMon10.Free;
  WilMon11.Free;
  WilMon12.Free;
  WilMon13.Free;
  WilMon16.Free;
  WilMon17.Free;
  WilMon24.Free;
  WilMon25.Free;
  WilMon26.Free;
  WilMon27.Free;
  WilMon28.Free;
  WilMon29.Free;
  WilMon42.Free;
  WilMon41.Free;
  WilMon40.Free;
  WilNewObject.Free;
  WilObject.Free;
  WilObject2.Free;
  WilObject3.Free;
  WilObject4.Free;
  WilObject5.Free;
  WilObject6.Free;
  WilObject7.Free;
  WilObject8.Free;
  WilObject9.Free;
  WilObject10.Free;
  WilObject11.Free;
  WilObject12.Free;
  WilObject13.Free;
  WilObject14.Free;
  WilObject15.Free;
  w16Faceimg.Free;

end;

end.

