unit magiceff;

interface

uses
  Windows,
  SysUtils,
  Graphics,
  MirGrobal, ClType, DXDraws, cliUtil, ClFunc, 
  ResManager, //ԴԪ TasNat 2009-02-14 22:38:49
  ClVarConst,
  TyFunc;


const
  MG_READY = 10;
  MG_FLY = 6;
  MG_EXPLOSION = 10;
  READYTIME = 120;
  EXPLOSIONTIME = 100;
  FLYBASE = 10;
  EXPLOSIONBASE = 170;
  MAXMAGIC = 10;
  FLYOMAAXEBASE = 447;
  THORNBASE = 2967;
  ARCHERBASE = 2607;
  ARCHERBASE2 = 272;

  FLYFORSEC = 500;
  FIREGUNFRAME = 6;

  MAXEFFECT = 55;
  EffectBaseList: array[0..MAXEFFECT - 1] of Integer = (
    0,
    200, //
    400, //
    600, //ʩ
    0,
    900, //ܻ
    920, //
    940, //Ӱ 940 ǸͼƬ+30 ǼӰ ͷЧ
    20, // ʼ
    940, //Ӱ 940 ǸͼƬ+30 ǼӰ ͷЧ
    940, //Ӱ 940 ǸͼƬ+30 ǼӰ ͷЧ
    940, //Ӱ 940 ǸͼƬ+30 ǼӰ ͷЧ
    0,
    1380, //ħ
    1500, //ٻ
    1520, //
    940, //Ӱ 940 ǸͼƬ+30 ǼӰ ͷЧ
    1560, //ջ֮
    1590, //˲Ϣƶ
    1620, //ǽ
    1650, //ѻ
    1680, //׹
    0,
    0,
    0,
    3960,
    1790,
    0,
    3880,
    3920,
    3840,
    190,
    600,
    130,
    0,
    190,
    220,
    210,
    400,
    400,
    210,
    710,
    710,
    0,
    910,
    130,
    650,
    910,
    190,
    600,
    160,
    990,
    950,
    1040,
    1110


    );
  MAXHITEFFECT = 8;
  HitEffectBase: array[0..MAXHITEFFECT - 1] of Integer = (
    800, //0 ɱ
    1410, //1 ɱ
    1700, //2 
    3480, //3 һ

    {Magic2}
    0,
    210, //˫ն
    40, //ն
    740 //ƿս
    );


  MAXMAGICTYPE = 12;
type
  TMagicType = (mtReady, mtFly, mtExplosion,
    mtFlyAxe, mtFireWind, mtFireGun,
    mtLightingThunder, mtThunder, mtExploBujauk,
    mtBujaukGroundEffect, mtKyulKai, mtFlyArrow,
    mt12, mt13, mt14,
    mt15, mt16);

  TUseMagicInfo = record
    ServerMagicCode: Integer;
    MagicSerial: Integer;
    target: Integer;
    EffectType: TMagicType;
    EffectNumber: Integer;
    targx: Integer;
    targy: Integer;
    Recusion: Boolean;
    AniTime: Integer;
  end;
  PTUseMagicInfo = ^TUseMagicInfo;

  TMagicEff = class
    Active: Boolean;
    ServerMagicId: Integer;
    MagOwner: TObject;
    TargetActor: TObject;
    ImgLib: TTilFile;
    EffectBase: Integer;
    MagExplosionBase: Integer;
    px, py: SmallInt;
    rx, ry: Integer;
    Dir16, OldDir16: Byte;
    targetx, targety: Integer;
    TargetRx, TargetRy: Integer;
    FlyX, FlyY, OldFlyX, OldFlyY: Integer;
    FlyXf, FlyYf: real;
    Repetition: Boolean;
    StopMove: Boolean; //ֹͣƶ
    MagicType: Integer;
    NextEffect: TMagicEff;
    ExplosionFrame: Integer;
    NextFrameTime: Integer;
    light: Integer;
  private
    start, CurFrame, frame: Integer;
    frametime: longword;
    starttime: longword;
    repeattime: longword;
    steptime: longword;
    fireX, fireY: Integer;
    firedisX, firedisY, newfiredisX, newfiredisY: Integer;
    FireMyselfX, FireMyselfY: Integer;
    prevdisx, prevdisy: Integer;
  protected
    procedure GetFlyXY(ms: Integer; var fx, fy: Integer);
  public
    constructor Create(id, imgIndex, sx, sy, tx, ty: Integer; mtype: TMagicType;
      Recusion: Boolean; AniTime: Integer);
    destructor Destroy; override;
    function Run: Boolean; dynamic;
    function Shift: Boolean; dynamic;
    procedure DrawEff(Surface: TDirectDrawSurface); dynamic;
  end;

  TFlyingAxe = class(TMagicEff)
    FlyImageBase: Integer;
    ReadyFrame: Integer;
  public
    constructor Create(id, effnum, sx, sy, tx, ty: Integer; mtype: TMagicType;
      Recusion: Boolean; AniTime: Integer);
    procedure DrawEff(Surface: TDirectDrawSurface); override;
  end;

  TFlyingArrow = class(TFlyingAxe)
  public
    procedure DrawEff(Surface: TDirectDrawSurface); override;
  end;

  TCharEffect = class(TMagicEff)
  public
    constructor Create(effbase, effframe: Integer; target: TObject);
    function Run: Boolean; override;
    procedure DrawEff(Surface: TDirectDrawSurface); override;
  end;

  TMapEffect = class(TMagicEff)
  public
    RepeatCount: Integer;
    constructor Create(effbase, effframe: Integer; X, Y: Integer);
    function Run: Boolean; override;
    procedure DrawEff(Surface: TDirectDrawSurface); override;
  end;

  TScrollHideEffect = class(TMapEffect)
  public
    constructor Create(effbase, effframe: Integer; X, Y: Integer; target:
      TObject);
    function Run: Boolean; override;
  end;

  TLightingEffect = class(TMagicEff)
  public
    constructor Create(effbase, effframe: Integer; X, Y: Integer);
    function Run: Boolean; override;
  end;

  TFireNode = record
    X: Integer;
    Y: Integer;
    firenumber: Integer;
  end;

  TFireGunEffect = class(TMagicEff)
  public
    OutofOil: Boolean;
    firetime: longword;
    FireNodes: array[0..FIREGUNFRAME - 1] of TFireNode;
    constructor Create(effbase, sx, sy, tx, ty: Integer);
    function Run: Boolean; override;
    procedure DrawEff(Surface: TDirectDrawSurface); override;
  end;

  TThuderEffect = class(TMagicEff)
  public
    constructor Create(effbase, tx, ty: Integer; target: TObject);
    procedure DrawEff(Surface: TDirectDrawSurface); override;
  end;

  TLightingThunder = class(TMagicEff)
  public
    constructor Create(effbase, sx, sy, tx, ty: Integer; target: TObject);
    procedure DrawEff(Surface: TDirectDrawSurface); override;
  end;

  TExploBujaukEffect = class(TMagicEff)
  public
    constructor Create(effbase, sx, sy, tx, ty: Integer; target: TObject);
    procedure DrawEff(Surface: TDirectDrawSurface); override;
  end;

  TBujaukGroundEffect = class(TMagicEff)
  public
    MagicNumber: Integer;
    BoGroundEffect: Boolean;
    constructor Create(effbase, magicnumb, sx, sy, tx, ty: Integer);
    function Run: Boolean; override;
    procedure DrawEff(Surface: TDirectDrawSurface); override;
  end;
  TNormalDrawEffect = class(TMagicEff) //Size 0xCC
    boC8: Boolean;
  public
    constructor Create(XX, YY: integer; WmImage: TTilFile; effbase, nX: integer; frmTime: longword; boFlag: Boolean);
    function Run: Boolean; override;
    procedure DrawEff(surface: TDirectDrawSurface); override;
  end;
  TFlyingBug = class(TMagicEff) //Size 0xD0
    FlyImageBase: integer; //0xC8
    ReadyFrame: integer; //0xCC
  public
    constructor Create(id, effnum, sx, sy, tx, ty: integer; mtype: TMagicType; Recusion: Boolean; AniTime: integer);
    procedure DrawEff(surface: TDirectDrawSurface); override;
  end;
  TFlyingFireBall = class(TFlyingAxe) //0xD0
  public
    procedure DrawEff(surface: TDirectDrawSurface); override;
  end;
procedure GetMagicEffectBase(EffectType: Integer; var wimg: TTilFile; var idx: SmallInt);
procedure GetHitEffectBase(mag: Integer; var wimg: TTilFile; var idx: SmallInt);

implementation

uses
  ClMain, Actor, SoundUtil;

procedure GetHitEffectBase(mag: Integer; var wimg: TTilFile; var idx: SmallInt);
begin
  idx := 0;
  wimg := WilMagic;
  if mag in [0..MAXHITEFFECT - 1] then begin
    idx := HitEffectBase[mag];
    if Mag > 4 then
      wimg := WilMagic2;
  end;
end;

procedure GetMagicEffectBase(EffectType: Integer; var wimg: TTilFile; var idx: SmallInt);
begin
  wimg := nil;
  idx := 0;
  case EffectType of
    8,
      27,
      31..59: begin
        wimg := WilMagic2;
        if EffectType in [0..MAXEFFECT - 1] then
          idx := EffectBaseList[EffectType];
      end;
  else begin
      wimg := WilMagic;
      if EffectType in [0..MAXEFFECT - 1] then
        idx := EffectBaseList[EffectType];
    end;
  end;
end;

constructor TMagicEff.Create(id, imgIndex, sx, sy, tx, ty: Integer; mtype:
  TMagicType; Recusion: Boolean; AniTime: Integer);
var
  tax, tay: Integer;
begin
  ImgLib := WilMagic;
  case mtype of
    mtReady: begin
      end;
    mtFly,
      mtBujaukGroundEffect,
      mtExploBujauk: begin
        start := 0;
        frame := 6;
        CurFrame := start;
        StopMove := False;
        Repetition := Recusion;
        ExplosionFrame := 10;
      end;
    mtExplosion,
      mtThunder,
      mtLightingThunder: begin
        start := 0;
        frame := -1;
        ExplosionFrame := 10;
        CurFrame := start;
        StopMove := True;
        Repetition := False;
      end;
    mtFlyAxe: begin
        start := 0;
        frame := 3;
        CurFrame := start;
        StopMove := False;
        Repetition := Recusion;
        ExplosionFrame := 3;
      end;
    mtFlyArrow: begin
        start := 0;
        frame := 1;
        CurFrame := start;
        StopMove := False;
        Repetition := Recusion;
        ExplosionFrame := 1;
      end;
  end;
  ServerMagicId := id;
  EffectBase := imgIndex;
  targetx := tx;
  targety := ty;
  fireX := sx;
  fireY := sy;
  FlyX := sx;
  Flyy := sy;
  OldFlyX := sx;
  OldFlyy := sy;
  FlyXf := sx;
  Flyyf := sy;
  FireMyselfX := MySelf.rx * UNITX + MySelf.ShiftX;
  FireMyselfY := MySelf.ry * UNITY + MySelf.ShiftY;
  MagExplosionBase := EffectBase + EXPLOSIONBASE;
  light := 1;

  if fireX <> targetx then
    tax := abs(targetx - fireX)
  else
    tax := 1;
  if fireY <> targety then
    tay := abs(targety - fireY)
  else
    tay := 1;
  if abs(fireX - targetx) > abs(fireY - targety) then begin
    firedisX := Round((targetx - fireX) * (500 / tax));
    firedisY := Round((targety - fireY) * (500 / tax));
  end
  else begin
    firedisX := Round((targetx - fireX) * (500 / tay));
    firedisY := Round((targety - fireY) * (500 / tay));
  end;

  NextFrameTime := 50;
  frametime := GetTickCount;
  starttime := GetTickCount;
  steptime := GetTickCount;
  repeattime := AniTime;
  Dir16 := GetFlyDirection16(sx, sy, tx, ty);
  OldDir16 := Dir16;
  NextEffect := nil;
  Active := True;
  prevdisx := 99999;
  prevdisy := 99999;
end;

destructor TMagicEff.Destroy;
begin
  inherited Destroy;
end;

function TMagicEff.Shift: Boolean;

  function OverThrough(olddir, newdir: Integer): Boolean;
  begin
    Result := False;
    if abs(olddir - newdir) >= 2 then begin
      Result := True;
      if ((olddir = 0) and (newdir = 15)) or ((olddir = 15) and (newdir = 0))
        then
        Result := False;
    end;
  end;
var
  i, rrx, rry, ms, stepx, stepy, newstepx, newstepy, nn: Integer;
  tax, tay, shx, shy, passdir16: Integer;
  crash: Boolean;
  stepxf, stepyf: real;
begin
  Result := True;
  if Repetition then begin
    if GetTickCount - steptime > longword(NextFrameTime) then begin
      steptime := GetTickCount;
      Inc(CurFrame);
      if CurFrame > start + frame - 1 then
        CurFrame := start;
    end;
  end
  else begin
    if (frame > 0) and (GetTickCount - steptime > longword(NextFrameTime)) then begin
      steptime := GetTickCount;
      Inc(CurFrame);
      if CurFrame > start + frame - 1 then begin
        CurFrame := start + frame - 1;
        Result := False;
      end;
    end;
  end;
  if (not StopMove) then begin

    crash := False;
    if TargetActor <> nil then begin
      ms := GetTickCount - frametime;

      frametime := GetTickCount;

      PlayScene.ScreenXYfromMCXY(TActor(TargetActor).rx,
        TActor(TargetActor).ry,
        targetx,
        targety);
      shx := (MySelf.rx * UNITX + MySelf.ShiftX) - FireMyselfX;
      shy := (MySelf.ry * UNITY + MySelf.ShiftY) - FireMyselfY;
      targetx := targetx + shx;
      targety := targety + shy;


      if FlyX <> targetx then
        tax := abs(targetx - FlyX)
      else
        tax := 1;
      if Flyy <> targety then
        tay := abs(targety - Flyy)
      else
        tay := 1;
      if abs(FlyX - targetx) > abs(Flyy - targety) then begin
        newfiredisX := Round((targetx - FlyX) * (500 / tax));
        newfiredisY := Round((targety - Flyy) * (500 / tax));
      end
      else begin
        newfiredisX := Round((targetx - FlyX) * (500 / tay));
        newfiredisY := Round((targety - Flyy) * (500 / tay));
      end;

      if firedisX < newfiredisX then
        firedisX := firedisX + _MAX(1, (newfiredisX - firedisX) div 10);
      if firedisX > newfiredisX then
        firedisX := firedisX - _MAX(1, (firedisX - newfiredisX) div 10);
      if firedisY < newfiredisY then
        firedisY := firedisY + _MAX(1, (newfiredisY - firedisY) div 10);
      if firedisY > newfiredisY then
        firedisY := firedisY - _MAX(1, (firedisY - newfiredisY) div 10);

      stepxf := (firedisX / 700) * ms;
      stepyf := (firedisY / 700) * ms;
      FlyXf := FlyXf + stepxf;
      Flyyf := Flyyf + stepyf;
      FlyX := Round(FlyXf);
      Flyy := Round(Flyyf);



      OldFlyX := FlyX;
      OldFlyy := Flyy;

      passdir16 := GetFlyDirection16(FlyX, Flyy, targetx, targety);
      if ((abs(targetx - FlyX) <= 15) and (abs(targety - Flyy) <= 15)) or
        ((abs(targetx - FlyX) >= prevdisx) and (abs(targety - Flyy) >= prevdisy))
        or
        OverThrough(OldDir16, passdir16) then begin
        crash := True;
      end
      else begin
        prevdisx := abs(targetx - FlyX);
        prevdisy := abs(targety - Flyy);

      end;
      OldDir16 := passdir16;

    end
    else begin
      ms := GetTickCount - frametime;

      rrx := targetx - fireX;
      rry := targety - fireY;

      stepx := Round((firedisX / 900) * ms);
      stepy := Round((firedisY / 900) * ms);
      FlyX := fireX + stepx;
      Flyy := fireY + stepy;
    end;

    PlayScene.CXYfromMouseXY(FlyX, Flyy, rx, ry);

    if crash and (TargetActor <> nil) then begin
      StopMove := True;
      start := 0;
      frame := ExplosionFrame;
      CurFrame := start;
      Repetition := False;


      PlaySound(TActor(MagOwner).magicexplosionsound);

    end;


  end;
  if StopMove then begin
    if frame = -1 then
      frame := ExplosionFrame;
    if TargetActor = nil then begin
      FlyX := targetx - ((MySelf.rx * UNITX + MySelf.ShiftX) - FireMyselfX);
      Flyy := targety - ((MySelf.ry * UNITY + MySelf.ShiftY) - FireMyselfY);
      PlayScene.CXYfromMouseXY(FlyX, Flyy, rx, ry);
    end
    else begin
      rx := TActor(TargetActor).rx;
      ry := TActor(TargetActor).ry;
      PlayScene.ScreenXYfromMCXY(rx, ry, FlyX, Flyy);
      FlyX := FlyX + TActor(TargetActor).ShiftX;
      Flyy := Flyy + TActor(TargetActor).ShiftY;
    end;
  end;
end;

procedure TMagicEff.GetFlyXY(ms: Integer; var fx, fy: Integer);
var
  rrx, rry, stepx, stepy: Integer;
begin
  rrx := targetx - fireX;
  rry := targety - fireY;

  stepx := Round((firedisX / 900) * ms);
  stepy := Round((firedisY / 900) * ms);
  fx := fireX + stepx;
  fy := fireY + stepy;
end;

function TMagicEff.Run: Boolean;
begin
  Result := Shift;
  if Result then
    if GetTickCount - starttime > 2000 then
      Result := False
    else
      Result := True;
end;

procedure TMagicEff.DrawEff(Surface: TDirectDrawSurface);
var
  img: Integer;
  shx, shy: Integer;
begin

  if Active and ((abs(FlyX - fireX) > 15) or (abs(Flyy - fireY) > 15) or
    StopMove) then begin

    shx := (MySelf.rx * UNITX + MySelf.ShiftX) - FireMyselfX;
    shy := (MySelf.ry * UNITY + MySelf.ShiftY) - FireMyselfY;

    if not StopMove then begin

      img := EffectBase + FLYBASE + Dir16 * 10;

      DrawBlend_DxImage(Surface,
        FlyX + px - UNITX div 2 - shx,
        Flyy + py - UNITY div 2 - shy,
        ImgLib.GetDxImage(img + CurFrame),
        DrawADDValue_MagicEffect);

    end
    else begin

      img := MagExplosionBase + CurFrame;
      DrawBlend_DxImage(Surface,
        FlyX + px - UNITX div 2,
        Flyy + py - UNITY div 2,
        ImgLib.GetDxImage(img),
        DrawADDValue_MagicEffect);
    end;
  end;
end;





constructor TFlyingAxe.Create(id, effnum, sx, sy, tx, ty: Integer; mtype:
  TMagicType; Recusion: Boolean; AniTime: Integer);
begin
  inherited Create(id, effnum, sx, sy, tx, ty, mtype, Recusion, AniTime);
  FlyImageBase := FLYOMAAXEBASE;
  ReadyFrame := 65;
end;

procedure TFlyingAxe.DrawEff(Surface: TDirectDrawSurface);
var
  img: Integer;
  d: TDirectDrawSurface;
  shx, shy: Integer;
begin
  d := nil;
  if Active and ((abs(FlyX - fireX) > ReadyFrame) or (abs(Flyy - fireY) >
    ReadyFrame)) then begin

    shx := (MySelf.rx * UNITX + MySelf.ShiftX) - FireMyselfX;
    shy := (MySelf.ry * UNITY + MySelf.ShiftY) - FireMyselfY;

    if not StopMove then begin
      img := FlyImageBase + Dir16 * 10;
      d := ImgLib.GetImage(img + CurFrame, px, py);
      if d <> nil then begin

        Surface.Draw(FlyX + px - UNITX div 2 - shx,
          Flyy + py - UNITY div 2 - shy,
          d.ClientRect, d, True);
      end;
    end
    else begin

    end;
  end;
end;









procedure TFlyingArrow.DrawEff(Surface: TDirectDrawSurface);
var
  img: Integer;
  d: TDirectDrawSurface;
  shx, shy: Integer;
begin
  d := nil;
  if Active and ((abs(FlyX - fireX) > 40) or (abs(Flyy - fireY) > 40)) then begin


    shx := (MySelf.rx * UNITX + MySelf.ShiftX) - FireMyselfX;
    shy := (MySelf.ry * UNITY + MySelf.ShiftY) - FireMyselfY;

    if not StopMove then begin
      img := FlyImageBase + Dir16;
      d := ImgLib.GetImage(img + CurFrame, px, py);

      if d <> nil then begin

        Surface.Draw(FlyX + px - UNITX div 2 - shx,
          Flyy + py - UNITY div 2 - shy - 46,
          d.ClientRect, d, True);
      end;


    end;
  end;
end;




constructor TCharEffect.Create(effbase, effframe: Integer; target: TObject);
begin
  inherited Create(111, effbase,
    TActor(target).XX, TActor(target).yy,
    TActor(target).XX, TActor(target).yy,
    mtExplosion,
    False,
    0);
  TargetActor := target;
  frame := effframe;
  NextFrameTime := 30;
end;

function TCharEffect.Run: Boolean;
begin
  Result := True;
  if GetTickCount - steptime > longword(NextFrameTime) then begin
    steptime := GetTickCount;
    Inc(CurFrame);
    if CurFrame > start + frame - 1 then begin
      CurFrame := start + frame - 1;
      Result := False;
    end;
  end;
end;

procedure TCharEffect.DrawEff(Surface: TDirectDrawSurface);
var
  d: TDirectDrawSurface;
begin
  d := nil;
  if TargetActor <> nil then begin
    rx := TActor(TargetActor).rx;
    ry := TActor(TargetActor).ry;
    PlayScene.ScreenXYfromMCXY(rx, ry, FlyX, Flyy);
    FlyX := FlyX + TActor(TargetActor).ShiftX;
    Flyy := Flyy + TActor(TargetActor).ShiftY;
    d := ImgLib.GetImage(EffectBase + CurFrame, px, py);
    if d <> nil then begin
      DrawBlend(Surface,
        FlyX + px - UNITX div 2,
        Flyy + py - UNITY div 2,
        d, DrawADDValue_CharEffect);
    end;
  end;
end;




constructor TMapEffect.Create(effbase, effframe: Integer; X, Y: Integer);
begin
  inherited Create(111, effbase,
    X, Y,
    X, Y,
    mtExplosion,
    False,
    0);
  TargetActor := nil;
  frame := effframe;
  NextFrameTime := 30;
  RepeatCount := 0;
end;

function TMapEffect.Run: Boolean;
begin
  Result := True;
  if GetTickCount - steptime > longword(NextFrameTime) then begin
    steptime := GetTickCount;
    Inc(CurFrame);
    if CurFrame > start + frame - 1 then begin
      CurFrame := start + frame - 1;
      if RepeatCount > 0 then begin
        Dec(RepeatCount);
        CurFrame := start;
      end
      else
        Result := False;
    end;
  end;
end;

procedure TMapEffect.DrawEff(Surface: TDirectDrawSurface);
var
  d: TDirectDrawSurface;
begin
  d := nil;
  rx := targetx;
  ry := targety;
  PlayScene.ScreenXYfromMCXY(rx, ry, FlyX, Flyy);
  d := ImgLib.GetImage(EffectBase + CurFrame, px, py);
  if d <> nil then begin
    DrawBlend(Surface,
      FlyX + px - UNITX div 2,
      Flyy + py - UNITY div 2,
      d, DrawADDValue_MapEffect);
  end;
end;




constructor TScrollHideEffect.Create(effbase, effframe: Integer; X, Y: Integer;
  target: TObject);
begin
  inherited Create(effbase, effframe, X, Y);


end;

function TScrollHideEffect.Run: Boolean;
begin
  Result := inherited Run;
  if frame = 7 then
    if TargetCret <> nil then
      PlayScene.DeleteActor(TargetCret.RecogId);
end;





constructor TLightingEffect.Create(effbase, effframe: Integer; X, Y: Integer);
begin

end;

function TLightingEffect.Run: Boolean;
begin
end;





constructor TFireGunEffect.Create(effbase, sx, sy, tx, ty: Integer);
begin
  inherited Create(111, effbase,
    sx, sy,
    tx, ty,
    mtFireGun,
    True,
    0);
  NextFrameTime := 50;
  Fillchar(FireNodes, SizeOf(TFireNode) * FIREGUNFRAME, #0);
  OutofOil := False;
  firetime := GetTickCount;
end;

function TFireGunEffect.Run: Boolean;
var
  i, fx, fy: Integer;
  allgone: Boolean;
begin
  Result := True;
  if GetTickCount - steptime > longword(NextFrameTime) then begin
    Shift;
    steptime := GetTickCount;

    if not OutofOil then begin
      if (abs(rx - TActor(MagOwner).rx) >= 5) or (abs(ry - TActor(MagOwner).ry)
        >= 5) or (GetTickCount - firetime > 800) then
        OutofOil := True;
      for i := FIREGUNFRAME - 2 downto 0 do begin
        FireNodes[i].firenumber := FireNodes[i].firenumber + 1;
        FireNodes[i + 1] := FireNodes[i];
      end;
      FireNodes[0].firenumber := 1;
      FireNodes[0].X := FlyX;
      FireNodes[0].Y := Flyy;
    end
    else begin
      allgone := True;
      for i := FIREGUNFRAME - 2 downto 0 do begin
        if FireNodes[i].firenumber <= FIREGUNFRAME then begin
          FireNodes[i].firenumber := FireNodes[i].firenumber + 1;
          FireNodes[i + 1] := FireNodes[i];
          allgone := False;
        end;
      end;
      if allgone then
        Result := False;
    end;
  end;
end;

procedure TFireGunEffect.DrawEff(Surface: TDirectDrawSurface);
var
  i, num, shx, shy, fireX, fireY, prx, pry, img: Integer;
  d: TDirectDrawSurface;
begin
  d := nil;
  prx := -1;
  pry := -1;
  for i := 0 to FIREGUNFRAME - 1 do begin
    if (FireNodes[i].firenumber <= FIREGUNFRAME) and (FireNodes[i].firenumber >
      0) then begin
      shx := (MySelf.rx * UNITX + MySelf.ShiftX) - FireMyselfX;
      shy := (MySelf.ry * UNITY + MySelf.ShiftY) - FireMyselfY;

      img := EffectBase + (FireNodes[i].firenumber - 1);
      d := ImgLib.GetImage(img, px, py);
      if d <> nil then begin
        fireX := FireNodes[i].X + px - UNITX div 2 - shx;
        fireY := FireNodes[i].Y + py - UNITY div 2 - shy;
        if (fireX <> prx) or (fireY <> pry) then begin
          prx := fireX;
          pry := fireY;
          DrawBlend(Surface, fireX, fireY, d, DrawADDValue_MagicEffect);
        end;
      end;
    end;
  end;
end;



constructor TThuderEffect.Create(effbase, tx, ty: Integer; target: TObject);
begin
  inherited Create(111, effbase,
    tx, ty,
    tx, ty,
    mtThunder,
    False,
    0);
  TargetActor := target;

end;

procedure TThuderEffect.DrawEff(Surface: TDirectDrawSurface);
var
  img, px, py: SmallInt;
  d: TDirectDrawSurface;
begin
  d := nil;
  img := EffectBase;
  d := ImgLib.GetImage(img + CurFrame, px, py);
  if d <> nil then begin
    DrawBlend(Surface,
      FlyX + px - UNITX div 2,
      Flyy + py - UNITY div 2,
      d, DrawADDValue_MagicEffect);
  end;
end;




constructor TLightingThunder.Create(effbase, sx, sy, tx, ty: Integer; target:
  TObject);
begin
  inherited Create(111, effbase,
    sx, sy,
    tx, ty,
    mtLightingThunder,
    False,
    0);
  TargetActor := target;
end;

procedure TLightingThunder.DrawEff(Surface: TDirectDrawSurface);
var
  img, sx, sy,  shx, shy: Integer;
  px, py:SmallInt;
  d: TDirectDrawSurface;
begin
  d := nil;
  img := EffectBase + Dir16 * 10;
  if CurFrame < 6 then begin

    shx := (MySelf.rx * UNITX + MySelf.ShiftX) - FireMyselfX;
    shy := (MySelf.ry * UNITY + MySelf.ShiftY) - FireMyselfY;

    d := ImgLib.GetImage(img + CurFrame, px, py);
    if d <> nil then begin
      PlayScene.ScreenXYfromMCXY(TActor(MagOwner).rx,
        TActor(MagOwner).ry,
        sx,
        sy);
      DrawBlend(Surface,
        sx + px - UNITX div 2,
        sy + py - UNITY div 2,
        d, DrawADDValue_MagicEffect);
    end;
  end;

end;




constructor TExploBujaukEffect.Create(effbase, sx, sy, tx, ty: Integer; target:
  TObject);
begin
  inherited Create(111, effbase,
    sx, sy,
    tx, ty,
    mtExploBujauk,
    True,
    0);
  frame := 3;
  TargetActor := target;
  NextFrameTime := 50;
end;

procedure TExploBujaukEffect.DrawEff(Surface: TDirectDrawSurface);
var
  img: Integer;
  d: TDirectDrawSurface;
  shx, shy: Integer;
  meff: TMapEffect;
begin
  d := nil;
  if Active and ((abs(FlyX - fireX) > 30) or (abs(Flyy - fireY) > 30) or
    StopMove) then begin

    shx := (MySelf.rx * UNITX + MySelf.ShiftX) - FireMyselfX;
    shy := (MySelf.ry * UNITY + MySelf.ShiftY) - FireMyselfY;

    if not StopMove then begin

      img := EffectBase + Dir16 * 10;
      d := ImgLib.GetImage(img + CurFrame, px, py);
      if d <> nil then begin

        Surface.Draw(FlyX + px - UNITX div 2 - shx,
          Flyy + py - UNITY div 2 - shy,
          d.ClientRect, d, True);
      end;
    end
    else begin

      img := MagExplosionBase + CurFrame;
      d := ImgLib.GetImage(img, px, py);
      if d <> nil then begin
        DrawBlend(Surface,
          FlyX + px - UNITX div 2,
          Flyy + py - UNITY div 2,
          d, DrawADDValue_MagicEffect);
      end;
    end;
  end;
end;



constructor TBujaukGroundEffect.Create(effbase, magicnumb, sx, sy, tx, ty:
  Integer);
begin
  inherited Create(111, effbase,
    sx, sy,
    tx, ty,
    mtBujaukGroundEffect,
    True,
    0);
  frame := 3;
  MagicNumber := magicnumb;
  BoGroundEffect := False;
  NextFrameTime := 50;
end;

function TBujaukGroundEffect.Run: Boolean;
begin
  Result := inherited Run;
  if not StopMove then begin
    if ((abs(targetx - FlyX) <= 15) and (abs(targety - Flyy) <= 15)) or
      ((abs(targetx - FlyX) >= prevdisx) and (abs(targety - Flyy) >= prevdisy))
      then begin
      StopMove := True;
      start := 0;
      frame := ExplosionFrame;
      CurFrame := start;
      Repetition := False;

      PlaySound(TActor(MagOwner).magicexplosionsound);

      Result := True;
    end
    else begin
      prevdisx := abs(targetx - FlyX);
      prevdisy := abs(targety - Flyy);
    end;
  end;
end;

procedure TBujaukGroundEffect.DrawEff(Surface: TDirectDrawSurface);
var
  img: Integer;
  d: TDirectDrawSurface;
  shx, shy: Integer;
  meff: TMapEffect;
begin
  d := nil;
  if Active and ((abs(FlyX - fireX) > 30) or (abs(Flyy - fireY) > 30) or
    StopMove) then begin

    shx := (MySelf.rx * UNITX + MySelf.ShiftX) - FireMyselfX;
    shy := (MySelf.ry * UNITY + MySelf.ShiftY) - FireMyselfY;

    if not StopMove then begin

      img := EffectBase + Dir16 * 10;
      d := ImgLib.GetImage(img + CurFrame, px, py);
      if d <> nil then begin
        Surface.Draw(FlyX + px - UNITX div 2 - shx,
          Flyy + py - UNITY div 2 - shy,
          d.ClientRect, d, True);
      end;
    end
    else begin

      if MagicNumber = 11 then //
        img := EffectBase + 16 * 10 + CurFrame
      else
        img := EffectBase + 18 * 10 + CurFrame;
      d := ImgLib.GetImage(img, px, py);
      if d <> nil then begin
        DrawBlend(Surface,
          FlyX + px - UNITX div 2,
          Flyy + py - UNITY div 2,
          d, DrawADDValue_MagicEffect);
      end;

    end;
  end;
end;
{ TNormalDrawEffect }

constructor TNormalDrawEffect.Create(XX, YY: integer; WmImage: TTilFile; effbase, nX: integer; frmTime: longword; boFlag: Boolean);
begin
  inherited Create(111, effbase, XX, YY, XX, YY, mtReady, True, 0);
  ImgLib := WmImage;
  EffectBase := effbase;
  start := 0;
  curframe := 0;
  frame := nX;
  NextFrameTime := frmTime;
  boC8 := boFlag;
end;

procedure TNormalDrawEffect.DrawEff(surface: TDirectDrawSurface);
var
  d: TDirectDrawSurface;
  nRx, nRy :Integer;
  nPx, nPy: SmallInt;
begin
  d := ImgLib.GetImage(EffectBase + curframe, nPx, nPy);
  if d <> nil then begin
    PlayScene.ScreenXYfromMCXY(FlyX, FlyY, nRx, nRy);
    if boC8 then begin
      DrawBlend(surface, nRx + nPx - UNITX div 2, nRy + nPy - UNITY div 2, d, 1);
    end else begin
      surface.Draw(nRx + nPx - UNITX div 2, nRy + nPy - UNITY div 2, d.ClientRect, d, True);
    end;
  end;
end;

function TNormalDrawEffect.Run: Boolean;
begin
  Result := True;
  if Active and (GetTickCount - steptime > longword(NextFrameTime)) then begin
    steptime := GetTickCount;
    inc(curframe);
    if curframe > start + frame - 1 then begin
      curframe := start;
      Result := False;
    end;
  end;
end;
constructor TFlyingBug.Create(id, effnum, sx, sy, tx, ty: integer;
  mtype: TMagicType; Recusion: Boolean; AniTime: integer);
begin
  inherited Create(id, effnum, sx, sy, tx, ty, mtype, Recusion, AniTime);
  FlyImageBase := FLYOMAAXEBASE;
  ReadyFrame := 65;
end;

procedure TFlyingBug.DrawEff(surface: TDirectDrawSurface);
var
  img: integer;
  d: TDirectDrawSurface;
  shx, shy: integer;
begin
  if Active and ((abs(FlyX - fireX) > ReadyFrame) or (abs(FlyY - fireY) > ReadyFrame)) then begin
    shx := (Myself.Rx * UNITX + Myself.ShiftX) - FireMyselfX;
    shy := (Myself.Ry * UNITY + Myself.ShiftY) - FireMyselfY;

    if not StopMove then begin
      img := FlyImageBase + (Dir16 div 2) * 10;
      d := ImgLib.GetImage(img + curframe, px, py);
      if d <> nil then begin
        surface.Draw(FlyX + px - UNITX div 2 - shx,
          FlyY + py - UNITY div 2 - shy,
          d.ClientRect, d, True);
      end;
    end else begin
      img := curframe + MagExplosionBase;
      d := ImgLib.GetImage(img, px, py);
      if d <> nil then begin
        surface.Draw(FlyX + px - UNITX div 2,
          FlyY + py - UNITY div 2,
          d.ClientRect, d, True);
      end;
    end;
  end;
end;
procedure TFlyingFireBall.DrawEff(surface: TDirectDrawSurface);
var
  d: TDirectDrawSurface;
begin
  if Active and ((abs(FlyX - fireX) > ReadyFrame) or (abs(FlyY - fireY) > ReadyFrame)) then begin
    d := ImgLib.GetImage(FlyImageBase + (GetFlyDirection(FlyX, FlyY, TargetX, TargetY) * 10) + curframe, px, py);
    if d <> nil then
      DrawBlend(surface,
        FlyX + px - UNITX div 2,
        FlyY + py - UNITY div 2,
        d, 1);
  end;
end;
end.








