unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Gauges, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP,ClType,TyFunc,ClVarConst,MirGrobal, DFUnRar,untUnRar;

type
  TForm1 = class(TForm)
    TimerUpFile: TTimer;
    ListBox_ServerList: TListBox;
    Gauge1: TGauge;
    IdHTTP1: TIdHTTP;
    Label1: TLabel;
    Gauge2: TGauge;
    Label2: TLabel;
    Label3: TLabel;
    LabelTotal: TLabel;

    procedure TimerUpFileTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IdHTTP1Work(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure IdHTTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure OnProgramException(Sender: TObject; E: Exception);
  private

  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  DownTime:LongWOrd;
  nLodVer:Integer;
  UnRar1: TDFUnRar;
implementation

{$R *.dfm}
Function DownloadBgein(strForm,strTo: string):Boolean;
var
 Stream: TFileStream;
 DownloadedLen:Integer;
 sext:string;
begin
  Result:=False;
  Form1.Label1.Caption := 'ļ...';
  Stream := TFileStream.Create(strTo, fmcreate);
  Stream.Seek(0, 0);
  try
     try
       DownTime:=GetTickCount;
       //if CanBreak then exit;
       //ShowMessage(strForm);
       Form1.IdHTTP1.Get(strForm, Stream);
       Result:=True;
     finally
       Stream.Free;
     end;
  except
    Result:=False;
    Exit;
  end;
  sext := Copy(strTo,Length(strTo)-2,3);
  if sext ='rar' then begin
   Form1.Label1.Caption := 'ѹļ...';
   UnRar1.Directory := ExtractFilePath(Application.EXEName);
   UnRar1.FileName := strTo;
   UnRar1.Mode := DFRAR_EXTRACT;
   try
     UnRar1.Extract;
   except
   end;
   DeleteFile(strTo);
  end;
end;
procedure TForm1.TimerUpFileTimer(Sender: TObject);
var
  Inf:pTUpFileInf;
  i:Integer;
  M : TMemoryStream;
begin
  TimerUpFile.Enabled := False;
  Gauge1.MaxValue := ListBox_ServerList.Count-1;
  try
  for i := 0 to ListBox_ServerList.Count-1 do begin
    Application.ProcessMessages;
    Inf := pTUpFileInf(ListBox_ServerList.Items.Objects[i]);
    if DownloadBgein(Inf.NetFileName,Inf.LodFileName) then begin
      ListBox_ServerList.Items[i]:=ListBox_ServerList.Items[i]+'..';
    end else ListBox_ServerList.Items[i]:=ListBox_ServerList.Items[i]+'ʧ..';
    ListBox_ServerList.ItemIndex :=i;
    nLodVer := Inf.Ver;
    Gauge1.Progress := i;
  end;
  finally
  end;
  Close;
end;
procedure TForm1.OnProgramException(Sender: TObject; E: Exception);
begin
  Label1.Hint:=(E.Message);
end;
procedure TForm1.FormCreate(Sender: TObject);
var
  UpFileInf:pTUpFileInf;
  FileList:TStringList;
  lineStr,strVer,sNetFileName,sLodFileName:string;
  i:Integer;

begin
  Application.OnException := OnProgramException;
  UnRar1 := TDFUnRar.Create;
  try
  if FileExists('.\Lcjdata\UpFileList.txt') then begin
    FileList:=TStringList.Create;
    FileList.LoadFromFile('.\Lcjdata\UpFileList.txt');
    i := 0;
    while True do begin
      if i > FileList.Count-1 then Break;
      lineStr := FileList[i];
      if (lineStr<> '')and (lineStr[1]<>';') then begin
        lineStr := GetValidStr3(lineStr, strVer, [',']);
        lineStr := GetValidStr3(lineStr, sNetFileName, [',']);
        lineStr := GetValidStr3(lineStr,sLodFileName , [',']);
        if (strVer <> '') and (sNetFileName <> '') and (sLodFileName <> '') then begin
          New(UpFileInf);
          UpFileInf.Ver := Str_ToInt(strVer,0);
          UpFileInf.NetFileName := g_sWebUrl+sNetFileName;
          UpFileInf.LodFileName :=sLodFileName;
          ListBox_ServerList.Items.AddObject(UpFileInf.LodFileName+'('+inttostr(UpFileInf.Ver)+')',TObject(UpFileInf));
        end;
      end;
      Inc(i);
    end;
    ListBox_ServerList.ItemIndex := 0;
    TimerUpFile.Enabled := True;
  end;
  except
    Close;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  M : TStringList;
  i:Integer;
begin
  for i := 0 to ListBox_ServerList.Items.Count -1 do begin
    Dispose(pTUpFileInf(ListBox_ServerList.Items.Objects[i]));
  end;

  UnRar1.Free;
  M := TStringList.Create;
  M.Add(IntToStr(nLodVer));
  if DirectoryExists('.\Lcjdata') then
  M.SaveToFile('.\Lcjdata\ver.dat');
  M.Free;
  Sleep(100);
  WinExec(PChar('.\Ӣ۴.exe'),0);
end;


procedure TForm1.IdHTTP1Work(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
var
  Speed,NowTime:integer;
  RecCount:Integer;
begin
  try
    if wmRead =AWorkMode then begin
      with IdHTTP1 do begin
        Application.ProcessMessages;
        RecCount:=AWorkCount-Gauge2.Progress;
        NowTime:=GetTickCount-DownTime;
        if NowTime<1 then
            NowTime:=10;
        Speed:=Round((RecCount/NowTime)*1000);
        if Speed<1 then
          Speed:=10000;

        DownTime:=GetTickCount;
        LabelTotal.Caption :=Format('ǰٶ: '+#13+'%s ÿ'
                                    //'ǰļ: %d/%d'
        ,[FmtFileSize(Speed)//,ListBox_ServerList.ItemIndex,ListBox_ServerList.Count
        ]
        );
        Application.ProcessMessages;
        Gauge2.Progress:=AWorkCount;
      end;
    end;
  except

  End;
end;

procedure TForm1.IdHTTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCountMax: Integer);
begin
  Gauge2.MaxValue:= AWorkCountMax;
end;

end.
