unit new;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, SUIForm, StdCtrls, SUIEdit, SUIButton, SUIImagePanel,
  SUIGroupBox, FileCtrl, PBFolderDialog,mywil, ComCtrls;

type
  TFormnew = class(TForm)
    suiForm1: TsuiForm;
    Label1: TLabel;
    Label2: TLabel;
    EditPicPath: TsuiEdit;
    EditFileName: TsuiEdit;
    suiButton1: TsuiButton;
    suiButton2: TsuiButton;
    suiButton3: TsuiButton;
    suiGroupBox1: TsuiGroupBox;
    suiRadioButton1: TsuiRadioButton;
    suiRadioButton2: TsuiRadioButton;
    editxy: TsuiEdit;
    suiButton4: TsuiButton;
    SaveDialog1: TSaveDialog;
    suiProgressBar1: TProgressBar;
    PBFolderDialog1: TPBFolderDialog;
    suiNumberEdit1: TsuiNumberEdit;
    procedure suiButton1Click(Sender: TObject);
    procedure suiButton2Click(Sender: TObject);
    procedure suiButton4Click(Sender: TObject);
    procedure suiButton3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Formnew: TFormnew;
  PicPath,FileName:String;
implementation

uses mail;





{$R *.dfm}
function  ExtractFileNameOnly (const fname: string): string;
var
   extpos: integer;
   ext, fn: string;
begin
   ext := ExtractFileExt (fname);
   fn := ExtractFileName (fname);
   if ext <> '' then begin
      extpos := pos (ext, fn);
      Result := Copy (fn, 1, extpos-1);
   end else
      Result := fn;
end;
procedure TFormnew.suiButton1Click(Sender: TObject);
begin
if  PBFolderDialog1.Execute then
    EditPicpath.Text:=PBFolderDialog1.SelectedFolder;
end;

procedure TFormnew.suiButton2Click(Sender: TObject);
var
  i:Integer;

  Temp:TFileStream;
  Temp1:TFileStream;
  idxFile,path:String;
  v:smallint;
  offset,count,FImageCount:integer;
  xy,t:string;
  x,y:smallint;
  DBits:PByte;
  xyList:TStringList;
  NewWil:TWIl;
  FileList:TFileListBox;
  Bmp:TBitMap;
Begin

  Try
     if EditPicPath.Text='' then
     Begin
       FormMain.showErrMessage('ͼƬ·!');
       Exit;
     End;
     if EditFileName.Text='' then
     Begin
      FormMain.showErrMessage('½ļ!');
      Exit;
     End;
       Application.ProcessMessages;
     Path:=EditPicPath.Text;
     if Path[length(Path)]<>'\' then Path:=Path+'\';
     FileList:=TFileListBox.Create(self);
     FileList.Parent:=FormNew;
     FileList.Directory:=EditPicPath.Text;
     FileList.Mask:='*.bmp';
     FileList.Visible:=False;
     if FileExists(EditFileName.Text) then
           DeleteFile(EditFileName.Text);
     FormMain.Extractrec('exefile','wil',EditFileName.Text);
     idxfile := ExtractFilePath(EditFileName.Text) + ExtractFileNameOnly(EditFileName.Text) + '.WIX';
     if FileExists(idxfile) then
        DeleteFile(idxfile);
     FormMain.Extractrec('exefile','wix',idxfile);
     NewWil:=TWIl.Create(self);
     NewWIl.FileName:=EditFileName.Text;
     NewWIl.Initialize((FormMain.suiCheckBox1.Checked));
     Bmp:=TBitMap.Create;
     suiProgressBar1.Max:=FileList.items.count;
     suiProgressBar1.Position:=0;
     suiProgressBar1.Visible:=True;
     xyList:=TStringList.Create;
     //Wil.Stream.Seek(0,2);
     For I:=0 to FileList.Items.Count-1 do
     Begin
        Application.ProcessMessages;
        suiProgressBar1.Position:=i;
        x:=0;
        y:=0;
        Bmp.LoadFromFile(FileList.Items[i]);
        if suiRadioButton1.Checked then
        Begin
          t:=FileList.Items[i];
          t:=ExtractFilepath(t)+'Placements\'+ExtractFileName(FileList.Items[i]);
          t:=ChangeFileExt(t,'.txt');
          if FileExists(t) then
          Begin
           xyList.LoadFromFile(t);
           xy:=XyList.Strings[0];
           val(xy,x,count);
           xy:=XyList.Strings[1];
           val(xy,y,count);
          end;
        end
        else
        Begin
         try
          xy:=Editxy.Text;
          Xy:=Copy(xy,1,Pos(',',xy)-1);
          val(xy,x,count);
          xy:=Editxy.Text;
          Xy:=Copy(xy,Pos(',',xy)+1,Length(xy)-Pos(',',xy));
          val(xy,y,count);
         except
           x:=0;
           y:=0;
         end;
        End;

        NewWil.AddBitmap(Bmp,x,y);
     End;
     NewWil.Free;
  Except

  End;
  suiProgressBar1.Visible:=False;
  Bmp.Free;
  FormMain.showMessage('ļɹ!');
  CLose;
End;
procedure TFormnew.suiButton4Click(Sender: TObject);
begin
if SaveDialog1.Execute then
      EditFileName.Text:=SaveDialog1.FileName;
end;

procedure TFormnew.suiButton3Click(Sender: TObject);
begin
close;
end;

end.
