unit SList;
{http://www.cnblogs.com/del/}
interface
//uses Windows;
const
  MaxListSize = Maxint div 16;
  BoListUseTry    = False;
Type

  TPointerList = array[0..MaxListSize - 1] of Pointer;
  PPointerList = ^TPointerList;  
  {򵥵б}
  TSimpleList = class(TObject)
  private
    FList: PPointerList;
    FCount: Integer;
    FCapacity: Integer;

  protected
    function Get(Index: Integer): Pointer;
    procedure Put(Index: Integer; Item: Pointer);
    procedure SetCapacity(NewCapacity: Integer);
    procedure SetCount(NewCount: Integer);
  public
    constructor Create();
    destructor Destroy; override;
    function Add(Item: Pointer): Integer;
    procedure Clear; virtual;

    procedure Delete(Index: Integer);

    property Capacity: Integer read FCapacity write SetCapacity;
    property Count: Integer read FCount write SetCount;
    property Items[Index: Integer]: Pointer read Get write Put; default;
  end;

implementation

{ б}
constructor TSimpleList.Create;
begin
  inherited;
  FCount := 0; //ҪԻ?
  FCapacity := 0;
end;

destructor TSimpleList.Destroy;
begin
  Clear;
  inherited;//ΪʲôҪ Ҫ...
end;

function TSimpleList.Add(Item: Pointer): Integer;
begin

  {$IF BoListUseTry}
  try
  {$ELSE}
  {$IFEND}
    {Ԥڴ, 빻 4 Ԫõ}
    if FCount = FCapacity then
      SetCapacity(FCapacity + 4);

    {Add , ָ븳}
    FList^[FCount] := Item;

    {}
    Result := FCount;

    {Ԫ + 1}
    Inc(FCount);

  {$IF BoListUseTry}
  finally
  end;
  {$ELSE}
  {$IFEND}
end;

procedure TSimpleList.Clear;
begin
  {$IF BoListUseTry}
  try
  {$ELSE}
  {$IFEND}
  SetCount(0);
  SetCapacity(0);
  {$IF BoListUseTry}
  finally
  end;
  {$ELSE}
  {$IFEND}
end;

procedure TSimpleList.Delete(Index: Integer);
begin
  if (Index < 0) or (Index >= FCount) then
    Exit;

  {$IF BoListUseTry}
  try
  {$ELSE}
  {$IFEND}
    Dec(FCount);
    if Index < FCount then
      System.Move(FList^[Index + 1], FList^[Index],(FCount - Index) * SizeOf(Pointer));

  {$IF BoListUseTry}
  finally
  end;
  {$ELSE}
  {$IFEND}
end;

{б Index ָ}
function TSimpleList.Get(Index: Integer): Pointer;
begin
  try
  if (Index < 0) or (Index >= FCount) then
     Result:=nil
  else
  Result := FList^[Index];
  finally
  end;
end;
{Itemдб Index}
procedure TSimpleList.Put(Index: Integer; Item: Pointer);
begin
  if (Index < 0) or (Index >= FCount) then
      Exit;
  FList^[Index] := Item;
end;
procedure TSimpleList.SetCapacity(NewCapacity: Integer);
begin
  if (NewCapacity < FCount) or (NewCapacity > MaxListSize) then Exit;
  if NewCapacity <> FCapacity then
  begin
    ReallocMem(FList, NewCapacity * SizeOf(Pointer));
    FCapacity := NewCapacity;
  end;
end;

procedure TSimpleList.SetCount(NewCount: Integer);
var
  I: Integer;
begin
  if (NewCount < 0) or (NewCount > MaxListSize) then Exit;
  if NewCount > FCapacity then
    SetCapacity(NewCount);
  if NewCount > FCount then
    FillChar(FList^[FCount], (NewCount - FCount) * SizeOf(Pointer), 0)
  else
    for I := FCount - 1 downto NewCount do
      Delete(I);
  FCount := NewCount;
end;



end.
