unit ClType;

interface
uses
  Windows, Classes, MirGrobal,Graphics;
type
  TMsgCol = record
   fcolor :Integer;
   bcolor :Integer;
  end;
  PTMsgCol=^TMsgCol;
  PTClientGoods = ^TClientGoods;
  TClientGoods = record
    Name: string[15];
    SubMenu: Longint;
    Price: Longint;
    Stock: Longint;
    Grade: Integer;
  end;
  PTDropItem = ^TDropItem;
  TDropItem = record
    X, Y: Word;
    id: Integer;
    looks: Integer;
    Name: string[15];
    FlashTime: Integer;
    BoFlash: Boolean;
    FlashStepTime: Integer;
    FlashStep: Integer;
    Canshow:Boolean;
    HintColor:Boolean;
  end;
  TBaseServer = packed record
      NoUse:Byte;
      case Byte of

        1:
        (
          NoDarkness: Byte; 
          NoRunReady: Byte; 
          CanNowExit: Byte; 
          ShowBlood: Byte;
          NumberBlood: Byte; 
          AutoRun: Byte; 
          AutoPut: Byte; 
          AutoTearOpen: Byte; 
          NoStruck: Byte; 
          SpeedChat: Byte; 
          SpeedGroup: Byte;
          WorkShow: Byte; 
          Nopalsy: Byte; 
          Autokill: Byte; 
          IncBloodShow: Byte; 
          AUtoFellow: Byte; 
          Noweight: Byte;
          ConPK: Byte;
          SHowName:Byte;
          CanCrashMon:Byte;
          GuildColor:BYte;
          DureShow:Byte;
          WarningDura: Byte;
          AutoMAgic: Byte;
          ClearBody: Byte;
          AttackShow: Byte;
          MagicLock: Byte;
          Sendstr  :Byte;
          CanCrashMan:Byte;
          noslow     :byte;
          );
        2:
        (
          Base: array[0..29] of Byte;
          );
  end;
  TProtectServer=Packed Record
     NoUse:Byte;
     Protect:Array[0..7] of Byte;
  End;
  TChatServer = packed record
    NoUse:Byte;
    ReChatNoUse,autoTalkNoUse,MaskNoUse:Byte;
    case Byte of
      0: (
        AutoReChat: Byte;
        AutoTalk: Byte;
        AutoTalkReturn: Byte;
        MaskTalk: Byte;
        MAskShout: Byte;
        MaskGuild: Byte;
        MaskGroup: Byte;
        );
      1:
      (
        Chat: array[0..6] of Byte;
      );
  end;
  TWorkServer = packed record
    NoUse:Byte;
    case Byte of
      0: (
        DaoDaoChi: Byte;
        AutoYeMan: Byte;
        AutoLie: Byte;
        AIBanYue: Byte;
        DingXiang: Byte;
        AutoPk: Byte;
        AutoChi: Byte;
        AutoMagicShield: Byte;
        AutoHP: Byte;
        AutoHide: Byte;
        AutoDuFu: Byte;
        AutoCall: Byte;
        Autodispute:Byte;
        );
      1: (
        Work: array[0..12] of Byte;
        );
  end;

  TGuanxiServer = packed record
     NoUse:Byte;
  end;


  TGoodsServer = packed record
    NoUse:Byte;
    case Byte of
      0: (
        AutoPickUp  : Byte;
        ShowFilter  : Byte;
        PickUpFilter: Byte;
        GoodShow    : Byte;
        GoodHint    : Byte;
        GoodColor   : Byte;
        BuyBat      : Byte;

        );
      1: (
        Goods: array[0..6] of Byte;
        );

  end;
  TGuajiServer=Packed Record
    Nouse:Byte;
    case Byte of
     0:(
        NoRed          :Byte;  
        NoBlue         :Byte;
        BagFull        :Byte;  
        NoFu           :Byte;  
        );
     1:(
       Guaji:Array[0..3] of Byte;
     );
  End;
  TFuzhuServer=packed record
     NoUse:Byte;
     NoSpeed:Byte;
     NoNotePad:Byte;
     Case Byte of
     0:(
        GameSpeed          :Byte;  
        AttackSpeed         :Byte;
        MagicSpeed        :Byte;
        );
     1:(
       BianTai:Array[0..2] of Byte;
     );
  End;
  TShezhiServer=Packed Record
    NoUse:Byte;
    Key,MagicLock,Color,Save:Byte;
  End;


  TFaceControl = record
    c: array[0..5] of Integer;
  end;
  TGameSetup = record
    Group: Boolean;
    Trad: Boolean;
    Talk: Boolean;
  end;
  TUserSetup =packed record
    Buy         :Boolean;
    GameSpeed   :Boolean;
    MagicSpeed  :Boolean;
    AttackSpeed :Boolean;
    Kill        :Boolean;
  end;
  TNeiGuaServer = packed record
    Base: TBaseServer;
    Protect: TProtectServer;
    Chat: TChatServer;
    Work: TWorkServer;
    Guaji:TGuajiServer;
    Goods: TGoodsServer;
    Guanxi:TGuanxiServer;
    Fuzhu:TFUzhuServer;
    Shezhi:TShezhiServer;
  end;
  TNeiGuaHeader=PAcked Record
     Version:Integer;
     Sign   :Integer;
     Name   :String[20];
  End;
  TProtectmethod = packed record
    which: string[30];
    Per: DWord;
    Time: DWord;
    Now: DWord;
  end;
  TProtect = packed record
    Protect: array[0..7] of Boolean;
    Method: array[0..7] of TProtectmethod;
    EditText: array[0..14] of string[20];
    ComboboxIndex: Byte;
    EditIndex: Byte;
    Dura:Byte;
    Repair:Byte;
    ComBoBoxExtend: array[0..7] of Boolean;
    ComBoBoxDowned: array[0..7] of Boolean;
    ComBoBoxStr: array[0..7] of string[20];
  end;
  TBase = packed record
    ComboboxIndex: Byte;
    ComBoBoxExtend: array[0..4] of Boolean;
    ComBoBoxDowned: array[0..4] of Boolean;
    ComBoBoxStr: array[0..4] of string[20];
    BtnDown: array[0..2] of Boolean;
    AUtoMAgicKey  :Byte;
    Sendstr:String[50];
    case Byte of
      1:
      (
        NoDarkness: Byte;
        NoRunReady: Byte;
        CanNowExit: Byte; 
        ShowBlood: Byte;
        NumberBlood: Byte;
        AutoRun: Byte;
        AutoPut: Byte;
        AutoTearOpen: Byte;
        NoStruck: Byte;
        SpeedChat: Byte;
        SpeedGroup: Byte;
        WorkShow: Byte; 
        Nopalsy: Byte; 
        Autokill: Byte; 
        IncBloodShow: Byte; 
        AUtoFellow: Byte;
        Noweight: Byte; 
        ConPK: Byte; 
        SHowName:Byte;
        CanCrashMon:Byte;
        GuildColor:BYte;
        MsgShow:Byte;
        WarningDura: Byte;
        AutoMAgic: Byte;
        ClearBody: Byte;
        AttackShow: Byte;
        MagicLock: Byte;
        WarningDuraPer: Byte;
        AutoMagicTime: Byte;
        ClearBodyTime: Byte;
        AttackShowType: Byte;
        MagicLockType: Byte;
        CanCrashMan   : Byte;
        NoSlow        :Byte;
        );

      2:
      (
        Base: array[0..33] of Byte;
        );
  end;
  TChat = packed record
    EditText: array[0..2] of string[255];
    AutoReChatstr: string[255];
    BtnDown: array[0..3] of Boolean;
    AutoTalkTime: Integer;
    AutoTalkIndex:Integer;
    AutoTalkMoveIndex:Integer;
    EditIndex: Byte;
    case Byte of
      0: (
        AutoReChat: Byte;
        AutoTalk: Byte;
        AutoTalkReturn: Byte;
        MaskTalk: Byte;
        MAskShout: Byte;
        MaskGuild: Byte;
        MaskGroup: Byte;

        );
      1:
      (
        Chat: array[0..6] of Byte;
        );
  end;
  TWork = packed record
    AutoHpPer: DWord;
    AutoHpTime: DWord;
    AutoCallTime: Integer;
    AutoChiType:Integer;
    MagicType: Byte;
    HideType: Byte;
    DuType: Byte;
    Duwhich:Byte;
    EditText: string[20];
    ComboboxIndex: Byte;
    ComBoBoxExtend: array[0..2] of Boolean;
    ComBoBoxDowned: array[0..2] of Boolean;
    ComBoBoxStr: array[0..2] of string[20];
    case Byte of
      0: (
        DaoDaoChi: Byte;
        AutoYeMan: Byte;
        AutoLie: Byte;     
        AIBanYue: Byte;
        DingXiang: Byte;   
        AutoPk: Byte;      
        AutoChi: Byte;
        AutoMagicShield: Byte;   
        AutoHP: Byte;            
        AutoHide: Byte;
        AutoDuFu: Byte;          
        AutoCall: Byte;          
        Autodispute:Byte;
        );
      1: (
        Work: array[0..12] of Byte;
        );
  end;
  THintmethod = packed record
    Name: string[30];
    which: Byte;
  end;
  TAssistant = packed record
    Hint: Boolean;
    EditText: string[20];
    ComboboxIndex: Byte;
    HintWhich: Byte;

    ListIndex: Integer;
    EditListIndex:Integer;
    Name: string[20];
    ComBoBoxExtend: array[0..2] of Boolean;
    ComBoBoxDowned: array[0..2] of Boolean;
    ComBoBoxStr: array[0..2] of string[20];
    BtnDown: array[0..7] of Boolean;
  end;
  TGoodsShow=Packed Record
    Name   : string[50];
    Show   : Boolean;
    Color  : Boolean;
    Pick   : Boolean;
    Hint   : Boolean;
  End;
  TKey=Packed Record
    Key1:Byte;
    Key2:char;
    Index:Byte;
  End;
  TMagicLock=Packed Record
    MagicId:Integer;
    Name   :string[50];
    IsLock :Boolean;
  End;

  TGoods = packed record
    BtnDown: array[0..7] of Boolean;
    EditText: array[0..3] of string[50];
    GoodsIndex:Integer;
    GoodsMoveIndex:Integer;
    EditIndex: Byte;
    ComBoBoxIndex:Integer;
    ComBoBoxExtend,ComBoBoxDowned:array[0..1] of Boolean;
    BuyCount:Integer;
    case Byte of
      0: (
        AutoPickUp: Byte;
        ShowFilter: Byte;
        PickUpFilter: Byte;
        GoodShow: Byte;
        GoodHint: Byte;
        GoodColor: Byte;
        BuyBat: Byte;
        );
      1: (
        Goods: array[0..6] of Byte;
        );

  end;
  TFUzhu=Packed Record
    BtnDown:Array[0..1] of Boolean;
    GameSpeed: Byte;
    AttackSpeed: Byte;
    MagicSpeed: Byte;
  End;
  TWpe=Packed Record
    //Msg:TDefaultMessage;
    BtnDown: array[0..6] of Boolean;

    EditIndex: Byte;
    case Byte of
     0:(
       Rec:Byte;
       Send:Byte;
       );
     1:(
        Wpe:Array[0..1] of byte;
       );
  End;
  TShezhi=Packed Record
    BtnDown:Array[0..6] of Boolean;
    ComBoBoxIndex:Integer;
    ComBoBoxExtend,ComBoBoxDowned:array[0..3] of Boolean;
    ComBoBoxStr: string[20];
    SaveIndex: Byte;
    LoadIndex: Byte;
    EditListIndex:Integer;
    KeyListTop,MagicLockTop,KeyIndex,MagicIndex:Integer;
    EditText:string[50];
    Key:Array[0..28] of Tkey;
    MagicLock:Array[0..20] of TMagicLock;
    MagicLockCount:Integer;
    HintColor:Array[0..7] of TColor;
    HintIndex:Byte;
    MagicChang:Boolean;
  End;
  TGuaJi=Packed Record
    AttackMode    :Byte;
    MagicKey      :Byte;
    AroundKey     :Byte;
    CameBack      :array[0..3] of Boolean;
    ComboboxIndex : Byte;
    NoAttackTop   :Integer;

    ComBoBoxExtend: array[0..1] of Boolean;
    ComBoBoxDowned: array[0..1] of Boolean;
    BtnDown       : array[0..4] of Boolean;
    EditText      : String[50];
    Guaji         :Boolean;
  End;
  TNeiGua = packed record
    Statues: Byte;
    Base: TBase;
    Protect: TProtect;
    Chat: TChat;
    Work: TWork;
    Assistant: TAssistant;
    Goods: TGoods;
    Fuzhu:TFuzhu;
    SHezhi:Tshezhi;
    Guaji:TGuaJi;
  end;
  TMiniMapControl = record
    Fang: Boolean;
    Tran: Boolean;
    Quan: Boolean;
    Q   : Boolean;
    X, Y: Integer;
    CanRun: Boolean;
  end;
  PServerName=^TServerName;
  TServerName=Packed Record
     Name    : String[100];
     Caption : String[100];
     Ip      : String[100];
     Port    : Integer;
  End;

implementation

end.
