  function CheckQuestStatus(ScriptInfo: pTScript): Boolean; //0049BA00
  var
    i: Integer;
  begin
    Result := True;
    if ScriptInfo = nil then Exit; // TasNat  2009-03-24 11:20:56
    if not ScriptInfo.boQuest then Exit;
    i := 0;
    while (True) do begin
      if (ScriptInfo.QuestInfo[i].nRandRage > 0) and (Random(ScriptInfo.QuestInfo[i].nRandRage) <> 0) then begin
        Result := False;
        break;
      end;
      if PlayObject.GetQuestFalgStatus(ScriptInfo.QuestInfo[i].wFlag) <> ScriptInfo.QuestInfo[i].btaValue then begin
        Result := False;
        break;
      end;
      Inc(i);
      if i >= 10 then break;
    end; // while
  end;
  function CheckItemW(sItemType: string; nParam: Integer): pTUserItem; //0049BA7C
  var
    nCount: Integer;
  begin
    Result := nil;
    if CompareLStr(sItemType, '[NECKLACE]', 4) then begin
      if PlayObject.m_UseItems[U_NECKLACE].wIndex > 0 then begin
        Result := @PlayObject.m_UseItems[U_NECKLACE];
      end;
      Exit;
    end;
    if CompareLStr(sItemType, '[RING]', 4) then begin
      if PlayObject.m_UseItems[U_RINGL].wIndex > 0 then begin
        Result := @PlayObject.m_UseItems[U_RINGL];
      end;
      if PlayObject.m_UseItems[U_RINGR].wIndex > 0 then begin
        Result := @PlayObject.m_UseItems[U_RINGR];
      end;
      Exit;
    end;
    if CompareLStr(sItemType, '[ARMRING]', 4) then begin
      if PlayObject.m_UseItems[U_ARMRINGL].wIndex > 0 then begin
        Result := @PlayObject.m_UseItems[U_ARMRINGL];
      end;
      if PlayObject.m_UseItems[U_ARMRINGR].wIndex > 0 then begin
        Result := @PlayObject.m_UseItems[U_ARMRINGR];
      end;
      Exit;
    end;
    if CompareLStr(sItemType, '[WEAPON]', 4) then begin
      if PlayObject.m_UseItems[U_WEAPON].wIndex > 0 then begin
        Result := @PlayObject.m_UseItems[U_WEAPON];
      end;
      Exit;
    end;
    if CompareLStr(sItemType, '[HELMET]', 4) then begin
      if PlayObject.m_UseItems[U_HELMET].wIndex > 0 then begin
        Result := @PlayObject.m_UseItems[U_HELMET];
      end;
      Exit;
    end;
    Result := PlayObject.sub_4C4CD4(sItemType, nCount);
    if nCount < nParam then
      Result := nil;
  end;
  function CheckAnsiContainsTextList(sTest, sListFileName: string): Boolean;
  var
    i: Integer;
    LoadList: TStringList;
  begin
    Result := False;
    sListFileName := g_Config.sEnvirDir + sListFileName;
    if FileExists(sListFileName) then begin
      LoadList := TStringList.Create;
      try
        LoadList.LoadFromFile(sListFileName);
      except
        MainOutMessage('loading fail.... => ' + sListFileName);
      end;
      for i := 0 to LoadList.Count - 1 do begin
        if AnsiContainsText(sTest, Trim(LoadList.Strings[i])) then begin
          Result := True;
          break;
        end;
      end;
      LoadList.Free;
    end else begin
      MainOutMessage('file not found => ' + sListFileName);
    end;
  end;
  function GetRandomName(sListFileName: string): string;
  var
    i: Integer;
    LoadList: TStringList;
  begin
    Result := '';
    sListFileName := g_Config.sEnvirDir + sListFileName;
    if FileExists(sListFileName) then begin
      LoadList := TStringList.Create;
      try
        LoadList.LoadFromFile(sListFileName);
      except
        MainOutMessage('ȡ漴ıʧļ򲻿.... => ' + sListFileName);
      end;
      if LoadList.Count <> 0 then begin
        Result := LoadList[Random(LoadList.Count - 1)];
      end;
      LoadList.Free;
    end else begin
      MainOutMessage('ȡ漴ıʧļ => ' + sListFileName);
    end;
  end;




  function JmpToLable(sLabel: string): Boolean;
  begin
    Result := False;
    Inc(PlayObject.m_nScriptGotoCount);
    if PlayObject.m_nScriptGotoCount > g_Config.nScriptGotoCountLimit {10} then Exit;
    ConditionOfGetValValue(PlayObject, sLabel, sLabel); //ӱ֧
    
    GotoLable(PlayObject, sLabel, False);
    Result := True;
  end;
  procedure GoToQuest(nQuest: Integer);
  var
    i: Integer;
    Script: pTScript;
  begin
    for i := 0 to m_ScriptList.Count - 1 do begin
      Script := m_ScriptList.Items[i];
      if Script.nQuest = nQuest then begin
        PlayObject.m_Script := Script;
        PlayObject.m_NPC := Self;
        GotoLable(PlayObject, sMAIN, False);
        break;
      end;
    end;
  end;

  procedure AddList(sHumName, sListFileName: string); //0049B620
  var
    i: Integer;
    LoadList: TStringList;
    s10: string;
    bo15: Boolean;
  begin
    sListFileName := g_Config.sEnvirDir + sListFileName;
    LoadList := TStringList.Create;
    if FileExists(sListFileName) then begin
      try
        LoadList.LoadFromFile(sListFileName);
      except
        MainOutMessage('loading fail.... => ' + sListFileName);
      end;
    end;
    bo15 := False;
    for i := 0 to LoadList.Count - 1 do begin
      s10 := Trim(LoadList.Strings[i]);
      if CompareText(sHumName, s10) = 0 then begin
        bo15 := True;
        break;
      end;
    end;
    if not bo15 then begin
      LoadList.Add(sHumName);
      try
        LoadList.SaveToFile(sListFileName);
      except
        MainOutMessage('saving fail.... => ' + sListFileName);
      end;
    end;

    LoadList.Free;
  end;
  procedure DelList(sHumName, sListFileName: string); //0049B7F8
  var
    i: Integer;
    LoadList: TStringList;
    s10: string;
    bo15: Boolean;
  begin
    sListFileName := g_Config.sEnvirDir + sListFileName;
    LoadList := TStringList.Create;
    if FileExists(sListFileName) then begin
      try
        LoadList.LoadFromFile(sListFileName);
      except
        MainOutMessage('loading fail.... => ' + sListFileName);
        Exit;
      end;
    end;
    bo15 := False;
    for i := 0 to LoadList.Count - 1 do begin
      if LoadList.Count <= 0 then break;
      s10 := Trim(LoadList.Strings[i]);
      if CompareText(sHumName, s10) = 0 then begin
        LoadList.Delete(i);
        bo15 := True;
        break;
      end;
    end;
    if bo15 then begin
      try
        LoadList.SaveToFile(sListFileName);
      except
        MainOutMessage('saving fail.... => ' + sListFileName);
      end;
    end;
    LoadList.Free;
  end;
  procedure TakeItem(sItemName: string; nItemCount: Integer; sVarNo: string); //0049C998
  var
    i: Integer;
    UserItem: pTUserItem;
    StdItem: pTStdItem;
    nCount: Integer;
    sName: string;
  begin
    nCount := nItemCount;
    sName := sItemName;
    ConditionOfGetValValue(PlayObject, sItemName, sName); //ӱ֧
    ConditionOfGetValValue(PlayObject, sVarNo, nCount); //ӱ֧
    if nCount <= 0 then Exit;
    if CompareText(sName, g_Config.sGoldName) = 0 then begin
      PlayObject.DecGold(nCount);
      PlayObject.GoldChanged();
      //0049CADB
      if g_boGameLogGold then
        AddGameDataLog('10' + #9 +
          PlayObject.m_sMapName + #9 +
          IntToStr(PlayObject.m_nCurrX) + #9 +
          IntToStr(PlayObject.m_nCurrY) + #9 +
          PlayObject.m_sCharName + #9 +
          g_Config.sGoldName + #9 +
          IntToStr(nCount) + #9 +
          '1' + #9 +
          m_sCharName);
      Exit;
    end;
    for i := PlayObject.m_ItemList.Count - 1 downto 0 do begin
      if nCount <= 0 then break;
      UserItem := PlayObject.m_ItemList.Items[i];
      if UserItem = nil then Continue;
      if CompareText(UserEngine.GetStdItemName(UserItem.wIndex), sName) = 0 then begin
        //0049CC24
        StdItem := UserEngine.GetStdItem(UserItem.wIndex);
        if StdItem.NeedIdentify = 1 then
          AddGameDataLog('10' + #9 +
            PlayObject.m_sMapName + #9 +
            IntToStr(PlayObject.m_nCurrX) + #9 +
            IntToStr(PlayObject.m_nCurrY) + #9 +
            PlayObject.m_sCharName + #9 +
            sName + #9 +
            IntToStr(UserItem.MakeIndex) + #9 +
            '1' + #9 +
            m_sCharName);
        PlayObject.SendDelItems(UserItem);
        sSC := UserEngine.GetStdItemName(UserItem.wIndex);
        DisPose(UserItem);
        PlayObject.m_ItemList.Delete(i);
        Dec(nCount);
      end;
    end;
  end;

  procedure TakeWItem(sItemName: string; nItemCount: Integer); //0049CCF8
  var
    i: Integer;
    sName: string;
  begin
    if nItemCount = 0 then begin
      PlayObject.FindAndDelItem(sItemName);
      Exit;
    end;
    for i := Low(THumItems) to High(THumItems) do begin
      if nItemCount <= 0 then Exit;
      if PlayObject.m_UseItems[i].wIndex > 0 then begin
        sName := UserEngine.GetStdItemName(PlayObject.m_UseItems[i].wIndex);
        if CompareText(sName, sItemName) = 0 then begin
          PlayObject.SendDelItems(@PlayObject.m_UseItems[i]);
          PlayObject.m_UseItems[i].wIndex := 0;
          Dec(nItemCount);
        end;
      end;
    end;
  end;
  procedure MovData(QuestActionInfo: pTQuestActionInfo);

    function GetHumanInfoValue(sVariable: string; var sValue: string; var nValue: Integer; var nDataType: Integer): Boolean;
    var
      sMsg, s10: string;
    begin
      sValue := '';
      nValue := -1;
      nDataType := -1;
      Result := False;
      if sVariable = '' then Exit;
      sMsg := sVariable;
      ArrestStringEx(sMsg, '<', '>', s10);
      if s10 = '' then Exit;
      sVariable := s10;
      //Ϣ
      if sVariable = '$USERNAME' then begin
        sValue := PlayObject.m_sCharName;
        nDataType := 0;
        Result := True;
        Exit;
      end;
      if sVariable = '$GUILDNAME' then begin
        if PlayObject.m_MyGuild <> nil then begin
          sValue := TGUild(PlayObject.m_MyGuild).sGuildName;
        end else begin
          sValue := '';
        end;
        nDataType := 0;
        Result := True;
        Exit;
      end;
      if sVariable = '$RANKNAME' then begin
        sValue := PlayObject.m_sGuildRankName;
        nDataType := 0;
        Result := True;
        Exit;
      end;

      if sVariable = '$LEVEL' then begin
        nValue := PlayObject.m_Abil.Level;
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$HP' then begin
        nValue := PlayObject.m_WAbil.HP;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAXHP' then begin
        nValue := PlayObject.m_WAbil.MaxHP;
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$MP' then begin
        nValue := PlayObject.m_WAbil.MP;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAXMP' then begin
        nValue := PlayObject.m_WAbil.MaxMP;
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$AC' then begin
        nValue := LoWord(PlayObject.m_WAbil.AC);
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAXAC' then begin
        nValue := HiWord(PlayObject.m_WAbil.AC);
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAC' then begin
        nValue := LoWord(PlayObject.m_WAbil.MAC);
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAXMAC' then begin
        nValue := HiWord(PlayObject.m_WAbil.MAC);
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$DC' then begin
        nValue := LoWord(PlayObject.m_WAbil.DC);
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$MAXDC' then begin
        nValue := HiWord(PlayObject.m_WAbil.DC);
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$MC' then begin
        nValue := LoWord(PlayObject.m_WAbil.MC);
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAXMC' then begin
        nValue := HiWord(PlayObject.m_WAbil.MC);
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$SC' then begin
        nValue := LoWord(PlayObject.m_WAbil.SC);
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAXSC' then begin
        nValue := HiWord(PlayObject.m_WAbil.SC);
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$EXP' then begin
        nValue := PlayObject.m_Abil.Exp;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAXEXP' then begin
        nValue := PlayObject.m_Abil.MaxExp;
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$PKPOINT' then begin
        nValue := PlayObject.m_wPkPoint;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$CREDITPOINT' then begin
        nValue := PlayObject.m_btCreditPoint;
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$HW' then begin
        nValue := PlayObject.m_WAbil.HandWeight;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAXHW' then begin
        nValue := PlayObject.m_WAbil.MaxHandWeight;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$BW' then begin
        nValue := PlayObject.m_WAbil.Weight;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAXBW' then begin
        nValue := PlayObject.m_WAbil.MaxWeight;
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$WW' then begin
        nValue := PlayObject.m_WAbil.WearWeight;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$MAXWW' then begin
        nValue := PlayObject.m_WAbil.MaxWearWeight;
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$GOLDCOUNT' then begin
        nValue := PlayObject.m_nGold;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$GAMEGOLD' then begin
        nValue := PlayObject.m_nGameGold;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$GAMEPOINT' then begin
        nValue := PlayObject.m_nGamePoint;
        nDataType := 1;
        Result := True;
        Exit;
      end;

      if sVariable = '$LOGINTIME' then begin
        sValue := DateTimeToStr(PlayObject.m_dLogonTime);
        nDataType := 0;
        Result := True;
        Exit;
      end;
      if sVariable = '$DATETIME' then begin
        sValue := FormatDateTime('dddddd,dddd,hh:mm:nn', Now);
        nDataType := 0;
        Result := True;
        Exit;
      end;
      if sVariable = '$LOGINLONG' then begin
        nValue := (GetTickCount - PlayObject.m_dwLogonTick) div 60000;
        nDataType := 1;
        Result := True;
        Exit;
      end;
      if sVariable = '$DRESS' then begin
        sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_DRESS].wIndex);
        nDataType := 0;
        Result := True;
        Exit;
      end else
        if sVariable = '$WEAPON' then begin
          sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_WEAPON].wIndex);
          nDataType := 0;
          Result := True;
          Exit;
        end else
          if sVariable = '$RIGHTHAND' then begin
            sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_Light].wIndex);
            nDataType := 0;
            Result := True;
            Exit;
          end else
            if sVariable = '$HELMET' then begin
              sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_HELMET].wIndex);
              nDataType := 0;
              Result := True;
              Exit;
            end else
              if sVariable = '$NECKLACE' then begin
                sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_NECKLACE].wIndex);
                nDataType := 0;
                Result := True;
                Exit;
              end else
                if sVariable = '$RING_R' then begin
                  sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_RINGR].wIndex);
                  nDataType := 0;
                  Result := True;
                  Exit;
                end else
                  if sVariable = '$RING_L' then begin
                    sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_RINGL].wIndex);
                    nDataType := 0;
                    Result := True;
                    Exit;
                  end else
                    if sVariable = '$ARMRING_R' then begin
                      sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_ARMRINGR].wIndex);
                      nDataType := 0;
                      Result := True;
                      Exit;
                    end else
                      if sVariable = '$ARMRING_L' then begin
                        sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_ARMRINGL].wIndex);
                        nDataType := 0;
                        Result := True;
                        Exit;
                      end else
                        if sVariable = '$BUJUK' then begin
                          sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_BUJUK].wIndex);
                          nDataType := 0;
                          Result := True;
                          Exit;
                        end else
                          if sVariable = '$BELT' then begin
                            sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_BELT].wIndex);
                            nDataType := 0;
                            Result := True;
                            Exit;
                          end else
                            if sVariable = '$BOOTS' then begin
                              sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_BOOTS].wIndex);
                              nDataType := 0;
                              Result := True;
                              Exit;
                            end else
                              if sVariable = '$CHARM' then begin
                                sValue := UserEngine.GetStdItemName(PlayObject.m_UseItems[U_CHARM].wIndex);
                                nDataType := 0;
                                Result := True;
                                Exit;
                              end else
                                if sVariable = '$IPADDR' then begin
                                  sValue := PlayObject.m_sIPaddr;
                                  nDataType := 0;
                                  Result := True;
                                  Exit;
                                end else
                                  if sVariable = '$IPLOCAL' then begin
                                    sValue := PlayObject.m_sIPLocal; // GetIPLocal(PlayObject.m_sIPaddr);
                                    nDataType := 0;
                                    Result := True;
                                    Exit;
                                  end else
                                    if sVariable = '$GUILDBUILDPOINT' then begin
                                      if PlayObject.m_MyGuild <> nil then begin
                                        nValue := TGUild(PlayObject.m_MyGuild).nBuildPoint;
                                      end;
                                      nDataType := 0;
                                      Result := True;
                                      Exit;
                                    end else
                                      if sVariable = '$GUILDAURAEPOINT' then begin
                                        if PlayObject.m_MyGuild <> nil then begin
                                          nValue := TGUild(PlayObject.m_MyGuild).nAurae;
                                        end;
                                        nDataType := 0;
                                        Result := True;
                                        Exit;
                                      end else
                                        if sVariable = '$GUILDSTABILITYPOINT' then begin
                                          if PlayObject.m_MyGuild <> nil then begin
                                            nValue := TGUild(PlayObject.m_MyGuild).nStability;
                                          end;
                                          nDataType := 0;
                                          Result := True;
                                          Exit;
                                        end;
      if sVariable = '$GUILDFLOURISHPOINT' then begin
        if PlayObject.m_MyGuild <> nil then begin
          nValue := TGUild(PlayObject.m_MyGuild).nFlourishing;
        end;
        nDataType := 0;
        Result := True;
        Exit;
      end;
    end;

    function SetValNameValue(n100: Integer; sValue: string; nValue: Integer; nDataType: Integer): Boolean;
    begin
      if n100 >= 0 then begin
        if (sValue <> '') and(sValue[1]='\') then begin
           sValue:=GetRandomName(sValue);
        end;
        case nDataType of
          0: begin
              case n100 of
                600..699: begin
                    PlayObject.m_sString[n100 - 600] := sValue;
                    Result := True;
                  end;
                700..799: begin
                    g_Config.sGlobalAVal[n100 - 700] := sValue;
                    Result := True;
                  end;
              else begin
                  Result := False;
                end;
              end;
            end;
          1: begin
              case n100 of
                0..9: begin
                    PlayObject.m_nVal[n100] := nValue;
                    Result := True;
                  end;
                100..199: begin
                    g_Config.nGlobalVal[n100 - 100] := nValue;
                    Result := True;
                  end;
                200..209: begin
                    PlayObject.m_DyVal[n100 - 200] := nValue;
                    Result := True;
                  end;
                300..399: begin
                    PlayObject.m_nMval[n100 - 300] := nValue;
                    Result := True;
                  end;
                400..499: begin
                    g_Config.nGlobaDyMval[n100 - 400] := nValue;
                    Result := True;
                  end;
                500..599: begin
                    PlayObject.m_nInteger[n100 - 500] := nValue;
                    Result := True;
                  end;
              else begin
                  Result := False;
                end;
              end;
            end;

          3: begin
              mainoutmessage('SetValNameValue 3');
              case n100 of
                0..9: begin
                    PlayObject.m_nVal[n100] := nValue;
                    Result := True;
                  end;
                100..199: begin
                    g_Config.nGlobalVal[n100 - 100] := nValue;
                    Result := True;
                  end;
                200..209: begin
                    PlayObject.m_DyVal[n100 - 200] := nValue;
                    Result := True;
                  end;
                300..399: begin
                    PlayObject.m_nMval[n100 - 300] := nValue;
                    Result := True;
                  end;
                400..499: begin
                    g_Config.nGlobaDyMval[n100 - 400] := nValue;
                    Result := True;
                  end;
                500..599: begin
                    PlayObject.m_nInteger[n100 - 500] := nValue;
                    Result := True;
                  end;
                600..699: begin
                    PlayObject.m_sString[n100 - 600] := sValue;
                    Result := True;
                  end;
                700..799: begin
                    g_Config.sGlobalAVal[n100 - 700] := sValue;
                    Result := True;
                  end;
              else begin
                  Result := False;
                end;
              end;
            end;
        end;
      end else Result := False;
    end;
    function GetValNameValue(sVarName: string; var sValue: string; var nValue: Integer; var nDataType: Integer): Boolean;
    var
      n100: Integer;
    begin
      nValue := -1;
      sValue := '';
      nDataType := -1;
      n100 := GetValNameNo(sVarName);
      if n100 >= 0 then begin
        case n100 of
          0..9: begin
              nValue := PlayObject.m_nVal[n100];
              nDataType := 1;
              Result := True;
            end;
          100..199: begin
              nValue := g_Config.nGlobalVal[n100 - 100];
              nDataType := 1;
              Result := True;
            end;
          200..209: begin
              nValue := PlayObject.m_DyVal[n100 - 200];
              nDataType := 1;
              Result := True;
            end;
          300..399: begin
              nValue := PlayObject.m_nMval[n100 - 300];
              nDataType := 1;
              Result := True;
            end;
          400..499: begin
              nValue := g_Config.nGlobaDyMval[n100 - 400];
              nDataType := 1;
              Result := True;
            end;
          500..599: begin
              nValue := PlayObject.m_nInteger[n100 - 500];
              nDataType := 1;
              Result := True;
            end;
          600..699: begin
              sValue := PlayObject.m_sString[n100 - 600];
              nDataType := 0;
              Result := True;
            end;
          700..799: begin
              sValue := g_Config.sGlobalAVal[n100 - 700];
              nDataType := 0;
              Result := True;
            end;
        else begin
            Result := False;
          end;
        end;
      end else Result := False;
    end;

    function GetDynamicVarValue(sVarType, sVarName: string; var sValue: string; var nValue: Integer; var nDataType: Integer): Boolean;
    var
      V: Integer;
      DynamicVar: pTDynamicVar;
      DynamicVarList: TSimpleList;
      sName: string;
      boVarFound: Boolean;
    begin
      boVarFound := False;
      sValue := '';
      nValue := -1;
      nDataType := -1;
      DynamicVarList := GetDynamicVarList(PlayObject, sVarType, sName);
      if DynamicVarList = nil then begin
        //DisPose(DynamicVar);
        Result := False;
        Exit;
      end;
      for V := 0 to DynamicVarList.Count - 1 do begin
        DynamicVar := DynamicVarList.Items[V];
        if CompareText(DynamicVar.sName, sVarName) = 0 then begin
          case DynamicVar.VarType of
            vInteger: begin
                nValue := DynamicVar.nInternet;
                nDataType := 1;
              end;
            vString: begin
                sValue := DynamicVar.sString;
                nDataType := 0;
              end;
          end;
          boVarFound := True;
          break;
        end;
      end;
      if not boVarFound then
        Result := False else Result := True;
    end;

    function SetDynamicVarValue(sVarType, sVarName: string; sValue: string; nValue: Integer; nDataType: Integer): Boolean;
    var
      V: Integer;
      DynamicVar: pTDynamicVar;
      DynamicVarList: TSimpleList;
      sName: string;
      boVarFound: Boolean;
    begin
      boVarFound := False;
      DynamicVarList := GetDynamicVarList(PlayObject, sVarType, sName);
      if DynamicVarList = nil then begin
        DisPose(DynamicVar);
        Result := False;
        Exit;
      end;
      for V := 0 to DynamicVarList.Count - 1 do begin
        DynamicVar := DynamicVarList.Items[V];
        if CompareText(DynamicVar.sName, sVarName) = 0 then begin
          if nDataType = 1 then begin
            case DynamicVar.VarType of
              vInteger: begin
                  DynamicVar.nInternet := nValue;
                  boVarFound := True;
                  break;
                end;
            end;
          end else begin
            case DynamicVar.VarType of
              vString: begin
                  DynamicVar.sString := sValue;
                  boVarFound := True;
                  break;
                end;
            end;
          end;
        end;
      end;
      if not boVarFound then Result := False else Result := True;
    end;

    function GetDataType: Integer; //
    var
      s10: string;
    begin
      Result := -1;
      with QuestActionInfo^ do begin

        if IsVarNumber(sParam1) then begin //ĿԶ
          if (sParam3 <> '') and (sParam3[1] = '<') and (sParam3[Length(sParam3)] = '>') then begin
            Result := 0; //Դ Ϣ
          end else
            if (sParam3 <> '') and (GetValNameNo(sParam3) >= 0) then begin
              Result := 1;  //Դ ̶
            end else
              if (sParam3 <> '') and IsStringNumber(sParam3) then begin
                Result := 2;  //Դ 
              end else begin
                Result := 3;  //Դַ
              end;
          Exit;
        end;

        nParam1 := GetValNameNo(sParam1);
        if nParam1 >= 0 then begin //Ŀǹ̶
          if (sParam2 <> '') and (sParam2[1] = '<') and (sParam2[Length(sParam2)] = '>') then begin
            Result := 4;      //Դ Ϣ
          end else
            if (sParam2 <> '') and (GetValNameNo(sParam2) >= 0) then begin
              Result := 5;       //Դ ̶
            end else
              if (sParam2 <> '') and IsVarNumber(sParam2) then begin
                Result := 6;   //Դ 
              end else begin
                Result := 7;  //Դַ
              end;
          Exit;
        end else Result := -2;
      end;
    end;
  var
    sString: string;
    sValue: string;
    nValue: Integer;
    nr:Integer;
    nDataType: Integer;
  resourcestring
    sVarFound = '%sڣ:%s';
    sVarTypeError = 'ʹ󣬴:%s ǰ֧(HUMANGUILDGLOBAL)';
    sDataTypeError = 'Ͳһ£:%s %s';
  begin
    //A0 <$LEVEL>
    with QuestActionInfo^ do begin
      if sParam1 = '' then begin
        ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
        Exit;
      end;
      nr := GetDataType;
      case nr of
        {-1:begin


           end; }
        0: begin
            if GetHumanInfoValue(sParam3, sValue, nValue, nDataType) then begin
              if not SetDynamicVarValue(sParam1, sParam2, sValue, nValue, nDataType) then
                ScriptActionError(PlayObject, format(sVarFound, [sParam1, sParam2]), QuestActionInfo, sMOV);
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
            end;
            Exit;
          end;
        1: begin
            if GetValNameValue(sParam3, sValue, nValue, nDataType) then begin
              //MainOutMessage('GetValNameValue sValue '+sValue+' nDataType '+IntToStr(nDataType));
              if not SetDynamicVarValue(sParam1, sParam2, sValue, nValue, nDataType) then
                ScriptActionError(PlayObject, format(sVarFound, [sParam1, sParam2]), QuestActionInfo, sMOV);
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
            end;
            Exit;
          end;
        2: begin
            if not SetDynamicVarValue(sParam1, sParam2, QuestActionInfo.sParam3, QuestActionInfo.nParam3, 1) then
              ScriptActionError(PlayObject, format(sVarFound, [sParam1, sParam2]), QuestActionInfo, sMOV);
          end;
        3: begin
            if not SetDynamicVarValue(sParam1, sParam2, QuestActionInfo.sParam3, QuestActionInfo.nParam3, 0) then
              ScriptActionError(PlayObject, format(sVarFound, [sParam1, sParam2]), QuestActionInfo, sMOV);
          end;




        //==============================================================================
        4: begin
            if GetHumanInfoValue(sParam2, sValue, nValue, nDataType) then begin
              if not SetValNameValue(nParam1, sValue, nValue, nDataType) then
                ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
            end;
            Exit;
          end;
        5: begin
            if GetValNameValue(sParam2, sValue, nValue, nDataType) then begin
              if not SetValNameValue(nParam1, sValue, nValue, nDataType) then
                ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
            end;
            Exit;
          end;
        6: begin
            if GetDynamicVarValue(sParam2, sParam3, sValue, nValue, nDataType) then begin
              if not SetValNameValue(nParam1, sValue, nValue, nDataType) then
                ScriptActionError(PlayObject, 'n1'+inttostr(nParam1)+ 'not Set type'+inttostr(nDataType), QuestActionInfo, sMOV);
            end else begin
              ScriptActionError(PlayObject, format(sVarFound, [sParam2, sParam3]), QuestActionInfo, sMOV);
            end;
            Exit;
          end;
        7: begin
            {PlayObject.m_sIPaddr := GetCurrentDir;
            PlayObject.m_sIPaddr :=PlayObject.m_sIPaddr;  }
            if GetValNameValue(sParam1, sValue, nValue, nDataType) then begin
              if not SetValNameValue(nParam1, QuestActionInfo.sParam2, QuestActionInfo.nParam2, nDataType) then begin
                ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
                Exit;
              end;
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
            end;
          end;
        {8: begin
            if not SetValNameValue(sParam1, QuestActionInfo.sParam2, QuestActionInfo.nParam2, 0) then begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
            end;
            Exit;
          end;}
      else begin
          ScriptActionError(PlayObject, inttostr(nr), QuestActionInfo, sMOV);
        end;
      end;
    end;
  end;


  procedure IncInteger(QuestActionInfo: pTQuestActionInfo);
  var
    i, n14, n3C, n10: Integer;
    DynamicVar: pTDynamicVar;
    DynamicVarList: TSimpleList;
    sName: string;
    boVarFound: Boolean;
    sParam1: string;
    sParam2: string;
    sParam3: string;
  resourcestring
    sVarFound = '%sڣ:%s';
    sVarTypeError = 'ʹ󣬴:%s ǰ֧(HUMANGUILDGLOBAL)';
  begin
    n10 := 0;
    sParam1 := QuestActionInfo.sParam1;
    sParam2 := QuestActionInfo.sParam2;
    sParam3 := QuestActionInfo.sParam3;
    if (sParam1 = '') or (sParam2 = '') then begin
      ScriptActionError(PlayObject, '', QuestActionInfo, sINC);
      Exit;
    end;
    if sParam3 <> '' then begin
      if (not IsVarNumber(sParam1)) and (IsVarNumber(sParam2)) then begin
        n10 := 1;
        boVarFound := False;
        DynamicVarList := GetDynamicVarList(PlayObject, sParam2, sName);
        if DynamicVarList = nil then begin
          DisPose(DynamicVar);
          ScriptActionError(PlayObject, format(sVarTypeError, [sParam2]), QuestActionInfo, sINC);
          Exit;
        end;
        for i := 0 to DynamicVarList.Count - 1 do begin
          DynamicVar := DynamicVarList.Items[i];
          if CompareText(DynamicVar.sName, sParam3) = 0 then begin
            case DynamicVar.VarType of
              vInteger: begin
                  n3C := DynamicVar.nInternet;
                end;
              vString: begin
                end;
            end;
            boVarFound := True;
            break;
          end;
        end;
        if not boVarFound then begin
          ScriptActionError(PlayObject, format(sVarFound, [sParam3, sParam2]), QuestActionInfo, sINC);
          Exit;
        end;
        n14 := GetValNameNo(sParam1);
        if n14 >= 0 then begin
          case n14 of
            0..9: begin
                if n3C > 1 then begin
                  Inc(PlayObject.m_nVal[n14], n3C);
                end else begin
                  Inc(PlayObject.m_nVal[n14]);
                end;
              end;
            100..199: begin
                if n3C > 1 then begin
                  Inc(g_Config.nGlobalVal[n14 - 100], n3C);
                end else begin
                  Inc(g_Config.nGlobalVal[n14 - 100]);
                end;
              end;
            200..209: begin
                if n3C > 1 then begin
                  Inc(PlayObject.m_DyVal[n14 - 200], n3C);
                end else begin
                  Inc(PlayObject.m_DyVal[n14 - 200]);
                end;
              end;
            300..399: begin
                if n3C > 1 then begin
                  Inc(PlayObject.m_nMval[n14 - 300], n3C);
                end else begin
                  Inc(PlayObject.m_nMval[n14 - 300]);
                end;
              end;
            400..499: begin
                if n3C > 1 then begin
                  Inc(g_Config.nGlobaDyMval[n14 - 400], n3C);
                end else begin
                  Inc(g_Config.nGlobaDyMval[n14 - 400]);
                end;
              end;
            500..599: begin
                if n3C > 1 then begin
                  Inc(PlayObject.m_nInteger[n14 - 500], n3C);
                end else begin
                  Inc(PlayObject.m_nInteger[n14 - 500]);
                end;
              end;
          else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sINC);
              Exit;
            end;
          end;
        end else begin
          ScriptActionError(PlayObject, '', QuestActionInfo, sINC);
          Exit;
        end;
        Exit;
      end;
      if (IsVarNumber(sParam1)) and (not IsVarNumber(sParam2)) then begin
        if (sParam3 <> '') and (not IsStringNumber(sParam3)) then begin
          n10 := 1;
          n14 := GetValNameNo(sParam3);
          if n14 >= 0 then begin
            case n14 of
              0..9: begin
                  n3C := PlayObject.m_nVal[n14];
                end;
              100..199: begin
                  n3C := g_Config.nGlobalVal[n14 - 100];
                end;
              200..209: begin
                  n3C := PlayObject.m_DyVal[n14 - 200];
                end;
              300..399: begin
                  n3C := PlayObject.m_nMval[n14 - 300];
                end;
              400..499: begin
                  n3C := g_Config.nGlobaDyMval[n14 - 400];
                end;
              500..599: begin
                  n3C := PlayObject.m_nInteger[n14 - 500];
                end;
            else begin
                ScriptActionError(PlayObject, '', QuestActionInfo, sINC);
                Exit;
              end;
            end;
          end else begin
            ScriptActionError(PlayObject, '', QuestActionInfo, sINC);
            Exit;
          end;
        end else n3C := QuestActionInfo.nParam3;
        boVarFound := False;
        DynamicVarList := GetDynamicVarList(PlayObject, sParam1, sName);
        if DynamicVarList = nil then begin
          DisPose(DynamicVar);
          ScriptActionError(PlayObject, format(sVarTypeError, [sParam1]), QuestActionInfo, sINC);
          Exit;
        end;
        for i := 0 to DynamicVarList.Count - 1 do begin
          DynamicVar := DynamicVarList.Items[i];
          if CompareText(DynamicVar.sName, sParam2) = 0 then begin
            case DynamicVar.VarType of
              vInteger: begin
                  if n3C > 1 then begin
                    Inc(DynamicVar.nInternet, n3C);
                  end else begin
                    Inc(DynamicVar.nInternet);
                  end;
                end;
              vString: begin
                end;
            end;
            boVarFound := True;
            break;
          end;
        end;
        if not boVarFound then begin
          ScriptActionError(PlayObject, format(sVarFound, [sParam2, sParam1]), QuestActionInfo, sINC);
          Exit;
        end;
        Exit;
      end;
      if n10 = 0 then
        ScriptActionError(PlayObject, '', QuestActionInfo, sINC);
    end else begin
      if (sParam2 <> '') and (not IsStringNumber(sParam2)) then begin //ȡ2ֵ
        n14 := GetValNameNo(sParam2);
        if n14 >= 0 then begin
          case n14 of
            0..9: begin
                n3C := PlayObject.m_nVal[n14];
              end;
            100..199: begin
                n3C := g_Config.nGlobalVal[n14 - 100];
              end;
            200..209: begin
                n3C := PlayObject.m_DyVal[n14 - 200];
              end;
            300..399: begin
                n3C := PlayObject.m_nMval[n14 - 300];
              end;
            400..499: begin
                n3C := g_Config.nGlobaDyMval[n14 - 400];
              end;
            500..599: begin
                n3C := PlayObject.m_nInteger[n14 - 500];
              end;
          else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
              Exit;
            end;
          end;
        end else begin
          ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
          Exit;
        end;
      end else n3C := QuestActionInfo.nParam2;
      n14 := GetValNameNo(sParam1);
      if n14 >= 0 then begin
        case n14 of
          0..9: begin
              if n3C > 1 then begin
                Inc(PlayObject.m_nVal[n14], n3C);
              end else begin
                Inc(PlayObject.m_nVal[n14]);
              end;
            end;
          100..199: begin
              if n3C > 1 then begin
                Inc(g_Config.nGlobalVal[n14 - 100], n3C);
              end else begin
                Inc(g_Config.nGlobalVal[n14 - 100]);
              end;
            end;
          200..209: begin
              if n3C > 1 then begin
                Inc(PlayObject.m_DyVal[n14 - 200], n3C);
              end else begin
                Inc(PlayObject.m_DyVal[n14 - 200]);
              end;
            end;
          300..399: begin
              if n3C > 1 then begin
                Inc(PlayObject.m_nMval[n14 - 300], n3C);
              end else begin
                Inc(PlayObject.m_nMval[n14 - 300]);
              end;
            end;
          400..499: begin
              if n3C > 1 then begin
                Inc(g_Config.nGlobaDyMval[n14 - 400], n3C);
              end else begin
                Inc(g_Config.nGlobaDyMval[n14 - 400]);
              end;
            end;
          500..599: begin
              if n3C > 1 then begin
                Inc(PlayObject.m_nInteger[n14 - 500], n3C);
              end else begin
                Inc(PlayObject.m_nInteger[n14 - 500]);
              end;
            end;
        else begin
            ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
            Exit;
          end;
        end;
      end else begin
        ScriptActionError(PlayObject, '', QuestActionInfo, sMOV);
        Exit;
      end;
    end;
  end;

  procedure DecInteger(QuestActionInfo: pTQuestActionInfo);
  var
    i, n14, n3C, n10: Integer;
    DynamicVar: pTDynamicVar;
    DynamicVarList: TSimpleList;
    sName: string;
    boVarFound: Boolean;
    sParam1: string;
    sParam2: string;
    sParam3: string;
  resourcestring
    sVarFound = '%sڣ:%s';
    sVarTypeError = 'ʹ󣬴:%s ǰ֧(HUMANGUILDGLOBAL)';
  begin
    //MainOutMessage('DecInteger');
    n10 := 0;
    sParam1 := QuestActionInfo.sParam1;
    sParam2 := QuestActionInfo.sParam2;
    sParam3 := QuestActionInfo.sParam3;
    if (sParam1 = '') or (sParam2 = '') then begin
      ScriptActionError(PlayObject, '', QuestActionInfo, sDEC);
      Exit;
    end;
    if sParam3 <> '' then begin
      if (not IsVarNumber(sParam1)) and (IsVarNumber(sParam2)) then begin
        n10 := 1;
        boVarFound := False;
        DynamicVarList := GetDynamicVarList(PlayObject, sParam2, sName);
        if DynamicVarList = nil then begin
          DisPose(DynamicVar);
          ScriptActionError(PlayObject, format(sVarTypeError, [sParam2]), QuestActionInfo, sDEC);
          Exit;
        end;
        for i := 0 to DynamicVarList.Count - 1 do begin
          DynamicVar := DynamicVarList.Items[i];
          if CompareText(DynamicVar.sName, sParam3) = 0 then begin
            case DynamicVar.VarType of
              vInteger: begin
                  n3C := DynamicVar.nInternet;
                end;
              vString: begin
                end;
            end;
            boVarFound := True;
            break;
          end;
        end;
        if not boVarFound then begin
          ScriptActionError(PlayObject, format(sVarFound, [sParam3, sParam2]), QuestActionInfo, sDEC);
          Exit;
        end;
        n14 := GetValNameNo(sParam1);
        if n14 >= 0 then begin
          case n14 of
            0..9: begin
                if n3C > 1 then begin
                  Dec(PlayObject.m_nVal[n14], n3C);
                end else begin
                  Dec(PlayObject.m_nVal[n14]);
                end;
              end;
            100..199: begin
                if n3C > 1 then begin
                  Dec(g_Config.nGlobalVal[n14 - 100], n3C);
                end else begin
                  Dec(g_Config.nGlobalVal[n14 - 100]);
                end;
              end;
            200..209: begin
                if n3C > 1 then begin
                  Dec(PlayObject.m_DyVal[n14 - 200], n3C);
                end else begin
                  Dec(PlayObject.m_DyVal[n14 - 200]);
                end;
              end;
            300..399: begin
                if n3C > 1 then begin
                  Dec(PlayObject.m_nMval[n14 - 300], n3C);
                end else begin
                  Dec(PlayObject.m_nMval[n14 - 300]);
                end;
              end;
            400..499: begin
                if n3C > 1 then begin
                  Dec(g_Config.nGlobaDyMval[n14 - 400], n3C);
                end else begin
                  Dec(g_Config.nGlobaDyMval[n14 - 400]);
                end;
              end;
            500..599: begin
                if n3C > 1 then begin
                  Dec(PlayObject.m_nInteger[n14 - 500], n3C);
                end else begin
                  Dec(PlayObject.m_nInteger[n14 - 500]);
                end;
              end;
          else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sDEC);
              Exit;
            end;
          end;
        end else begin
          ScriptActionError(PlayObject, '', QuestActionInfo, sDEC);
          Exit;
        end;
        Exit;
      end;
      if (IsVarNumber(sParam1)) and (not IsVarNumber(sParam2)) then begin
        if (sParam3 <> '') and (not IsStringNumber(sParam3)) then begin
          n10 := 1;
          n14 := GetValNameNo(sParam3);
          if n14 >= 0 then begin
            case n14 of
              0..9: begin
                  n3C := PlayObject.m_nVal[n14];
                end;
              100..199: begin
                  n3C := g_Config.nGlobalVal[n14 - 100];
                end;
              200..209: begin
                  n3C := PlayObject.m_DyVal[n14 - 200];
                end;
              300..399: begin
                  n3C := PlayObject.m_nMval[n14 - 300];
                end;
              400..499: begin
                  n3C := g_Config.nGlobaDyMval[n14 - 400];
                end;
              500..599: begin
                  n3C := PlayObject.m_nInteger[n14 - 500];
                end;
            else begin
                ScriptActionError(PlayObject, '', QuestActionInfo, sDEC);
                Exit;
              end;
            end;
          end else begin
            ScriptActionError(PlayObject, '', QuestActionInfo, sDEC);
            Exit;
          end;
        end else n3C := QuestActionInfo.nParam3;
        boVarFound := False;
        DynamicVarList := GetDynamicVarList(PlayObject, sParam1, sName);
        if DynamicVarList = nil then begin
          DisPose(DynamicVar);
          ScriptActionError(PlayObject, format(sVarTypeError, [sParam1]), QuestActionInfo, sDEC);
          Exit;
        end;
        for i := 0 to DynamicVarList.Count - 1 do begin
          DynamicVar := DynamicVarList.Items[i];
          if CompareText(DynamicVar.sName, sParam2) = 0 then begin
            case DynamicVar.VarType of
              vInteger: begin
                  if n3C > 1 then begin
                    Dec(DynamicVar.nInternet, n3C);
                  end else begin
                    Dec(DynamicVar.nInternet);
                  end;
                end;
              vString: begin
                end;
            end;
            boVarFound := True;
            break;
          end;
        end;
        if not boVarFound then begin
          ScriptActionError(PlayObject, format(sVarFound, [sParam2, sParam1]), QuestActionInfo, sDEC);
          Exit;
        end;
        Exit;
      end;
      if n10 = 0 then
        ScriptActionError(PlayObject, '', QuestActionInfo, sDEC);
    end else begin
      if (sParam2 <> '') and (not IsStringNumber(sParam2)) then begin //ȡ2ֵ
        n14 := GetValNameNo(sParam2);
        if n14 >= 0 then begin
          case n14 of
            0..9: begin
                n3C := PlayObject.m_nVal[n14];
              end;
            100..199: begin
                n3C := g_Config.nGlobalVal[n14 - 100];
              end;
            200..209: begin
                n3C := PlayObject.m_DyVal[n14 - 200];
              end;
            300..399: begin
                n3C := PlayObject.m_nMval[n14 - 300];
              end;
            400..499: begin
                n3C := g_Config.nGlobaDyMval[n14 - 400];
              end;
            500..599: begin
                n3C := PlayObject.m_nInteger[n14 - 500];
              end;
          else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sDEC);
              Exit;
            end;
          end;
        end else begin
          ScriptActionError(PlayObject, '', QuestActionInfo, sDEC);
          Exit;
        end;
      end else n3C := QuestActionInfo.nParam2;
      n14 := GetValNameNo(sParam1);
      if n14 >= 0 then begin
        case n14 of
          0..9: begin
              if n3C > 1 then begin
                Dec(PlayObject.m_nVal[n14], n3C);
              end else begin
                Dec(PlayObject.m_nVal[n14]);
              end;
            end;
          100..199: begin
              if n3C > 1 then begin
                Dec(g_Config.nGlobalVal[n14 - 100], n3C);
              end else begin
                Dec(g_Config.nGlobalVal[n14 - 100]);
              end;
            end;
          200..209: begin
              if n3C > 1 then begin
                Dec(PlayObject.m_DyVal[n14 - 200], n3C);
              end else begin
                Dec(PlayObject.m_DyVal[n14 - 200]);
              end;
            end;
          300..399: begin
              if n3C > 1 then begin
                Dec(PlayObject.m_nMval[n14 - 300], n3C);
              end else begin
                Dec(PlayObject.m_nMval[n14 - 300]);
              end;
            end;
          400..499: begin
              if n3C > 1 then begin
                Dec(g_Config.nGlobaDyMval[n14 - 400], n3C);
              end else begin
                Dec(g_Config.nGlobaDyMval[n14 - 400]);
              end;
            end;
          500..599: begin
              if n3C > 1 then begin
                Dec(PlayObject.m_nInteger[n14 - 500], n3C);
              end else begin
                Dec(PlayObject.m_nInteger[n14 - 500]);
              end;
            end;
        else begin
            ScriptActionError(PlayObject, '', QuestActionInfo, sDEC);
            Exit;
          end;
        end;
      end else begin
        ScriptActionError(PlayObject, '', QuestActionInfo, sDEC);
        Exit;
      end;
    end;
  end;

  function QuestActionProcess(ActionList: TList): Boolean; //0049D660
  var
    i, ii, III: Integer;
    QuestActionInfo: pTQuestActionInfo;
    n14, n18, n1C, n28, n2C: Integer;
    n20X, n24Y, n34, n38, n3C, n40: Integer;
    s4C, s50: string;
    s34, s44, s48: string;
    Map: TMap;
    List58: TList;
    User: TPlayObject;
    DynamicVar: pTDynamicVar;
    DynamicVarList: TList;
    sName: string;
    OnLinePlayObject: TPlayObject;
    GuildRank: pTGuildRank;
    BaseObject: TBaseObject;
  begin
    Result := True;
    n18 := 0;
    n34 := 0;
    n38 := 0;
    n3C := 0;
    n40 := 0;
    for i := 0 to ActionList.Count - 1 do begin
      QuestActionInfo := ActionList.Items[i];
      case QuestActionInfo.nCMDCode of
        nSET: begin
            n28 := Str_ToInt(QuestActionInfo.sParam1, 0);
            n2C := Str_ToInt(QuestActionInfo.sParam2, 0);
            PlayObject.SetQuestFlagStatus(n28, n2C);
          end;
        nTAKE: TakeItem(QuestActionInfo.sParam1, QuestActionInfo.nParam2, QuestActionInfo.sParam2);
        //nGIVE: GiveItem(QuestActionInfo.sParam1,QuestActionInfo.nParam2);
        nSC_GIVE: ActionOfGiveItem(PlayObject, QuestActionInfo);
        nTAKEW: begin
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C) then begin //ӱ֧
              s4C := QuestActionInfo.sParam1;
            end;
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, n14) then begin //ӱ֧
              n14 := QuestActionInfo.nParam2;
            end;
            TakeWItem(s4C, n14);
          end;
        nCLOSE: PlayObject.AddAction(Self, RM_MERCHANTDLGCLOSE, 0, Integer(Self), 0, 0, '');
        nRESET: begin
            for ii := 0 to QuestActionInfo.nParam2 - 1 do begin
              PlayObject.SetQuestFlagStatus(QuestActionInfo.nParam1 + ii, 0);
            end;
          end;
        nSETOPEN: begin
            n28 := Str_ToInt(QuestActionInfo.sParam1, 0);
            n2C := Str_ToInt(QuestActionInfo.sParam2, 0);
            PlayObject.SetQuestUnitOpenStatus(n28, n2C);
          end;
        nSETUNIT: begin
            n28 := Str_ToInt(QuestActionInfo.sParam1, 0);
            n2C := Str_ToInt(QuestActionInfo.sParam2, 0);
            PlayObject.SetQuestUnitStatus(n28, n2C);
          end;
        nRESETUNIT: begin
            for ii := 0 to QuestActionInfo.nParam2 - 1 do begin
              PlayObject.SetQuestUnitStatus(QuestActionInfo.nParam1 + ii, 0);
            end;
          end;
        nBREAK: Result := False;
        nTIMERECALL: begin
            PlayObject.m_boTimeRecall := True;
            PlayObject.m_sMoveMap := PlayObject.m_sMapName;
            PlayObject.m_nMoveX := PlayObject.m_nCurrX;
            PlayObject.m_nMoveY := PlayObject.m_nCurrY;
            PlayObject.m_dwTimeRecallTick := GetTickCount + LongWord(QuestActionInfo.nParam1 * 60 * 1000);
          end;
        nSC_PARAM1: begin
            n34 := QuestActionInfo.nParam1;
            s44 := QuestActionInfo.sParam1;
          end;
        nSC_PARAM2: begin
            n38 := QuestActionInfo.nParam1;
            s48 := QuestActionInfo.sParam1;
          end;
        nSC_PARAM3: begin
            n3C := QuestActionInfo.nParam1;
            s4C := QuestActionInfo.sParam1;
          end;
        nSC_PARAM4: begin
            n40 := QuestActionInfo.nParam1;
            s50 := QuestActionInfo.sParam1;
          end;
        nSC_EXEACTION: begin
            n40 := QuestActionInfo.nParam1;
            s50 := QuestActionInfo.sParam1;
            ExeAction(PlayObject, QuestActionInfo.sParam1, QuestActionInfo.sParam2, QuestActionInfo.sParam3, QuestActionInfo.nParam1, QuestActionInfo.nParam2, QuestActionInfo.nParam3);
          end;
        nSC_MoveToHome: begin
            PlayObject.MoveToHome;
            bo11 := True;
          end;
        nMAPMOVE: begin
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C) then begin //ӱ֧
              s4C := QuestActionInfo.sParam1;
            end;
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, n14) then begin //ӱ֧
              n14 := QuestActionInfo.nParam2;
            end;
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam3, n40) then begin //ӱ֧
              n40 := QuestActionInfo.nParam3;
            end;
            PlayObject.AddRefAction(RM_SPACEMOVE_FIRE, 0, 0, 0, 0, '');
            PlayObject.SpaceMove(s4C, n14, n40, 0);
            bo11 := True;
          end;
        nMAP: begin
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C) then begin //ӱ֧
              s4C := QuestActionInfo.sParam1;
            end;
            PlayObject.AddRefAction(RM_SPACEMOVE_FIRE, 0, 0, 0, 0, '');
            PlayObject.MapRandomMove(s4C, 0);
            bo11 := True;
          end;
        nTAKECHECKITEM: begin
            if UserItem <> nil then begin
              PlayObject.QuestTakeCheckItem(UserItem);
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sTAKECHECKITEM);
            end;
          end;
        nMONGEN: begin
            for ii := 0 to QuestActionInfo.nParam2 - 1 do begin
              n20X := Random(QuestActionInfo.nParam3 * 2 + 1) + (n38 - QuestActionInfo.nParam3);
              n24Y := Random(QuestActionInfo.nParam3 * 2 + 1) + (n3C - QuestActionInfo.nParam3);
             { if (s44 = '')then
              begin
              s44:=PlayObject.m_sMapName;
              MainOutMessage ('(s44 = '')');//or s44 = mymap]') ;
              end;   }
              UserEngine.RegenMonsterByName(s44, n20X, n24Y, QuestActionInfo.sParam1);
            end;
          end;
        nMONCLEAR: begin
            List58 := TList.Create;
            UserEngine.GetMapMonster(g_MapManager.FindMap(QuestActionInfo.sParam1), List58);
            for ii := 0 to List58.Count - 1 do begin
              TBaseObject(List58.Items[ii]).m_boNoItem := True;
              TBaseObject(List58.Items[ii]).m_WAbil.HP := 0;
            end;
            List58.Free;
          end;
        nMOV: MovData(QuestActionInfo);

        nINC: IncInteger(QuestActionInfo);
        nDEC: DecInteger(QuestActionInfo);
        nSUM: begin
            n18 := 0;
            n14 := GetValNameNo(QuestActionInfo.sParam1);
            if n14 >= 0 then begin
              case n14 of //
                0..9: begin
                    n18 := PlayObject.m_nVal[n14];
                  end;
                100..199: begin
                    n18 := g_Config.nGlobalVal[n14 - 100];
                  end;
                200..209: begin
                    n18 := PlayObject.m_DyVal[n14 - 200];
                  end;
                300..399: begin
                    n18 := PlayObject.m_nMval[n14 - 300];
                  end;
                400..499: begin
                    n18 := g_Config.nGlobaDyMval[n14 - 400];
                  end;
                500..599: begin
                    n18 := PlayObject.m_nInteger[n14 - 500];
                  end;
              else begin
                  ScriptActionError(PlayObject, '', QuestActionInfo, sSUM);
                end;
              end; // case
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sSUM);
            end;
            n1C := 0;
            n14 := GetValNameNo(QuestActionInfo.sParam2);
            if n14 >= 0 then begin
              case n14 of //
                0..9: begin
                    n1C := PlayObject.m_nVal[n14];
                  end;
                100..199: begin
                    n1C := g_Config.nGlobalVal[n14 - 100];
                  end;
                200..209: begin
                    n1C := PlayObject.m_DyVal[n14 - 200];
                  end;
                300..399: begin
                    n1C := PlayObject.m_nMval[n14 - 300];
                  end;
                400..499: begin
                    n1C := g_Config.nGlobaDyMval[n14 - 400];
                  end;
                500..599: begin
                    n1C := PlayObject.m_nInteger[n14 - 500];
                  end;
              else begin
                  ScriptActionError(PlayObject, '', QuestActionInfo, sSUM);
                end;
              end;
            end else begin
              //ScriptActionError(PlayObject,'',QuestActionInfo,sSUM);
            end;
            n14 := GetValNameNo(QuestActionInfo.sParam1);
            if n14 >= 0 then begin
              case n14 of //
                0..9: begin
                    PlayObject.m_nVal[9] := PlayObject.m_nVal[9] + n18 + n1C;
                  end;
                100..199: begin
                    g_Config.nGlobalVal[99] := g_Config.nGlobalVal[99] + n18 + n1C;
                  end;
                200..209: begin
                    PlayObject.m_DyVal[9] := PlayObject.m_DyVal[9] + n18 + n1C;
                  end;
                300..399: begin
                    PlayObject.m_nMval[99] := PlayObject.m_nMval[99] + n18 + n1C;
                  end;
                400..499: begin
                    g_Config.nGlobaDyMval[99] := g_Config.nGlobaDyMval[99] + n18 + n1C;
                  end;
                500..599: begin
                    PlayObject.m_nInteger[9] := PlayObject.m_nInteger[9] + n18 + n1C;
                  end;
              end;
            end;
          end;
        nBREAKTIMERECALL: PlayObject.m_boTimeRecall := False;

        nCHANGEMODE: begin
            case QuestActionInfo.nParam1 of
              1: PlayObject.CmdChangeAdminMode('', 10, '', Str_ToInt(QuestActionInfo.sParam2, 0) = 1);
              2: PlayObject.CmdChangeSuperManMode('', 10, '', Str_ToInt(QuestActionInfo.sParam2, 0) = 1);
              3: PlayObject.CmdChangeObMode('', 10, '', Str_ToInt(QuestActionInfo.sParam2, 0) = 1);
            else begin
                ScriptActionError(PlayObject, '', QuestActionInfo, sCHANGEMODE);
              end;
            end;
          end;
        nPKPOINT: begin
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, n14) then begin //ӱ֧
              n14 := QuestActionInfo.nParam1;
            end;
            if n14 = 0 then begin
              PlayObject.m_wPkPoint := 0;
            end else begin
              if n14 < 0 then begin
                if (PlayObject.m_wPkPoint + n14) >= 0 then begin
                  Inc(PlayObject.m_wPkPoint, n14);
                end else PlayObject.m_wPkPoint := 0;
              end else begin
                if (PlayObject.m_wPkPoint + n14) > 10000 then begin
                  PlayObject.m_wPkPoint := 10000;
                end else begin
                  Inc(PlayObject.m_wPkPoint, n14);
                end;
              end;
            end;
            PlayObject.RefNameColor();
          end;
        nCHANGEXP: begin

          end;
        nSC_RECALLMOB: ActionOfRecallmob(PlayObject, QuestActionInfo);
        {
        nSC_RECALLMOB: begin
          if QuestActionInfo.nParam3 <= 1 then begin
            PlayObject.MakeSlave(QuestActionInfo.sParam1,3,Str_ToInt(QuestActionInfo.sParam2,0),100,10 * 24 * 60 * 60);
          end else begin
            PlayObject.MakeSlave(QuestActionInfo.sParam1,3,Str_ToInt(QuestActionInfo.sParam2,0),100,QuestActionInfo.nParam3 * 60)
          end;
        end;
        }
        nKICK: begin
            PlayObject.m_boReconnection := True;
            PlayObject.m_boSoftClose := True;
          end;
        nMOVR: begin
            n14 := GetValNameNo(QuestActionInfo.sParam1);
            if n14 >= 0 then begin
              case n14 of //
                0..9: begin
                    PlayObject.m_nVal[n14] := Random(QuestActionInfo.nParam2);
                  end;
                100..199: begin
                    g_Config.nGlobalVal[n14 - 100] := Random(QuestActionInfo.nParam2);
                  end;
                200..209: begin
                    PlayObject.m_DyVal[n14 - 200] := Random(QuestActionInfo.nParam2);
                  end;
                300..399: begin
                    PlayObject.m_nMval[n14 - 300] := Random(QuestActionInfo.nParam2);
                  end;
                400..499: begin
                    g_Config.nGlobaDyMval[n14 - 400] := Random(QuestActionInfo.nParam2);
                  end;
                500..599: begin
                    PlayObject.m_nInteger[n14 - 500] := Random(QuestActionInfo.nParam2);
                  end;
              else begin
                  ScriptActionError(PlayObject, '', QuestActionInfo, sMOVR);
                end;
              end;
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sMOVR);
            end;
          end;
        nEXCHANGEMAP: begin
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C) then begin //ӱ֧
              s4C := QuestActionInfo.sParam1;
            end;
            Map := g_MapManager.FindMap(s4C);
            if Map <> nil then begin
              List58 := TList.Create;
              UserEngine.GetMapRageHuman(Map, 0, 0, 1000, List58);
              if List58.Count > 0 then begin
                User := TPlayObject(List58.Items[0]);
                User.MapRandomMove(Self.m_sMapName, 0);
              end;
              List58.Free;
              PlayObject.MapRandomMove(s4C, 0);
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sEXCHANGEMAP);
            end;

          end;
        nRECALLMAP: begin
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C) then begin //ӱ֧
              s4C := QuestActionInfo.sParam1;
            end;
            Map := g_MapManager.FindMap(s4C);
            if Map <> nil then begin
              List58 := TList.Create;
              UserEngine.GetMapRageHuman(Map, 0, 0, 1000, List58);
              for ii := 0 to List58.Count - 1 do begin
                User := TPlayObject(List58.Items[ii]);
                User.MapRandomMove(Self.m_sMapName, 0);
                if ii > 20 then break;
              end;
              List58.Free;
            end else begin
              ScriptActionError(PlayObject, '', QuestActionInfo, sRECALLMAP);
            end;
          end;
        nADDBATCH: List1C.AddObject(QuestActionInfo.sParam1, TObject(n18));
        nBATCHDELAY: n18 := QuestActionInfo.nParam1 * 1000;
        nBATCHMOVE: begin
            for ii := 0 to List1C.Count - 1 do begin
              PlayObject.AddDelayAction(Self, RM_RANDOMSPACEMOVE, 0, 0, 0, 0, List1C.Strings[ii], Integer(List1C.Objects[ii]) + n20);
              Inc(n20, Integer(List1C.Objects[ii]));
            end;
          end;
        nPLAYDICE: begin //0049E209
            PlayObject.m_sPlayDiceLabel := QuestActionInfo.sParam2;
            PlayObject.AddAction(Self,
              RM_PLAYDICE,
              QuestActionInfo.nParam1,
              MakeLong(MakeWord(PlayObject.m_DyVal[0], PlayObject.m_DyVal[1]), MakeWord(PlayObject.m_DyVal[2], PlayObject.m_DyVal[3])),
              MakeLong(MakeWord(PlayObject.m_DyVal[4], PlayObject.m_DyVal[5]), MakeWord(PlayObject.m_DyVal[6], PlayObject.m_DyVal[7])),
              MakeLong(MakeWord(PlayObject.m_DyVal[8], PlayObject.m_DyVal[9]), 0),
              QuestActionInfo.sParam2);
            bo11 := True;
          end;

        nADDNAMELIST: AddList(PlayObject.m_sCharName, m_sPath + QuestActionInfo.sParam1);
        nDELNAMELIST: DelList(PlayObject.m_sCharName, m_sPath + QuestActionInfo.sParam1);
        nADDGUILDLIST: if PlayObject.m_MyGuild <> nil then AddList(TGUild(PlayObject.m_MyGuild).sGuildName, m_sPath + QuestActionInfo.sParam1);
        nDELGUILDLIST: if PlayObject.m_MyGuild <> nil then DelList(TGUild(PlayObject.m_MyGuild).sGuildName, m_sPath + QuestActionInfo.sParam1);
        nSENDMESG: ActionOfLineMsg(PlayObject, QuestActionInfo);

        nADDACCOUNTLIST: AddList(PlayObject.m_sUserID, m_sPath + QuestActionInfo.sParam1);
        nDELACCOUNTLIST: DelList(PlayObject.m_sUserID, m_sPath + QuestActionInfo.sParam1);
        nADDIPLIST: AddList(PlayObject.m_sIPaddr, m_sPath + QuestActionInfo.sParam1);
        nDELIPLIST: DelList(PlayObject.m_sIPaddr, m_sPath + QuestActionInfo.sParam1);
        nGOQUEST: GoToQuest(QuestActionInfo.nParam1);
        nENDQUEST: PlayObject.m_Script := nil;
        nGOTO: begin
            if not JmpToLable(QuestActionInfo.sParam1) then begin
              MainOutMessage('[űѭ] NPC:' + m_sCharName +
                ' λ:' + m_sMapName + '(' + IntToStr(m_nCurrX) + ':' + IntToStr(m_nCurrY) + ')' +
                ' :' + sGOTO + ' ' + QuestActionInfo.sParam1);
              Result := False;
              Exit;
            end;
          end;

        nSC_HAIRCOLOR: ;
        nSC_WEARCOLOR: ;
        nSC_HAIRSTYLE: ActionOfChangeHairStyle(PlayObject, QuestActionInfo);
        nSC_MONRECALL: ;
        nSC_HORSECALL: ;
        nSC_HAIRRNDCOL: ;
        nSC_KILLHORSE: ;
        nSC_RANDSETDAILYQUEST: ;

        nSC_RECALLGROUPMEMBERS: ActionOfRecallGroupMembers(PlayObject, QuestActionInfo);
        nSC_CLEARNAMELIST: ActionOfClearNameList(PlayObject, QuestActionInfo);
        nSC_CHANGELEVEL: ActionOfChangeLevel(PlayObject, QuestActionInfo);
        nSC_MARRY: ActionOfMarry(PlayObject, QuestActionInfo);
        nSC_MASTER: ActionOfMaster(PlayObject, QuestActionInfo);
        nSC_UNMASTER: ActionOfUnMaster(PlayObject, QuestActionInfo);
        nSC_UNMARRY: ActionOfUnMarry(PlayObject, QuestActionInfo);
        nSC_GETMARRY: ActionOfGetMarry(PlayObject, QuestActionInfo);
        nSC_GETMASTER: ActionOfGetMaster(PlayObject, QuestActionInfo);
        nSC_CLEARSKILL: ActionOfClearSkill(PlayObject, QuestActionInfo);
        nSC_DELNOJOBSKILL: ActionOfDelNoJobSkill(PlayObject, QuestActionInfo);
        nSC_DELSKILL: ActionOfDelSkill(PlayObject, QuestActionInfo);
        nSC_ADDSKILL: ActionOfAddSkill(PlayObject, QuestActionInfo);
        nSC_SKILLLEVEL: ActionOfSkillLevel(PlayObject, QuestActionInfo);
        nSC_CHANGEPKPOINT: ActionOfChangePkPoint(PlayObject, QuestActionInfo);
        nSC_CHANGEEXP: ActionOfChangeExp(PlayObject, QuestActionInfo);
        nSC_CHANGEJOB: ActionOfChangeJob(PlayObject, QuestActionInfo);
        nSC_MISSION: ActionOfMission(PlayObject, QuestActionInfo);
        nSC_MOBPLACE: ActionOfMobPlace(PlayObject, QuestActionInfo, n34, n38, n3C, n40);
        nSC_SETMEMBERTYPE: ActionOfSetMemberType(PlayObject, QuestActionInfo);
        nSC_SETMEMBERLEVEL: ActionOfSetMemberLevel(PlayObject, QuestActionInfo);
        nSC_GAMEGOLD: ActionOfGameGold(PlayObject, QuestActionInfo);
        nSC_GAMEPOINT: ActionOfGamePoint(PlayObject, QuestActionInfo);
        nSC_CHANGENAMECOLOR: ActionOfChangeNameColor(PlayObject, QuestActionInfo);
        nSC_CLEARPASSWORD: ActionOfClearPassword(PlayObject, QuestActionInfo);
        nSC_RENEWLEVEL: ActionOfReNewLevel(PlayObject, QuestActionInfo);
        nSC_KILLSLAVE: ActionOfKillSlave(PlayObject, QuestActionInfo);
        nSC_CHANGEGENDER: ActionOfChangeGender(PlayObject, QuestActionInfo);
        nSC_KILLMONEXPRATE: ActionOfKillMonExpRate(PlayObject, QuestActionInfo);
        nSC_POWERRATE: ActionOfPowerRate(PlayObject, QuestActionInfo);
        nSC_CHANGEMODE: ActionOfChangeMode(PlayObject, QuestActionInfo);
        nSC_CHANGEPERMISSION: ActionOfChangePerMission(PlayObject, QuestActionInfo);
        nSC_KILL: ActionOfKill(PlayObject, QuestActionInfo);
        nSC_KICK: ActionOfKick(PlayObject, QuestActionInfo);
        nSC_BONUSPOINT: ActionOfBonusPoint(PlayObject, QuestActionInfo);
        nSC_RESTRENEWLEVEL: ActionOfRestReNewLevel(PlayObject, QuestActionInfo);
        nSC_DELMARRY: ActionOfDelMarry(PlayObject, QuestActionInfo);
        nSC_DELMASTER: ActionOfDelMaster(PlayObject, QuestActionInfo);
        nSC_CREDITPOINT: ActionOfChangeCreditPoint(PlayObject, QuestActionInfo);
        nSC_CLEARNEEDITEMS: ActionOfClearNeedItems(PlayObject, QuestActionInfo);
        nSC_CLEARMAEKITEMS: ActionOfClearMakeItems(PlayObject, QuestActionInfo);
        nSC_UPGRADEITEMS: ActionOfUpgradeItems(PlayObject, QuestActionInfo);
        nSC_UPGRADEITEMSEX: ActionOfUpgradeItemsEx(PlayObject, QuestActionInfo);
        nSC_AddGuildMember: ActionOfAddGuildMember(PlayObject, QuestActionInfo);
        nSC_ChangeSlaveName: ActionOfChangeSlaveName(PlayObject, QuestActionInfo);
        nSC_MONGENEX: ActionOfMonGenEx(PlayObject, QuestActionInfo);
        nSC_CLEARMAPMON: ActionOfClearMapMon(PlayObject, QuestActionInfo);
        nSC_SETMAPMODE: ActionOfSetMapMode(PlayObject, QuestActionInfo);
        nSC_PKZONE: ActionOfPkZone(PlayObject, QuestActionInfo);
        nSC_RESTBONUSPOINT: ActionOfRestBonusPoint(PlayObject, QuestActionInfo);
        nSC_TAKECASTLEGOLD: ActionOfTakeCastleGold(PlayObject, QuestActionInfo);
        nSC_HUMANHP: ActionOfHumanHP(PlayObject, QuestActionInfo);
        nSC_HUMANMP: ActionOfHumanMP(PlayObject, QuestActionInfo);
        nSC_BUILDPOINT: ActionOfGuildBuildPoint(PlayObject, QuestActionInfo);
        nSC_AURAEPOINT: ActionOfGuildAuraePoint(PlayObject, QuestActionInfo);
        nSC_STABILITYPOINT: ActionOfGuildstabilityPoint(PlayObject, QuestActionInfo);
        nSC_FLOURISHPOINT: ActionOfGuildFlourishPoint(PlayObject, QuestActionInfo);
        nSC_OPENMAGICBOX: ActionOfOpenMagicBox(PlayObject, QuestActionInfo);
        nSC_SETRANKLEVELNAME: ActionOfSetRankLevelName(PlayObject, QuestActionInfo);
        nSC_GMEXECUTE: ActionOfGmExecute(PlayObject, QuestActionInfo);
        nSC_GUILDCHIEFITEMCOUNT: ActionOfGuildChiefItemCount(PlayObject, QuestActionInfo);
        nSC_ADDNAMEDATELIST, nSC_ADDUSERDATE: ActionOfAddNameDateList(PlayObject, QuestActionInfo);
        nSC_DELNAMEDATELIST, nSC_DELUSERDATE: ActionOfDelNameDateList(PlayObject, QuestActionInfo);
        nSC_MOBFIREBURN: ActionOfMobFireBurn(PlayObject, QuestActionInfo);
        nSC_MESSAGEBOX: ActionOfMessageBox(PlayObject, QuestActionInfo);
        nSC_SETAUTOGETEXP: ActionOfAutoGetExp(PlayObject, QuestActionInfo);
        nSC_VAR: ActionOfVar(PlayObject, QuestActionInfo);
        nSC_LOADVAR: ActionOfLoadVar(PlayObject, QuestActionInfo);
        nSC_SAVEVAR: ActionOfSaveVar(PlayObject, QuestActionInfo);
        nSC_CALCVAR: ActionOfCalcVar(PlayObject, QuestActionInfo);
        nOFFLINEPLAY: ActionOfNotLineAddPiont(PlayObject, QuestActionInfo);
        nSTARTTAKEGOLD: ActionOfStartTakeGold(PlayObject);
        nDELAYGOTO: begin
            PlayObject.m_boTimeGoto := True;
            PlayObject.m_dwTimeGotoTick := GetTickCount + LongWord(QuestActionInfo.nParam1 * 1000);
            PlayObject.m_sTimeGotoLable := QuestActionInfo.sParam2;
            PlayObject.m_TimeGotoNPC := Self;
          end;
        nCLEARDELAYGOTO: begin
            PlayObject.m_boTimeGoto := False;
            PlayObject.m_sTimeGotoLable := '';
            PlayObject.m_TimeGotoNPC := nil;
          end;
        nCHANGERECOMMENDGAMEGOLD: ActionOfCommendGameGold(PlayObject, QuestActionInfo);
        nSC_ANSIREPLACETEXT: ActionOfAnsiReplaceText(PlayObject, QuestActionInfo);
        nSC_ENCODETEXT: ActionOfEncodeText(PlayObject, QuestActionInfo);
        nSC_DECODETEXT: ActionOfDecodeText(PlayObject, QuestActionInfo);
        nSC_ADDTEXTLIST: begin
            s4C := QuestActionInfo.sParam1;
            ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C);
            AddList(s4C, m_sPath + QuestActionInfo.sParam2);
          end;
        nSC_DELTEXTLIST: begin
            s4C := QuestActionInfo.sParam1;
            ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C);
            DelList(s4C, m_sPath + QuestActionInfo.sParam2);
          end;
        nSC_GROUPMOVE: begin
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C) then begin //ӱ֧
              s4C := QuestActionInfo.sParam1;
            end;
            PlayObject.AddRefAction(RM_SPACEMOVE_FIRE, 0, 0, 0, 0, '');
            PlayObject.MapRandomMove(s4C, 0);
            if PlayObject.m_GroupOwner.m_GroupMembers.Count > 0 then begin
              for ii := 0 to PlayObject.m_GroupOwner.m_GroupMembers.Count - 1 do begin
                if (not TPlayObject(PlayObject.m_GroupOwner.m_GroupMembers.Objects[ii]).m_boDeath) and
                  (not TPlayObject(PlayObject.m_GroupOwner.m_GroupMembers.Objects[ii]).m_boGhost) then begin
                  TPlayObject(PlayObject.m_GroupOwner.m_GroupMembers.Objects[ii]).MapRandomMove(s4C, 0);
                end;
              end;
            end;
            bo11 := True;
          end;
        nSC_GROUPMAPMOVE: begin
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C) then begin //ӱ֧
              s4C := QuestActionInfo.sParam1;
            end;
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, n14) then begin //ӱ֧
              n14 := QuestActionInfo.nParam2;
            end;
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam3, n40) then begin //ӱ֧
              n40 := QuestActionInfo.nParam3;
            end;
            PlayObject.AddRefAction(RM_SPACEMOVE_FIRE, 0, 0, 0, 0, '');
            PlayObject.SpaceMove(s4C, n14, n40, 0);
            if PlayObject.m_GroupOwner.m_GroupMembers.Count > 0 then begin
              for ii := 0 to PlayObject.m_GroupOwner.m_GroupMembers.Count - 1 do begin
                if (not TPlayObject(PlayObject.m_GroupOwner.m_GroupMembers.Objects[ii]).m_boDeath) and
                  (not TPlayObject(PlayObject.m_GroupOwner.m_GroupMembers.Objects[ii]).m_boGhost) then begin
                  TPlayObject(PlayObject.m_GroupOwner.m_GroupMembers.Objects[ii]).SpaceMove(s4C, n14, n40, 0);
                end;
              end;
            end;
            bo11 := True;
          end;
        nSC_RECALLHUMAN: begin
            s4C := QuestActionInfo.sParam1;
            ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C);
            if s4C <> '' then begin
              PlayObject.RecallHuman(s4C);
            end;
          end;
        nSC_REGOTO: begin
            s4C := QuestActionInfo.sParam1;
            ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C);
            if s4C <> '' then begin
              OnLinePlayObject := UserEngine.GetPlayObject(s4C);
              if PlayObject <> nil then begin
                PlayObject.AddRefAction(RM_SPACEMOVE_FIRE, 0, 0, 0, 0, '');
                PlayObject.SpaceMove(OnLinePlayObject.m_PMap.sMapName, OnLinePlayObject.m_nCurrX, OnLinePlayObject.m_nCurrY, 0);
                bo11 := True;
              end;
            end;
          end;
        nSC_INTTOSTR: begin
            n40 := 0;
            ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, n40);
            n14 := GetValNameNo(QuestActionInfo.sParam1);
            if n14 >= 0 then begin
              case n14 of
                600..699: begin
                    PlayObject.m_sString[n14 - 600] := IntToStr(n40);
                  end;
                700..799: begin
                    g_Config.sGlobalAVal[n14 - 700] := IntToStr(n40);
                  end;
              else begin
                  ScriptActionError(PlayObject, '', QuestActionInfo, sSC_INTTOSTR);
                end;
              end;
            end;
          end;
        nSC_STRTOINT: begin
            ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C);
            n14 := GetValNameNo(QuestActionInfo.sParam1);
            if n14 >= 0 then begin
              case n14 of
                0..9: begin
                    PlayObject.m_nVal[n14] := Str_ToInt(s4C, 0);
                  end;
                100..199: begin
                    g_Config.nGlobalVal[n14 - 100] := Str_ToInt(s4C, 0);
                  end;
                200..209: begin
                    PlayObject.m_DyVal[n14 - 200] := Str_ToInt(s4C, 0);
                  end;
                300..399: begin
                    PlayObject.m_nMval[n14 - 300] := Str_ToInt(s4C, 0);
                  end;
                400..499: begin
                    g_Config.nGlobaDyMval[n14 - 400] := Str_ToInt(s4C, 0);
                  end;
                500..599: begin
                    PlayObject.m_nInteger[n14 - 500] := Str_ToInt(s4C, 0);
                  end;
              else begin
                  ScriptActionError(PlayObject, '', QuestActionInfo, sSC_STRTOINT);
                end;
              end;
            end;
          end;
        nSC_GUILDMOVE: begin
            if PlayObject.m_MyGuild = nil then Exit;
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C) then begin //ӱ֧
              s4C := QuestActionInfo.sParam1;
            end;
            PlayObject.AddRefAction(RM_SPACEMOVE_FIRE, 0, 0, 0, 0, '');
            PlayObject.MapRandomMove(s4C, 0);
            for ii := 0 to TGUild(PlayObject.m_MyGuild).m_RankList.Count - 1 do begin
              GuildRank := TGUild(PlayObject.m_MyGuild).m_RankList.Items[ii];
              if GuildRank = nil then Continue;
              for III := 0 to GuildRank.MemberList.Count - 1 do begin
                BaseObject := TBaseObject(GuildRank.MemberList.Objects[III]);
                if BaseObject = nil then Continue;
                if (not BaseObject.m_boDeath) and (not BaseObject.m_boGhost) then
                  TPlayObject(BaseObject).MapRandomMove(s4C, 0);
              end;
            end;
            bo11 := True;
          end;
        nSC_GUILDMAPMOVE: begin
            if PlayObject.m_MyGuild = nil then Exit;
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam1, s4C) then begin //ӱ֧
              s4C := QuestActionInfo.sParam1;
            end;
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam2, n14) then begin //ӱ֧
              n14 := QuestActionInfo.nParam2;
            end;
            if not ConditionOfGetValValue(PlayObject, QuestActionInfo.sParam3, n40) then begin //ӱ֧
              n40 := QuestActionInfo.nParam3;
            end;
            PlayObject.AddRefAction(RM_SPACEMOVE_FIRE, 0, 0, 0, 0, '');
            PlayObject.SpaceMove(s4C, n14, n40, 0);
            for ii := 0 to TGUild(PlayObject.m_MyGuild).m_RankList.Count - 1 do begin
              GuildRank := TGUild(PlayObject.m_MyGuild).m_RankList.Items[ii];
              if GuildRank = nil then Continue;
              for III := 0 to GuildRank.MemberList.Count - 1 do begin
                BaseObject := TBaseObject(GuildRank.MemberList.Objects[III]);
                if BaseObject = nil then Continue;
                if (not BaseObject.m_boDeath) and (not BaseObject.m_boGhost) then
                  TPlayObject(BaseObject).SpaceMove(s4C, n14, n40, 0);
              end;
            end;
            bo11 := True;
          end;
        nSC_RANDOMMOVE: begin
            if PlayObject.m_PMap = nil then Exit;
            n14 := Random(PlayObject.m_PMap.m_nWidth);
            n40 := Random(PlayObject.m_PMap.m_nHeight);
            PlayObject.AddRefAction(RM_SPACEMOVE_FIRE, 0, 0, 0, 0, '');
            PlayObject.SpaceMove(PlayObject.m_sMapName, n14, n40, 0);
            bo11 := True;
          end;
        nSC_USEBONUSPOINT: ActionOfUseBonusPoint(PlayObject, QuestActionInfo);

        nSC_REPAIRITEM: ActionOfRepairItem(PlayObject, QuestActionInfo);
        nSC_TAKEONITEM: ActionOfTakeOnItem(PlayObject, QuestActionInfo);
        nSC_TAKEOFFITEM: ActionOfTakeOffItem(PlayObject, QuestActionInfo);

        nSC_SETHUEICHENGCOUNT: ActionOfHueiChengCount(PlayObject, QuestActionInfo);
        nSC_SETSueiJiCount: ActionOfSueiJiCount(PlayObject, QuestActionInfo);
        nSC_ReNameColor :PlayObject.m_boReNameColor := Boolean(QuestActionInfo.nParam1);
        nSC_UnInlayItem :ActionOfUnInlayItem(PlayObject, QuestActionInfo);
        nSC_ThrowItem :ActionOfThrowItem(PlayObject, QuestActionInfo);
        nSC_SendTimeMsg:ActionOfSendTimeMsg(PlayObject, QuestActionInfo);
        nSC_StopGotoLabel:begin
          PlayObject.m_sTimeGotoLable := '';
          PlayObject.m_dwTimeGotoTick := 0;
          PlayObject.m_boTimeGoto := false;
          PlayObject.m_TimeGotoNPC := nil;
          PlayObject.SysMsg('', TMsgColor(0), t_TimeHint);
        end;
      else begin

        end;
      end;
    end;
  end;
  procedure SendMerChantSayMsg(sMsg: string; boFlag: Boolean); //0049E3E0
  var
    s10, s14: string;
    nC: Integer;
  begin
    s14 := sMsg;
    nC := 0;
    while (True) do begin
      if TagCount(s14, '>') < 1 then break;
      s14 := ArrestStringEx(s14, '<', '>', s10);
      GetVariableText(PlayObject, sMsg, s10);
      Inc(nC);
      if nC >= 101 then break;
    end;
    PlayObject.GetScriptLabel(sMsg);
    if PlayObject.m_boIsGotoHelpLabel then nC := 1
    else nC := 0;
    if boFlag then begin
      PlayObject.AddFirstAction(Self, RM_Chat, nC, 0, 0, Byte(t_MerSay), m_sCharName + '/' + sMsg);
    end else begin
      PlayObject.AddAction(Self, RM_Chat, nC, 0, 0, Byte(t_MerSay), m_sCharName + '/' + sMsg);
    end;
  end;
    function QuestCheckCondition(ConditionList: TList): Boolean;
  var
    i, ii: Integer;
    QuestConditionInfo: pTQuestConditionInfo;
    n10, n14, n18, n1C, nMaxDura, nDura: Integer;
    Hour, Min, Sec, MSec: Word;
    Map: TMap;
    StdItem: pTStdItem;
    s01: string;
    MonList: TList;
  begin
    Result := True;
    for i := 0 to ConditionList.Count - 1 do begin
      QuestConditionInfo := ConditionList.Items[i];
      case QuestConditionInfo.nCMDCode of
        nCHECK: begin
            n14 := Str_ToInt(QuestConditionInfo.sParam1, 0);
            n18 := Str_ToInt(QuestConditionInfo.sParam2, 0);
            n10 := PlayObject.GetQuestFalgStatus(n14);
            if n10 = 0 then begin
              if n18 <> 0 then Result := False;
            end else begin
              if n18 = 0 then Result := False;
            end;
          end;
        nRANDOM: begin
            if Random(QuestConditionInfo.nParam1) <> 0 then
              Result := False;
          end;
        nGENDER: begin
            if CompareText(QuestConditionInfo.sParam1, sMAN) = 0 then begin
              if PlayObject.m_btGender <> 0 then Result := False;
            end else begin
              if PlayObject.m_btGender <> 1 then Result := False;
            end;
          end;
        nDAYTIME: begin
            if CompareText(QuestConditionInfo.sParam1, sSUNRAISE) = 0 then begin
              if g_nGameTime <> 0 then Result := False;
            end;
            if CompareText(QuestConditionInfo.sParam1, sDAY) = 0 then begin
              if g_nGameTime <> 1 then Result := False;
            end;
            if CompareText(QuestConditionInfo.sParam1, sSUNSET) = 0 then begin
              if g_nGameTime <> 2 then Result := False;
            end;
            if CompareText(QuestConditionInfo.sParam1, sNIGHT) = 0 then begin
              if g_nGameTime <> 3 then Result := False;
            end;
          end;
        nCHECKOPEN: begin
            n14 := Str_ToInt(QuestConditionInfo.sParam1, 0);
            n18 := Str_ToInt(QuestConditionInfo.sParam2, 0);
            n10 := PlayObject.GetQuestUnitOpenStatus(n14);
            if n10 = 0 then begin
              if n18 <> 0 then Result := False;
            end else begin
              if n18 = 0 then Result := False;
            end;
          end;
        nCHECKUNIT: begin
            n14 := Str_ToInt(QuestConditionInfo.sParam1, 0);
            n18 := Str_ToInt(QuestConditionInfo.sParam2, 0);
            n10 := PlayObject.GetQuestUnitStatus(n14);
            if n10 = 0 then begin
              if n18 <> 0 then Result := False;
            end else begin
              if n18 = 0 then Result := False;
            end;
          end;
        nCHECKLEVEL: if PlayObject.m_Abil.Level < QuestConditionInfo.nParam1 then Result := False;
        nCHECKJOB: begin
            if CompareLStr(QuestConditionInfo.sParam1, sWARRIOR, 3) then begin
              if PlayObject.m_btJob <> 0 then Result := False;
            end;
            if CompareLStr(QuestConditionInfo.sParam1, sWIZARD, 3) then begin
              if PlayObject.m_btJob <> 1 then Result := False;
            end;
            if CompareLStr(QuestConditionInfo.sParam1, sTAOS, 3) then begin
              if PlayObject.m_btJob <> 2 then Result := False;
            end;
          end;
        nCHECKBBCOUNT: if PlayObject.m_SlaveList.Count < QuestConditionInfo.nParam1 then Result := False;
        nCHECKCREDITPOINT: ;
        nCHECKITEM: begin
            UserItem := PlayObject.QuestCheckItem(QuestConditionInfo.sParam1, n1C, nMaxDura, nDura);
            if n1C < QuestConditionInfo.nParam2 then
              Result := False;
          end;
        nCHECKITEMW: begin
            UserItem := CheckItemW(QuestConditionInfo.sParam1, QuestConditionInfo.nParam2);
            if UserItem = nil then
              Result := False;
          end;
        nCHECKGOLD: begin
            if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, n14) then begin //ӱ֧
              n14 := QuestConditionInfo.nParam1;
            end;
            if PlayObject.m_nGold < n14 then Result := False;
          end;
        nISTAKEITEM: if sSC <> QuestConditionInfo.sParam1 then Result := False;
        nCHECKDURA: begin
            UserItem := PlayObject.QuestCheckItem(QuestConditionInfo.sParam1, n1C, nMaxDura, nDura);
            if ROUND(nDura / 1000) < QuestConditionInfo.nParam2 then
              Result := False;
          end;
        nCHECKDURAEVA: begin
            UserItem := PlayObject.QuestCheckItem(QuestConditionInfo.sParam1, n1C, nMaxDura, nDura);
            if n1C > 0 then begin
              if ROUND(nMaxDura / n1C / 1000) < QuestConditionInfo.nParam2 then
                Result := False;
            end else Result := False;
          end;
        nDAYOFWEEK: begin
            if CompareLStr(QuestConditionInfo.sParam1, sSUN, Length(sSUN)) then begin
              if DayOfWeek(Now) <> 1 then Result := False;
            end;
            if CompareLStr(QuestConditionInfo.sParam1, sMON, Length(sMON)) then begin
              if DayOfWeek(Now) <> 2 then Result := False;
            end;
            if CompareLStr(QuestConditionInfo.sParam1, sTUE, Length(sTUE)) then begin
              if DayOfWeek(Now) <> 3 then Result := False;
            end;
            if CompareLStr(QuestConditionInfo.sParam1, sWED, Length(sWED)) then begin
              if DayOfWeek(Now) <> 4 then Result := False;
            end;
            if CompareLStr(QuestConditionInfo.sParam1, sTHU, Length(sTHU)) then begin
              if DayOfWeek(Now) <> 5 then Result := False;
            end;
            if CompareLStr(QuestConditionInfo.sParam1, sFRI, Length(sFRI)) then begin
              if DayOfWeek(Now) <> 6 then Result := False;
            end;
            if CompareLStr(QuestConditionInfo.sParam1, sSAT, Length(sSAT)) then begin
              if DayOfWeek(Now) <> 7 then Result := False;
            end;
          end;
        nHOUR: begin
            if (QuestConditionInfo.nParam1 <> 0) and
            (QuestConditionInfo.nParam2 = 0) then
              QuestConditionInfo.nParam2 := QuestConditionInfo.nParam1;
            DecodeTime(Time, Hour, Min, Sec, MSec);
            if (Hour < QuestConditionInfo.nParam1) or
            (Hour > QuestConditionInfo.nParam2) then
              Result := False;
          end;
        nMIN: begin
            if (QuestConditionInfo.nParam1 <> 0) and
            (QuestConditionInfo.nParam2 = 0) then
              QuestConditionInfo.nParam2 := QuestConditionInfo.nParam1;
            DecodeTime(Time, Hour, Min, Sec, MSec);
            if (Min < QuestConditionInfo.nParam1) or
            (Min > QuestConditionInfo.nParam2) then
              Result := False;
          end;
        nCHECKPKPOINT: begin
            if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, n14) then begin //ӱ֧
              n14 := QuestConditionInfo.nParam1;
            end;
            if PlayObject.PKLevel < n14 then Result := False;
          end;

        nCHECKLUCKYPOINT: if PlayObject.m_nBodyLuckLevel < QuestConditionInfo.nParam1 then Result := False;
        nCHECKMONMAP: if not ConditionOfCheckMonMapCount(PlayObject, QuestConditionInfo) then Result := False;
        nCHECKMONAREA: ;
        nCHECKHUM: begin //0049C4CB
            if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam3, n14) then begin //ӱ֧
              n14 := QuestConditionInfo.nParam3;
            end;
            if QuestConditionInfo.sParam2 <> '' then begin
              case QuestConditionInfo.sParam2[1] of
                '=': Result :=  UserEngine.GetMapHuman(QuestConditionInfo.sParam1) = n14;
                '>': Result :=  UserEngine.GetMapHuman(QuestConditionInfo.sParam1) > n14;
                '<': Result :=  UserEngine.GetMapHuman(QuestConditionInfo.sParam1) < n14;
              else Result :=  UserEngine.GetMapHuman(QuestConditionInfo.sParam1) >= n14;
              end;
            end else
            if UserEngine.GetMapHuman(QuestConditionInfo.sParam1) < n14 then Result := False;
          end;

        nCHECKBAGGAGE: begin
            if PlayObject.IsEnoughBag then begin
              if QuestConditionInfo.sParam1 <> '' then begin
                Result := False;
                if not ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, s01) then begin //ӱ֧
                  s01 := QuestConditionInfo.sParam1;
                end;
                StdItem := UserEngine.GetStdItem(s01);
                if StdItem <> nil then begin
                  if PlayObject.IsAddWeightAvailable(StdItem.Weight) then
                    Result := True;
                end;
              end;
            end else Result := False;
          end;
          
        nCheckInList: begin
          if (QuestConditionInfo.sParam1 <> '') then begin
            if(QuestConditionInfo.sParam1[1]='.') and
             (QuestConditionInfo.sParam1[2]='.') then begin
              if not CheckStringList(PlayObject.m_sCharName, m_sPath + QuestConditionInfo.sParam1) then Result := False;
            end else begin
              s01 := QuestConditionInfo.sParam1;
              if not GetHumanInfoValue(PlayObject,s01,s01) then
              ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, s01);
              if not CheckStringList(s01, m_sPath + QuestConditionInfo.sParam2) then Result := False;
            end;
          end;
        end;
        nCHECKACCOUNTLIST: if not CheckStringList(PlayObject.m_sUserID, m_sPath + QuestConditionInfo.sParam1) then Result := False;
        nCHECKIPLIST: if not CheckStringList(PlayObject.m_sIPaddr, m_sPath + QuestConditionInfo.sParam1) then Result := False;
        nEQUAL: begin
            if CheckVarNameNo(PlayObject,QuestConditionInfo, n14, n18) then begin
              if n14 <> n18 then Result := False;
            end else Result := False;
          end;
        nLARGE: begin
            if CheckVarNameNo(PlayObject,QuestConditionInfo, n14, n18) then begin
              if n14 <= n18 then Result := False;
            end else Result := False;
          end;
        nSMALL: begin
            if CheckVarNameNo(PlayObject,QuestConditionInfo, n14, n18) then begin
              if n14 >= n18 then Result := False;
            end else Result := False;
          end;
        nSC_ISSYSOP: if not (PlayObject.m_btPermission >= 4) then Result := False;
        nSC_ISADMIN: if not (PlayObject.m_btPermission >= 6) then Result := False;
        nSC_CHECKGROUPCOUNT: if not ConditionOfCheckGroupCount(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKPOSEDIR: if not ConditionOfCheckPoseDir(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKPOSELEVEL: if not ConditionOfCheckPoseLevel(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKPOSEGENDER: if not ConditionOfCheckPoseGender(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKLEVELEX: if not ConditionOfCheckLevelEx(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKBONUSPOINT: if not ConditionOfCheckBonusPoint(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKMARRY: if not ConditionOfCheckMarry(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKPOSEMARRY: if not ConditionOfCheckPoseMarry(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKMARRYCOUNT: if not ConditionOfCheckMarryCount(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKMASTER: if not ConditionOfCheckMaster(PlayObject, QuestConditionInfo) then Result := False;
        nSC_HAVEMASTER: if not ConditionOfHaveMaster(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKPOSEMASTER: if not ConditionOfCheckPoseMaster(PlayObject, QuestConditionInfo) then Result := False;
        nSC_POSEHAVEMASTER: if not ConditionOfPoseHaveMaster(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKISMASTER: if not ConditionOfCheckIsMaster(PlayObject, QuestConditionInfo) then Result := False;
        nSC_HASGUILD: if not ConditionOfCheckHaveGuild(PlayObject, QuestConditionInfo) then Result := False;
        nSC_ISGUILDMASTER: if not ConditionOfCheckIsGuildMaster(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKCASTLEMASTER: if not ConditionOfCheckIsCastleMaster(PlayObject, QuestConditionInfo) then Result := False;
        nSC_ISCASTLEGUILD: if not ConditionOfCheckIsCastleaGuild(PlayObject, QuestConditionInfo) then Result := False;
        nSC_ISATTACKGUILD: if not ConditionOfCheckIsAttackGuild(PlayObject, QuestConditionInfo) then Result := False;
        nSC_ISDEFENSEGUILD: if not ConditionOfCheckIsDefenseGuild(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKCASTLEDOOR: if not ConditionOfCheckCastleDoorStatus(PlayObject, QuestConditionInfo) then Result := False;
        nSC_ISATTACKALLYGUILD: if not ConditionOfCheckIsAttackAllyGuild(PlayObject, QuestConditionInfo) then Result := False;
        nSC_ISDEFENSEALLYGUILD: if not ConditionOfCheckIsDefenseAllyGuild(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKPOSEISMASTER: if not ConditionOfCheckPoseIsMaster(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKNAMEIPLIST: if not ConditionOfCheckNameIPList(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKACCOUNTIPLIST: if not ConditionOfCheckAccountIPList(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKSLAVECOUNT: if not ConditionOfCheckSlaveCount(PlayObject, QuestConditionInfo) then Result := False;
        nSC_ISNEWHUMAN: if not PlayObject.m_boNewHuman then Result := False;
        nSC_CHECKMEMBERTYPE: if not ConditionOfCheckMemberType(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKMEMBERLEVEL: if not ConditionOfCheckMemBerLevel(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKGAMEGOLD: if not ConditionOfCheckGameGold(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKGAMEPOINT: if not ConditionOfCheckGamePoint(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKNAMELISTPOSITION: if not ConditionOfCheckNameListPostion(PlayObject, QuestConditionInfo) then Result := False;
        //nSC_CHECKGUILDLIST:     if not ConditionOfCheckGuildList(PlayObject,QuestConditionInfo) then Result:=False;
        nSC_CHECKGUILDLIST: begin
            if PlayObject.m_MyGuild <> nil then begin
              if not CheckStringList(TGUild(PlayObject.m_MyGuild).sGuildName, m_sPath + QuestConditionInfo.sParam1) then Result := False;
            end else Result := False;
          end;
        nSC_CHECKRENEWLEVEL: if not ConditionOfCheckReNewLevel(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKSLAVELEVEL: if not ConditionOfCheckSlaveLevel(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKSLAVENAME: if not ConditionOfCheckSlaveName(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKCREDITPOINT: if not ConditionOfCheckCreditPoint(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKOFGUILD: if not ConditionOfCheckOfGuild(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKPAYMENT: if not ConditionOfCheckPayMent(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKUSEITEM: if not ConditionOfCheckUseItem(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKBAGSIZE: if not ConditionOfCheckBagSize(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKLISTCOUNT: if not ConditionOfCheckListCount(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKDC: if not ConditionOfCheckDC(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKMC: if not ConditionOfCheckMC(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKSC: if not ConditionOfCheckSC(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKHP: if not ConditionOfCheckHP(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKMP: if not ConditionOfCheckMP(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKITEMTYPE: if not ConditionOfCheckItemType(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKEXP: if not ConditionOfCheckExp(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKCASTLEGOLD: if not ConditionOfCheckCastleGold(PlayObject, QuestConditionInfo) then Result := False;
        nSC_PASSWORDERRORCOUNT: if not ConditionOfCheckPasswordErrorCount(PlayObject, QuestConditionInfo) then Result := False;
        nSC_ISLOCKPASSWORD: if not ConditionOfIsLockPassword(PlayObject, QuestConditionInfo) then Result := False;
        nSC_ISLOCKSTORAGE: if not ConditionOfIsLockStorage(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKBUILDPOINT: if not ConditionOfCheckGuildBuildPoint(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKAURAEPOINT: if not ConditionOfCheckGuildAuraePoint(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKSTABILITYPOINT: if not ConditionOfCheckStabilityPoint(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKFLOURISHPOINT: if not ConditionOfCheckFlourishPoint(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKCONTRIBUTION: if not ConditionOfCheckContribution(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKRANGEMONCOUNT: if not ConditionOfCheckRangeMonCount(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKITEMADDVALUE: if not ConditionOfCheckItemAddValue(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKINMAPRANGE: if not ConditionOfCheckInMapRange(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CASTLECHANGEDAY: if not ConditionOfCheckCastleChageDay(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CASTLEWARDAY: if not ConditionOfCheckCastleWarDay(PlayObject, QuestConditionInfo) then Result := False;
        nSC_ONLINELONGMIN: if not ConditionOfCheckOnlineLongMin(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKGUILDCHIEFITEMCOUNT: if not ConditionOfCheckChiefItemCount(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKNAMEDATELIST, nSC_CHECKUSERDATE: if not ConditionOfCheckNameDateList(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CheckMapHumanCount: if not ConditionOfCheckMapHumanCount(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CheckMapMonCount: if not ConditionOfCheckMapMonCount(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKVAR: if not ConditionOfCheckVar(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKSERVERNAME: if not ConditionOfCheckServerName(PlayObject, QuestConditionInfo) then Result := False;
        nCHECKMAPNAME: if not ConditionOfCheckMapName(PlayObject, QuestConditionInfo) then Result := False;
        nINSAFEZONE: if not ConditionOfCheckSafeZone(PlayObject, QuestConditionInfo) then Result := False;
        nCHECKSKILL: if not ConditionOfCheckSkill(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKCONTAINSTEXT: if not ConditionOfAnsiContainsText(PlayObject, QuestConditionInfo) then Result := False;
        nSC_COMPARETEXT: if not ConditionOfCompareText(PlayObject, QuestConditionInfo) then Result := False;
        nSC_CHECKTEXTLIST: begin
            s01 := QuestConditionInfo.sParam1;
            ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, s01);
            if not CheckStringList(s01, m_sPath + QuestConditionInfo.sParam2) then Result := False;
          end;
        nSC_ISGROUPMASTER: begin
            if PlayObject.m_GroupOwner <> nil then begin
              if PlayObject.m_GroupOwner <> PlayObject then
                Result := False;
            end else Result := False;
          end;
        nSC_CHECKCONTAINSTEXTLIST: begin
            s01 := QuestConditionInfo.sParam1;
            ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, s01);
            if not CheckAnsiContainsTextList(s01, m_sPath + QuestConditionInfo.sParam2) then Result := False;
          end;
        nSC_CHECKONLINE: begin
            s01 := QuestConditionInfo.sParam1;
            ConditionOfGetValValue(PlayObject, QuestConditionInfo.sParam1, s01);
            if (s01 = '') or (UserEngine.GetPlayObject(s01) = nil) then Result := False;
          end;
        nSC_ISDUPMODE: begin
            if PlayObject.m_PMap <> nil then begin
              if PlayObject.m_PMap.GetXYObjCount(PlayObject.m_nCurrX, PlayObject.m_nCurrY) >= 2 then Result := False;
            end else Result := False;
          end;
         nSC_isOnline: begin
            Result := ConditionOfCheckOnline(PlayObject,QuestConditionInfo);
          end;
      else begin

        end;
      end;
      if not Result then break;
    end;
  end;
