program M2Server;

uses
  //ShareMem,
  Forms,
  Windows,
  Graphics,
  svMain in 'svMain.pas' {FrmMain},
  LocalDB in 'LocalDB.pas' {FrmDB},
  InterServerMsg in 'InterServerMsg.pas' {FrmSrvMsg},
  InterMsgClient in 'InterMsgClient.pas' {FrmMsgClient},
  IdSrvClient in 'IdSrvClient.pas' {FrmIDSoc},
  FSrvValue in 'FSrvValue.pas' {FrmServerValue},
  SDK in 'SDK.pas',
  UsrEngn in 'UsrEngn.pas',
  ObjNpc in 'ObjNpc.pas',
  ObjMon2 in 'ObjMon2.pas',
  ObjMon in 'ObjMon.pas',
  ObjGuard in 'ObjGuard.pas',
  ObjBase in 'ObjBase.pas',
  ObjAxeMon in 'ObjAxeMon.pas',
  NoticeM in 'NoticeM.pas',
  Magic in 'Magic.pas',
  M2Share in 'M2Share.pas',
  ItmUnit in 'ItmUnit.pas',
  DBEngn in 'DBEngn.pas',
  Event in 'Event.pas',
  GameMap in 'GameMap.pas',
  Castle in 'Castle.pas',
  RunDB in 'RunDB.pas',
  RunSock in 'RunSock.pas',
  MirGrobal in '..\Common\MirGrobal.pas',
  EDcode in '..\Common\EDcode.pas',
  HUtil32 in 'HUtil32.pas',
  Mudutil in 'Mudutil.pas',
  GeneralConfig in 'GeneralConfig.pas' {frmGeneralConfig},
  GameConfig in 'GameConfig.pas' {frmGameConfig},
  FunctionConfig in 'FunctionConfig.pas' {frmFunctionConfig},
  ObjRobot in 'ObjRobot.pas',
  BnkEngn in 'BnkEngn.pas',
  ViewSession in 'ViewSession.pas' {frmViewSession},
  ViewOnlineHuman in 'ViewOnlineHuman.pas' {frmViewOnlineHuman},
  ViewLevel in 'ViewLevel.pas' {frmViewLevel},
  ViewList in 'ViewList.pas' {frmViewList},
  OnlineMsg in 'OnlineMsg.pas' {frmOnlineMsg},
  HumanInfo in 'HumanInfo.pas' {frmHumanInfo},
  ViewKernelInfo in 'ViewKernelInfo.pas' {frmViewKernelInfo},
  ConfigMerchant in 'ConfigMerchant.pas' {frmConfigMerchant},
  ItemSet in 'ItemSet.pas' {frmItemSet},
  ConfigMonGen in 'ConfigMonGen.pas' {frmConfigMonGen},
  GameCommand in 'GameCommand.pas' {frmGameCmd},
  MonsterConfig in 'MonsterConfig.pas' {frmMonsterConfig},
  ActionSpeedConfig in 'ActionSpeedConfig.pas' {frmActionSpeed},
  CastleManage in 'CastleManage.pas' {frmCastleManage},
  EncryptUnit in 'EncryptUnit.pas',
  Common in '..\Common\Common.pas',
  AttackSabukWallConfig in 'AttackSabukWallConfig.pas' {FrmAttackSabukWall},
  AboutUnit in 'AboutUnit.pas' {FrmAbout},
  ObjAutoPlay in 'ObjAutoPlay.pas',
  HeroConfig in 'HeroConfig.pas' {frmHeroConfig},
  M2Type in 'M2Type.pas',
  M2Config in 'M2Config.pas',
  ObjBActor in 'ObjBActor.pas',
  PaiMai in 'PaiMai.pas',
  TyFunc in '..\Common\TyFunc.pas',
  ShopConfig in 'ShopConfig.pas' {FrmShopItem},
  fmAutoPlayMan in 'fmAutoPlayMan.pas' {FrmAutoPlayMan},
  ObjPlayMon in 'ObjPlayMon.pas',
  PaiMaiManage in 'PaiMaiManage.pas' {FrmPaiMaiManage},
  SList in '..\Common\SList.pas';

{$R *.res}

begin
  g_Config.nServerFile_CRCA := CalcFileCRC32(Application.ExeName);
  Application.Initialize;
  Application.HintPause := 100;
  Application.HintShortPause := 100;
  Application.HintHidePause := 5000;
  Application.CreateForm(TFrmMain, FrmMain);
  Application.CreateForm(TFrmSrvMsg, FrmSrvMsg);
  Application.CreateForm(TfrmHeroConfig, frmHeroConfig);
  Application.CreateForm(TFrmMsgClient, FrmMsgClient);
  Application.CreateForm(TFrmIDSoc, FrmIDSoc);
  Application.CreateForm(TFrmServerValue, FrmServerValue);
  Application.CreateForm(TfrmGameCmd, frmGameCmd);
  Application.CreateForm(TfrmMonsterConfig, frmMonsterConfig);
  Application.CreateForm(TFrmShopItem, FrmShopItem);
  Application.CreateForm(TFrmAutoPlayMan, FrmAutoPlayMan);
  Application.CreateForm(TFrmPaiMaiManage, FrmPaiMaiManage);
  Application.Run;

end.

