unit PaiMai;
{ʱʵֵԪ  By TasNat}
interface
uses
  //Generics.Collections  ,//^_^
  Windows,
  SysUtils,
  Classes,
  TyFunc,
  M2Config,
  EDcode,
  ObjBase,
  M2Type,
  SerGrobal,
  MirGrobal;

type

{ TPaiMaiItemList }
  TPaiMaiItem = packed record //ڶеƷ
    sCharName: string[sChrNameLength];
    //sBuyCharName: string[sChrNameLength];
    //dDateTime: TDateTime;
    //Play:pTPlayObject;
    //nTiJiaoTime:Integer;

    btStatus :Byte; // 0 ռ 1 տʼ 2ӹǮ
    nGold: Integer; //-1 û¼ -2  -3 û -4 û
    UseItems: TUserItem;
    sItemName:string;
  end;
  pTPaiMaiItem = ^TPaiMaiItem;
  TPaiMaiShowItem = MirGrobal.TPaiMaiShowItem;
  pTPaiMaiShowItem = MirGrobal.pTPaiMaiShowItem;

  TPaiMaiManage = class
  private   
    m_StopPicCount:Byte;
    m_NowPaiMaiItem:pTPaiMaiItem;
    m_NowPaiMaiClientItem:TClientItem;
    m_StopPaiMaiTick:DWORD;
    m_NextUpStopPicCountTime:DWORD;//´һ۸ʱ
    m_dwNextPaiMaiTime:DWORD;        //һʱ

    procedure GetFirst;
    function Count:Byte;
  public
    m_btPaiMaiStatus : Byte;//0  1 
    m_PaiMaiItemList:TList;
    m_NowUpPicPlay:TPlayObject;
    m_NowSellPlay:TPlayObject;  //ǰƷָ
    m_NowSellPlayName:string[sChrNameLength];  //ǰƷ
    constructor Create;
    destructor Destroy; override;

    //Ϣ
    procedure Run;


    //Ʒ
    function Add(PaiMaiItem:pTPaiMaiItem):Integer;
    procedure DoSellPlayOffLine(SellPlay:TPlayObject);//
    procedure DoBuyPlayOffLine(BuyPlay:TPlayObject);//
    procedure SendAllPlayMsg(sMsg:string);
    procedure UpStopPicCount;
    procedure UpPaiMaiAItemPic(nCount:Integer;UpPicPlay:TPlayObject);
    procedure BeginPaiMaiAItem;
    procedure EndPaiMaiAItem;
    procedure GetNextPaiMaiItemAndDisposNowItem;
  end;

implementation
uses M2Share;

constructor TPaiMaiManage.Create;
begin
  inherited Create;
  m_NowPaiMaiItem := nil;
  m_NextUpStopPicCountTime:= GetTickCount +10000;
  m_StopPaiMaiTick:= GetTickCount +10000;
  m_NowUpPicPlay:= nil;
  m_NowSellPlay := nil;
  m_StopPicCount := 0;
  m_btPaiMaiStatus:= 0;
  m_PaiMaiItemList := TList.Create;
end;

destructor TPaiMaiManage.Destroy;
begin
  m_PaiMaiItemList.Free;
  inherited;
end;

procedure TPaiMaiManage.GetNextPaiMaiItemAndDisposNowItem;
begin
  m_NowUpPicPlay:= nil;//¼۸
  m_NowSellPlay := nil;//
  m_StopPicCount := 0;
  m_btPaiMaiStatus:= 0;
  m_dwNextPaiMaiTime:= GetTickCount + 30 *1000;
  Dispose(m_NowPaiMaiItem);
  GetFirst;
end;
procedure TPaiMaiManage.SendAllPlayMsg(sMsg:string);
var
  i: Integer;
  PlayObject: TPlayObject;
begin
  try
    EnterCriticalSection(ProcessHumanCriticalSection);
    for i := 0 to UserEngine.m_PlayObjectList.Count - 1 do begin
      PlayObject := TPlayObject(UserEngine.m_PlayObjectList.Objects[i]);
      if PlayObject <> nil then begin
        if (not PlayObject.m_boGhost) and (not PlayObject.m_boIsAuto)  then
          PlayObject.SysMsg(sMsg+'\'+EncodeBuffer(@m_NowPaiMaiClientItem, SizeOf(TClientItem)), c_White, t_PaiMai);
      end;
    end;
  finally
    LeaveCriticalSection(ProcessHumanCriticalSection);
  end;

end;
procedure TPaiMaiManage.DoSellPlayOffLine(SellPlay:TPlayObject);//
var
  UserItem: pTUserItem;
  PaiMaiItem:pTPaiMaiItem;
  i:Integer;
begin
  if  (Count = 0)and (m_NowPaiMaiItem = nil) then Exit;
  PaiMaiItem := nil;
  i := -1;
  if (m_NowPaiMaiItem <> nil) and
    (m_NowPaiMaiItem.sCharName = SellPlay.m_sCharName) then
    PaiMaiItem :=  m_NowPaiMaiItem
  else begin
    for i := 0 to m_PaiMaiItemList.Count -1 do begin
      PaiMaiItem := m_PaiMaiItemList[i];
      if (PaiMaiItem <> nil) and (PaiMaiItem.sCharName = SellPlay.m_sCharName) then begin
        Break;
      end;
    end;
    if i > -1 then
    m_PaiMaiItemList.Delete(i);
  end;
  if PaiMaiItem = nil then begin
    MainOutMessage('TPaiMaiManage:: Not in List '+SellPlay.m_sCharName+'/'+inttostr(SellPlay.m_nDiYaGameGold)+'/'+inttostr(m_PaiMaiItemList.Count));
    Exit;
  end;
  try
    New(UserItem);
    System.Move(PaiMaiItem.UseItems,UserItem^,SizeOf(TUserItem));
    if SellPlay.IsEnoughBag then begin
      SellPlay.m_ItemList.Add(UserItem);
    end else begin
      SellPlay.m_StorageItemList.Add(UserItem);
    end;
    SellPlay.m_nDiYaGameGold := 0;
    if PaiMaiItem = m_NowPaiMaiItem then begin //ǵǰĵƷ
                                           {'[%s]ƨ,[%s]ľĽ....'}
      SendAllPlayMsg(format(g_sPaiMaiSellIsDieMsg,[SellPlay.m_sCharName,PaiMaiItem.sItemName]));
      if m_NowUpPicPlay <> nil then begin  //˼ӹǮ Ǯ
        if m_NowUpPicPlay.m_nDiYaGameGold > 0 then
        m_NowUpPicPlay.IncGameGold(m_NowUpPicPlay.m_nDiYaGameGold);
        m_NowUpPicPlay.GameGoldChanged;
        m_NowUpPicPlay.SysMsg(PaiMaiItem.sCharName+',ĵѺ['+Inttostr(m_NowUpPicPlay.m_nDiYaGameGold)+']˻...',c_Green,t_PaiMai);
        m_NowUpPicPlay.m_nDiYaGameGold := 0;
      end;
      GetNextPaiMaiItemAndDisposNowItem;
      PaiMaiItem := nil;
      if m_NowPaiMaiItem = nil then begin {'ûƷ...'}
        SendAllPlayMsg(g_sNextPaiMaiNilTimeMsg);
      end else begin             {'һƷ(%d)Ӻʼ...'}
        SendAllPlayMsg(format(g_sNextPaiMaiTimeMsg,[m_NowPaiMaiClientItem.s.Name,FmtTime(30000)]));
      end;

    end else begin
      SendAllPlayMsg(format(g_sPaiMaiWaitSellIsDieMsg,[SellPlay.m_sCharName,10 - m_PaiMaiItemList.Count]));
    end;

  finally
    if PaiMaiItem <> nil then
      Dispose(PaiMaiItem);
  end;
end;
procedure TPaiMaiManage.DoBuyPlayOffLine(BuyPlay:TPlayObject);//
var
  nDecGold,nIncGold :Integer;
begin
  if (m_btPaiMaiStatus = 0)or(m_NowPaiMaiItem = nil) or
    (m_NowPaiMaiItem.btStatus <> 2)or(m_NowUpPicPlay = nil)or
    (BuyPlay <> m_NowUpPicPlay) then begin

    MainOutMessage('ѺԪ:'+BuyPlay.m_sCharName+'/'+inttostr(BuyPlay.m_nDiYaGameGold));
    BuyPlay.m_nDiYaGameGold := 0;
    if (BuyPlay <> m_NowUpPicPlay) then
      MainOutMessage('ðf/t:'+BuyPlay.m_sCharName+'/'+m_NowUpPicPlay.m_sCharName);
    Exit;
  end;
  nDecGold := (Round((m_NowUpPicPlay.m_nDiYaGameGold) * (2 / 100)));
  nIncGold := m_NowUpPicPlay.m_nDiYaGameGold -  nDecGold;
  m_NowUpPicPlay.IncGameGold(nIncGold);
  m_NowUpPicPlay.m_nDiYaGameGold := 0;
  m_StopPicCount  := 0;
  {'[%s]ƨ,[%s]ľļΪ[%d]Ҽ....'}
  UserEngine.SendBroadCastMsgExt(format(g_sPaiMaiBuyIsDieMsg,[m_NowUpPicPlay.m_sCharName,m_NowPaiMaiClientItem.s.Name,m_NowPaiMaiItem.nGold]),t_PaiMai);
  m_NowUpPicPlay := nil;
end;

function TPaiMaiManage.Count:Byte;
var
  i:Integer;
begin
  Result := m_PaiMaiItemList.Count;
end;

{Ʒ}
function TPaiMaiManage.Add(PaiMaiItem:pTPaiMaiItem):Integer;
var
  i,checkCode:Integer;
begin
  try
    checkCode := 0;
    Result:= -1;  //g_Config.btJiShiPaiMaiWaitCount
    if (g_Config.btJiShiPaiMaiWaitCount = 0) or (Count >= 10) then Exit;
    checkCode := 1;
    Result := m_PaiMaiItemList.Add(PaiMaiItem);
    checkCode := 2;
    if (Count = 1) and (m_btPaiMaiStatus = 0) then begin
      checkCode := 3;
      GetFirst;
      checkCode := 4;
      m_dwNextPaiMaiTime := 0;
      BeginPaiMaiAItem;
      checkCode := 5;
    end;
  except
    MainOutMessage('E-Add '+inttostr(checkCode));
  end;
end;

{ӵȴȡƷ}
procedure TPaiMaiManage.GetFirst;
var
  i:Integer;
  pStdItem: pTStdItem;
  StdItem: TStdItem;
  ClientItem: TClientItem;
  sUserItemName: string;
  checkCode :Integer;
begin
  try
    checkCode := 0;
    m_NowPaiMaiItem := nil;
    if Count = 0 then  Exit;
    checkCode := 1;
    m_NowPaiMaiItem := pTPaiMaiItem(m_PaiMaiItemList.First);
    checkCode := 2;
    pStdItem := UserEngine.GetStdItem(m_NowPaiMaiItem.UseItems.wIndex);
    checkCode := 3;
    if pStdItem = nil then Exit;
    checkCode := 4;
    StdItem := pStdItem^;
    ItemUnit.GetItemAddValue(@m_NowPaiMaiItem.UseItems, StdItem);
    Move(StdItem, m_NowPaiMaiClientItem.s, SizeOf(TStdItem));
    checkCode := 5;
      //ȡԶƷ

    sUserItemName := ItemUnit.GetCustomItemName(@m_NowPaiMaiItem.UseItems);
    if sUserItemName <> '' then
      m_NowPaiMaiClientItem.s.Name := sUserItemName;
    checkCode := 6;
    m_NowPaiMaiClientItem.MakeIndex := m_NowPaiMaiItem.UseItems.MakeIndex;
    m_NowPaiMaiClientItem.Dura := m_NowPaiMaiItem.UseItems.Dura;
    m_NowPaiMaiClientItem.DuraMax := m_NowPaiMaiItem.UseItems.DuraMax;
    checkCode := 7;
    if StdItem.StdMode in [15, 19, 20, 21, 22, 23, 24, 26] then begin
      if m_NowPaiMaiItem.UseItems.btAddValue[IVIUnknow] = 0 then
        m_NowPaiMaiClientItem.s.Shape := 0
      else m_NowPaiMaiClientItem.s.Shape := 130;
    end;
    checkCode := 8;
    m_NowPaiMaiItem.sItemName := m_NowPaiMaiClientItem.s.Name;
    checkCode := 9;
    m_PaiMaiItemList.Delete(0);
    checkCode := 10;
  except
    MainOutMessage('E-GetFirst '+inttostr(checkCode));
  end;
end;

procedure TPaiMaiManage.BeginPaiMaiAItem;
var
  TempPlay:TPlayObject;
  checkCode :Integer;
begin
  try
    checkCode := 0;
    m_NowSellPlay  := nil;
    m_NowUpPicPlay := nil;
    //if m_btPaiMaiStatus <> 0 then
    if m_NowPaiMaiItem = nil then Exit;
    //NowPlay:= UserEngine.GetPlayObject()

    TempPlay:= UserEngine.GetPlayObject(m_NowPaiMaiItem.sCharName);
    checkCode := 1;
    if (TempPlay = nil) then begin //ǰ Ѿ߻򲻴.
      checkCode := 2;
      SendAllPlayMsg(format(g_sPaiMaiPlayIsNilMsg,[m_NowPaiMaiItem.sItemName]));
        try
          Dispose(m_NowPaiMaiItem);
        except
        end;
      checkCode := 3;
      GetFirst;
      checkCode := 4;
      BeginPaiMaiAItem;
      checkCode := 5;
    end else begin //
      checkCode := 6;
      if (TempPlay.m_boGhost) then begin //ǰ Ѿ߻򲻴
        checkCode := 7;                        {[%s]ƨ,[%s]ľĽ...}
        SendAllPlayMsg(format(g_sPaiMaiSellIsDieMsg,[TempPlay.m_sCharName,m_NowPaiMaiItem.sItemName]));
        checkCode := 8;
        try
          Dispose(m_NowPaiMaiItem);
        except
        end;
        checkCode := 9;
        GetFirst;
        checkCode := 10;
        BeginPaiMaiAItem;
        checkCode := 11;
      end else begin  //Ч
        checkCode := 12;
        m_NowPaiMaiItem.btStatus := 1;
        m_btPaiMaiStatus := 1;
        checkCode := 13;
        m_NowSellPlay:=TempPlay;   {'ڿʼ[%s],׼[%d]....'}
        m_NowSellPlay.m_nDiYaGameGold := -1;
        checkCode := 14;
        m_NowSellPlay.SysMsg(format(g_sPaiMaiBeginForSellPlayMsg,[m_NowPaiMaiClientItem.s.Name,m_NowPaiMaiItem.nGold]),c_Green,t_PaiMai);
        checkCode := 15;                                      {'ڿʼ[%s][%s],׼[%d]....'}
        SendAllPlayMsg(format(g_sPaiMaiBeginForAllPlayMsg,[m_NowSellPlay.m_sCharName, m_NowPaiMaiItem.sItemName,m_NowPaiMaiItem.nGold]));
        checkCode := 16;
        m_NextUpStopPicCountTime := GetTickCount + 30 *1000; //´μӼʱ
      end;
    end;
  except
    MainOutMessage('E-BeginPaiMaiAItem '+inttostr(checkCode));
  end;
end;

{}
procedure TPaiMaiManage.EndPaiMaiAItem;
var
  UserItem: pTUserItem;
  checkCode :Integer;
begin
  try
    checkCode := 0;
    if m_NowPaiMaiItem = nil then Exit;
    if m_NowSellPlay = nil then Exit;
    checkCode := 1;
    case m_NowPaiMaiItem.btStatus of
      1:begin
        checkCode := 2;
        New(UserItem);
        System.Move(m_NowPaiMaiItem.UseItems,UserItem^,SizeOf(TUserItem));
        m_NowSellPlay.m_ItemList.Add(UserItem);
        m_NowSellPlay.SendAddItem(UserItem);
        m_NowSellPlay.m_nDiYaGameGold := 0;
        m_NowSellPlay.SysMsg(Format('[%s]ʽ...',[m_NowPaiMaiItem.sItemName]),c_Green,t_PaiMai);
        checkCode := 3;
        SendAllPlayMsg(format(g_sNotUpPicEndPaiMaiMsg,[m_NowPaiMaiItem.sItemName]));
      end;
      2:begin                                     {'[%s][%d]ɹĵ[%s]....'}
        checkCode := 4;
        SendAllPlayMsg(format(g_sEndPaiMaiMsg,[m_NowUpPicPlay.m_sCharName,m_NowPaiMaiItem.nGold,m_NowPaiMaiItem.sItemName]));
        if (m_NowSellPlay <> nil) then begin  //ҼǮ
          checkCode := 5;
          Inc(m_NowSellPlay.m_nGameGold,m_NowPaiMaiItem.nGold);
          m_NowSellPlay.m_nDiYaGameGold := 0;
          m_NowSellPlay.GameGoldChanged;
        end;
        checkCode := 6;
        if (m_NowUpPicPlay <> nil) then begin //ҵö
          m_NowUpPicPlay.m_nDiYaGameGold := 0;
          checkCode := 7;
          New(UserItem);
          System.Move(m_NowPaiMaiItem.UseItems,UserItem^,SizeOf(TUserItem));
          if m_NowUpPicPlay.IsEnoughBag then begin
            m_NowUpPicPlay.m_ItemList.Add(UserItem);
            //m_NowUpPicPlay.SendAddItem(UserItem);
          end else begin
            m_NowUpPicPlay.m_StorageItemList.Add(UserItem);
          end;
          checkCode := 8;
          m_NowPaiMaiItem.nGold := -1;
          m_NowUpPicPlay.SendDefMessage(SM_BuyPaiMaiItem,0,0,0,0,'');
          checkCode := 9;
        end;                              //g_Config.btJiShiPaiMaiStopTime
      end;
    end;
    //һʼʱ
    checkCode := 10;
    GetNextPaiMaiItemAndDisposNowItem;
    checkCode := 11;
    if m_NowPaiMaiItem = nil then begin {'ûƷ...'}
       SendAllPlayMsg(g_sNextPaiMaiNilTimeMsg);
    end else begin   {'һƷ(%d)Ӻʼ...'}
      m_dwNextPaiMaiTime:= GetTickCount + 30 *1000;
      SendAllPlayMsg(format(g_sNextPaiMaiTimeMsg,[m_NowPaiMaiItem.sItemName,FmtTime(m_dwNextPaiMaiTime-GetTickCount)]));
    end;
  except
    MainOutMessage('E-GetFirst '+inttostr(checkCode));
  end;
end;



procedure TPaiMaiManage.UpStopPicCount;
begin                                  {'[%s] %s [%d]....'}
  if (m_btPaiMaiStatus = 0) or (m_NowPaiMaiItem = nil) then Exit;
  if (m_NowUpPicPlay <> nil)   then
    SendAllPlayMsg(format(g_sPaiMaiUpPicMsg,[m_NowPaiMaiItem.sItemName,m_NowUpPicPlay.m_sCharName,m_NowPaiMaiItem.nGold])+inttostr(m_StopPicCount)+'')
  else                                   {'[%s]ǰ[%d]˳(%d)....'}
    SendAllPlayMsg(format(g_sPaiMaiNotUpPicMsg,[m_NowPaiMaiItem.sItemName,m_NowPaiMaiItem.nGold,m_StopPicCount]))
end;

procedure TPaiMaiManage.UpPaiMaiAItemPic(nCount:Integer;UpPicPlay:TPlayObject);
begin
  if (m_btPaiMaiStatus = 0)or(m_NowPaiMaiItem = nil) then begin
    MainOutMessage('ûʼľͼӼ,ɻ:'+UpPicPlay.m_sCharName);
    if m_NowPaiMaiItem <> nil then
      m_NowUpPicPlay.SysMsg(m_NowPaiMaiItem.sItemName+' ûʼ...',c_Green,t_PaiMai)
    else m_NowUpPicPlay.SysMsg('ĿǰûκƷ...',c_Green,t_PaiMai);
    Exit;
  end;
  if UpPicPlay.m_nDiYaGameGold < 0 then begin
    UpPicPlay.SysMsg('ѾύƷ,ٲ뾺...',c_Green,t_PaiMai);
    UpPicPlay.SysMsg('.С...',c_Green,t_PaiMai);
    Exit;
  end;
  if m_NowSellPlay = UpPicPlay then begin
    UpPicPlay.SysMsg('...',c_Green,t_PaiMai);
    Exit;
  end;

  if UpPicPlay.m_nGameGold < nCount   then begin
    UpPicPlay.SysMsg('ٺٸŶ,㻹ûôࣤ...',c_Green,t_PaiMai);
    Exit;
  end;
  if nCount <= m_NowPaiMaiItem.nGold then begin
    UpPicPlay.SysMsg('ļ̫...',c_Green,t_PaiMai);
    Exit;
  end;


  if m_NowUpPicPlay <> nil then begin //ԭӼǮ
    Inc(m_NowUpPicPlay.m_nGameGold,m_NowUpPicPlay.m_nDiYaGameGold);//Ǯ
    m_NowUpPicPlay.GameGoldChanged;
    m_NowUpPicPlay.SysMsg(UpPicPlay.m_sCharName+'۱,ѱ,ĵѺ['+Inttostr(m_NowUpPicPlay.m_nDiYaGameGold)+']˻...',c_Green,t_PaiMai);
    m_NowUpPicPlay.m_nDiYaGameGold := 0;
  end;
  m_NowPaiMaiItem.nGold := nCount; //¼۸
  m_NowPaiMaiItem.nGold:=_MIN(1000000000,m_NowPaiMaiItem.nGold);//Χ

  m_NowUpPicPlay:= UpPicPlay; //Ӽ
  m_NowUpPicPlay.m_nDiYaGameGold := m_NowPaiMaiItem.nGold; //ӼߵĵѺ
  //ӦԪ
  Dec(m_NowUpPicPlay.m_nGameGold,m_NowUpPicPlay.m_nDiYaGameGold);
  //Ԫ
  m_NowUpPicPlay.GameGoldChanged;
  //Ϊӹ.
  m_NowPaiMaiItem.btStatus := 2;
  m_StopPicCount := 0;
  SendAllPlayMsg(format(g_sPaiMaiUpPicMsg,[m_NowPaiMaiItem.sItemName,m_NowUpPicPlay.m_sCharName,m_NowPaiMaiItem.nGold]));
  m_NextUpStopPicCountTime := GetTickCount + 30 *1000;
  //´һ۸ʱ
end;                                         //g_Config.btJiShiPaiMaiOverTime

procedure TPaiMaiManage.Run;
begin
  if ((Count = 0)and (m_NowPaiMaiItem = nil ))or
  (g_Config.btJiShiPaiMaiWaitCount = 0) then Exit;

  if (m_btPaiMaiStatus = 0)and (GetTickCount > m_dwNextPaiMaiTime) then begin //ûϢ
    BeginPaiMaiAItem;//ʼµ
  end;
  if (m_btPaiMaiStatus <> 0)and(GetTickCount > m_NextUpStopPicCountTime) then begin
    if m_StopPicCount < 2 then begin             //g_Config.btJiShiPaiMaiOverTime
      m_NextUpStopPicCountTime := GetTickCount + 30 *1000;
      Inc(m_StopPicCount);
      UpStopPicCount;
    end else EndPaiMaiAItem;
  end;
end;

end.
