unit PaiMaiManage;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Spin,
  M2Share,
  M2Config,
  PaiMai

  ;

type
  TFrmPaiMaiManage = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ListView1: TListView;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    SpinEdit_JiShouGoldR: TSpinEdit;
    SpinEdit_JiShouGameGoldR: TSpinEdit;
    GroupBox5: TGroupBox;
    CheckBox_XianShouShuei: TCheckBox;
    GroupBox9: TGroupBox;
    Button_LoadConfig: TButton;
    Button_SaveDefConfig: TButton;
    Button_SaveConfig: TButton;
    Label13: TLabel;
    SpinEdit_QingLiJiShou: TSpinEdit;
    Label14: TLabel;
    GroupBox6: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    SpinEdit_WaitCount: TSpinEdit;
    SpinEdit_OverTime: TSpinEdit;
    SpinEdit1: TSpinEdit;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    SpinEdit_GoldRate: TSpinEdit;
    SpinEdit_GameGoldRate: TSpinEdit;
    SpinEdit_StopTime: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    procedure SetVal(Sender: TObject);
    procedure Button_LoadConfigClick(Sender: TObject);
    procedure Button_SaveDefConfigClick(Sender: TObject);
    procedure Button_SaveConfigClick(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
  private
    { Private declarations }
  public
    procedure Open;
  end;

  procedure UpDataInf;
  procedure LoadConfig;
  procedure SaveConfig;
  procedure SaveDefConfig;
var
  FrmPaiMaiManage: TFrmPaiMaiManage;

implementation

{$R *.dfm}
var
  SetPaiMaiItem : pTPaiMaiItem = nil;
  SetPaiMaiShowItem : pTPaiMaiShowItem = nil;
procedure UpDataInf;
var
  i:Integer;
  ListItem:TListItem;
begin
  if FrmPaiMaiManage = nil then Exit;
  with FrmPaiMaiManage do begin
    SpinEdit_WaitCount.Value := g_Config.btJiShiPaiMaiWaitCount;
    SpinEdit_GoldRate.Value := g_Config.btPaiMaiGoldRate;
    SpinEdit_GameGoldRate.Value := g_Config.btPaiMaiGameGoldRate;
    CheckBox_XianShouShuei.Checked := g_Config.boPaiMaiXianShouShueiRate;
    SpinEdit_OverTime.Value := g_Config.btJiShiPaiMaiOverTime;
    SpinEdit_StopTime.Value := g_Config.btJiShiPaiMaiStopTime;
    SpinEdit_QingLiJiShou.Value:= g_Config.nJiShouClearDay;
    SpinEdit_JiShouGoldR.Value:= g_Config.btJiShouGoldRate;
    SpinEdit_JiShouGameGoldR.Value:= g_Config.btJiShouGameGoldRate;
    if g_PaiMaiManage = nil then Exit;
    try
      for i := 0 to g_PaiMaiManage.m_PaiMaiItemList.Count -1 do begin
        if g_PaiMaiManage.m_PaiMaiItemList[i]<> nil then begin
          ListItem:=ListView1.Items.Add;
          SetPaiMaiItem:= pTPaiMaiItem(g_PaiMaiManage.m_PaiMaiItemList[i]);
          with ListItem do begin
            //Data :=  SetPaiMaiItem;
            Caption := SetPaiMaiItem.sCharName;
            SubItems.Add(SetPaiMaiItem.sItemName);
            SubItems.Add(IntToStr(SetPaiMaiItem.UseItems.MakeIndex));
            SubItems.Add(IntToStr(SetPaiMaiItem.nGold));
            SubItems.Add(IntToStr(SetPaiMaiItem.btStatus));
            //SubItems.Add(DateTimeToStr(SetPaiMaiItem.dDateTime));
            //SubItems.Add(DateTimeToStr(SetPaiMaiItem.dqDateTime));
            SubItems.Add('ʱ');
            {case SetPaiMaiItem.btSellMode of
              0:SubItems.Add('Ԫ');
              1:SubItems.Add('ʱ');
              2:SubItems.Add('Ԫ');
              3:SubItems.Add('Ҽ')
              else SubItems.Add(IntToStr(SetPaiMaiItem.btSellMode));
            end; }
          end;
        end;
      end;
    finally

    end;
  end;
  SetPaiMaiItem := nil;
  SetPaiMaiShowItem := nil;
end;
procedure LoadConfig;
var
  Section, Ident:string;
begin
  {
  if StringConf.ReadString('', 'GuildChief', '') = '' then
    StringConf.WriteString('', 'GuildChief', g_Config.sGuildChief);
  g_Config.sGuildChief := StringConf.ReadString('Guild', 'GuildChief', g_Config.sGuildChief);
  }
  //
  Section:='';
  Ident  :='ʱȴ';
  if Config.ReadInteger(Section,Ident , -1) < 0 then
    Config.WriteInteger(Section,Ident ,  g_Config.btJiShiPaiMaiWaitCount);
  g_Config.btJiShiPaiMaiWaitCount := Config.ReadInteger(Section,Ident ,  g_Config.btJiShiPaiMaiWaitCount);

  Ident  :='˰';
  if Config.ReadInteger(Section,Ident , -1) < 0 then
    Config.WriteInteger(Section,Ident ,  g_Config.btPaiMaiGoldRate);
  g_Config.btPaiMaiGoldRate := Config.ReadInteger(Section,Ident ,  g_Config.btPaiMaiGoldRate);

  Ident  :='Ԫ˰';
  if Config.ReadInteger(Section,Ident , -1) < 0 then
    Config.WriteInteger(Section,Ident ,  g_Config.btPaiMaiGameGoldRate);
  g_Config.btPaiMaiGameGoldRate := Config.ReadInteger(Section,Ident ,  g_Config.btPaiMaiGameGoldRate);

  Ident  :='˰';
  if Config.ReadInteger(Section,Ident , -1) < 0 then
    Config.WriteInteger(Section,Ident ,  Byte(g_Config.boPaiMaiXianShouShueiRate));
  g_Config.boPaiMaiXianShouShueiRate := Boolean(Config.ReadInteger(Section,Ident , Byte(g_Config.boPaiMaiXianShouShueiRate)));

  Ident  :='ʱʱ';
  if Config.ReadInteger(Section,Ident , -1) < 0 then
    Config.WriteInteger(Section,Ident ,  g_Config.btJiShiPaiMaiOverTime);
  g_Config.btJiShiPaiMaiOverTime := Config.ReadInteger(Section,Ident ,  g_Config.btJiShiPaiMaiOverTime);

  Section:='';
  Ident  :='۽˰';
  if Config.ReadInteger(Section,Ident , -1) < 0 then
    Config.WriteInteger(Section,Ident ,  g_Config.btJiShouGoldRate);
  g_Config.btJiShouGoldRate := Config.ReadInteger(Section,Ident ,  g_Config.btJiShouGoldRate);


  Ident  :='Ԫ˰';
  if Config.ReadInteger(Section,Ident , -1) < 0 then
    Config.WriteInteger(Section,Ident ,  g_Config.btJiShouGameGoldRate);
  g_Config.btJiShouGameGoldRate := Config.ReadInteger(Section,Ident ,  g_Config.btJiShouGameGoldRate);


  Ident  :='ۻʱ';
  if Config.ReadInteger(Section,Ident , -1) < 0 then
    Config.WriteInteger(Section,Ident ,  g_Config.nJiShouClearDay);
  g_Config.nJiShouClearDay := Config.ReadInteger(Section,Ident ,  g_Config.nJiShouClearDay);



  UpDataInf;
end;

procedure SaveConfig;
begin
end;

procedure SaveDefConfig;
begin
  LoadConfig;
end;  
procedure TFrmPaiMaiManage.Open;
begin
  UpDataInf();   
  ShowModal;
end;

procedure TFrmPaiMaiManage.SetVal(Sender: TObject);
begin
  if Sender = nil then begin
    Exit;
  end;
  if TComponent(Sender).Tag <> 10 then begin
    with  TSpinEdit(Sender) do
    case Tag of
      0:g_Config.btJiShiPaiMaiWaitCount := Value;
      1:g_Config.btJiShiPaiMaiStopTime := Value;
      2:g_Config.btPaiMaiGoldRate := Value;
      3:g_Config.btPaiMaiGameGoldRate := Value;
      4:g_Config.btJiShiPaiMaiOverTime := Value;
      5:g_Config.btJiShouGoldRate := Value;
      6:g_Config.btJiShouGameGoldRate := Value;
      7:g_Config.nJiShouClearDay := Value;
    end;
  end else begin
    g_Config.boPaiMaiXianShouShueiRate:=TCheckBox(Sender).Checked;
  end;
  Button_SaveConfig.Enabled := True;
end;

procedure TFrmPaiMaiManage.Button_LoadConfigClick(Sender: TObject);
begin
  LoadConfig;
end;

procedure TFrmPaiMaiManage.Button_SaveDefConfigClick(Sender: TObject);
begin
  SaveDefConfig;
end;

procedure TFrmPaiMaiManage.Button_SaveConfigClick(Sender: TObject);
begin
  SaveConfig;
end;

procedure TFrmPaiMaiManage.ListView1SelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if Item = nil then Exit;
  SetPaiMaiItem := Item.Data;
end;

end.
