unit AxeMon;

interface

uses
  Windows, Classes,
  MirGrobal, ClType, DXDraws, cliUtil, ClFunc, magiceff, Actor,
  ResManager, //ԴԪ TasNat 2009-02-14 22:38:49
  ClVarConst,
  SoundUtil,
  clMapEff;
const
   DEATHEFFECTBASE = 340;
   DEATHFIREEFFECTBASE = 2860;
   AXEMONATTACKFRAME = 6;
   KUDEGIGASBASE = 1445;
   COWMONFIREBASE = 1800;
   COWMONLIGHTBASE = 1900;
   ZOMBILIGHTINGBASE = 350;
   ZOMBIDIEBASE = 340;
   ZOMBILIGHTINGEXPBASE = 520;
   SCULPTUREFIREBASE = 1680;
   MOTHPOISONGASBASE = 3590;
   DUNGPOISONGASBASE = 3590;
   WARRIORELFFIREBASE = 820;
   //Jacky
   SUPERIORGUARDBASE = 760;

type
   TSkeletonOma = class (TActor) // ==
   private
   protected
      m_EffectSurface: TDirectDrawSurface;    //0x240
      ax,ay:SmallInt;                           //0x244
   public
      constructor Create; override;
      destructor Destroy; override;
      procedure CalcActorFrame; override;
      function  GetDefaultFrame (wmode: Boolean): integer; override;
      procedure DoLoadSurface; override;
      procedure Run; override;
      procedure DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean); override;
   end;

   TDualAxeOma = class (TSkeletonOma)  // 
   private
   public
      procedure Run; override;
   end;

   TCatMon = class (TSkeletonOma)
   private
   public
      procedure DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean); override;
   end;

   TArcherMon = class (TCatMon)//Size: 0x25C Address: 0x00461A90
   public
      procedure Run; override;
   end;

   TScorpionMon = class (TCatMon)
   public
   end;

   THuSuABi = class (TSkeletonOma)
   public
      procedure DoLoadSurface; override;
   end;

   TZombiDigOut = class (TSkeletonOma)
   public
      procedure RunFrameAction (frame: integer); override;
   end;

   TZombiZilkin = class (TSkeletonOma)
   public
   end;

   TWhiteSkeleton = class (TSkeletonOma)//
   public
   end;


   TGasKuDeGi = class (TActor)//Ш
   protected
      AttackEffectSurface :TDirectDrawSurface;    //0x250
      DieEffectSurface    :TDirectDrawSurface;    //0x254
      BoUseDieEffect      :Boolean;    //0x258
      firedir             :SmallInt;    //0x25C
      fire16dir           :SmallInt;    //0c260
      ax,ay                  :SmallInt;    //0x264
      bx,by                  :SmallInt;
   public
      constructor Create; override;
      procedure CalcActorFrame; override;
      function  GetDefaultFrame (wmode: Boolean): integer; override;
      procedure DoLoadSurface; override;
      procedure Run; override;
      procedure DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean); override;
      procedure DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer); override;
   end;

   TFireCowFaceMon = class (TGasKuDeGi)
   public
      function   Light: integer; override;
   end;

   TCowFaceKing = class (TGasKuDeGi)
   public
      function   Light: integer; override;
   end;

   TZombiLighting = class (TGasKuDeGi)
   protected
   public
   end;
   TSuperiorGuard = class (TGasKuDeGi)
   protected
   public
   end;
   TExplosionSpider = class (TGasKuDeGi)
   protected
   public
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
   end;
   TFlyingSpider = class (TSkeletonOma)//ħ ==
   protected
   public
     procedure CalcActorFrame; override;
   end;
   TSculptureMon = class (TSkeletonOma)//ʿ 
   private
      AttackEffectSurface: TDirectDrawSurface;
      ax, ay, firedir: SmallInt;
   public
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
      function  GetDefaultFrame (wmode: Boolean): integer; override;
      procedure DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer); override;
      procedure Run; override;
   end;

   TSculptureKingMon = class (TSculptureMon)//
   public
   end;

   TSmallElfMonster = class (TSkeletonOma)
   public
   end;

   TWarriorElfMonster = class (TSkeletonOma)//(
   private
      oldframe: integer;
   public
      procedure  RunFrameAction (frame: integer); override;  //Ӹ Ưϰ ؾ
   end;
   //
   TElectronicScolpionMon = class (TGasKuDeGi)//Size 0x274 0x3c
   protected
   public
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
   end;
   TBossPigMon = class (TGasKuDeGi)//0x3d
   protected
   public
      procedure DoLoadSurface; override;
   end;
   TKingOfSculpureKingMon = class (TGasKuDeGi)//0x3e
   protected
   public
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
   end;
   TSkeletonKingMon = class (TGasKuDeGi)//0x3f
   protected
   public
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
      procedure Run; override;   
   end;
   TSamuraiMon = class (TGasKuDeGi)//0x41
   protected
   public
   end;
   TSkeletonSoldierMon = class (TGasKuDeGi)//0x42 0x43 0x44
   protected
   public
   end;
   TSkeletonArcherMon = class (TArcherMon)//Size: 0x26C Address: 0x004623B4 //0x45
      AttackEffectSurface :TDirectDrawSurface;//0x25C
      bo260:Boolean;
      n264,n268:SmallInt;
   protected
   public
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
      procedure Run; override;
      procedure DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer); override;
   end;
   TBanyaGuardMon = class (TSkeletonArcherMon)//Size: 0x270 Address: 0x00462430 0x46 0x47 0x48 0x4e
     n26C:TDirectDrawSurface;
   protected
   public
      constructor Create; override;
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
      procedure Run; override;
      procedure DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer); override;
   end;
   TStoneMonster = class (TSkeletonArcherMon)//Size: 0x270 0x4d 0x4b
     n26C:TDirectDrawSurface;
   protected
   public
      constructor Create; override;
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
      procedure Run; override;
      procedure DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer); override;   
   end;
   TPBOMA1Mon = class (TCatMon)//0x49
   protected
   public
      procedure Run; override;   
   end;
   TPBOMA6Mon = class (TCatMon)//0x4f
   protected
   public
      procedure Run; override;
   end;
   TAngel = class (TBanyaGuardMon)//Size: 0x27C 0x51
     n270,n274:SmallInt;
     n278:TDirectDrawSurface;
   protected
   public
      procedure  DoLoadSurface; override;
      procedure  DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean); override;
   end;
   TFireDragon = class (TSkeletonArcherMon)//0x53
     n270:TDirectDrawSurface;
   private
      procedure AttackEff;   
   protected
   public
      constructor Create; override;
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
      procedure Run; override;
      procedure DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer); override;   
   end;
   TDragonStatue = class (TSkeletonArcherMon)//Size: 0x270 0x54
     n26C:TDirectDrawSurface;
   protected
   public
      constructor Create; override;
      procedure CalcActorFrame; override;
      procedure DoLoadSurface; override;
      procedure Run; override;
      procedure DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer); override;   
   end;


implementation

uses
   ClMain, mywil;


{============================== TSkeletonOma =============================}

//      ذ (ذ, ūذ, ذ)

{--------------------------}


constructor TSkeletonOma.Create;
begin
   inherited Create;
   m_EffectSurface := nil;
   boUseEffect := FALSE;
end;
destructor TSkeletonOma.Destroy;
begin
  inherited Destroy;
end;  
procedure TSkeletonOma.CalcActorFrame;
var
   pm: PTMonsterAction;
   haircount: integer;
begin
   CurrentFrame := -1;
   ReverseFrame := FALSE;
   boUseEffect := FALSE;

   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   case CurrentAction of
      SM_TURN:
         begin
            StartFrame := pm.ActStand.start + Dir * (pm.ActStand.frame + pm.ActStand.skip);
            EndFrame := StartFrame + pm.ActStand.frame - 1;
            FrameTime := pm.ActStand.ftime;
            StartTime := GetTickCount;
            DefFrameCount := pm.ActStand.frame;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_WALK, SM_BACKSTEP:
         begin
            StartFrame := pm.ActWalk.start + Dir * (pm.ActWalk.frame + pm.ActWalk.skip);
            EndFrame := StartFrame + pm.ActWalk.frame - 1;
            FrameTime := pm.ActWalk.ftime;
            StartTime := GetTickCount;
            MaxTick := pm.ActWalk.UseTick;
            CurTick := 0;
            //WarMode := FALSE;
            MoveStep := 1;
            if CurrentAction = SM_WALK then
               MicroMove(Dir, MoveStep, 0, EndFrame-StartFrame+1)
            else  //sm_backstep
               MicroMove(GetBack(Dir), MoveStep, 0, EndFrame-StartFrame+1);
         end;
      SM_DIGUP: //ȱ , SM_DIGUP,  .
         begin
            if (Race = 23) then begin //or (Race = 54) or (Race = 55) then begin
               //
               StartFrame := pm.ActDeath.start;
            end else begin
               StartFrame := pm.ActDeath.start + Dir * (pm.ActDeath.frame + pm.ActDeath.skip);
            end;
            EndFrame := StartFrame + pm.ActDeath.frame - 1;
            FrameTime := pm.ActDeath.ftime;
            StartTime := GetTickCount;
            //WarMode := FALSE;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_DIGDOWN:
         begin
            if Race = 55 then begin
               //ż1   
               StartFrame := pm.ActCritical.start + Dir * (pm.ActCritical.frame + pm.ActCritical.skip);
               EndFrame := StartFrame + pm.ActCritical.frame - 1;
               FrameTime := pm.ActCritical.ftime;
               StartTime := GetTickCount;
               ReverseFrame := TRUE;
               //WarMode := FALSE;
               MicroMove(Dir, 0, 0, 1);
            end;
         end;
      SM_HIT,
      SM_FLYAXE,
      SM_LIGHTING:
         begin
            StartFrame := pm.ActAttack.start + Dir * (pm.ActAttack.frame + pm.ActAttack.skip);
            EndFrame := StartFrame + pm.ActAttack.frame - 1;
            FrameTime := pm.ActAttack.ftime;
            StartTime := GetTickCount;
            //WarMode := TRUE;
            WarModeTime := GetTickCount;
            if (Race = 16) or (Race = 54) then
               boUseEffect := TRUE;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_STRUCK:
         begin
            StartFrame := pm.ActStruck.start + Dir * (pm.ActStruck.frame + pm.ActStruck.skip);
            EndFrame := StartFrame + pm.ActStruck.frame - 1;
            FrameTime := StruckFrameTime; //pm.ActStruck.ftime;
            StartTime := GetTickCount;
         end;
      SM_DEATH:
         begin
            StartFrame := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip);
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            StartFrame := EndFrame; //
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
         end;
      SM_NOWDEATH:
         begin
            StartFrame := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip);
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
            if Race <> 22 then
               boUseEffect := TRUE;
         end;
      SM_SKELETON:
         begin
            StartFrame := pm.ActDeath.start;
            EndFrame := StartFrame + pm.ActDeath.frame - 1;
            FrameTime := pm.ActDeath.ftime;
            StartTime := GetTickCount;
         end;
      SM_ALIVE:
         begin
            StartFrame := pm.ActDeath.start + Dir * (pm.ActDeath.frame + pm.ActDeath.skip);
            EndFrame := StartFrame + pm.ActDeath.frame - 1;
            FrameTime := pm.ActDeath.ftime;
            StartTime := GetTickCount;
         end;
   end;
end;

function  TSkeletonOma.GetDefaultFrame (wmode: Boolean): integer;
var
   cf, dr: integer;
   pm: PTMonsterAction;
begin
   Result:=0;//jacky
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   if Death then begin
      // 
      if Appearance in [30..34, 151] then //  ü     
         DownDrawLevel := 1;

      if Skeleton then
         Result := pm.ActDeath.start
      else Result := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip) + (pm.ActDie.frame - 1);
   end else begin
      DefFrameCount := pm.ActStand.frame;
      if CurrentDefFrame < 0 then cf := 0
      else if CurrentDefFrame >= pm.ActStand.frame then cf := 0
      else cf := CurrentDefFrame;
      Result := pm.ActStand.start + Dir * (pm.ActStand.frame + pm.ActStand.skip) + cf;
   end;
end;

procedure  TSkeletonOma.DoLoadSurface;
begin
  if currentframe < 0 then currentframe := 0;
   inherited DoLoadSurface;
   case Race of
      //
      14, 15, 17, 22, 53:
         begin
            if boUseEffect then
               m_EffectSurface := WilMon3.GetImage (DEATHEFFECTBASE + CurrentFrame-StartFrame, ax, ay);
         end;
      23:
         begin
            if CurrentAction = SM_DIGUP then begin
               {if m_BodySurface^<> nil then begin
                 m_BodySurface^.Free;
               end;                   }
               m_BodySurface := nil;
               m_EffectSurface := WilMon4.GetImage (BodyOffset + CurrentFrame, ax, ay);
               boUseEffect := TRUE;
            end else
               boUseEffect := FALSE;
         end;
   end;
end;

procedure  TSkeletonOma.Run;
var
   prv: integer;
   FrameTimetime: longword;
begin
   if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;

   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;

   // ȿ
   RunActSound (CurrentFrame - StartFrame);
   RunFrameAction (CurrentFrame - StartFrame);

   prv := CurrentFrame;
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            // .
            CurrentAction := 0; // Ϸ
            boUseEffect := FALSE;
         end;
      end;
      CurrentDefFrame := 0;
      DefFrameTime := GetTickCount;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if prv <> CurrentFrame then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;

end;


procedure TSkeletonOma.DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean);
var
   idx: integer;
   d: TDirectDrawSurface;
   ceff: TColorEffect;
begin
   if not (Dir in [0..7]) then exit;
   if GetTickCount - m_loadsurfacetime > 60 * 1000 then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface; //bodysurface loadsurface ٽ θ ʾ ޸𸮰 Ǵ  
   end;

   ceff := GetDrawEffectValue;

   if m_BodySurface <> nil then begin
      DrawEffSurface (dsurface, m_BodySurface, dx + Px + ShiftX, dy + Py + ShiftY, blend, ceff);
   end;
   DrawAddBlood(dsurface,dx,dy);
   if boUseEffect then
      if m_EffectSurface <> nil then begin
         DrawBlend (dsurface,
                    dx + ax + ShiftX,
                    dy + ay + ShiftY,
                    m_EffectSurface, DrawADDValue_MagicEffect);
      end;
end;




{============================== TSkeletonOma =============================}

//      ذ (ذ, ūذ, ذ)

{--------------------------}


procedure  TDualAxeOma.Run;
var
   prv: integer;
   FrameTimetime: longword;
   meff: TFlyingAxe;
begin
   if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;

   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;

   // ȿ
   RunActSound (CurrentFrame - StartFrame);
   //Ӹ ؾ 
   RunFrameAction (CurrentFrame - StartFrame);

   prv := CurrentFrame;
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            // .
            CurrentAction := 0; // Ϸ
            boUseEffect := FALSE;
         end;
         if (CurrentAction = SM_FLYAXE) and (CurrentFrame-StartFrame = AXEMONATTACKFRAME-4) then begin
            // ߻
            meff := TFlyingAxe (PlayScene.NewFlyObject (self,
                             XX,
                             yy,
                             MagicTargetX,
                             MagicTargetY,
                             TargetRecog,
                             mtFlyAxe));
            if meff <> nil then begin
               meff.ImgLib := WilMon3;
               case Race of
                  15: meff.FlyImageBase := FLYOMAAXEBASE;
                  22: meff.FlyImageBase := THORNBASE;
               end;
            end;      
         end;
      end;
      CurrentDefFrame := 0;
      DefFrameTime := GetTickCount;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if prv <> CurrentFrame then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;

end;


{============================== TGasKuDeGi =============================}

//         TCatMon : ,   ذ̶ ,  ִϰ .


procedure  TWarriorElfMonster.RunFrameAction (frame: integer); //Ӹ Ưϰ ؾ
var
   meff: TMapEffect;
begin
   if CurrentAction = SM_HIT then begin
      if (frame = 5) and (oldframe <> frame) then begin
         meff := TMapEffect.Create (WARRIORELFFIREBASE + 10 * Dir + 1, 5, XX, yy);
         meff.ImgLib := WilMon18;
         meff.NextFrameTime := 100;
         PlayScene.EffectList.Add (meff);
      end;
      oldframe := frame;
   end;
end;

{============================== TGasKuDeGi =============================}

//         TCatMon : ,   ذ̶ ,  ִϰ .

{--------------------------}


procedure TCatMon.DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean);
var
   idx: integer;
   d: TDirectDrawSurface;
   ceff: TColorEffect;
begin
   if not (Dir in [0..7]) then exit;
   if GetTickCount - m_loadsurfacetime > 60 * 1000 then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface; //m_BodySurface loadsurface ٽ θ ʾ ޸𸮰 Ǵ  
   end;

   ceff := GetDrawEffectValue;
   DrawAddBlood(dsurface,dx,dy);
   if m_BodySurface <> nil then
      DrawEffSurface (dsurface, m_BodySurface, dx + Px + ShiftX, dy + Py + ShiftY, blend, ceff);

end;


{============================= TArcherMon =============================}


procedure TArcherMon.Run;
var
   prv: integer;
   FrameTimetime: longword;
   meff: TFlyingAxe;
begin
   if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;

   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;

   // ȿ
   RunActSound (CurrentFrame - StartFrame);
   //Ӹ ؾ 
   RunFrameAction (CurrentFrame - StartFrame);

   prv := CurrentFrame;
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            // .
            CurrentAction := 0; // Ϸ
            boUseEffect := FALSE;
         end;
         if (CurrentAction = SM_FLYAXE) and (CurrentFrame-StartFrame = 4) then begin
            //ȭ 
//(** 6ġ

            meff := TFlyingArrow (PlayScene.NewFlyObject (self,
                             XX,
                             yy,
                             MagicTargetX,
                             MagicTargetY,
                             TargetRecog,
                             mtFlyArrow));
            if meff <> nil then begin
               meff.ImgLib := WilEffect;
               meff.NextFrameTime := 30;
               meff.FlyImageBase := ARCHERBASE2;
            end;
//**)
(** 
            meff := TFlyingArrow (PlayScene.NewFlyObject (self,
                             XX,
                             .yy,
                             TargetX,
                             TargetY,
                             TargetRecog,
                             mtFlyAxe));
            if meff <> nil then begin
               meff.ImgLib := WMon5Img;
               meff.NextFrameTime := 30;
               meff.FlyImageBase := ARCHERBASE;
            end;
//**)
         end;
      end;
      CurrentDefFrame := 0;
      DefFrameTime := GetTickCount;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if prv <> CurrentFrame then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;

end;


{============================= TZombiDigOut =============================}


procedure TZombiDigOut.RunFrameAction (frame: integer);
var
   clevent: TMapEff;
begin
   if CurrentAction = SM_DIGUP then begin
      if frame = 6 then begin
         clevent := TMapEff.Create (CurrentEvent, XX, yy, ET_DIGOUTZOMBI);
         clevent.Dir := Dir;
         MapEffMan.AddEvent (clevent);
         //pdo.DSurface := WMon6Img.GetImage (ZOMBIDIGUPDUSTBASE+Dir, pdo.px, pdo.py);
      end;
   end;
end;


{============================== THuSuABi =============================}

//      ƺ

{--------------------------}


procedure  THuSuABi.DoLoadSurface;
begin
  if currentframe < 0 then currentframe := 0;
   inherited DoLoadSurface;
   if boUseEffect then
      m_EffectSurface := WilMon3.GetImage (DEATHFIREEFFECTBASE + CurrentFrame-StartFrame, ax, ay);
end;


{============================== TGasKuDeGi =============================}

//       ( )

{--------------------------}


constructor TGasKuDeGi.Create;
begin
   inherited Create;
   AttackEffectSurface := nil;
   DieEffectSurface := nil;
   boUseEffect := FALSE;
   BoUseDieEffect := FALSE;
end;

procedure TGasKuDeGi.CalcActorFrame;
var
   pm: PTMonsterAction;
   actor: TActor;
   haircount, scx, scy, stx, sty: integer;
   meff: TCharEffect;
begin
   CurrentFrame := -1;

   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   case CurrentAction of
      SM_TURN:
         begin
            StartFrame := pm.ActStand.start + Dir * (pm.ActStand.frame + pm.ActStand.skip);
            EndFrame := StartFrame + pm.ActStand.frame - 1;
            FrameTime := pm.ActStand.ftime;
            StartTime := GetTickCount;
            DefFrameCount := pm.ActStand.frame;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_WALK:
         begin
            StartFrame := pm.ActWalk.start + Dir * (pm.ActWalk.frame + pm.ActWalk.skip);
            EndFrame := StartFrame + pm.ActWalk.frame - 1;
            FrameTime := pm.ActWalk.ftime;
            StartTime := GetTickCount;
            MaxTick := pm.ActWalk.UseTick;
            CurTick := 0;
            //WarMode := FALSE;
            MoveStep := 1;
            if CurrentAction = SM_WALK then
               MicroMove(Dir, MoveStep, 0, EndFrame-StartFrame+1)
            else  //sm_backstep
               MicroMove(GetBack(Dir), MoveStep, 0, EndFrame-StartFrame+1);
         end;
      SM_HIT,
      SM_LIGHTING:
         begin
            StartFrame := pm.ActAttack.start + Dir * (pm.ActAttack.frame + pm.ActAttack.skip);
            EndFrame := StartFrame + pm.ActAttack.frame - 1;
            FrameTime := pm.ActAttack.ftime;
            StartTime := GetTickCount;
            //WarMode := TRUE;
            WarModeTime := GetTickCount;
            MicroMove(Dir, 0, 0, 1);
            boUseEffect := TRUE;
            firedir := Dir;
            EffectFrame := StartFrame;
            EffectStart := StartFrame;
            if Race = 20 then EffectEnd := EndFrame + 1
            else EffectEnd := EndFrame;
            EffectStartTime := GetTickCount;
            EffectFrameTime := FrameTime;

            //16  
            actor := PlayScene.FindActor (TargetRecog);
            if actor <> nil then begin
               PlayScene.ScreenXYfromMCXY (XX, yy, scx, scy);
               PlayScene.ScreenXYfromMCXY (actor.XX, actor.yy, stx, sty);
               fire16dir := GetFlyDirection16 (scx, scy, stx, sty);
               //meff := TCharEffect.Create (ZOMBILIGHTINGEXPBASE, 12, actor);  //´  ȿ
               //meff.ImgLib := WMon5Img;
               //meff.NextFrameTime := 50;
               //PlayScene.EffectList.Add (meff);
            end else
               fire16dir := firedir * 2;
         end;
      SM_STRUCK:
         begin
            StartFrame := pm.ActStruck.start + Dir * (pm.ActStruck.frame + pm.ActStruck.skip);
            EndFrame := StartFrame + pm.ActStruck.frame - 1;
            FrameTime := StruckFrameTime; //pm.ActStruck.ftime;
            StartTime := GetTickCount;
         end;
      SM_DEATH:
         begin
            StartFrame := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip);
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            StartFrame := EndFrame; //
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
         end;
      SM_NOWDEATH:
         begin
            StartFrame := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip);
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
            {
            if Race = 40 then
               BoUseDieEffect := TRUE;
            }
            if (Race = 40) or (Race = 65) or (Race = 66) or (Race = 67) or (Race = 68) or (Race = 69) then
               BoUseDieEffect := TRUE;
         end;
      SM_SKELETON:
         begin
            StartFrame := pm.ActDeath.start;
            EndFrame := StartFrame + pm.ActDeath.frame - 1;
            FrameTime := pm.ActDeath.ftime;
            StartTime := GetTickCount;
         end;
   end;
end;

function  TGasKuDeGi.GetDefaultFrame (wmode: Boolean): integer;
var
   cf, dr: integer;
   pm: PTMonsterAction;
begin
   Result:=0;//jacky
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   if Death then begin
      if Skeleton then
         Result := pm.ActDeath.start
      else Result := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip) + (pm.ActDie.frame - 1);
   end else begin
      DefFrameCount := pm.ActStand.frame;
      if CurrentDefFrame < 0 then cf := 0
      else if CurrentDefFrame >= pm.ActStand.frame then cf := 0
      else cf := CurrentDefFrame;
      Result := pm.ActStand.start + Dir * (pm.ActStand.frame + pm.ActStand.skip) + cf;
   end;
end;

procedure  TGasKuDeGi.DoLoadSurface;
begin
  if currentframe < 0 then currentframe := 0;
   inherited DoLoadSurface;
   case Race of
      //Ч
      16://
         begin
            if boUseEffect then
               AttackEffectSurface := WilMon3.GetImage (
                        KUDEGIGASBASE-1 + (firedir * 10) + EffectFrame-EffectStart, // ó  ʰ .
                        ax, ay);
         end;
      20://
         begin
            if boUseEffect then
               AttackEffectSurface := WilMon4.GetImage (
                        COWMONFIREBASE + (firedir * 10) + EffectFrame-EffectStart, //
                        ax, ay);
         end;
      21://
         begin
            if boUseEffect then
               AttackEffectSurface := WilMon4.GetImage (
                        COWMONLIGHTBASE + (firedir * 10) + EffectFrame-EffectStart, //
                        ax, ay);
         end;
      24:
         begin
            if boUseEffect then
               AttackEffectSurface := WilMon1.GetImage (
                        SUPERIORGUARDBASE + (Dir * 8) + EffectFrame-EffectStart, //
                        ax, ay);
         end;

      40://ʬ1
         begin
            if boUseEffect then begin
               AttackEffectSurface := WilMon5.GetImage (
                        ZOMBILIGHTINGBASE + (fire16dir * 10) + EffectFrame-EffectStart, //
                        ax, ay);
            end;
            if BoUseDieEffect then begin
               DieEffectSurface := WilMon5.GetImage (
                        ZOMBIDIEBASE + CurrentFrame-StartFrame, //
                        bx, by);
            end;
         end;
      52://Ш
         begin
            if boUseEffect then
               AttackEffectSurface := WilMon4.GetImage (
                        MOTHPOISONGASBASE + (firedir * 10) + EffectFrame-EffectStart, //
                        ax, ay);
         end;
      53://
         begin
            if boUseEffect then
               AttackEffectSurface := WilMon3.GetImage (
                        DUNGPOISONGASBASE + (firedir * 10) + EffectFrame-EffectStart, //
                        ax, ay);
         end;
      64: begin
        if boUseEffect then begin
          AttackEffectSurface := WilMon20.GetImage (
                        720 + (firedir * 10) + EffectFrame-EffectStart, //
                        ax, ay);
        end;
      end;
      65: begin
        if BoUseDieEffect then begin
          DieEffectSurface:= WilMon20.GetImage (
                        350 + CurrentFrame-StartFrame, bx, by);
        end;
      end;
      66: begin
        if BoUseDieEffect then begin
          DieEffectSurface:= WilMon20.GetImage (
                        1600 + CurrentFrame-StartFrame, bx, by);
        end;
      end;
      67: begin
        if BoUseDieEffect then begin
          DieEffectSurface:= WilMon20.GetImage (
                        1160 + (Dir * 10) + CurrentFrame-StartFrame, bx, by);
        end;
      end;
      68: begin
        if BoUseDieEffect then begin
          DieEffectSurface:= WilMon20.GetImage (
                        1600 + CurrentFrame-StartFrame, bx, by);
        end;
      end;

   end;
end;

procedure  TGasKuDeGi.Run;
var
   prv: integer;
   EffectFrameTimetime, FrameTimetime: longword;
begin
   if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;

   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;

   //
   RunActSound (CurrentFrame - StartFrame);
   RunFrameAction (CurrentFrame - StartFrame);

   if boUseEffect then begin
      if muchAction then EffectFrameTimetime := Round(EffectFrameTime * 2 / 3)
      else EffectFrameTimetime := EffectFrameTime;
      if GetTickCount - EffectStartTime > EffectFrameTimetime then begin
         EffectStartTime := GetTickCount;
         if EffectFrame < EffectEnd then begin
            Inc (EffectFrame);
         end else begin
            boUseEffect := FALSE;
         end;
      end;
   end;

   prv := CurrentFrame;
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            CurrentAction := 0;
            BoUseDieEffect := FALSE;
         end;
      end;
      CurrentDefFrame := 0;
      DefFrameTime := GetTickCount;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if prv <> CurrentFrame then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;

end;


procedure TGasKuDeGi.DrawChr (dsurface: TDirectDrawSurface; dx, dy: integer; blend: Boolean);
var
   idx: integer;
   d: TDirectDrawSurface;
   ceff: TColorEffect;
begin
   if not (Dir in [0..7]) then exit;
   if GetTickCount - m_loadsurfacetime > 60 * 1000 then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface; //m_BodySurface loadsurface ٽ θ ʾ ޸𸮰 Ǵ  
   end;

   ceff := GetDrawEffectValue;
   DrawAddBlood(dsurface,dx,dy);
   if m_BodySurface <> nil then
      DrawEffSurface (dsurface, m_BodySurface, dx + Px + ShiftX, dy + Py + ShiftY, blend, ceff);

end;

procedure TGasKuDeGi.DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer);
var
   idx: integer;
   d: TDirectDrawSurface;
   ceff: TColorEffect;
begin
   if boUseEffect then
     if AttackEffectSurface <> nil then begin
        DrawBlend (dsurface,
                    dx + ax + ShiftX,
                    dy + ay + ShiftY,
                    AttackEffectSurface, DrawADDValue_MagicEffect);
     end;


   if BoUseDieEffect then
      if DieEffectSurface <> nil then begin
         DrawBlend (dsurface,
                    dx + bx + ShiftX,
                    dy + by + ShiftY,
                    DieEffectSurface, DrawADDValue_MagicEffect);
      end;
end;



{-----------------------------------------------------------}

function  TFireCowFaceMon.Light: integer;
var
   l: integer;
begin
   l := ChrLight;
   if l < 2 then begin
      if boUseEffect then
         l := 2;
   end;
   Result := l;
end;

function  TCowFaceKing.Light: integer;
var
   l: integer;
begin
   l := ChrLight;
   if l < 2 then begin
      if boUseEffect then
         l := 2;
   end;
   Result := l;
end;


{-----------------------------------------------------------}

//procedure TZombiLighting.Run;


{-----------------------------------------------------------}


procedure TSculptureMon.CalcActorFrame;
var
   pm: PTMonsterAction;
   haircount: integer;
begin
   CurrentFrame := -1;

   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
   boUseEffect := FALSE;

   case CurrentAction of
      SM_TURN:
         begin
            if (State and STATE_STONE_MODE) <> 0 then begin
               if (Race = 49) then
                  StartFrame := pm.ActDeath.start // + Dir * (pm.ActDeath.frame + pm.ActDeath.skip)
               else
                  StartFrame := pm.ActDeath.start + Dir * (pm.ActDeath.frame + pm.ActDeath.skip);
               EndFrame := StartFrame;
               FrameTime := pm.ActDeath.ftime;
               StartTime := GetTickCount;
               DefFrameCount := pm.ActDeath.frame;
            end else begin
               StartFrame := pm.ActStand.start + Dir * (pm.ActStand.frame + pm.ActStand.skip);
               EndFrame := StartFrame + pm.ActStand.frame - 1;
               FrameTime := pm.ActStand.ftime;
               StartTime := GetTickCount;
               DefFrameCount := pm.ActStand.frame;
            end;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_WALK, SM_BACKSTEP:
         begin
            StartFrame := pm.ActWalk.start + Dir * (pm.ActWalk.frame + pm.ActWalk.skip);
            EndFrame := StartFrame + pm.ActWalk.frame - 1;
            FrameTime := pm.ActWalk.ftime;
            StartTime := GetTickCount;
            MaxTick := pm.ActWalk.UseTick;
            CurTick := 0;
            //WarMode := FALSE;
            MoveStep := 1;
            if CurrentAction = SM_WALK then
               MicroMove(Dir, MoveStep, 0, EndFrame-StartFrame+1)
            else  //sm_backstep
               MicroMove(GetBack(Dir), MoveStep, 0, EndFrame-StartFrame+1);
         end;
      SM_DIGUP: //ȱ , SM_DIGUP,  .
         begin
            if (Race = 49) then begin
               StartFrame := pm.ActDeath.start;
            end else begin
               StartFrame := pm.ActDeath.start + Dir * (pm.ActDeath.frame + pm.ActDeath.skip);
            end;
            EndFrame := StartFrame + pm.ActDeath.frame - 1;
            FrameTime := pm.ActDeath.ftime;
            StartTime := GetTickCount;
            //WarMode := FALSE;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_HIT:
         begin
            StartFrame := pm.ActAttack.start + Dir * (pm.ActAttack.frame + pm.ActAttack.skip);
            EndFrame := StartFrame + pm.ActAttack.frame - 1;
            FrameTime := pm.ActAttack.ftime;
            StartTime := GetTickCount;
            if Race = 49 then begin
               boUseEffect := TRUE;
               firedir := Dir;
               EffectFrame := 0; //startframe;
               EffectStart := 0; //startframe;
               EffectEnd := EffectStart + 8;
               EffectStartTime := GetTickCount;
               EffectFrameTime := FrameTime;
            end;
            MicroMove(Dir, 0, 0, 1);
         end;
      SM_STRUCK:
         begin
            StartFrame := pm.ActStruck.start + Dir * (pm.ActStruck.frame + pm.ActStruck.skip);
            EndFrame := StartFrame + pm.ActStruck.frame - 1;
            FrameTime := StruckFrameTime; //pm.ActStruck.ftime;
            StartTime := GetTickCount;
         end;
      SM_DEATH:
         begin
            StartFrame := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip);
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            StartFrame := EndFrame; //
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
         end;
      SM_NOWDEATH:
         begin
            StartFrame := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip);
            EndFrame := StartFrame + pm.ActDie.frame - 1;
            FrameTime := pm.ActDie.ftime;
            StartTime := GetTickCount;
         end;
   end;
end;

procedure  TSculptureMon.DoLoadSurface;
begin
   inherited DoLoadSurface;
   case Race of
      48, 49:
         begin
            if boUseEffect then
               AttackEffectSurface := WilMon7.GetImage (
                        SCULPTUREFIREBASE + (firedir * 10) + EffectFrame-EffectStart, //
                        ax, ay);
         end;
   end;
end;

function  TSculptureMon.GetDefaultFrame (wmode: Boolean): integer;
var
   cf, dr: integer;
   pm: PTMonsterAction;
begin
   Result:=0;//jacky
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   if Death then begin
      Result := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip) + (pm.ActDie.frame - 1);
   end else begin
      if (State and STATE_STONE_MODE) <> 0 then begin
         case Race of
            47: Result := pm.ActDeath.start + Dir * (pm.ActDeath.frame + pm.ActDeath.skip);
            48, 49: Result := pm.ActDeath.start;
         end;
      end else begin
         DefFrameCount := pm.ActStand.frame;
         if CurrentDefFrame < 0 then cf := 0
         else if CurrentDefFrame >= pm.ActStand.frame then cf := 0
         else cf := CurrentDefFrame;
         Result := pm.ActStand.start + Dir * (pm.ActStand.frame + pm.ActStand.skip) + cf;
      end;
   end;
end;

procedure TSculptureMon.DrawEff (dsurface: TDirectDrawSurface; dx, dy: integer);
var
   idx: integer;
   d: TDirectDrawSurface;
   ceff: TColorEffect;
begin
   if boUseEffect then
      if AttackEffectSurface <> nil then begin
         DrawBlend (dsurface,
                    dx + ax + ShiftX,
                    dy + ay + ShiftY,
                    AttackEffectSurface, DrawADDValue_MagicEffect);
      end;
end;

procedure TSculptureMon.Run;
var
   EffectFrameTimetime, FrameTimetime: longword;
begin
   if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;
   if boUseEffect then begin
      EffectFrameTimetime := EffectFrameTime;
      if GetTickCount - EffectStartTime > EffectFrameTimetime then begin
         EffectStartTime := GetTickCount;
         if EffectFrame < EffectEnd then begin
            Inc (EffectFrame);
         end else begin
            boUseEffect := FALSE;
         end;
      end;
   end;
   inherited Run;
end;


{ TBanyaGuardMon }

procedure TBanyaGuardMon.CalcActorFrame;
var
   pm: PTMonsterAction;
begin
   CurrentFrame := -1;
   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
   case CurrentAction of
     SM_HIT: begin
       StartFrame := pm.ActAttack.start + Dir * (pm.ActAttack.frame + pm.ActAttack.skip);
       EndFrame := StartFrame + pm.ActAttack.frame - 1;
       FrameTime := pm.ActAttack.ftime;
       StartTime := GetTickCount;
       WarModeTime := GetTickCount;
       MicroMove(Dir, 0, 0, 1);
       boUseEffect := TRUE;
       EffectFrame := StartFrame;
       EffectStart := StartFrame;
       EffectEnd := EndFrame;
       EffectStartTime := GetTickCount;
       EffectFrameTime := FrameTime;
     end;
     SM_LIGHTING: begin
       StartFrame := pm.ActCritical.start + Dir * (pm.ActCritical.frame + pm.ActCritical.skip);
       EndFrame := StartFrame + pm.ActCritical.frame - 1;
       FrameTime := pm.ActCritical.ftime;
       StartTime := GetTickCount;
       CurMagicFrame:=0;
       boUseMagic:=True;
       WarModeTime := GetTickCount;
       MicroMove(Dir, 0, 0, 1);
       if (Race = 71) then begin
         boUseEffect := TRUE;
         EffectFrame := StartFrame;
         EffectStart := StartFrame;
         EffectEnd := EndFrame;
         EffectStartTime := GetTickCount;
         EffectFrameTime := FrameTime;
       end;
     end;
     else begin
       inherited;
     end;
   end;

end;

constructor TBanyaGuardMon.Create;
begin
  inherited;
  n26C:=nil;
end;

procedure TBanyaGuardMon.DrawEff(dsurface: TDirectDrawSurface; dx,
  dy: integer);
begin
  inherited;
  if boUseEffect and (n26C <> nil) then begin
    DrawBlend (dsurface,dx + ax + ShiftX,dy + ay + ShiftY,n26C, DrawADDValue_MagicEffect);
  end;
end;

procedure TBanyaGuardMon.DoLoadSurface;
begin
  if currentframe < 0 then currentframe := 0;
  inherited DoLoadSurface;
  if bo260 then begin
    case Race of
      70: begin
        AttackEffectSurface := WilMon20.GetImage (
                        2320 + CurrentFrame - StartFrame,
                        n264, n268);

      end;
      71: begin
        AttackEffectSurface := WilMon21.GetImage (
                        2870 + (Dir * 10) + CurrentFrame - StartFrame,
                        n264, n268);
      end;
      78: begin
        AttackEffectSurface := WilMon22.GetImage (
                        3120 + (Dir * 4) + CurrentFrame - StartFrame,
                        n264, n268);
      end;
    end;
  end else begin
    if boUseEffect then begin
      case Race of
        70: begin
          if CurrentAction = SM_HIT then begin
            n26C := WilMon21.GetImage (
                            2230 + (Dir * 10) + EffectFrame - EffectStart,
                            ax, ay);
          end;
        end;
        71: begin
          case CurrentAction of
            SM_HIT: begin
              n26C := WilMon21.GetImage (
                            2780 + (Dir * 10) + EffectFrame - EffectStart,
                            ax, ay);
            end;
            SM_FLYAXE ..SM_LIGHTING: begin
              n26C := WilMon21.GetImage (
                            2960 + (Dir * 10) + EffectFrame - EffectStart,
                            ax, ay);
            end;
          end;
        end;
        72: begin
          if CurrentAction = SM_HIT then begin
            n26C := WilMon21.GetImage (
                            3490 + (Dir * 10) + EffectFrame - EffectStart,
                            ax, ay);
          end;
        end;
        78: begin
          if CurrentAction = SM_HIT then begin
            n26C := WilMon22.GetImage (
                            3440 + (Dir * 10) + EffectFrame - EffectStart,
                            ax, ay);
          end;
        end;
      end;
    end;
  end;
end;

procedure TBanyaGuardMon.Run;
var
   prv: integer;
   EffectFrameTimetime, FrameTimetime: longword;
   bo11:Boolean;
begin
  if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;
   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;

   RunActSound (CurrentFrame - StartFrame);
   RunFrameAction (CurrentFrame - StartFrame);

   if boUseEffect then begin
      if muchAction then EffectFrameTimetime := Round(EffectFrameTime * 2 / 3)
      else EffectFrameTimetime := EffectFrameTime;
      if GetTickCount - EffectStartTime > EffectFrameTimetime then begin
         EffectStartTime := GetTickCount;
         if EffectFrame < EffectEnd then begin
            Inc (EffectFrame);
         end else begin
            boUseEffect := FALSE;
         end;
      end;
   end;

   prv := CurrentFrame;
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            CurrentAction := 0;
            boUseEffect := FALSE;
            bo260:=False;            
         end;
         if CurrentAction = SM_LIGHTING then begin
           if (CurrentFrame - StartFrame) = 4 then begin
             if (Race = 70) or (Race = 81) then begin
               PlayScene.AddNewMagic (Self,MagicNum,8,XX,yy,MagicTargetX,MagicTargetY,TargetRecog,mtThunder,False,30,bo11);
               PlaySound(10112);
             end;
             if (Race = 71) then begin
               PlayScene.AddNewMagic (Self,1,1,XX,yy,MagicTargetX,MagicTargetY,TargetRecog,mtFly,True,30,bo11);
               PlaySound(10012);
             end;
             if (Race = 72) then begin
               PlayScene.AddNewMagic (Self,11,32,XX,yy,MagicTargetX,MagicTargetY,TargetRecog,mt13,False,30,bo11);
               PlaySound(2276);
             end;
             if (Race = 78) then begin
               PlayScene.AddNewMagic (Self,11,37,XX,yy,XX,yy,RecogId,mt13,False,30,bo11);
               PlaySound(2396);
             end;
           end;
         end;
         CurrentDefFrame := 0;
         DefFrameTime := GetTickCount;
      end;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if prv <> CurrentFrame then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;
end;

{ TElectronicScolpionMon }

procedure TElectronicScolpionMon.CalcActorFrame;
var
   pm: PTMonsterAction;
begin
   CurrentFrame := -1;
   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
   case CurrentAction of
     SM_HIT: begin
       StartFrame := pm.ActAttack.start + Dir * (pm.ActAttack.frame + pm.ActAttack.skip);
       EndFrame := StartFrame + pm.ActAttack.frame - 1;
       FrameTime := pm.ActAttack.ftime;
       StartTime := GetTickCount;
       WarModeTime := GetTickCount;
       MicroMove(Dir, 0, 0, 1);
     end;
     SM_LIGHTING: begin
       StartFrame := pm.ActCritical.start + Dir * (pm.ActCritical.frame + pm.ActCritical.skip);
       EndFrame := StartFrame + pm.ActCritical.frame - 1;
       FrameTime := pm.ActCritical.ftime;
       StartTime := GetTickCount;
       WarModeTime := GetTickCount;
       MicroMove(Dir, 0, 0, 1);
       boUseEffect := TRUE;
       firedir := Dir;
       EffectFrame := StartFrame;
       EffectStart := StartFrame;
       EffectEnd := EndFrame;
       EffectStartTime := GetTickCount;
       EffectFrameTime := FrameTime;
     end;
     else begin
       inherited;
     end;
   end;
end;

procedure TElectronicScolpionMon.DoLoadSurface;
begin
  inherited;
  {
  if (Race = 60) and BoUseEffect and (CurrentAction = SM_SPELL) then begin
    AttackEffectSurface := WMon19Img.GetImage (
                        430 + (firedir * 10) + EffectFrame - EffectStart,
                        ax, ay);
  }
  if (Race = 60) and boUseEffect and (CurrentAction = SM_LIGHTING) then begin
    AttackEffectSurface := WilMon19.GetImage (
                        430 + (firedir * 10) + EffectFrame - EffectStart,
                        ax, ay);
  end;
end;

{ TBossPigMon }

procedure TBossPigMon.DoLoadSurface;
begin
  inherited;
  if (Race = 61) and boUseEffect then begin
    AttackEffectSurface := WilMon19.GetImage (
                        860 + (firedir * 10) + EffectFrame - EffectStart,
                        ax, ay);
  end;
end;

{ TKingOfSculpureKingMon }

procedure TKingOfSculpureKingMon.CalcActorFrame;
var
   pm: PTMonsterAction;
begin
   CurrentFrame := -1;
   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
   case CurrentAction of
     SM_HIT: begin
       StartFrame := pm.ActAttack.start + Dir * (pm.ActAttack.frame + pm.ActAttack.skip);
       EndFrame := StartFrame + pm.ActAttack.frame - 1;
       FrameTime := pm.ActAttack.ftime;
       StartTime := GetTickCount;
       WarModeTime := GetTickCount;
       MicroMove(Dir, 0, 0, 1);
       boUseEffect := TRUE;
       firedir := Dir;
       EffectFrame := StartFrame;
       EffectStart := StartFrame;
       EffectEnd := EndFrame;
       EffectStartTime := GetTickCount;
       EffectFrameTime := FrameTime;
     end;
     SM_LIGHTING: begin
       StartFrame := pm.ActCritical.start + Dir * (pm.ActCritical.frame + pm.ActCritical.skip);
       EndFrame := StartFrame + pm.ActCritical.frame - 1;
       FrameTime := pm.ActCritical.ftime;
       StartTime := GetTickCount;
       WarModeTime := GetTickCount;
       MicroMove(Dir, 0, 0, 1);
       boUseEffect := TRUE;
       firedir := Dir;
       EffectFrame := StartFrame;
       EffectStart := StartFrame;
       EffectEnd := EndFrame;
       EffectStartTime := GetTickCount;
       EffectFrameTime := FrameTime;
     end;
     SM_NOWDEATH: begin
       StartFrame := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip);
       EndFrame := StartFrame + pm.ActDie.frame - 1;
       FrameTime := pm.ActDie.ftime;
       StartTime := GetTickCount;
       EffectFrame := pm.ActDie.start;
       EffectStart := pm.ActDie.start;
       EffectEnd := pm.ActDie.start + pm.ActDie.frame - 1;
       EffectStartTime := GetTickCount;
       EffectFrameTime := FrameTime;
       boUseEffect := TRUE;
     end;
     else begin
      inherited;
     end;     
   end;
end;

procedure TKingOfSculpureKingMon.DoLoadSurface;
begin
  inherited;
  if (Race = 62) and boUseEffect then begin
    case CurrentAction of
      SM_HIT: begin
        AttackEffectSurface := WilMon19.GetImage (
                        1490 + (firedir * 10) + EffectFrame - EffectStart,
                        ax, ay);
      end;
      SM_LIGHTING: begin
        AttackEffectSurface := WilMon19.GetImage (
                        1380 + (firedir * 10) + EffectFrame - EffectStart,
                        ax, ay);
      end;
      SM_NOWDEATH: begin
        AttackEffectSurface := WilMon19.GetImage (
                        1470 + EffectFrame - EffectStart,
                        ax, ay);
      end;
    end;

  end;
end;

{ TSkeletonArcherMon }

procedure TSkeletonArcherMon.CalcActorFrame;
begin
  inherited;
  if (CurrentAction = SM_NOWDEATH) and (Race <> 72) then begin
    bo260:=True;
  end;
end;

procedure TSkeletonArcherMon.DrawEff(dsurface: TDirectDrawSurface; dx,
  dy: integer);
begin
  inherited;
  if bo260 and (AttackEffectSurface <> nil) then begin
    DrawBlend (dsurface,dx + n264 + ShiftX,dy + n268 + ShiftY,AttackEffectSurface, DrawADDValue_MagicEffect);
  end;
end;

procedure TSkeletonArcherMon.DoLoadSurface;
begin
  inherited;
  if bo260 then begin
        AttackEffectSurface := WilMon20.GetImage (
                        1600 + EffectFrame - EffectStart,
                        n264, n268);
  end;
end;

procedure TSkeletonArcherMon.Run;
var
  FrameTimetime: longword;
begin

  if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
  else FrameTimetime := FrameTime;
  if CurrentAction <> 0 then begin
    if (GetTickCount - StartTime) > FrameTimetime then begin
      if CurrentFrame < EndFrame then begin
      end else begin
        CurrentAction:=0;
        bo260:=False;
      end;
    end;
  end;

  inherited;
end;

{ TFlyingSpider }

procedure TFlyingSpider.CalcActorFrame;
var
  Eff8:TNormalDrawEffect;
begin
  inherited;
  if CurrentAction = SM_NOWDEATH then begin
    Eff8:=TNormalDrawEffect.Create(XX,yy,WilMon12,1420,20,FrameTime,True);
    if Eff8 <> nil then begin
      Eff8.MagOwner:=MySelf;
      PlayScene.EffectList.Add(Eff8);
    end;
  end;
end;

{ TExplosionSpider }

procedure TExplosionSpider.CalcActorFrame;
begin
  inherited;
  case CurrentAction of
    SM_HIT: begin
      boUseEffect:=False;
    end;
    SM_NOWDEATH: begin
      EffectStart:=StartFrame;
      EffectFrame:=StartFrame;
      EffectStartTime:=GetTickCount();
      EffectFrameTime:=FrameTime;
      EffectEnd:=EndFrame;
      boUseEffect:=True;
    end;
  end;
end;

procedure TExplosionSpider.DoLoadSurface;
begin
  inherited;
  if boUseEffect then
    AttackEffectSurface := WilMon14.GetImage (
                        730 + EffectFrame-EffectStart,
                        ax, ay);
end;

{ TSkeletonKingMon }

procedure TSkeletonKingMon.CalcActorFrame;
var
   pm: PTMonsterAction;
   actor: TActor;
   haircount, scx, scy, stx, sty: integer;
   meff: TCharEffect;
begin
   CurrentFrame := -1;

   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;

   case CurrentAction of
     SM_BACKSTEP,SM_WALK: begin
       StartFrame := pm.ActWalk.start + Dir * (pm.ActWalk.frame + pm.ActWalk.skip);
       EndFrame := StartFrame + pm.ActWalk.frame - 1;
       FrameTime := pm.ActWalk.ftime;
       StartTime := GetTickCount;
       EffectFrame:=pm.ActWalk.start;
       EffectStart:=pm.ActWalk.start;
       EffectEnd:=pm.ActWalk.start + pm.ActWalk.frame -1;
       EffectStartTime:=GetTickCount();
       EffectFrameTime:=FrameTime;
       boUseEffect:=True;
       MaxTick := pm.ActWalk.UseTick;
       CurTick := 0;
            //WarMode := FALSE;
       MoveStep := 1;
       if CurrentAction = SM_WALK then
         MicroMove(Dir, MoveStep, 0, EndFrame-StartFrame+1)
       else
         MicroMove(GetBack(Dir), MoveStep, 0, EndFrame-StartFrame+1);
     end;
     SM_HIT: begin
       StartFrame := pm.ActAttack.start + Dir * (pm.ActAttack.frame + pm.ActAttack.skip);
       EndFrame := StartFrame + pm.ActAttack.frame - 1;
       FrameTime := pm.ActAttack.ftime;
       StartTime := GetTickCount;
       WarModeTime:= GetTickCount;
       MicroMove(Dir, 0, 0, 1);
       boUseEffect := TRUE;
       firedir := Dir;
       EffectFrame:=StartFrame;
       EffectStart:=StartFrame;
       EffectEnd:=EndFrame;
       EffectStartTime:=GetTickCount();
       EffectFrameTime := FrameTime;
     end;
     SM_FLYAXE: begin
       StartFrame := pm.ActCritical.start + Dir * (pm.ActCritical.frame + pm.ActCritical.skip);
       EndFrame := StartFrame + pm.ActCritical.frame - 1;
       FrameTime := pm.ActCritical.ftime;
       StartTime := GetTickCount;
       WarModeTime:= GetTickCount;
       MicroMove(Dir, 0, 0, 1);
       boUseEffect := TRUE;
       firedir := Dir;
       EffectFrame:=StartFrame;
       EffectStart:=StartFrame;
       EffectEnd:=EndFrame;
       EffectStartTime:=GetTickCount();
       EffectFrameTime := FrameTime;
     end;
     SM_LIGHTING: begin
       StartFrame := 80 + pm.ActAttack.start + Dir * (pm.ActAttack.frame + pm.ActAttack.skip);
       EndFrame := StartFrame + pm.ActAttack.frame - 1;
       FrameTime := pm.ActAttack.ftime;
       StartTime := GetTickCount;
       WarModeTime:= GetTickCount;
       MicroMove(Dir, 0, 0, 1);
       boUseEffect := TRUE;
       firedir := Dir;
       EffectFrame:=StartFrame;
       EffectStart:=StartFrame;
       EffectEnd:=EndFrame;
       EffectStartTime:=GetTickCount();
       EffectFrameTime := FrameTime;
     end;
     SM_STRUCK: begin
       StartFrame := pm.ActStruck.start + Dir * (pm.ActStruck.frame + pm.ActStruck.skip);
       EndFrame := StartFrame + pm.ActStruck.frame - 1;
       FrameTime := pm.ActStruck.ftime;
       StartTime := GetTickCount;
       EffectFrame:=pm.ActStruck.start;
       EffectStart:=pm.ActStruck.start;
       EffectEnd:=pm.ActStruck.start + pm.ActStruck.frame -1;
       EffectStartTime:=GetTickCount;
       EffectFrameTime:=FrameTime;
       boUseEffect := TRUE;
     end;
     SM_NOWDEATH: begin
       StartFrame := pm.ActDie.start + Dir * (pm.ActDie.frame + pm.ActDie.skip);
       EndFrame := StartFrame + pm.ActDie.frame - 1;
       FrameTime := pm.ActDie.ftime;
       StartTime := GetTickCount;
       EffectFrame := pm.ActDie.start;
       EffectStart := pm.ActDie.start;
       EffectEnd := pm.ActDie.start + pm.ActDie.frame - 1;
       EffectStartTime := GetTickCount;
       EffectFrameTime := FrameTime;
       boUseEffect := TRUE;
     end;
     else begin
       inherited;
     end;
   end;
end;

procedure TSkeletonKingMon.DoLoadSurface;
begin
  inherited;
   if (Race = 63) and boUseEffect then begin
     case CurrentAction of
       SM_WALK: begin
         AttackEffectSurface := WilMon20.GetImage (
                                3060 + (Dir * 10) + EffectFrame-EffectStart,
                                ax,
                                ay);
       end;
       SM_HIT: begin
         AttackEffectSurface := WilMon20.GetImage (
                                3140 + (firedir * 10) + EffectFrame-EffectStart,
                                ax,
                                ay);
       end;
       SM_FLYAXE: begin
         AttackEffectSurface := WilMon20.GetImage (
                                3300 + (firedir * 10) + EffectFrame-EffectStart,
                                ax,
                                ay);
       end;
       SM_LIGHTING: begin
         AttackEffectSurface := WilMon20.GetImage (
                                3220 + (firedir * 10) + EffectFrame-EffectStart,
                                ax,
                                ay);
       end;
       SM_STRUCK: begin
         AttackEffectSurface := WilMon20.GetImage (
                                3380 + (Dir * 2) + EffectFrame-EffectStart,
                                ax,
                                ay);       
       end;
       SM_NOWDEATH: begin
         AttackEffectSurface := WilMon20.GetImage (
                                3400 + (Dir * 4) + EffectFrame-EffectStart,
                                ax,
                                ay);
       end;
     end;
   end;
end;

procedure TSkeletonKingMon.Run;
var
   prv: integer;
   EffectFrameTimetime, FrameTimetime: longword;
   meff: TFlyingFireBall;
begin
   if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;

   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;

   //
   RunActSound (CurrentFrame - StartFrame);
   RunFrameAction (CurrentFrame - StartFrame);

   if boUseEffect then begin
      if muchAction then EffectFrameTimetime := Round(EffectFrameTime * 2 / 3)
      else EffectFrameTimetime := EffectFrameTime;
      if GetTickCount - EffectStartTime > EffectFrameTimetime then begin
         EffectStartTime := GetTickCount;
         if EffectFrame < EffectEnd then begin
            Inc (EffectFrame);
         end else begin
            boUseEffect := FALSE;
         end;
      end;
   end;

   prv := CurrentFrame;
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            CurrentAction := 0;
            boUseEffect:=False;
            BoUseDieEffect := FALSE;
         end;

         if (CurrentAction = SM_FLYAXE) and (CurrentFrame-StartFrame = 4) then begin
            meff := TFlyingFireBall (PlayScene.NewFlyObject (self,
                             XX,
                             yy,
                             MagicTargetX,
                             MagicTargetY,
                             TargetRecog,
                             mt12));
            if meff <> nil then begin
               meff.ImgLib := WilMon20;
               meff.NextFrameTime := 40;
               meff.FlyImageBase := 3573;
            end;
         end;
        CurrentDefFrame := 0;
        DefFrameTime := GetTickCount;
      end;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if prv <> CurrentFrame then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;
end;

{ TStoneMonster }

procedure TStoneMonster.CalcActorFrame;
var
   pm: PTMonsterAction;
begin
   boUseMagic:=False;
   CurrentFrame := -1;
   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
   Dir:=0;
   case CurrentAction of
     SM_TURN: begin
       StartFrame := pm.ActStand.start;
       EndFrame := StartFrame + pm.ActStand.frame - 1;
       FrameTime := pm.ActStand.ftime;
       StartTime := GetTickCount;
       DefFrameCount:=pm.ActStand.frame;
       if not boUseEffect then begin
         boUseEffect:=True;
         EffectFrame := StartFrame;
         EffectStart := StartFrame;
         EffectEnd := EndFrame;
         EffectStartTime := GetTickCount;
         EffectFrameTime := 300;
       end;
     end;
     SM_HIT: begin
       StartFrame := pm.ActAttack.start;
       EndFrame := StartFrame + pm.ActAttack.frame - 1;
       FrameTime := pm.ActAttack.ftime;
       StartTime := GetTickCount;
       WarModeTime := GetTickCount;
       if not boUseEffect then begin
         boUseEffect:=True;
         EffectFrame := StartFrame;
         EffectStart := StartFrame;
         EffectEnd := StartFrame + 25;
         EffectStartTime := GetTickCount;
         EffectFrameTime := 150;
       end;
     end;
     SM_STRUCK: begin
       StartFrame := pm.ActStruck.start;
       EndFrame := StartFrame + pm.ActStruck.frame - 1;
       FrameTime := pm.ActStruck.ftime;
       StartTime := GetTickCount;
     end;
     SM_DEATH: begin
       StartFrame := pm.ActDie.start;
       EndFrame := StartFrame + pm.ActDie.frame - 1;
       FrameTime := pm.ActDie.ftime;
       StartTime := GetTickCount;
     end;
     SM_NOWDEATH: begin
       StartFrame := pm.ActDie.start;
       EndFrame := StartFrame + pm.ActDie.frame - 1;
       FrameTime := pm.ActDie.ftime;
       StartTime := GetTickCount;
       bo260:=True;
       EffectFrame := StartFrame;
       EffectStart := StartFrame;
       EffectEnd := StartFrame + 19;
       EffectStartTime := GetTickCount;
       EffectFrameTime := 80;
     end;
   end;
end;

constructor TStoneMonster.Create;
begin
  inherited;
  n26C:=nil;
  boUseEffect:=False;
  bo260:=False;
end;

procedure TStoneMonster.DrawEff(dsurface: TDirectDrawSurface; dx,
  dy: integer);
begin
  inherited;
  if boUseEffect and (n26C <> nil) then begin
    DrawBlend (dsurface,
               dx + ax + ShiftX,
               dy + ay + ShiftY,
               n26C, DrawADDValue_MagicEffect);
  end;
end;

procedure TStoneMonster.DoLoadSurface;
begin
  inherited  DoLoadSurface;
  if bo260 then begin
    case Race of
      75: begin
        AttackEffectSurface := WilMon22.GetImage (
                        2530 + EffectFrame - EffectStart,
                        n264, n268);
      end;
      77: begin
        AttackEffectSurface := WilMon22.GetImage (
                        2660 + EffectFrame - EffectStart,
                        n264, n268);      
      end;
    end;
  end else begin
    if boUseEffect then
      case Race of
        75: begin
          case CurrentAction of
            SM_HIT: begin
              n26C := WilMon22.GetImage (
                            2500 + EffectFrame - EffectStart,
                            ax, ay);
            end;
            SM_TURN: begin
              n26C := WilMon22.GetImage (
                            2490 + EffectFrame - EffectStart,
                            ax, ay);
            end;
          end;
        end;
        77: begin
          case CurrentAction of
            SM_HIT: begin
              n26C := WilMon22.GetImage (
                            2630 + EffectFrame - EffectStart,
                            ax, ay);
            end;
            SM_TURN: begin
              n26C := WilMon22.GetImage (
                            2620 + EffectFrame - EffectStart,
                            ax, ay);
            end;
          end;
        end;
      end;
  end;
end;

procedure TStoneMonster.Run;
var
   prv: integer;
   EffectFrameTimetime: longword;
   FrameTimetime: longword;
begin
  if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;
   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;

   RunActSound (CurrentFrame - StartFrame);
   RunFrameAction (CurrentFrame - StartFrame);

   if boUseEffect or bo260 then begin
      if muchAction then EffectFrameTimetime := Round(EffectFrameTime * 2 / 3)
      else EffectFrameTimetime := EffectFrameTime;
      if GetTickCount - EffectStartTime > EffectFrameTimetime then begin
         EffectStartTime := GetTickCount;
         if EffectFrame < EffectEnd then begin
            Inc (EffectFrame);
         end else begin
            boUseEffect := FALSE;
            bo260:=False;
         end;
      end;
   end;

   prv := CurrentFrame;
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            CurrentAction := 0;
         end;
         CurrentDefFrame := 0;
         DefFrameTime := GetTickCount;
      end;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if (prv <> CurrentFrame) or (prv <> EffectFrame) then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;
end;

{ TAngel }

procedure TAngel.DrawChr(dsurface: TDirectDrawSurface; dx, dy: integer;
  blend: Boolean);
var
  ceff: TColorEffect;
begin
  if not (Dir in [0..7]) then exit;
   if GetTickCount - m_loadsurfacetime > 60 * 1000 then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface; //m_BodySurface loadsurface ٽ θ ʾ ޸𸮰 Ǵ  
   end;


  if n278 <> nil then begin
    DrawBlend (dsurface, dx + n270 + ShiftX, dy + n274 + ShiftY, n278, DrawADDValue_MagicEffect);
  end;
  //inherited;

  ceff := GetDrawEffectValue;
  //ceff := ceBright;

  if m_BodySurface <> nil then begin
    DrawEffSurface (dsurface, m_BodySurface, dx + Px + ShiftX, dy + Py + ShiftY, blend, ceff);
  end;

  
end;

procedure TAngel.DoLoadSurface;
var
   mimg: TTilFile;
begin
  if currentframe < 0 then currentframe := 0;
   mimg := GetMonImg (Appearance);
   if mimg <> nil then begin
     if (not ReverseFrame) then begin
       m_BodySurface := mimg.GetImage (1280 + CurrentFrame, Px, Py);
       n278 := mimg.GetImage (920 + CurrentFrame, n270, n274);
     end else begin
       m_BodySurface := mimg.GetImage (
                            1280 + EndFrame - (CurrentFrame-StartFrame),
                            Px, Py);
       n278 := mimg.GetImage (
                            920 + EndFrame - (CurrentFrame-StartFrame),
                            n270, n274);
     end;
   end;
end;

{ TPBOMA6Mon }

procedure TPBOMA6Mon.Run;
var
   prv: integer;
   EffectFrameTimetime, FrameTimetime: longword;
   meff: TFlyingAxe;
begin
   if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;

   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;

   RunActSound (CurrentFrame - StartFrame);
   RunFrameAction (CurrentFrame - StartFrame);
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            CurrentAction := 0;
            boUseEffect := FALSE;
         end;
         if (CurrentAction = SM_FLYAXE) and (CurrentFrame - StartFrame = 4) then begin
            meff := TFlyingAxe (PlayScene.NewFlyObject (self,
                             XX,
                             yy,
                             MySelf.AutoMoveX,
                             MySelf.AutoMoveY,
                             TargetRecog,
                             mt16));
            if meff <> nil then begin
               meff.ImgLib := WilMon22;
               meff.NextFrameTime := 50;
               meff.FlyImageBase:=1989;
            end;
         end;
      end;
      CurrentDefFrame := 0;
      DefFrameTime := GetTickCount;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if prv <> CurrentFrame then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;

end;

{ TDragonStatue }

procedure TDragonStatue.CalcActorFrame;
var
   pm: PTMonsterAction;
begin
   Dir:=0;
   CurrentFrame := -1;
   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
   case CurrentAction of
     SM_DIGUP: begin
       MicroMove(0, 0, 0, 1);
       StartFrame:=0;
       EndFrame:=9;
       FrameTime:=100;
       StartTime:=GetTickCount;
     end;
     SM_LIGHTING: begin
       StartFrame:=0;
       EndFrame:=9;
       FrameTime:=100;
       StartTime:=GetTickCount;
       boUseEffect:=True;
       EffectStart:=0;
       EffectFrame:=0;
       EffectEnd:=9;
       EffectStartTime:=GetTickCount;
       EffectFrameTime:=100;
     end;
   end;
end;

constructor TDragonStatue.Create;
begin
  inherited;
  n26C:=nil;
end;

procedure TDragonStatue.DrawEff(dsurface: TDirectDrawSurface; dx,
  dy: integer);
begin
  inherited;
  if boUseEffect and (m_EffectSurface <> nil) then begin
    DrawBlend (dsurface,dx + ax + ShiftX,dy + ay + ShiftY,m_EffectSurface, DrawADDValue_MagicEffect);
  end;
end;

procedure TDragonStatue.DoLoadSurface;
var
  mimg:TTilFile;
begin
  if currentframe < 0 then currentframe := 0;
   mimg :=WilDragon;
   if mimg <> nil then
     m_BodySurface := mimg.GetImage (GetOffset (Appearance) + CurrentFrame, Px, Py);
   if boUseEffect then begin
     case Race of
       84..86: begin
         m_EffectSurface:= mimg.GetImage (310 + EffectFrame, ax, ay);
       end;
       87..89: begin
         m_EffectSurface:= mimg.GetImage (330 + EffectFrame, ax, ay);
       end;
     end;
   end;
end;

procedure TDragonStatue.Run;
var
   prv: integer;
   dwEffectFrameTime, FrameTimetime: longword;
   bo11:Boolean;
begin
  Dir:=0;
   if (CurrentAction = SM_WALK) or
      (CurrentAction = SM_BACKSTEP) or
      (CurrentAction = SM_RUN) or
      (CurrentAction = SM_HORSERUN) then exit;

   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;

   if boUseEffect then begin
      if muchAction then dwEffectFrameTime := Round(EffectFrameTime * 2 / 3)
      else dwEffectFrameTime := EffectFrameTime;
      if GetTickCount - EffectStartTime > dwEffectFrameTime then begin
         EffectStartTime := GetTickCount;
         if EffectFrame < EffectEnd then begin
            Inc (EffectFrame);
         end else begin
            boUseEffect := FALSE;
         end;
      end;
   end;

   prv := CurrentFrame;
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            CurrentAction := 0;
            boUseEffect := FALSE;
            bo260:=False;
         end;
         if (CurrentAction = SM_LIGHTING) and (CurrentFrame = 4) then begin
           PlayScene.AddNewMagic (Self,74,74,XX,yy,MagicTargetX,MagicTargetY,0,mtThunder,False,30,bo11);
           PlaySound(8222);
         end;
      end;
      CurrentDefFrame := 0;
      DefFrameTime := GetTickCount;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if prv <> CurrentFrame then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;

end;

{ TPBOMA1Mon }

procedure TPBOMA1Mon.Run;
var
   prv: integer;
   EffectFrameTimetime, FrameTimetime: longword;
   meff: TFlyingBug;
begin
   if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;

   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;

   RunActSound (CurrentFrame - StartFrame);
   RunFrameAction (CurrentFrame - StartFrame);
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            CurrentAction := 0;
            boUseEffect := FALSE;
         end;
         if (CurrentAction = SM_FLYAXE) and (CurrentFrame - StartFrame = 4) then begin
            meff := TFlyingBug (PlayScene.NewFlyObject (self,
                             XX,
                             yy,
                             MagicTargetX,
                             MagicTargetY,
                             TargetRecog,
                             mt15));
            if meff <> nil then begin
               meff.ImgLib := WilMon22;
               meff.NextFrameTime := 50;
               meff.FlyImageBase:=350;
               meff.MagExplosionBase := 430;
            end;
         end;
      end;
      CurrentDefFrame := 0;
      DefFrameTime := GetTickCount;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if prv <> CurrentFrame then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;

end;

{ TFireDragon }

procedure TFireDragon.CalcActorFrame;
var
   pm: PTMonsterAction;
begin
   Dir:=0;
   CurrentFrame := -1;
   BodyOffset := GetOffset (Appearance);
   pm := GetRaceByPM (Race,Appearance);
   if pm = nil then exit;
   case CurrentAction of
     SM_DIGUP: begin
       MicroMove(0, 0, 0, 1);
       StartFrame:=0;
       EndFrame:=9;
       FrameTime:=300;
       StartTime:=GetTickCount;
     end;
     SM_HIT: begin
       StartFrame:=0;
       EndFrame:=19;
       FrameTime:=150;
       StartTime:=GetTickCount;
       boUseEffect:=True;
       EffectStart:=0;
       EffectFrame:=0;
       EffectEnd:=19;
       EffectStartTime:=GetTickCount;
       EffectFrameTime:=150;
       CurMagicFrame:=0;
       boUseMagic:=True;
       WarModeTime:=GetTickcount;
       MicroMove(Dir, 0, 0, 1);
     end;
     SM_STRUCK: begin
       StartFrame:=0;
       EndFrame:=9;
       FrameTime:=300;
       StartTime:=GetTickCount;
     end;
     81..83: begin
       StartFrame:=0;
       EndFrame:=5;
       FrameTime:=150;
       StartTime:=GetTickCount;
       boUseEffect:=True;
       EffectStart:=0;
       EffectFrame:=0;
       EffectEnd:=10;
       EffectStartTime:=GetTickCount;
       EffectFrameTime:=150;
       CurMagicFrame:=0;
       boUseMagic:=True;
       WarModeTime:=GetTickcount;
       MicroMove(Dir, 0, 0, 1);
     end;
   end;
end;

constructor TFireDragon.Create;
begin
  inherited;
  n270:=nil;
end;

procedure TFireDragon.AttackEff;
var
  n8,nC,n10,n14,n18:integer;
  bo11:Boolean;
  i,iCount:integer;
begin
    n8:=XX;
    nC:=yy;
//    PlayScene.NewMagic (Self,80,80,XX,.yy,n8 - 3,nC + 3,0,mtThunder,False,30,bo11);
//    PlayScene.NewMagic (Self,80,80,XX,.yy,n8 - 3,nC + 3,0,mtThunder,False,30,bo11);
    iCount:=Random(4);
    for i:=0 to iCount do begin
    n10:=Random(4);
    n14:=Random(8);
    n18:=Random(8);
    case n10 of
      0: begin
        PlayScene.AddNewMagic (Self,80,80,XX,yy,n8 - n14 - 2,nC + n18 + 1,0,mtThunder,False,30,bo11);
      end;
      1: begin
        PlayScene.AddNewMagic (Self,80,80,XX,yy,n8 - n14,nC + n18,0,mtThunder,False,30,bo11);
      end;
      2: begin
        PlayScene.AddNewMagic (Self,80,80,XX,yy,n8 - n14,nC + n18 + 1,0,mtThunder,False,30,bo11);
      end;
      3: begin
        PlayScene.AddNewMagic (Self,80,80,XX,yy,n8 - n14 - 2,nC + n18,0,mtThunder,False,30,bo11);
      end;
    end;
    PlaySound(8206);
    end;
end;

procedure TFireDragon.DrawEff(dsurface: TDirectDrawSurface; dx,
  dy: integer);
begin
  inherited;
  if boUseEffect and (n270 <> nil) then begin
    DrawBlend (dsurface,dx + ax + ShiftX,dy + ay + ShiftY,n270, DrawADDValue_MagicEffect);
  end;
end;

procedure TFireDragon.DoLoadSurface;
var
  mimg:TTilFile;
begin
   mimg := WilDragon;
   if currentframe < 0 then currentframe := 0;
   if mimg = nil then exit;
     if (not ReverseFrame) then begin
       case CurrentAction of
         SM_HIT: begin
           m_BodySurface:= mimg.GetImage (40 + CurrentFrame, Px, Py);
         end;

         81: begin
           m_BodySurface:= mimg.GetImage (10 + CurrentFrame, Px, Py);
         end;
         82: begin
           m_BodySurface:= mimg.GetImage (20 + CurrentFrame, Px, Py);
         end;
         83: begin
           m_BodySurface:= mimg.GetImage (30 + CurrentFrame, Px, Py);
         end;
         else begin
           m_BodySurface:= mimg.GetImage (GetOffset (Appearance) + CurrentFrame, Px, Py);
         end;
       end;
     end else begin
       case CurrentAction of
         SM_HIT: begin
           m_BodySurface := mimg.GetImage (40 + EndFrame - CurrentFrame, ax, ay);
         end;
         81: begin
           m_BodySurface := mimg.GetImage (10 + EndFrame - CurrentFrame, ax, ay);
         end;
         82: begin
           m_BodySurface := mimg.GetImage (20 + EndFrame - CurrentFrame, ax, ay);
         end;
         83: begin
           m_BodySurface := mimg.GetImage (30 + EndFrame - CurrentFrame, ax, ay);
         end;
         else begin
           m_BodySurface := mimg.GetImage (GetOffset (Appearance) + EndFrame - CurrentFrame, Px, Py);
         end;
       end;
     end;


   if boUseEffect then begin
     case CurrentAction of
       SM_HIT: begin
         n270 := WilDragon.GetImage (60 + EffectFrame, ax, ay);
       end;
       81: begin
         n270 := WilDragon.GetImage (90 + EffectFrame, ax, ay);
       end;
       82: begin
         n270 := WilDragon.GetImage (100 + EffectFrame, ax, ay);
       end;
       83: begin
         n270 := WilDragon.GetImage (110 + EffectFrame, ax, ay);
       end;

     end;
   end;
   {
   Dec(px,14);
   Dec(py,14);
   Dec(ax,14);
   Dec(ay,14);
   }

end;

procedure TFireDragon.Run;
var
   prv: integer;
   EffectFrameTimetime, FrameTimetime: longword;
   bo11:Boolean;
begin
   if (CurrentAction = SM_WALK) or (CurrentAction = SM_BACKSTEP) or (CurrentAction = SM_RUN) or (CurrentAction = SM_HORSERUN) then exit;

   muchAction := FALSE;
   if MsgList.Count >= 2 then muchAction := TRUE;
   if boRunSound then begin
     PlaySound(8201);
     boRunSound:=False;
   end;

   if boUseEffect then begin
      if muchAction then EffectFrameTimetime := Round(EffectFrameTime * 2 / 3)
      else EffectFrameTimetime := EffectFrameTime;
      if GetTickCount - EffectStartTime > EffectFrameTimetime then begin
         EffectStartTime := GetTickCount;
         if EffectFrame < EffectEnd then begin
            Inc (EffectFrame);
         end else begin
            boUseEffect := FALSE;
         end;
      end;
   end;

   prv := CurrentFrame;
   if CurrentAction <> 0 then begin
      if (CurrentFrame < StartFrame) or (CurrentFrame > EndFrame) then
         CurrentFrame := StartFrame;

      if muchAction then FrameTimetime := Round(FrameTime * 2 / 3)
      else FrameTimetime := FrameTime;

      if GetTickCount - StartTime > FrameTimetime then begin
         if CurrentFrame < EndFrame then begin
            Inc (CurrentFrame);
            StartTime := GetTickCount;
         end else begin
            CurrentAction := 0;
            boUseEffect := FALSE;
            bo260:=False;
         end;

         if (CurrentAction = SM_HIT)  then begin//and (CurrentFrame = 4) then begin
           AttackEff;
           PlaySound(8202);
         end;

         if (CurrentAction = 81) or (CurrentAction = 82) or (CurrentAction = 83) then begin
           if (CurrentFrame - StartFrame) = 4 then begin
             PlayScene.AddNewMagic (Self,CurrentAction,CurrentAction,XX,yy,MagicTargetX,MagicTargetY,TargetRecog,mtFly,True,30,bo11);
             PlaySound(8203);
           end;
         end;

      end;
      CurrentDefFrame := 0;
      DefFrameTime := GetTickCount;
   end else begin
      if GetTickCount - SmoothMoveTime > 200 then begin
         if GetTickCount - DefFrameTime > 500 then begin
            DefFrameTime := GetTickCount;
            Inc (CurrentDefFrame);
            if CurrentDefFrame >= DefFrameCount then
               CurrentDefFrame := 0;
         end;
         DefaultMotion;
      end;
   end;

   if prv <> CurrentFrame then begin
      m_loadsurfacetime := GetTickCount;
      DoLoadSurface;
   end;
end;

end.






