unit ClType;

interface
uses
  Windows, Classes, MirGrobal, Graphics;


type
  TUpFileInf = Packed record
     NetFileName :String[250];
     LodFileName:String[250];         //ע
     Ver: Integer;
  End;

  pTUpFileInf =^TUpFileInf;

  TMsgCol = record
    fcolor: Integer;
    bcolor: Integer;
  end;
  PTMsgCol = ^TMsgCol;
  PTDropItem = ^TDropItem;
  TDropItem = record
    X, Y: SmallInt;
    id: Integer;
    looks: Integer;
    Name: string[14];
    FlashTime: Integer;
    BoFlash: Boolean;
    FlashStepTime: Integer;
    FlashStep: Integer;
    
    Canshow: Boolean;
    HintColor: Boolean;
    TryPicupCount:ShortInt;
  end;
  TFaceControl = record
    c: array[0..5] of Integer;
  end;
  TNeiGuaHeader = packed record
    Version: Integer;
    Sign: Integer;
    Name: string[20];
  end;
  TProtectmethod = packed record
    ItemName: string[30];
    Per: DWord;
    Time: DWord;
    Now: DWord;
  end;
  TProtect = packed record
    Protect: array[0..7] of Boolean;
    Method: array[0..7] of TProtectmethod;
    EditText: array[0..14] of string[20];
    ComboboxIndex: Byte;
    EditIndex: Byte;
    Dura: Byte;
    Repair: Byte;
    ComBoBoxExtend: array[0..7] of Boolean;
    ComBoBoxDowned: array[0..7] of Boolean;
    ComBoBoxStr: array[0..7] of string[20];
  end;
  TBase = packed record
    ComboboxIndex: Byte;
    ComBoBoxExtend: array[0..4] of Boolean;
    ComBoBoxDowned: array[0..4] of Boolean;
    ComBoBoxStr: array[0..4] of string[20];
    BtnDown: array[0..2] of Boolean;
    AUtoMAgicKey: Byte;
    Sendstr: string[50];
    case Byte of
      1:
      (
        NoDarkness: Byte;      {00}
        NoRunReady: Byte;      {01}
        CanNowExit: Byte;      {02}
        ShowBlood: Byte;       {03}
        NumberBlood: Byte;     {04}
        AutoRun: Byte;         {05}
        AutoPut: Byte;         {06}
        AutoTearOpen: Byte;    {07}
        NoStruck: Byte;        {08}
        SpeedChat: Byte;       {09}
        SpeedGroup: Byte;      {10}
        WorkShow: Byte;        {11}
        Nopalsy: Byte;         {12}
        Autokill: Byte;        {13}
        IncBloodShow: Byte;    {14}
        AUtoFellow: Byte;      {15}//Զ
        Noweight: Byte;        {16}
        ConPK: Byte;           {17}
        SHowName: Byte;        {18}
        CanCrashMon: Byte;     {19}
        GuildColor: BYte;      {20}
        MsgShow: Byte;         {21}
        WarningDura: Byte;     {22}
        AutoMAgic: Byte;       {23}
        ClearBody: Byte;       {24}
        AttackShow: Byte;      {25}
        MagicLock: Byte;       {26}
        WarningDuraPer: Byte;  {27}
        AutoMagicTime: Byte;   {28}
        ClearBodyTime: Byte;   {29}
        AttackShowType: Byte;
        MagicLockType: Byte;
        CanCrashMan: Byte;
        NoSlow: Byte;
        );

      2:
      (
        BassValArr: array[0..33] of Byte;
        );
  end;
  TChat = packed record
    EditText: array[0..2] of string[255];
    AutoReChatstr: string[255];
    BtnDown: array[0..3] of Boolean;
    AutoTalkTime: Integer;
    AutoTalkIndex: Integer;
    AutoTalkMoveIndex: Integer;
    EditIndex: Byte;
    case Byte of
      0: (
        AutoReChat: Byte;
        AutoTalk: Byte;
        AutoTalkReturn: Byte;
        MaskTalk: Byte;
        MAskShout: Byte;
        MaskGuild: Byte;
        MaskGroup: Byte;

        );
      1:
      (
        Chat: array[0..6] of Byte;
        );
  end;
  TWork = packed record
    AutoHpPer: DWord;
    AutoHpTime: DWord;
    AutoCallTime: Integer;
    AutoChiType: Integer;
    MagicType: Byte;
    HideType: Byte;
    DuType: Byte;
    Duwhich: Byte;
    EditText: string[20];
    ComboboxIndex: Byte;
    ComBoBoxExtend: array[0..2] of Boolean;
    ComBoBoxDowned: array[0..2] of Boolean;
    ComBoBoxStr: array[0..2] of string[20];
    case Byte of
      0: (
        DaoDaoChi: Byte;
        AutoYeMan: Byte;
        AutoLie: Byte;
        AIBanYue: Byte;
        DingXiang: Byte;
        AutoPk: Byte;
        AutoChi: Byte;
        AutoMagicShield: Byte;//ħ
        AutoHP: Byte;
        AutoHide: Byte; //Զ
        AutoDuFu: Byte;
        AutoCall: Byte;
        Autodispute: Byte; //ܻ
        );
      1: (
        Work: array[0..12] of Byte;
        );
  end;
  THintmethod = packed record
    Name: string[30];
    which: Byte;
  end;
  TAssistant = packed record
    Hint: Boolean;
    EditText: string[20];
    ComboboxIndex: Byte;
    HintWhich: Byte;

    ListIndex: Integer;
    EditListIndex: Integer;
    Name: string[20];
    ComBoBoxExtend: array[0..2] of Boolean;
    ComBoBoxDowned: array[0..2] of Boolean;
    ComBoBoxStr: array[0..2] of string[20];
    BtnDown: array[0..7] of Boolean;
  end;
  TGoodsShow = packed record
    Name: string[50];
    Show: Boolean;
    Color: Boolean;
    Pick: Boolean;
    Hint: Boolean;
  end;
  TKey = packed record
    Key1: Byte; //1  'Ctrl'  2'Alt' 3'Shift';
    Key2: char;
    Index: Byte;
  end;
  TMagicLock = packed record
    MagicId: Integer;
    Name: string[50];
    IsLock: Boolean;
  end;

  TGoods = packed record
    BtnDown: array[0..7] of Boolean;
    EditText: array[0..3] of string[50];
    GoodsIndex: Integer;
    GoodsMoveIndex: Integer;
    EditIndex: Byte;
    ComBoBoxIndex: Integer;
    ComBoBoxExtend, ComBoBoxDowned: array[0..1] of Boolean;
    BuyCount: Integer;
    case Byte of
      0: (
        AutoPickUp: Byte;
        ShowFilter: Byte;
        PickUpFilter: Byte;
        GoodShow: Byte;
        GoodHint: Byte;
        GoodColor: Byte;
        BuyBat: Byte;
        );
      1: (
        Goods: array[0..6] of Byte;
        );

  end;
  TFUzhu = packed record
    BtnDown: array[0..1] of Boolean;
    GameSpeed: Byte;
    AttackSpeed: Byte;
    MagicSpeed: Byte;
  end;
  TWpe = packed record
    //Msg:TDefaultMessage;
    BtnDown: array[0..6] of Boolean;

    EditIndex: Byte;
    case Byte of
      0: (
        Rec: Byte;
        Send: Byte;
        );
      1: (
        Wpe: array[0..1] of byte;
        );
  end;
  TShezhi = packed record
    BtnDown: array[0..6] of Boolean;
    ComBoBoxIndex: Integer;
    ComBoBoxExtend, ComBoBoxDowned: array[0..3] of Boolean;
    ComBoBoxStr: string[20];
    SaveIndex: Byte;
    LoadIndex: Byte;
    EditListIndex: Integer;
    KeyListTop, MagicLockTop, KeyIndex, MagicIndex: Integer;
    EditText: string[50];
    Key: array[0..28] of Tkey;
    MagicLock: array[0..20] of TMagicLock;
    MagicLockCount: Integer;
    HintColor: array[0..7] of TColor;
    HintIndex: Byte;
    MagicChang: Boolean;
  end;
  TGuaJi = packed record
    AttackMode: Byte;
    MagicKey: Byte;
    AroundKey: Byte;
    CameBack: array[0..3] of Boolean;
    ComboboxIndex: Byte;
    NoAttackTop: Integer;

    ComBoBoxExtend: array[0..1] of Boolean;
    ComBoBoxDowned: array[0..1] of Boolean;
    BtnDown: array[0..4] of Boolean;
    EditText: string[50];
    Guaji: Boolean;
  end;
  TNeiGua = packed record
    Statues: Byte;
    Base: TBase;
    Protect: TProtect;
    Chat: TChat;
    Work: TWork;
    Assistant: TAssistant;
    Goods: TGoods;
    Fuzhu: TFuzhu;
    SHezhi: Tshezhi;
    Guaji: TGuaJi;
  end;
  TMiniMapControl = record
    btViewMode: Byte;
    X, Y: Integer;
    CanRun: Boolean;
  end;
  PServerName = ^TServerName;
  TServerName = packed record
    Name: string[100];
    Caption: string[100];
    Ip: string[100];
    Port: Integer;
  end;

implementation

end.
