unit PlayScn;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms,
  MPlayer,
  DXDraws,
  IntroScn, MirGrobal, cliUtil,
  Actor, HerbActor, AxeMon, SoundUtil,
  StdCtrls, magiceff, ExtCtrls,
  EDCode,
  PlayActor,
  Debug, //ϢԪ TasNat 2009-02-17 20:07:52
  ResManager, //ԴԪ TasNat 2009-02-14 22:38:49
  clMapEff,
  ClType,
  ClVarConst,                  
  ClFunc,
  TyFunc;


const
  MAPSURFACEWIDTH = 800;
{$IF Ver_LCJ}
  MAPSURFACEHEIGHT = 550;
{$ELSE}
  MAPSURFACEHEIGHT = 485;
{$IFEND}
  LONGHEIGHT_IMAGE = 35;
  FLASHBASE = 410;
  AAX30 = 30;
  SOFFX = 0;
  SOFFY = 0;
  LMX = 30;
  LMY = 26;
   BKMASK = 58;
   FRMASK = 59;

  MAXLIGHT = 5;
  LightFiles: array[0..MAXLIGHT] of string = (
    'Data\lig0a.dat',
    'Data\lig0b.dat',
    'Data\lig0c.dat',
    'Data\lig0d.dat',
    'Data\lig0e.dat',
    'Data\lig0f.dat'
    );

  LightMask0: array[0..2, 0..2] of shortint = (
    (0, 1, 0),
    (1, 3, 1),
    (0, 1, 0)
    );
  LightMask1: array[0..4, 0..4] of shortint = (
    (0, 1, 1, 1, 0),
    (1, 1, 3, 1, 1),
    (1, 3, 4, 3, 1),
    (1, 1, 3, 1, 1),
    (0, 1, 2, 1, 0)
    );
  LightMask2: array[0..8, 0..8] of shortint = (
    (0, 0, 0, 1, 1, 1, 0, 0, 0),
    (0, 0, 1, 2, 3, 2, 1, 0, 0),
    (0, 1, 2, 3, 4, 3, 2, 1, 0),
    (1, 2, 3, 4, 4, 4, 3, 2, 1),
    (1, 3, 4, 4, 4, 4, 4, 3, 1),
    (1, 2, 3, 4, 4, 4, 3, 2, 1),
    (0, 1, 2, 3, 4, 3, 2, 1, 0),
    (0, 0, 1, 2, 3, 2, 1, 0, 0),
    (0, 0, 0, 1, 1, 1, 0, 0, 0)
    );
  LightMask3: array[0..10, 0..10] of shortint = (
    (0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0),
    (0, 0, 0, 1, 2, 2, 2, 1, 0, 0, 0),
    (0, 0, 1, 2, 3, 3, 3, 2, 1, 0, 0),
    (0, 1, 2, 3, 4, 4, 4, 3, 2, 1, 0),
    (1, 2, 3, 4, 4, 4, 4, 4, 3, 2, 1),
    (2, 3, 4, 4, 4, 4, 4, 4, 4, 3, 2),
    (1, 2, 3, 4, 4, 4, 4, 4, 3, 2, 1),
    (0, 1, 2, 3, 4, 4, 4, 3, 2, 1, 0),
    (0, 0, 1, 2, 3, 3, 3, 2, 1, 0, 0),
    (0, 0, 0, 1, 2, 2, 2, 1, 0, 0, 0),
    (0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0)
    );

  LightMask4: array[0..14, 0..14] of shortint = (
    (0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0),
    (0, 0, 0, 0, 1, 1, 2, 2, 2, 1, 1, 0, 0, 0, 0),
    (0, 0, 0, 1, 1, 2, 3, 3, 3, 2, 1, 1, 0, 0, 0),
    (0, 0, 1, 1, 2, 3, 4, 4, 4, 3, 2, 1, 1, 0, 0),
    (0, 1, 1, 2, 3, 4, 4, 4, 4, 4, 3, 2, 1, 1, 0),
    (1, 1, 2, 3, 4, 4, 4, 4, 4, 4, 4, 3, 2, 1, 1),
    (1, 2, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3, 2, 1),
    (1, 1, 2, 3, 4, 4, 4, 4, 4, 4, 4, 3, 2, 1, 1),
    (0, 1, 1, 2, 3, 4, 4, 4, 4, 4, 3, 2, 1, 1, 0),
    (0, 0, 1, 1, 2, 3, 4, 4, 4, 3, 2, 1, 1, 0, 0),
    (0, 0, 0, 1, 1, 2, 3, 3, 3, 2, 1, 1, 0, 0, 0),
    (0, 0, 0, 0, 1, 1, 2, 2, 2, 1, 1, 0, 0, 0, 0),
    (0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0)
    );

  LightMask5: array[0..16, 0..16] of shortint = (
    (0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0, 0, 1, 2, 2, 2, 1, 0, 0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0, 1, 2, 4, 4, 4, 2, 1, 0, 0, 0, 0, 0),
    (0, 0, 0, 0, 1, 2, 4, 4, 4, 4, 4, 2, 1, 0, 0, 0, 0),
    (0, 0, 0, 1, 2, 4, 4, 4, 4, 4, 4, 4, 2, 1, 0, 0, 0),
    (0, 0, 1, 2, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 1, 0, 0),
    (0, 1, 2, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 1, 0),
    (1, 2, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 1),
    (1, 2, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 1),
    (1, 2, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 1),
    (0, 1, 2, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 1, 0),
    (0, 0, 1, 2, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 1, 0, 0),
    (0, 0, 0, 1, 2, 4, 4, 4, 4, 4, 4, 4, 2, 1, 0, 0, 0),
    (0, 0, 0, 0, 1, 2, 4, 4, 4, 4, 4, 2, 1, 0, 0, 0, 0),
    (0, 0, 0, 0, 0, 1, 2, 4, 4, 4, 2, 1, 0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0, 0, 1, 2, 2, 2, 1, 0, 0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0)

    );

type
  PShoftInt = ^shortint;
  TLightEffect = record
    Width: Integer;
    Height: Integer;
    PFog: PByte;
  end;
  TLightMapInfo = record
    ShiftX: Integer;
    ShiftY: Integer;
    light: Integer;
    bright: Integer;
  end;

  TPlayScene = class(TScene)
  private
    MapSurface: TDirectDrawSurface;
    ObjSurface: TDirectDrawSurface;

    FogScreen: array[0..MAPSURFACEHEIGHT, 0..MAPSURFACEWIDTH] of Byte;
    PFogScreen: PByte;
    FogWidth, FogHeight: Integer;
    Lights: array[0..MAXLIGHT] of TLightEffect;
    MoveTime, MoveMyTime: longword;
    AniTime: longword;
    AniCount: Integer;
    DefXX, DefYY: Integer;
    MainSoundTimer: TTimer;

    MsgList: TList;
    LightMap: array[0..LMX, 0..LMY] of TLightMapInfo;
    procedure DrawTileMap;
    procedure LoadFog;
    procedure ClearLightMap;
    procedure AddLight(X, Y, ShiftX, ShiftY, light: Integer; nocheck: Boolean);
    procedure UpdateBright(X, Y, light: Integer);
    function CheckOverLight(X, Y, light: Integer): Boolean;
    procedure ApplyLightMap;
    procedure DrawLightEffect(lx, ly, bright: Integer);
    procedure EdChatEnter(Sender: TObject);
    procedure EdChatExit(Sender: TObject);
    procedure EdChatKeyPress(Sender: TObject; var Key: Char);
    procedure EdChatKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SoundOnTimer(Sender: TObject);
  public
    EdChat: TEdit;
    ActorList, TempList: TList;
    GroundEffectList: TList;
    EffectList: TList;
    FlyList: TList;
    BlinkTime: longword;
    ViewBlink: Boolean;
    constructor Create;
    destructor Destroy; override;
    procedure Initialize; override;
    procedure Finalize; override;
    procedure OpenScene; override;
    procedure CloseScene; override;
    procedure OpeningScene; override;
    procedure PlayScene(MSurface: TDirectDrawSurface); override;
    function ButchAnimal(X, Y: Integer): TActor;

    function ActorToPlayActor(id: Integer): TPlayActor;
    function FindActor(id: Integer): TActor;
    function FindActorByName(Name: string): TActor;
    function FindActorXY(X, Y: Integer): TActor;
    function IsValidActor(Actor: TActor): Boolean;
    function NewActor(chrid: Integer; cx, cy, cdir: Word; cfeature, cstate:
      Integer; isPlay: Boolean = False): TActor;
    procedure ActorDied(Actor: TObject);
    procedure SetActorDrawLevel(Actor: TObject; Level: Integer);
    procedure ClearAllActorsAndMagicEff;
    function DeleteActor(id: Integer): TActor;
    procedure DelActor(Actor: TObject);
    procedure AddAction(ident, chrid, X, Y, cdir, Feature, State: Integer; Str:
      string);

    procedure AddNewMagic(aowner: TActor;
      magid, magnumb, cx, cy, tx, ty, targetcode: Integer;
      mtype: TMagicType;
      Recusion: Boolean;
      AniTime: Integer;
      var bofly: Boolean);
    procedure DelMagic(magid: Integer);
    function NewFlyObject(aowner: TActor; cx, cy, tx, ty, targetcode: Integer;
      mtype: TMagicType): TMagicEff;


    procedure ScreenXYfromMCXY(cx, cy: Integer; var sx, sy: Integer);
    procedure CXYfromMouseXY(mx, my: Integer; var ccx, ccy: Integer);
    function GetCharacter(X, Y, wantsel: Integer; var nowsel: Integer; liveonly:
      Boolean): TActor;
    function GetAttackFocusCharacter(X, Y, wantsel: Integer; var nowsel:
      Integer; liveonly: Boolean): TActor;
    function IsSelectMyself(X, Y: Integer): Boolean;
    function GetDropItems(X, Y: Integer; var inames: string): PTDropItem;
    procedure GetDropItems2(mx, my: Integer; var List:TStringList);
    function CanRun(sx, sy, ex, ey: Integer): Boolean;
    function CanWalk(mx, my: Integer): Boolean;
    function CrashActor(mx, my: Integer): Boolean;
    function CanFly(mx, my: Integer): Boolean;
    //procedure RefreshScene;
    procedure CleanObjects;
  end;


implementation

uses
  ClMain, FState;


constructor TPlayScene.Create;
begin
  MapSurface := nil;
  ObjSurface := nil;
  MsgList := TList.Create;
  ActorList := TList.Create;
  TempList := TList.Create;
  GroundEffectList := TList.Create;
  EffectList := TList.Create;
  FlyList := TList.Create;
  BlinkTime := GetTickCount;
  ViewBlink := False;

  EdChat := TEdit.Create(GameWindows.Owner);
  with EdChat do begin
    Parent := GameWindows;
    BorderStyle := bsNone;
    OnKeyPress := EdChatKeyPress;
    Onkeydown := EdChatKeyDown;
    OnEnter := EdChatEnter;
    OnExit := EdChatExit;
    Visible := False;
    MaxLength := 70;
    Ctl3D := False;
{$IF Ver_LCJ}
    Left := 7;
    Top := SCREENHEIGHT - 76;
    Height := 186 - 175;
    Width := 251 - 7;
{$ELSE}
    Left := 208;
    Top := SCREENHEIGHT - 19;
    Height := 12;
    Width := (SCREENWIDTH div 2 - 207) * 2;
{$IFEND}


    Color := clSilver;
  end;
  MoveTime := GetTickCount;
  AniTime := GetTickCount;
  AniCount := 0;
  MainSoundTimer := TTimer.Create(GameWindows.Owner);
  with MainSoundTimer do begin
    OnTimer := SoundOnTimer;
    Interval := 1;
    Enabled := False;
  end;
end;

destructor TPlayScene.Destroy;
begin
  MsgList.Free;
  ActorList.Free;
  TempList.Free;
  GroundEffectList.Free;
  EffectList.Free;
  FlyList.Free;
  inherited Destroy;
end;

procedure TPlayScene.SoundOnTimer(Sender: TObject);
begin
  PlaySound(s_main_theme);
  MainSoundTimer.Interval := 46 * 1000;
end;
procedure TPlayScene.EdChatEnter(Sender: TObject);
begin
  if EdChat.Tag = 99 then EdChat.Text := '';
end;
procedure TPlayScene.EdChatExit(Sender: TObject);
begin

end;
procedure TPlayScene.EdChatKeyDown(Sender: TObject; var Key: Word; Shift:
  TShiftState);
begin
  case Key of
    VK_UP: begin
        with DScreen do begin

        end;
      end;
    VK_DOWN:
      with DScreen do begin

      end;
  end;
end;

procedure TPlayScene.EdChatKeyPress(Sender: TObject; var Key: Char);
var
  msg:TDefaultMessage;
  pic:Integer;
begin
  if Key = #13 then begin
    if EdChat.Tag = 99 then begin
      pic := Str_ToInt(EdChat.Text,-1);
      if pic > 0 then begin
        msg := MakeDefaultMsg(CM_BuyPaiMaiItem, pic, 0, 0, 0);
        GameWindows.SendSocket(EncodeMessage(msg));
      end;
      EdChat.Tag := 0;
      EdChat.Text := '';
      EdChat.Visible := False;
      Key := #0;
    end else begin
      GameWindows.Say(EdChat.Text);
      EdChat.Text := '';
      EdChat.Visible := False;
    end;
    Key := #0;
  end;
  {10.3
  if not ((Key = '/') and (EdChat.Text = '')) then
    FrmDlg.Dtalk.Visible := False; }
  if Key = #27 then begin
    EdChat.Text := '';
    EdChat.Visible := False;
    Key := #0;
  end;
end;

procedure TPlayScene.Initialize;
var
  i: Integer;
begin
  MapSurface := TDirectDrawSurface.Create(WILCSDD);
  MapSurface.SystemMemory := True;
  MapSurface.SetSize(MAPSURFACEWIDTH + UNITX * 4 + 30, MAPSURFACEHEIGHT + UNITY
    * 4);
  ObjSurface := TDirectDrawSurface.Create(WILCSDD);
  ObjSurface.SystemMemory := True;
  ObjSurface.SetSize(MAPSURFACEWIDTH - SOFFX * 2, MAPSURFACEHEIGHT);
  if (GameWindows.DXDraw1.Display.BitCount = 8) and ( FullScreen) then begin
  FogWidth := MAPSURFACEWIDTH - SOFFX * 2;
  FogHeight := MAPSURFACEHEIGHT;
  PFogScreen := @FogScreen;
  
  ZeroMemory(PFogScreen, MAPSURFACEHEIGHT * MAPSURFACEWIDTH);

  ViewFog := False;
  for i := 0 to MAXLIGHT do
    Lights[i].PFog := nil;
  LoadFog;
  end;
end;

procedure TPlayScene.Finalize;
begin
  if MapSurface <> nil then
    MapSurface.Free;
  if ObjSurface <> nil then
    ObjSurface.Free;
  MapSurface := nil;
  ObjSurface := nil;
end;

procedure TPlayScene.OpenScene;
begin
  ViewBottomBox(True);
  ClearSound;
end;

procedure TPlayScene.CloseScene;
begin

  ClearSound;
  if (GameWindows.MediaPlayer1.Mode = mpPlaying) then
  GameWindows.MediaPlayer1.Stop;
  PlayBGM(bmg_select);
  EdChat.Visible := False;
  ViewBottomBox(False);
end;

procedure TPlayScene.OpeningScene;

begin

end;

procedure TPlayScene.CleanObjects;
var
  i: Integer;
  actor: Tactor;
  Magf: TMagicEff;
begin
  for i := ActorList.Count - 1 downto 0 do begin
    Actor := TActor(ActorList[i]);
    if (Actor <> MySelf) and (Actor <> MyHero) then begin
      FreeAndnil(Actor);

      ActorList.Delete(i);
    end;
  end;
  MsgList.Clear;
  TargetCret := nil;
  FocusCret := nil;
  MagicTarget := nil;

  for i := 0 to GroundEffectList.Count - 1 do begin
    Magf := TMagicEff(GroundEffectList[i]);
    FreeAndNil(Magf);
  end;
  GroundEffectList.Clear;
  for i := 0 to EffectList.Count - 1 do begin
    Magf := TMagicEff(EffectList[i]);
    FreeAndNil(Magf);

  end;
  EffectList.Clear;
end;



procedure TPlayScene.DrawTileMap;
var
  i, j, m, n, imgnum: Integer;
  dsurface: TDirectDrawSurface;
begin
  dsurface := nil;
  with Map do
    if (ClientRect.Left = OldClientRect.Left) and (ClientRect.Top =
      OldClientRect.Top) then
      Exit;
  Map.OldClientRect := Map.ClientRect;
  MapSurface.Fill(0);
  with Map.ClientRect do begin
    m := -UNITY * 2;
    for j := (Top - Map.BlockTop - 1) to (Bottom - Map.BlockTop + 1) do begin
      n := AAX30 - UNITX;
      for i := (Left - Map.BlockLeft - 2) to (Right - Map.BlockLeft + 1) do begin
        if (i >= 0) and (i < LOGICALMAPUNIT * 3) and (j >= 0) and (j < LOGICALMAPUNIT * 3) then begin
          imgnum := (Map.MArr[i, j].BkImg and $7FFF);
          if imgnum > 0 then begin
            if (i mod 2 = 0) and (j mod 2 = 0) then begin
              imgnum := imgnum - 1;
              dsurface := GetTiles(imgnum);
              if dsurface <> nil then
                MapSurface.Draw(n, m, dsurface.ClientRect, dsurface, False);
            end;
          end;
        end;
        Inc(n, UNITX);
      end;
      Inc(m, UNITY);
    end;
  end;

  with Map.ClientRect do begin
    m := -UNITY;
    for j := (Top - Map.BlockTop - 1) to (Bottom - Map.BlockTop + 1) do begin
      n := AAX30 - UNITX;
      for i := (Left - Map.BlockLeft - 2) to (Right - Map.BlockLeft + 1) do begin
        if (i >= 0) and (i < LOGICALMAPUNIT * 3) and (j >= 0) and (j < LOGICALMAPUNIT * 3) then begin
          imgnum := Map.MArr[i, j].MidImg;
          if imgnum > 0 then begin
            imgnum := imgnum - 1;
            dsurface := GetSmTiles(imgnum);
            if dsurface <> nil then
              MapSurface.Draw(n, m, dsurface.ClientRect, dsurface, True);
          end;
        end;
        Inc(n, UNITX);
      end;
      Inc(m, UNITY);
    end;
  end;
end;




procedure TPlayScene.LoadFog;
var
  i, fhandle, w, H, prevsize: Integer;
  cheat: Boolean;
begin
  prevsize := 0;
  cheat := False;
  for i := 0 to MAXLIGHT do begin
    if FileExists(LightFiles[i]) then begin
      fhandle := FileOpen(LightFiles[i], fmOpenRead or fmShareDenyNone);
      FileRead(fhandle, w, SizeOf(Integer));
      FileRead(fhandle, H, SizeOf(Integer));
      Lights[i].Width := w;
      Lights[i].Height := H;
      Lights[i].PFog := AllocMem(w * H + 8);
      if prevsize < w * H then begin
        FileRead(fhandle, Lights[i].PFog^, w * H);
      end
      else
        cheat := True;
      prevsize := w * H;
      FileClose(fhandle);
    end;
  end;
  if cheat then
    for i := 0 to MAXLIGHT do begin
      if Lights[i].PFog <> nil then
        Fillchar(Lights[i].PFog^, Lights[i].Width * Lights[i].Height + 8, #0);
    end;
end;

procedure TPlayScene.ClearLightMap;
var
  i, j: Integer;
begin
  Fillchar(LightMap, (LMX + 1) * (LMY + 1) * SizeOf(TLightMapInfo), 0);
  for i := 0 to LMX do
    for j := 0 to LMY do
      LightMap[i, j].light := -1;
end;

procedure TPlayScene.UpdateBright(X, Y, light: Integer);
var
  i, j, r, lx, ly: Integer;
  pmask: ^shortint;
begin
  r := -1;
  case light of
    0: begin
        r := 2;
        pmask := @LightMask0;
      end;
    1: begin
        r := 4;
        pmask := @LightMask1;
      end;
    2: begin
        r := 8;
        pmask := @LightMask2;
      end;
    3: begin
        r := 10;
        pmask := @LightMask3;
      end;
    4: begin
        r := 14;
        pmask := @LightMask4;
      end;
    5: begin
        r := 16;
        pmask := @LightMask5;
      end;
  end;
  for i := 0 to r do
    for j := 0 to r do begin
      lx := X - (r div 2) + i;
      ly := Y - (r div 2) + j;
      if (lx in [0..LMX]) and (ly in [0..LMY]) then
        LightMap[lx, ly].bright := LightMap[lx, ly].bright +
          PShoftInt(Integer(pmask) + (i * (r + 1) + j) * SizeOf(shortint))^;
    end;
end;

function TPlayScene.CheckOverLight(X, Y, light: Integer): Boolean;
var
  i, j, r, mlight, lx, ly, Count, check: Integer;
  pmask: ^shortint;
begin
  r := -1;
  case light of
    0: begin
        r := 2;
        pmask := @LightMask0;
        check := 0;
      end;
    1: begin
        r := 4;
        pmask := @LightMask1;
        check := 4;
      end;
    2: begin
        r := 8;
        pmask := @LightMask2;
        check := 8;
      end;
    3: begin
        r := 10;
        pmask := @LightMask3;
        check := 18;
      end;
    4: begin
        r := 14;
        pmask := @LightMask4;
        check := 30;
      end;
    5: begin
        r := 16;
        pmask := @LightMask5;
        check := 40;
      end;
  end;
  Count := 0;
  for i := 0 to r do
    for j := 0 to r do begin
      lx := X - (r div 2) + i;
      ly := Y - (r div 2) + j;
      if (lx in [0..LMX]) and (ly in [0..LMY]) then begin
        mlight := PShoftInt(Integer(pmask) + (i * (r + 1) + j) *
          SizeOf(shortint))^;
        if LightMap[lx, ly].bright < mlight then begin
          Inc(Count, mlight - LightMap[lx, ly].bright);
          if Count >= check then begin
            Result := False;
            Exit;
          end;
        end;
      end;
    end;
  Result := True;
end;

procedure TPlayScene.AddLight(X, Y, ShiftX, ShiftY, light: Integer; nocheck:
  Boolean);
var
  lx, ly: Integer;
begin
  lx := X - MySelf.rx + LMX div 2;
  ly := Y - MySelf.ry + LMY div 2;
  if (lx >= 1) and (lx < LMX) and (ly >= 1) and (ly < LMY) then begin
    if LightMap[lx, ly].light < light then begin
      if not CheckOverLight(lx, ly, light) or nocheck then begin
        UpdateBright(lx, ly, light);
        LightMap[lx, ly].light := light;
        LightMap[lx, ly].ShiftX := ShiftX;
        LightMap[lx, ly].ShiftY := ShiftY;
      end;
    end;
  end;
end;

procedure TPlayScene.ApplyLightMap;
var
  i, j, light, defx, defy, lx, ly, lxx, lyy, lcount: Integer;
begin
  defx := -UNITX * 2 + AAX30 - MySelf.ShiftX;
  defy := -UNITY * 3 - MySelf.ShiftY;
  lcount := 0;
  for i := 1 to LMX - 1 do
    for j := 1 to LMY - 1 do begin
      light := LightMap[i, j].light;
      if light >= 0 then begin
        lx := (i + MySelf.rx - LMX div 2);
        ly := (j + MySelf.ry - LMY div 2);
        lxx := (lx - Map.ClientRect.Left) * UNITX + defx + LightMap[i,
          j].ShiftX;
        lyy := (ly - Map.ClientRect.Top) * UNITY + defy + LightMap[i, j].ShiftY;

        FogCopy(Lights[light].PFog,
          0,
          0,
          Lights[light].Width,
          Lights[light].Height,
          PFogScreen,
          lxx - (Lights[light].Width - UNITX) div 2,
          lyy - (Lights[light].Height - UNITY) div 2 - 5,
          FogWidth,
          FogHeight,
          20);
        Inc(lcount);
      end;
    end;
end;

procedure TPlayScene.DrawLightEffect(lx, ly, bright: Integer);
begin
  if (bright > 0) and (bright <= MAXLIGHT) then
    FogCopy(Lights[bright].PFog,
      0,
      0,
      Lights[bright].Width,
      Lights[bright].Height,
      PFogScreen,
      lx - (Lights[bright].Width - UNITX) div 2,
      ly - (Lights[bright].Height - UNITY) div 2,
      FogWidth,
      FogHeight,
      15);
end;


procedure TPlayScene.PlayScene(MSurface: TDirectDrawSurface);
var
  i, j, k, n, m, mmm, mx, my, ix, iy, line, defx, defy, wunit, fridx, ani, anitick,
  idx, drawingbottomline, RunTime: Integer;
  ax,ay :SmallInt;
  dsurface, d: TDirectDrawSurface;
  blend, movetick, CanMoveMy: Boolean;

  pd: PTDropItem;
  MapEff: TMapEff;
  Actor: TActor;
  meff: TMagicEff;
  co1: TColor;
  msgstr: string;
begin
  dsurface := nil;
  d := nil;
  if (MySelf = nil) then begin
    msgstr := 'Ժ...';
    with MSurface.Canvas do begin
      BoldTextOut(MSurface, (SCREENWIDTH - TextWidth(msgstr)) div 2, 200,
        clWhite, ClBlack, msgstr);
    end;
    Exit;
  end;
  MapEff := nil;
  DoFastFadeOut := False;


  movetick := False;
  CanMoveMy := False;

  //RunTime := 95 - NeiGua.Fuzhu.GameSpeed * 4;
  RunTime := 0;
  if GetTickCount - MoveMyTime >= RunTime then begin
    MoveMyTime := GetTickCount;
    CanMoveMy := True;
  end;
  if GetTickCount - MoveTime >= 75 then begin
    MoveTime := GetTickCount;
    movetick := True;
  end;
  if GetTickCount - AniTime >= 50 then begin
    AniTime := GetTickCount;
    Inc(AniCount);
    if AniCount > 100000 then
      AniCount := 0;
  end;
  try
    i := 0;
    while True do begin
      if i >= ActorList.Count then
        Break;
      Actor := ActorList[i];
      if Actor = Myself then begin
        if CanMoveMy then
          Actor.LockEndFrame := False;

      end
      else begin
        if movetick then
          Actor.LockEndFrame := False;
      end;
      if not Actor.LockEndFrame then begin
        Actor.ProcMsg;
        if Actor = Myself then begin
          if CanMoveMy then
            if Actor.Move then begin
              Inc(i);
              continue;
            end;

        end
        else
          if movetick then
            if Actor.Move then begin
              Inc(i);
              continue;
            end;
        Actor.Run;
        if Actor <> MySelf then
          Actor.ProcMagicMsg;
      end;
      if Actor = MySelf then
        Actor.ProcMagicMsg;

      if Actor.WaitForRecogId <> 0 then begin
        if Actor.IsIdle then begin
          DelChangeFace(Actor.WaitForRecogId);
          NewActor(Actor.WaitForRecogId, Actor.XX, Actor.yy, Actor.Dir,
            Actor.WaitForFeature, Actor.WaitForStatus);
          Actor.WaitForRecogId := 0;
          Actor.BoDelActor := True;
        end;
      end;
      if Actor.BoDelActor then begin

        FreeActorList.Add(Actor);
        ActorList.Delete(i);
        if TargetCret = Actor then
          TargetCret := nil;
        if FocusCret = Actor then
          FocusCret := nil;
        if MagicTarget = Actor then
          MagicTarget := nil;
      end
      else
        Inc(i);
    end;
  except
    on E: Exception do
      DebugOutStr('[ɫ]쳣!!' + E.Message);
  end;

  try
    i := 0;
    while True do begin
      if i >= GroundEffectList.Count then
        Break;
      meff := GroundEffectList[i];
      if meff.Active then begin
        if not meff.Run then begin
          meff.Free;
          Meff := nil;
          GroundEffectList.Delete(i);
          continue;
        end;
      end;
      Inc(i);
    end;
    i := 0;
    while True do begin
      if i >= EffectList.Count then
        Break;
      meff := EffectList[i];
      if meff.Active then begin
        if not meff.Run then begin
          meff.Free;
          Meff := nil;
          EffectList.Delete(i);
          continue;
        end;
      end;
      Inc(i);
    end;
    i := 0;
    while True do begin
      if i >= FlyList.Count then
        Break;
      meff := FlyList[i];
      if meff.Active then begin
        if not meff.Run then begin
          meff.Free;
          FlyList.Delete(i);
          continue;
        end;
      end;
      Inc(i);
    end;

    MapEffMan.Execute;
  except
    on E: Exception do
      DebugOutStr('[ͼЧ]쳣!!' + E.Message);
  end;

  try
    for k := 0 to DropedItemList.Count - 1 do begin
      pd := PTDropItem(DropedItemList[k]);
      if pd <> nil then begin
        if (abs(pd.X - MySelf.NowX) > 30) and (abs(pd.Y - MySelf.Nowy) > 30) then begin
          Dispose(PTDropItem(DropedItemList[k]));
          DropedItemList.Delete(k);
          Break;
        end;
      end;
    end;
    for k := 0 to MapEffMan.EffList.Count - 1 do begin
      MapEff := TMapEff(MapEffMan.EffList[k]);
      if (abs(MapEff.X - MySelf.NowX) > 30) and (abs(MapEff.Y - MySelf.Nowy) > 30) then begin
        MapEff.Free;
        MapEffMan.EffList.Delete(k);
        Break;
      end;
    end;
  except
    on E: Exception do
      DebugOutStr('[ƷOrʾΧħ]쳣!!' + E.Message);
  end;

  try
{$IF Ver_LCJ}
    with Map.ClientRect do begin
      Left := MySelf.rx - 9;
      Top := MySelf.ry - 11;
      Right := MySelf.rx + 9;
      Bottom := MySelf.ry + 13;
    end;
{$ELSE}
    with Map.ClientRect do begin
      Left := MySelf.rx - 9;
      Top := MySelf.ry - 9;
      Right := MySelf.rx + 9;
      Bottom := MySelf.ry + 9;
    end;
{$IFEND}
    Map.UpdateMapPos(MySelf.rx, MySelf.ry);





    if (MySelf.Death) or (neigua.Base.NoDarkness = 1) then begin
      ViewFog := False;
    end;

    if ViewFog then begin
      ZeroMemory(PFogScreen, MAPSURFACEHEIGHT * MAPSURFACEWIDTH);
      ClearLightMap;
    end;
{$IF Ver_LCJ}
    drawingbottomline := 585;
{$ELSE}
    drawingbottomline := 485;
{$IFEND}



    //ObjSurface.Fill(0);
    DrawTileMap;
    ObjSurface.Draw(0, 0,
      Rect(UNITX * 3 + MySelf.ShiftX,
      UNITY * 2 + MySelf.ShiftY,
      UNITX * 3 + MySelf.ShiftX + MAPSURFACEWIDTH,
      UNITY * 2 + MySelf.ShiftY + MAPSURFACEHEIGHT),
      MapSurface,
      False);

  except
    on E: Exception do
      DebugOutStr('104' + E.Message);
  end;

  defx := -UNITX * 2 - MySelf.ShiftX + AAX30;
  defy := -UNITY * 2 - MySelf.ShiftY;
  DefXX := defx;// -66
  Defyy := defy;// -64;

  try
    m := defy - UNITY;
    for j := (Map.ClientRect.Top - Map.BlockTop) to (Map.ClientRect.Bottom -
      Map.BlockTop + LONGHEIGHT_IMAGE) do begin
      if j < 0 then begin
        Inc(m, UNITY);
        continue;
      end;
      n := defx - UNITX * 2; 
                             
      for i := (Map.ClientRect.Left - Map.BlockLeft - 2) to (Map.ClientRect.Right
        - Map.BlockLeft + 2) do begin
        if (i >= 0) and (i < LOGICALMAPUNIT * 3) and (j >= 0) and (j < LOGICALMAPUNIT * 3) then begin
          fridx := (Map.MArr[i, j].FrImg) and $7FFF;
          if fridx > 0 then begin
            ani := Map.MArr[i, j].AniFrame;
            wunit := Map.MArr[i, j].Area;
            if (ani and $80) > 0 then begin
              blend := True;
              ani := ani and $7F;
            end;
            if ani > 0 then begin
              anitick := Map.MArr[i, j].anitick;
              fridx := fridx + (AniCount mod (ani + (ani * anitick))) div (1 +
                anitick);
            end;
            if (Map.MArr[i, j].DoorOffset and $80) > 0 then begin
              if (Map.MArr[i, j].DoorIndex and $7F) > 0 then
                fridx := fridx + (Map.MArr[i, j].DoorOffset and $7F);
            end;
            fridx := fridx - 1;

            dsurface := GetObjs(wunit, fridx);
            if dsurface <> nil then begin
              if (dsurface.Width = 48) and (dsurface.Height = 32) then begin
                mmm := m + UNITY - dsurface.Height;
                if (n + dsurface.Width > 0) and (n <= SCREENWIDTH) and (mmm +
                  dsurface.Height > 0) and (mmm < drawingbottomline) then begin
                  ObjSurface.Draw(n, mmm, dsurface.ClientRect, dsurface, True)
                end
                else begin
                  if mmm < drawingbottomline then begin
                    ObjSurface.Draw(n, mmm, dsurface.ClientRect, dsurface, True)
                  end;
                end;
              end;
            end;

          end;
        end;
        Inc(n, UNITX);
      end;
      Inc(m, UNITY);
    end;


    for k := 0 to GroundEffectList.Count - 1 do begin
      meff := TMagicEff(GroundEffectList[k]);

      meff.DrawEff(ObjSurface);
      if ViewFog then begin
        AddLight(meff.rx, meff.ry, 0, 0, meff.light, False);
      end;
    end;

  except
    on E: Exception do
      DebugOutStr('105' + E.Message);
  end;

  try
    m := defy - UNITY;
    for j := (Map.ClientRect.Top - Map.BlockTop) to (Map.ClientRect.Bottom -
      Map.BlockTop + LONGHEIGHT_IMAGE) do begin
      if j < 0 then begin
        Inc(m, UNITY);
        continue;
      end;
      n := defx - UNITX * 2;

      for i := (Map.ClientRect.Left - Map.BlockLeft - 2) to (Map.ClientRect.Right
        - Map.BlockLeft + 2) do begin
        if (i >= 0) and (i < LOGICALMAPUNIT * 3) and (j >= 0) and (j < LOGICALMAPUNIT * 3) then begin
          fridx := (Map.MArr[i, j].FrImg) and $7FFF;
          if fridx > 0 then begin
            blend := False;
            wunit := Map.MArr[i, j].Area;

            ani := Map.MArr[i, j].AniFrame;
            if (ani and $80) > 0 then begin
              blend := True;
              ani := ani and $7F;
            end;
            if ani > 0 then begin
              anitick := Map.MArr[i, j].anitick;
              fridx := fridx + (AniCount mod (ani + (ani * anitick))) div (1 +
                anitick);
            end;
            if (Map.MArr[i, j].DoorOffset and $80) > 0 then begin
              if (Map.MArr[i, j].DoorIndex and $7F) > 0 then
                fridx := fridx + (Map.MArr[i, j].DoorOffset and $7F);
            end;
            fridx := fridx - 1;

            if not blend then begin
              dsurface := GetObjs(wunit, fridx);
              if dsurface <> nil then begin
                if (dsurface.Width <> 48) or (dsurface.Height <> 32) then begin
                  mmm := m + UNITY - dsurface.Height;
                  if (n + dsurface.Width > 0) and (n <= SCREENWIDTH) and (mmm +
                    dsurface.Height > 0) and (mmm < drawingbottomline) then begin
                    ObjSurface.Draw(n, mmm, dsurface.ClientRect, dsurface, True)
                  end
                  else begin
                    if mmm < drawingbottomline then begin
                      ObjSurface.Draw(n, mmm, dsurface.ClientRect, dsurface,
                        True)
                    end;
                  end;
                end;
              end;
            end
            else begin
              dsurface := GetObjsEx(wunit, fridx, ax, ay);
              if dsurface <> nil then begin
                mmm := m + ay - 68;
                if (n > 0) and (mmm + dsurface.Height > 0) and (n +
                  dsurface.Width < SCREENWIDTH) and (mmm < drawingbottomline)
                  then begin
                  DrawBlend(ObjSurface, n + ax - 2, mmm, dsurface, DrawADDValue_MapObjects);
                end
                else begin
                  if mmm < drawingbottomline then begin
                    DrawBlend(ObjSurface, n + ax - 2, mmm, dsurface, DrawADDValue_MapObjects);
                  end;
                end;
              end;
            end;
          end;
          {if (Map.MArr[i, j].BkImg and $8000) <> 0 then begin
            dsurface := WilSmTiles[BKMASK];
              if dsurface <> nil then
            ObjSurface.Draw(n, m, dsurface.ClientRect,dsurface);
          end;
          if (Map.MArr[i, j].FrImg and $8000)<> 0  then begin
            dsurface := WilSmTiles[FRMASK];
              if dsurface <> nil then
            ObjSurface.Draw(n, m, dsurface.ClientRect,dsurface);
          end; }
        end;
        Inc(n, UNITX);
      end;//for i := (Map.ClientRect.Left - Map.BlockLeft - 2) to (Map.ClientRect.Right - Map.BlockLeft + 2) do

      if (j <= (Map.ClientRect.Bottom - Map.BlockTop)) and (not BoServerChanging) then begin


        for k := 0 to MapEffMan.EffList.Count - 1 do begin
          MapEff := TMapEff(MapEffMan.EffList[k]);
          if j = (MapEff.Y - Map.BlockTop) then begin
            MapEff.DrawEvent(ObjSurface,
              (MapEff.X - Map.ClientRect.Left) * UNITX + defx,
              m);
          end;
        end;



        for k := 0 to DropedItemList.Count - 1 do begin
          pd := PTDropItem(DropedItemList[k]);
          if NeiGua.Goods.ShowFilter = 1 then begin
            if not pd.Canshow then Continue;

          end;
          if pd <> nil then begin
            if j = (pd.Y - Map.BlockTop) then begin
              d := GetDnItems(pd.looks);
              if d <> nil then begin
                ix := (pd.X - Map.ClientRect.Left) * UNITX + defx + SOFFX;

                iy := m;
                if pd = FocusItem then begin
                  ImgMixSurface.Draw(0, 0, d.ClientRect, d, False);
                  DrawEffect(0, 0, d.Width, d.Height, ImgMixSurface, ceBright);
                  ObjSurface.Draw(ix + HALFX - (d.Width div 2),
                    iy + HALFY - (d.Height div 2),
                    d.ClientRect,
                    ImgMixSurface, True);
                end
                else
                  ObjSurface.Draw(ix + HALFX - (d.Width div 2), iy + HALFY - (d.Height div 2), d.ClientRect, d, True);

              end;
            end;
          end;
        end;


        for k := 0 to ActorList.Count - 1 do begin
          Actor := ActorList[k];
          if (j = Actor.ry - Map.BlockTop - Actor.DownDrawLevel) then begin
            Actor.SayX := (Actor.rx - Map.ClientRect.Left) * UNITX + defx + Actor.ShiftX + 24;
            if Actor.Death then
              Actor.Sayy := m + UNITY + Actor.ShiftY + 16 - 60 +(Actor.DownDrawLevel * UNITY)
            else
              Actor.Sayy := m + UNITY + Actor.ShiftY + 16 - 95 +(Actor.DownDrawLevel * UNITY);
            try
              Actor.DrawChr(ObjSurface, (Actor.rx - Map.ClientRect.Left) * UNITX +
              defx, m + (Actor.DownDrawLevel * UNITY), False);
            except
              on E: Exception do begin
                if Actor <> nil then
                  DebugOutStr('116' +Actor.ClassName+':'+Actor.UserName+':'+ E.Message)
                else
                  DebugOutStr('116' + E.Message)
              end;
            end;
          end;
        end;


        for k := 0 to FlyList.Count - 1 do begin
          meff := TMagicEff(FlyList[k]);
          if j = (meff.ry - Map.BlockTop) then
            meff.DrawEff(ObjSurface);
        end;

      end;
      Inc(m, UNITY);
    end;
  except
    on E: Exception do
      DebugOutStr('106' + E.Message);
  end;

  try
    if ViewFog then begin
      m := defy - UNITY * 4;
      for j := (Map.ClientRect.Top - Map.BlockTop - 4) to (Map.ClientRect.Bottom
        - Map.BlockTop + LONGHEIGHT_IMAGE) do begin
        if j < 0 then begin
          Inc(m, UNITY);
          continue;
        end;
        n := defx - UNITX * 5;

        for i := (Map.ClientRect.Left - Map.BlockLeft - 5) to
          (Map.ClientRect.Right - Map.BlockLeft + 5) do begin
          if (i >= 0) and (i < LOGICALMAPUNIT * 3) and (j >= 0) and (j < LOGICALMAPUNIT * 3) then begin
            idx := Map.MArr[i, j].light;
            if idx > 0 then begin
              AddLight(i + Map.BlockLeft, j + Map.BlockTop, 0, 0, idx, False);
            end;
          end;
          Inc(n, UNITX);
        end;
        Inc(m, UNITY);
      end;


      if ActorList.Count > 0 then begin
        for k := 0 to ActorList.Count - 1 do begin
          Actor := ActorList[k];
          if (Actor = MySelf) or (Actor.light > 0) then
            AddLight(Actor.rx, Actor.ry, Actor.ShiftX, Actor.ShiftY,
              Actor.light, Actor = MySelf);
        end;
      end
      else begin
        if MySelf <> nil then
          AddLight(MySelf.rx, MySelf.ry, MySelf.ShiftX, MySelf.ShiftY,
            MySelf.light, True);
      end;
    end;
  except
    on E: Exception do
      DebugOutStr('107' + E.Message);
  end;

  if not BoServerChanging then begin
    try

      //if not CheckBadMapMode then
      if MySelf.State and $00800000 = 0 then begin
        {if MySelf.HorseSurface <> nil then
        ObjSurface.DrawAlpha(Bounds((MySelf.rx - Map.ClientRect.Left) * UNITX +defx+MySelf.horsex+MySelf.ShiftX,
                                  (MySelf.ry - Map.ClientRect.Top - 1) * UNITY + defy+MySelf.horsey+MySelf.ShiftY,
                                  MySelf.HorseSurface.Width,
                                  MySelf.HorseSurface.Height),MySelf.HorseSurface.ClientRect,MySelf.HorseSurface,True,100
        ); }
        if MySelf.m_BodySurface <> nil then
        ObjSurface.DrawAlpha(Bounds((MySelf.rx - Map.ClientRect.Left) * UNITX +defx+MySelf.px+MySelf.ShiftX,
                                  (MySelf.ry - Map.ClientRect.Top - 1) * UNITY + defy+MySelf.py+MySelf.ShiftY,
                                  MySelf.m_BodySurface.Width,
                                  MySelf.m_BodySurface.Height),MySelf.m_BodySurface.ClientRect,MySelf.m_BodySurface,True,100
        );

        //MySelf.DrawChr(ObjSurface, , True,True);
      end;

      if (MagicTarget <> nil) then begin
        if IsValidActor(MagicTarget) and (MagicTarget <> MySelf) then
          if MagicTarget.State and $00800000 = 0 then
            MagicTarget.DrawChr(ObjSurface,
              (MagicTarget.rx - Map.ClientRect.Left) * UNITX + defx,
              (MagicTarget.ry - Map.ClientRect.Top - 1) * UNITY + defy, True);
      end;
    except
      on E: Exception do
        DebugOutStr('108' + E.Message);
    end;
  end;

  try

    for k := 0 to ActorList.Count - 1 do begin
      Actor := ActorList[k];
      Actor.DrawEff(ObjSurface,
        (Actor.rx - Map.ClientRect.Left) * UNITX + defx,
        (Actor.ry - Map.ClientRect.Top - 1) * UNITY + defy);
    end;

    for k := 0 to EffectList.Count - 1 do begin
      meff := TMagicEff(EffectList[k]);

      meff.DrawEff(ObjSurface);
      if ViewFog then begin
        AddLight(meff.rx, meff.ry, 0, 0, meff.light, False);
      end;
    end;

    if ViewFog then begin
      for k := 0 to MapEffMan.EffList.Count - 1 do begin
        MapEff := TMapEff(MapEffMan.EffList[k]);
        if MapEff.light > 0 then
          AddLight(MapEff.X, MapEff.Y, 0, 0, MapEff.light, False);
      end;
    end;
  except
    on E: Exception do
      DebugOutStr('109' + E.Message);
  end;


  try
    for k := 0 to DropedItemList.Count - 1 do begin
      pd := PTDropItem(DropedItemList[k]);
      if pd <> nil then begin
        if NeiGua.Goods.ShowFilter = 1 then begin
          if not pd.Canshow then Continue;

        end;
        if GetTickCount - pd.FlashTime > 5 * 1000 then begin
          pd.FlashTime := GetTickCount;
          pd.BoFlash := True;
          pd.FlashStepTime := GetTickCount;
          pd.FlashStep := 0;
        end;
        if pd.BoFlash then begin
          if GetTickCount - pd.FlashStepTime >= 20 then begin
            pd.FlashStepTime := GetTickCount;
            Inc(pd.FlashStep);
          end;
          ix := (pd.X - Map.ClientRect.Left) * UNITX + defx + SOFFX;
          iy := (pd.Y - Map.ClientRect.Top - 1) * UNITY + defy + SOFFY;
          if (pd.FlashStep >= 0) and (pd.FlashStep < 10) then begin
            dsurface := WilPrguse.GetImage(FLASHBASE +
              pd.FlashStep, ax, ay);
            DrawBlend(ObjSurface, ix + ax, iy + ay, dsurface, DrawADDValue_MapObjects);
          end
          else
            pd.BoFlash := False;
        end;
      end;
    end;
  except
    on E: Exception do
      DebugOutStr('110' + E.Message);
  end;

  try
    if ViewFog then begin
      ApplyLightMap;
      DrawFog(ObjSurface, PFogScreen, FogWidth);
      MSurface.Draw(SOFFX, SOFFY, ObjSurface.ClientRect, ObjSurface, False);
    end
    else begin
      if MySelf.Death then   begin
        {if not FrmDlg.DWindow_Out.Visible then
          FrmDlg.DWindow_Out.Open;  }
        DrawEffect(0, 0, ObjSurface.Width, ObjSurface.Height, ObjSurface,
          ceGrayScale);
      end;
      MSurface.Draw(SOFFX, SOFFY, ObjSurface.ClientRect, ObjSurface, False);
    end;

  except
    on E: Exception do
      DebugOutStr('111' + E.Message);
  end;


end;





procedure TPlayScene.AddNewMagic(aowner: TActor;
  magid, magnumb, cx, cy, tx, ty, targetcode: Integer;
  mtype: TMagicType;
  Recusion: Boolean;
  AniTime: Integer;
  var bofly: Boolean);
var
  i, scx, scy, sctx, scty: Integer;
  imgIndex:SmallInt;
  meff: TMagicEff;
  target: TActor;
  wimg: TTilFile;
begin
  bofly := False;
  if magid <> 111 then
    for i := 0 to EffectList.Count - 1 do
      if TMagicEff(EffectList[i]).ServerMagicId = magid then
        Exit;
  ScreenXYfromMCXY(cx, cy, scx, scy);
  ScreenXYfromMCXY(tx, ty, sctx, scty);
  if magnumb > 0 then
    GetMagicEffectBase(magnumb - 1, wimg, imgIndex)
  else
    imgIndex := -magnumb; //Ҳ TasNat
  target := FindActor(targetcode);

  meff := nil;
  case mtype of
    mtReady, mtFly, mtFlyAxe: begin
        meff := TMagicEff.Create(magid, imgIndex, scx, scy, sctx, scty, mtype,
          Recusion, AniTime);
        if magnumb = 39 then
        begin
          meff.ImgLib := WilMagic2;
          meff.MagExplosionBase := 410;
        end;
        if magnumb = 40 then
        begin
          meff.ImgLib := WilMagic2;
          meff.MagExplosionBase := 570;
        end;
        if magnumb = 45 then begin
          meff.ImgLib := WilMagic2;
          meff.MagExplosionBase := 570;
        end;
        meff.TargetActor := target;
        bofly := True;
      end;
    mtExplosion: begin
        case magnumb of
          18: begin //ջ֮
              meff := TMagicEff.Create(magid, imgIndex, scx, scy, sctx, scty, mtype, Recusion, AniTime);
              meff.MagExplosionBase := 1570;
              meff.TargetActor := target;
              meff.NextFrameTime := 80;
            end;
          21: begin //ѻ
              meff := TMagicEff.Create(magid, imgIndex, scx, scy, sctx, scty, mtype, Recusion, AniTime);
              meff.MagExplosionBase := 1660;
              meff.TargetActor := nil;
              meff.NextFrameTime := 80;
              meff.ExplosionFrame := 20;
              meff.light := 3;
            end;
          26: begin //ʾ
              meff := TMagicEff.Create(magid, imgIndex, scx, scy, sctx, scty, mtype, Recusion, AniTime);
              meff.MagExplosionBase := 3990;
              meff.TargetActor := target;
              meff.NextFrameTime := 80;
              meff.ExplosionFrame := 10;
              meff.light := 2;
            end;
          27: begin //Ⱥ
              meff := TMagicEff.Create(magid, imgIndex, scx, scy, sctx, scty, mtype, Recusion, AniTime);
              meff.MagExplosionBase := 1800;
              meff.TargetActor := nil;
              meff.NextFrameTime := 80;
              meff.ExplosionFrame := 10;
              meff.light := 3;
            end;
          30: begin //ʥ
              meff := TMagicEff.Create(magid, imgIndex, scx, scy, sctx, scty, mtype, Recusion, AniTime);
              meff.MagExplosionBase := 3930;
              meff.TargetActor := target;
              meff.NextFrameTime := 80;
              meff.ExplosionFrame := 16;
              meff.light := 3;
            end;
          31: begin //
              meff := TMagicEff.Create(magid, imgIndex, scx, scy, sctx, scty, mtype, Recusion, AniTime);
              meff.MagExplosionBase := 3850;
              meff.TargetActor := nil;
              meff.NextFrameTime := 80;
              meff.ExplosionFrame := 20;
              meff.light := 3;
            end;
        else begin
            meff := TMagicEff.Create(magid, imgIndex, scx, scy, sctx, scty, mtype, Recusion, AniTime);
            meff.TargetActor := target;
            meff.NextFrameTime := 80;
          end;
        end;
      end;
    mtFireWind: begin

        meff := nil;
      end;
    mtFireGun:
      meff := TFireGunEffect.Create(930, scx, scy, sctx, scty);
    mtThunder: begin


        if magnumb = 41 then begin
          meff := TThuderEffect.Create(140, sctx, scty, nil);
          meff.ExplosionFrame := 20;
        end
        else begin
          meff := TThuderEffect.Create(10, sctx, scty, nil);
          meff.ExplosionFrame := 6;
        end;
        meff.ImgLib := WilMagic2;
        meff.NextFrameTime := 80;
      end;
    mtLightingThunder:
      meff := TLightingThunder.Create(970, scx, scy, sctx, scty, target);
    mtExploBujauk: begin
        case magnumb of
          10: begin //ħ
              meff := TExploBujaukEffect.Create(1160, scx, scy, sctx, scty,
                target);
              meff.MagExplosionBase := 1360;
            end;
          17: begin //
              meff := TExploBujaukEffect.Create(1160, scx, scy, sctx, scty,
                target);
              meff.MagExplosionBase := 1540;
            end;
        end;
        bofly := True;
      end;
    mtBujaukGroundEffect: begin
        meff := TBujaukGroundEffect.Create(1160, magnumb, scx, scy, sctx, scty);
        case magnumb of
          11, 12: meff.ExplosionFrame := 16; //    ʥս
          //: meff.ExplosionFrame := 16; //
        end;
        bofly := True;
      end;
    mtKyulKai: begin
        meff := nil;
      end;
  end;
  if meff = nil then
    Exit;

  meff.TargetRx := tx;
  meff.TargetRy := ty;
  if meff.TargetActor <> nil then begin
    meff.TargetRx := TActor(meff.TargetActor).XX;
    meff.TargetRy := TActor(meff.TargetActor).yy;
  end;
  meff.MagOwner := aowner;
  EffectList.Add(meff);
end;

procedure TPlayScene.DelMagic(magid: Integer);
var
  i: Integer;
begin
  for i := 0 to EffectList.Count - 1 do begin
    if TMagicEff(EffectList[i]).ServerMagicId = magid then begin
      TMagicEff(EffectList[i]).Free;
      EffectList.Delete(i);
      Break;
    end;
  end;
end;



function TPlayScene.NewFlyObject(aowner: TActor; cx, cy, tx, ty, targetcode:
  Integer; mtype: TMagicType): TMagicEff;
var
  i, scx, scy, sctx, scty: Integer;
  meff: TMagicEff;
begin
  ScreenXYfromMCXY(cx, cy, scx, scy);
  ScreenXYfromMCXY(tx, ty, sctx, scty);
  case mtype of
    mtFlyArrow: meff := TFlyingArrow.Create(1, 1, scx, scy, sctx, scty, mtype,
        True, 0);
  else
    meff := TFlyingAxe.Create(1, 1, scx, scy, sctx, scty, mtype, True, 0);
  end;
  meff.TargetRx := tx;
  meff.TargetRy := ty;
  meff.TargetActor := FindActor(targetcode);
  meff.MagOwner := aowner;
  FlyList.Add(meff);
  Result := meff;
end;

procedure TPlayScene.ScreenXYfromMCXY(cx, cy: Integer; var sx, sy: Integer);
begin
  if MySelf = nil then
    Exit;
  sx := (cx - MySelf.rx) * UNITX + 364 + UNITX div 2 - MySelf.ShiftX;
{$IF Ver_LCJ}
  sy := (cy - MySelf.ry) * UNITY + (192 + UNITY*2) + UNITY div 2 - MySelf.ShiftY;
{$ELSE}
  sy := (cy - MySelf.ry) * UNITY + (192) + UNITY div 2 - MySelf.ShiftY;
{$IFEND}
end;



procedure TPlayScene.CXYfromMouseXY(mx, my: Integer; var ccx, ccy: Integer);
begin
  if MySelf = nil then
    Exit;
  ccx := UpInt((mx - 364 + MySelf.ShiftX - UNITX) / UNITX) + MySelf.rx;
{$IF Ver_LCJ}
  ccy := UpInt((my - (192 + UNITY*2) + MySelf.ShiftY - UNITY) / UNITY) + MySelf.ry;
{$ELSE}
  ccy := UpInt((my - (192) + MySelf.ShiftY - UNITY) / UNITY) + MySelf.ry;
{$IFEND}
end;



function TPlayScene.GetCharacter(X, Y, wantsel: Integer; var nowsel: Integer;
  liveonly: Boolean): TActor;
var
  k, i, ccx, ccy, dx, dy: Integer;
  a: TActor;
begin
  Result := nil;
  nowsel := -1;
  CXYfromMouseXY(X, Y, ccx, ccy);
  for k := ccy + 8 downto ccy - 1 do begin
    for i := ActorList.Count - 1 downto 0 do
      if TActor(ActorList[i]) <> MySelf then begin
        a := TActor(ActorList[i]);
        if (not liveonly or not a.Death) and (a.BoHoldPlace) and (a.isVisible)
          then begin
          if a.yy = k then begin

            dx := (a.rx - Map.ClientRect.Left) * UNITX + DefXX + a.px +
              a.ShiftX;
            dy := (a.ry - Map.ClientRect.Top - 1) * UNITY + Defyy + a.py +
              a.ShiftY;
            if a.CheckSelect(X - dx, Y - dy) then begin
              Result := a;
              Inc(nowsel);
              if nowsel >= wantsel then
                Exit;
            end;
          end;
        end;
      end;
  end;
end;



function TPlayScene.GetAttackFocusCharacter(X, Y, wantsel: Integer; var nowsel:
  Integer; liveonly: Boolean): TActor;
var
  k, i, ccx, ccy, dx, dy, centx, centy: Integer;
  a: TActor;
begin
  Result := GetCharacter(X, Y, wantsel, nowsel, liveonly);
  if Result = nil then begin
    nowsel := -1;
    CXYfromMouseXY(X, Y, ccx, ccy);
    for k := ccy + 8 downto ccy - 1 do begin
      for i := ActorList.Count - 1 downto 0 do
        if TActor(ActorList[i]) <> MySelf then begin
          a := TActor(ActorList[i]);
          if (not liveonly or not a.Death) and (a.BoHoldPlace) and (a.isVisible)
            then begin
            if a.yy = k then begin

              dx := (a.rx - Map.ClientRect.Left) * UNITX + DefXX + a.px +
                a.ShiftX;
              dy := (a.ry - Map.ClientRect.Top - 1) * UNITY + Defyy + a.py +
                a.ShiftY;
              if a.CharWidth > 40 then
                centx := (a.CharWidth - 40) div 2
              else
                centx := 0;
              if a.CharHeight > 70 then
                centy := (a.CharHeight - 70) div 2
              else
                centy := 0;
              if (X - dx >= centx) and (X - dx <= a.CharWidth - centx) and (Y -
                dy >= centy) and (Y - dy <= a.CharHeight - centy) then begin
                Result := a;
                Inc(nowsel);
                if nowsel >= wantsel then
                  Exit;
              end;
            end;
          end;
        end;
    end;
  end;
end;

function TPlayScene.IsSelectMyself(X, Y: Integer): Boolean;
var
  k, i, ccx, ccy, dx, dy: Integer;
begin
  Result := False;
  CXYfromMouseXY(X, Y, ccx, ccy);
  for k := ccy + 2 downto ccy - 1 do begin
    if MySelf.yy = k then begin

      dx := (MySelf.rx - Map.ClientRect.Left) * UNITX + DefXX + MySelf.px +
        MySelf.ShiftX;
      dy := (MySelf.ry - Map.ClientRect.Top - 1) * UNITY + Defyy + MySelf.py +
        MySelf.ShiftY;
      if MySelf.CheckSelect(X - dx, Y - dy) then begin
        Result := True;
        Exit;
      end;
    end;
  end;
end;
procedure TPlayScene.GetDropItems2(mx, my: Integer; var List:TStringList);  
var
  i: Integer;
  d: PTDropItem;
begin
  if List = nil then Exit;
  for i := 0 to DropedItemList.Count - 1 do begin
    d := PTDropItem(DropedItemList[i]);
    if (d.X = mx) and (d.Y = my) then begin
      List.Add(d.Name);
    end;
  end;
end;

function TPlayScene.GetDropItems(X, Y: Integer; var inames: string): PTDropItem;

var
  i, ccx, ccy, ssx, ssy, dx, dy: Integer;
  d: PTDropItem;
  s: TDirectDrawSurface;
  c: Byte;
begin
  s := nil;
  Result := nil;
  CXYfromMouseXY(X, Y, ccx, ccy);
  ScreenXYfromMCXY(ccx, ccy, ssx, ssy);
  dx := X - ssx;
  dy := Y - ssy;
  inames := '';
  for i := 0 to DropedItemList.Count - 1 do begin
    d := PTDropItem(DropedItemList[i]);
    if NeiGua.Goods.ShowFilter = 1 then begin
      if not d.Canshow then Continue;

    end;
    if (d.X = ccx) and (d.Y = ccy) then begin
      s := GetDnItems(d.looks);
      if s = nil then
        continue;
      dx := (X - ssx) + (s.Width div 2) - 3;
      dy := (Y - ssy) + (s.Height div 2);
      c := s.Pixels[dx, dy];
      if c <> 0 then begin
        if Result = nil then
          Result := d;
        inames := inames + d.Name + '\';

      end;
    end;
  end;
end;

function TPlayScene.CanRun(sx, sy, ex, ey: Integer): Boolean;
var
  ndir, rx, ry, rx1, ry1: Integer;
begin
  ndir := GetNextDirection(sx, sy, ex, ey);
  rx := sx;
  ry := sy;
  GetNextPosXY(ndir, rx, ry);


  if CanWalk(rx, ry) and CanWalk(ex, ey) then begin
    if (MySelf.Horse > 0) then begin
      rx1 := rx;
      ry1 := ry;
      GetNextPosXY(ndir, rx1, ry1);
      Result := CanWalk(rx1, ry1);
    end
    else
      Result := True;
  end
  else
    Result := False;
end;

function TPlayScene.CanWalk(mx, my: Integer): Boolean;
begin
  Result := False;
  if Map.FixCanMove(mx, my) then
    Result := not CrashActor(mx, my);
end;

function TPlayScene.CrashActor(mx, my: Integer): Boolean;
var
  i,j: Integer;
  a: TActor;
begin
  Result := False;

  if (NeiGua.Base.CanCrashMon = 1) and (Neigua.Base.CanCrashMan = 1) and
    (ServerSetup.Base.CanCrashMon > 0) and (ServerSetup.Base.CanCrashMan > 0) then
    Exit;


  for i := 0 to ActorList.Count - 1 do begin
    a := TActor(ActorList[i]);
    if (a.isVisible) and (a.BoHoldPlace) and (not a.Death) then begin
      if (a.XX = mx) and (a.yy = my) then begin
        if (ServerSetup.Base.CanCrashMan > 0) and (neigua.Base.CanCrashMan = 1) and (a.Race = 0) then begin
          Result := False;
          Break;
        end;
        if (ServerSetup.Base.CanCrashMon > 0) and (neigua.Base.CanCrashMon = 1) and (a.Race <> 0) then begin
          Result := False;
          Break;
        end; 
        Result := True;
        Break;
      end;
    end;
  end;
  {if Result then
  if (Map.CurrentMap = '0') or (Map.CurrentMap = '3') or (Map.CurrentMap = 'HELL00') then begin
    if (Map.CurrentMap = '0') then
      Result := not ((((mx >= 289-10) and( mx<= 289+10)) and (my >= 618-10) and( my<= 618+10)) or
                ((mx >= 650-10) and( mx<= 650+10) and (my >= 631-10) and( my<= 631+10)) or
                ((mx >= 334-10) and( mx<= 334+10)) and ((my >= 266-10) and( my<= 266+10)));
    if (Map.CurrentMap = 'HELL00') then
      Result := not ((mx >= 53-10) and( mx<= 53+10)) and ((my >= 232-10) and( my<= 232+10));
    if (Map.CurrentMap = '3') then
      Result := not ((mx >= 330-10) and( mx<= 330+10)) and ((my >= 330-10) and( my<= 330+10));
  end; }
end;

function TPlayScene.CanFly(mx, my: Integer): Boolean;
begin
  Result := Map.CanFly(mx, my);
end;




function TPlayScene.FindActorByName(Name: string): TActor;
var
  i: Integer;
begin
  Result := nil;
  for i := 0 to ActorList.Count - 1 do begin
    DScreen.AddChatBoardString(TActor(ActorList[i]).UserName + ':' + inttostr(TActor(ActorList[i]).RecogId), 0, 255);
    if TActor(ActorList[i]).UserName = Name then begin

      Result := TActor(ActorList[i]);
      Break;
    end;
  end;
end;

function TPlayScene.FindActor(id: Integer): TActor;
var
  i: Integer;
begin
  Result := nil;
  for i := 0 to ActorList.Count - 1 do begin
    if ActorList[i] = nil then Continue;
    if TActor(ActorList[i]).RecogId = id then begin
      Result := TActor(ActorList[i]);
      Break;
    end;
  end;
end;

function TPlayScene.ActorToPlayActor(id: Integer): TPlayActor;
var
  Actor: TActor;
begin
  Actor := nil;
  Actor := FindActor(id);
  if Actor = nil then Exit;
  Result := TPlayActor.Create;
  Result.RecogId := Actor.RecogId;
  Result.XX := Actor.XX;
  Result.yy := Actor.yy;
  Result.RX := Actor.RX;
  Result.RY := Actor.RY;
  Result.Dir := Actor.Dir;
  Result.Feature := Actor.Feature;
  Result.Race := Actor.Race;
  Result.hair := Actor.hair;
  Result.dress := Actor.dress;
  Result.weapon := Actor.weapon;
  Result.Appearance := Actor.Appearance;
  Result.sex := Actor.sex;
  Result.State := Actor.State;
  Result.saying := Actor.saying;
  Result.m_Abil := Actor.m_Abil;
  Result.UserName := Actor.UserName;
  DeleteActor(Actor.RecogId);
  ActorList.Add(Result);

end;

function TPlayScene.FindActorXY(X, Y: Integer): TActor;
var
  i: Integer;
begin
  Result := nil;
  for i := 0 to ActorList.Count - 1 do begin
    if (TActor(ActorList[i]).XX = X) and (TActor(ActorList[i]).yy = Y) then begin
      Result := TActor(ActorList[i]);
      if not Result.Death and Result.isVisible and Result.BoHoldPlace then
        Break;
    end;
  end;
end;

function TPlayScene.IsValidActor(Actor: TActor): Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := 0 to ActorList.Count - 1 do begin
    if TActor(ActorList[i]) = Actor then begin
      Result := True;
      Break;
    end;
  end;
end;

function TPlayScene.NewActor(chrid: Integer;
  cx: Word;
  cy: Word;
  cdir: Word;
  cfeature: Integer;
  cstate: Integer; isPlay: Boolean = False): TActor;
var
  i: Integer;
  Actor: TActor;
begin
  Result := nil;
  for i := 0 to ActorList.Count - 1 do
    if TActor(ActorList[i]).RecogId = chrid then begin
      Result := TActor(ActorList[i]);
      Exit;
    end;
  if IsChangingFace(chrid) then
    Exit;

  if isPlay then begin
    Actor := TPlayActor.Create;
  end else
    case RACEfeature(cfeature) of
    0: Actor := THumActor.Create; //
    9: Actor := TSoccerBall.Create; //
    13: Actor := TKillingHerb.Create; //ʳ˻
    14: Actor := TSkeletonOma.Create; //
    15: Actor := TDualAxeOma.Create; //

    16: Actor := TGasKuDeGi.Create; //

    17: Actor := TCatMon.Create; //צè
    18: Actor := THuSuABi.Create; //
    19: Actor := TCatMon.Create; //սʿ

    20: Actor := TFireCowFaceMon.Create; //
    21: Actor := TCowFaceKing.Create; //
    22: Actor := TDualAxeOma.Create; //ڰսʿ
    23: Actor := TWhiteSkeleton.Create; //
    24: Actor := TSuperiorGuard.Create; //ʿ
    30: Actor := TCatMon.Create; //
    31: Actor := TCatMon.Create; //Ӭ
    32: Actor := TScorpionMon.Create; //Ы

    33: Actor := TCentipedeKingMon.Create; //
    34: Actor := TBigHeartMon.Create; //¶ħ
    35: Actor := TSpiderHouseMon.Create; //Ӱ֩
    36: Actor := TExplosionSpider.Create; //ħ֩
    37: Actor := TFlyingSpider.Create; //

    40: Actor := TZombiLighting.Create; //ʬ1
    41: Actor := TZombiDigOut.Create; //ʬ2
    42: Actor := TZombiZilkin.Create; //ʬ3

    43: Actor := TBeeQueen.Create; //Ӭ

    45: Actor := TArcherMon.Create; //
    47: Actor := TSculptureMon.Create; //
    48: Actor := TSculptureMon.Create; //
    49: Actor := TSculptureKingMon.Create; //

    50: Actor := TNpcActor.Create;

    52: Actor := TGasKuDeGi.Create; //Ш
    53: Actor := TGasKuDeGi.Create; //
    54: Actor := TSmallElfMonster.Create; //
    55: Actor := TWarriorElfMonster.Create; //1

    60: Actor := TElectronicScolpionMon.Create;
    61: Actor := TBossPigMon.Create;
    62: Actor := TKingOfSculpureKingMon.Create;
    63: Actor := TSkeletonKingMon.Create;
    64: Actor := TGasKuDeGi.Create;
    65: Actor := TSamuraiMon.Create;
    66: Actor := TSkeletonSoldierMon.Create;
    67: Actor := TSkeletonSoldierMon.Create;
    68: Actor := TSkeletonSoldierMon.Create;
    69: Actor := TSkeletonArcherMon.Create;
    70: Actor := TBanyaGuardMon.Create;
    71: Actor := TBanyaGuardMon.Create;
    72: Actor := TBanyaGuardMon.Create;
    73: Actor := TPBOMA1Mon.Create;
    74: Actor := TCatMon.Create;
    75: Actor := TStoneMonster.Create;
    76: Actor := TSuperiorGuard.Create;
    77: Actor := TStoneMonster.Create;
    78: Actor := TBanyaGuardMon.Create;
    79: Actor := TPBOMA6Mon.Create;
    80: Actor := TMineMon.Create;
    81: Actor := TAngel.Create;
    83: Actor := TFireDragon.Create;
    84: Actor := TDragonStatue.Create;

    90: Actor := TDragonBody.Create; //
    98: Actor := TWallStructure.Create; //LeftWall
    99: Actor := TCastleDoor.Create; //MainDoor

    else
      Actor := TActor.Create;
    end;

  with Actor do begin
    RecogId := chrid;
    XX := cx;
    yy := cy;
    rx := XX;
    ry := yy;
    Dir := cdir;
    Feature := cfeature;
    Race := RACEfeature(cfeature);
    hair := HAIRfeature(cfeature);
    dress := DRESSfeature(cfeature);
    weapon := WEAPONfeature(cfeature);
    Appearance := APPRfeature(cfeature);
    if Race = 0 then begin
      sex := dress mod 2;
    end
    else
      sex := 0;
    State := cstate;
    saying[0] := '';
  end;
  ActorList.Add(Actor);
  Result := Actor;
end;

procedure TPlayScene.ActorDied(Actor: TObject);
var
  i: Integer;
  flag: Boolean;
begin
  for i := 0 to ActorList.Count - 1 do
    if ActorList[i] = Actor then begin
      ActorList.Delete(i);
      Break;
    end;
  flag := False;
  for i := 0 to ActorList.Count - 1 do
    if not TActor(ActorList[i]).Death then begin
      ActorList.Insert(i, Actor);
      flag := True;
      Break;
    end;
  if not flag then
    ActorList.Add(Actor);
end;

procedure TPlayScene.SetActorDrawLevel(Actor: TObject; Level: Integer);
var
  i: Integer;
begin
  if Level = 0 then begin
    for i := 0 to ActorList.Count - 1 do
      if ActorList[i] = Actor then begin
        ActorList.Delete(i);
        ActorList.Insert(0, Actor);
        Break;
      end;
  end;
end;

procedure TPlayScene.ClearAllActorsAndMagicEff;
var
  i: Integer;
begin
  for i := 0 to ActorList.Count - 1 do
    if ActorList[i] <> nil then
      TActor(ActorList[i]).Free;
  ActorList.Clear;

  MySelf := nil;
  MyHero := nil;
  TargetCret := nil;
  FocusCret := nil;
  MagicTarget := nil;


  for i := 0 to EffectList.Count - 1 do
    TMagicEff(EffectList[i]).Free;
  EffectList.Clear;
end;

function TPlayScene.DeleteActor(id: Integer): TActor;
var
  i: Integer;
begin
  Result := nil;
  i := 0;
  while True do begin
    if i >= ActorList.Count then
      Break;
    if TActor(ActorList[i]).RecogId = id then begin
      if TargetCret = TActor(ActorList[i]) then
        TargetCret := nil;
      if FocusCret = TActor(ActorList[i]) then
        FocusCret := nil;
      if MagicTarget = TActor(ActorList[i]) then
        MagicTarget := nil;
      TActor(ActorList[i]).DeleteTime := GetTickCount;
      FreeActorList.Add(ActorList[i]);

      ActorList.Delete(i);
    end
    else
      Inc(i);
  end;
end;

procedure TPlayScene.DelActor(Actor: TObject);
var
  i: Integer;
begin
  for i := 0 to ActorList.Count - 1 do
    if ActorList[i] = Actor then begin
      TActor(ActorList[i]).DeleteTime := GetTickCount;
      FreeActorList.Add(ActorList[i]);
      ActorList.Delete(i);
      Break;
    end;
end;

function TPlayScene.ButchAnimal(X, Y: Integer): TActor;
var
  i: Integer;
  a: TActor;
begin
  Result := nil;
  for i := 0 to ActorList.Count - 1 do begin
    a := TActor(ActorList[i]);
    if a.Death and (a.Race <> 0) then begin
      if (abs(a.XX - X) <= 1) and (abs(a.yy - Y) <= 1) then begin
        Result := a;
        Break;
      end;
    end;
  end;
end;


procedure TPlayScene.AddAction(ident, chrid, X, Y, cdir, Feature, State: Integer;
  Str: string);
var
  Actor: TActor;
  i: integer;
  sMapFile: string;
begin
  case ident of
    SM_CHANGEMAP,
      SM_NEWMAP: begin
        //DScreen.AddDebugChatBoardString(SM_ToStr(ident));
        //DScreen.AddDebugChatBoardString(Str);
        Str := GetValidStr3(Str, sMapFile, ['/']);
        Str := GetValidStr3(Str, MapTitle, ['/']);
        MiniMapIndex := Feature - 1;
        

        //DScreen.AddDebugChatBoardString(IntToStr(Feature));
        g_SearchMap.MapHeight := -1;
        Map.LoadMap(sMapFile, X, Y);
        DarkLevel := cdir;
        if DarkLevel = 0 then
          ViewFog := False
        else
          ViewFog := True;

        if (ident = SM_NEWMAP) and (MySelf <> nil) then begin
          MySelf.XX := X;
          MySelf.yy := Y;
          MySelf.rx := X;
          MySelf.ry := Y;
          DelActor(MySelf);
        end;
      end;
    SM_LOGON: begin

        Actor := FindActor(chrid);
        if Actor = nil then begin
          Actor := NewActor(chrid, X, Y, Lobyte(cdir), Feature, State, True);
          Actor.ChrLight := Hibyte(cdir);

          cdir := Lobyte(cdir);

          Actor.AddAction(SM_TURN, X, Y, cdir, Feature, State, '', 0);
        end;
        if MySelf <> nil then begin
          MySelf := nil;
        end;
        MySelf := TPlayActor(Actor);
        
      end;
    SM_HIDE: begin
        Actor := FindActor(chrid);
        if Actor <> nil then begin
          if Actor.BoDelActionAfterFinished then begin
            Exit;
          end;
          if Actor.WaitForRecogId <> 0 then begin
            Exit;
          end;
        end;
        DeleteActor(chrid);
      end;
  else begin
      Actor := FindActor(chrid);
      if (ident = SM_TURN) or (ident = SM_RUN) or (ident = SM_WALK) or
        (ident = SM_BACKSTEP) or
        (ident = SM_DEATH) or (ident = SM_SKELETON) or
        (ident = SM_DIGUP) or (ident = SM_ALIVE) then begin
        if Actor = nil then
          Actor := NewActor(chrid, X, Y, Lobyte(cdir), Feature, State);
        if Actor <> nil then begin
          actor.XX1 := x;
          Actor.yy1 := y;
          Actor.ChrLight := Hibyte(cdir);
          if (Actor.ChrLight > 0) and (Actor.Race = 0) then begin
            GameWindows.SendClientMessage(CM_QUERYUSERSTATE, Actor.RecogId,
              Actor.XX, Actor.yy, 0);
          end;
          cdir := Lobyte(cdir);
          if ident = SM_SKELETON then begin
            Actor.Death := True;
            Actor.Skeleton := True;
          end;
        end;
      end;
      if Actor = nil then
        Exit;
      case ident of
        SM_FEATURECHANGED: begin
            Actor.Feature := Feature;
            Actor.HorseState := State;
            Actor.FeatureChanged;
          end;
        SM_CHARSTATUSCHANGED: begin
            Actor.State := Feature;
            Actor.HitSpeed := State;
          end;
      else begin
          if ident = SM_TURN then begin
            if Str <> '' then begin
              Actor.UserName := Str;
            end;
          end;
          Actor.AddAction(ident, X, Y, cdir, Feature, State, '', 0);
        end;
      end;
    end;
  end;
end;


end.






















