unit addpic;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, SUIForm, StdCtrls, SUIEdit, SUIButton, SUIImagePanel,
  SUIGroupBox, FileCtrl, PBFolderDialog, SUIProgressBar, ComCtrls,DIB;

type
  TFormadd = class(TForm)
    suiForm1: TsuiForm;
    Label1: TLabel;
    EditPicPath: TsuiEdit;
    suiButton1: TsuiButton;
    suiButton2: TsuiButton;
    suiButton3: TsuiButton;
    GroupBoxxy: TsuiGroupBox;
    RabtnFile: TsuiRadioButton;
    suiRadioButton2: TsuiRadioButton;
    editxy: TsuiEdit;
    suiProgressBar1: TProgressBar;
    suiGroupBox2: TsuiGroupBox;
    suiGroupBox3: TsuiGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    EditEnd: TsuiEdit;
    editBegin: TsuiEdit;
    RabtnAdd: TsuiRadioButton;
    RabtnInsert: TsuiRadioButton;
    RabtnReplace: TsuiRadioButton;
    suiGroupBox4: TsuiGroupBox;
    RabtnAll: TsuiRadioButton;
    RabtnPic: TsuiRadioButton;
    Rabtnxy: TsuiRadioButton;
    PBFolderDialog1: TPBFolderDialog;
    procedure suiButton1Click(Sender: TObject);
    procedure suiButton3Click(Sender: TObject);
    procedure RabtnInsertClick(Sender: TObject);
    function AddAll:Boolean;
    function AddPic:Boolean;
    function AddXy:Boolean;
    FunCtion  Add(FileList:Tstrings;Path:String;XyMode:Byte):Boolean;
    FunCtion  InSert(FileList:Tstrings;XyMode:Byte;BeginIndex:Integer):Boolean;
    FunCtion  Replace(FileList:Tstrings;XyMode:Byte;BeginIndex,EndIndex:Integer):Boolean;
    procedure RabtnPicClick(Sender: TObject);
    procedure suiButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Formadd: TFormadd;
  PicPath,FileName:String;
implementation

uses mail;



{$R *.dfm}
function  ExtractFileNameOnly (const fname: string): string;
var
   extpos: integer;
   ext, fn: string;
begin
   ext := ExtractFileExt (fname);
   fn := ExtractFileName (fname);
   if ext <> '' then begin
      extpos := pos (ext, fn);
      Result := Copy (fn, 1, extpos-1);
   end else
      Result := fn;
end;
procedure TFormadd.suiButton1Click(Sender: TObject);
begin
 if  PBFolderDialog1.Execute then
    EditPicpath.Text:=PBFolderDialog1.SelectedFolder;
end;
function TFormadd.AddAll:boolean;
var
 BeginIndex,EndIndex,code,i,mode:Integer;
xy,t:string;
x,y:smallint;
xxx,count:integer;
FileList:TFileListBox;
tempname,path:String;
xyList:TStringList;
begin
  Result:=False;
  if EditPicPath.Text='' then
  Begin
     FormMain.showErrMessage('ͼƬ·!');
     Exit;
  End;
  Application.ProcessMessages;
  Path:=EditPicPath.Text;
  if Path[length(Path)]<>'\' then Path:=Path+'\';
  FileList:=TFileListBox.Create(self);
  FileList.Parent:=Formadd;
  FileList.Directory:=EditPicPath.Text;
  FileList.Mask:='*.bmp';
  FileList.Visible:=False;
  if RabtnFile.Checked then
     Mode:=0
  else
     Mode:=1;
  if RaBtnAdd.Checked then
     Add(FileList.Items,EditPicPath.Text,Mode)
  else
    if RaBtnInsert.Checked then
    Begin
      val(EditBegin.Text,BeginIndex,code);
      if (code>0) or (BeginIndex>Wil.ImageCount-1) or (BeginIndex<0) then
      Begin
        FormMain.ShowErrMessage('ȷı');
        EditBegin.SetFocus;
        exit;
      End;
      val(EditEnd.Text,EndIndex,code);
      if (code>0)or (EndIndex>Wil.ImageCount-1) or (EndIndex<0) or (EndIndex<BeginIndex) then
      Begin
        FormMain.ShowErrMessage('ȷı');
        EditEnd.SetFocus;
        exit;
      End;
      Insert(FileList.Items,Mode,BeginIndex);
    end
    else
      if RaBtnReplace.Checked then
      Begin
        val(EditBegin.Text,BeginIndex,code);
        if (code>0) or (BeginINdex>Wil.ImageCount-1) or (BeginIndex<0) then
        Begin
          FormMain.ShowErrMessage('ȷı');
          EditBegin.SetFocus;
          exit;
        End;
        val(EditEnd.Text,EndIndex,code);
        if (code>0)or (EndIndex>Wil.ImageCount-1) or (EndIndex<0) or (EndIndex<BeginIndex) then
        Begin
          FormMain.ShowErrMessage('ȷı');
          EditEnd.SetFocus;
          exit;
        End;
        if (EndIndex-BeginIndex+1)>FileList.Items.Count then
        Begin
          FormMain.ShowErrMessage('ͼƬĿ');
          EditEnd.SetFocus;
          exit;
        End;
        Replace(FileList.Items,Mode,BeginIndex,EndIndex);
      End;
  Result:=True;

end;

function TFormadd.AddPic:boolean;
var
 BeginIndex,EndIndex,code,i,mode:Integer;
 BitMap:TBitmap;
 Path:String;
 FileList:TFileListBox;
Begin
  Result:=True;
  if EditPicPath.Text='' then
  Begin
     FormMain.showErrMessage('ͼƬ·!');
     Exit;
  End;
    Path:=EditPicPath.Text;
  if Path[length(Path)]<>'\' then Path:=Path+'\';
  FileList:=TFileListBox.Create(self);
  FileList.Parent:=Formadd;
  FileList.Directory:=EditPicPath.Text;
  FileList.Mask:='*.bmp';
  FileList.Visible:=False;
  val(EditBegin.Text,BeginIndex,code);
  if (code>0) or (BeginIndex>Wil.ImageCount-1) or (BeginIndex<0) then
   Begin
     FormMain.ShowErrMessage('ȷı');
     EditBegin.SetFocus;
     exit;
   End;
   val(EditEnd.Text,EndIndex,code);
   if (code>0)or (EndIndex>Wil.ImageCount-1) or (EndIndex<0) or (EndIndex<BeginIndex) then
   Begin
     FormMain.ShowErrMessage('ȷı');
     EditEnd.SetFocus;
     exit;
   End;
    BitMap:=TBitmap.Create;
   suiProgressBar1.Max:=EndIndex-BeginIndex+1;
   suiProgressBar1.Position:=0;
   suiProgressBar1.Visible:=True;
   if (EndIndex-BeginINdex+1)>FileList.Items.Count then
   Begin
     FormMain.ShowErrMessage('ͼƬĿ');
     EditEnd.SetFocus;
     exit;
   End;
   for i:=BeginIndex to EndIndex do
   Begin
     try
      BitMap.LoadFromFile(Path+format('%.6d.bmp',[i]));
     except
       BitMap.Width:=1;
       BitMap.Height:=1;
       BitMap.Canvas.Pixels[0,0]:=0;
     End;
     suiProgressBar1.StepIt;
     Wil.ReplaceBitMap(i,Bitmap);
   End;
   suiProgressBar1.Visible:=False;
   Result:=True;
end;
function TFormadd.AddXy:boolean;
var
 BeginIndex,EndIndex,code,i,mode,count:Integer;
 BitMap:TBitmap;
 Path:String;
   xy,t:string;
  x,y:smallint;
  xyList:TStringList;
Begin
  Result:=false;
  if (EditPicPath.Text='') and RabtnFile.Checked then
  Begin
     FormMain.showErrMessage('ͼƬ·!');
     Exit;
  End;
  if EditPicPath.Text<>'' then
  Begin
    Path:=EditPicPath.Text;
    if Path[length(Path)]<>'\' then Path:=Path+'\';

  end;
      xyList:=TStringList.Create;
  val(EditBegin.Text,BeginIndex,code);
  if (code>0) or (BeginIndex>Wil.ImageCount-1) or (BeginIndex<0) then
   Begin
     FormMain.ShowErrMessage('ȷı');
     EditBegin.SetFocus;
     exit;
   End;
   val(EditEnd.Text,EndIndex,code);
   if (code>0)or (EndIndex>Wil.ImageCount-1) or (EndIndex<0) or (EndIndex<BeginIndex) then
   Begin
     FormMain.ShowErrMessage('ȷı');
     EditEnd.SetFocus;
     exit;
   End;
   suiProgressBar1.Max:=EndIndex-BeginIndex+1;
   suiProgressBar1.Position:=0;
   suiProgressBar1.Visible:=True;

   for i:=BeginIndex to EndIndex do
   Begin
        x:=0;
        y:=0;
        if RabtnFile.Checked then
        Begin
          t:=path+format('%.6d.txt',[i]);
          if FileExists(t) then
          Begin
           xyList.LoadFromFile(t);
           xy:=XyList.Strings[0];
           val(xy,x,count);
           xy:=XyList.Strings[1];
           val(xy,y,count);
          end;
        end
        else
        Begin
         try
          xy:=Editxy.Text;
          Xy:=Copy(xy,1,Pos(',',xy)-1);
          val(xy,x,count);
          xy:=Editxy.Text;
          Xy:=Copy(xy,Pos(',',xy)+1,Length(xy)-Pos(',',xy));
          val(xy,y,count);
         except
           x:=0;
           y:=0;
         end;
        End;

     suiProgressBar1.StepIt;
     wil.Changex(i,x);
     wil.Changey(i,y);
   End;
   suiProgressBar1.Visible:=False;
   if xyList<>nil then
      xyList.Free;
   Result:=True;
end;
procedure TFormadd.suiButton3Click(Sender: TObject);
begin
close;
end;

procedure TFormadd.RabtnInsertClick(Sender: TObject);
begin
 suiGroupBox2.Enabled:=Not RaBtnAdd.Checked;
 EditEnd.Enabled:=RabtnReplace.Checked;

end;
//ͼƬ
FunCtion  TFormadd.Add(FileList:Tstrings;Path:String;XyMode:Byte):Boolean;
var
  i:Integer;
  tmpDib,Dib:TDib;
  Temp:TFileStream;
  Temp1:TFileStream;
  idxFile:String;
  v:smallint;
  offset,count,FImageCount:integer;
  xy,t:string;
  x,y:smallint;
  DBits:PByte;
  xyList:TStringList;
Begin
  Result:=True;
  Try
     FImageCount:=Wil.ImageCount;
     FImageCount:=FImageCount+FileList.Count;
     TmpDib:=TDib.Create;
     Dib:=TDib.Create;
     Dib.BitCount:=8;
     Dib.ColorTable:=Wil.MainPalette;
     Dib.UpdatePalette;
     suiProgressBar1.Max:=FileList.Count;
     suiProgressBar1.Position:=0;
     suiProgressBar1.Visible:=True;
     idxfile := ExtractFilePath(WIl.FileName) + ExtractFileNameOnly(WIl.FileName) + '.WIX';
     xyList:=TStringList.Create;
     Temp:= TFileStream.Create (idxfile, fmOpenReadWrite or fmShareDenyNone);
     Temp.Seek(0,2);
     Wil.Stream.Seek(0,2);
     For I:=0 to FileList.Count-1 do
     Begin
        Application.ProcessMessages;
        suiProgressBar1.Position:=i;
        tmpDib.Clear;
        try
          tmpDib.LoadFromFile(FileList.Strings[i]);
        except
          TmpDIb.Width:=1;
          TmpDIb.Height:=1;
        end;
        if TmpDib.Width<1 then
           TmpDIb.Width:=1;
        if TmpDib.Height<1 then
           TmpDIb.Height:=1;
        Dib.Width:=TmpDIb.Width;
        Dib.Height:=TmpDib.Height;
        Dib.Canvas.Draw(0,0,TmpDib);
//        Dib.SaveToFile('c:\1.bmp');
        //дͼƬĿ
        offset:=Wil.Stream.Size;
        v:=Dib.Width;
        Wil.Stream.Write(v,2);
        //дͼƬĸ߶
        v:=Dib.Height;
        Wil.Stream.Write(v,2);
        //дͼƬ
        x:=0;
        y:=0;
        if XyMode=0 then
        Begin
          t:=FileList.Strings[i];
          t:=ExtractFilepath(t)+'Placements\'+ExtractFileName(FileList.Strings[i]);
          t:=ChangeFileExt(t,'.txt');
          if FileExists(t) then
          Begin
           xyList.LoadFromFile(t);
           xy:=XyList.Strings[0];
           val(xy,x,count);
           xy:=XyList.Strings[1];
           val(xy,y,count);
          end;
        end
        else
        Begin
         try
          xy:=Editxy.Text;
          Xy:=Copy(xy,1,Pos(',',xy)-1);
          val(xy,x,count);
          xy:=Editxy.Text;
          Xy:=Copy(xy,Pos(',',xy)+1,Length(xy)-Pos(',',xy));
          val(xy,y,count);
         except
           x:=0;
           y:=0;
         end;
        End;
        Wil.Stream.Write(x,2);
        Wil.Stream.Write(y,2);
        if WIl.OffSet>0 then
        Begin
          Wil.Stream.Write(x,2);
          Wil.Stream.Write(y,2);
        End;
        DBits:=DIb.PBits;
        Wil.Stream.Write(DBits^,dib.Size);//lsDib.Height*lsDib.Width);

        Temp.Write(Offset,4);
     End;
     Wil.Stream.Seek(44,0);
     Wil.Stream.Write(FImageCount,4);
     Temp.Seek(44,0);
     Temp.Write(FImageCount,4);
     Temp.Free;
     Wil.Finalize;
     Wil.Initialize(FormMain.suiCheckBox1.Checked);
     FormMain.DrawGrid1.RowCount:=(Wil.ImageCount div 6)+1;
  Except
    Temp.Free;
    Result:=False;
  End;
End;
FunCtion  TFormadd.InSert(FileList:Tstrings;XyMode:Byte;BeginIndex:Integer):Boolean;
var
  i,endindex:Integer;
  tmpDib,Dib:TDib;
  Temp:TFileStream;
  Temp1:TMemoryStream;
  idxFile:String;
  v:smallint;
  offset,pos1,count,FImageCount:integer;
  xy,t:string;
  x,y:smallint;
  DBits:PByte;
  xyList:TStringList;
  index:Array of Integer;
Begin
  Result:=True;
  Try
     EndIndex:=BeginIndex+FileList.Count-1;
     FImageCount:=Wil.ImageCount;
     FImageCount:=FImageCount+EndIndex-BeginIndex+1;
     TmpDib:=TDib.Create;
     Dib:=TDib.Create;
     Dib.BitCount:=8;
     Dib.ColorTable:=Wil.MainPalette;
     Dib.UpdatePalette;
     suiProgressBar1.Max:=EndIndex-BeginIndex+1;
     suiProgressBar1.Position:=0;
     suiProgressBar1.Visible:=True;
     idxfile := ExtractFilePath(WIl.FileName) + ExtractFileNameOnly(WIl.FileName) + '.WIX';
     xyList:=TStringList.Create;
     Temp:= TFileStream.Create (idxfile, fmOpenReadWrite or fmShareDenyNone);
     Temp.Seek(0,2);
     SetLength(Index,FImageCount);
     //ԭλ
     for i:=0 to Beginindex-1  do
        Index[i]:=Wil.IndexList[i];
     for i:=Endindex+1 to Wil.ImageCount-1 do
        Index[i]:=Wil.IndexList[i];
      //ԭļ
     Temp1:=TMemoryStream.Create;
     Temp1.SetSize(Wil.Stream.Size-Wil.IndexList[BeginIndex]);
     Temp1.Seek(0,0);
     WIl.Stream.Seek(Wil.IndexList[BeginIndex],0);
          Application.ProcessMessages;
     Temp1.CopyFrom(WIl.Stream,Wil.Stream.Size-Wil.Stream.Position);
          Application.ProcessMessages;
     WIl.Stream.Seek(Wil.IndexList[BeginIndex],0);
     For I:=BeginIndex to EndIndex do
     Begin
        Application.ProcessMessages;
        suiProgressBar1.StepIt;
        tmpDib.Clear;
        OffSet:=Wil.IndexList[i];
        Try
         try
          tmpDib.LoadFromFile(FileList.Strings[i-BeginIndex]);
         except
           TmpDIb.Width:=1;
          TmpDIb.Height:=1;
         end;
         if TmpDib.Width<1 then
           TmpDIb.Width:=1;
         if TmpDib.Height<1 then
           TmpDIb.Height:=1;

          Dib.Width:=TmpDIb.Width;
          Dib.Height:=TmpDib.Height;
          Dib.Canvas.Draw(0,0,TmpDib);
        except  //ͼƬӿͼƬ
          Dib.Width:=1;
          Dib.Height:=1;
        End;
//        Dib.SaveToFile('c:\1.bmp');
        //дͼƬĿ
        Index[i]:=Wil.Stream.Position;
        v:=Dib.Width;
        Wil.Stream.Write(v,2);
        //дͼƬĸ߶
        v:=Dib.Height;
        Wil.Stream.Write(v,2);
        //дͼƬ
        x:=0;
        y:=0;
        if XyMode=0 then
        Begin
           t:=FileList.Strings[i-beginindex];
           t:=ExtractFilepath(t)+'Placements\'+ExtractFileName(FileList.Strings[i-BeginIndex]);
           t:=ChangeFileExt(t,'.txt');
           if FileExists(t) then
           Begin
             xyList.LoadFromFile(t);
             xy:=XyList.Strings[0];
             val(xy,x,count);
             xy:=XyList.Strings[1];
             val(xy,y,count);
           end;
        end
        else
        Begin
         try
          xy:=Editxy.Text;
          Xy:=Copy(xy,1,Pos(',',xy)-1);
          val(xy,x,count);
          xy:=Editxy.Text;
          Xy:=Copy(xy,Pos(',',xy)+1,Length(xy)-Pos(',',xy));
          val(xy,y,count);
         except
           x:=0;
           y:=0;
         end;
        End;
        Wil.Stream.Write(x,2);
        Wil.Stream.Write(y,2);
        if WIl.OffSet>0 then
        Begin
          Wil.Stream.Write(x,2);
          Wil.Stream.Write(y,2);
        End;
        DBits:=DIb.PBits;
        Wil.Stream.Write(DBits^,dib.Size);//lsDib.Height*lsDib.Width);

     End;
     Temp1.Seek(0,0);
     offset:=Wil.Stream.Position;
     Wil.Stream.CopyFrom(Temp1,Temp1.Size);
     Wil.Stream.Seek(44,0);
     Wil.Stream.Write(FImageCount,4);
     Temp.Seek(44,0);
     Temp.Write(FImageCount,4);
     pos1:=index[Endindex+1];
     index[EndIndex+1]:=Offset;
     for i:=Endindex+2 to Wil.ImageCount+EndIndex-BeginIndex do
     Begin
       Index[i]:=Wil.IndexList[i-EndIndex+BeginIndex-1]-Wil.IndexList[i-EndIndex+BeginIndex-2]+Index[i-1];

     End;
     Temp.Seek(48+Wil.OffSet,0);
     Temp.Write(Index[0],FImageCount*4);
     Temp.Free;
     Temp1.Free;
     Wil.Finalize;
     Wil.Initialize((FormMain.suiCheckBox1.Checked));
     tmpDib.Free;
     FormMain.DrawGrid1.RowCount:=(Wil.ImageCount div 6)+1;
  Except
    Temp.Free;
    Result:=False;
  End;
End;
FunCtion  TFormadd.Replace(FileList:Tstrings;XyMode:Byte;BeginIndex,EndIndex:Integer):Boolean;
var
  i:Integer;
  tmpDib,Dib:TDib;
  Temp:TFileStream;
  Temp1:TMemoryStream;
  idxFile:String;
  v:smallint;
  offset,pos1,count,FImageCount:integer;
  xy,t:string;
  x,y:smallint;
  DBits:PByte;
  xyList:TStringList;
  index:Array of Integer;
Begin
  Result:=True;
  Try
     FImageCount:=Wil.ImageCount;
  //   FImageCount:=FImageCount+EndIndex-BeginIndex+1;
     TmpDib:=TDib.Create;
     Dib:=TDib.Create;
     Dib.BitCount:=8;
     Dib.ColorTable:=Wil.MainPalette;
     Dib.UpdatePalette;
     suiProgressBar1.Max:=EndIndex-BeginIndex+1;
     suiProgressBar1.Position:=0;
     suiProgressBar1.Visible:=True;
     idxfile := ExtractFilePath(WIl.FileName) + ExtractFileNameOnly(WIl.FileName) + '.WIX';
     xyList:=TStringList.Create;
     Temp:= TFileStream.Create (idxfile, fmOpenReadWrite or fmShareDenyNone);
     Temp.Seek(0,2);
     SetLength(Index,FImageCount);
     //ԭλ
     for i:=0 to Beginindex-1  do
        Index[i]:=Wil.IndexList[i];
     for i:=Endindex+1 to Wil.ImageCount-1 do
        Index[i]:=Wil.IndexList[i];
      //ԭļ
     Temp1:=TMemoryStream.Create;
     Application.ProcessMessages;
     Temp1.SetSize(Wil.Stream.Size-Wil.IndexList[EndIndex+1]);
     Temp1.Seek(0,0);
     WIl.Stream.Seek(Wil.IndexList[EndIndex+1],0);
     Temp1.CopyFrom(WIl.Stream,Wil.Stream.Size-Wil.Stream.Position);
          Application.ProcessMessages;
     WIl.Stream.Seek(Wil.IndexList[BeginIndex],0);
     For I:=BeginIndex to EndIndex do
     Begin
        Application.ProcessMessages;
        suiProgressBar1.StepIt;
        tmpDib.Clear;
        OffSet:=Wil.IndexList[i];
        Try
          tmpDib.LoadFromFile(FileList.Strings[i-beginindex]);
          Dib.Width:=TmpDIb.Width;
          Dib.Height:=TmpDib.Height;
          if TmpDib.Width<1 then
            TmpDIb.Width:=1;
          if TmpDib.Height<1 then
            TmpDIb.Height:=1;

          Dib.Canvas.Draw(0,0,TmpDib);

        except  //ͼƬӿͼƬ
          Dib.Width:=1;
          Dib.Height:=1;
        End;
//        Dib.SaveToFile('c:\1.bmp');
        //дͼƬĿ
        Index[i]:=Wil.Stream.Position;
        v:=Dib.Width;
        Wil.Stream.Write(v,2);
        //дͼƬĸ߶
        v:=Dib.Height;
        Wil.Stream.Write(v,2);
        //дͼƬ
        x:=0;
        y:=0;
        if XyMode=0 then
        Begin
           t:=FileList.Strings[i-beginindex];
           t:=ExtractFilepath(t)+'Placements\'+ExtractFileName(FileList.Strings[i-BeginIndex]);
           t:=ChangeFileExt(t,'.txt');
           if FileExists(t) then
           Begin
             xyList.LoadFromFile(t);
             xy:=XyList.Strings[0];
             val(xy,x,count);
             xy:=XyList.Strings[1];
             val(xy,y,count);
           end;
        end
        else
        Begin
         try
          xy:=Editxy.Text;
          Xy:=Copy(xy,1,Pos(',',xy)-1);
          val(xy,x,count);
          xy:=Editxy.Text;
          Xy:=Copy(xy,Pos(',',xy)+1,Length(xy)-Pos(',',xy));
          val(xy,y,count);
         except
           x:=0;
           y:=0;
         end;
        End;
        Wil.Stream.Write(x,2);
        Wil.Stream.Write(y,2);
        if WIl.OffSet>0 then
        Begin
          Wil.Stream.Write(x,2);
          Wil.Stream.Write(y,2);
        End;
        DBits:=DIb.PBits;
        Wil.Stream.Write(DBits^,dib.Size);//lsDib.Height*lsDib.Width);

     End;
     Temp1.Seek(0,0);
     offset:=Wil.Stream.Position;
     Wil.Stream.CopyFrom(Temp1,Temp1.Size);
     pos1:=index[Endindex+1];
     index[EndIndex+1]:=Offset;
     for i:=Endindex+2 to Wil.ImageCount-1 do
     Begin
       Index[i]:=Wil.IndexList[i]-Wil.IndexList[i-1]+Index[i-1];

     End;
     Temp.Seek(48+Wil.OffSet,0);
     Temp.Write(Index[0],Wil.ImageCount*4);
     Temp.Free;
     Temp1.Free;
     tmpDib.Free;
     Wil.Finalize;
     Wil.Initialize((FormMain.suiCheckBox1.Checked));
     FormMain.DrawGrid1.RowCount:=(Wil.ImageCount div 6)+1;
  Except
    Temp.Free;
    Result:=False;
  End;
End;
procedure TFormadd.RabtnPicClick(Sender: TObject);
begin
 if Rabtnall.Checked then
 Begin
   Rabtnadd.Enabled:=True;
   Rabtninsert.Enabled:=True;
   RabtnReplace.Enabled:=true;
   EditPicPath.Enabled:=True;
   suiButton1.Enabled:=True;
   GroupBoxxy.Enabled:=True;
   Label1.Caption:='ͼƬļУ';
 End
 else
 Begin
   suiGroupBox2.Enabled:=True;
   RabtnReplace.Checked:=True;
   Rabtnadd.Enabled:=False;
   Rabtninsert.Enabled:=False;
   RabtnReplace.Enabled:=true;
   if Rabtnxy.Checked then
   Begin
     GroupBoxxy.Enabled:=True;
     Label1.Caption:='ļУ';
   End
   else
   Begin
   Label1.Caption:='ͼƬļУ';
     GroupBoxxy.Enabled:=False;
   End;

 End;

end;

procedure TFormadd.suiButton2Click(Sender: TObject);
var
  s:Boolean;
begin
   if Rabtnall.Checked then
        s:=addall
   else
     if Rabtnpic.Checked then
        s:=addpic
     else
        s:=addxy;
  if s then
    FormMain.showMessage('ɹ')
  else
    FormMain.showMessage('ʧ');

  Formadd.suiProgressBar1.Visible:=False;
  Formadd.suiProgressBar1.Position:=0;
  Formadd.EditPicPath.Text:='';
  FormMain.DrawGrid1.Repaint;
  Formadd.Close;
end;

end.
