unit del;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, SUIEdit, SUIImagePanel, SUIGroupBox,
  SUIButton, ExtCtrls, SUIForm;

type
  TFormdel = class(TForm)
    suiForm1: TsuiForm;
    suiButton2: TsuiButton;
    suiButton3: TsuiButton;
    suiGroupBox1: TsuiGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    editBegin: TsuiEdit;
    EditEnd: TsuiEdit;
    suiGroupBox3: TsuiGroupBox;
    RabtnDel: TsuiRadioButton;
    RabtnNull: TsuiRadioButton;
    suiProgressBar1: TProgressBar;
    procedure suiButton3Click(Sender: TObject);
    FunCtion  Del(BeginIndex,EndIndex:Integer):Boolean;
    FunCtion  Del1(BeginIndex,EndIndex:Integer):Boolean;
    procedure suiButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Formdel: TFormdel;

implementation

uses mail;

{$R *.dfm}
function  ExtractFileNameOnly (const fname: string): string;
var
   extpos: integer;
   ext, fn: string;
begin
   ext := ExtractFileExt (fname);
   fn := ExtractFileName (fname);
   if ext <> '' then begin
      extpos := pos (ext, fn);
      Result := Copy (fn, 1, extpos-1);
   end else
      Result := fn;
end;
procedure TFormdel.suiButton3Click(Sender: TObject);
begin
close;
end;
FunCtion  TFormdel.Del1(BeginIndex,EndIndex:Integer):Boolean;
var
  i:Integer;
  Temp1,temp:TMemoryStream;
  idxFile:String;
  v:smallint;
  offset,pos1,count,FImageCount:integer;
  xy,t:string;
  x,y:smallint;
  xyList:TStringList;
  index:Array of Integer;
  Size:Integer;
  B:TBitMap;
Begin
  Result:=False;
  Try
     b:=TbitMap.Create;
     b.PixelFormat:=pf8bit;
     B.Width:=1;
     B.Height:=1;
     B.Canvas.Pixels[0,0]:=0;
     suiProgressBar1.Max:=EndIndex-BeginIndex+1;
     suiProgressBar1.Position:=0;
     suiProgressBar1.Visible:=True;
     for i:=BeginIndex to Endindex do
     Begin

        Wil.ReplaceBitMap(i,b);
        suiProgressBar1.StepIt;
        Application.ProcessMessages;
     End;
     Wil.Finalize;
     Wil.Initialize(FormMain.suiCheckBox1.Checked);
     suiProgressBar1.Visible:=false;

  Except

    Result:=False;
  End;
  b.Free;
  Result:=True;
End;
FunCtion  TFormdel.Del(BeginIndex,EndIndex:Integer):Boolean;
var
  i:Integer;
  Temp1,temp:TMemoryStream;
  idxFile:String;
  v:smallint;
  offset,pos1,count,FImageCount:integer;
  xy,t:string;
  x,y:smallint;
  xyList:TStringList;
  index:Array of Integer;
  Size:Integer;
Begin
  Result:=True;
  Try
     FImageCount:=Wil.ImageCount;
     FImageCount:=FImageCount-EndIndex+BeginIndex-1;
     idxfile := ExtractFilePath(WIl.FileName) + ExtractFileNameOnly(WIl.FileName) + '.WIX';
     SetLength(Index,FImageCount-EndIndex-BeginIndex+1);
     Size:=Wil.indexList[EndIndex+1]-Wil.indexList[BeginIndex];
     Temp1:=TMemoryStream.Create;
     Temp1.SetSize(Wil.Stream.Size-Size);
     Temp1.Seek(0,0);
     Wil.Stream.Seek(0,0);
     Temp1.CopyFrom(Wil.Stream,Wil.indexList[BeginIndex]);
     Wil.Stream.Seek(Wil.indexList[EndIndex+1],0);
     Temp1.CopyFrom(wil.Stream,Wil.Stream.Size-Wil.Stream.Position);
     for I:=0 to BeginIndex-1 do
        Index[i]:=Wil.indexList[i];
      if BeginIndex=0 then
      Begin
         Index[0]:=1080+wil.OffSet;
         Inc(BeginINdex);
      end;
     for i:=BeginIndex to FImageCount-1 do
     Begin
        Index[i]:=Index[i-1]+Wil.indexList[EndIndex+i-BeginIndex+2]-Wil.indexList[EndIndex+i-BeginIndex+1];
     End;
     Size:=48+Wil.OffSet;
     Wil.Finalize;
     Temp1.Seek(44,0);
     Temp1.Write(FImageCount,4);
     Temp1.Seek(0,0);
     Temp1.SaveToFile(Wil.FileName);
     Temp1.Clear;
     Temp:=TmemoryStream.Create;
     Temp.LoadFromFile(IdxFile);
     Temp1.SetSize(Size+FimageCount*4);
     Temp1.Seek(0,0);
     Temp.Seek(0,0);
     Temp1.CopyFrom(Temp,Size);
     Temp1.Write(Index[0],FimageCount*4);
     Temp1.Seek(44,0);
     Temp1.Write(FImageCount,4);
     Temp1.Seek(0,0);
     Temp1.SaveToFile(idxfile);
     Temp1.Free;
     Wil.Finalize;
     Wil.Initialize(FormMain.suiCheckBox1.Checked);
     Temp.Free;
     FormMain.DrawGrid1.RowCount:=(Wil.ImageCount div 6)+1;
  Except
 
    Result:=False;
  End;
End;
procedure TFormdel.suiButton2Click(Sender: TObject);
var
 BeginIndex,EndIndex,code,i,mode:Integer;
 s:Boolean;
begin
     suiProgressBar1.Position:=0;
      val(EditBegin.Text,BeginIndex,code);
      if (code>0) or (BeginIndex>Wil.ImageCount-1) or (BeginIndex<0) then
      Begin
        FormMain.ShowErrMessage('ȷı');
        EditBegin.SetFocus;
        exit;
      End;
      val(EditEnd.Text,EndIndex,code);
      if (code>0)or (EndIndex>Wil.ImageCount-1) or (EndIndex<0) or (EndIndex<BeginIndex) then
      Begin
        FormMain.ShowErrMessage('ȷı');
        EditEnd.SetFocus;
        exit;
      End;
      if RabtnDel.Checked then
         s:=Del(BeginIndex,EndIndex)
      else
          s:=Del1(BeginIndex,EndIndex);
     if s then
       FormMain.showMessage('ɾɹ')
     else
       FormMain.showMessage('ɾʧ');
     FormMain.DrawGrid1.Repaint;
     Formdel.Close;
end;

end.
