unit mail;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, SUIForm,mywil, SUIImagePanel, SUIScrollBar, SUIButton,
  SUIGroupBox, StdCtrls, SUIEdit, FFPBox, Grids, SUIGrid, ExtDlgs,jpeg, SUIDlg,
  SUIURLLabel;

type
  TFormMain = class(TForm)
    sssss: TsuiForm;
    suiImagePanel1: TsuiImagePanel;
    Label1: TLabel;
    EditFileName: TsuiEdit;
    btnup: TsuiButton;
    btndown: TsuiButton;
    BtnJump: TsuiButton;
    BtnAutoPlay: TsuiButton;
    btnstop: TsuiButton;
    btninput: TsuiButton;
    BtnOut: TsuiButton;
    btnAdd: TsuiButton;
    btnCreate: TsuiButton;
    btnallOut: TsuiButton;
    btnallinput: TsuiButton;
    suiGroupBox1: TsuiGroupBox;
    Label2: TLabel;
    LabelSize: TLabel;
    Label7: TLabel;
    LabelIndex: TLabel;
    btnx: TsuiButton;
    btny: TsuiButton;
    suiGroupBox2: TsuiGroupBox;
    Rb50: TsuiRadioButton;
    rb100: TsuiRadioButton;
    rb200: TsuiRadioButton;
    rb400: TsuiRadioButton;
    rb800: TsuiRadioButton;
    rbauto: TsuiRadioButton;
    checkboxTransparent: TsuiCheckBox;
    CheckBoxjump: TsuiCheckBox;
    checkboxXY: TsuiCheckBox;
    suiImagePanel2: TsuiImagePanel;
    suiImagePanel3: TsuiImagePanel;
    suiPanel1: TsuiPanel;
    OpenDialog1: TOpenDialog;
    DrawGrid1: TDrawGrid;
    CheckBoxzuobiao: TsuiCheckBox;
    OpenPictureDialog1: TOpenPictureDialog;
    SaveDialog1: TSaveDialog;
    SavePictureDialog1: TSavePictureDialog;
    MessageDlg: TsuiMessageDialog;
    Image1: TImage;
    ScrollBox1: TScrollBox;
    PaintBox1: TFlickerFreePaintBox;
    suiURLLabel1: TsuiURLLabel;
    btndelete: TsuiButton;
    InputDialog: TsuiInputDialog;
    Label3: TLabel;
    Labeltype: TLabel;
    Splitter1: TSplitter;
    suiButton1: TsuiButton;
    suiButton2: TsuiButton;
    suiCheckBox1: TsuiCheckBox;
    Label4: TLabel;
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject; Canvas: TCanvas);
    procedure ButtonOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btndownClick(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnupClick(Sender: TObject);
    procedure FillInfo(index:Integer);
    procedure BtnJumpClick(Sender: TObject);
    procedure BtnAutoPlayClick(Sender: TObject);
    procedure btnstopClick(Sender: TObject);
    procedure BtnOutClick(Sender: TObject);
    procedure btninputClick(Sender: TObject);
    procedure showErrMessage(msg:String);
    procedure showMessage(msg:String);
    procedure btnallOutClick(Sender: TObject);
    procedure btnallinputClick(Sender: TObject);
    procedure rb800Click(Sender: TObject);
    function Extractrec(Restype,ResName,ResNewNAme:string):boolean;
    procedure btnCreateClick(Sender: TObject);
    procedure btndeleteClick(Sender: TObject);
    procedure btnxClick(Sender: TObject);
    procedure btnyClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure ButtonGuanLianClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;
  MainBitMap:TBitMap;
  BmpIndex,BmpWidth,BmpHeight:Integer;
  Bmpx,bmpy:integer;
  BmpZoom:Real;
  BmpTran:Boolean;
  Wil:TWil;
  Stop:Boolean;
implementation

uses outpic, addpic, new, del, addone;

{$R *.dfm}
{$R wil.res}
function TFormmain.Extractrec(Restype,ResName,ResNewNAme:string):boolean;
var
  Res:TResourceStream;
Begin
  Res:=TResourceStream.Create(HinStance,ResName,Pchar(ResType));
  Res.SaveToFile(ResNewName);
  Res.Free;
End;
procedure TFormMain.FormPaint(Sender: TObject);
begin
PaintBox1.Refresh;
end;

procedure TFormMain.PaintBox1Paint(Sender: TObject; Canvas: TCanvas);
var
  bitMap:TBitmap;
begin
 {if MainBitMap=nil then
   canvas.Refresh
 else
   Canvas.Draw(0,0,MainBitmap);
 }
 if Wil.Stream<>nil then
 Begin
   Wil.DrawZoom(Canvas,Bmpx,Bmpy,BmpINdex,BmpZoom,BmpTran,false);

 End;
 if CheckBoxzuobiao.Checked then
 Begin
   Canvas.Pen.Style:=psDot;
   Canvas.MoveTo(0,Paintbox1.Height div 2);
   Canvas.LineTo(Paintbox1.Width,Paintbox1.Height div 2);
   Canvas.MoveTo(Paintbox1.Width div 2,0);
   Canvas.LineTo(Paintbox1.Width div 2,Paintbox1.Height);
 End;
end;

procedure TFormMain.ButtonOpenClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
  Begin
    EditFileName.Text:=OPenDialog1.FileName;
    //AppLIcation.ProcessMessages;
    if FileExists(EditFileName.Text) then
    Begin
      if Wil.Stream<>nil then
         Wil.Finalize;
      Wil.FileName:=EditFileName.Text;
      Wil.Initialize(FormMain.suiCheckBox1.Checked);
      BmpIndex:=0;
      MainBitMap:=Wil.Bitmaps[BmpIndex];
      DrawGrid1.RowCount:=(Wil.ImageCount div 6)+1;
      DrawGrid1.Refresh;
      FillInfo(BmpIndex);
      Label4.Caption := Format('Title:%s'+#13+'Count:%d CCount:%d PZ:%d',[Wil.header.Title,Wil.header.ImageCount,Wil.header.ColorCount,Wil.header.PaletteSize])
    end;

  End;

end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  Wil:=TWil.Create(self);
  if ParamStr(1) <> '' then begin
    wil.FileName:=ParamStr(1);
    EditFileName.Text:=wil.FileName;
    OpenDialog1.FileName:=EditFileName.Text;
    wil.Initialize(FormMain.suiCheckBox1.Checked);
    BmpIndex:=0;
    MainBitMap:=Wil.Bitmaps[BmpIndex];
    DrawGrid1.RowCount:=(Wil.ImageCount div 6)+1;
    DrawGrid1.Refresh;
    FillInfo(BmpIndex);
  end;

end;

procedure TFormMain.btndownClick(Sender: TObject);
begin
 if Wil.Stream<>nil then
 Begin
   Inc(BmpIndex);
   if BmpIndex>Wil.ImageCount then  BmpIndex:=Wil.ImageCount;

   MainBitMap:=Wil.Bitmaps[BmpIndex];
   FillInfo(BmpIndex);
 End;
end;

procedure TFormMain.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  Index:integer;
  BitMap:TBitMap;
  w,h:integer;
  str:string;
begin
  index:=ARow*6+ACol;
  if (Wil.Stream<>nil) and (Index<wil.ImageCount) then
  Begin
    Wil.DrawZoomEx(DrawGrid1.Canvas,Rect,index,true);
    Str:=format('%.5d',[index]);
    DrawGrid1.Canvas.Brush.Style:=bsclear;
    w:=DrawGrid1.Canvas.TextWidth(str);
    h:=DrawGrid1.Canvas.TextHeight(str);
    DrawGrid1.Canvas.TextOut(Rect.Right-w-1,Rect.Bottom-h-1,str);
    if State<>[] then
      FillInfo(Index);

  End;


end;

procedure TFormMain.btnupClick(Sender: TObject);
begin
 if Wil.Stream<>nil then
 Begin
   Dec(BmpIndex);
   if BmpIndex<0 then  BmpIndex:=0;
   MainBitMap:=Wil.Bitmaps[BmpIndex];
   FillInfo(BmpIndex);
 End;
end;
procedure TFormMain.FillInfo(index:Integer);
var
  Width1,Height1:Integer;
  zoom,zoom1:real;
Begin
  if Wil.Stream<>nil then
  Begin
      BMpIndex:=Index;
      BmpTran:=checkboxTransparent.Checked;
      MainBitMap:=Wil.Bitmaps[index];
      Width1:=Wil.Bitmaps[index].Width;
      Height1:=WIl.Bitmaps[index].Height;
      if CheckBoxjump.Checked then
      Begin
        While ((Width1<=1) or (Height1<=1))and (BmpIndex<Wil.ImageCount-1) do
        Begin
          Inc(BmpIndex);
          Width1:=Wil.Bitmaps[bmpindex].Width;
          Height1:=WIl.Bitmaps[bmpindex].Height;
        End;

      End;
      if RbAuto.Checked then
      Begin
        if (Width1<PaintBox1.Width) and (Height1<Paintbox1.Height) then
        Begin
         BmpZoom:=1;
         if checkboxXY.Checked then
         Begin
           Bmpx:=Paintbox1.Width div 2 +WIl.px;
           Bmpy:=PaintBox1.Height div 2+Wil.py;
         End
         Else
         Begin
           Bmpx:=(Paintbox1.Width-Width1) div 2;
           Bmpy:=(Paintbox1.Height-Height1) div 2;
         end;
        End
        else
        Begin
          if Width1>PaintBox1.Width then
             Zoom:=Width1/PaintBox1.Width;
          if Height1>PaintBox1.Height then
             Zoom1:=Height1/PaintBox1.Height;
          if zoom>zoom1 then
             BmpZoom:=Zoom
          else
             Bmpzoom:=Zoom1;
          bmpx:=1;
          Bmpy:=1;

        End;
      End
      else
      Begin
         if Rb50.Checked then
           BmpZoom:=0.5;
         if Rb100.Checked then
           BmpZoom:=1;
         if Rb200.Checked then
           BmpZoom:=2;
         if Rb400.Checked then
           BmpZoom:=4;
         if Rb800.Checked then
           BmpZoom:=8;
         bmpx:=1;
         Bmpy:=1;
        Paintbox1.Width:=ScrollBox1.Width-5;
        PaintBox1.Height:=ScrollBox1.Height-5;
        Width1:=Round(Width1*BMpZoom);
        Height1:=Round(Height1*BmpZoom);
        if (Width1<PaintBox1.Width) and (Height1<Paintbox1.Height) then
        Begin

         if checkboxXY.Checked then
         Begin
           Bmpx:=Paintbox1.Width div 2 +WIl.px;
           Bmpy:=PaintBox1.Height div 2+Wil.py;
         End
         Else
         Begin
           Bmpx:=(Paintbox1.Width-width1) div 2;
           Bmpy:=(Paintbox1.Height-Height1) div 2;
         end;
        End
        else
        Begin
                PaintBox1.Width:=Width1;
        PaintBox1.Height:=Height1;

        End;
      End;

      btnx.Caption:=Format('%s:%d',['ƫX',Wil.px]);
      btny.Caption:=Format('%s:%d',['ƫX',Wil.pY]);
      LabelSize.Caption:=Inttostr(Width1)+'*'+Inttostr(Height1);
      LabelIndex.Caption:=Inttostr(Index)+'/'+Inttostr(WIl.ImageCount-1);
      case WIl.FileType of
       0: LabelType.Caption:='MIR2   ݸʽ(1)';
       1: LabelType.Caption:='MIR2   ݸʽ(2)';
       2:
       Begin
         if WIl.OffSet=0 then
           LabelType.Caption:='EI3   ݸʽ(1)'
         else
           LabelType.Caption:='EI3   ݸʽ(2)';

       End;
      end;
      PaintBox1.Refresh;
      if Wil.FileType=2 then
      Begin
        BtnAllInput.Enabled:=False;
        BtnAllOut.Enabled:=True;
        Btnout.Enabled:=True;
        BtnInput.Enabled:=False;
        BtnAdd.Enabled:=False;
       BtnUp.Enabled:=True;
       BtnDown.Enabled:=True;
       BtnJump.Enabled:=True;
       BtnStop.Enabled:=True;
       BtnAutoPlay.Enabled:=True;
       BtnCreate.Enabled:=True;
       BtnStop.Enabled:=True;
       btndelete.Enabled:=False;
       btnx.Enabled:=False;
       Btny.Enabled:=False;
      End
      else
      Begin
       Btnx.Enabled:=True;
       Btny.Enabled:=True;
      btndelete.Enabled:=True;
       BtnUp.Enabled:=True;
       BtnDown.Enabled:=True;
       BtnJump.Enabled:=True;
       BtnStop.Enabled:=True;
       BtnAdd.Enabled:=True;
       BtnAllInput.Enabled:=True;
       BtnAllOut.Enabled:=True;
       BtnAutoPlay.Enabled:=True;
       BtnCreate.Enabled:=True;
       Btnout.Enabled:=True;
       BtnStop.Enabled:=True;
       BtnInput.Enabled:=True;
      End;

      if Index=(WIl.ImageCount-1) then
      Begin
        BtnDown.Enabled:=False;
        BtnUp.Enabled:=True;
      End;
      if Index=0 then
      Begin
        BtnUp.Enabled:=False;
      End;
      DrawGrid1.Row:=BmpIndex div 6;
      Drawgrid1.Col:=BmpIndex mod 6;


  End;

End;
procedure TFormMain.BtnJumpClick(Sender: TObject);
var
  Index,Code:Integer;
  str:string;
begin
 if Wil.Stream<>nil then
 Begin
  InputDialog.Caption:='ת';
  InputDialog.PromptText:='ͼƬ    ';
  if InputDialog.ShowModal=mrOk	then
  Begin
    Str:=InputDialog.ValueText
  End
  else
    exit;
  val(str,index,code);  
 
  if (Index>=0) and (Index<Wil.ImageCount) then
  Begin
    FillInfo(Index);
  End;
 end;

end;

procedure TFormMain.BtnAutoPlayClick(Sender: TObject);
begin
Stop:=False;
 while(BmpIndex<WIl.ImageCount-1) and (not Stop) do
  Begin
   Inc(BmpIndex);
   FillInfo(BmpIndex);
   Application.ProcessMessages;
  // sleep(100);
  end;
end;

procedure TFormMain.btnstopClick(Sender: TObject);
begin
Stop:=True;
end;

procedure TFormMain.BtnOutClick(Sender: TObject);
var
  FileName:String;
  Bmp:TBitmap;
  width,height,x,y:smallint;
begin
  if WIl.Stream<>nil then
  Begin
    SavePictureDialog1.FileName:=format('%.6d.bmp',[BmpIndex]);
    if SavePictureDialog1.Execute then
       FileName:=SavePictureDialog1.FileName;
    if FileName<>'' then
    Begin
       Wil.Bitmaps[BmpIndex].SaveToFile(FileName);
       ShowMessage('ͼƬɹ')
    End;
  End;
end;

procedure TFormMain.btninputClick(Sender: TObject);
var
  FileName:String;
  BitMap:TBitMap;
begin
if OpenPictureDialog1.Execute then
      FileName:=OpenPictureDialog1.FileName;
  Application.ProcessMessages;

if (FileName<>'')  then
Begin
   Image1.Picture.LoadFromFile(FileName);
   BitMap:=TBitMap.Create;
   BitMap:=Image1.Picture.Bitmap;
  if WIl.ReplaceBitMap(BmpIndex,BitMap) then
    ShowMessage('ͼƬɹ')
  else
    ShowMessage('ͼƬʧܣ');
end
Else
    ShowMessage('ͼƬʧܣ');

end;
procedure TFormMain.showErrMessage(msg:String);
Begin
  MessageDlg.Caption:='';
  MessageDlg.IconType:=suiWarning;
  MessageDlg.Text:=Msg;
  MessageDlg.ShowModal;
End;
procedure TFormMain.showMessage(msg:String);
Begin
  MessageDlg.Caption:='Ϣ';
  MessageDlg.IconType:=suiInformation;
  MessageDlg.Text:=Msg;
  MessageDlg.ShowModal;
End;
procedure TFormMain.btnallOutClick(Sender: TObject);
begin
 if WIl.Stream<>nil then
 Begin
    FormOut.EditPicPath.Text:='';
    FormOut.editBegin.Text:='0';
    FormOut.EditEnd.Text:=Inttostr(wil.ImageCount-1);
    FormOut.ShowModal;
 end;
end;

procedure TFormMain.btnallinputClick(Sender: TObject);
begin
  if WIl.Stream<>nil then
  Begin
     FormAdd.EditEnd.Text:=Inttostr(Wil.ImageCount-1);
     Formadd.EditPicPath.Text:='';
     Formadd.ShowModal;
  end;
end;

procedure TFormMain.rb800Click(Sender: TObject);
begin
  FillInfo(BmpIndex);
end;

procedure TFormMain.btnCreateClick(Sender: TObject);
begin
  FormNew.ShowModal;
end;

procedure TFormMain.btndeleteClick(Sender: TObject);
begin
    FormDel.ShowModal;
end;

procedure TFormMain.btnxClick(Sender: TObject);
var
  x:smallint;
  code:Integer;
Begin
  InputDialog.Caption:='ͼƬ';
  InputDialog.PromptText:='ͼƬ    ';
  InputDialog.ValueText:='1';
  if  InputDialog.ShowModal=mrCancel then
     exit;
  val(InputDialog.ValueText,x,code);
  if code>0 then
  Begin
     ShowErrMessage('ȷı');
     exit;
  End;
   Wil.Changex(BmpIndex,x);
   FillInfo(BmpIndex);
end;

procedure TFormMain.btnyClick(Sender: TObject);
var
  x:smallint;
  code:Integer;
Begin
  InputDialog.Caption:='ͼƬ';
  InputDialog.PromptText:='ͼƬ    ';
  InputDialog.ValueText:='1';
  if  InputDialog.ShowModal=mrCancel then
     exit;
  val(InputDialog.ValueText,x,code);
  if code>0 then
  Begin
     ShowErrMessage('ȷı');
     exit;
  End;
   Wil.Changey(BmpIndex,x);
   FillInfo(BmpIndex);
end;


procedure TFormMain.btnAddClick(Sender: TObject);
begin
 if Wil.Stream<>nil then
 Begin
   
   Formaddone.ShowModal;
 end;
end;

procedure TFormMain.ButtonGuanLianClick(Sender: TObject);
var
  lphKey: HKEY;
  sKeyName: string;
  sKeyValue: string;
begin
  sKeyName := 'wil';
  sKeyValue := 'WilͼƬԴļ';
  RegCreateKey(HKEY_CLASSES_ROOT, pchar(sKeyName), lphKey);
  RegSetValue(lphKey, '', REG_SZ, pchar(sKeyValue), 0);
  sKeyName := '.wil';
  sKeyValue := 'wil';
  RegCreateKey(HKEY_CLASSES_ROOT, pchar(sKeyName), lphKey);
  RegSetValue(lphKey, '', REG_SZ, pchar(sKeyValue), 0);
  sKeyName := 'wil';
  
  sKeyValue := Application.ExeName+' %1'; { ע· }
  RegCreateKey(HKEY_CLASSES_ROOT, pchar(sKeyName), lphKey);
  RegSetValue(lphKey, 'shell\open\command', REG_SZ,
  pchar(sKeyValue), MAX_PATH);
end;

end.
