unit outpic;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, SUIForm, StdCtrls, SUIEdit, SUIButton, SUIImagePanel,
  SUIGroupBox, FileCtrl, PBFolderDialog, SUIProgressBar, ComCtrls, DXDraws;

type
  TFormout = class(TForm)
    suiForm1: TsuiForm;
    Label1: TLabel;
    EditPicPath: TsuiEdit;
    suiButton1: TsuiButton;
    suiButton2: TsuiButton;
    suiButton3: TsuiButton;
    suiGroupBox1: TsuiGroupBox;
    editBegin: TsuiEdit;

    Label2: TLabel;
    EditEnd: TsuiEdit;
    Label3: TLabel;
    suiProgressBar1: TProgressBar;
    PBFolderDialog1: TPBFolderDialog;
    procedure suiButton1Click(Sender: TObject);
    procedure suiButton2Click(Sender: TObject);
    procedure suiButton3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Formout: TFormout;
  PicPath,FileName:String;
implementation

uses mail;



{$R *.dfm}

procedure TFormout.suiButton1Click(Sender: TObject);
begin
 if  PBFolderDialog1.Execute then
    EditPicpath.Text:=PBFolderDialog1.SelectedFolder;
end;

procedure TFormout.suiButton2Click(Sender: TObject);
var
  BeginIndex,EndIndex,code,i:Integer;
  x,y,width,height:smallint;
  str:string;
  Bmp:TBitMap;
  s:TStringlist;
begin
  Application.ProcessMessages;
  if Wil.Stream=nil then
  Begin
     FormMain.ShowErrMessage('ȴwilļ');
     exit;
  End;
  val(EditBegin.Text,BeginIndex,code);
  if code>0 then
  Begin
     FormMain.ShowErrMessage('ȷı');
     EditBegin.SetFocus;
     exit;
  End;
  val(EditEnd.Text,EndIndex,code);
  if code>0 then
  Begin
     FormMain.ShowErrMessage('ȷı');
     EditEnd.SetFocus;
     exit;
  End;
    Application.ProcessMessages;
  if BeginIndex<0 then BeginIndex:=0;
  if EndIndex>=WIl.ImageCount then EndIndex:=Wil.ImageCount-1;
  Str:=EditPicPath.Text;
  if str='' then
  Begin
     FormMain.ShowErrMessage('뵼λã');
     exit;
  End;
  if str[length(str)]<>'\' then str:=str+'\';
  s:=TStringList.Create;
  if not DirectoryExists(str+'Placements\') then
     mkdir(str+'Placements\');
  suiProgressBar1.Visible:=True;
  suiProgressBar1.Max:=EndIndex-BeginIndex+1;
  suiProgressBar1.Position:=0;
  for i:=BeginIndex to EndIndex do
  Begin
    suiProgressBar1.StepIt;
    Application.ProcessMessages;
    Wil.Bitmaps[i].SaveToFile(str+format('%.6d.bmp',[i]));
    s.Clear;
    s.Add(inttostr(Wil.px));
    s.Add(inttostr(Wil.py));
    s.SaveToFile(str+'Placements\'+format('%.6d.txt',[i]));
  End;
  suiProgressBar1.Visible:=False;
  FormMain.ShowMessage('ͼƬɹ');
  close;
end;


procedure TFormout.suiButton3Click(Sender: TObject);
begin
close;
end;

end.

